/* A Bison parser, made by GNU Bison 2.7.12-4996.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7.12-4996"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 2003-2015, PgPool Global Development Group
 * Portions Copyright (c) 1996-2015, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */

#include "pool_parser.h"
#include "utils/elog.h"
#include "utils/palloc.h"
#include <ctype.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nodes.h"
#include "keywords.h"
#include "gramparse.h"
#include "makefuncs.h"
#include "pool_string.h"
#include "parser.h"
#include "pg_class.h"
#include "pg_trigger.h"

/* This is a configuration parameter since PostgreSQL 9.5.
 * We set this false in pgpool-II. This is default in PostgreSQL.
 */
bool operator_precedence_warning = false;

/*
 * Definition taken from
 * postgreSQL source code file: src/include/commands/trigger.h
 */
#define TRIGGER_FIRES_ON_ORIGIN                         'O'
#define TRIGGER_FIRES_ALWAYS                            'A'
#define TRIGGER_FIRES_ON_REPLICA                        'R'
#define TRIGGER_DISABLED                                'D'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_class.h
 */

#define           REPLICA_IDENTITY_DEFAULT      'd'
#define           REPLICA_IDENTITY_NOTHING      'n'
#define           REPLICA_IDENTITY_FULL         'f'
#define           REPLICA_IDENTITY_INDEX        'i'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/utils/xml.h
 */
typedef enum
{
	XML_STANDALONE_YES,
	XML_STANDALONE_NO,
	XML_STANDALONE_NO_VALUE,
	XML_STANDALONE_OMITTED
} XmlStandaloneType;

static DefElem *defWithOids(bool value);
/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


/* Line 371 of yacc.c  */
#line 292 "gram.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_BASE_YY_Y_TAB_H_INCLUDED
# define YY_BASE_YY_Y_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FCONST = 259,
     SCONST = 260,
     BCONST = 261,
     XCONST = 262,
     Op = 263,
     ICONST = 264,
     PARAM = 265,
     TYPECAST = 266,
     DOT_DOT = 267,
     COLON_EQUALS = 268,
     EQUALS_GREATER = 269,
     LESS_EQUALS = 270,
     GREATER_EQUALS = 271,
     NOT_EQUALS = 272,
     ABORT_P = 273,
     ABSOLUTE_P = 274,
     ACCESS = 275,
     ACTION = 276,
     ADD_P = 277,
     ADMIN = 278,
     AFTER = 279,
     AGGREGATE = 280,
     ALL = 281,
     ALSO = 282,
     ALTER = 283,
     ALWAYS = 284,
     ANALYSE = 285,
     ANALYZE = 286,
     AND = 287,
     ANY = 288,
     ARRAY = 289,
     AS = 290,
     ASC = 291,
     ASSERTION = 292,
     ASSIGNMENT = 293,
     ASYMMETRIC = 294,
     AT = 295,
     ATTRIBUTE = 296,
     AUTHORIZATION = 297,
     BACKWARD = 298,
     BEFORE = 299,
     BEGIN_P = 300,
     BETWEEN = 301,
     BIGINT = 302,
     BINARY = 303,
     BIT = 304,
     BOOLEAN_P = 305,
     BOTH = 306,
     BY = 307,
     CACHE = 308,
     CALLED = 309,
     CASCADE = 310,
     CASCADED = 311,
     CASE = 312,
     CAST = 313,
     CATALOG_P = 314,
     CHAIN = 315,
     CHAR_P = 316,
     CHARACTER = 317,
     CHARACTERISTICS = 318,
     CHECK = 319,
     CHECKPOINT = 320,
     CLASS = 321,
     CLOSE = 322,
     CLUSTER = 323,
     COALESCE = 324,
     COLLATE = 325,
     COLLATION = 326,
     COLUMN = 327,
     COMMENT = 328,
     COMMENTS = 329,
     COMMIT = 330,
     COMMITTED = 331,
     CONCURRENTLY = 332,
     CONFIGURATION = 333,
     CONFLICT = 334,
     CONNECTION = 335,
     CONSTRAINT = 336,
     CONSTRAINTS = 337,
     CONTENT_P = 338,
     CONTINUE_P = 339,
     CONVERSION_P = 340,
     COPY = 341,
     COST = 342,
     CREATE = 343,
     CROSS = 344,
     CSV = 345,
     CUBE = 346,
     CURRENT_P = 347,
     CURRENT_CATALOG = 348,
     CURRENT_DATE = 349,
     CURRENT_ROLE = 350,
     CURRENT_SCHEMA = 351,
     CURRENT_TIME = 352,
     CURRENT_TIMESTAMP = 353,
     CURRENT_USER = 354,
     CURSOR = 355,
     CYCLE = 356,
     DATA_P = 357,
     DATABASE = 358,
     DAY_P = 359,
     DEALLOCATE = 360,
     DEC = 361,
     DECIMAL_P = 362,
     DECLARE = 363,
     DEFAULT = 364,
     DEFAULTS = 365,
     DEFERRABLE = 366,
     DEFERRED = 367,
     DEFINER = 368,
     DELETE_P = 369,
     DELIMITER = 370,
     DELIMITERS = 371,
     DESC = 372,
     DICTIONARY = 373,
     DISABLE_P = 374,
     DISCARD = 375,
     DISTINCT = 376,
     DO = 377,
     DOCUMENT_P = 378,
     DOMAIN_P = 379,
     DOUBLE_P = 380,
     DROP = 381,
     EACH = 382,
     ELSE = 383,
     ENABLE_P = 384,
     ENCODING = 385,
     ENCRYPTED = 386,
     END_P = 387,
     ENUM_P = 388,
     ESCAPE = 389,
     EVENT = 390,
     EXCEPT = 391,
     EXCLUDE = 392,
     EXCLUDING = 393,
     EXCLUSIVE = 394,
     EXECUTE = 395,
     EXISTS = 396,
     EXPLAIN = 397,
     EXTENSION = 398,
     EXTERNAL = 399,
     EXTRACT = 400,
     FALSE_P = 401,
     FAMILY = 402,
     FETCH = 403,
     FILTER = 404,
     FIRST_P = 405,
     FLOAT_P = 406,
     FOLLOWING = 407,
     FOR = 408,
     FORCE = 409,
     FOREIGN = 410,
     FORWARD = 411,
     FREEZE = 412,
     FROM = 413,
     FULL = 414,
     FUNCTION = 415,
     FUNCTIONS = 416,
     GLOBAL = 417,
     GRANT = 418,
     GRANTED = 419,
     GREATEST = 420,
     GROUP_P = 421,
     GROUPING = 422,
     HANDLER = 423,
     HAVING = 424,
     HEADER_P = 425,
     HOLD = 426,
     HOUR_P = 427,
     IDENTITY_P = 428,
     IF_P = 429,
     ILIKE = 430,
     IMMEDIATE = 431,
     IMMUTABLE = 432,
     IMPLICIT_P = 433,
     IMPORT_P = 434,
     IN_P = 435,
     INCLUDING = 436,
     INCREMENT = 437,
     INDEX = 438,
     INDEXES = 439,
     INHERIT = 440,
     INHERITS = 441,
     INITIALLY = 442,
     INLINE_P = 443,
     INNER_P = 444,
     INOUT = 445,
     INPUT_P = 446,
     INSENSITIVE = 447,
     INSERT = 448,
     INSTEAD = 449,
     INT_P = 450,
     INTEGER = 451,
     INTERSECT = 452,
     INTERVAL = 453,
     INTO = 454,
     INVOKER = 455,
     IS = 456,
     ISNULL = 457,
     ISOLATION = 458,
     JOIN = 459,
     KEY = 460,
     LABEL = 461,
     LANGUAGE = 462,
     LARGE_P = 463,
     LAST_P = 464,
     LATERAL_P = 465,
     LEADING = 466,
     LEAKPROOF = 467,
     LEAST = 468,
     LEFT = 469,
     LEVEL = 470,
     LIKE = 471,
     LIMIT = 472,
     LISTEN = 473,
     LOAD = 474,
     LOCAL = 475,
     LOCALTIME = 476,
     LOCALTIMESTAMP = 477,
     LOCATION = 478,
     LOCK_P = 479,
     LOCKED = 480,
     LOGGED = 481,
     MAPPING = 482,
     MATCH = 483,
     MATERIALIZED = 484,
     MAXVALUE = 485,
     MINUTE_P = 486,
     MINVALUE = 487,
     MODE = 488,
     MONTH_P = 489,
     MOVE = 490,
     NAME_P = 491,
     NAMES = 492,
     NATIONAL = 493,
     NATURAL = 494,
     NCHAR = 495,
     NEXT = 496,
     NO = 497,
     NONE = 498,
     NOT = 499,
     NOTHING = 500,
     NOTIFY = 501,
     NOTNULL = 502,
     NOWAIT = 503,
     NULL_P = 504,
     NULLIF = 505,
     NULLS_P = 506,
     NUMERIC = 507,
     OBJECT_P = 508,
     OF = 509,
     OFF = 510,
     OFFSET = 511,
     OIDS = 512,
     ON = 513,
     ONLY = 514,
     OPERATOR = 515,
     OPTION = 516,
     OPTIONS = 517,
     OR = 518,
     ORDER = 519,
     ORDINALITY = 520,
     OUT_P = 521,
     OUTER_P = 522,
     OVER = 523,
     OVERLAPS = 524,
     OVERLAY = 525,
     OWNED = 526,
     OWNER = 527,
     PARSER = 528,
     PARTIAL = 529,
     PARTITION = 530,
     PASSING = 531,
     PASSWORD = 532,
     PLACING = 533,
     PLANS = 534,
     POLICY = 535,
     POSITION = 536,
     PRECEDING = 537,
     PRECISION = 538,
     PRESERVE = 539,
     PREPARE = 540,
     PREPARED = 541,
     PRIMARY = 542,
     PRIOR = 543,
     PRIVILEGES = 544,
     PROCEDURAL = 545,
     PROCEDURE = 546,
     PROGRAM = 547,
     QUOTE = 548,
     RANGE = 549,
     READ = 550,
     REAL = 551,
     REASSIGN = 552,
     RECHECK = 553,
     RECURSIVE = 554,
     REF = 555,
     REFERENCES = 556,
     REFRESH = 557,
     REINDEX = 558,
     RELATIVE_P = 559,
     RELEASE = 560,
     RENAME = 561,
     REPEATABLE = 562,
     REPLACE = 563,
     REPLICA = 564,
     RESET = 565,
     RESTART = 566,
     RESTRICT = 567,
     RETURNING = 568,
     RETURNS = 569,
     REVOKE = 570,
     RIGHT = 571,
     ROLE = 572,
     ROLLBACK = 573,
     ROLLUP = 574,
     ROW = 575,
     ROWS = 576,
     RULE = 577,
     SAVEPOINT = 578,
     SCHEMA = 579,
     SCROLL = 580,
     SEARCH = 581,
     SECOND_P = 582,
     SECURITY = 583,
     SELECT = 584,
     SEQUENCE = 585,
     SEQUENCES = 586,
     SERIALIZABLE = 587,
     SERVER = 588,
     SESSION = 589,
     SESSION_USER = 590,
     SET = 591,
     SETS = 592,
     SETOF = 593,
     SHARE = 594,
     SHOW = 595,
     SIMILAR = 596,
     SIMPLE = 597,
     SKIP = 598,
     SMALLINT = 599,
     SNAPSHOT = 600,
     SOME = 601,
     SQL_P = 602,
     STABLE = 603,
     STANDALONE_P = 604,
     START = 605,
     STATEMENT = 606,
     STATISTICS = 607,
     STDIN = 608,
     STDOUT = 609,
     STORAGE = 610,
     STRICT_P = 611,
     STRIP_P = 612,
     SUBSTRING = 613,
     SYMMETRIC = 614,
     SYSID = 615,
     SYSTEM_P = 616,
     TABLE = 617,
     TABLES = 618,
     TABLESAMPLE = 619,
     TABLESPACE = 620,
     TEMP = 621,
     TEMPLATE = 622,
     TEMPORARY = 623,
     TEXT_P = 624,
     THEN = 625,
     TIME = 626,
     TIMESTAMP = 627,
     TO = 628,
     TRAILING = 629,
     TRANSACTION = 630,
     TRANSFORM = 631,
     TREAT = 632,
     TRIGGER = 633,
     TRIM = 634,
     TRUE_P = 635,
     TRUNCATE = 636,
     TRUSTED = 637,
     TYPE_P = 638,
     TYPES_P = 639,
     UNBOUNDED = 640,
     UNCOMMITTED = 641,
     UNENCRYPTED = 642,
     UNION = 643,
     UNIQUE = 644,
     UNKNOWN = 645,
     UNLISTEN = 646,
     UNLOGGED = 647,
     UNTIL = 648,
     UPDATE = 649,
     USER = 650,
     USING = 651,
     VACUUM = 652,
     VALID = 653,
     VALIDATE = 654,
     VALIDATOR = 655,
     VALUE_P = 656,
     VALUES = 657,
     VARCHAR = 658,
     VARIADIC = 659,
     VARYING = 660,
     VERBOSE = 661,
     VERSION_P = 662,
     VIEW = 663,
     VIEWS = 664,
     VOLATILE = 665,
     WHEN = 666,
     WHERE = 667,
     WHITESPACE_P = 668,
     WINDOW = 669,
     WITH = 670,
     WITHIN = 671,
     WITHOUT = 672,
     WORK = 673,
     WRAPPER = 674,
     WRITE = 675,
     XML_P = 676,
     XMLATTRIBUTES = 677,
     XMLCONCAT = 678,
     XMLELEMENT = 679,
     XMLEXISTS = 680,
     XMLFOREST = 681,
     XMLPARSE = 682,
     XMLPI = 683,
     XMLROOT = 684,
     XMLSERIALIZE = 685,
     YEAR_P = 686,
     YES_P = 687,
     ZONE = 688,
     NOT_LA = 689,
     NULLS_LA = 690,
     WITH_LA = 691,
     POSTFIXOP = 692,
     UMINUS = 693
   };
#endif
/* Tokens.  */
#define IDENT 258
#define FCONST 259
#define SCONST 260
#define BCONST 261
#define XCONST 262
#define Op 263
#define ICONST 264
#define PARAM 265
#define TYPECAST 266
#define DOT_DOT 267
#define COLON_EQUALS 268
#define EQUALS_GREATER 269
#define LESS_EQUALS 270
#define GREATER_EQUALS 271
#define NOT_EQUALS 272
#define ABORT_P 273
#define ABSOLUTE_P 274
#define ACCESS 275
#define ACTION 276
#define ADD_P 277
#define ADMIN 278
#define AFTER 279
#define AGGREGATE 280
#define ALL 281
#define ALSO 282
#define ALTER 283
#define ALWAYS 284
#define ANALYSE 285
#define ANALYZE 286
#define AND 287
#define ANY 288
#define ARRAY 289
#define AS 290
#define ASC 291
#define ASSERTION 292
#define ASSIGNMENT 293
#define ASYMMETRIC 294
#define AT 295
#define ATTRIBUTE 296
#define AUTHORIZATION 297
#define BACKWARD 298
#define BEFORE 299
#define BEGIN_P 300
#define BETWEEN 301
#define BIGINT 302
#define BINARY 303
#define BIT 304
#define BOOLEAN_P 305
#define BOTH 306
#define BY 307
#define CACHE 308
#define CALLED 309
#define CASCADE 310
#define CASCADED 311
#define CASE 312
#define CAST 313
#define CATALOG_P 314
#define CHAIN 315
#define CHAR_P 316
#define CHARACTER 317
#define CHARACTERISTICS 318
#define CHECK 319
#define CHECKPOINT 320
#define CLASS 321
#define CLOSE 322
#define CLUSTER 323
#define COALESCE 324
#define COLLATE 325
#define COLLATION 326
#define COLUMN 327
#define COMMENT 328
#define COMMENTS 329
#define COMMIT 330
#define COMMITTED 331
#define CONCURRENTLY 332
#define CONFIGURATION 333
#define CONFLICT 334
#define CONNECTION 335
#define CONSTRAINT 336
#define CONSTRAINTS 337
#define CONTENT_P 338
#define CONTINUE_P 339
#define CONVERSION_P 340
#define COPY 341
#define COST 342
#define CREATE 343
#define CROSS 344
#define CSV 345
#define CUBE 346
#define CURRENT_P 347
#define CURRENT_CATALOG 348
#define CURRENT_DATE 349
#define CURRENT_ROLE 350
#define CURRENT_SCHEMA 351
#define CURRENT_TIME 352
#define CURRENT_TIMESTAMP 353
#define CURRENT_USER 354
#define CURSOR 355
#define CYCLE 356
#define DATA_P 357
#define DATABASE 358
#define DAY_P 359
#define DEALLOCATE 360
#define DEC 361
#define DECIMAL_P 362
#define DECLARE 363
#define DEFAULT 364
#define DEFAULTS 365
#define DEFERRABLE 366
#define DEFERRED 367
#define DEFINER 368
#define DELETE_P 369
#define DELIMITER 370
#define DELIMITERS 371
#define DESC 372
#define DICTIONARY 373
#define DISABLE_P 374
#define DISCARD 375
#define DISTINCT 376
#define DO 377
#define DOCUMENT_P 378
#define DOMAIN_P 379
#define DOUBLE_P 380
#define DROP 381
#define EACH 382
#define ELSE 383
#define ENABLE_P 384
#define ENCODING 385
#define ENCRYPTED 386
#define END_P 387
#define ENUM_P 388
#define ESCAPE 389
#define EVENT 390
#define EXCEPT 391
#define EXCLUDE 392
#define EXCLUDING 393
#define EXCLUSIVE 394
#define EXECUTE 395
#define EXISTS 396
#define EXPLAIN 397
#define EXTENSION 398
#define EXTERNAL 399
#define EXTRACT 400
#define FALSE_P 401
#define FAMILY 402
#define FETCH 403
#define FILTER 404
#define FIRST_P 405
#define FLOAT_P 406
#define FOLLOWING 407
#define FOR 408
#define FORCE 409
#define FOREIGN 410
#define FORWARD 411
#define FREEZE 412
#define FROM 413
#define FULL 414
#define FUNCTION 415
#define FUNCTIONS 416
#define GLOBAL 417
#define GRANT 418
#define GRANTED 419
#define GREATEST 420
#define GROUP_P 421
#define GROUPING 422
#define HANDLER 423
#define HAVING 424
#define HEADER_P 425
#define HOLD 426
#define HOUR_P 427
#define IDENTITY_P 428
#define IF_P 429
#define ILIKE 430
#define IMMEDIATE 431
#define IMMUTABLE 432
#define IMPLICIT_P 433
#define IMPORT_P 434
#define IN_P 435
#define INCLUDING 436
#define INCREMENT 437
#define INDEX 438
#define INDEXES 439
#define INHERIT 440
#define INHERITS 441
#define INITIALLY 442
#define INLINE_P 443
#define INNER_P 444
#define INOUT 445
#define INPUT_P 446
#define INSENSITIVE 447
#define INSERT 448
#define INSTEAD 449
#define INT_P 450
#define INTEGER 451
#define INTERSECT 452
#define INTERVAL 453
#define INTO 454
#define INVOKER 455
#define IS 456
#define ISNULL 457
#define ISOLATION 458
#define JOIN 459
#define KEY 460
#define LABEL 461
#define LANGUAGE 462
#define LARGE_P 463
#define LAST_P 464
#define LATERAL_P 465
#define LEADING 466
#define LEAKPROOF 467
#define LEAST 468
#define LEFT 469
#define LEVEL 470
#define LIKE 471
#define LIMIT 472
#define LISTEN 473
#define LOAD 474
#define LOCAL 475
#define LOCALTIME 476
#define LOCALTIMESTAMP 477
#define LOCATION 478
#define LOCK_P 479
#define LOCKED 480
#define LOGGED 481
#define MAPPING 482
#define MATCH 483
#define MATERIALIZED 484
#define MAXVALUE 485
#define MINUTE_P 486
#define MINVALUE 487
#define MODE 488
#define MONTH_P 489
#define MOVE 490
#define NAME_P 491
#define NAMES 492
#define NATIONAL 493
#define NATURAL 494
#define NCHAR 495
#define NEXT 496
#define NO 497
#define NONE 498
#define NOT 499
#define NOTHING 500
#define NOTIFY 501
#define NOTNULL 502
#define NOWAIT 503
#define NULL_P 504
#define NULLIF 505
#define NULLS_P 506
#define NUMERIC 507
#define OBJECT_P 508
#define OF 509
#define OFF 510
#define OFFSET 511
#define OIDS 512
#define ON 513
#define ONLY 514
#define OPERATOR 515
#define OPTION 516
#define OPTIONS 517
#define OR 518
#define ORDER 519
#define ORDINALITY 520
#define OUT_P 521
#define OUTER_P 522
#define OVER 523
#define OVERLAPS 524
#define OVERLAY 525
#define OWNED 526
#define OWNER 527
#define PARSER 528
#define PARTIAL 529
#define PARTITION 530
#define PASSING 531
#define PASSWORD 532
#define PLACING 533
#define PLANS 534
#define POLICY 535
#define POSITION 536
#define PRECEDING 537
#define PRECISION 538
#define PRESERVE 539
#define PREPARE 540
#define PREPARED 541
#define PRIMARY 542
#define PRIOR 543
#define PRIVILEGES 544
#define PROCEDURAL 545
#define PROCEDURE 546
#define PROGRAM 547
#define QUOTE 548
#define RANGE 549
#define READ 550
#define REAL 551
#define REASSIGN 552
#define RECHECK 553
#define RECURSIVE 554
#define REF 555
#define REFERENCES 556
#define REFRESH 557
#define REINDEX 558
#define RELATIVE_P 559
#define RELEASE 560
#define RENAME 561
#define REPEATABLE 562
#define REPLACE 563
#define REPLICA 564
#define RESET 565
#define RESTART 566
#define RESTRICT 567
#define RETURNING 568
#define RETURNS 569
#define REVOKE 570
#define RIGHT 571
#define ROLE 572
#define ROLLBACK 573
#define ROLLUP 574
#define ROW 575
#define ROWS 576
#define RULE 577
#define SAVEPOINT 578
#define SCHEMA 579
#define SCROLL 580
#define SEARCH 581
#define SECOND_P 582
#define SECURITY 583
#define SELECT 584
#define SEQUENCE 585
#define SEQUENCES 586
#define SERIALIZABLE 587
#define SERVER 588
#define SESSION 589
#define SESSION_USER 590
#define SET 591
#define SETS 592
#define SETOF 593
#define SHARE 594
#define SHOW 595
#define SIMILAR 596
#define SIMPLE 597
#define SKIP 598
#define SMALLINT 599
#define SNAPSHOT 600
#define SOME 601
#define SQL_P 602
#define STABLE 603
#define STANDALONE_P 604
#define START 605
#define STATEMENT 606
#define STATISTICS 607
#define STDIN 608
#define STDOUT 609
#define STORAGE 610
#define STRICT_P 611
#define STRIP_P 612
#define SUBSTRING 613
#define SYMMETRIC 614
#define SYSID 615
#define SYSTEM_P 616
#define TABLE 617
#define TABLES 618
#define TABLESAMPLE 619
#define TABLESPACE 620
#define TEMP 621
#define TEMPLATE 622
#define TEMPORARY 623
#define TEXT_P 624
#define THEN 625
#define TIME 626
#define TIMESTAMP 627
#define TO 628
#define TRAILING 629
#define TRANSACTION 630
#define TRANSFORM 631
#define TREAT 632
#define TRIGGER 633
#define TRIM 634
#define TRUE_P 635
#define TRUNCATE 636
#define TRUSTED 637
#define TYPE_P 638
#define TYPES_P 639
#define UNBOUNDED 640
#define UNCOMMITTED 641
#define UNENCRYPTED 642
#define UNION 643
#define UNIQUE 644
#define UNKNOWN 645
#define UNLISTEN 646
#define UNLOGGED 647
#define UNTIL 648
#define UPDATE 649
#define USER 650
#define USING 651
#define VACUUM 652
#define VALID 653
#define VALIDATE 654
#define VALIDATOR 655
#define VALUE_P 656
#define VALUES 657
#define VARCHAR 658
#define VARIADIC 659
#define VARYING 660
#define VERBOSE 661
#define VERSION_P 662
#define VIEW 663
#define VIEWS 664
#define VOLATILE 665
#define WHEN 666
#define WHERE 667
#define WHITESPACE_P 668
#define WINDOW 669
#define WITH 670
#define WITHIN 671
#define WITHOUT 672
#define WORK 673
#define WRAPPER 674
#define WRITE 675
#define XML_P 676
#define XMLATTRIBUTES 677
#define XMLCONCAT 678
#define XMLELEMENT 679
#define XMLEXISTS 680
#define XMLFOREST 681
#define XMLPARSE 682
#define XMLPI 683
#define XMLROOT 684
#define XMLSERIALIZE 685
#define YEAR_P 686
#define YES_P 687
#define ZONE 688
#define NOT_LA 689
#define NULLS_LA 690
#define WITH_LA 691
#define POSTFIXOP 692
#define UMINUS 693



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 226 "gram.y"

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	InferClause			*infer;
	OnConflictClause	*onconflict;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	struct ImportQual	*importqual;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;


/* Line 387 of yacc.c  */
#line 1252 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int base_yyparse (void *YYPARSE_PARAM);
#else
int base_yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int base_yyparse (core_yyscan_t yyscanner);
#else
int base_yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_BASE_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1292 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if (! defined __GNUC__ || __GNUC__ < 2 \
      || (__GNUC__ == 2 && __GNUC_MINOR__ < 5))
#  define __attribute__(Spec) /* empty */
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif


/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  755
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   89916

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  456
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  612
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2483
/* YYNRULES -- Number of states.  */
#define YYNSTATES  4917

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   693

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   445,     2,     2,
     450,   451,   443,   441,   454,   442,   452,   444,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   455,   453,
     437,   439,   438,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   448,     2,   449,   446,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   440,   447
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   215,   217,   219,
     221,   223,   225,   227,   229,   231,   233,   235,   237,   239,
     241,   243,   245,   247,   249,   251,   253,   255,   256,   262,
     264,   266,   267,   270,   271,   274,   275,   278,   281,   285,
     289,   291,   295,   299,   302,   304,   306,   309,   312,   315,
     319,   323,   329,   335,   336,   340,   346,   352,   358,   363,
     367,   373,   377,   383,   389,   396,   398,   400,   404,   410,
     417,   422,   432,   440,   442,   443,   446,   447,   449,   451,
     453,   455,   457,   459,   462,   466,   470,   473,   479,   481,
     485,   489,   493,   497,   499,   503,   507,   510,   513,   516,
     519,   523,   527,   531,   535,   537,   541,   543,   547,   549,
     551,   554,   557,   560,   562,   564,   566,   568,   570,   572,
     574,   578,   584,   586,   588,   590,   592,   594,   595,   597,
     599,   602,   604,   607,   611,   614,   616,   618,   621,   623,
     626,   628,   631,   635,   640,   644,   647,   652,   654,   656,
     658,   660,   662,   665,   668,   671,   674,   677,   682,   689,
     700,   714,   719,   726,   737,   751,   756,   763,   768,   775,
     781,   789,   801,   816,   818,   822,   825,   829,   834,   841,
     848,   855,   861,   867,   874,   881,   886,   895,   900,   903,
     908,   912,   919,   924,   928,   932,   936,   940,   943,   946,
     950,   955,   960,   964,   968,   972,   976,   980,   984,   989,
     994,   998,  1001,  1005,  1008,  1011,  1015,  1019,  1022,  1025,
    1029,  1034,  1039,  1041,  1045,  1048,  1050,  1052,  1053,  1056,
    1057,  1060,  1061,  1063,  1065,  1067,  1071,  1075,  1078,  1079,
    1081,  1085,  1089,  1091,  1097,  1101,  1106,  1108,  1112,  1117,
    1124,  1129,  1138,  1141,  1144,  1156,  1164,  1166,  1168,  1170,
    1171,  1173,  1175,  1177,  1179,  1183,  1186,  1187,  1189,  1191,
    1193,  1197,  1201,  1203,  1205,  1209,  1213,  1217,  1221,  1226,
    1230,  1233,  1235,  1236,  1239,  1240,  1244,  1245,  1247,  1248,
    1250,  1254,  1257,  1259,  1261,  1263,  1267,  1268,  1270,  1274,
    1276,  1288,  1303,  1314,  1328,  1330,  1332,  1335,  1338,  1341,
    1344,  1346,  1347,  1349,  1350,  1354,  1355,  1357,  1361,  1363,
    1367,  1369,  1371,  1373,  1375,  1377,  1382,  1387,  1390,  1391,
    1395,  1397,  1399,  1402,  1405,  1407,  1411,  1416,  1422,  1425,
    1431,  1433,  1436,  1439,  1442,  1446,  1450,  1454,  1455,  1457,
    1459,  1461,  1463,  1465,  1467,  1471,  1473,  1479,  1487,  1491,
    1500,  1505,  1515,  1527,  1530,  1531,  1535,  1536,  1538,  1542,
    1544,  1547,  1550,  1553,  1554,  1556,  1560,  1564,  1571,  1576,
    1577,  1579,  1581,  1584,  1587,  1588,  1592,  1596,  1599,  1601,
    1603,  1606,  1609,  1614,  1615,  1618,  1621,  1624,  1625,  1629,
    1634,  1639,  1640,  1643,  1644,  1649,  1650,  1654,  1662,  1673,
    1679,  1682,  1686,  1687,  1696,  1708,  1713,  1715,  1716,  1723,
    1729,  1738,  1743,  1750,  1752,  1753,  1755,  1758,  1761,  1763,
    1766,  1770,  1773,  1776,  1779,  1782,  1786,  1790,  1792,  1796,
    1798,  1799,  1801,  1804,  1806,  1808,  1812,  1819,  1830,  1832,
    1833,  1835,  1838,  1841,  1842,  1845,  1848,  1850,  1851,  1857,
    1865,  1867,  1868,  1876,  1879,  1880,  1884,  1890,  1896,  1905,
    1908,  1909,  1912,  1915,  1918,  1924,  1927,  1928,  1931,  1939,
    1950,  1957,  1964,  1971,  1978,  1986,  1994,  2004,  2014,  2021,
    2029,  2036,  2045,  2054,  2063,  2072,  2079,  2086,  2094,  2102,
    2111,  2118,  2128,  2135,  2143,  2146,  2149,  2152,  2155,  2157,
    2160,  2162,  2163,  2170,  2179,  2187,  2194,  2199,  2200,  2202,
    2206,  2211,  2213,  2217,  2219,  2222,  2225,  2228,  2231,  2233,
    2235,  2246,  2249,  2250,  2253,  2256,  2258,  2259,  2264,  2271,
    2277,  2282,  2287,  2299,  2314,  2320,  2328,  2340,  2343,  2345,
    2350,  2351,  2360,  2362,  2364,  2372,  2382,  2391,  2401,  2410,
    2417,  2426,  2431,  2432,  2438,  2439,  2442,  2443,  2446,  2447,
    2450,  2451,  2453,  2455,  2457,  2459,  2461,  2477,  2498,  2500,
    2502,  2505,  2507,  2511,  2513,  2515,  2517,  2521,  2523,  2527,
    2528,  2530,  2531,  2533,  2535,  2540,  2541,  2543,  2547,  2548,
    2550,  2552,  2554,  2556,  2559,  2560,  2561,  2564,  2567,  2569,
    2572,  2575,  2578,  2581,  2588,  2597,  2609,  2623,  2625,  2629,
    2635,  2637,  2641,  2647,  2649,  2652,  2655,  2657,  2666,  2671,
    2677,  2682,  2687,  2692,  2696,  2704,  2713,  2720,  2727,  2734,
    2741,  2748,  2753,  2759,  2763,  2765,  2769,  2773,  2775,  2777,
    2779,  2781,  2783,  2785,  2789,  2791,  2795,  2799,  2801,  2802,
    2804,  2808,  2816,  2826,  2836,  2840,  2841,  2855,  2857,  2861,
    2867,  2874,  2879,  2887,  2890,  2892,  2893,  2896,  2897,  2900,
    2905,  2906,  2908,  2909,  2916,  2925,  2934,  2936,  2940,  2946,
    2952,  2960,  2970,  2978,  2988,  2994,  3001,  3008,  3013,  3018,
    3025,  3030,  3037,  3043,  3051,  3053,  3055,  3057,  3060,  3062,
    3065,  3068,  3070,  3072,  3074,  3076,  3080,  3084,  3088,  3092,
    3094,  3098,  3100,  3103,  3106,  3110,  3112,  3116,  3122,  3125,
    3128,  3129,  3136,  3143,  3150,  3158,  3166,  3174,  3183,  3193,
    3202,  3211,  3218,  3228,  3237,  3247,  3257,  3265,  3276,  3284,
    3286,  3288,  3290,  3292,  3294,  3296,  3298,  3301,  3303,  3305,
    3307,  3309,  3311,  3314,  3316,  3320,  3323,  3327,  3331,  3335,
    3339,  3341,  3343,  3352,  3361,  3370,  3380,  3390,  3400,  3410,
    3413,  3414,  3416,  3418,  3421,  3424,  3426,  3428,  3430,  3432,
    3434,  3436,  3439,  3441,  3443,  3446,  3449,  3451,  3454,  3458,
    3462,  3466,  3470,  3475,  3480,  3484,  3488,  3492,  3497,  3502,
    3506,  3511,  3516,  3518,  3520,  3522,  3523,  3531,  3539,  3550,
    3552,  3554,  3557,  3562,  3568,  3570,  3574,  3577,  3580,  3583,
    3586,  3588,  3591,  3594,  3599,  3603,  3606,  3609,  3612,  3615,
    3619,  3622,  3625,  3628,  3634,  3640,  3646,  3648,  3652,  3654,
    3657,  3661,  3662,  3664,  3668,  3671,  3678,  3685,  3695,  3699,
    3700,  3704,  3705,  3711,  3714,  3715,  3719,  3723,  3727,  3735,
    3743,  3754,  3756,  3758,  3760,  3762,  3777,  3795,  3797,  3798,
    3800,  3801,  3803,  3804,  3807,  3808,  3810,  3814,  3820,  3826,
    3834,  3837,  3838,  3840,  3843,  3844,  3846,  3848,  3849,  3852,
    3855,  3856,  3866,  3879,  3887,  3890,  3891,  3895,  3898,  3900,
    3904,  3908,  3911,  3913,  3917,  3921,  3925,  3928,  3931,  3933,
    3935,  3937,  3939,  3942,  3944,  3946,  3948,  3950,  3955,  3961,
    3963,  3967,  3971,  3973,  3977,  3981,  3987,  3994,  3996,  4000,
    4002,  4005,  4010,  4016,  4018,  4020,  4022,  4024,  4028,  4032,
    4035,  4038,  4040,  4043,  4046,  4049,  4051,  4054,  4057,  4060,
    4062,  4064,  4066,  4070,  4074,  4080,  4083,  4084,  4087,  4089,
    4093,  4099,  4101,  4104,  4106,  4107,  4113,  4121,  4127,  4135,
    4141,  4149,  4153,  4159,  4165,  4171,  4173,  4177,  4180,  4182,
    4185,  4187,  4190,  4202,  4213,  4224,  4227,  4230,  4231,  4241,
    4244,  4245,  4256,  4268,  4280,  4286,  4292,  4301,  4305,  4309,
    4316,  4323,  4325,  4327,  4329,  4331,  4333,  4335,  4339,  4341,
    4347,  4353,  4361,  4368,  4375,  4382,  4389,  4398,  4407,  4414,
    4421,  4429,  4439,  4449,  4458,  4469,  4476,  4483,  4490,  4499,
    4506,  4515,  4522,  4531,  4539,  4549,  4556,  4565,  4573,  4583,
    4592,  4603,  4613,  4625,  4634,  4645,  4655,  4667,  4676,  4685,
    4693,  4700,  4707,  4714,  4723,  4732,  4741,  4750,  4757,  4767,
    4769,  4770,  4773,  4774,  4782,  4789,  4796,  4803,  4810,  4817,
    4825,  4835,  4845,  4852,  4861,  4870,  4879,  4888,  4897,  4904,
    4913,  4920,  4929,  4937,  4947,  4955,  4965,  4972,  4980,  4987,
    4994,  5001,  5008,  5015,  5023,  5031,  5039,  5049,  5059,  5066,
    5073,  5080,  5089,  5098,  5107,  5114,  5122,  5136,  5138,  5140,
    5144,  5148,  5150,  5152,  5154,  5156,  5158,  5160,  5162,  5163,
    5165,  5167,  5169,  5171,  5173,  5175,  5176,  5183,  5192,  5196,
    5199,  5200,  5203,  5206,  5209,  5212,  5216,  5220,  5223,  5226,
    5229,  5232,  5236,  5239,  5245,  5250,  5254,  5258,  5262,  5264,
    5266,  5267,  5271,  5274,  5277,  5279,  5282,  5284,  5288,  5291,
    5293,  5294,  5304,  5316,  5329,  5344,  5348,  5353,  5358,  5359,
    5362,  5368,  5370,  5371,  5373,  5376,  5380,  5384,  5388,  5390,
    5393,  5395,  5397,  5399,  5401,  5403,  5405,  5406,  5412,  5417,
    5424,  5429,  5433,  5439,  5444,  5449,  5456,  5461,  5468,  5475,
    5481,  5489,  5499,  5506,  5508,  5509,  5516,  5528,  5540,  5552,
    5566,  5576,  5588,  5590,  5592,  5603,  5608,  5611,  5617,  5620,
    5621,  5626,  5632,  5638,  5643,  5650,  5652,  5656,  5658,  5660,
    5662,  5664,  5667,  5672,  5674,  5676,  5678,  5679,  5681,  5682,
    5684,  5685,  5689,  5690,  5693,  5698,  5702,  5708,  5710,  5712,
    5714,  5716,  5718,  5720,  5722,  5724,  5726,  5728,  5732,  5735,
    5737,  5739,  5741,  5743,  5744,  5750,  5754,  5755,  5757,  5759,
    5761,  5763,  5767,  5777,  5781,  5782,  5785,  5789,  5792,  5796,
    5804,  5806,  5810,  5812,  5817,  5820,  5822,  5826,  5829,  5838,
    5844,  5845,  5850,  5854,  5855,  5858,  5859,  5867,  5870,  5871,
    5877,  5881,  5882,  5885,  5888,  5891,  5895,  5897,  5901,  5903,
    5906,  5908,  5909,  5911,  5914,  5915,  5924,  5926,  5930,  5932,
    5934,  5938,  5944,  5950,  5953,  5955,  5959,  5967,  5969,  5970,
    5974,  5977,  5980,  5983,  5984,  5987,  5990,  5992,  5994,  5998,
    6002,  6004,  6007,  6012,  6017,  6020,  6024,  6030,  6036,  6038,
    6040,  6050,  6060,  6062,  6065,  6070,  6075,  6080,  6083,  6086,
    6090,  6092,  6096,  6103,  6105,  6106,  6109,  6110,  6114,  6118,
    6123,  6128,  6133,  6138,  6142,  6145,  6147,  6149,  6150,  6152,
    6154,  6155,  6157,  6163,  6165,  6166,  6168,  6169,  6173,  6175,
    6179,  6184,  6188,  6191,  6194,  6196,  6198,  6200,  6201,  6204,
    6209,  6215,  6218,  6222,  6224,  6226,  6228,  6230,  6234,  6235,
    6237,  6239,  6241,  6243,  6245,  6249,  6250,  6252,  6256,  6258,
    6260,  6262,  6264,  6266,  6269,  6274,  6279,  6285,  6288,  6289,
    6291,  6295,  6297,  6298,  6300,  6303,  6307,  6310,  6315,  6318,
    6322,  6325,  6326,  6329,  6333,  6336,  6337,  6339,  6343,  6346,
    6350,  6353,  6357,  6360,  6364,  6366,  6371,  6375,  6380,  6386,
    6391,  6397,  6402,  6408,  6411,  6416,  6418,  6420,  6421,  6423,
    6428,  6434,  6439,  6440,  6443,  6446,  6449,  6451,  6453,  6454,
    6459,  6462,  6464,  6467,  6470,  6475,  6477,  6481,  6483,  6486,
    6490,  6497,  6502,  6503,  6506,  6513,  6516,  6518,  6522,  6527,
    6528,  6531,  6532,  6535,  6536,  6539,  6544,  6545,  6547,  6548,
    6550,  6554,  6558,  6561,  6565,  6571,  6578,  6581,  6585,  6589,
    6594,  6595,  6597,  6599,  6601,  6603,  6605,  6608,  6613,  6615,
    6617,  6619,  6621,  6624,  6628,  6632,  6633,  6635,  6637,  6639,
    6641,  6643,  6646,  6649,  6652,  6655,  6658,  6660,  6664,  6665,
    6667,  6669,  6671,  6673,  6679,  6682,  6684,  6686,  6688,  6690,
    6696,  6699,  6702,  6705,  6707,  6711,  6715,  6718,  6720,  6721,
    6725,  6726,  6732,  6735,  6741,  6744,  6746,  6750,  6754,  6755,
    6757,  6759,  6761,  6763,  6765,  6767,  6771,  6775,  6779,  6783,
    6787,  6791,  6795,  6796,  6798,  6803,  6805,  6809,  6813,  6819,
    6822,  6825,  6829,  6833,  6837,  6841,  6845,  6849,  6853,  6857,
    6861,  6865,  6869,  6873,  6877,  6880,  6883,  6887,  6891,  6894,
    6897,  6901,  6907,  6912,  6919,  6923,  6929,  6934,  6941,  6946,
    6953,  6959,  6967,  6971,  6974,  6979,  6982,  6986,  6990,  6995,
    6999,  7004,  7008,  7013,  7019,  7026,  7033,  7041,  7048,  7056,
    7063,  7071,  7075,  7080,  7085,  7092,  7095,  7099,  7104,  7106,
    7110,  7113,  7116,  7120,  7124,  7128,  7132,  7136,  7140,  7144,
    7148,  7152,  7156,  7160,  7164,  7168,  7171,  7174,  7180,  7187,
    7194,  7202,  7206,  7211,  7213,  7215,  7218,  7223,  7225,  7227,
    7229,  7232,  7235,  7238,  7241,  7243,  7245,  7250,  7254,  7260,
    7267,  7276,  7283,  7290,  7295,  7300,  7302,  7304,  7306,  7312,
    7314,  7316,  7321,  7323,  7328,  7330,  7335,  7337,  7342,  7344,
    7346,  7348,  7350,  7352,  7354,  7361,  7366,  7371,  7376,  7381,
    7388,  7394,  7400,  7406,  7411,  7418,  7423,  7428,  7433,  7438,
    7444,  7452,  7460,  7470,  7476,  7481,  7488,  7494,  7502,  7510,
    7518,  7521,  7525,  7529,  7533,  7538,  7539,  7544,  7546,  7550,
    7554,  7556,  7558,  7560,  7563,  7566,  7567,  7570,  7575,  7580,
    7587,  7593,  7594,  7600,  7601,  7604,  7605,  7607,  7611,  7615,
    7618,  7621,  7622,  7629,  7631,  7632,  7636,  7637,  7640,  7643,
    7644,  7646,  7651,  7654,  7657,  7660,  7663,  7666,  7671,  7675,
    7681,  7686,  7690,  7696,  7698,  7700,  7702,  7704,  7706,  7708,
    7710,  7712,  7714,  7716,  7718,  7720,  7722,  7724,  7726,  7728,
    7730,  7732,  7737,  7739,  7744,  7746,  7751,  7753,  7756,  7758,
    7761,  7763,  7767,  7769,  7773,  7775,  7779,  7783,  7785,  7789,
    7793,  7797,  7800,  7802,  7806,  7810,  7811,  7813,  7815,  7817,
    7819,  7821,  7823,  7825,  7827,  7832,  7836,  7839,  7843,  7844,
    7848,  7852,  7855,  7858,  7860,  7861,  7864,  7867,  7871,  7874,
    7876,  7878,  7882,  7888,  7890,  7893,  7898,  7901,  7902,  7904,
    7905,  7907,  7910,  7913,  7916,  7920,  7926,  7928,  7931,  7932,
    7935,  7937,  7938,  7940,  7942,  7944,  7948,  7952,  7954,  7955,
    7957,  7961,  7965,  7968,  7970,  7972,  7974,  7978,  7980,  7983,
    7985,  7989,  7991,  7993,  7995,  7997,  7999,  8001,  8003,  8006,
    8008,  8010,  8012,  8014,  8016,  8019,  8026,  8029,  8033,  8039,
    8041,  8043,  8045,  8047,  8049,  8051,  8054,  8057,  8059,  8061,
    8063,  8065,  8067,  8071,  8073,  8075,  8077,  8079,  8081,  8083,
    8085,  8087,  8089,  8091,  8093,  8095,  8097,  8099,  8101,  8103,
    8105,  8107,  8109,  8111,  8113,  8115,  8117,  8119,  8121,  8123,
    8125,  8127,  8129,  8131,  8133,  8135,  8137,  8139,  8141,  8143,
    8145,  8147,  8149,  8151,  8153,  8155,  8157,  8159,  8161,  8163,
    8165,  8167,  8169,  8171,  8173,  8175,  8177,  8179,  8181,  8183,
    8185,  8187,  8189,  8191,  8193,  8195,  8197,  8199,  8201,  8203,
    8205,  8207,  8209,  8211,  8213,  8215,  8217,  8219,  8221,  8223,
    8225,  8227,  8229,  8231,  8233,  8235,  8237,  8239,  8241,  8243,
    8245,  8247,  8249,  8251,  8253,  8255,  8257,  8259,  8261,  8263,
    8265,  8267,  8269,  8271,  8273,  8275,  8277,  8279,  8281,  8283,
    8285,  8287,  8289,  8291,  8293,  8295,  8297,  8299,  8301,  8303,
    8305,  8307,  8309,  8311,  8313,  8315,  8317,  8319,  8321,  8323,
    8325,  8327,  8329,  8331,  8333,  8335,  8337,  8339,  8341,  8343,
    8345,  8347,  8349,  8351,  8353,  8355,  8357,  8359,  8361,  8363,
    8365,  8367,  8369,  8371,  8373,  8375,  8377,  8379,  8381,  8383,
    8385,  8387,  8389,  8391,  8393,  8395,  8397,  8399,  8401,  8403,
    8405,  8407,  8409,  8411,  8413,  8415,  8417,  8419,  8421,  8423,
    8425,  8427,  8429,  8431,  8433,  8435,  8437,  8439,  8441,  8443,
    8445,  8447,  8449,  8451,  8453,  8455,  8457,  8459,  8461,  8463,
    8465,  8467,  8469,  8471,  8473,  8475,  8477,  8479,  8481,  8483,
    8485,  8487,  8489,  8491,  8493,  8495,  8497,  8499,  8501,  8503,
    8505,  8507,  8509,  8511,  8513,  8515,  8517,  8519,  8521,  8523,
    8525,  8527,  8529,  8531,  8533,  8535,  8537,  8539,  8541,  8543,
    8545,  8547,  8549,  8551,  8553,  8555,  8557,  8559,  8561,  8563,
    8565,  8567,  8569,  8571,  8573,  8575,  8577,  8579,  8581,  8583,
    8585,  8587,  8589,  8591,  8593,  8595,  8597,  8599,  8601,  8603,
    8605,  8607,  8609,  8611,  8613,  8615,  8617,  8619,  8621,  8623,
    8625,  8627,  8629,  8631,  8633,  8635,  8637,  8639,  8641,  8643,
    8645,  8647,  8649,  8651,  8653,  8655,  8657,  8659,  8661,  8663,
    8665,  8667,  8669,  8671,  8673,  8675,  8677,  8679,  8681,  8683,
    8685,  8687,  8689,  8691,  8693,  8695,  8697,  8699,  8701,  8703,
    8705,  8707,  8709,  8711,  8713,  8715,  8717,  8719,  8721,  8723,
    8725,  8727,  8729,  8731,  8733,  8735,  8737,  8739,  8741,  8743,
    8745,  8747,  8749,  8751,  8753,  8755,  8757,  8759,  8761,  8763,
    8765,  8767,  8769,  8771,  8773,  8775,  8777,  8779,  8781,  8783,
    8785,  8787,  8789,  8791,  8793,  8795,  8797,  8799,  8801,  8803,
    8805,  8807,  8809,  8811,  8813,  8815,  8817,  8819,  8821,  8823,
    8825,  8827,  8829,  8831,  8833,  8835,  8837,  8839,  8841,  8843,
    8845,  8847,  8849,  8851,  8853,  8855,  8857,  8859,  8861,  8863,
    8865,  8867,  8869,  8871,  8873,  8875,  8877,  8879,  8881,  8883,
    8885,  8887,  8889,  8891,  8893,  8895,  8897,  8899,  8901,  8903,
    8905,  8907,  8909,  8911,  8913,  8915,  8917,  8919,  8921,  8923,
    8925,  8927,  8929,  8931
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     457,     0,    -1,   458,    -1,   458,   453,   459,    -1,   459,
      -1,   663,    -1,   822,    -1,   823,    -1,   728,    -1,   827,
      -1,   677,    -1,   603,    -1,   606,    -1,   612,    -1,   626,
      -1,   628,    -1,   767,    -1,   475,    -1,   794,    -1,   795,
      -1,   637,    -1,   582,    -1,   825,    -1,   505,    -1,   790,
      -1,   517,    -1,   469,    -1,   467,    -1,   830,    -1,   829,
      -1,   635,    -1,   471,    -1,   470,    -1,   838,    -1,   503,
      -1,   520,    -1,   833,    -1,   702,    -1,   500,    -1,   521,
      -1,   574,    -1,   665,    -1,   778,    -1,   832,    -1,   826,
      -1,   600,    -1,   607,    -1,   621,    -1,   627,    -1,   744,
      -1,   474,    -1,   577,    -1,   679,    -1,   686,    -1,   687,
      -1,   636,    -1,   589,    -1,   478,    -1,   581,    -1,   537,
      -1,   597,    -1,   782,    -1,   645,    -1,   659,    -1,   460,
      -1,   466,    -1,   632,    -1,   816,    -1,   855,    -1,   878,
      -1,   667,    -1,   864,    -1,   504,    -1,   775,    -1,   666,
      -1,   780,    -1,   611,    -1,   625,    -1,   477,    -1,   690,
      -1,   691,    -1,   692,    -1,   638,    -1,   595,    -1,   803,
      -1,   694,    -1,   599,    -1,   784,    -1,   658,    -1,   472,
      -1,   473,    -1,   634,    -1,   824,    -1,   853,    -1,   844,
      -1,   709,    -1,   713,    -1,   724,    -1,   629,    -1,   733,
      -1,   856,    -1,   806,    -1,   580,    -1,   815,    -1,   866,
      -1,   804,    -1,   850,    -1,   693,    -1,   785,    -1,   771,
      -1,   770,    -1,   772,    -1,   791,    -1,   714,    -1,   725,
      -1,   796,    -1,   705,    -1,   882,    -1,   808,    -1,   700,
      -1,   807,    -1,   871,    -1,   835,    -1,   494,    -1,   482,
      -1,   499,    -1,   813,    -1,    -1,    88,   317,  1057,   461,
     462,    -1,   415,    -1,   436,    -1,    -1,   462,   465,    -1,
      -1,   463,   464,    -1,    -1,   277,  1055,    -1,   277,   249,
      -1,   131,   277,  1055,    -1,   387,   277,  1055,    -1,   185,
      -1,    80,   217,  1056,    -1,   398,   393,  1055,    -1,   395,
    1059,    -1,     3,    -1,   464,    -1,   360,  1054,    -1,    23,
    1059,    -1,   317,  1059,    -1,   180,   317,  1059,    -1,   180,
     166,  1059,    -1,    88,   395,  1057,   461,   462,    -1,    28,
     317,  1058,   461,   463,    -1,    -1,   180,   103,  1047,    -1,
      28,   317,  1058,   468,   497,    -1,    28,   317,    26,   468,
     497,    -1,    28,   395,  1058,   461,   463,    -1,    28,   395,
    1058,   497,    -1,   126,   317,  1059,    -1,   126,   317,   174,
     141,  1059,    -1,   126,   395,  1059,    -1,   126,   395,   174,
     141,  1059,    -1,    88,   166,  1057,   461,   462,    -1,    28,
     166,  1058,   476,   395,  1059,    -1,    22,    -1,   126,    -1,
     126,   166,  1059,    -1,   126,   166,   174,   141,  1059,    -1,
      88,   324,   479,    42,  1058,   480,    -1,    88,   324,  1060,
     480,    -1,    88,   324,   174,   244,   141,   479,    42,  1058,
     480,    -1,    88,   324,   174,   244,   141,  1060,   480,    -1,
    1060,    -1,    -1,   480,   481,    -1,    -1,   537,    -1,   733,
      -1,   581,    -1,   645,    -1,   713,    -1,   813,    -1,   336,
     483,    -1,   336,   220,   483,    -1,   336,   334,   483,    -1,
     375,   811,    -1,   334,    63,    35,   375,   811,    -1,   485,
      -1,   486,   373,   487,    -1,   486,   439,   487,    -1,   486,
     373,   109,    -1,   486,   439,   109,    -1,   484,    -1,   486,
     158,    92,    -1,   371,   433,   491,    -1,    59,  1055,    -1,
     324,  1055,    -1,   237,   492,    -1,   317,   493,    -1,   334,
      42,   493,    -1,   334,    42,   109,    -1,   421,   261,   987,
      -1,   375,   345,  1055,    -1,  1060,    -1,   486,   452,  1060,
      -1,   488,    -1,   487,   454,   488,    -1,   490,    -1,   587,
      -1,   295,   386,    -1,   295,    76,    -1,   307,   295,    -1,
     332,    -1,   380,    -1,   146,    -1,   258,    -1,   493,    -1,
    1055,    -1,     3,    -1,   971,  1055,   973,    -1,   971,   450,
    1054,   451,  1055,    -1,   587,    -1,   109,    -1,   220,    -1,
    1055,    -1,   109,    -1,    -1,  1062,    -1,  1055,    -1,   310,
     495,    -1,   496,    -1,   371,   433,    -1,   375,   203,   215,
      -1,   334,    42,    -1,   486,    -1,    26,    -1,   336,   483,
      -1,   494,    -1,   336,   485,    -1,   494,    -1,   340,   486,
      -1,   340,   371,   433,    -1,   340,   375,   203,   215,    -1,
     340,   334,    42,    -1,   340,    26,    -1,   336,    82,   501,
     502,    -1,    26,    -1,  1043,    -1,   112,    -1,   176,    -1,
      65,    -1,   120,    26,    -1,   120,   366,    -1,   120,   368,
      -1,   120,   279,    -1,   120,   331,    -1,    28,   362,   936,
     506,    -1,    28,   362,   174,   141,   936,   506,    -1,    28,
     362,    26,   180,   365,  1046,   336,   365,  1046,   869,    -1,
      28,   362,    26,   180,   365,  1046,   271,    52,  1059,   336,
     365,  1046,   869,    -1,    28,   183,  1044,   506,    -1,    28,
     183,   174,   141,  1044,   506,    -1,    28,   183,    26,   180,
     365,  1046,   336,   365,  1046,   869,    -1,    28,   183,    26,
     180,   365,  1046,   271,    52,  1059,   336,   365,  1046,   869,
      -1,    28,   330,  1044,   506,    -1,    28,   330,   174,   141,
    1044,   506,    -1,    28,   408,  1044,   506,    -1,    28,   408,
     174,   141,  1044,   506,    -1,    28,   229,   408,  1044,   506,
      -1,    28,   229,   408,   174,   141,  1044,   506,    -1,    28,
     229,   408,    26,   180,   365,  1046,   336,   365,  1046,   869,
      -1,    28,   229,   408,    26,   180,   365,  1046,   271,    52,
    1059,   336,   365,  1046,   869,    -1,   507,    -1,   506,   454,
     507,    -1,    22,   545,    -1,    22,    72,   545,    -1,    28,
     792,  1060,   508,    -1,    28,   792,  1060,   126,   244,   249,
      -1,    28,   792,  1060,   336,   244,   249,    -1,    28,   792,
    1060,   336,   352,  1056,    -1,    28,   792,  1060,   336,   513,
      -1,    28,   792,  1060,   310,   513,    -1,    28,   792,  1060,
     336,   355,  1060,    -1,   126,   792,   174,   141,  1060,   509,
      -1,   126,   792,  1060,   509,    -1,    28,   792,  1060,   793,
     383,   951,   510,   511,    -1,    28,   792,  1060,   615,    -1,
      22,   554,    -1,    28,    81,  1046,   656,    -1,   399,    81,
    1046,    -1,   126,    81,   174,   141,  1046,   509,    -1,   126,
      81,  1046,   509,    -1,   336,   415,   257,    -1,   336,   417,
     257,    -1,    68,   258,  1046,    -1,   336,   417,    68,    -1,
     336,   226,    -1,   336,   392,    -1,   129,   378,  1046,    -1,
     129,    29,   378,  1046,    -1,   129,   309,   378,  1046,    -1,
     129,   378,    26,    -1,   129,   378,   395,    -1,   119,   378,
    1046,    -1,   119,   378,    26,    -1,   119,   378,   395,    -1,
     129,   322,  1046,    -1,   129,    29,   322,  1046,    -1,   129,
     309,   322,  1046,    -1,   119,   322,  1046,    -1,   185,  1044,
      -1,   242,   185,  1044,    -1,   254,   697,    -1,   244,   254,
      -1,   272,   373,  1058,    -1,   336,   365,  1046,    -1,   336,
     513,    -1,   310,   513,    -1,   309,   173,   512,    -1,   129,
     320,   215,   328,    -1,   119,   320,   215,   328,    -1,   615,
      -1,   336,   109,   975,    -1,   126,   109,    -1,    55,    -1,
     312,    -1,    -1,    70,   697,    -1,    -1,   396,   975,    -1,
      -1,   245,    -1,   159,    -1,   109,    -1,   396,   183,  1046,
      -1,   450,   515,   451,    -1,   415,   513,    -1,    -1,   516,
      -1,   515,   454,   516,    -1,  1063,   439,   671,    -1,  1063,
      -1,  1063,   452,  1063,   439,   671,    -1,  1063,   452,  1063,
      -1,    28,   383,   697,   518,    -1,   519,    -1,   518,   454,
     519,    -1,    22,    41,   950,   509,    -1,   126,    41,   174,
     141,  1060,   509,    -1,   126,    41,  1060,   509,    -1,    28,
      41,  1060,   793,   383,   951,   510,   509,    -1,    67,   879,
      -1,    67,    26,    -1,    86,   528,  1044,   557,   529,   522,
     523,   524,   530,   461,   525,    -1,    86,   883,   373,   523,
     524,   461,   525,    -1,   158,    -1,   373,    -1,   292,    -1,
      -1,  1055,    -1,   353,    -1,   354,    -1,   526,    -1,   450,
     532,   451,    -1,   526,   527,    -1,    -1,    48,    -1,   257,
      -1,   157,    -1,   115,   828,  1055,    -1,   249,   828,  1055,
      -1,    90,    -1,   170,    -1,   293,   828,  1055,    -1,   134,
     828,  1055,    -1,   154,   293,   558,    -1,   154,   293,   443,
      -1,   154,   244,   249,   558,    -1,   154,   249,   558,    -1,
     130,  1055,    -1,    48,    -1,    -1,   415,   257,    -1,    -1,
     531,   116,  1055,    -1,    -1,   396,    -1,    -1,   533,    -1,
     532,   454,   533,    -1,  1063,   534,    -1,   490,    -1,   587,
      -1,   443,    -1,   450,   535,   451,    -1,    -1,   536,    -1,
     535,   454,   536,    -1,   490,    -1,    88,   538,   362,  1044,
     450,   539,   451,   568,   569,   570,   571,    -1,    88,   538,
     362,   174,   244,   141,  1044,   450,   539,   451,   568,   569,
     570,   571,    -1,    88,   538,   362,  1044,   254,   697,   540,
     569,   570,   571,    -1,    88,   538,   362,   174,   244,   141,
    1044,   254,   697,   540,   569,   570,   571,    -1,   368,    -1,
     366,    -1,   220,   368,    -1,   220,   366,    -1,   162,   368,
      -1,   162,   366,    -1,   392,    -1,    -1,   541,    -1,    -1,
     450,   542,   451,    -1,    -1,   543,    -1,   541,   454,   543,
      -1,   544,    -1,   542,   454,   544,    -1,   545,    -1,   551,
      -1,   554,    -1,   546,    -1,   554,    -1,  1060,   951,   613,
     547,    -1,  1060,   415,   262,   547,    -1,   547,   548,    -1,
      -1,    81,  1046,   549,    -1,   549,    -1,   550,    -1,    70,
     697,    -1,   244,   249,    -1,   249,    -1,   389,   764,   572,
      -1,   287,   205,   764,   572,    -1,    64,   450,   975,   451,
     556,    -1,   109,   976,    -1,   301,  1044,   557,   560,   564,
      -1,   111,    -1,   244,   111,    -1,   187,   112,    -1,   187,
     176,    -1,   216,  1044,   552,    -1,   552,   181,   553,    -1,
     552,   138,   553,    -1,    -1,   110,    -1,    82,    -1,   184,
      -1,   355,    -1,    74,    -1,    26,    -1,    81,  1046,   555,
      -1,   555,    -1,    64,   450,   975,   451,   656,    -1,   389,
     450,   558,   451,   764,   572,   656,    -1,   389,   573,   656,
      -1,   287,   205,   450,   558,   451,   764,   572,   656,    -1,
     287,   205,   573,   656,    -1,   137,   737,   450,   561,   451,
     764,   572,   563,   656,    -1,   155,   205,   450,   558,   451,
     301,  1044,   557,   560,   564,   656,    -1,   242,   185,    -1,
      -1,   450,   558,   451,    -1,    -1,   559,    -1,   558,   454,
     559,    -1,  1060,    -1,   228,   159,    -1,   228,   274,    -1,
     228,   342,    -1,    -1,   562,    -1,   561,   454,   562,    -1,
     739,   415,   774,    -1,   739,   415,   260,   450,   774,   451,
      -1,   412,   450,   975,   451,    -1,    -1,   565,    -1,   566,
      -1,   565,   566,    -1,   566,   565,    -1,    -1,   258,   394,
     567,    -1,   258,   114,   567,    -1,   242,    21,    -1,   312,
      -1,    55,    -1,   336,   249,    -1,   336,   109,    -1,   186,
     450,  1043,   451,    -1,    -1,   415,   513,    -1,   415,   257,
      -1,   417,   257,    -1,    -1,   258,    75,   126,    -1,   258,
      75,   114,   321,    -1,   258,    75,   284,   321,    -1,    -1,
     365,  1046,    -1,    -1,   396,   183,   365,  1046,    -1,    -1,
     396,   183,  1050,    -1,    88,   538,   362,   575,    35,   882,
     576,    -1,    88,   538,   362,   174,   244,   141,   575,    35,
     882,   576,    -1,  1044,   557,   569,   570,   571,    -1,   415,
     102,    -1,   415,   242,   102,    -1,    -1,    88,   579,   229,
     408,   578,    35,   882,   576,    -1,    88,   579,   229,   408,
     174,   244,   141,   578,    35,   882,   576,    -1,  1044,   557,
     514,   571,    -1,   392,    -1,    -1,   302,   229,   408,   735,
    1044,   576,    -1,    88,   538,   330,  1044,   583,    -1,    88,
     538,   330,   174,   244,   141,  1044,   583,    -1,    28,   330,
    1044,   584,    -1,    28,   330,   174,   141,  1044,   584,    -1,
     584,    -1,    -1,   585,    -1,   584,   585,    -1,    53,   587,
      -1,   101,    -1,   242,   101,    -1,   182,   586,   587,    -1,
     230,   587,    -1,   232,   587,    -1,   242,   230,    -1,   242,
     232,    -1,   271,    52,   697,    -1,   350,   461,   587,    -1,
     311,    -1,   311,   461,   587,    -1,    52,    -1,    -1,     4,
      -1,   442,     4,    -1,  1056,    -1,   587,    -1,   588,   454,
     587,    -1,    88,   745,   590,   596,   207,   493,    -1,    88,
     745,   590,   596,   207,   493,   168,   591,   592,   594,    -1,
     382,    -1,    -1,  1046,    -1,  1046,   698,    -1,   188,   591,
      -1,    -1,   400,   591,    -1,   242,   400,    -1,   593,    -1,
      -1,   126,   596,   207,   493,   509,    -1,   126,   596,   207,
     174,   141,   493,   509,    -1,   290,    -1,    -1,    88,   365,
    1046,   598,   223,  1055,   514,    -1,   272,  1058,    -1,    -1,
     126,   365,  1046,    -1,   126,   365,   174,   141,  1046,    -1,
      88,   143,  1046,   461,   601,    -1,    88,   143,   174,   244,
     141,  1046,   461,   601,    -1,   601,   602,    -1,    -1,   324,
    1046,    -1,   407,   493,    -1,   158,   493,    -1,    28,   143,
    1046,   394,   604,    -1,   604,   605,    -1,    -1,   373,   493,
      -1,    28,   143,  1046,   476,    25,  1052,   757,    -1,    28,
     143,  1046,   476,    58,   450,   951,    35,   951,   451,    -1,
      28,   143,  1046,   476,    71,   697,    -1,    28,   143,  1046,
     476,    85,   697,    -1,    28,   143,  1046,   476,   124,   951,
      -1,    28,   143,  1046,   476,   160,   723,    -1,    28,   143,
    1046,   476,   596,   207,  1046,    -1,    28,   143,  1046,   476,
     260,   774,   773,    -1,    28,   143,  1046,   476,   260,    66,
     697,   396,  1048,    -1,    28,   143,  1046,   476,   260,   147,
     697,   396,  1048,    -1,    28,   143,  1046,   476,   324,  1046,
      -1,    28,   143,  1046,   476,   135,   378,  1046,    -1,    28,
     143,  1046,   476,   362,   697,    -1,    28,   143,  1046,   476,
     369,   326,   273,   697,    -1,    28,   143,  1046,   476,   369,
     326,   118,   697,    -1,    28,   143,  1046,   476,   369,   326,
     367,   697,    -1,    28,   143,  1046,   476,   369,   326,    78,
     697,    -1,    28,   143,  1046,   476,   330,   697,    -1,    28,
     143,  1046,   476,   408,   697,    -1,    28,   143,  1046,   476,
     229,   408,   697,    -1,    28,   143,  1046,   476,   155,   362,
     697,    -1,    28,   143,  1046,   476,   155,   102,   419,  1046,
      -1,    28,   143,  1046,   476,   333,  1046,    -1,    28,   143,
    1046,   476,   376,   153,   951,   207,  1046,    -1,    28,   143,
    1046,   476,   383,   951,    -1,    88,   155,   102,   419,  1046,
     610,   613,    -1,   168,   591,    -1,   242,   168,    -1,   400,
     591,    -1,   242,   400,    -1,   608,    -1,   609,   608,    -1,
     609,    -1,    -1,   126,   155,   102,   419,  1046,   509,    -1,
     126,   155,   102,   419,   174,   141,  1046,   509,    -1,    28,
     155,   102,   419,  1046,   610,   615,    -1,    28,   155,   102,
     419,  1046,   609,    -1,   262,   450,   614,   451,    -1,    -1,
     618,    -1,   614,   454,   618,    -1,   262,   450,   616,   451,
      -1,   617,    -1,   616,   454,   617,    -1,   618,    -1,   336,
     618,    -1,    22,   618,    -1,   126,   619,    -1,   619,   620,
      -1,  1063,    -1,  1055,    -1,    88,   333,  1046,   622,   624,
     155,   102,   419,  1046,   613,    -1,   383,  1055,    -1,    -1,
     407,  1055,    -1,   407,   249,    -1,   623,    -1,    -1,   126,
     333,  1046,   509,    -1,   126,   333,   174,   141,  1046,   509,
      -1,    28,   333,  1046,   623,   615,    -1,    28,   333,  1046,
     623,    -1,    28,   333,  1046,   615,    -1,    88,   155,   362,
    1044,   450,   539,   451,   568,   333,  1046,   613,    -1,    88,
     155,   362,   174,   244,   141,  1044,   450,   539,   451,   568,
     333,  1046,   613,    -1,    28,   155,   362,   936,   506,    -1,
      28,   155,   362,   174,   141,   936,   506,    -1,   179,   155,
     324,  1046,   631,   158,   333,  1046,   199,  1046,   613,    -1,
     217,   373,    -1,   136,    -1,   630,   450,   937,   451,    -1,
      -1,    88,   395,   227,   153,   633,   333,  1046,   613,    -1,
    1058,    -1,   395,    -1,   126,   395,   227,   153,   633,   333,
    1046,    -1,   126,   395,   227,   174,   141,   153,   633,   333,
    1046,    -1,    28,   395,   227,   153,   633,   333,  1046,   615,
      -1,    88,   280,  1046,   258,  1044,   643,   641,   639,   640,
      -1,    28,   280,  1046,   258,  1044,   642,   639,   640,    -1,
     126,   280,  1046,   258,   697,   509,    -1,   126,   280,   174,
     141,  1046,   258,   697,   509,    -1,   396,   450,   975,   451,
      -1,    -1,   415,    64,   450,   975,   451,    -1,    -1,   373,
    1059,    -1,    -1,   373,  1059,    -1,    -1,   153,   644,    -1,
      -1,    26,    -1,   329,    -1,   193,    -1,   394,    -1,   114,
      -1,    88,   378,  1046,   646,   647,   258,  1044,   649,   652,
     140,   291,  1052,   450,   653,   451,    -1,    88,    81,   378,
    1046,    24,   647,   258,  1044,   655,   656,   153,   127,   320,
     652,   140,   291,  1052,   450,   653,   451,    -1,    44,    -1,
      24,    -1,   194,   254,    -1,   648,    -1,   647,   263,   648,
      -1,   193,    -1,   114,    -1,   394,    -1,   394,   254,   558,
      -1,   381,    -1,   153,   650,   651,    -1,    -1,   127,    -1,
      -1,   320,    -1,   351,    -1,   411,   450,   975,   451,    -1,
      -1,   654,    -1,   653,   454,   654,    -1,    -1,  1054,    -1,
       4,    -1,  1055,    -1,  1063,    -1,   158,  1044,    -1,    -1,
      -1,   656,   657,    -1,   244,   111,    -1,   111,    -1,   187,
     176,    -1,   187,   112,    -1,   244,   398,    -1,   242,   185,
      -1,   126,   378,  1046,   258,   697,   509,    -1,   126,   378,
     174,   141,  1046,   258,   697,   509,    -1,    88,   135,   378,
    1046,   258,  1063,   140,   291,  1052,   450,   451,    -1,    88,
     135,   378,  1046,   258,  1063,   411,   660,   140,   291,  1052,
     450,   451,    -1,   661,    -1,   660,    32,   661,    -1,  1060,
     180,   450,   662,   451,    -1,     5,    -1,   662,   454,     5,
      -1,    28,   135,   378,  1046,   664,    -1,   129,    -1,   129,
     309,    -1,   129,    29,    -1,   119,    -1,    88,    37,  1046,
      64,   450,   975,   451,   656,    -1,   126,    37,  1046,   509,
      -1,    88,    25,  1052,   757,   668,    -1,    88,    25,  1052,
     672,    -1,    88,   260,   774,   668,    -1,    88,   383,   697,
     668,    -1,    88,   383,   697,    -1,    88,   383,   697,    35,
     450,   948,   451,    -1,    88,   383,   697,    35,   133,   450,
     675,   451,    -1,    88,   383,   697,    35,   294,   668,    -1,
      88,   369,   326,   273,   697,   668,    -1,    88,   369,   326,
     118,   697,   668,    -1,    88,   369,   326,   367,   697,   668,
      -1,    88,   369,   326,    78,   697,   668,    -1,    88,    71,
     697,   668,    -1,    88,    71,   697,   158,   697,    -1,   450,
     669,   451,    -1,   670,    -1,   669,   454,   670,    -1,  1063,
     439,   671,    -1,  1063,    -1,   754,    -1,  1067,    -1,  1009,
      -1,   587,    -1,  1055,    -1,   450,   673,   451,    -1,   674,
      -1,   673,   454,   674,    -1,     3,   439,   671,    -1,   676,
      -1,    -1,  1055,    -1,   676,   454,  1055,    -1,    28,   383,
     697,    22,   401,   678,  1055,    -1,    28,   383,   697,    22,
     401,   678,  1055,    44,  1055,    -1,    28,   383,   697,    22,
     401,   678,  1055,    24,  1055,    -1,   174,   244,   141,    -1,
      -1,    88,   260,    66,   697,   682,   153,   383,   951,   396,
    1048,   683,    35,   680,    -1,   681,    -1,   680,   454,   681,
      -1,   260,  1054,   774,   684,   685,    -1,   260,  1054,   774,
     773,   684,   685,    -1,   160,  1054,  1052,   746,    -1,   160,
    1054,   450,  1014,   451,  1052,   746,    -1,   355,   951,    -1,
     109,    -1,    -1,   147,   697,    -1,    -1,   153,   326,    -1,
     153,   264,    52,   697,    -1,    -1,   298,    -1,    -1,    88,
     260,   147,   697,   396,  1048,    -1,    28,   260,   147,   697,
     396,  1048,    22,   680,    -1,    28,   260,   147,   697,   396,
    1048,   126,   688,    -1,   689,    -1,   688,   454,   689,    -1,
     260,  1054,   450,  1014,   451,    -1,   160,  1054,   450,  1014,
     451,    -1,   126,   260,    66,   697,   396,  1048,   509,    -1,
     126,   260,    66,   174,   141,   697,   396,  1048,   509,    -1,
     126,   260,   147,   697,   396,  1048,   509,    -1,   126,   260,
     147,   174,   141,   697,   396,  1048,   509,    -1,   126,   271,
      52,  1059,   509,    -1,   297,   271,    52,  1059,   373,  1058,
      -1,   126,   695,   174,   141,   696,   509,    -1,   126,   695,
     696,   509,    -1,   126,   383,   699,   509,    -1,   126,   383,
     174,   141,   699,   509,    -1,   126,   124,   699,   509,    -1,
     126,   124,   174,   141,   699,   509,    -1,   126,   183,    77,
     696,   509,    -1,   126,   183,    77,   174,   141,   696,   509,
      -1,   362,    -1,   330,    -1,   408,    -1,   229,   408,    -1,
     183,    -1,   155,   362,    -1,   135,   378,    -1,    71,    -1,
      85,    -1,   324,    -1,   143,    -1,   369,   326,   273,    -1,
     369,   326,   118,    -1,   369,   326,   367,    -1,   369,   326,
      78,    -1,   697,    -1,   696,   454,   697,    -1,  1060,    -1,
    1060,   698,    -1,   452,  1049,    -1,   698,   452,  1049,    -1,
     951,    -1,   699,   454,   951,    -1,   381,   893,   937,   701,
     509,    -1,    84,   173,    -1,   311,   173,    -1,    -1,    73,
     258,   703,   697,   201,   704,    -1,    73,   258,   383,   951,
     201,   704,    -1,    73,   258,   124,   951,   201,   704,    -1,
      73,   258,    25,  1052,   757,   201,   704,    -1,    73,   258,
     160,  1052,   746,   201,   704,    -1,    73,   258,   260,   774,
     773,   201,   704,    -1,    73,   258,    81,  1046,   258,   697,
     201,   704,    -1,    73,   258,    81,  1046,   258,   124,   697,
     201,   704,    -1,    73,   258,   280,  1046,   258,   697,   201,
     704,    -1,    73,   258,   322,  1046,   258,   697,   201,   704,
      -1,    73,   258,   322,  1046,   201,   704,    -1,    73,   258,
     376,   153,   951,   207,  1046,   201,   704,    -1,    73,   258,
     378,  1046,   258,   697,   201,   704,    -1,    73,   258,   260,
      66,   697,   396,  1048,   201,   704,    -1,    73,   258,   260,
     147,   697,   396,  1048,   201,   704,    -1,    73,   258,   208,
     253,   587,   201,   704,    -1,    73,   258,    58,   450,   951,
      35,   951,   451,   201,   704,    -1,    73,   258,   596,   207,
     697,   201,   704,    -1,    72,    -1,   103,    -1,   324,    -1,
     183,    -1,   330,    -1,   362,    -1,   408,    -1,   229,   408,
      -1,    71,    -1,    85,    -1,   365,    -1,   143,    -1,   317,
      -1,   155,   362,    -1,   333,    -1,   155,   102,   419,    -1,
     135,   378,    -1,   369,   326,    78,    -1,   369,   326,   118,
      -1,   369,   326,   273,    -1,   369,   326,   367,    -1,  1055,
      -1,   249,    -1,   328,   206,   706,   258,   707,   697,   201,
     708,    -1,   328,   206,   706,   258,   383,   951,   201,   708,
      -1,   328,   206,   706,   258,   124,   951,   201,   708,    -1,
     328,   206,   706,   258,    25,  1052,   757,   201,   708,    -1,
     328,   206,   706,   258,   160,  1052,   746,   201,   708,    -1,
     328,   206,   706,   258,   208,   253,   587,   201,   708,    -1,
     328,   206,   706,   258,   596,   207,   697,   201,   708,    -1,
     153,   493,    -1,    -1,    72,    -1,   103,    -1,   135,   378,
      -1,   155,   362,    -1,   324,    -1,   330,    -1,   362,    -1,
     317,    -1,   365,    -1,   408,    -1,   229,   408,    -1,  1055,
      -1,   249,    -1,   148,   710,    -1,   235,   710,    -1,   879,
      -1,   711,   879,    -1,   241,   712,   879,    -1,   288,   712,
     879,    -1,   150,   712,   879,    -1,   209,   712,   879,    -1,
      19,  1056,   712,   879,    -1,   304,  1056,   712,   879,    -1,
    1056,   712,   879,    -1,    26,   712,   879,    -1,   156,   712,
     879,    -1,   156,  1056,   712,   879,    -1,   156,    26,   712,
     879,    -1,    43,   712,   879,    -1,    43,  1056,   712,   879,
      -1,    43,    26,   712,   879,    -1,   158,    -1,   180,    -1,
     711,    -1,    -1,   163,   715,   258,   718,   373,   719,   721,
      -1,   315,   715,   258,   718,   158,   719,   509,    -1,   315,
     163,   261,   153,   715,   258,   718,   158,   719,   509,    -1,
     716,    -1,    26,    -1,    26,   289,    -1,    26,   450,   558,
     451,    -1,    26,   289,   450,   558,   451,    -1,   717,    -1,
     716,   454,   717,    -1,   329,   557,    -1,   301,   557,    -1,
      88,   557,    -1,  1060,   557,    -1,  1043,    -1,   362,  1043,
      -1,   330,  1043,    -1,   155,   102,   419,  1045,    -1,   155,
     333,  1045,    -1,   160,   722,    -1,   103,  1045,    -1,   124,
     696,    -1,   207,  1045,    -1,   208,   253,   588,    -1,   324,
    1045,    -1,   365,  1045,    -1,   383,   696,    -1,    26,   363,
     180,   324,  1045,    -1,    26,   331,   180,   324,  1045,    -1,
      26,   161,   180,   324,  1045,    -1,   720,    -1,   719,   454,
     720,    -1,  1058,    -1,   166,  1058,    -1,   415,   163,   261,
      -1,    -1,   723,    -1,   722,   454,   723,    -1,  1052,   746,
      -1,   163,   716,   373,  1059,   726,   727,    -1,   315,   716,
     158,  1059,   727,   509,    -1,   315,    23,   261,   153,   716,
     158,  1059,   727,   509,    -1,   415,    23,   261,    -1,    -1,
     164,    52,  1058,    -1,    -1,    28,   109,   289,   729,   731,
      -1,   729,   730,    -1,    -1,   180,   324,  1045,    -1,   153,
     317,  1059,    -1,   153,   395,  1059,    -1,   163,   715,   258,
     732,   373,   719,   721,    -1,   315,   715,   258,   732,   158,
     719,   509,    -1,   315,   163,   261,   153,   715,   258,   732,
     158,   719,   509,    -1,   363,    -1,   161,    -1,   331,    -1,
     384,    -1,    88,   734,   183,   735,   736,   258,  1044,   737,
     450,   738,   451,   514,   571,   946,    -1,    88,   734,   183,
     735,   174,   244,   141,  1050,   258,  1044,   737,   450,   738,
     451,   514,   571,   946,    -1,   389,    -1,    -1,    77,    -1,
      -1,  1050,    -1,    -1,   396,  1048,    -1,    -1,   739,    -1,
     738,   454,   739,    -1,  1060,   740,   741,   742,   743,    -1,
     980,   740,   741,   742,   743,    -1,   450,   975,   451,   740,
     741,   742,   743,    -1,    70,   697,    -1,    -1,   697,    -1,
     396,   697,    -1,    -1,    36,    -1,   117,    -1,    -1,   435,
     150,    -1,   435,   209,    -1,    -1,    88,   745,   160,  1052,
     748,   314,   753,   759,   764,    -1,    88,   745,   160,  1052,
     748,   314,   362,   450,   766,   451,   759,   764,    -1,    88,
     745,   160,  1052,   748,   759,   764,    -1,   263,   308,    -1,
      -1,   450,   747,   451,    -1,   450,   451,    -1,   750,    -1,
     747,   454,   750,    -1,   450,   749,   451,    -1,   450,   451,
      -1,   755,    -1,   749,   454,   755,    -1,   751,   752,   754,
      -1,   752,   751,   754,    -1,   752,   754,    -1,   751,   754,
      -1,   754,    -1,   180,    -1,   266,    -1,   190,    -1,   180,
     266,    -1,   404,    -1,  1061,    -1,   754,    -1,   951,    -1,
    1061,   698,   445,   383,    -1,   338,  1061,   698,   445,   383,
      -1,   750,    -1,   750,   109,   975,    -1,   750,   439,   975,
      -1,   750,    -1,   450,   443,   451,    -1,   450,   758,   451,
      -1,   450,   264,    52,   758,   451,    -1,   450,   758,   264,
      52,   758,   451,    -1,   756,    -1,   758,   454,   756,    -1,
     761,    -1,   759,   761,    -1,    54,   258,   249,   191,    -1,
     314,   249,   258,   249,   191,    -1,   356,    -1,   177,    -1,
     348,    -1,   410,    -1,   144,   328,   113,    -1,   144,   328,
     200,    -1,   328,   113,    -1,   328,   200,    -1,   212,    -1,
     244,   212,    -1,    87,   587,    -1,   321,   587,    -1,   498,
      -1,    35,   762,    -1,   207,   493,    -1,   376,   763,    -1,
     414,    -1,   760,    -1,  1055,    -1,  1055,   454,  1055,    -1,
     153,   383,   951,    -1,   763,   454,   153,   383,   951,    -1,
     415,   668,    -1,    -1,   752,   754,    -1,   765,    -1,   766,
     454,   765,    -1,    28,   160,   723,   768,   769,    -1,   760,
      -1,   768,   760,    -1,   312,    -1,    -1,   126,   160,  1052,
     746,   509,    -1,   126,   160,   174,   141,  1052,   746,   509,
      -1,   126,    25,  1052,   757,   509,    -1,   126,    25,   174,
     141,  1052,   757,   509,    -1,   126,   260,   774,   773,   509,
      -1,   126,   260,   174,   141,   774,   773,   509,    -1,   450,
     951,   451,    -1,   450,   951,   454,   951,   451,    -1,   450,
     243,   454,   951,   451,    -1,   450,   951,   454,   243,   451,
      -1,  1006,    -1,  1060,   452,   774,    -1,   122,   776,    -1,
     777,    -1,   776,   777,    -1,  1055,    -1,   207,   493,    -1,
      88,    58,   450,   951,    35,   951,   451,   415,   160,   723,
     779,    -1,    88,    58,   450,   951,    35,   951,   451,   417,
     160,   779,    -1,    88,    58,   450,   951,    35,   951,   451,
     415,   190,   779,    -1,    35,   178,    -1,    35,    38,    -1,
      -1,   126,    58,   781,   450,   951,    35,   951,   451,   509,
      -1,   174,   141,    -1,    -1,    88,   745,   376,   153,   951,
     207,  1046,   450,   783,   451,    -1,   158,   347,   415,   160,
     723,   454,   373,   347,   415,   160,   723,    -1,   373,   347,
     415,   160,   723,   454,   158,   347,   415,   160,   723,    -1,
     158,   347,   415,   160,   723,    -1,   373,   347,   415,   160,
     723,    -1,   126,   376,   781,   153,   951,   207,  1046,   509,
      -1,   303,   786,  1044,    -1,   303,   787,  1046,    -1,   303,
     450,   788,   451,   786,  1044,    -1,   303,   450,   788,   451,
     787,  1046,    -1,   183,    -1,   362,    -1,   324,    -1,   361,
      -1,   103,    -1,   789,    -1,   788,   454,   789,    -1,   406,
      -1,    28,   365,  1046,   336,   513,    -1,    28,   365,  1046,
     310,   513,    -1,    28,    25,  1052,   757,   306,   373,  1046,
      -1,    28,    71,   697,   306,   373,  1046,    -1,    28,    85,
     697,   306,   373,  1046,    -1,    28,   103,  1047,   306,   373,
    1047,    -1,    28,   124,   697,   306,   373,  1046,    -1,    28,
     124,   697,   306,    81,  1046,   373,  1046,    -1,    28,   155,
     102,   419,  1046,   306,   373,  1046,    -1,    28,   160,   723,
     306,   373,  1046,    -1,    28,   166,  1057,   306,   373,  1057,
      -1,    28,   596,   207,  1046,   306,   373,  1046,    -1,    28,
     260,    66,   697,   396,  1048,   306,   373,  1046,    -1,    28,
     260,   147,   697,   396,  1048,   306,   373,  1046,    -1,    28,
     280,  1046,   258,  1044,   306,   373,  1046,    -1,    28,   280,
     174,   141,  1046,   258,  1044,   306,   373,  1046,    -1,    28,
     324,  1046,   306,   373,  1046,    -1,    28,   333,  1046,   306,
     373,  1046,    -1,    28,   362,   936,   306,   373,  1046,    -1,
      28,   362,   174,   141,   936,   306,   373,  1046,    -1,    28,
     330,  1044,   306,   373,  1046,    -1,    28,   330,   174,   141,
    1044,   306,   373,  1046,    -1,    28,   408,  1044,   306,   373,
    1046,    -1,    28,   408,   174,   141,  1044,   306,   373,  1046,
      -1,    28,   229,   408,  1044,   306,   373,  1046,    -1,    28,
     229,   408,   174,   141,  1044,   306,   373,  1046,    -1,    28,
     183,  1044,   306,   373,  1046,    -1,    28,   183,   174,   141,
    1044,   306,   373,  1046,    -1,    28,   155,   362,   936,   306,
     373,  1046,    -1,    28,   155,   362,   174,   141,   936,   306,
     373,  1046,    -1,    28,   362,   936,   306,   792,  1046,   373,
    1046,    -1,    28,   362,   174,   141,   936,   306,   792,  1046,
     373,  1046,    -1,    28,   229,   408,  1044,   306,   792,  1046,
     373,  1046,    -1,    28,   229,   408,   174,   141,  1044,   306,
     792,  1046,   373,  1046,    -1,    28,   362,   936,   306,    81,
    1046,   373,  1046,    -1,    28,   362,   174,   141,   936,   306,
      81,  1046,   373,  1046,    -1,    28,   155,   362,   936,   306,
     792,  1046,   373,  1046,    -1,    28,   155,   362,   174,   141,
     936,   306,   792,  1046,   373,  1046,    -1,    28,   322,  1046,
     258,  1044,   306,   373,  1046,    -1,    28,   378,  1046,   258,
    1044,   306,   373,  1046,    -1,    28,   135,   378,  1046,   306,
     373,  1046,    -1,    28,   317,  1057,   306,   373,  1057,    -1,
      28,   395,  1057,   306,   373,  1057,    -1,    28,   365,  1046,
     306,   373,  1046,    -1,    28,   369,   326,   273,   697,   306,
     373,  1046,    -1,    28,   369,   326,   118,   697,   306,   373,
    1046,    -1,    28,   369,   326,   367,   697,   306,   373,  1046,
      -1,    28,   369,   326,    78,   697,   306,   373,  1046,    -1,
      28,   383,   697,   306,   373,  1046,    -1,    28,   383,   697,
     306,    41,  1046,   373,  1046,   509,    -1,    72,    -1,    -1,
     336,   102,    -1,    -1,    28,    25,  1052,   757,   336,   324,
    1046,    -1,    28,    71,   697,   336,   324,  1046,    -1,    28,
      85,   697,   336,   324,  1046,    -1,    28,   124,   697,   336,
     324,  1046,    -1,    28,   143,   697,   336,   324,  1046,    -1,
      28,   160,   723,   336,   324,  1046,    -1,    28,   260,   774,
     773,   336,   324,  1046,    -1,    28,   260,    66,   697,   396,
    1048,   336,   324,  1046,    -1,    28,   260,   147,   697,   396,
    1048,   336,   324,  1046,    -1,    28,   362,   936,   336,   324,
    1046,    -1,    28,   362,   174,   141,   936,   336,   324,  1046,
      -1,    28,   369,   326,   273,   697,   336,   324,  1046,    -1,
      28,   369,   326,   118,   697,   336,   324,  1046,    -1,    28,
     369,   326,   367,   697,   336,   324,  1046,    -1,    28,   369,
     326,    78,   697,   336,   324,  1046,    -1,    28,   330,  1044,
     336,   324,  1046,    -1,    28,   330,   174,   141,  1044,   336,
     324,  1046,    -1,    28,   408,  1044,   336,   324,  1046,    -1,
      28,   408,   174,   141,  1044,   336,   324,  1046,    -1,    28,
     229,   408,  1044,   336,   324,  1046,    -1,    28,   229,   408,
     174,   141,  1044,   336,   324,  1046,    -1,    28,   155,   362,
     936,   336,   324,  1046,    -1,    28,   155,   362,   174,   141,
     936,   336,   324,  1046,    -1,    28,   383,   697,   336,   324,
    1046,    -1,    28,    25,  1052,   757,   272,   373,  1058,    -1,
      28,    71,   697,   272,   373,  1058,    -1,    28,    85,   697,
     272,   373,  1058,    -1,    28,   103,  1047,   272,   373,  1058,
      -1,    28,   124,   697,   272,   373,  1058,    -1,    28,   160,
     723,   272,   373,  1058,    -1,    28,   596,   207,  1046,   272,
     373,  1058,    -1,    28,   208,   253,   587,   272,   373,  1058,
      -1,    28,   260,   774,   773,   272,   373,  1058,    -1,    28,
     260,    66,   697,   396,  1048,   272,   373,  1058,    -1,    28,
     260,   147,   697,   396,  1048,   272,   373,  1058,    -1,    28,
     324,  1046,   272,   373,  1058,    -1,    28,   383,   697,   272,
     373,  1058,    -1,    28,   365,  1046,   272,   373,  1058,    -1,
      28,   369,   326,   118,   697,   272,   373,  1058,    -1,    28,
     369,   326,    78,   697,   272,   373,  1058,    -1,    28,   155,
     102,   419,  1046,   272,   373,  1058,    -1,    28,   333,  1046,
     272,   373,  1058,    -1,    28,   135,   378,  1046,   272,   373,
    1058,    -1,    88,   745,   322,  1046,    35,   258,   801,   373,
    1044,   946,   122,   802,   797,    -1,   245,    -1,   799,    -1,
     450,   798,   451,    -1,   798,   453,   800,    -1,   800,    -1,
     882,    -1,   856,    -1,   871,    -1,   864,    -1,   804,    -1,
     799,    -1,    -1,   329,    -1,   394,    -1,   114,    -1,   193,
      -1,   194,    -1,    27,    -1,    -1,   126,   322,  1046,   258,
     697,   509,    -1,   126,   322,   174,   141,  1046,   258,   697,
     509,    -1,   246,  1060,   805,    -1,   454,  1055,    -1,    -1,
     218,  1060,    -1,   391,  1060,    -1,   391,   443,    -1,    18,
     809,    -1,    45,   809,   812,    -1,   350,   375,   812,    -1,
      75,   809,    -1,   132,   809,    -1,   318,   809,    -1,   323,
    1060,    -1,   305,   323,  1060,    -1,   305,  1060,    -1,   318,
     809,   373,   323,  1060,    -1,   318,   809,   373,  1060,    -1,
     285,   375,  1055,    -1,    75,   286,  1055,    -1,   318,   286,
    1055,    -1,   418,    -1,   375,    -1,    -1,   203,   215,   489,
      -1,   295,   259,    -1,   295,   420,    -1,   111,    -1,   244,
     111,    -1,   810,    -1,   811,   454,   810,    -1,   811,   810,
      -1,   811,    -1,    -1,    88,   538,   408,  1044,   557,   514,
      35,   882,   814,    -1,    88,   263,   308,   538,   408,  1044,
     557,   514,    35,   882,   814,    -1,    88,   538,   299,   408,
    1044,   450,   558,   451,   514,    35,   882,   814,    -1,    88,
     263,   308,   538,   299,   408,  1044,   450,   558,   451,   514,
      35,   882,   814,    -1,   415,    64,   261,    -1,   415,    56,
      64,   261,    -1,   415,   220,    64,   261,    -1,    -1,   219,
    1051,    -1,    88,   103,  1047,   461,   817,    -1,   818,    -1,
      -1,   819,    -1,   818,   819,    -1,   820,   821,  1056,    -1,
     820,   821,   490,    -1,   820,   821,   109,    -1,     3,    -1,
      80,   217,    -1,   130,    -1,   223,    -1,   272,    -1,   365,
      -1,   367,    -1,   439,    -1,    -1,    28,   103,  1047,   415,
     817,    -1,    28,   103,  1047,   817,    -1,    28,   103,  1047,
     336,   365,  1046,    -1,    28,   103,  1047,   497,    -1,   126,
     103,  1047,    -1,   126,   103,   174,   141,  1047,    -1,    28,
     361,   336,   484,    -1,    28,   361,   310,   496,    -1,    88,
     124,   697,   828,   951,   547,    -1,    28,   124,   697,   508,
      -1,    28,   124,   697,   126,   244,   249,    -1,    28,   124,
     697,   336,   244,   249,    -1,    28,   124,   697,    22,   554,
      -1,    28,   124,   697,   126,    81,  1046,   509,    -1,    28,
     124,   697,   126,    81,   174,   141,  1046,   509,    -1,    28,
     124,   697,   399,    81,  1046,    -1,    35,    -1,    -1,    28,
     369,   326,   118,   697,   668,    -1,    28,   369,   326,    78,
     697,    22,   227,   153,  1045,   831,   696,    -1,    28,   369,
     326,    78,   697,    28,   227,   153,  1045,   831,   696,    -1,
      28,   369,   326,    78,   697,    28,   227,   308,   697,   831,
     697,    -1,    28,   369,   326,    78,   697,    28,   227,   153,
    1045,   308,   697,   831,   697,    -1,    28,   369,   326,    78,
     697,   126,   227,   153,  1045,    -1,    28,   369,   326,    78,
     697,   126,   227,   174,   141,   153,  1045,    -1,   415,    -1,
     436,    -1,    88,   682,    85,   697,   153,  1055,   373,  1055,
     158,   697,    -1,    68,   840,  1044,   834,    -1,    68,   840,
      -1,    68,   840,  1050,   258,  1044,    -1,   396,  1050,    -1,
      -1,   397,   841,   842,   840,    -1,   397,   841,   842,   840,
    1044,    -1,   397,   841,   842,   840,   838,    -1,   397,   450,
     836,   451,    -1,   397,   450,   836,   451,  1044,   843,    -1,
     837,    -1,   836,   454,   837,    -1,   839,    -1,   406,    -1,
     157,    -1,   159,    -1,   839,   840,    -1,   839,   840,  1044,
     843,    -1,    31,    -1,    30,    -1,   406,    -1,    -1,   159,
      -1,    -1,   157,    -1,    -1,   450,  1045,   451,    -1,    -1,
     142,   845,    -1,   142,   839,   840,   845,    -1,   142,   406,
     845,    -1,   142,   450,   846,   451,   845,    -1,   882,    -1,
     856,    -1,   871,    -1,   864,    -1,   878,    -1,   574,    -1,
     577,    -1,   580,    -1,   853,    -1,   847,    -1,   846,   454,
     847,    -1,   848,   849,    -1,  1062,    -1,   839,    -1,   490,
      -1,   587,    -1,    -1,   285,  1046,   851,    35,   852,    -1,
     450,  1014,   451,    -1,    -1,   882,    -1,   856,    -1,   871,
      -1,   864,    -1,   140,  1046,   854,    -1,    88,   538,   362,
     575,    35,   140,  1046,   854,   576,    -1,   450,  1011,   451,
      -1,    -1,   105,  1046,    -1,   105,   285,  1046,    -1,   105,
      26,    -1,   105,   285,    26,    -1,   890,   193,   199,   857,
     858,   861,   863,    -1,  1044,    -1,  1044,    35,  1060,    -1,
     882,    -1,   450,   859,   451,   882,    -1,   109,   402,    -1,
     860,    -1,   859,   454,   860,    -1,  1060,  1035,    -1,   258,
      79,   862,   122,   394,   336,   872,   946,    -1,   258,    79,
     862,   122,   245,    -1,    -1,   450,   738,   451,   946,    -1,
     258,    81,  1046,    -1,    -1,   313,  1041,    -1,    -1,   890,
     114,   158,   938,   865,   947,   863,    -1,   396,   927,    -1,
      -1,   224,   893,   937,   867,   869,    -1,   180,   868,   233,
      -1,    -1,    20,   339,    -1,   320,   339,    -1,   320,   139,
      -1,   339,   394,   139,    -1,   339,    -1,   339,   320,   139,
      -1,   139,    -1,    20,   139,    -1,   248,    -1,    -1,   248,
      -1,   343,   225,    -1,    -1,   890,   394,   938,   336,   872,
     926,   947,   863,    -1,   873,    -1,   872,   454,   873,    -1,
     874,    -1,   875,    -1,   876,   439,  1037,    -1,   450,   877,
     451,   439,  1039,    -1,   450,   877,   451,   439,   883,    -1,
    1060,  1035,    -1,   876,    -1,   877,   454,   876,    -1,   108,
     879,   880,   100,   881,   153,   882,    -1,  1046,    -1,    -1,
     880,   242,   325,    -1,   880,   325,    -1,   880,    48,    -1,
     880,   192,    -1,    -1,   415,   171,    -1,   417,   171,    -1,
     884,    -1,   883,    -1,   450,   884,   451,    -1,   450,   883,
     451,    -1,   886,    -1,   885,   898,    -1,   885,   897,   919,
     902,    -1,   885,   897,   901,   920,    -1,   887,   885,    -1,
     887,   885,   898,    -1,   887,   885,   897,   919,   902,    -1,
     887,   885,   897,   901,   920,    -1,   886,    -1,   883,    -1,
     329,   896,  1040,   891,   926,   946,   911,   918,   992,    -1,
     329,   895,  1041,   891,   926,   946,   911,   918,   992,    -1,
     925,    -1,   362,   936,    -1,   885,   388,   894,   885,    -1,
     885,   197,   894,   885,    -1,   885,   136,   894,   885,    -1,
     415,   888,    -1,   436,   888,    -1,   415,   299,   888,    -1,
     889,    -1,   888,   454,   889,    -1,  1046,   843,    35,   450,
     852,   451,    -1,   887,    -1,    -1,   199,   892,    -1,    -1,
     368,   893,  1044,    -1,   366,   893,  1044,    -1,   220,   368,
     893,  1044,    -1,   220,   366,   893,  1044,    -1,   162,   368,
     893,  1044,    -1,   162,   366,   893,  1044,    -1,   392,   893,
    1044,    -1,   362,  1044,    -1,  1044,    -1,   362,    -1,    -1,
      26,    -1,   121,    -1,    -1,   121,    -1,   121,   258,   450,
    1011,   451,    -1,    26,    -1,    -1,   898,    -1,    -1,   264,
      52,   899,    -1,   900,    -1,   899,   454,   900,    -1,   975,
     396,  1009,   743,    -1,   975,   742,   743,    -1,   903,   904,
      -1,   904,   903,    -1,   903,    -1,   904,    -1,   901,    -1,
      -1,   217,   905,    -1,   217,   905,   454,   906,    -1,   148,
     910,   907,   909,   259,    -1,   256,   906,    -1,   256,   908,
     909,    -1,   975,    -1,    26,    -1,   975,    -1,  1056,    -1,
     450,   975,   451,    -1,    -1,   977,    -1,   320,    -1,   321,
      -1,   150,    -1,   241,    -1,   166,    52,   912,    -1,    -1,
     913,    -1,   912,   454,   913,    -1,   975,    -1,   914,    -1,
     916,    -1,   915,    -1,   917,    -1,   450,   451,    -1,   319,
     450,  1011,   451,    -1,    91,   450,  1011,   451,    -1,   167,
     337,   450,   912,   451,    -1,   169,   975,    -1,    -1,   921,
      -1,   153,   295,   259,    -1,   919,    -1,    -1,   922,    -1,
     921,   922,    -1,   923,   924,   870,    -1,   153,   394,    -1,
     153,   242,   205,   394,    -1,   153,   339,    -1,   153,   205,
     339,    -1,   254,  1043,    -1,    -1,   402,  1039,    -1,   925,
     454,  1039,    -1,   158,   927,    -1,    -1,   928,    -1,   927,
     454,   928,    -1,   936,   931,    -1,   936,   931,   939,    -1,
     941,   932,    -1,   210,   941,   932,    -1,   883,   931,    -1,
     210,   883,   931,    -1,   929,    -1,   450,   929,   451,   930,
      -1,   450,   929,   451,    -1,   928,    89,   204,   928,    -1,
     928,   933,   204,   928,   935,    -1,   928,   204,   928,   935,
      -1,   928,   239,   933,   204,   928,    -1,   928,   239,   204,
     928,    -1,    35,  1060,   450,  1045,   451,    -1,    35,  1060,
      -1,  1060,   450,  1045,   451,    -1,  1060,    -1,   930,    -1,
      -1,   930,    -1,    35,   450,   949,   451,    -1,    35,  1060,
     450,   949,   451,    -1,  1060,   450,   949,   451,    -1,    -1,
     159,   934,    -1,   214,   934,    -1,   316,   934,    -1,   189,
      -1,   267,    -1,    -1,   396,   450,  1045,   451,    -1,   258,
     975,    -1,  1044,    -1,  1044,   443,    -1,   259,  1044,    -1,
     259,   450,  1044,   451,    -1,   936,    -1,   937,   454,   936,
      -1,   936,    -1,   936,  1060,    -1,   936,    35,  1060,    -1,
     364,  1052,   450,  1011,   451,   940,    -1,   307,   450,   975,
     451,    -1,    -1,   980,   945,    -1,   321,   158,   450,   943,
     451,   945,    -1,   980,   944,    -1,   942,    -1,   943,   454,
     942,    -1,    35,   450,   949,   451,    -1,    -1,   436,   265,
      -1,    -1,   412,   975,    -1,    -1,   412,   975,    -1,   412,
      92,   254,   879,    -1,    -1,   949,    -1,    -1,   950,    -1,
     949,   454,   950,    -1,  1060,   951,   510,    -1,   953,   952,
      -1,   338,   953,   952,    -1,   953,    34,   448,  1054,   449,
      -1,   338,   953,    34,   448,  1054,   449,    -1,   953,    34,
      -1,   338,   953,    34,    -1,   952,   448,   449,    -1,   952,
     448,  1054,   449,    -1,    -1,   955,    -1,   957,    -1,   959,
      -1,   963,    -1,   970,    -1,   971,   973,    -1,   971,   450,
    1054,   451,    -1,   957,    -1,   960,    -1,   964,    -1,   970,
      -1,  1061,   956,    -1,  1061,   698,   956,    -1,   450,  1011,
     451,    -1,    -1,   195,    -1,   196,    -1,   344,    -1,    47,
      -1,   296,    -1,   151,   958,    -1,   125,   283,    -1,   107,
     956,    -1,   106,   956,    -1,   252,   956,    -1,    50,    -1,
     450,  1054,   451,    -1,    -1,   961,    -1,   962,    -1,   961,
      -1,   962,    -1,    49,   968,   450,  1011,   451,    -1,    49,
     968,    -1,   965,    -1,   966,    -1,   965,    -1,   966,    -1,
     967,   450,  1054,   451,   969,    -1,   967,   969,    -1,    62,
     968,    -1,    61,   968,    -1,   403,    -1,   238,    62,   968,
      -1,   238,    61,   968,    -1,   240,   968,    -1,   405,    -1,
      -1,    62,   336,  1060,    -1,    -1,   372,   450,  1054,   451,
     972,    -1,   372,   972,    -1,   371,   450,  1054,   451,   972,
      -1,   371,   972,    -1,   198,    -1,   436,   371,   433,    -1,
     417,   371,   433,    -1,    -1,   431,    -1,   234,    -1,   104,
      -1,   172,    -1,   231,    -1,   974,    -1,   431,   373,   234,
      -1,   104,   373,   172,    -1,   104,   373,   231,    -1,   104,
     373,   974,    -1,   172,   373,   231,    -1,   172,   373,   974,
      -1,   231,   373,   974,    -1,    -1,   327,    -1,   327,   450,
    1054,   451,    -1,   977,    -1,   975,    11,   951,    -1,   975,
      70,   697,    -1,   975,    40,   371,   433,   975,    -1,   441,
     975,    -1,   442,   975,    -1,   975,   441,   975,    -1,   975,
     442,   975,    -1,   975,   443,   975,    -1,   975,   444,   975,
      -1,   975,   445,   975,    -1,   975,   446,   975,    -1,   975,
     437,   975,    -1,   975,   438,   975,    -1,   975,   439,   975,
      -1,   975,    15,   975,    -1,   975,    16,   975,    -1,   975,
      17,   975,    -1,   975,  1008,   975,    -1,  1008,   975,    -1,
     975,  1008,    -1,   975,    32,   975,    -1,   975,   263,   975,
      -1,   244,   975,    -1,   434,   975,    -1,   975,   216,   975,
      -1,   975,   216,   975,   134,   975,    -1,   975,   434,   216,
     975,    -1,   975,   434,   216,   975,   134,   975,    -1,   975,
     175,   975,    -1,   975,   175,   975,   134,   975,    -1,   975,
     434,   175,   975,    -1,   975,   434,   175,   975,   134,   975,
      -1,   975,   341,   373,   975,    -1,   975,   341,   373,   975,
     134,   975,    -1,   975,   434,   341,   373,   975,    -1,   975,
     434,   341,   373,   975,   134,   975,    -1,   975,   201,   249,
      -1,   975,   202,    -1,   975,   201,   244,   249,    -1,   975,
     247,    -1,  1002,   269,  1002,    -1,   975,   201,   380,    -1,
     975,   201,   244,   380,    -1,   975,   201,   146,    -1,   975,
     201,   244,   146,    -1,   975,   201,   390,    -1,   975,   201,
     244,   390,    -1,   975,   201,   121,   158,   975,    -1,   975,
     201,   244,   121,   158,   975,    -1,   975,   201,   254,   450,
    1014,   451,    -1,   975,   201,   244,   254,   450,  1014,   451,
      -1,   975,    46,  1036,   976,    32,   975,    -1,   975,   434,
      46,  1036,   976,    32,   975,    -1,   975,    46,   359,   976,
      32,   975,    -1,   975,   434,    46,   359,   976,    32,   975,
      -1,   975,   180,  1026,    -1,   975,   434,   180,  1026,    -1,
     975,  1010,  1005,   883,    -1,   975,  1010,  1005,   450,   975,
     451,    -1,   389,   883,    -1,   975,   201,   123,    -1,   975,
     201,   244,   123,    -1,   977,    -1,   976,    11,   951,    -1,
     441,   976,    -1,   442,   976,    -1,   976,   441,   976,    -1,
     976,   442,   976,    -1,   976,   443,   976,    -1,   976,   444,
     976,    -1,   976,   445,   976,    -1,   976,   446,   976,    -1,
     976,   437,   976,    -1,   976,   438,   976,    -1,   976,   439,
     976,    -1,   976,    15,   976,    -1,   976,    16,   976,    -1,
     976,    17,   976,    -1,   976,  1008,   976,    -1,  1008,   976,
      -1,   976,  1008,    -1,   976,   201,   121,   158,   976,    -1,
     976,   201,   244,   121,   158,   976,    -1,   976,   201,   254,
     450,  1014,   451,    -1,   976,   201,   244,   254,   450,  1014,
     451,    -1,   976,   201,   123,    -1,   976,   201,   244,   123,
      -1,  1032,    -1,  1053,    -1,    10,  1035,    -1,   450,   975,
     451,  1035,    -1,  1027,    -1,   979,    -1,   883,    -1,   883,
    1034,    -1,   141,   883,    -1,    34,   883,    -1,    34,  1015,
      -1,  1003,    -1,  1004,    -1,   167,   450,  1011,   451,    -1,
    1052,   450,   451,    -1,  1052,   450,  1012,   897,   451,    -1,
    1052,   450,   404,  1013,   897,   451,    -1,  1052,   450,  1012,
     454,   404,  1013,   897,   451,    -1,  1052,   450,    26,  1012,
     897,   451,    -1,  1052,   450,   121,  1012,   897,   451,    -1,
    1052,   450,   443,   451,    -1,   978,   990,   991,   995,    -1,
     981,    -1,   978,    -1,   981,    -1,    71,   153,   450,   975,
     451,    -1,    94,    -1,    97,    -1,    97,   450,  1054,   451,
      -1,    98,    -1,    98,   450,  1054,   451,    -1,   221,    -1,
     221,   450,  1054,   451,    -1,   222,    -1,   222,   450,  1054,
     451,    -1,    95,    -1,    99,    -1,   335,    -1,   395,    -1,
      93,    -1,    96,    -1,    58,   450,   975,    35,   951,   451,
      -1,   145,   450,  1017,   451,    -1,   270,   450,  1019,   451,
      -1,   281,   450,  1021,   451,    -1,   358,   450,  1022,   451,
      -1,   377,   450,   975,    35,   951,   451,    -1,   379,   450,
      51,  1025,   451,    -1,   379,   450,   211,  1025,   451,    -1,
     379,   450,   374,  1025,   451,    -1,   379,   450,  1025,   451,
      -1,   250,   450,   975,   454,   975,   451,    -1,    69,   450,
    1011,   451,    -1,   165,   450,  1011,   451,    -1,   213,   450,
    1011,   451,    -1,   423,   450,  1011,   451,    -1,   424,   450,
     236,  1063,   451,    -1,   424,   450,   236,  1063,   454,   984,
     451,    -1,   424,   450,   236,  1063,   454,  1011,   451,    -1,
     424,   450,   236,  1063,   454,   984,   454,  1011,   451,    -1,
     425,   450,   977,   989,   451,    -1,   426,   450,   985,   451,
      -1,   427,   450,   987,   975,   988,   451,    -1,   428,   450,
     236,  1063,   451,    -1,   428,   450,   236,  1063,   454,   975,
     451,    -1,   429,   450,   975,   454,   982,   983,   451,    -1,
     430,   450,   987,   975,    35,   953,   451,    -1,   407,   975,
      -1,   407,   242,   401,    -1,   454,   349,   432,    -1,   454,
     349,   242,    -1,   454,   349,   242,   401,    -1,    -1,   422,
     450,   985,   451,    -1,   986,    -1,   985,   454,   986,    -1,
     975,    35,  1063,    -1,   975,    -1,   123,    -1,    83,    -1,
     284,   413,    -1,   357,   413,    -1,    -1,   276,   977,    -1,
     276,   977,    52,   300,    -1,   276,    52,   300,   977,    -1,
     276,    52,   300,   977,    52,   300,    -1,   416,   166,   450,
     898,   451,    -1,    -1,   149,   450,   412,   975,   451,    -1,
      -1,   414,   993,    -1,    -1,   994,    -1,   993,   454,   994,
      -1,  1060,    35,   996,    -1,   268,   996,    -1,   268,  1060,
      -1,    -1,   450,   997,   998,   897,   999,   451,    -1,  1060,
      -1,    -1,   275,    52,  1011,    -1,    -1,   294,  1000,    -1,
     321,  1000,    -1,    -1,  1001,    -1,    46,  1001,    32,  1001,
      -1,   385,   282,    -1,   385,   152,    -1,    92,   320,    -1,
     975,   282,    -1,   975,   152,    -1,   320,   450,  1011,   451,
      -1,   320,   450,   451,    -1,   450,  1011,   454,   975,   451,
      -1,   320,   450,  1011,   451,    -1,   320,   450,   451,    -1,
     450,  1011,   454,   975,   451,    -1,    33,    -1,   346,    -1,
      26,    -1,     8,    -1,  1007,    -1,   441,    -1,   442,    -1,
     443,    -1,   444,    -1,   445,    -1,   446,    -1,   437,    -1,
     438,    -1,   439,    -1,    15,    -1,    16,    -1,    17,    -1,
       8,    -1,   260,   450,   774,   451,    -1,  1006,    -1,   260,
     450,   774,   451,    -1,  1006,    -1,   260,   450,   774,   451,
      -1,   216,    -1,   434,   216,    -1,   175,    -1,   434,   175,
      -1,   975,    -1,  1011,   454,   975,    -1,  1013,    -1,  1012,
     454,  1013,    -1,   975,    -1,   752,    13,   975,    -1,   752,
      14,   975,    -1,   951,    -1,  1014,   454,   951,    -1,   448,
    1011,   449,    -1,   448,  1016,   449,    -1,   448,   449,    -1,
    1015,    -1,  1016,   454,  1015,    -1,  1018,   158,   975,    -1,
      -1,     3,    -1,   431,    -1,   234,    -1,   104,    -1,   172,
      -1,   231,    -1,   327,    -1,  1055,    -1,   975,  1020,  1023,
    1024,    -1,   975,  1020,  1023,    -1,   278,   975,    -1,   976,
     180,   976,    -1,    -1,   975,  1023,  1024,    -1,   975,  1024,
    1023,    -1,   975,  1023,    -1,   975,  1024,    -1,  1011,    -1,
      -1,   158,   975,    -1,   153,   975,    -1,   975,   158,  1011,
      -1,   158,  1011,    -1,  1011,    -1,   883,    -1,   450,  1011,
     451,    -1,    57,  1031,  1028,  1030,   132,    -1,  1029,    -1,
    1028,  1029,    -1,   411,   975,   370,   975,    -1,   128,   975,
      -1,    -1,   975,    -1,    -1,  1060,    -1,  1060,  1034,    -1,
     452,  1049,    -1,   452,   443,    -1,   448,   975,   449,    -1,
     448,   975,   455,   975,   449,    -1,  1033,    -1,  1034,  1033,
      -1,    -1,  1035,  1033,    -1,    39,    -1,    -1,   975,    -1,
     109,    -1,  1037,    -1,  1038,   454,  1037,    -1,   450,  1038,
     451,    -1,  1041,    -1,    -1,  1042,    -1,  1041,   454,  1042,
      -1,   975,    35,  1063,    -1,   975,     3,    -1,   975,    -1,
     443,    -1,  1044,    -1,  1043,   454,  1044,    -1,  1060,    -1,
    1060,  1034,    -1,  1046,    -1,  1045,   454,  1046,    -1,  1060,
      -1,  1060,    -1,  1060,    -1,  1063,    -1,  1060,    -1,  1055,
      -1,  1061,    -1,  1060,  1034,    -1,  1054,    -1,     4,    -1,
    1055,    -1,     6,    -1,     7,    -1,  1052,  1055,    -1,  1052,
     450,  1012,   897,   451,  1055,    -1,   954,  1055,    -1,   971,
    1055,   973,    -1,   971,   450,  1054,   451,  1055,    -1,   380,
      -1,   146,    -1,   249,    -1,     9,    -1,     5,    -1,  1054,
      -1,   441,  1054,    -1,   442,  1054,    -1,  1058,    -1,  1062,
      -1,    99,    -1,   335,    -1,  1058,    -1,  1059,   454,  1058,
      -1,     3,    -1,  1064,    -1,  1065,    -1,     3,    -1,  1064,
      -1,  1066,    -1,     3,    -1,  1064,    -1,  1065,    -1,  1066,
      -1,     3,    -1,  1064,    -1,  1065,    -1,  1066,    -1,  1067,
      -1,    18,    -1,    19,    -1,    20,    -1,    21,    -1,    22,
      -1,    23,    -1,    24,    -1,    25,    -1,    27,    -1,    28,
      -1,    29,    -1,    37,    -1,    38,    -1,    40,    -1,    41,
      -1,    43,    -1,    44,    -1,    45,    -1,    52,    -1,    53,
      -1,    54,    -1,    55,    -1,    56,    -1,    59,    -1,    60,
      -1,    63,    -1,    65,    -1,    66,    -1,    67,    -1,    68,
      -1,    73,    -1,    74,    -1,    75,    -1,    76,    -1,    78,
      -1,    79,    -1,    80,    -1,    82,    -1,    83,    -1,    84,
      -1,    85,    -1,    86,    -1,    87,    -1,    90,    -1,    91,
      -1,    92,    -1,   100,    -1,   101,    -1,   102,    -1,   103,
      -1,   104,    -1,   105,    -1,   108,    -1,   110,    -1,   112,
      -1,   113,    -1,   114,    -1,   115,    -1,   116,    -1,   118,
      -1,   119,    -1,   120,    -1,   123,    -1,   124,    -1,   125,
      -1,   126,    -1,   127,    -1,   129,    -1,   130,    -1,   131,
      -1,   133,    -1,   134,    -1,   135,    -1,   137,    -1,   138,
      -1,   139,    -1,   140,    -1,   142,    -1,   143,    -1,   144,
      -1,   147,    -1,   149,    -1,   150,    -1,   152,    -1,   154,
      -1,   156,    -1,   160,    -1,   161,    -1,   162,    -1,   164,
      -1,   168,    -1,   170,    -1,   171,    -1,   172,    -1,   173,
      -1,   174,    -1,   176,    -1,   177,    -1,   178,    -1,   179,
      -1,   181,    -1,   182,    -1,   183,    -1,   184,    -1,   185,
      -1,   186,    -1,   188,    -1,   191,    -1,   192,    -1,   193,
      -1,   194,    -1,   200,    -1,   203,    -1,   205,    -1,   206,
      -1,   207,    -1,   208,    -1,   209,    -1,   212,    -1,   215,
      -1,   218,    -1,   219,    -1,   220,    -1,   223,    -1,   224,
      -1,   225,    -1,   226,    -1,   227,    -1,   228,    -1,   229,
      -1,   230,    -1,   231,    -1,   232,    -1,   233,    -1,   234,
      -1,   235,    -1,   236,    -1,   237,    -1,   241,    -1,   242,
      -1,   245,    -1,   246,    -1,   248,    -1,   251,    -1,   253,
      -1,   254,    -1,   255,    -1,   257,    -1,   260,    -1,   261,
      -1,   262,    -1,   265,    -1,   268,    -1,   271,    -1,   272,
      -1,   273,    -1,   274,    -1,   275,    -1,   276,    -1,   277,
      -1,   279,    -1,   280,    -1,   282,    -1,   285,    -1,   286,
      -1,   284,    -1,   288,    -1,   289,    -1,   290,    -1,   291,
      -1,   292,    -1,   293,    -1,   294,    -1,   295,    -1,   297,
      -1,   298,    -1,   299,    -1,   300,    -1,   302,    -1,   303,
      -1,   304,    -1,   305,    -1,   306,    -1,   307,    -1,   308,
      -1,   309,    -1,   310,    -1,   311,    -1,   312,    -1,   314,
      -1,   315,    -1,   317,    -1,   318,    -1,   319,    -1,   321,
      -1,   322,    -1,   323,    -1,   324,    -1,   325,    -1,   326,
      -1,   327,    -1,   328,    -1,   330,    -1,   331,    -1,   332,
      -1,   333,    -1,   334,    -1,   336,    -1,   337,    -1,   339,
      -1,   340,    -1,   342,    -1,   343,    -1,   345,    -1,   347,
      -1,   348,    -1,   349,    -1,   350,    -1,   351,    -1,   352,
      -1,   353,    -1,   354,    -1,   355,    -1,   356,    -1,   357,
      -1,   360,    -1,   361,    -1,   363,    -1,   365,    -1,   366,
      -1,   367,    -1,   368,    -1,   369,    -1,   375,    -1,   376,
      -1,   378,    -1,   381,    -1,   382,    -1,   383,    -1,   384,
      -1,   385,    -1,   386,    -1,   387,    -1,   390,    -1,   391,
      -1,   392,    -1,   393,    -1,   394,    -1,   397,    -1,   398,
      -1,   399,    -1,   400,    -1,   401,    -1,   405,    -1,   407,
      -1,   408,    -1,   409,    -1,   410,    -1,   413,    -1,   416,
      -1,   417,    -1,   418,    -1,   419,    -1,   420,    -1,   421,
      -1,   431,    -1,   432,    -1,   433,    -1,    46,    -1,    47,
      -1,    49,    -1,    50,    -1,    61,    -1,    62,    -1,    69,
      -1,   106,    -1,   107,    -1,   141,    -1,   145,    -1,   151,
      -1,   165,    -1,   167,    -1,   190,    -1,   195,    -1,   196,
      -1,   198,    -1,   213,    -1,   238,    -1,   240,    -1,   243,
      -1,   250,    -1,   252,    -1,   266,    -1,   270,    -1,   281,
      -1,   283,    -1,   296,    -1,   320,    -1,   338,    -1,   344,
      -1,   358,    -1,   371,    -1,   372,    -1,   377,    -1,   379,
      -1,   402,    -1,   403,    -1,   422,    -1,   423,    -1,   424,
      -1,   425,    -1,   426,    -1,   427,    -1,   428,    -1,   429,
      -1,   430,    -1,    42,    -1,    48,    -1,    71,    -1,    77,
      -1,    89,    -1,    96,    -1,   157,    -1,   159,    -1,   175,
      -1,   189,    -1,   201,    -1,   202,    -1,   204,    -1,   214,
      -1,   216,    -1,   239,    -1,   247,    -1,   267,    -1,   269,
      -1,   316,    -1,   341,    -1,   364,    -1,   406,    -1,    26,
      -1,    30,    -1,    31,    -1,    32,    -1,    33,    -1,    34,
      -1,    35,    -1,    36,    -1,    39,    -1,    51,    -1,    57,
      -1,    58,    -1,    64,    -1,    70,    -1,    72,    -1,    81,
      -1,    88,    -1,    93,    -1,    94,    -1,    95,    -1,    97,
      -1,    98,    -1,    99,    -1,   109,    -1,   111,    -1,   117,
      -1,   121,    -1,   122,    -1,   128,    -1,   132,    -1,   136,
      -1,   146,    -1,   148,    -1,   153,    -1,   155,    -1,   158,
      -1,   163,    -1,   166,    -1,   169,    -1,   180,    -1,   187,
      -1,   197,    -1,   199,    -1,   210,    -1,   211,    -1,   217,
      -1,   221,    -1,   222,    -1,   244,    -1,   249,    -1,   256,
      -1,   258,    -1,   259,    -1,   263,    -1,   264,    -1,   278,
      -1,   287,    -1,   301,    -1,   313,    -1,   329,    -1,   335,
      -1,   346,    -1,   359,    -1,   362,    -1,   370,    -1,   373,
      -1,   374,    -1,   380,    -1,   388,    -1,   389,    -1,   395,
      -1,   396,    -1,   404,    -1,   411,    -1,   412,    -1,   414,
      -1,   415,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   767,   767,   774,   781,   791,   792,   793,   794,   795,
     796,   797,   798,   799,   800,   801,   802,   803,   804,   805,
     806,   807,   808,   809,   810,   811,   812,   813,   814,   815,
     816,   817,   818,   819,   820,   821,   822,   823,   824,   825,
     826,   827,   828,   829,   830,   831,   832,   833,   834,   835,
     836,   837,   838,   839,   840,   841,   842,   843,   844,   845,
     846,   847,   848,   849,   850,   851,   852,   853,   854,   855,
     856,   857,   858,   859,   860,   861,   862,   863,   864,   865,
     866,   867,   868,   869,   870,   871,   872,   873,   874,   875,
     876,   877,   878,   879,   880,   881,   882,   883,   884,   885,
     886,   887,   888,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,   899,   900,   901,   902,   903,   904,   905,
     906,   907,   908,   909,   910,   911,   912,   914,   924,   935,
     936,   937,   946,   947,   951,   952,   956,   961,   965,   970,
     975,   979,   983,   988,   992,  1050,  1052,  1056,  1060,  1064,
    1068,  1082,  1100,  1111,  1112,  1116,  1124,  1142,  1154,  1175,
    1182,  1201,  1208,  1225,  1243,  1254,  1255,  1267,  1274,  1291,
    1301,  1311,  1326,  1344,  1345,  1349,  1356,  1364,  1365,  1366,
    1367,  1368,  1369,  1383,  1389,  1395,  1404,  1412,  1420,  1424,
    1432,  1440,  1447,  1456,  1457,  1465,  1476,  1484,  1492,  1503,
    1511,  1519,  1526,  1535,  1545,  1546,  1550,  1551,  1554,  1556,
    1560,  1561,  1562,  1563,  1567,  1568,  1569,  1575,  1587,  1591,
    1595,  1610,  1617,  1618,  1619,  1623,  1624,  1625,  1629,  1630,
    1634,  1638,  1639,  1646,  1653,  1663,  1670,  1680,  1681,  1686,
    1687,  1692,  1698,  1704,  1710,  1716,  1726,  1736,  1737,  1741,
    1742,  1750,  1765,  1771,  1777,  1783,  1789,  1808,  1817,  1826,
    1837,  1848,  1857,  1866,  1877,  1888,  1897,  1906,  1915,  1924,
    1933,  1942,  1953,  1967,  1968,  1973,  1981,  1989,  1998,  2006,
    2014,  2023,  2032,  2041,  2050,  2060,  2073,  2088,  2097,  2105,
    2120,  2128,  2138,  2148,  2155,  2162,  2170,  2178,  2185,  2192,
    2200,  2208,  2216,  2223,  2230,  2238,  2245,  2252,  2260,  2268,
    2276,  2284,  2292,  2300,  2310,  2317,  2325,  2333,  2341,  2349,
    2357,  2364,  2370,  2380,  2381,  2385,  2386,  2387,  2391,  2399,
    2403,  2404,  2408,  2415,  2422,  2429,  2439,  2442,  2443,  2447,
    2448,  2453,  2457,  2461,  2466,  2481,  2494,  2495,  2500,  2509,
    2519,  2529,  2555,  2561,  2591,  2620,  2642,  2643,  2647,  2648,
    2657,  2658,  2659,  2662,  2663,  2668,  2669,  2673,  2677,  2681,
    2685,  2689,  2693,  2697,  2701,  2705,  2709,  2713,  2717,  2721,
    2725,  2734,  2738,  2742,  2746,  2750,  2754,  2758,  2759,  2764,
    2768,  2775,  2782,  2783,  2784,  2785,  2786,  2790,  2794,  2802,
    2813,  2829,  2846,  2863,  2893,  2894,  2895,  2896,  2897,  2904,
    2911,  2912,  2916,  2917,  2921,  2922,  2926,  2930,  2937,  2941,
    2948,  2949,  2950,  2954,  2955,  2958,  2979,  3000,  3001,  3005,
    3013,  3014,  3015,  3046,  3053,  3060,  3071,  3082,  3092,  3101,
    3134,  3141,  3148,  3155,  3166,  3176,  3177,  3178,  3182,  3183,
    3184,  3185,  3186,  3187,  3196,  3204,  3208,  3221,  3236,  3250,
    3265,  3279,  3297,  3318,  3319,  3323,  3324,  3328,  3329,  3332,
    3338,  3342,  3350,  3355,  3361,  3362,  3366,  3371,  3378,  3379,
    3389,  3391,  3393,  3395,  3398,  3401,  3404,  3408,  3409,  3410,
    3411,  3412,  3415,  3416,  3421,  3422,  3423,  3424,  3427,  3428,
    3429,  3430,  3433,  3434,  3437,  3438,  3441,  3456,  3469,  3485,
    3499,  3500,  3501,  3513,  3526,  3542,  3555,  3556,  3568,  3588,
    3598,  3611,  3619,  3630,  3631,  3634,  3635,  3638,  3642,  3646,
    3650,  3654,  3658,  3662,  3666,  3670,  3674,  3678,  3682,  3688,
    3689,  3693,  3694,  3699,  3702,  3703,  3715,  3727,  3742,  3743,
    3751,  3752,  3756,  3757,  3761,  3762,  3766,  3767,  3771,  3782,
    3795,  3796,  3806,  3817,  3818,  3831,  3838,  3855,  3863,  3874,
    3877,  3881,  3885,  3889,  3901,  3911,  3914,  3918,  3931,  3941,
    3951,  3960,  3969,  3978,  3988,  3997,  4007,  4016,  4025,  4034,
    4043,  4052,  4061,  4070,  4079,  4088,  4097,  4106,  4115,  4124,
    4133,  4142,  4152,  4170,  4181,  4182,  4183,  4184,  4188,  4189,
    4193,  4194,  4204,  4215,  4235,  4243,  4255,  4256,  4260,  4264,
    4272,  4276,  4280,  4287,  4291,  4296,  4301,  4308,  4315,  4320,
    4330,  4344,  4345,  4350,  4351,  4355,  4356,  4366,  4377,  4397,
    4406,  4414,  4431,  4451,  4481,  4490,  4511,  4526,  4527,  4531,
    4539,  4554,  4565,  4566,  4576,  4584,  4601,  4623,  4639,  4653,
    4664,  4678,  4679,  4683,  4684,  4688,  4689,  4693,  4694,  4698,
    4699,  4703,  4704,  4705,  4706,  4707,  4719,  4739,  4764,  4765,
    4766,  4770,  4772,  4794,  4796,  4798,  4800,  4802,  4807,  4812,
    4822,  4823,  4827,  4828,  4832,  4833,  4837,  4838,  4839,  4843,
    4847,  4848,  4849,  4853,  4854,  4859,  4860,  4887,  4888,  4889,
    4890,  4891,  4892,  4897,  4908,  4931,  4941,  4955,  4957,  4962,
    4967,  4969,  4974,  4984,  4985,  4986,  4987,  4999,  5019,  5042,
    5052,  5063,  5073,  5083,  5094,  5103,  5110,  5117,  5126,  5135,
    5144,  5153,  5162,  5173,  5176,  5177,  5180,  5184,  5191,  5192,
    5193,  5194,  5195,  5198,  5201,  5202,  5210,  5217,  5218,  5221,
    5223,  5234,  5244,  5254,  5266,  5267,  5283,  5298,  5299,  5303,
    5313,  5324,  5333,  5343,  5352,  5353,  5356,  5357,  5360,  5361,
    5362,  5365,  5379,  5384,  5394,  5403,  5415,  5416,  5420,  5428,
    5440,  5450,  5463,  5473,  5495,  5505,  5523,  5534,  5545,  5555,
    5565,  5575,  5585,  5596,  5610,  5611,  5612,  5613,  5614,  5615,
    5616,  5617,  5618,  5619,  5620,  5621,  5622,  5623,  5624,  5628,
    5629,  5632,  5633,  5636,  5638,  5643,  5644,  5654,  5665,  5666,
    5667,  5700,  5709,  5718,  5727,  5736,  5745,  5754,  5763,  5777,
    5786,  5795,  5805,  5814,  5823,  5831,  5840,  5849,  5858,  5870,
    5871,  5872,  5873,  5874,  5875,  5876,  5877,  5878,  5879,  5880,
    5881,  5882,  5883,  5884,  5885,  5886,  5887,  5888,  5889,  5890,
    5894,  5895,  5909,  5920,  5931,  5942,  5953,  5964,  5975,  5988,
    5989,  5993,  5994,  5995,  5996,  5997,  5998,  5999,  6000,  6001,
    6002,  6003,  6006,  6007,  6017,  6023,  6031,  6039,  6047,  6055,
    6063,  6071,  6079,  6087,  6095,  6103,  6111,  6119,  6127,  6135,
    6143,  6151,  6161,  6162,  6165,  6166,  6176,  6192,  6206,  6232,
    6234,  6236,  6238,  6245,  6254,  6255,  6258,  6265,  6272,  6279,
    6293,  6301,  6309,  6317,  6325,  6333,  6341,  6349,  6357,  6365,
    6373,  6381,  6389,  6397,  6405,  6413,  6425,  6426,  6430,  6431,
    6436,  6437,  6441,  6442,  6447,  6463,  6476,  6486,  6498,  6499,
    6502,  6503,  6513,  6523,  6524,  6528,  6532,  6536,  6547,  6560,
    6574,  6591,  6592,  6593,  6594,  6606,  6632,  6661,  6662,  6666,
    6667,  6671,  6672,  6676,  6677,  6680,  6681,  6689,  6700,  6711,
    6724,  6725,  6728,  6729,  6730,  6733,  6734,  6735,  6738,  6739,
    6740,  6756,  6768,  6781,  6796,  6797,  6800,  6801,  6805,  6806,
    6814,  6815,  6819,  6820,  6835,  6844,  6853,  6862,  6871,  6883,
    6884,  6885,  6886,  6887,  6893,  6897,  6912,  6913,  6919,  6929,
    6933,  6938,  6946,  6987,  6991,  6995,  6999,  7007,  7008,  7013,
    7014,  7021,  7025,  7029,  7033,  7037,  7041,  7045,  7049,  7053,
    7057,  7061,  7065,  7069,  7073,  7077,  7085,  7089,  7093,  7097,
    7101,  7107,  7108,  7115,  7116,  7120,  7121,  7124,  7136,  7140,
    7155,  7166,  7167,  7172,  7173,  7188,  7199,  7213,  7224,  7238,
    7249,  7263,  7271,  7273,  7275,  7280,  7282,  7295,  7304,  7305,
    7309,  7313,  7325,  7336,  7347,  7360,  7361,  7362,  7366,  7379,
    7380,  7390,  7402,  7406,  7410,  7414,  7421,  7442,  7451,  7460,
    7469,  7480,  7481,  7484,  7485,  7486,  7489,  7490,  7493,  7503,
    7512,  7529,  7539,  7548,  7557,  7566,  7575,  7584,  7593,  7603,
    7612,  7621,  7630,  7639,  7649,  7659,  7668,  7677,  7687,  7697,
    7707,  7717,  7727,  7737,  7747,  7757,  7767,  7777,  7787,  7797,
    7808,  7819,  7830,  7841,  7851,  7861,  7872,  7883,  7893,  7903,
    7911,  7920,  7929,  7938,  7947,  7956,  7965,  7974,  7983,  7997,
    7998,  8001,  8002,  8012,  8022,  8031,  8040,  8049,  8058,  8068,
    8078,  8087,  8096,  8105,  8114,  8123,  8132,  8141,  8150,  8159,
    8168,  8177,  8186,  8195,  8204,  8213,  8222,  8239,  8248,  8256,
    8264,  8272,  8280,  8289,  8297,  8305,  8314,  8322,  8330,  8338,
    8346,  8354,  8362,  8370,  8378,  8386,  8403,  8420,  8421,  8422,
    8427,  8433,  8442,  8443,  8444,  8445,  8446,  8450,  8451,  8454,
    8455,  8456,  8457,  8461,  8462,  8463,  8468,  8479,  8501,  8511,
    8512,  8515,  8524,  8530,  8549,  8556,  8563,  8570,  8577,  8584,
    8591,  8599,  8607,  8615,  8623,  8631,  8638,  8645,  8654,  8655,
    8656,  8660,  8663,  8666,  8669,  8672,  8679,  8681,  8683,  8688,
    8690,  8702,  8715,  8728,  8746,  8767,  8768,  8769,  8770,  8780,
    8796,  8806,  8807,  8811,  8812,  8816,  8820,  8824,  8842,  8843,
    8844,  8845,  8846,  8847,  8848,  8855,  8856,  8867,  8874,  8881,
    8892,  8909,  8916,  8934,  8940,  8956,  8969,  8978,  8986,  8994,
    9003,  9014,  9025,  9035,  9036,  9047,  9057,  9068,  9079,  9090,
    9101,  9110,  9122,  9123,  9137,  9160,  9168,  9177,  9188,  9189,
    9201,  9215,  9229,  9241,  9249,  9262,  9263,  9267,  9268,  9269,
    9270,  9274,  9284,  9297,  9298,  9302,  9303,  9306,  9307,  9310,
    9311,  9315,  9316,  9329,  9336,  9346,  9353,  9363,  9364,  9365,
    9366,  9367,  9368,  9369,  9370,  9371,  9375,  9379,  9386,  9393,
    9394,  9398,  9399,  9400,  9410,  9420,  9421,  9425,  9426,  9427,
    9428,  9438,  9445,  9463,  9464,  9474,  9480,  9486,  9492,  9508,
    9526,  9530,  9538,  9544,  9550,  9559,  9561,  9566,  9577,  9587,
    9597,  9603,  9612,  9621,  9627,  9628,  9639,  9653,  9654,  9665,
    9676,  9677,  9680,  9681,  9682,  9683,  9684,  9685,  9686,  9687,
    9690,  9691,  9695,  9696,  9697,  9708,  9726,  9727,  9731,  9732,
    9736,  9752,  9778,  9811,  9822,  9823,  9833,  9844,  9847,  9848,
    9849,  9850,  9851,  9854,  9855,  9856,  9904,  9905,  9909,  9910,
    9925,  9926,  9933,  9941,  9949,  9957,  9965,  9973,  9984,  9985,
   10012, 10026, 10041, 10042, 10061, 10065, 10069, 10086, 10093, 10100,
   10110, 10111, 10114, 10126, 10127, 10131, 10143, 10151, 10156, 10161,
   10166, 10171, 10179, 10187, 10192, 10197, 10204, 10205, 10209, 10210,
   10211, 10218, 10219, 10223, 10224, 10228, 10229, 10233, 10237, 10238,
   10241, 10250, 10263, 10264, 10265, 10266, 10270, 10271, 10275, 10277,
   10287, 10292, 10295, 10300, 10301, 10309, 10319, 10320, 10321, 10329,
   10333, 10334, 10337, 10338, 10363, 10364, 10368, 10369, 10373, 10374,
   10375, 10376, 10377, 10381, 10394, 10401, 10408, 10415, 10416, 10420,
   10421, 10425, 10426, 10430, 10431, 10435, 10446, 10447, 10448, 10449,
   10453, 10454, 10459, 10465, 10483, 10484, 10488, 10489, 10495, 10500,
   10508, 10515, 10523, 10558, 10583, 10587, 10613, 10617, 10629, 10642,
   10656, 10667, 10682, 10688, 10693, 10699, 10706, 10707, 10715, 10719,
   10723, 10729, 10736, 10741, 10742, 10743, 10744, 10748, 10749, 10761,
   10762, 10767, 10774, 10781, 10788, 10799, 10800, 10813, 10817, 10824,
   10837, 10850, 10851, 10866, 10876, 10888, 10893, 10894, 10897, 10898,
   10901, 10902, 10907, 10908, 10913, 10914, 10922, 10927, 10928, 10932,
   10936, 10942, 10972, 10977, 10984, 10989, 10995, 11000, 11009, 11011,
   11014, 11018, 11019, 11020, 11021, 11022, 11023, 11028, 11048, 11049,
   11050, 11051, 11062, 11068, 11076, 11077, 11083, 11088, 11093, 11098,
   11103, 11108, 11113, 11118, 11124, 11130, 11136, 11143, 11165, 11174,
   11178, 11186, 11190, 11198, 11210, 11231, 11235, 11241, 11245, 11258,
   11269, 11284, 11286, 11288, 11290, 11292, 11294, 11299, 11300, 11304,
   11305, 11312, 11321, 11329, 11338, 11349, 11357, 11358, 11359, 11363,
   11365, 11367, 11369, 11371, 11373, 11375, 11380, 11385, 11391, 11399,
   11404, 11411, 11418, 11422, 11426, 11462, 11463, 11465, 11473, 11488,
   11490, 11492, 11494, 11496, 11498, 11500, 11502, 11504, 11506, 11508,
   11510, 11512, 11514, 11517, 11519, 11521, 11524, 11526, 11528, 11530,
   11533, 11538, 11546, 11551, 11559, 11564, 11572, 11577, 11586, 11594,
   11602, 11610, 11628, 11636, 11644, 11652, 11660, 11676, 11684, 11692,
   11700, 11708, 11716, 11724, 11728, 11734, 11738, 11742, 11750, 11758,
   11766, 11774, 11794, 11816, 11827, 11834, 11850, 11855, 11872, 11874,
   11876, 11878, 11880, 11882, 11884, 11886, 11888, 11890, 11892, 11894,
   11896, 11898, 11900, 11902, 11904, 11906, 11908, 11910, 11914, 11920,
   11924, 11928, 11933, 11949, 11950, 11951, 11966, 11996, 11998, 12000,
   12011, 12035, 12046, 12057, 12065, 12075, 12085, 12094, 12098, 12104,
   12111, 12118, 12128, 12135, 12163, 12198, 12209, 12210, 12217, 12223,
   12249, 12259, 12272, 12280, 12293, 12303, 12316, 12326, 12339, 12343,
   12347, 12351, 12355, 12359, 12363, 12365, 12369, 12378, 12383, 12390,
   12405, 12412, 12416, 12420, 12424, 12428, 12435, 12443, 12451, 12455,
   12459, 12463, 12467, 12471, 12477, 12481, 12490, 12494, 12498, 12503,
   12517, 12519, 12523, 12525, 12527, 12530, 12533, 12536, 12537, 12540,
   12548, 12558, 12559, 12562, 12563, 12564, 12569, 12573, 12577, 12581,
   12592, 12593, 12597, 12598, 12606, 12607, 12611, 12612, 12617, 12625,
   12627, 12641, 12644, 12671, 12672, 12675, 12676, 12687, 12705, 12712,
   12721, 12738, 12783, 12791, 12799, 12807, 12815, 12836, 12837, 12838,
   12841, 12842, 12845, 12848, 12849, 12850, 12853, 12854, 12857, 12858,
   12859, 12860, 12861, 12862, 12863, 12864, 12865, 12866, 12867, 12868,
   12871, 12873, 12878, 12880, 12885, 12887, 12889, 12891, 12893, 12895,
   12907, 12911, 12918, 12922, 12928, 12932, 12941, 12952, 12953, 12956,
   12960, 12964, 12970, 12971, 12976, 12980, 12987, 12988, 12989, 12990,
   12991, 12992, 12993, 12994, 13004, 13008, 13015, 13022, 13023, 13039,
   13043, 13048, 13052, 13067, 13072, 13076, 13079, 13082, 13083, 13084,
   13087, 13094, 13104, 13118, 13119, 13123, 13134, 13135, 13138, 13139,
   13142, 13146, 13153, 13157, 13161, 13168, 13178, 13179, 13183, 13184,
   13187, 13188, 13199, 13200, 13209, 13210, 13218, 13228, 13229, 13233,
   13234, 13237, 13253, 13261, 13269, 13291, 13292, 13303, 13307, 13334,
   13336, 13341, 13344, 13347, 13349, 13351, 13353, 13363, 13365, 13376,
   13380, 13384, 13388, 13392, 13401, 13408, 13440, 13444, 13450, 13457,
   13461, 13465, 13471, 13472, 13474, 13475, 13476, 13480, 13510, 13537,
   13541, 13547, 13549, 13566, 13567, 13568, 13573, 13574, 13575, 13580,
   13581, 13582, 13583, 13589, 13590, 13591, 13592, 13593, 13613, 13614,
   13615, 13616, 13617, 13618, 13619, 13620, 13621, 13622, 13623, 13624,
   13625, 13626, 13627, 13628, 13629, 13630, 13631, 13632, 13633, 13634,
   13635, 13636, 13637, 13638, 13639, 13640, 13641, 13642, 13643, 13644,
   13645, 13646, 13647, 13648, 13649, 13650, 13651, 13652, 13653, 13654,
   13655, 13656, 13657, 13658, 13659, 13660, 13661, 13662, 13663, 13664,
   13665, 13666, 13667, 13668, 13669, 13670, 13671, 13672, 13673, 13674,
   13675, 13676, 13677, 13678, 13679, 13680, 13681, 13682, 13683, 13684,
   13685, 13686, 13687, 13688, 13689, 13690, 13691, 13692, 13693, 13694,
   13695, 13696, 13697, 13698, 13699, 13700, 13701, 13702, 13703, 13704,
   13705, 13706, 13707, 13708, 13709, 13710, 13711, 13712, 13713, 13714,
   13715, 13716, 13717, 13718, 13719, 13720, 13721, 13722, 13723, 13724,
   13725, 13726, 13727, 13728, 13729, 13730, 13731, 13732, 13733, 13734,
   13735, 13736, 13737, 13738, 13739, 13740, 13741, 13742, 13743, 13744,
   13745, 13746, 13747, 13748, 13749, 13750, 13751, 13752, 13753, 13754,
   13755, 13756, 13757, 13758, 13759, 13760, 13761, 13762, 13763, 13764,
   13765, 13766, 13767, 13768, 13769, 13770, 13771, 13772, 13773, 13774,
   13775, 13776, 13777, 13778, 13779, 13780, 13781, 13782, 13783, 13784,
   13785, 13786, 13787, 13788, 13789, 13790, 13791, 13792, 13793, 13794,
   13795, 13796, 13797, 13798, 13799, 13800, 13801, 13802, 13803, 13804,
   13805, 13806, 13807, 13808, 13809, 13810, 13811, 13812, 13813, 13814,
   13815, 13816, 13817, 13818, 13819, 13820, 13821, 13822, 13823, 13824,
   13825, 13826, 13827, 13828, 13829, 13830, 13831, 13832, 13833, 13834,
   13835, 13836, 13837, 13838, 13839, 13840, 13841, 13842, 13843, 13844,
   13845, 13846, 13847, 13848, 13849, 13850, 13851, 13852, 13853, 13854,
   13855, 13856, 13857, 13858, 13859, 13860, 13861, 13862, 13863, 13864,
   13865, 13866, 13867, 13868, 13869, 13870, 13871, 13872, 13873, 13874,
   13875, 13876, 13877, 13878, 13879, 13880, 13894, 13895, 13896, 13897,
   13898, 13899, 13900, 13901, 13902, 13903, 13904, 13905, 13906, 13907,
   13908, 13909, 13910, 13911, 13912, 13913, 13914, 13915, 13916, 13917,
   13918, 13919, 13920, 13921, 13922, 13923, 13924, 13925, 13926, 13927,
   13928, 13929, 13930, 13931, 13932, 13933, 13934, 13935, 13936, 13937,
   13938, 13939, 13940, 13941, 13955, 13956, 13957, 13958, 13959, 13960,
   13961, 13962, 13963, 13964, 13965, 13966, 13967, 13968, 13969, 13970,
   13971, 13972, 13973, 13974, 13975, 13976, 13977, 13987, 13988, 13989,
   13990, 13991, 13992, 13993, 13994, 13995, 13996, 13997, 13998, 13999,
   14000, 14001, 14002, 14003, 14004, 14005, 14006, 14007, 14008, 14009,
   14010, 14011, 14012, 14013, 14014, 14015, 14016, 14017, 14018, 14019,
   14020, 14021, 14022, 14023, 14024, 14025, 14026, 14027, 14028, 14029,
   14030, 14031, 14032, 14033, 14034, 14035, 14036, 14037, 14038, 14039,
   14040, 14041, 14042, 14043, 14044, 14045, 14046, 14047, 14048, 14049,
   14050, 14051, 14052, 14053, 14054, 14055, 14056, 14057, 14058, 14059,
   14060, 14061, 14062, 14063
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "EQUALS_GREATER", "LESS_EQUALS", "GREATER_EQUALS", "NOT_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE",
  "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH",
  "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COMMENT", "COMMENTS", "COMMIT", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD",
  "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH",
  "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE",
  "EXISTS", "EXPLAIN", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FILTER", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR",
  "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION",
  "FUNCTIONS", "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P",
  "GROUPING", "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P",
  "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P",
  "IMPORT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX", "INDEXES",
  "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P", "INOUT",
  "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P", "INTEGER",
  "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL", "ISOLATION",
  "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P",
  "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT",
  "LISTEN", "LOAD", "LOCAL", "LOCALTIME", "LOCALTIMESTAMP", "LOCATION",
  "LOCK_P", "LOCKED", "LOGGED", "MAPPING", "MATCH", "MATERIALIZED",
  "MAXVALUE", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P",
  "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NONE", "NOT",
  "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P",
  "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "ON", "ONLY",
  "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY", "OUT_P",
  "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER", "PARSER",
  "PARTIAL", "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS",
  "POLICY", "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE",
  "PREPARED", "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE",
  "PROGRAM", "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK",
  "RECURSIVE", "REF", "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P",
  "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA", "RESET",
  "RESTART", "RESTRICT", "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE",
  "ROLLBACK", "ROLLUP", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA",
  "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE",
  "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET",
  "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SKIP",
  "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE", "STANDALONE_P",
  "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE",
  "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC", "SYSID", "SYSTEM_P",
  "TABLE", "TABLES", "TABLESAMPLE", "TABLESPACE", "TEMP", "TEMPLATE",
  "TEMPORARY", "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P",
  "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED",
  "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATE",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER",
  "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "YEAR_P", "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA", "'<'", "'>'",
  "'='", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept",
  "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt", "opt_with",
  "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "DropPolicyStmt", "RowSecurityOptionalExpr",
  "RowSecurityOptionalWithCheck", "RowSecurityDefaultToRole",
  "RowSecurityOptionalToRole", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateTrigStmt", "TriggerActionTime",
  "TriggerEvents", "TriggerOneEvent", "TriggerForSpec",
  "TriggerForOptEach", "TriggerForType", "TriggerWhen", "TriggerFuncArgs",
  "TriggerFuncArg", "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "DropTrigStmt", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertStmt", "DropAssertStmt", "DefineStmt", "definition",
  "def_list", "def_elem", "def_arg", "old_aggr_definition",
  "old_aggr_list", "old_aggr_elem", "opt_enum_val_list", "enum_val_list",
  "AlterEnumStmt", "opt_if_not_exists", "CreateOpClassStmt",
  "opclass_item_list", "opclass_item", "opt_default", "opt_opfamily",
  "opclass_purpose", "opt_recheck", "CreateOpFamilyStmt",
  "AlterOpFamilyStmt", "opclass_drop_list", "opclass_drop",
  "DropOpClassStmt", "DropOpFamilyStmt", "DropOwnedStmt",
  "ReassignOwnedStmt", "DropStmt", "drop_type", "any_name_list",
  "any_name", "attrs", "type_name_list", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "SecLabelStmt", "opt_provider", "security_label_type", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "createfunc_opt_list",
  "common_func_opt_item", "createfunc_opt_item", "func_as",
  "transform_type_list", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "CreateTransformStmt", "transform_element_list",
  "DropTransformStmt", "ReindexStmt", "reindex_target_type",
  "reindex_target_multitable", "reindex_option_list",
  "reindex_option_elem", "AlterTblSpcStmt", "RenameStmt", "opt_column",
  "opt_set_data", "AlterObjectSchemaStmt", "AlterOwnerStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "DropRuleStmt",
  "NotifyStmt", "notify_payload", "ListenStmt", "UnlistenStmt",
  "TransactionStmt", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty", "ViewStmt",
  "opt_check_option", "LoadStmt", "CreatedbStmt", "createdb_opt_list",
  "createdb_opt_items", "createdb_opt_item", "createdb_opt_name",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "vacuum_option_list", "vacuum_option_elem", "AnalyzeStmt",
  "analyze_keyword", "opt_verbose", "opt_full", "opt_freeze",
  "opt_name_list", "ExplainStmt", "ExplainableStmt", "explain_option_list",
  "explain_option_elem", "explain_option_name", "explain_option_arg",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_target",
  "insert_rest", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "all_or_distinct", "distinct_clause",
  "opt_all_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "Typename", "opt_array_bounds", "SimpleTypename", "ConstTypename",
  "GenericType", "opt_type_modifiers", "Numeric", "opt_float", "Bit",
  "ConstBit", "BitWithLength", "BitWithoutLength", "Character",
  "ConstCharacter", "CharacterWithLength", "CharacterWithoutLength",
  "character", "opt_varying", "opt_charset", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "explicit_row", "implicit_row", "sub_type",
  "all_Op", "MathOp", "qual_Op", "qual_all_Op", "subquery_Op", "expr_list",
  "func_arg_list", "func_arg_expr", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "case_default", "case_arg", "columnref", "indirection_el",
  "indirection", "opt_indirection", "opt_asymmetric", "ctext_expr",
  "ctext_expr_list", "ctext_row", "opt_target_list", "target_list",
  "target_el", "qualified_name_list", "qualified_name", "name_list",
  "name", "database_name", "access_method", "attr_name", "index_name",
  "file_name", "func_name", "AexprConst", "Iconst", "Sconst",
  "SignedIconst", "RoleId", "RoleSpec", "role_list", "ColId",
  "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,    60,    62,    61,
     692,    43,    45,    42,    47,    37,    94,   693,    91,    93,
      40,    41,    46,    59,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   456,   457,   458,   458,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   460,   461,
     461,   461,   462,   462,   463,   463,   464,   464,   464,   464,
     464,   464,   464,   464,   464,   465,   465,   465,   465,   465,
     465,   466,   467,   468,   468,   469,   469,   470,   471,   472,
     472,   473,   473,   474,   475,   476,   476,   477,   477,   478,
     478,   478,   478,   479,   479,   480,   480,   481,   481,   481,
     481,   481,   481,   482,   482,   482,   483,   483,   483,   484,
     484,   484,   484,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   486,   486,   487,   487,   488,   488,
     489,   489,   489,   489,   490,   490,   490,   490,   491,   491,
     491,   491,   491,   491,   491,   492,   492,   492,   493,   493,
     494,   495,   495,   495,   495,   496,   496,   497,   497,   498,
     498,   499,   499,   499,   499,   499,   500,   501,   501,   502,
     502,   503,   504,   504,   504,   504,   504,   505,   505,   505,
     505,   505,   505,   505,   505,   505,   505,   505,   505,   505,
     505,   505,   505,   506,   506,   507,   507,   507,   507,   507,
     507,   507,   507,   507,   507,   507,   507,   507,   507,   507,
     507,   507,   507,   507,   507,   507,   507,   507,   507,   507,
     507,   507,   507,   507,   507,   507,   507,   507,   507,   507,
     507,   507,   507,   507,   507,   507,   507,   507,   507,   507,
     507,   507,   507,   508,   508,   509,   509,   509,   510,   510,
     511,   511,   512,   512,   512,   512,   513,   514,   514,   515,
     515,   516,   516,   516,   516,   517,   518,   518,   519,   519,
     519,   519,   520,   520,   521,   521,   522,   522,   523,   523,
     524,   524,   524,   525,   525,   526,   526,   527,   527,   527,
     527,   527,   527,   527,   527,   527,   527,   527,   527,   527,
     527,   528,   528,   529,   529,   530,   530,   531,   531,   532,
     532,   533,   534,   534,   534,   534,   534,   535,   535,   536,
     537,   537,   537,   537,   538,   538,   538,   538,   538,   538,
     538,   538,   539,   539,   540,   540,   541,   541,   542,   542,
     543,   543,   543,   544,   544,   545,   546,   547,   547,   548,
     548,   548,   548,   549,   549,   549,   549,   549,   549,   549,
     550,   550,   550,   550,   551,   552,   552,   552,   553,   553,
     553,   553,   553,   553,   554,   554,   555,   555,   555,   555,
     555,   555,   555,   556,   556,   557,   557,   558,   558,   559,
     560,   560,   560,   560,   561,   561,   562,   562,   563,   563,
     564,   564,   564,   564,   564,   565,   566,   567,   567,   567,
     567,   567,   568,   568,   569,   569,   569,   569,   570,   570,
     570,   570,   571,   571,   572,   572,   573,   574,   574,   575,
     576,   576,   576,   577,   577,   578,   579,   579,   580,   581,
     581,   582,   582,   583,   583,   584,   584,   585,   585,   585,
     585,   585,   585,   585,   585,   585,   585,   585,   585,   586,
     586,   587,   587,   587,   588,   588,   589,   589,   590,   590,
     591,   591,   592,   592,   593,   593,   594,   594,   595,   595,
     596,   596,   597,   598,   598,   599,   599,   600,   600,   601,
     601,   602,   602,   602,   603,   604,   604,   605,   606,   606,
     606,   606,   606,   606,   606,   606,   606,   606,   606,   606,
     606,   606,   606,   606,   606,   606,   606,   606,   606,   606,
     606,   606,   606,   607,   608,   608,   608,   608,   609,   609,
     610,   610,   611,   611,   612,   612,   613,   613,   614,   614,
     615,   616,   616,   617,   617,   617,   617,   618,   619,   620,
     621,   622,   622,   623,   623,   624,   624,   625,   625,   626,
     626,   626,   627,   627,   628,   628,   629,   630,   630,   631,
     631,   632,   633,   633,   634,   634,   635,   636,   637,   638,
     638,   639,   639,   640,   640,   641,   641,   642,   642,   643,
     643,   644,   644,   644,   644,   644,   645,   645,   646,   646,
     646,   647,   647,   648,   648,   648,   648,   648,   649,   649,
     650,   650,   651,   651,   652,   652,   653,   653,   653,   654,
     654,   654,   654,   655,   655,   656,   656,   657,   657,   657,
     657,   657,   657,   658,   658,   659,   659,   660,   660,   661,
     662,   662,   663,   664,   664,   664,   664,   665,   666,   667,
     667,   667,   667,   667,   667,   667,   667,   667,   667,   667,
     667,   667,   667,   668,   669,   669,   670,   670,   671,   671,
     671,   671,   671,   672,   673,   673,   674,   675,   675,   676,
     676,   677,   677,   677,   678,   678,   679,   680,   680,   681,
     681,   681,   681,   681,   682,   682,   683,   683,   684,   684,
     684,   685,   685,   686,   687,   687,   688,   688,   689,   689,
     690,   690,   691,   691,   692,   693,   694,   694,   694,   694,
     694,   694,   694,   694,   695,   695,   695,   695,   695,   695,
     695,   695,   695,   695,   695,   695,   695,   695,   695,   696,
     696,   697,   697,   698,   698,   699,   699,   700,   701,   701,
     701,   702,   702,   702,   702,   702,   702,   702,   702,   702,
     702,   702,   702,   702,   702,   702,   702,   702,   702,   703,
     703,   703,   703,   703,   703,   703,   703,   703,   703,   703,
     703,   703,   703,   703,   703,   703,   703,   703,   703,   703,
     704,   704,   705,   705,   705,   705,   705,   705,   705,   706,
     706,   707,   707,   707,   707,   707,   707,   707,   707,   707,
     707,   707,   708,   708,   709,   709,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   711,   711,   712,   712,   713,   714,   714,   715,
     715,   715,   715,   715,   716,   716,   717,   717,   717,   717,
     718,   718,   718,   718,   718,   718,   718,   718,   718,   718,
     718,   718,   718,   718,   718,   718,   719,   719,   720,   720,
     721,   721,   722,   722,   723,   724,   725,   725,   726,   726,
     727,   727,   728,   729,   729,   730,   730,   730,   731,   731,
     731,   732,   732,   732,   732,   733,   733,   734,   734,   735,
     735,   736,   736,   737,   737,   738,   738,   739,   739,   739,
     740,   740,   741,   741,   741,   742,   742,   742,   743,   743,
     743,   744,   744,   744,   745,   745,   746,   746,   747,   747,
     748,   748,   749,   749,   750,   750,   750,   750,   750,   751,
     751,   751,   751,   751,   752,   753,   754,   754,   754,   755,
     755,   755,   756,   757,   757,   757,   757,   758,   758,   759,
     759,   760,   760,   760,   760,   760,   760,   760,   760,   760,
     760,   760,   760,   760,   760,   760,   761,   761,   761,   761,
     761,   762,   762,   763,   763,   764,   764,   765,   766,   766,
     767,   768,   768,   769,   769,   770,   770,   771,   771,   772,
     772,   773,   773,   773,   773,   774,   774,   775,   776,   776,
     777,   777,   778,   778,   778,   779,   779,   779,   780,   781,
     781,   782,   783,   783,   783,   783,   784,   785,   785,   785,
     785,   786,   786,   787,   787,   787,   788,   788,   789,   790,
     790,   791,   791,   791,   791,   791,   791,   791,   791,   791,
     791,   791,   791,   791,   791,   791,   791,   791,   791,   791,
     791,   791,   791,   791,   791,   791,   791,   791,   791,   791,
     791,   791,   791,   791,   791,   791,   791,   791,   791,   791,
     791,   791,   791,   791,   791,   791,   791,   791,   791,   792,
     792,   793,   793,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   795,   795,   795,
     795,   795,   795,   795,   795,   795,   795,   795,   795,   795,
     795,   795,   795,   795,   795,   795,   796,   797,   797,   797,
     798,   798,   799,   799,   799,   799,   799,   800,   800,   801,
     801,   801,   801,   802,   802,   802,   803,   803,   804,   805,
     805,   806,   807,   807,   808,   808,   808,   808,   808,   808,
     808,   808,   808,   808,   808,   808,   808,   808,   809,   809,
     809,   810,   810,   810,   810,   810,   811,   811,   811,   812,
     812,   813,   813,   813,   813,   814,   814,   814,   814,   815,
     816,   817,   817,   818,   818,   819,   819,   819,   820,   820,
     820,   820,   820,   820,   820,   821,   821,   822,   822,   822,
     823,   824,   824,   825,   825,   826,   827,   827,   827,   827,
     827,   827,   827,   828,   828,   829,   830,   830,   830,   830,
     830,   830,   831,   831,   832,   833,   833,   833,   834,   834,
     835,   835,   835,   835,   835,   836,   836,   837,   837,   837,
     837,   838,   838,   839,   839,   840,   840,   841,   841,   842,
     842,   843,   843,   844,   844,   844,   844,   845,   845,   845,
     845,   845,   845,   845,   845,   845,   846,   846,   847,   848,
     848,   849,   849,   849,   850,   851,   851,   852,   852,   852,
     852,   853,   853,   854,   854,   855,   855,   855,   855,   856,
     857,   857,   858,   858,   858,   859,   859,   860,   861,   861,
     861,   862,   862,   862,   863,   863,   864,   865,   865,   866,
     867,   867,   868,   868,   868,   868,   868,   868,   868,   868,
     869,   869,   870,   870,   870,   871,   872,   872,   873,   873,
     874,   875,   875,   876,   877,   877,   878,   879,   880,   880,
     880,   880,   880,   881,   881,   881,   882,   882,   883,   883,
     884,   884,   884,   884,   884,   884,   884,   884,   885,   885,
     886,   886,   886,   886,   886,   886,   886,   887,   887,   887,
     888,   888,   889,   890,   890,   891,   891,   892,   892,   892,
     892,   892,   892,   892,   892,   892,   893,   893,   894,   894,
     894,   895,   895,   896,   896,   897,   897,   898,   899,   899,
     900,   900,   901,   901,   901,   901,   902,   902,   903,   903,
     903,   904,   904,   905,   905,   906,   907,   907,   907,   908,
     909,   909,   910,   910,   911,   911,   912,   912,   913,   913,
     913,   913,   913,   914,   915,   916,   917,   918,   918,   919,
     919,   920,   920,   921,   921,   922,   923,   923,   923,   923,
     924,   924,   925,   925,   926,   926,   927,   927,   928,   928,
     928,   928,   928,   928,   928,   928,   929,   929,   929,   929,
     929,   929,   930,   930,   930,   930,   931,   931,   932,   932,
     932,   932,   932,   933,   933,   933,   933,   934,   934,   935,
     935,   936,   936,   936,   936,   937,   937,   938,   938,   938,
     939,   940,   940,   941,   941,   942,   943,   943,   944,   944,
     945,   945,   946,   946,   947,   947,   947,   948,   948,   949,
     949,   950,   951,   951,   951,   951,   951,   951,   952,   952,
     952,   953,   953,   953,   953,   953,   953,   953,   954,   954,
     954,   954,   955,   955,   956,   956,   957,   957,   957,   957,
     957,   957,   957,   957,   957,   957,   957,   958,   958,   959,
     959,   960,   960,   961,   962,   963,   963,   964,   964,   965,
     966,   967,   967,   967,   967,   967,   967,   968,   968,   969,
     969,   970,   970,   970,   970,   971,   972,   972,   972,   973,
     973,   973,   973,   973,   973,   973,   973,   973,   973,   973,
     973,   973,   973,   974,   974,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   976,   976,
     976,   976,   976,   976,   976,   976,   976,   976,   976,   976,
     976,   976,   976,   976,   976,   976,   976,   976,   976,   976,
     976,   976,   976,   977,   977,   977,   977,   977,   977,   977,
     977,   977,   977,   977,   977,   977,   977,   978,   978,   978,
     978,   978,   978,   978,   979,   979,   980,   980,   981,   981,
     981,   981,   981,   981,   981,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   981,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   981,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   981,   981,   981,   981,   981,   981,
     982,   982,   983,   983,   983,   983,   984,   985,   985,   986,
     986,   987,   987,   988,   988,   988,   989,   989,   989,   989,
     990,   990,   991,   991,   992,   992,   993,   993,   994,   995,
     995,   995,   996,   997,   997,   998,   998,   999,   999,   999,
    1000,  1000,  1001,  1001,  1001,  1001,  1001,  1002,  1002,  1002,
    1003,  1003,  1004,  1005,  1005,  1005,  1006,  1006,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1008,  1008,  1009,  1009,  1010,  1010,  1010,  1010,  1010,  1010,
    1011,  1011,  1012,  1012,  1013,  1013,  1013,  1014,  1014,  1015,
    1015,  1015,  1016,  1016,  1017,  1017,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1019,  1019,  1020,  1021,  1021,  1022,
    1022,  1022,  1022,  1022,  1022,  1023,  1024,  1025,  1025,  1025,
    1026,  1026,  1027,  1028,  1028,  1029,  1030,  1030,  1031,  1031,
    1032,  1032,  1033,  1033,  1033,  1033,  1034,  1034,  1035,  1035,
    1036,  1036,  1037,  1037,  1038,  1038,  1039,  1040,  1040,  1041,
    1041,  1042,  1042,  1042,  1042,  1043,  1043,  1044,  1044,  1045,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1052,  1053,
    1053,  1053,  1053,  1053,  1053,  1053,  1053,  1053,  1053,  1053,
    1053,  1053,  1054,  1055,  1056,  1056,  1056,  1057,  1058,  1058,
    1058,  1059,  1059,  1060,  1060,  1060,  1061,  1061,  1061,  1062,
    1062,  1062,  1062,  1063,  1063,  1063,  1063,  1063,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1065,  1065,  1065,  1065,
    1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,
    1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,
    1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,
    1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,
    1065,  1065,  1065,  1065,  1066,  1066,  1066,  1066,  1066,  1066,
    1066,  1066,  1066,  1066,  1066,  1066,  1066,  1066,  1066,  1066,
    1066,  1066,  1066,  1066,  1066,  1066,  1066,  1067,  1067,  1067,
    1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,
    1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,
    1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,
    1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,
    1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,
    1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,
    1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,  1067,
    1067,  1067,  1067,  1067
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     1,
       1,     0,     2,     0,     2,     0,     2,     2,     3,     3,
       1,     3,     3,     2,     1,     1,     2,     2,     2,     3,
       3,     5,     5,     0,     3,     5,     5,     5,     4,     3,
       5,     3,     5,     5,     6,     1,     1,     3,     5,     6,
       4,     9,     7,     1,     0,     2,     0,     1,     1,     1,
       1,     1,     1,     2,     3,     3,     2,     5,     1,     3,
       3,     3,     3,     1,     3,     3,     2,     2,     2,     2,
       3,     3,     3,     3,     1,     3,     1,     3,     1,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     5,     1,     1,     1,     1,     1,     0,     1,     1,
       2,     1,     2,     3,     2,     1,     1,     2,     1,     2,
       1,     2,     3,     4,     3,     2,     4,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     4,     6,    10,
      13,     4,     6,    10,    13,     4,     6,     4,     6,     5,
       7,    11,    14,     1,     3,     2,     3,     4,     6,     6,
       6,     5,     5,     6,     6,     4,     8,     4,     2,     4,
       3,     6,     4,     3,     3,     3,     3,     2,     2,     3,
       4,     4,     3,     3,     3,     3,     3,     3,     4,     4,
       3,     2,     3,     2,     2,     3,     3,     2,     2,     3,
       4,     4,     1,     3,     2,     1,     1,     0,     2,     0,
       2,     0,     1,     1,     1,     3,     3,     2,     0,     1,
       3,     3,     1,     5,     3,     4,     1,     3,     4,     6,
       4,     8,     2,     2,    11,     7,     1,     1,     1,     0,
       1,     1,     1,     1,     3,     2,     0,     1,     1,     1,
       3,     3,     1,     1,     3,     3,     3,     3,     4,     3,
       2,     1,     0,     2,     0,     3,     0,     1,     0,     1,
       3,     2,     1,     1,     1,     3,     0,     1,     3,     1,
      11,    14,    10,    13,     1,     1,     2,     2,     2,     2,
       1,     0,     1,     0,     3,     0,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     4,     4,     2,     0,     3,
       1,     1,     2,     2,     1,     3,     4,     5,     2,     5,
       1,     2,     2,     2,     3,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     3,     1,     5,     7,     3,     8,
       4,     9,    11,     2,     0,     3,     0,     1,     3,     1,
       2,     2,     2,     0,     1,     3,     3,     6,     4,     0,
       1,     1,     2,     2,     0,     3,     3,     2,     1,     1,
       2,     2,     4,     0,     2,     2,     2,     0,     3,     4,
       4,     0,     2,     0,     4,     0,     3,     7,    10,     5,
       2,     3,     0,     8,    11,     4,     1,     0,     6,     5,
       8,     4,     6,     1,     0,     1,     2,     2,     1,     2,
       3,     2,     2,     2,     2,     3,     3,     1,     3,     1,
       0,     1,     2,     1,     1,     3,     6,    10,     1,     0,
       1,     2,     2,     0,     2,     2,     1,     0,     5,     7,
       1,     0,     7,     2,     0,     3,     5,     5,     8,     2,
       0,     2,     2,     2,     5,     2,     0,     2,     7,    10,
       6,     6,     6,     6,     7,     7,     9,     9,     6,     7,
       6,     8,     8,     8,     8,     6,     6,     7,     7,     8,
       6,     9,     6,     7,     2,     2,     2,     2,     1,     2,
       1,     0,     6,     8,     7,     6,     4,     0,     1,     3,
       4,     1,     3,     1,     2,     2,     2,     2,     1,     1,
      10,     2,     0,     2,     2,     1,     0,     4,     6,     5,
       4,     4,    11,    14,     5,     7,    11,     2,     1,     4,
       0,     8,     1,     1,     7,     9,     8,     9,     8,     6,
       8,     4,     0,     5,     0,     2,     0,     2,     0,     2,
       0,     1,     1,     1,     1,     1,    15,    20,     1,     1,
       2,     1,     3,     1,     1,     1,     3,     1,     3,     0,
       1,     0,     1,     1,     4,     0,     1,     3,     0,     1,
       1,     1,     1,     2,     0,     0,     2,     2,     1,     2,
       2,     2,     2,     6,     8,    11,    13,     1,     3,     5,
       1,     3,     5,     1,     2,     2,     1,     8,     4,     5,
       4,     4,     4,     3,     7,     8,     6,     6,     6,     6,
       6,     4,     5,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     3,     1,     0,     1,
       3,     7,     9,     9,     3,     0,    13,     1,     3,     5,
       6,     4,     7,     2,     1,     0,     2,     0,     2,     4,
       0,     1,     0,     6,     8,     8,     1,     3,     5,     5,
       7,     9,     7,     9,     5,     6,     6,     4,     4,     6,
       4,     6,     5,     7,     1,     1,     1,     2,     1,     2,
       2,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       3,     1,     2,     2,     3,     1,     3,     5,     2,     2,
       0,     6,     6,     6,     7,     7,     7,     8,     9,     8,
       8,     6,     9,     8,     9,     9,     7,    10,     7,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     2,     1,     3,     2,     3,     3,     3,     3,
       1,     1,     8,     8,     8,     9,     9,     9,     9,     2,
       0,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     2,     2,     1,     2,     3,     3,
       3,     3,     4,     4,     3,     3,     3,     4,     4,     3,
       4,     4,     1,     1,     1,     0,     7,     7,    10,     1,
       1,     2,     4,     5,     1,     3,     2,     2,     2,     2,
       1,     2,     2,     4,     3,     2,     2,     2,     2,     3,
       2,     2,     2,     5,     5,     5,     1,     3,     1,     2,
       3,     0,     1,     3,     2,     6,     6,     9,     3,     0,
       3,     0,     5,     2,     0,     3,     3,     3,     7,     7,
      10,     1,     1,     1,     1,    14,    17,     1,     0,     1,
       0,     1,     0,     2,     0,     1,     3,     5,     5,     7,
       2,     0,     1,     2,     0,     1,     1,     0,     2,     2,
       0,     9,    12,     7,     2,     0,     3,     2,     1,     3,
       3,     2,     1,     3,     3,     3,     2,     2,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     4,     5,     1,
       3,     3,     1,     3,     3,     5,     6,     1,     3,     1,
       2,     4,     5,     1,     1,     1,     1,     3,     3,     2,
       2,     1,     2,     2,     2,     1,     2,     2,     2,     1,
       1,     1,     3,     3,     5,     2,     0,     2,     1,     3,
       5,     1,     2,     1,     0,     5,     7,     5,     7,     5,
       7,     3,     5,     5,     5,     1,     3,     2,     1,     2,
       1,     2,    11,    10,    10,     2,     2,     0,     9,     2,
       0,    10,    11,    11,     5,     5,     8,     3,     3,     6,
       6,     1,     1,     1,     1,     1,     1,     3,     1,     5,
       5,     7,     6,     6,     6,     6,     8,     8,     6,     6,
       7,     9,     9,     8,    10,     6,     6,     6,     8,     6,
       8,     6,     8,     7,     9,     6,     8,     7,     9,     8,
      10,     9,    11,     8,    10,     9,    11,     8,     8,     7,
       6,     6,     6,     8,     8,     8,     8,     6,     9,     1,
       0,     2,     0,     7,     6,     6,     6,     6,     6,     7,
       9,     9,     6,     8,     8,     8,     8,     8,     6,     8,
       6,     8,     7,     9,     7,     9,     6,     7,     6,     6,
       6,     6,     6,     7,     7,     7,     9,     9,     6,     6,
       6,     8,     8,     8,     6,     7,    13,     1,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     0,     6,     8,     3,     2,
       0,     2,     2,     2,     2,     3,     3,     2,     2,     2,
       2,     3,     2,     5,     4,     3,     3,     3,     1,     1,
       0,     3,     2,     2,     1,     2,     1,     3,     2,     1,
       0,     9,    11,    12,    14,     3,     4,     4,     0,     2,
       5,     1,     0,     1,     2,     3,     3,     3,     1,     2,
       1,     1,     1,     1,     1,     1,     0,     5,     4,     6,
       4,     3,     5,     4,     4,     6,     4,     6,     6,     5,
       7,     9,     6,     1,     0,     6,    11,    11,    11,    13,
       9,    11,     1,     1,    10,     4,     2,     5,     2,     0,
       4,     5,     5,     4,     6,     1,     3,     1,     1,     1,
       1,     2,     4,     1,     1,     1,     0,     1,     0,     1,
       0,     3,     0,     2,     4,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     2,     1,
       1,     1,     1,     0,     5,     3,     0,     1,     1,     1,
       1,     3,     9,     3,     0,     2,     3,     2,     3,     7,
       1,     3,     1,     4,     2,     1,     3,     2,     8,     5,
       0,     4,     3,     0,     2,     0,     7,     2,     0,     5,
       3,     0,     2,     2,     2,     3,     1,     3,     1,     2,
       1,     0,     1,     2,     0,     8,     1,     3,     1,     1,
       3,     5,     5,     2,     1,     3,     7,     1,     0,     3,
       2,     2,     2,     0,     2,     2,     1,     1,     3,     3,
       1,     2,     4,     4,     2,     3,     5,     5,     1,     1,
       9,     9,     1,     2,     4,     4,     4,     2,     2,     3,
       1,     3,     6,     1,     0,     2,     0,     3,     3,     4,
       4,     4,     4,     3,     2,     1,     1,     0,     1,     1,
       0,     1,     5,     1,     0,     1,     0,     3,     1,     3,
       4,     3,     2,     2,     1,     1,     1,     0,     2,     4,
       5,     2,     3,     1,     1,     1,     1,     3,     0,     1,
       1,     1,     1,     1,     3,     0,     1,     3,     1,     1,
       1,     1,     1,     2,     4,     4,     5,     2,     0,     1,
       3,     1,     0,     1,     2,     3,     2,     4,     2,     3,
       2,     0,     2,     3,     2,     0,     1,     3,     2,     3,
       2,     3,     2,     3,     1,     4,     3,     4,     5,     4,
       5,     4,     5,     2,     4,     1,     1,     0,     1,     4,
       5,     4,     0,     2,     2,     2,     1,     1,     0,     4,
       2,     1,     2,     2,     4,     1,     3,     1,     2,     3,
       6,     4,     0,     2,     6,     2,     1,     3,     4,     0,
       2,     0,     2,     0,     2,     4,     0,     1,     0,     1,
       3,     3,     2,     3,     5,     6,     2,     3,     3,     4,
       0,     1,     1,     1,     1,     1,     2,     4,     1,     1,
       1,     1,     2,     3,     3,     0,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     1,     3,     0,     1,
       1,     1,     1,     5,     2,     1,     1,     1,     1,     5,
       2,     2,     2,     1,     3,     3,     2,     1,     0,     3,
       0,     5,     2,     5,     2,     1,     3,     3,     0,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     0,     1,     4,     1,     3,     3,     5,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     3,     3,     2,     2,
       3,     5,     4,     6,     3,     5,     4,     6,     4,     6,
       5,     7,     3,     2,     4,     2,     3,     3,     4,     3,
       4,     3,     4,     5,     6,     6,     7,     6,     7,     6,
       7,     3,     4,     4,     6,     2,     3,     4,     1,     3,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     5,     6,     6,
       7,     3,     4,     1,     1,     2,     4,     1,     1,     1,
       2,     2,     2,     2,     1,     1,     4,     3,     5,     6,
       8,     6,     6,     4,     4,     1,     1,     1,     5,     1,
       1,     4,     1,     4,     1,     4,     1,     4,     1,     1,
       1,     1,     1,     1,     6,     4,     4,     4,     4,     6,
       5,     5,     5,     4,     6,     4,     4,     4,     4,     5,
       7,     7,     9,     5,     4,     6,     5,     7,     7,     7,
       2,     3,     3,     3,     4,     0,     4,     1,     3,     3,
       1,     1,     1,     2,     2,     0,     2,     4,     4,     6,
       5,     0,     5,     0,     2,     0,     1,     3,     3,     2,
       2,     0,     6,     1,     0,     3,     0,     2,     2,     0,
       1,     4,     2,     2,     2,     2,     2,     4,     3,     5,
       4,     3,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     1,     4,     1,     4,     1,     2,     1,     2,
       1,     3,     1,     3,     1,     3,     3,     1,     3,     3,
       3,     2,     1,     3,     3,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     2,     3,     0,     3,
       3,     2,     2,     1,     0,     2,     2,     3,     2,     1,
       1,     3,     5,     1,     2,     4,     2,     0,     1,     0,
       1,     2,     2,     2,     3,     5,     1,     2,     0,     2,
       1,     0,     1,     1,     1,     3,     3,     1,     0,     1,
       3,     3,     2,     1,     1,     1,     3,     1,     2,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     6,     2,     3,     5,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1474,  1260,   561,  1344,  1343,  1260,   251,     0,  1346,     0,
    1260,   382,  1005,     0,     0,     0,     0,   561,  1260,     0,
    1474,     0,     0,     0,     0,     0,  1487,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1260,     0,     0,  1494,
       0,     0,     0,     0,  1487,     0,  1348,     0,     0,     0,
       0,     0,     2,     4,    64,    65,    27,    26,    32,    31,
      89,    90,    50,    17,    78,    57,   124,   123,   125,    38,
      34,    72,    23,    25,    35,    39,    59,    40,    51,   102,
      58,    21,    56,    83,    60,    86,    45,    11,    12,    46,
      76,    13,    47,    77,    14,    48,    15,    98,    66,    91,
      30,    55,    20,    82,    62,    88,    63,     5,    41,    74,
      70,    10,    52,    53,    54,    79,    80,    81,   107,    85,
     119,    37,   116,    95,    96,   113,    97,   114,     8,    99,
      49,    16,   110,   109,   111,    73,    42,    75,    61,    87,
     108,    24,   112,    18,    19,   115,    84,   105,   101,   120,
     118,   126,   103,    67,     6,     7,    92,    22,    44,     9,
      29,    28,    43,    36,   122,    33,  1346,    94,   106,    93,
      68,   100,    71,   104,   121,    69,   117,  1447,  1446,  1496,
    1450,  1473,     0,  1462,  1259,  1258,  1244,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   560,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1270,  2053,
    2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,   353,  2076,
    2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2336,
    2337,  2338,  2339,  2086,  2087,  2088,  2089,  2090,  2091,  2092,
    2340,  2341,  2093,  2094,  2095,  2096,  2097,  2342,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2343,  2344,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2345,  2145,  2146,
    2147,  2346,  2148,  2149,  2150,  2347,  2151,  2152,  2153,  2154,
    2155,  2156,  2157,  2348,  2349,  2158,  2159,  2160,  2161,  2162,
    2163,  2164,  2165,  2166,  2167,  2168,  2169,  2170,  2171,  2172,
    2173,  2174,  2350,  2175,  2176,  2177,  2178,  2351,  2352,  2353,
    2179,  2180,  2181,  2182,  2183,  2184,  2185,  2186,  2354,  2187,
    2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,
    2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2355,  2356,
    2206,  2207,  2357,  2208,  2209,  2210,  2358,  2211,  2359,  2212,
    2213,  2214,  2215,  2216,  2217,  2218,  2219,  2360,  2220,  2361,
    2221,  2222,  2223,  2224,  2225,  2226,  2227,  2228,  2229,  2362,
    2230,  2363,  2233,  2231,  2232,  2234,  2235,  2236,  2237,  2238,
    2239,  2240,  2241,  2364,  2242,  2243,  2244,  2245,  2246,  2247,
    2248,  2249,  2250,  2251,  2252,  2253,  2254,  2255,  2256,  2257,
    2258,  2259,  2260,  2261,  2365,  2262,  2263,  2264,  2265,  2266,
    2267,  2268,  2269,  2270,  2271,  2272,  2273,  2274,  2275,  2276,
    2366,  2277,  2278,  2279,  2280,  2367,  2281,  2282,  2283,  2284,
    2285,  2286,  2287,  2288,  2289,  2290,  2291,  2292,  2368,  2293,
    2294,  2295,  2296,  2297,  2298,  2299,  2300,  2369,  2370,  2301,
    2302,  2371,  2303,  2372,  2304,  2305,  2306,  2307,  2308,  2309,
    2310,  2311,  2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,
    2320,  2373,  2374,  2321,  2322,  2323,  2324,  2325,  2326,  2327,
    2328,  2329,  2330,  2331,  2332,  2375,  2376,  2377,  2378,  2379,
    2380,  2381,  2382,  2383,  2333,  2334,  2335,   352,  1437,  2021,
    2054,  2055,  1345,  1326,   561,     0,  1247,   381,     0,     0,
       0,     0,     0,     0,     0,     0,   774,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,     0,
       0,   405,   404,     0,     0,     0,   977,   410,     0,     0,
       0,     0,     0,   549,  1387,  2231,  1385,  1438,   252,   255,
     256,   253,   254,  2043,     0,  1087,  1088,  1090,     0,     0,
    1100,   811,   812,     0,     0,     0,   814,     0,     0,     0,
     808,     0,     0,     0,     0,     0,     0,   813,   805,     0,
     804,     0,     0,  1100,     0,     0,     0,   806,     0,     0,
    1248,  1384,   411,  1474,     0,  1362,  1363,  1364,  1346,  1353,
    1365,  1358,  1360,  1359,  1361,  1357,  2042,  2069,   915,   915,
     915,   915,   912,   913,   915,   915,   915,  2248,     0,     0,
     894,     0,   896,  2044,   915,   920,   466,   466,   466,     0,
     919,   924,   466,     0,  1241,  1279,  2026,  1486,     0,   895,
    1240,  2301,  1376,     0,     0,  1115,  1111,  1113,  1114,  1112,
       0,     0,     0,  2264,  1252,   236,  2274,  2369,  2301,   235,
     230,   231,   204,  2073,     0,     0,   919,     0,  1249,  1250,
     880,  1493,  1491,     0,  2008,  2091,  2105,  2190,   227,  2259,
    2265,  2274,  2369,  2301,  2332,   183,   193,   188,     0,   245,
    2274,  2369,  2301,   241,  1270,     0,  1463,  1591,  2017,     0,
    1243,  1242,  1347,     0,  1350,     0,  1552,  2244,  1467,  1470,
    1352,  1468,  1459,     0,     0,     1,  1474,  1341,  1490,  1490,
       0,  1490,     0,  1451,  1459,  1454,  1458,     0,     0,     0,
       0,  2053,  2384,  2385,  2386,  2387,  2388,  2389,  2390,  2391,
    2392,  2393,  2394,  2395,  2396,  2397,  2398,  2399,  2400,  2401,
    2402,  2403,  2404,  2405,  2406,     0,     0,  2027,  2054,  2058,
       0,   821,     0,  1282,  2022,   964,     0,     0,     0,     0,
    2021,     0,     0,     0,     0,  2059,  2049,  2050,     0,  2047,
    2048,  2060,  2061,  2062,     0,  2163,     0,     0,     0,  1916,
    1927,  1928,  1929,  2095,  2148,  1924,  1925,  1926,  1918,  1919,
    1920,  1921,  1922,  1923,     0,  1085,  1917,     0,  2163,     0,
     153,     0,   131,     0,     0,  2163,     0,     0,     0,     0,
       0,  2163,     0,     0,     0,     0,     0,  2195,     0,   131,
    2163,     0,     0,  1264,     0,     0,     0,  1266,  1269,  1245,
    1329,     0,  2017,     0,     0,   857,   849,     0,   858,   850,
       0,     0,   860,     0,     0,   852,     0,     0,     0,     0,
     861,     0,   851,   853,   863,   854,   859,     0,     0,     0,
       0,   855,     0,     0,  1256,   466,   359,     0,     0,     0,
       0,     0,   131,  1314,     0,  2163,   131,     0,     0,   409,
     408,   131,  2047,   407,   406,  2095,  2148,     0,  1004,     0,
     131,  2163,     0,   176,   632,   564,     0,     0,   733,  2195,
     131,     0,     0,     0,     0,     0,     0,   980,     0,     0,
       0,   548,   561,  1388,  1386,     0,  1091,   229,   228,  1089,
    2163,     0,   327,     0,     0,  2163,  1301,  2056,  1649,  1678,
    1656,  1678,  1678,  1645,  1645,  2132,  1658,  2163,  1646,  1647,
    1685,     0,  1678,  1645,  1650,     0,  1648,  1688,  1688,  1673,
     327,   825,  1630,  1631,  1632,  1633,  1659,  1660,  1634,  1665,
    1666,  1680,  1635,  1702,  1645,  2057,   810,     0,   809,  2163,
       0,  2163,  2051,   167,     0,   807,  2095,  2148,  2163,     0,
       0,  2163,     0,  2163,   159,  2163,     0,  2163,   327,  2163,
     565,     0,     0,  2163,     0,  2163,   327,  2163,  2195,   161,
       0,  2163,   327,   819,     0,  1381,     0,  1355,  2373,  1370,
       0,  1366,  1373,  1369,  1474,   915,   914,     0,   915,     0,
     915,     0,   915,     0,   915,     0,     0,     0,   915,  2045,
    2046,   897,     0,   921,     0,     0,   928,   927,   926,     0,
       0,     0,   929,     0,  1595,  1411,     0,  1238,  1255,     0,
       0,     0,   980,  1118,     0,  1116,  1107,  1108,  1251,   234,
     232,     0,     0,     0,     0,     0,     0,  1257,     0,     0,
       0,     0,  2030,  2032,  2033,  1930,  1998,     0,  2337,  2338,
    2339,  1989,     0,  2340,  2341,  2342,  2386,  1832,  1819,  1828,
    1833,  1820,  1822,  1829,  2343,  2344,  2345,  2346,  2040,  2347,
    2348,  2349,  2351,  2352,  2353,  2354,  1824,  1826,  2355,  2356,
       0,  2041,  2358,  2359,  2216,  2361,  2362,  2364,  2365,  1830,
    2367,  2368,  2369,  2370,  2371,  2372,  2039,     0,  1831,  2374,
    2376,  2377,  2378,  2379,  2380,  2381,  2382,  2383,     0,     0,
       0,  2014,     0,  1799,     0,  1638,  1639,  1661,  1662,  1640,
    1667,  1668,  1641,     0,  2013,  1705,  1881,  1798,  1815,     0,
    1804,  1805,     0,  1797,  1793,  1476,  2009,     0,  1794,  2029,
    2031,  1990,  1476,  2007,   196,   247,     0,   248,  2015,  2274,
     184,   226,   198,   225,   199,   197,     0,  2093,   185,     0,
       0,   186,     0,     0,     0,     0,   244,   242,     0,  1246,
       0,  1593,  1592,     0,     0,  1996,  2018,   830,  1339,  1340,
    1338,     0,  1335,  1337,  1349,  1346,  2003,  2002,  2004,     0,
    1469,     0,     0,     0,  1449,  1448,     3,  1352,  1488,  1489,
       0,     0,     0,     0,     0,     0,     0,     0,  1542,  1504,
    1505,  1507,  1539,  1543,  1551,     0,  1455,     0,     0,  1597,
       0,  1553,     0,     0,  2028,     0,     0,     0,     0,   822,
       0,     0,     0,  1288,     0,  1290,  1291,  1292,     0,     0,
    1293,  1294,  1282,   238,  1300,  1298,  1281,  1283,  1296,     0,
       0,     0,     0,     0,     0,     0,  1306,     0,     0,   165,
     166,   576,   561,     0,  2163,     0,     0,     0,     0,  1044,
    1051,     0,     0,     0,     0,     0,     0,     0,  1045,  1043,
    1046,   240,  1055,  1071,  1074,     0,   954,     0,     0,     0,
       0,     0,  1170,     0,     0,  1170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   261,   273,
     322,   541,     0,     0,   543,     0,  2163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   129,   130,
     135,     0,     0,     0,     0,     0,     0,   528,   540,     0,
       0,     0,     0,     0,   537,     0,   131,   265,   521,   525,
       0,     0,     0,   641,   640,  1304,  1303,     0,     0,     0,
    1170,     0,   257,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   345,   346,
       0,     0,     0,   135,   158,     0,     0,     0,   267,     0,
       0,  1265,  1262,  1263,     0,  1268,     0,  1325,     0,     0,
       0,     0,     0,   865,     0,   862,     0,     0,   856,  2095,
    2148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     384,   358,     0,     0,   730,     0,     0,     0,     0,     0,
     741,     0,  1282,  1313,     0,     0,     0,   570,     0,  2163,
       0,   133,   775,     0,   731,   410,     0,     0,   133,     0,
       0,   170,     0,   636,     0,     0,     0,     0,     0,     0,
     679,   678,     0,     0,     0,   732,     0,   133,     0,  2163,
     524,  2163,     0,   466,   466,     0,     0,   979,   982,     0,
       0,     0,     0,  1441,  1443,  1442,     0,  1440,     0,   327,
     325,   326,   728,  1099,     0,     0,  1677,  1664,  1672,  1671,
       0,  1654,  1653,  1652,     0,  1651,     0,  1678,  1678,  1676,
    1655,  1630,     0,     0,     0,  1684,     0,  1682,     0,   800,
    1626,  1622,     0,     0,  1670,  1691,  1692,  1693,  1690,  1703,
    1689,     0,  1636,  1694,  1645,  1642,     0,     0,   327,     0,
       0,  2163,   327,  2163,     0,  2163,     0,     0,   327,   327,
       0,     0,     0,     0,     0,     0,   637,     0,   818,   816,
     815,   817,     0,     0,     0,     0,   798,     0,     0,     0,
    2163,   327,     0,     0,   797,  1940,     0,     0,  1474,     0,
     215,   216,   214,  1371,   217,  1372,  1368,  1354,     0,   905,
       0,   909,     0,   900,     0,   906,     0,   901,   898,   899,
       0,   904,     0,     0,   467,   469,     0,     0,  2117,  2131,
       0,  2154,  2183,  2184,  2265,  2270,     0,  2296,  2306,     0,
     930,   959,   925,   650,     0,     0,  1421,  1239,  1947,     0,
    1474,     0,     0,     0,     0,   233,   205,     0,     0,     0,
     961,  2264,  1254,   879,   561,     0,  1795,     0,  1802,  1803,
    1988,     0,     0,     0,     0,     0,     0,  1801,  1955,     0,
       0,     0,     0,     0,  1728,     0,     0,     0,  1968,     0,
    1974,     0,     0,  1765,     0,     0,     0,     0,     0,     0,
       0,     0,  1729,  1709,  1710,  1799,  1940,     0,  1800,  2036,
       0,  1702,  2012,  1930,     0,  1927,  1928,  1929,     0,     0,
       0,  2001,     0,  1938,     0,     0,  1743,  1936,  1745,     0,
       0,     0,     0,  1924,  1925,  1926,  1918,  1919,  1920,  1921,
    1922,  1923,  1934,  1725,     0,     0,  1883,     0,  1724,     0,
       0,  1555,     0,  2034,  1991,  1555,   249,   250,   246,     0,
       0,   201,   200,     0,   219,   223,   224,   195,   222,     0,
     218,   203,  1872,  1871,   202,   194,   191,   189,   206,   208,
     209,   192,   190,   243,     0,     0,  2063,  2407,  2408,  2409,
    2410,  2411,  2412,  2413,  2414,  2415,  2416,  2417,  2418,  2419,
    2420,  2421,  2422,  2423,  2424,  2425,  2426,  2427,  2428,  2429,
    2430,  2431,  2432,  2433,  2434,  2435,  2436,  2437,  2438,  2439,
    2440,  2441,  2442,  2443,  2444,  2445,  2446,  2447,  2448,  2449,
    2450,  2451,  2452,  2453,  2454,  2455,  2456,  2457,  2458,  2459,
    2460,  2461,  2462,  2463,  2464,  2465,  2466,  2467,  2468,  2469,
    2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,
    2480,  2481,  2482,  2483,  1993,  1992,  2024,  2064,  2065,  2066,
    2067,  1997,     0,     0,   327,  1333,     0,  1330,  2006,     0,
    1471,     0,  2019,     0,  1342,  1466,  1465,  1497,  1498,   997,
    1464,  1522,  1523,  1518,     0,     0,     0,  1548,  1546,  1514,
    1508,  1513,  1511,     0,  1515,  1705,  1541,  1453,  1502,  1503,
    1506,  1452,     0,  1544,     0,  1424,  1542,  1507,  1408,     0,
    1390,     0,  1598,     0,  1019,  1021,     0,  1020,     0,  1023,
       0,  1032,     0,     0,  1018,  1037,     0,  1026,  1024,     0,
       0,     0,     0,     0,     0,   823,     0,     0,     0,     0,
    1289,     0,     0,  2296,   237,  1292,  1297,  1284,  1295,     0,
       0,     0,     0,     0,   963,   962,     0,     0,   984,     0,
       0,     0,  1309,   455,     0,   324,     0,     0,     0,     0,
       0,     0,     0,     0,   726,   723,     0,     0,   722,     0,
     574,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     611,     0,  1170,     0,   644,     0,  1053,     0,  1052,     0,
       0,     0,  1054,  1049,  1050,  2265,  2274,  2301,   239,  1073,
       0,  1072,  1070,  1007,     0,  1008,     0,     0,     0,     0,
       0,  2141,   275,   288,     0,  1169,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   311,
       0,   314,   313,     0,     0,     0,     0,     0,   318,   297,
       0,   298,     0,     0,   317,     0,     0,   542,     0,     0,
       0,  1170,     0,   269,     0,     0,     0,     0,     0,     0,
    1086,     0,   668,     0,   156,     0,   152,   155,     0,     0,
       0,     0,   527,   539,     0,   531,   532,   529,   533,   534,
       0,     0,     0,     0,     0,     0,   526,     0,     0,   634,
     633,   639,     0,     0,     0,     0,     0,     0,     0,     0,
    1120,  1119,     0,     0,     0,     0,     0,     0,   765,     0,
       0,     0,     0,     0,     0,     0,   653,     0,   652,     0,
     157,     0,     0,     0,     0,     0,     0,     0,   213,  1261,
    1267,  1328,  2025,  1327,     0,     0,     0,     0,   864,     0,
       0,     0,     0,     0,     0,     0,     0,   866,   867,   868,
     869,     0,     0,     0,     0,     0,     0,     0,   361,   362,
     131,   360,  2056,     0,   754,   729,     0,     0,   742,     0,
     744,   747,     0,  1280,   428,     0,     0,   567,   611,     0,
     413,   163,     0,     0,     0,     0,   670,   128,   174,   176,
     411,     0,   175,   177,   179,   180,   181,   178,   182,   631,
     635,     0,   563,     0,     0,     0,     0,     0,   680,   684,
     683,   687,   685,     0,   681,     0,     0,  1618,     0,   151,
       0,     0,   519,   523,     0,     0,     0,   413,   497,   338,
    2163,     0,   466,     0,  2163,     0,   981,     0,     0,     0,
       0,     0,     0,     0,     0,  1439,     0,  1077,     0,  1302,
       0,     0,     0,   327,  1675,  1674,  1627,  1623,     0,     0,
       0,     0,   826,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1643,  2163,   327,     0,  1075,   168,  2052,
       0,   802,     0,     0,     0,     0,     0,  1079,   794,     0,
     327,   160,     0,   327,   327,   566,     0,     0,   327,   327,
     162,     0,     0,     0,   558,   327,   820,  1383,     0,  2163,
     466,  1356,  1367,   902,   911,   910,   908,   907,   903,     0,
     922,     0,   465,     0,     0,     0,   936,   937,     0,     0,
     935,   952,   938,     0,   940,   932,   931,   941,   942,     0,
       0,   961,   648,     0,     0,     0,     0,  1418,     0,  1416,
       0,  1596,  1420,  1409,  1375,     0,  1374,  1378,  1380,  1379,
    1377,     0,   512,     0,     0,  1117,     0,     0,   919,     0,
       0,   327,  1253,     0,   881,   882,     0,     0,     0,     0,
       0,     0,   888,   885,   886,   887,   889,     0,   890,     0,
       0,     0,  1999,  1951,     0,  1952,     0,     0,  1987,  1983,
       0,     0,     0,     0,     0,  1956,  1959,  1960,  1961,  1958,
    1962,  1957,     0,     0,  1963,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2365,     0,     0,     0,     0,  1768,
       0,     0,  1911,     0,  1940,  1973,     0,     0,     0,     0,
       0,     0,  1940,  1979,     0,     0,     0,     0,  1870,     0,
    1867,     0,     0,     0,     0,  1998,     0,     0,  2037,  1706,
    1720,  1721,  1722,  1726,  2011,     0,  2000,     0,     0,  1707,
    1734,     0,  1980,  1761,     0,  1766,  1749,     0,  1742,     0,
    1747,  1751,  1730,     0,  1727,     0,  2001,  1939,     0,  1937,
       0,  1717,  1718,  1719,  1711,  1712,  1713,  1714,  1715,  1716,
    1723,  1915,  1913,  1914,     0,     0,     0,  1891,     0,     0,
    1746,  2156,  2190,     0,  1487,  1487,  1487,  1475,  1485,  2010,
       0,  1613,     0,     0,     0,     0,  1807,     0,  1944,  1496,
    1942,  1024,  1613,  2016,     0,     0,  1702,     0,  1594,  1994,
       0,   828,   829,   827,  1352,  1336,  1332,  1331,  2005,  1351,
       0,  1474,     0,   995,   996,     0,  1000,     0,     0,  1516,
    1549,     0,  1540,     0,  1520,  1521,  1512,  1550,  1422,     0,
    1545,  1457,  1456,     0,  1616,     0,     0,  1400,  1392,     0,
    1599,     0,  1555,  1426,  1428,  1429,     0,  1998,  1022,     0,
    1645,  1033,     0,  1017,     0,  1016,  1645,     0,  1034,     0,
    1645,     0,     0,     0,  1198,  1122,  1174,   824,  1199,  1123,
    1175,  1200,  1124,  1299,  1287,  1286,  1285,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   705,  2163,   327,  1307,  1201,     0,  1125,   323,  1308,
    1176,  1312,   725,   724,     0,     0,  1177,     0,   575,     0,
       0,   580,   581,   582,     0,     0,     0,   583,     0,  2095,
    2148,     0,   588,   595,   600,   590,     0,     0,   602,   596,
       0,     0,     0,     0,     0,     0,   608,   615,     0,     0,
       0,     0,     0,     0,  1047,  1048,  1202,  1128,     0,  1178,
    1006,     0,  1129,   164,     0,     0,   262,   276,   617,   705,
    1172,   295,     0,   310,   305,   306,   304,  2163,   327,  2163,
     327,     0,     0,     0,     0,     0,   307,   302,   303,   299,
     312,  2072,  2133,  2275,     0,   621,   623,     0,   628,   315,
    1145,   334,   333,   332,     0,   319,     0,   339,   342,   316,
     293,   296,   294,   290,   274,     0,     0,     0,     0,     0,
       0,     0,  2023,     0,     0,  1081,     0,     0,     0,     0,
       0,     0,   662,   154,  1160,   144,     0,     0,   140,     0,
       0,     0,     0,   134,     0,  1208,  1135,     0,     0,   266,
     522,   530,   535,  1139,   538,  1188,   536,  1214,  1136,     0,
    1170,     0,   258,     0,  1137,     0,  1182,  1210,  1162,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1315,     0,
       0,     0,     0,     0,   327,     0,     0,     0,  1172,  2163,
     327,  1209,     0,  1167,  1196,     0,   347,     0,  1161,     0,
       0,   268,  1141,  1190,     0,     0,   211,   210,   212,     0,
       0,  2131,     0,   871,   833,   870,     0,     0,     0,     0,
       0,     0,   841,     0,     0,     0,   832,     0,   831,   383,
     356,   357,   359,   366,     0,   753,     0,     0,     0,   743,
       0,     0,     0,  1305,     0,   131,     0,     0,     0,   569,
     610,   617,     0,     0,     0,   412,   416,   420,   421,   422,
       0,     0,     0,     0,   145,   132,     0,   783,     0,   466,
       0,   666,     0,   176,   169,     0,     0,     0,   338,   740,
     738,   737,   739,     0,     0,     0,   758,   736,     0,  1617,
    1619,     0,     0,     0,     0,     0,   512,   415,     0,   469,
       0,     0,   501,     0,     0,     0,     0,   338,     0,     0,
       0,  1011,     0,  1029,  1012,     0,     0,     0,     0,  1059,
    1066,  1060,  1039,     0,     0,   546,  1444,  1445,     0,   327,
       0,     0,  1644,  1657,   801,     0,  1687,  1686,  1688,  1688,
       0,  1628,     0,  1679,  1680,  1696,  1697,  1698,  1699,  1700,
    1701,     0,  1695,  1637,     0,   612,   327,   327,     0,   327,
       0,   327,   327,     0,   659,     0,  1236,   638,     0,     0,
     713,   799,     0,     0,   327,   796,  1941,     0,   923,   468,
       0,     0,     0,     0,   934,     0,   544,   939,     0,   951,
     946,   948,     0,   955,   647,     0,     0,  1419,  1412,  1414,
    1413,     0,     0,  1410,  1948,   795,     0,   518,  1109,  1110,
       0,     0,   327,     0,   956,     0,     0,   883,   884,     0,
       0,   891,     0,     0,     0,  1492,  1949,  1950,     0,     0,
       0,  1984,     0,     0,  1845,     0,  1821,  1823,  1835,     0,
    1846,  1806,  1847,  1825,  1827,     0,  1931,     0,     0,  1836,
       0,  1770,  1771,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1786,  1785,  1837,  1910,     0,     0,  1971,  1972,  1838,     0,
       0,  1978,     0,     0,     0,  1843,  1848,     0,     0,     0,
       0,  1854,     0,  1875,     0,     0,     0,  1796,  1941,     0,
       0,     0,     0,     0,     0,     0,     0,  1767,  1750,  1744,
       0,  1748,  1752,     0,     0,     0,  1738,     0,     0,  1736,
    1762,  1732,     0,     0,  1763,     0,     0,     0,  1814,     0,
       0,  1487,  1487,  1487,  1487,  1484,     0,     0,     0,     0,
    2262,     0,  1577,  1554,  1556,  1564,  1577,  1582,  1816,  1611,
    1817,     0,  2017,     0,  1525,  1496,  1496,  1496,  1813,     0,
       0,     0,     0,  1495,  1525,   187,     0,   220,   207,     0,
    1334,  2020,     0,  1499,     0,  1932,  1000,     0,  1501,     0,
       0,  1547,  1509,  1423,  1407,     0,  1405,  1394,     0,  1395,
    1998,     0,  1405,  1391,  1434,     0,     0,  1616,     0,  1433,
       0,  1645,  1014,  1015,     0,  1038,     0,  1197,  1121,  1173,
     966,   967,     0,   965,     0,     0,     0,   454,   983,     0,
       0,     0,   705,     0,     0,   458,     0,  1310,     0,  1215,
    1159,   577,   578,     0,   589,     0,   598,   597,     0,     0,
     585,     0,     0,     0,     0,     0,   584,   604,   550,   605,
     607,     0,     0,   606,   609,   614,  1170,     0,   645,  1147,
       0,  1194,  1041,     0,  1009,     0,     0,     0,     0,   428,
     289,     0,     0,     0,   277,   287,     0,   321,     0,   292,
       0,   285,   308,   300,   309,   301,   320,   625,   626,   624,
     620,     0,   627,   629,     0,   336,     0,     0,     0,  1204,
       0,  1170,     0,   270,  1143,     0,  1192,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1205,  1179,
       0,     0,   667,     0,   664,     0,     0,   137,   136,     0,
     143,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   348,   329,     0,
     761,     0,     0,     0,   350,     0,     0,     0,     0,  1203,
    1130,   834,     0,     0,     0,   835,   846,     0,     0,   836,
       0,     0,     0,     0,   848,     0,     0,   355,   363,  2216,
    1918,  1919,   751,   756,   748,   750,   752,   749,     0,   755,
     705,     0,   745,   746,     0,     0,     0,     0,     0,   440,
       0,     0,   434,     0,     0,  1066,   427,   430,   431,     0,
       0,   570,   573,   571,   572,   603,     0,   447,   493,     0,
     147,     0,     0,   148,   146,     0,     0,   338,   671,   675,
     673,   672,   674,   669,     0,   662,     0,   172,   411,     0,
       0,   562,   686,   689,   682,     0,   757,   759,   734,     0,
     617,     0,   524,     0,   466,  1384,   507,     0,   497,   493,
     495,   494,   496,     0,   503,   337,     0,     0,   512,   503,
       0,     0,   984,  1010,     0,     0,     0,  1056,  1061,  1057,
       0,     0,  1025,     0,  1058,     0,  1040,  1003,  1231,  1232,
    1229,  1230,     0,     0,     0,  1436,  1078,     0,  1663,     0,
    1683,  1681,  1624,  1629,  1669,  1704,   327,  1076,   803,     0,
     790,     0,   792,  1080,   327,   327,   327,   327,   654,     0,
     559,     0,     0,     0,     0,   933,   953,     0,   949,     0,
       0,   916,   958,     0,     0,  1417,  1415,   510,     0,   961,
       0,   917,   960,     0,     0,     0,     0,     0,     0,     0,
    1953,     0,  1986,  1982,     0,  1818,  1954,     0,  1966,  1965,
    1911,     0,     0,  1769,  1781,  1782,  1783,  1967,     0,  1791,
       0,     0,  1778,  1779,  1780,  1772,  1773,  1774,  1775,  1776,
    1777,  1784,  1976,  1975,  1969,  1970,     0,  1840,  1841,  1842,
    1977,  1849,     0,  2086,  1876,  1853,  1869,  1868,     0,     0,
       0,  1856,     0,     0,  1865,     0,  1912,  2038,  1708,     0,
       0,  1735,  1981,  1753,     0,     0,     0,  1731,  1931,     0,
       0,     0,     0,     0,  1740,     0,     0,     0,  1894,  1889,
    1890,  1908,     0,     0,     0,     0,     0,     0,  1478,  1477,
    1483,  1577,  1582,     0,  1459,     0,  1564,     0,  1576,  1562,
    1575,     0,     0,  1588,  1586,     0,  1588,     0,  1588,     0,
    1558,     0,  1578,  1560,  1575,     0,  1603,     0,  2018,  1612,
       0,  1538,     0,     0,     0,     0,  1945,  1946,     0,  1943,
    1808,  1538,     0,  1995,  1472,     0,  1500,   998,   999,  1517,
    1510,  2113,  1614,     0,  1406,     0,     0,  1397,  1403,  1389,
       0,     0,  1427,  1405,  1430,  1035,     0,     0,  1027,   972,
     973,   971,   974,     0,     0,     0,   705,     0,     0,   474,
       0,   991,   991,     0,     0,   460,   506,  1066,   708,     0,
       0,     0,   706,   327,  1126,     0,   599,     0,     0,   594,
     592,   591,   593,     0,   551,  1213,  1127,     0,     0,     0,
       0,  1042,     0,     0,  1146,     0,   425,     0,   282,  1171,
       0,     0,     0,   281,     0,   327,   327,   622,   335,   340,
     341,   344,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   784,   767,     0,     0,   785,   786,
       0,     0,     0,  1083,  1084,  1082,     0,  1133,     0,     0,
     658,   141,   138,   139,   142,  1157,  1140,  1189,     0,     0,
       0,  1138,     0,  1183,  1153,  1149,     0,     0,     0,     0,
       0,  1212,  1166,  1187,  1211,  1164,  1185,  1163,  1184,  1165,
    1186,  1158,     0,  1621,   764,     0,     0,     0,   327,   327,
     656,  1142,  1191,     0,     0,   837,     0,     0,   839,   840,
       0,   843,   386,     0,   389,   396,   367,   372,  1314,     0,
    1314,     0,   369,   373,  1314,   368,  1314,   365,   727,     0,
       0,   704,     0,   432,     0,   438,   442,   443,   441,   433,
    1066,   466,   505,     0,     0,   717,     0,   568,   413,   444,
       0,     0,   417,   150,   149,     0,     0,     0,   665,   664,
     176,  2163,     0,     0,   691,   695,   735,     0,  1620,   651,
     338,   520,     0,     0,   413,   512,     0,   418,   423,   424,
       0,   501,   497,     0,     0,   509,  1278,     0,   513,   515,
       0,     0,     0,  1013,  1030,  1031,     0,     0,  1066,     0,
       0,  1065,     0,     0,   553,   327,  1625,   613,   327,   327,
     660,  1237,  1106,   714,     0,   945,   944,   943,   545,     0,
     947,   649,     0,   511,   327,     0,     0,   893,   874,   892,
       0,     0,   873,     0,   872,  1985,  1834,  1844,  1964,  1910,
    1941,     0,     0,  1792,     0,     0,  1839,  2375,     0,     0,
       0,     0,  1873,  1874,  1855,     0,  2207,  1860,     0,     0,
       0,  1759,  1757,  1754,     0,  1755,  1739,     0,     0,  1737,
    1733,     0,  1764,  1880,     0,  1896,  1893,  1907,  1941,  1482,
    1481,  1480,  1479,  1563,  1561,     0,  1566,  1573,     0,  1557,
       0,  1587,  1583,     0,  1584,     0,     0,  1585,     0,     0,
    1559,     0,  1573,     0,  1610,  1496,     0,     0,  1885,  1811,
    1812,  1809,  1496,  2035,  1885,   221,     0,     0,  1404,  1393,
    1396,     0,     0,     0,     0,  1435,  1425,  1028,  1036,     0,
       0,     0,   456,     0,  1066,     0,     0,     0,   994,   994,
       0,  1066,   505,   710,   709,   712,   707,   711,  1311,     0,
     586,   587,   601,  1148,     0,  1195,  1155,     0,  1421,     0,
     618,   278,   279,   280,   283,   329,   291,   284,     0,     0,
       0,  1144,     0,  1193,  1151,  1206,  1131,  1180,     0,     0,
     773,     0,     0,     0,     0,  1207,  1132,  1181,     0,     0,
       0,     0,  1421,     0,     0,     0,     0,     0,  1320,     0,
     328,   763,   762,   329,   349,  1168,     0,   838,   844,   845,
     842,   387,   131,     0,   364,     0,   394,     0,   392,   391,
     393,     0,   380,     0,     0,     0,     0,     0,     0,     0,
    1097,  1097,     0,   705,     0,     0,   429,   505,   473,     0,
     435,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   657,   171,     0,   413,   617,   690,     0,
       0,     0,   760,     0,   512,   415,     0,  1382,   414,     0,
       0,   503,   501,     0,   498,     0,   502,     0,  1271,     0,
       0,     0,     0,  1062,     0,  1068,     0,  1024,  1001,  1063,
       0,  1613,     0,     0,     0,     0,   557,  1098,   791,   793,
     655,   950,     0,   957,   327,   875,   876,   877,   878,  1912,
    1787,     0,     0,     0,     0,  1850,     0,  1851,  1878,  1877,
    1857,  1861,     0,  1858,  1859,  1756,  1760,  1758,  1741,  1882,
       0,  1496,  1909,  1606,     0,  1609,  1565,     0,     0,  1567,
       0,     0,  1569,  1571,     0,     0,     0,     0,     0,     0,
    2021,     0,  2112,  2349,  2261,     0,  1524,  1526,  1529,  1531,
    1530,  1532,  1528,  1537,     0,  1461,     0,  1460,  1933,  1615,
       0,     0,   985,     0,     0,  1432,  1431,   951,     0,   327,
     991,   505,   475,  2216,   476,   990,     0,   992,   997,   997,
       0,   505,   705,   579,     0,     0,   263,   616,     0,   331,
     343,     0,  1421,     0,     0,     0,   780,   768,     0,     0,
     787,  1134,   661,     0,     0,   259,  1154,  1150,  1322,  1323,
       0,     0,     0,     0,     0,   327,   847,   366,     0,   390,
     399,     0,   397,   370,   375,     0,   379,   377,   376,   371,
     374,  1097,     0,  1094,  1093,   703,     0,   464,   436,     0,
     484,     0,     0,   718,     0,     0,   493,   453,   452,   449,
     448,   450,   451,   446,   445,     0,   617,   777,   338,  1278,
       0,   630,   692,   693,   688,     0,     0,     0,   508,   497,
     493,   419,   428,   402,   503,   499,   500,     0,     0,     0,
     512,  1324,   984,     0,  1067,     0,     0,     0,     0,     0,
       0,  1101,   552,     0,     0,   556,   547,   617,   918,  1788,
       0,  1789,     0,     0,     0,  1863,  1862,     0,  1899,  1611,
       0,     0,  1605,     0,  1574,  1590,     0,  1570,  1568,     0,
    1579,     0,  1581,  1808,     0,     0,     0,  1533,     0,  1884,
    1886,     0,  1810,  1402,  1613,     0,  1399,     0,   968,     0,
     969,   994,   479,     0,   993,  1000,  1000,   466,   705,   457,
    1156,     0,   619,     0,   286,     0,   271,  1152,     0,   771,
       0,   782,   780,     0,     0,     0,     0,  1316,     0,  1317,
    1318,  1321,   351,   354,   385,   395,     0,   378,  1092,  1096,
    1095,     0,     0,   437,   470,   471,   472,     0,   439,   480,
     481,     0,   715,     0,   720,     0,     0,   492,   642,     0,
       0,     0,  1272,     0,     0,     0,  1278,   501,   497,   426,
     400,     0,  1275,     0,   514,     0,   338,  1066,  1069,  1064,
    1235,     0,     0,   555,   554,   646,  1790,  1866,  1852,  1879,
    1864,  1895,     0,     0,     0,  1604,  1607,     0,  1572,     0,
       0,  1580,     0,     0,     0,  1527,     0,     0,  1401,   986,
       0,     0,   997,     0,   705,     0,   988,   987,   473,   459,
    1421,   330,     0,     0,     0,   778,   781,   769,   782,   789,
     788,   663,  1421,     0,   398,     0,   463,     0,     0,     0,
     482,     0,   483,   504,     0,   719,     0,     0,   776,     0,
       0,   413,   694,     0,  1273,   503,   501,  1276,  1277,     0,
     503,  1002,  1234,  1233,  1474,     0,     0,  2336,  2113,  2308,
       0,  1897,  1900,  1898,  1892,     0,  1589,  1602,  1535,     0,
    1534,  1887,  1888,  1613,   327,  1000,     0,   461,   477,   484,
     264,  1421,     0,     0,   770,   260,  1319,   695,   489,     0,
     488,     0,   486,   485,   716,   721,   617,   766,  1278,   698,
     403,   503,     0,  1613,  1217,  1474,  1216,  1218,  1226,  1223,
    1225,  1224,  1222,  1104,  1105,     0,  1904,  1903,  1902,  1906,
    1905,  1608,     0,  1600,  1536,  1398,   970,   989,     0,   705,
     272,   772,   779,     0,   487,   491,   490,   643,  1274,   700,
       0,   696,   699,   701,   702,   401,   338,   975,     0,  1227,
    1221,  1459,  1446,     0,     0,     0,     0,   478,   462,     0,
     676,     0,   503,  1219,  1474,     0,     0,  1901,     0,     0,
     697,  1613,  1220,     0,     0,  1601,     0,   976,     0,     0,
     698,     0,     0,     0,  1102,  1103,   677
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    51,    52,    53,    54,  1410,  2271,  2156,  2984,  2985,
      55,    56,  1406,    57,    58,    59,    60,    61,    62,    63,
    1342,    64,    65,   942,  1531,  2282,    66,  2014,   726,   727,
     728,  1837,  1838,  2219,  1839,  1827,  1232,  1664,  1361,   700,
     701,  1324,  1362,    68,    69,  1226,  1818,    70,    71,    72,
    1388,  1389,  1336,  1572,  3963,  4634,  2825,  2134,  3024,  2826,
    2827,    73,  1458,  1459,    74,    75,  2952,  1502,  2250,  3507,
    3508,  3997,   548,  2247,  4282,  4283,  3983,  3984,  4289,  4501,
    4502,  2283,  1526,  3018,  3588,  2975,  4046,  2976,  4047,  2977,
    4048,  2963,  3536,  3537,  3538,  2978,  4019,  4533,  2979,  2033,
    4663,  2318,  1686,  1684,  4520,  3848,  3849,  4734,  4668,  4669,
    4670,  4822,  4021,  3022,  3594,  4055,  4310,  2721,   635,  1552,
    3127,   636,  2321,   580,   637,  2284,    81,  2312,  2313,  1429,
    2164,  3512,  3107,    82,   962,  3367,  4366,  4575,  4576,    83,
     217,    84,  1535,    85,    86,  2267,  2969,    87,  2050,  2738,
      88,    89,  2766,  2767,  2768,    90,    91,  3389,  4229,  1390,
    2814,  2815,  2816,  2817,  3412,    92,  1533,  1434,  2291,    93,
      94,    95,    96,    97,  2434,  2435,    98,  2207,    99,   100,
     101,   102,   103,  3444,  3930,  3565,  2852,  2991,  3563,  2285,
    1543,  2303,  2304,  4035,  4329,  4544,  4331,  4870,  4871,  4303,
    3345,  3862,   105,   106,  4014,  4015,  4675,   107,  2048,   108,
     109,   110,  1510,  2259,  2260,  3513,  1504,  2253,  2254,  3575,
    3576,   111,  2907,   112,  3914,  3915,   581,  4680,  4641,  4747,
     113,   114,  3918,  3919,   115,   116,   117,   118,   119,   629,
    1052,  1053,  1309,  1000,   120,  1934,   121,   913,  2934,   122,
    1120,  2480,  4098,   123,   660,  1066,  1067,  2286,   125,   669,
    2458,   671,  1699,  3109,  3110,  3661,  2420,   813,   126,   127,
    2431,  2461,   128,  1329,  2024,  2025,  3843,  2287,   582,  1558,
    2325,  2716,  4441,  4442,  4208,  4458,  2646,  3298,   130,   583,
    1366,  2094,  2328,  3032,  1991,  1992,  1993,  3611,  1994,  3034,
    1995,  1303,  1996,  3040,  3041,  3042,  3607,  3614,  3617,  4355,
    4356,   131,  1364,  2092,   132,   133,   134,  1401,   844,   135,
     595,   596,   136,  4513,   137,   974,   138,  4364,   139,   140,
     691,   692,  1104,  1105,   141,   142,  2107,  3396,   143,   144,
     145,  4836,  4878,  4879,  4880,  3622,  4784,   146,  4838,  1097,
     148,   149,   150,   186,   877,   878,   879,  2288,  4348,   152,
     153,  1325,  1326,  1327,  1328,  2019,   154,   155,   156,   157,
     158,   159,  1514,   160,   161,  4490,   162,   163,  1477,   164,
    1261,  1262,   165,   166,   543,   744,  1265,  1273,   167,   639,
    1060,  1061,  1062,  1666,   168,  1100,  2446,   640,  1055,   170,
     641,  1979,  2667,  3308,  3309,  3312,  4193,  3824,   642,  2664,
     173,  1706,  2440,  2443,  2660,   643,  2672,  2673,  2674,  2675,
    2676,  3315,   644,   662,   965,  2334,   645,  1193,   178,   179,
     180,   754,   748,   749,   182,  1811,  2607,   678,  1280,   713,
     714,   762,  3283,  1947,  1948,  1970,  1971,  1289,  1290,  1960,
    1962,  2648,  1963,  2656,  1953,  3801,  4426,  4427,  4428,  4429,
    4430,  4431,  4178,  1966,  1967,  1292,  1293,  1294,  1975,   183,
    2611,  3263,  3264,  3265,  3778,  3779,  3793,  3789,  4162,  4412,
    3266,  1095,  1300,  4170,  4853,  3267,  4403,  4404,  4592,  3796,
    3274,  3306,  3008,  3009,  3010,  1997,  1601,  1002,  1194,  1003,
    1615,  1195,  1585,  1005,  1196,  1197,  1198,  1008,  1199,  1200,
    1201,  1011,  1577,  1604,  1202,  1203,  1595,  1612,  1613,  1655,
    2518,  1205,  1206,  1207,  3269,  1208,  3734,  4129,  4118,  2539,
    2540,  1834,  3730,  3209,  1806,  2597,  4435,  4609,  4610,  3248,
    3759,  4145,  4401,  4714,  4791,  4792,  1209,  1210,  1211,  2594,
    1802,   846,  1212,  3515,  1804,  2533,  2619,  2620,  1709,  1729,
    2486,  2502,  2503,  2513,  3168,  2521,  2526,  3196,  3197,  2534,
    2563,  1213,  2488,  2489,  3152,  1731,  1214,  1255,  1256,  1726,
    2558,  1268,  1269,   746,  1222,  1215,  1216,  1700,   737,  4408,
     538,   803,  2841,  1925,   881,   675,  1217,  1218,  1219,  1220,
    1394,   818,  1022,  1023,   539,   797,   820,  2818,   540,   541,
     799,  1930
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -4409
static const int yypact[] =
{
    5349,   737,  4906, -4409, -4409,   737, -4409, 61145,    15,   552,
      79,   164,  9699, 61576, 68472,   220,   313, 11802,   737, 68472,
    1790, 46491, 58128,   726, 68472,  1024,   690, 46491, 68472, 68903,
     869,   731,   872, 69334, 62007, 56835,  1131, 68472,  1001,   309,
   69765, 62438,   879, 62869,   690, 43053,   230,   887, 70196, 68472,
    1511,  1379,   898, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409,    15, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409,  1312, -4409,   820,
    2003,  1296,   240,   943, -4409, -4409, -4409, 54680, 68472, 68472,
   68472,  1480, 68472,  1110, 68472,   177, 54680, 50370, 63300,  1251,
    1391, 39599, 70627, -4409, 49077, 68472, 68472, 71058, 68472,  1351,
   59421, 68472,  1213, 68472, 68472, 50801, 71489,  1374,  1144, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, 68472, 12289,  1024, -4409, -4409, 68472,  1477,
   54680, 68472,  1415, 68472,  1496, 68472, -4409, 68472,  1537, 71920,
     381,  1704, 50370,  1715, 40031,  1637, 68472, 50370, 72351, 68472,
   68472, -4409, -4409,  1626, 68472, 68472, -4409,  1765, 51232,  1429,
    1799,  1950,  1860,   795, -4409, 63731, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, 53818,   313, -4409, -4409, 55111, 68472,
    1892, -4409, -4409, 72782, 87388,  1670, -4409,   431, 55542, 51663,
    1975,  1649, 40463,  2009, 73213, 52094, 73644, -4409, -4409, 74075,
   -4409, 74506,  1749,  1892, 74937, 87807, 52525, -4409,  1877, 75368,
   -4409,  1664,  1542,  1092, 36131, -4409, -4409, -4409,    15, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409,   334,  1272,   211,
     198,   285, -4409, -4409,   214,   215,   217,   334,  2127,  2127,
   -4409, 68472, -4409, -4409,  1272,    34,  1680,  1680,  1680,  1911,
      19, -4409,  1680,  1818, -4409, -4409, -4409, -4409, 62869, -4409,
    1727,  1024,  1743,  2145,  1814, -4409, -4409, -4409, -4409, -4409,
    1817, 68472, 68472, 68472, -4409, -4409,  2186,  1825,  2051,  1795,
   -4409, -4409, -4409,  2004,  2029,  2006,    81,  1024,  1905, -4409,
    2117, -4409,  2021, 25952, 25952,  1024, 64162, 75799,   179, 53818,
    1024, 64593,  1891,   897,  2030, -4409, -4409, -4409,   120, -4409,
    2278,  1906,  2146,  1795,  1144, 37432, -4409,  1912,  1394, 62869,
   -4409, -4409, -4409,   346,  2219, 26400, -4409, 68472,  1928, -4409,
    1937,  1928,  1942,  1947,  1296, -4409,  5349, 68472,   314,   314,
    2347,   314,  1316,  1771, -4409,  2017, -4409,  2230,  2205, 62869,
     887,   194, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409,  1961,  1394, -4409,   221, -4409,
    1313,  1968,  1420,  1373, -4409, -4409,   234, 68472,  2092,   203,
       8,  2019, 65024,  3442,  1993, -4409, -4409, -4409,  2131,  1305,
   -4409, -4409, -4409, -4409,  2267,  2339,  5096,   332, 65455, -4409,
   -4409, -4409, -4409, 68472, 68472, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409,  2031, -4409, -4409,  2039,  2355,  2239,
    2321,  2198,  1447,  2252,  1199,  2375,  5788,  1274, 65886, 68472,
    2348,  2397,  5205,  1250,   976,  2281,   533,  2391,  2254,  1471,
    2424,  6051, 68472, -4409,  2352,  2457,    71, -4409,   119, -4409,
    2175,  2314,   574, 54680,  2126, -4409, -4409, 68472, -4409, -4409,
   88226,  2199, -4409,   444, 54680, -4409,  2326,  2174, 40895, 68472,
   -4409, 68472, -4409, -4409, -4409, -4409, -4409,  2257,  2432, 68472,
   88226, -4409,  2379, 68472, -4409,  1680,  2296,  2142,  2529, 88226,
     295, 68472,  1485,  2564, 68472,  2359,  1485,  2187, 76230, -4409,
   -4409,  1485, -4409, -4409, -4409, 68472, 68472,  2155,  1650,  2349,
    1485,  2364,  2571,  2574,  2234,  2346,  1043,   975,   169,  2466,
    1485,  2212, 76661, 77092, 68472,  2214, 68472,  2546, 54680, 68472,
    2476, -4409,  2342, -4409, -4409,   805, -4409, -4409, -4409, -4409,
    2492,  1961,   219,  2494,  2188,  2495, -4409, -4409, -4409,  2235,
   -4409,  2235,  2235,  2200,  2200,  2365,  2201,  2508, -4409, -4409,
   -4409,  1723,  2235,  2200, -4409, 89064, -4409,  1478,  1526, -4409,
     147, -4409,  2619, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409,   148, -4409,   888,  1712, -4409, -4409,  2237, -4409,  2513,
    1993,  2521, -4409,  2209, 77523, -4409, 77954, 78385,  2523,  2031,
   50370,  2528,  2412,  2535,  2209,  2537,  2421,  2539,   219,  2551,
   -4409,  1096,  2540,  2555,  2440,  2559,   147,  2561,  1057,  2209,
   54249,  2562,   158, -4409, 28192, -4409,  2343, -4409,   887, -4409,
     -47, -4409, 45629, -4409,  1092,  1272, -4409, 68472,  1272, 68472,
    1272, 68472,  1272, 68472,  1272, 68472, 68472, 68472,  1272, -4409,
   -4409, -4409, 68472,  2256, 68472, 68472, -4409, -4409, -4409, 58559,
   50370, 58990, -4409, 68472, -4409,    88,  1024, -4409, -4409, 88226,
    2673, 50370,  2546, -4409,  1385, -4409, -4409, -4409, -4409, -4409,
   -4409,  2498, 68472,  2563,  2565, 58559, 50370, -4409, 78816, 53818,
    2459,  2265, -4409, -4409, -4409, -4409, -4409,  1767,  2714,   222,
    2717, 28192,  2275,   200,   200,  2276,  2577, -4409, -4409, -4409,
     245,  2282,  2284, -4409,   246,   246,  2287,  2292, -4409,   270,
    2293,  2294,  2726,  2741,   275,  2302,  2304,  2307,  1723,   200,
   28192, -4409,  2312,   246,  2313,  2316,  2317,  2742,  2319, -4409,
    2759,  2320,   292,   329,  2322,  2323, -4409,  2287, -4409,   250,
    2325,  2327,  2328,  2330,  2331,  2335,  2337,  2338, 28192, 28192,
   28192, -4409, 24608,  1394,  1024, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409,   282,  5543, -4409,  2360, -4409, -4409,  2502,
   -4409, -4409, 28192, -4409, -4409,   335, -4409,   286, -4409, -4409,
   -4409,  1394,  2590,  2340, -4409, -4409,  1051,  2344, -4409,  1805,
   -4409, -4409, -4409, -4409, -4409, -4409, 52956,  2755, -4409,   343,
    1024,   119,  1102,  2699, 44767, 45198, -4409, -4409,  2578, -4409,
   68472, -4409, -4409, 28192, 42622, -4409,  1394,   243, -4409, -4409,
   -4409,  1398, -4409, -4409, -4409,    15, -4409, 14754, -4409,  1524,
    1928, 68472, 68472,  2764, -4409, -4409, -4409,  1937, -4409, -4409,
    1296,  1296, 28192,  1296,   663,  1173, 26848, 28192,  2647,  2547,
     699,  1372,  2649, -4409,  2550,  1316,  1771, 62869, 68472, 79247,
    2470, -4409, 43484,  1431,  1394,  2434,  2435,  2485, 47353,  2358,
    2438,  2439,  2489, -4409,  2599, -4409, -4409,  2446,  2449, 79678,
   -4409, -4409,   921, -4409, -4409, -4409,   921, -4409,  2385,  1282,
     919,   278,  2452,   393,   791,  2745, -4409,  1194,  2503, -4409,
   -4409, -4409,  5341, 68472,  2687,  6105,  2573,   332,  2501, -4409,
   -4409,  2621,  2461,  2464,  2589,   332,   878, 80109, -4409, -4409,
   -4409, -4409, -4409, -4409,  3465, 23322, -4409,  2467,  2444,  2477,
   68472, 55973,   337,  2583,  1555,  1655,   180, 68472,  2659,  2591,
   68472,  2396,  2475,  2481,  2676,  2411,  1756,  2781,  2409, -4409,
   -4409, -4409,   402,  2592, -4409,  2686,  2728,  6272,  2471,  2478,
   86550,  1072, 41327, 68472, 68472,  2770,  1407,  2504, -4409, -4409,
   -4409,  1407, 68472,  2505,  2507, 68472,   332, -4409,  2823,   332,
     332,  1244,  2824,  2512,   379,  1630,  1485,  2409,   216, -4409,
    2517,  2519,   267, -4409,  2632, -4409, -4409,  1324,  2516, 62869,
     397,  1730,  2409,  2525,  2531,  2411,  2411, 68472, 68472, 68472,
   68472, 68472,   195,  2855,  2856,  2533,   191,  2588,  2453, -4409,
   49508,  2542, 75799, -4409, -4409, 68472,  2543,  2042,  2409,  1333,
    1548, -4409, -4409, -4409,  1144, -4409, 68472, -4409, 68472,  1961,
   88226,  2660,  2716, -4409,  2510, -4409,  1993,   332, -4409, 68472,
   68472,  2031,  2665,  1326,  1228, 88226,  2667,  2731, 68472,  2733,
    2522, -4409,   223, 43910, -4409,  2155,  2496,  2909, 68472, 47353,
   -4409,  2923,   921, -4409, 88226,  2690,  2808, -4409, 68472,  2707,
    2511, -4409,  2844,  2567, -4409, -4409,    86, 68472, -4409,  2813,
   50370,  1082,  1024,  2548, 50370,  2737, 68472, 68472, 68472, 68472,
   -4409, -4409,  2710,   792,   143, -4409, 49508, -4409, 68472,  2729,
     216,  2730,  2940,   594,  1680, 80540,  2825, -4409, 80971,  2526,
    2942, 88226,  2772, -4409,  1686, -4409,  2655, -4409, 54680,   219,
   -4409, -4409, -4409, -4409, 88226, 68472, -4409,  2532, -4409, -4409,
   28192, -4409, -4409, -4409,  2127, -4409, 88226,  2235,  2235, -4409,
   -4409,  2947,  2612,  2614,  2127, -4409,  2127, -4409, 88226, -4409,
    2538,  2541,  2657,  2127, -4409,  2633,  2635,  2636, -4409,  2560,
    2638,  2127, -4409, -4409,  2012, -4409, 81402, 54680,   219, 50370,
   50370,  2864,   158,  2873,  2620,  2874,  2626, 41327,   219,   176,
   68472, 68472, 50370, 68472, 68472, 68472, -4409, 68472, -4409, -4409,
   -4409, -4409, 88226, 68472, 68472, 88226, -4409, 50370, 49508,  2876,
    2883,   219, 68472, 68472, -4409, 14754,  1570, 81833,  1092, 53387,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, 68472, -4409,
   68472, -4409, 68472, -4409, 68472, -4409, 68472, -4409, -4409, -4409,
   68472, -4409, 68472,  1614, -4409, -4409,  1620,   655, 68472, 68472,
     204, 54680, 68472,  2777, 68472, 68472, 68472, 68472, 68472,  2652,
    2344,  1162, -4409,   988,   670, 62869,  2783, -4409, -4409,  1625,
    1511,   930, 68472,   968,  1817, -4409, -4409, 58990, 58128,  2878,
     136, 68472, -4409, -4409,  2506, 28192,  1394, 25504, -4409, -4409,
   14754,  2628, 28192, 28192,  2587,  2127,  2127, -4409,   799, 28192,
   28192, 28192,  2127,  2127,  3018, 28192, 41327, 28192, 31328, 21556,
   28192, 28192, 25056, -4409, 28192,  2804, 32666, 28192,  1102,  2805,
   28192,  1102,  3018,  3033,  3033,  1382,  5823,  2594,  1394, -4409,
    2127,   806, -4409,   257, 88226, 28192, 28192, 28192, 28192, 47353,
    2674,   209, 68472, 28192,  2596,  1349, -4409, 28192, -4409,  2602,
   28192,  2680,   938, 28192, 28192, 28192, 28192, 28192, 28192, 28192,
   28192, 28192, -4409, 33532,   316,  2888,  2908,   581,   385, 66317,
   25952,  2901, 20658, -4409,   281,  2901, -4409, -4409, -4409, 68472,
    2755, -4409, -4409,  2685, -4409, -4409, -4409, -4409, -4409,   287,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409,  2607, -4409, -4409,
   -4409, -4409,  2607, -4409,  2611,  3290, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409,  2890,  2892,   219, 68472,   346, 59852, -4409, 26400,
   -4409,  1639, -4409,  2616, -4409,  2870, -4409,  2615, -4409, 11834,
    2870, -4409, -4409,   330,  2732,  2863,  2811, -4409, -4409, -4409,
    2625, 14754, -4409,   956, 14754,  1768, -4409, -4409, -4409, -4409,
   -4409, -4409,   971, -4409, 68472,   114,  2647,  1372,  2677,   747,
    3039, 68472, -4409, 37865,  2809, -4409,  3028, -4409, 89064, -4409,
    2630, -4409, 88645, 85281, -4409, -4409,    56, -4409,   811,  2711,
    2713,  2763, 50370, 68472, 68472, -4409, 47353, 50370, 68472, 68472,
   -4409, 50370, 68472, 68472, -4409, -4409, -4409, -4409, -4409, 46060,
      91, 58128,  2766, 57266, -4409, -4409,  2642, 68472,  2698,  2891,
    2893,    -3, -4409, -4409, 82264, -4409,  2834, 50370, 68472, 68472,
   28192,  2846, 68472, 68472, -4409,   274,  2724,  2727, -4409, 68472,
    2735, 54680,  2656, 68472, 68472, 88226,  2721,   648, 54680,  2701,
   41759, 68472, 68472, 68472, 68472,  2784,  2958, 88226, 68472,  2906,
     109, 62869,   172,  2050,  2409,  2865, -4409,  1019, -4409, 50370,
   68472,  2857, -4409, -4409, -4409, 66748,  3074,  2774, -4409, -4409,
   82695, -4409, -4409, -4409,  1646, -4409, 50370, 50370, 68472,  6790,
   68472,  1084, -4409, -4409, 88226, -4409, 68472, 68472, 68472,  2905,
   68472, 60283, 83126, 83557,   580,  1278,  2907, 68472, 60714, -4409,
   68472, -4409, -4409, 47784, 50370, 68472,   729, 47353, -4409, -4409,
   68472, -4409,  2867,   260, -4409, 68472,  3010, -4409,  2748,  2760,
   68472,   175,  2222,  2409, 68472, 68472,  2678,  1651,  2757,  2810,
   -4409,  2875,   588, 68472, -4409, 50370,  1095, -4409,  2829, 50370,
   68472,  5890, -4409, -4409,   332, -4409, -4409, -4409, -4409, -4409,
   68472, 68472,   332, 68472,   332,  1267, -4409, 50370, 68472, -4409,
   -4409, -4409, 68472,  7271, 68472, 68472, 68472, 68472, 50370, 68472,
   -4409, -4409,   885,  1298,  1064,  1205,  2831, 68472,  2966, 68472,
   83988, 50370, 68472, 68472, 68472,  1292, -4409,  2812, -4409, 50370,
    1095,  7832, 68472, 68472,  2769,  2771,   167,  2851, -4409, -4409,
   -4409, -4409, -4409, -4409,  2946,  3113, 84419,   796, -4409,  2949,
    2950,  2753,  2756,  2952, 68472,   796, 68472, -4409, -4409, -4409,
   -4409,  2951, 68472,   796,  2953,   796,  2900,   151, -4409, -4409,
    1485, -4409,  2722,  1653, -4409, -4409, 28192, 88226, -4409,  1657,
   -4409,  2723,   792, -4409, -4409, 47353, 68472,   642,   113,  3024,
   56404,  1360,  3014, 68472,  2765, 68472,  3015,  1360, 68472, -4409,
    1728, 58128, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409,  3017, -4409,  1024,  2155,  2155,  2155,  2155, -4409, -4409,
   -4409, -4409,  2920,  1624, -4409,  2725,  2155, 68472,  2843,  1360,
    2734,  3036, -4409,   216,  3037,  1221, 68472, 56404,  1887,  2767,
    2935,  3145,  1680,  1024,  2939,  2928, -4409, 23741,  4266,  2929,
    2981, 53818,  3019,  3020,  3041, -4409,  1961, -4409,  3154, -4409,
   28192,  1659,  2746,   147, -4409, -4409,  2744,  2541,  2768,  2773,
    2749,  2751, -4409,  2127,   207, 68472,  2754,  1100,  1124,  2869,
    2127,  2965,  2758, -4409,  3066,   219,  1993, -4409,  2209, -4409,
   68472, -4409, 68472, 68472, 68472, 68472,  2031, -4409, -4409,  2955,
     219,  2209,  2956,   219,   219, -4409,  3004,  2957,   219,   147,
    2209,  2884,  3063, 53818, -4409,   158, -4409, -4409, 28192,  2974,
    1680, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,  1672,
   -4409, 68472, -4409,  3043,  3045,  3046,  2775,  2776,  2802, 68472,
    2782, -4409,  2775,   332,  2775,  2344,  2344,  2775,  2776, 49939,
    3204,  3064, -4409,  2862,  2787,  3080,   277, -4409,   673,    33,
    3006, -4409, -4409, -4409, -4409, 88226, -4409, -4409, -4409, -4409,
   -4409, 50370,  2836, 68472, 68472, -4409,    82,  2982,  2792, 49939,
    3201,   219, -4409, 54680, -4409, -4409, 88226,  2877,  2895, 54680,
    3005,  2852, -4409, -4409, -4409, -4409, -4409, 88226, -4409,  3059,
   68472,  1687, -4409, -4409,  1525, -4409,  1557, 28192,   139, -4409,
   12797,  1695, 28192,  2816,  2817, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409,  2818,  3112, -4409,  1703,  1709,  1724,  2820,  2822,
    2558,  2828, 12921,  2832,  2830, 31328, 31328, 24608,  2871, -4409,
   31328,  2833,  3016,  1732, 11119,  2821,  2837, 13257, 27296, 28192,
   27296, 27296, 13555,  2821,  2841,  1736, 47353,  2998, 14081,  1737,
   -4409, 28192, 47353,  4707, 28192, -4409, 28192,  2842, -4409, -4409,
    1120,  1120,  1120,  3018, -4409,  2854, -4409, 31328, 31328, -4409,
    2524, 24608, -4409, -4409,  3136, -4409, -4409,  1352, -4409,  2845,
   -4409, -4409,  2948, 41327,  6432, 28192,   232, 28192,  2596, 28192,
    2926,  1120,  1120,  1120,   391,   391,   183,   183,   183,  1720,
     385, -4409, -4409, -4409,  2850,  2853,  2861,  3034,  2868, 28192,
   -4409,  2102,  2121, 68472,  2297,  3385,  4000, -4409, -4409, -4409,
   34399,  2912, 28192, 28192, 28192,  2872, -4409,  2163, 14754,   587,
   -4409,   290,  2912, -4409,  1144,  2127,   806, 45629, -4409, -4409,
   28192, -4409, -4409, -4409,  1937, -4409, -4409, -4409, -4409, -4409,
   68472,  1511, 28192, -4409, -4409,  2245,  2894, 28192,   956, -4409,
   -4409,  2902, -4409, 28192, -4409, -4409, -4409,  2344, -4409,  3079,
   -4409, -4409, -4409, 34399,  2913,  2924, 36998,  3069, -4409, 68472,
   -4409, 68472,   103, -4409, -4409, -4409,  2889, -4409, -4409, 85281,
    1712, -4409, 88645, -4409, 88645, -4409,  1712,  3279, -4409, 85281,
    1580, 50370, 68472, 68472, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, 50370, 50370,  3075,
   68472,  3071,  3076, 28192,   859, 68472,  2885,  2887,  1268,  3155,
   68472, -4409,  3199,   219, -4409, -4409,  2968, -4409, 14754, -4409,
   -4409, -4409, -4409, -4409, 50370, 68472, -4409, 53818, -4409,  1961,
   88226, -4409, -4409, -4409, 68472,  2932, 68472, -4409, 68472, 68472,
   68472,  2031, -4409, -4409, -4409, -4409,  1275, 88226, -4409, -4409,
   68472, 68472,   128,  2972,  2988, 68472, -4409,   835,  2632,  8265,
   68472, 68472, 68472,  3156, -4409, -4409, -4409, -4409,  3116, -4409,
   -4409, 85281, -4409,  2209,   616,  2999,  2409, -4409,  3114, -4409,
     960, -4409,  3047, -4409, -4409, -4409, -4409,  3233,   219,  3236,
     219, 68472, 68472, 68472, 68472,  3051, -4409, -4409, -4409, -4409,
   -4409, 47353, 47353, 47353,  1758, -4409, -4409,  1024, -4409, -4409,
   -4409, -4409, -4409, -4409,  3197, -4409,  1762, -4409,  1170, -4409,
   -4409, -4409, -4409, -4409, -4409, 50370, 68472,  8808, 68472, 68472,
   68472,  1522, -4409,   836, 88226, -4409, 86969, 50370, 68472, 68472,
    3008, 50370,  2987, -4409, -4409, -4409,  3167,  3109, -4409,   839,
    3110, 50370,  2995, -4409,  3022, -4409, -4409,  3023,  2260,  2409,
     216, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,  1053,
     404,  2336,  2409,  3026, -4409,  3030, -4409, -4409, -4409,  3170,
    3178,  3179,  3038,  3049,  3083,  3054,  3055,  3086, -4409,  3061,
    3088,  3070,  3092,  3073,   219, 88226,  3174,  1024,  3096,  3283,
     219, -4409,  3077, -4409, -4409,  3396, -4409, 68472, -4409,  3078,
    2400,  2409, -4409, -4409, 50370, 68472, -4409, -4409, -4409,   796,
   88226, 68472,  3241, -4409, -4409, -4409,   796,   796, 68472, 68472,
     796,  3252, -4409,  3253, 68472,  3257, -4409,   796, -4409, -4409,
   -4409, -4409,  2296,  3021, 39167, -4409,  3469,  5991,  3025, -4409,
   47353, 39167,  1754,  1842,   228,  1485, 53818, 68472, 53818, -4409,
     113,  3114, 68472, 68472,  3029,  3040, -4409, -4409, -4409, -4409,
   50370,   165, 50370,  2127, -4409, -4409,  3085, -4409, 68472,  1680,
     231,  3106,  3446,  2574,  1082,  3182,  1527,  3395,  2767, -4409,
   -4409, -4409, -4409, 68472, 68472,   792,  1024, -4409,  3048,  3050,
   -4409, 68472, 68472, 68472, 68472, 68472,  2836,  3052,  3056, 88226,
     598,  3243,  3245,  2411,  3470,  3360,  1511,  2767,  3135,  3368,
   68472, -4409,  1770,   145, -4409,  1024, 53818, 85700,  3357, -4409,
    4400, -4409, -4409,   621, 68472,  3344, -4409, -4409,  1511,   219,
   88226,  1779, -4409, -4409, -4409,  2127, -4409, -4409,   -14,   -14,
    3067, -4409,  3081, -4409,  3451, -4409, -4409, -4409, -4409, -4409,
   -4409,  3072, -4409, -4409, 68472, -4409,   219,   158,  3119,   219,
    3122,   219,   219, 68472, -4409, 68472, -4409, -4409, 68472, 68472,
   -4409, -4409, 68472, 49508,   219, -4409, 14754,  3379, -4409, -4409,
    3198,  3200,  3202, 68472,  2775, 54680, -4409,  3082, 50370,  1200,
   -4409, -4409,  3264, -4409, -4409, 62869,  3194, -4409, -4409, -4409,
   -4409,  3389,  3392, -4409, -4409, -4409,   778, -4409, -4409, -4409,
   50370, 58559,   178, 50370, -4409,  1961,  3331, -4409, -4409,  1993,
     332, -4409,  3333, 68472,  3334, -4409, -4409, -4409,  3091, 14369,
   28192, -4409,  3410, 88226, -4409,  6326, -4409, -4409, -4409, 28192,
   -4409, -4409, -4409, -4409, -4409, 28192, -4409, 28192,  3386, -4409,
   22005,  3534,  3534,  3093, 88226, 31328, 31328, 31328, 31328,  1061,
    2313, 31328, 31328, 31328, 31328, 31328, 31328, 31328, 31328, 31328,
   32224,   433, -4409,  3277, 28192, 28192,  3402,  3386, -4409, 88226,
    3098,  2821,  3105,  3107, 28192, -4409, -4409,  1781, 33099,  3108,
   47353, -4409, 28192, 12276,  1797,  3150, 14468,  1394,  6794,  1024,
   28192,  1800,  2414, 28192,  1801, 28192,  3403, -4409, -4409, -4409,
    3115, -4409, -4409, 88226, 28192,  3111,  3845, 31328, 31328,  4215,
   -4409,  4363, 28192, 24608, -4409,  3296,  3151, 38298, -4409, 22454,
    3117,   690,   690,   690,   690, -4409, 68472, 68472, 68472, 34832,
    3406, 33965, 67179,  3121,  1621, -4409, 67179, 67610, -4409,  3130,
   -4409,  3123,  1394, 28192,  3411,   689,   689,  3296, -4409, 28192,
   28192, 27744,  3128, -4409,  3411,   119,  3129, -4409, -4409, 10778,
   -4409, -4409,  3132, -4409,  3138, -4409,  2894,  1183, -4409,  6822,
    3326, -4409, -4409, -4409,  3121, 28640,  3276, -4409,  1815, -4409,
   -4409,  3512,  3276, -4409, -4409,  1821, 37865,  2913, 26400,  1394,
    1833,  1601, -4409, -4409, 85281, -4409,  3210, -4409, -4409, -4409,
    2209,  2209,   978,  2775,  3447,   978,  7308, -4409, -4409, 35265,
   68472, 68472, -4409, 68472,  1834,  1368, 68472, -4409, 68472, -4409,
   -4409, -4409, -4409,  3560, -4409, 68472, -4409, -4409,  3203,  3207,
   -4409, 68472, 68472, 68472, 68472,  3397, -4409, -4409,  1968, -4409,
   -4409, 50370, 68472, -4409, -4409, -4409,   226,  2455,  2409, -4409,
    3232, -4409, -4409,  3415, -4409,  3555,  3258, 68472,  3158, -4409,
    1368,   252,  2411,   715, -4409, -4409,  3242, -4409, 68472, -4409,
   68472, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, 47784, -4409, -4409, 68472, -4409, 47353, 39167, 47353, -4409,
    1088,   233,  2606,  2409, -4409,  3254, -4409,  3255,  3256,  3292,
     856,  1104,  3259,  3260,  3300,  3175,  3183,  3184, -4409, -4409,
    3324, 68472,  2209,  3186,  3222,   334,  1024, -4409, -4409,  1024,
    2209,  1024, 68472, 68472, 68472,  3587,  3275, 68472, 68472, 68472,
   68472, 68472, 68472,  3491,   160,  1764, 50370, 68472, 68472, 50370,
   68472, 68472, 68472, 68472, 68472, 68472, 68472, -4409,  3575,  3505,
    1896,  3545,  3265, 68472, -4409, 68472,  2632, 68472, 68472, -4409,
   -4409, -4409,  3205,  3449,   796, -4409, -4409,  3450,  3452, -4409,
     796,   796,  3454,   796, -4409,   223, 47353, -4409,  2025,  3138,
    2127,   402, -4409, -4409, -4409, -4409, -4409, -4409,  2722, -4409,
   -4409,  2130, -4409, -4409, 68472,  3209, 68472, 68472, 31328, -4409,
    1236,   954, -4409,  3455, 68472,  3237, -4409, -4409, -4409,  3366,
   68472, -4409, -4409, -4409, -4409, -4409,  3212, -4409,  3478, 56404,
    2209, 50370, 50370,  2209, -4409, 88226,  3215,  2767, -4409, -4409,
   -4409, -4409, -4409, -4409, 50370,  2987, 50370,  1082,  1353, 84850,
    3247, -4409,  3214,  3516, -4409,  3219,  3217, -4409, -4409, 68472,
    3114,  1838,   216,  3639,   612,  1664, -4409, 57697,  1887,  3478,
   -4409, -4409, -4409,  3600,  3313, -4409,  1511, 68472,  2836,  3313,
    1024, 68472,  2698, -4409, 85281, 28192, 28192, -4409,  3225, -4409,
    3234,  5216, -4409,  3305,  3235,  2155, -4409, -4409, -4409, -4409,
   -4409, -4409,  3317,  3249, 68472, -4409, -4409,  3240, -4409,  3261,
   -4409, -4409, -4409, -4409, -4409, -4409,   219, -4409, -4409, 68472,
   -4409, 68472, -4409, -4409,   219,   219,   219,   219, -4409,  3370,
   -4409, 68472, 68472, 68472, 68472,  2775, -4409,   332, -4409,  3538,
   49939, -4409, -4409,  1852, 68472, -4409, -4409, -4409,  3602,   136,
    3547, -4409, -4409,  3506,   865,  3510,  3511,   865,  3519,   865,
   -4409, 28192, 14754, -4409,  3270, -4409, 14754,  7450, 14754,  3402,
   -4409,  1857, 28192, -4409,  3466,  3466,  3466,  3665,  3548, -4409,
    1315,  3272,  3466,  3466,  3466,   453,   453,   288,   288,   288,
    3534,   433, 14754, 14754, -4409, -4409,  3274, -4409, -4409, -4409,
    2821, -4409, 29088,  3423,  3685, -4409, -4409, -4409,  3325,  3327,
    3291, -4409, 28192, 29536,  3287, 89064,  3474, -4409,  1432, 28192,
   28192,  3251, -4409,  7974, 28192, 88226,  1858,  3251,   384, 28192,
    2911,  2925, 28192, 28192,  4421,  7587,  3293, 28192, 86119, -4409,
   -4409, -4409,  1874, 28192, 68472, 68472, 68472, 68472, -4409, -4409,
   -4409, 67179, 67610,  3299, 22888,  1621,  3295, 68472, -4409, -4409,
    3301, 34399,  3546,  3486, -4409, 34399,  3486,  1634,  3486,  3550,
    3391, 38731, -4409, -4409,  3307,  3493, -4409, 20658,  1586, 14754,
    3708,  3592, 28192,  3311,  3314,  3315, 14754, 14754, 28192, -4409,
    1024,  3592,  1024, -4409, -4409, 41327, -4409, -4409, -4409, -4409,
   -4409,  3513, 14754, 25952, -4409,  1511, 68472,  1394,    61, -4409,
    3329, 68472, -4409,  3276, -4409, -4409,  3381,  1878, -4409, -4409,
   -4409, -4409, -4409,  3398, 58128,  3611, -4409, 28192,  1879, -4409,
    3359,  3702,   296,  1883,  1884,  1368, -4409,  3237, -4409,  1435,
    3591,   182, -4409,   219, -4409, 88226, -4409, 68472, 68472, -4409,
   -4409, -4409, -4409, 68472,  2358, -4409, -4409, 68472, 68472, 68472,
   68472, -4409, 50370, 68472, -4409, 47353,  1842,  3531, -4409, -4409,
    3532,   334, 68472, -4409, 88226,   219,   219, -4409, -4409, -4409,
   -4409,  3343,  3732,  3420, 68472, 68472, 68472, 68472, 50370, 68472,
   68472,  2127,  2127, 88226,  3335, -4409,  2127,  2127,  3337, -4409,
   50370, 68472, 68472, -4409, -4409, -4409,  3419, -4409, 28192,  3724,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, 50370, 68472,
    3422, -4409,  3430, -4409, -4409, -4409, 68472, 68472, 68472, 68472,
    3663, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, 68472, -4409, -4409,  1024,  1024, 88226,   219,   219,
   -4409, -4409, -4409,  3604,   796, -4409,   796,   796, -4409, -4409,
     796, -4409,   396,  1893, -4409, 35698, -4409, -4409,  2564,  1024,
    2564,  1505, -4409, -4409,  2564, -4409,  2564, -4409,  1368,  1427,
    3647,  3650, 28192, -4409,   915,  3665, -4409, -4409, -4409, -4409,
    3237,  1680,  3413, 54680,  1186, -4409,  3630,   642, 56404,  1569,
    3361,  3479, -4409,  2209,  2209,  3418, 68472,  3780,  2209,  3222,
   -4409,  3572,   619, 68472,  3690,  3407, -4409,  1024, -4409, -4409,
    2767, -4409,  1511, 68472, 56404,  2836,  1897, -4409, -4409, -4409,
    3405,  3245,  1887,   224, 68472, -4409,  3408,  3787, -4409, -4409,
    3666,  3567,  3378, -4409, 14754, 14754,  1024, 89483,  4400, 88226,
    3676, -4409, 68472,   321,  3642,   219, -4409, -4409,   219,   219,
   -4409, -4409, -4409, -4409, 68472,  2775,  2775,  2775, -4409,  3570,
   -4409, -4409,  3633, -4409,   219, 49939,   865, -4409, -4409, -4409,
     865,   865, -4409,   865, -4409, 14754, -4409, -4409, -4409, -4409,
    7898, 31328,  3677, -4409,  3384, 88226, -4409,  3390,  1899,  1908,
   32666,  3539, -4409, -4409, -4409,  8035,  3440, 14754,  3495,  3394,
    3399,  3251,  3251,  7974,  1909, -4409,  3251, 28192, 28192,  3251,
    3251, 28192, -4409, -4409,  8180,  3571, -4409, -4409,  8208, -4409,
   -4409, -4409, -4409, -4409, -4409, 48215, 67179,  3401, 68472,  1621,
   34399, -4409, -4409,  1128, -4409, 34399,  3638, -4409, 34399, 54680,
   -4409, 68472,  3404, 68472, -4409,   587, 29984, 28192,  3433, -4409,
   -4409, -4409,  3296, -4409,  3433, -4409,  3409, 68472,  2340, -4409,
   -4409,  3767, 35265,  3727,  3412, -4409, -4409, -4409, -4409, 49939,
    3597, 49939,  1368,  8527,  3237, 35265, 42191, 68472, 68041, 68041,
    3556,  3237,  3413, -4409, -4409, -4409, -4409, -4409, -4409,  3414,
   -4409, -4409, -4409, -4409,  3485, -4409, -4409,    50,  2783,  1910,
   -4409, -4409, -4409, -4409, -4409,  3575, -4409, -4409, 39167, 50370,
   68472, -4409,  3488, -4409, -4409, -4409, -4409, -4409, 36565, 41327,
   -4409,   856,  3417,  3421,  1104, -4409, -4409, -4409, 68472,  8546,
    3424,   535,  2783, 68472, 68472,  1482,  1215,  1510,  2775,  3706,
   -4409, -4409, -4409,  3575, -4409, -4409,   796, -4409, -4409, -4409,
   -4409, -4409,  1485,  3747, -4409, 47353, -4409, 48646, -4409, -4409,
   -4409,  1024, -4409,  1024,  3615, 68472, 44336,  1024,  1024, 54680,
    3833,  3833, 68472, -4409,  8885,  3620, -4409,  3413,  3644,  3687,
   -4409,  3426, 68472,  3582,  3427,  3428,   331,   331, 68472, 68472,
   68472,  1914,  1511, -4409,  1082,  3737, 56404,  3114, -4409,  1355,
    3434,  3740, -4409,  3848,  2836,  3052,  3435, -4409, -4409, 57697,
    3625,  3313,  3245,  3568, -4409,  3569, -4409,  1331, -4409,  1511,
   68472, 68472, 35265, -4409, 88645, -4409,  1918, -4409, -4409, -4409,
    3509,  2912,  3541,  3549,  3443, 68472,   625, -4409, -4409, -4409,
   -4409, -4409, 68472, -4409,   178, -4409, -4409, -4409, -4409, -4409,
    4075, 31328, 88226,  1919, 28192, -4409, 28192, -4409,  3841, -4409,
   -4409, -4409,   763, -4409, -4409, -4409,  3251,  3251,  3251, -4409,
    3843,  3296, -4409, -4409,  1924,  3862, -4409, 68472,  1935, -4409,
   28192,  3448, -4409, -4409, 34399,  1128,  3456,  1941, 68472,  1943,
   88226,  3462,  3464,    45,  3467, 21107,  3445, -4409, -4409, -4409,
   -4409, -4409, 14754, 14754, 68472, -4409,  3468, -4409, -4409, -4409,
   68472,  1952, -4409,   604, 24160, -4409, -4409,  1200,   978,   178,
    3702,  3413, -4409,  3476, -4409, -4409, 68472, -4409,  1339,  1339,
   68472,  3413, -4409, -4409, 68472,  3535, -4409, -4409, 47353,  3520,
   -4409,   559,  2783, 68472, 88226,  1993,    69, -4409, 88226, 88226,
   -4409, -4409, -4409, 28192,  3536, -4409, -4409, -4409, -4409, -4409,
   68472, 68472, 68472, 68472, 68472,   219, -4409,  3021,  1024, -4409,
   -4409,  1959, -4409, -4409, -4409, 68472,  3214, -4409,  3214, -4409,
   -4409,  3833,  1021, -4409, -4409, -4409,  1421,  3660, -4409,   993,
    3662,  3553,  3473, -4409, 54680,  3922,  3478, -4409, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409,  1973,  3114,  3782,  2767,  3408,
   68472, -4409, -4409, -4409, -4409, 28192,  3640,  1511, -4409,  1887,
    3478, -4409, -4409, -4409,  3313, -4409, -4409,  3868,  3673,  3872,
    2836, -4409,  2698,  1981, -4409,  5216, 89483, 88226,  3816,  3524,
    3525, -4409, -4409,  3543, 68472, -4409, -4409,  3114, -4409,  4075,
    1985, -4409,  1990,  2000,  3645,  3551, -4409, 28192,  1457,  3130,
   48215,  3503, -4409,  2007, -4409, 14754, 68472, -4409, -4409, 28192,
   -4409,  2018, -4409, -4409, 28192,  3504, 28192, -4409, 29984,  3508,
   -4409,  3924, -4409, -4409,  2912, 35265, -4409,  3621, -4409,  3805,
   -4409, 68041,  3554, 41327, -4409,  2894,  2894,  1680, -4409,  1368,
   -4409, 68472, -4409, 28192, -4409,  3606, -4409, -4409,  2028, -4409,
     106,  3667,  3814,  2034,  2044,  8994, 68472,  2776,  1510,  2776,
   -4409,  2775, -4409, -4409, -4409, -4409, 48646,  3214, -4409, -4409,
   -4409,  3847,  3790, -4409, -4409, -4409, -4409,   387, -4409,  3714,
    3718, 68472, -4409,  3527, -4409,  2052,  3648, -4409, -4409, 68472,
    3945,  3947, -4409,   629,  9454, 54680,  3408,  3245,  1887,  1842,
   -4409,  3723, -4409,  3725, -4409,  3537,  2767,  4400, -4409, -4409,
     298,  3829,  3831, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409,  2821, 30432, 30432,  3542, -4409, -4409, 68472, -4409,  2057,
    2058, -4409,  2064, 29984,  2066, -4409, 68472,  3552, -4409, -4409,
   37865, 49939,  1339,  3557, -4409,  3559, -4409, -4409,  3644,  1368,
    2783, 14754, 68472, 54680,  3944, -4409, -4409, -4409,  3667, -4409,
   -4409, -4409,  2783, 68472, -4409,  3681, -4409,   727,   727,  3883,
   -4409,  3609, -4409, -4409,  3561, -4409,  3999, 68472, -4409,   856,
    1511, 56404, -4409,  3558, -4409,  3313,  3245, -4409, -4409, 35265,
    3313, -4409, -4409, -4409,  1921, 54680, 54680, 31776,  3686,   852,
   12318, -4409, -4409, -4409, -4409,  2070, -4409,  3698, -4409,  2075,
   -4409, -4409, -4409,   -28,   178,  2894, 28192,  1368, -4409,  3662,
   -4409,  2783,  1993, 68472, -4409, -4409, -4409,  3407, -4409,  3990,
   -4409,   955, -4409, -4409, -4409, -4409,  3114,  3335,  3408, 46922,
   -4409,  3313,  2076,  2912, -4409,  2305, -4409, -4409, -4409, -4409,
   -4409, -4409, -4409,  3562,  3563,  3982, -4409, -4409, -4409, -4409,
   -4409, -4409,  3573, -4409, -4409, -4409, -4409, -4409,  9504, -4409,
   -4409, -4409, -4409,  3878, -4409, -4409, -4409, -4409, -4409, -4409,
    2082, -4409, -4409, -4409, -4409, -4409,  2767, -4409,  2097, -4409,
   -4409,  2101,  1947,  3646,  3869, 30880, 28192, -4409,  1368,  3735,
   -4409, 46922,  3313, -4409,  2305,  3682,  3683, -4409, 10330, 54680,
   -4409,  2912, -4409,  3613,  3616, -4409,  3583, -4409,  3874,  3876,
   46922, 54680, 54680,  2086, -4409, -4409, -4409
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4409, -4409, -4409,  3281, -4409,  -837,   254,  2569,  -381, -4409,
   -4409, -4409,  3187, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
    3221, -4409, -4409,  1760, -2203, -4409, -4409,   129,  3188, -1199,
     123,  2796,  1419, -4409, -1046, -4409, -4409,  -552,   108, -4409,
    3190,  -690, -4409, -4409, -4409, -4409, -4409, -4409, -4409, -4409,
    -728,  1913,  1252,  -736, -2595, -4409, -4409, -1315, -2872, -4409,
     635, -4409, -4409,  1847, -4409, -4409, -4409,  1101,   549,  -442,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409,  -228, -4409, -4409,
    -597,   153,    51, -2222,  -275, -4409, -4409,   513,  -276, -1215,
   -4409, -3268, -4409,    60, -4409, -4409, -4409,  -252, -1292,  1356,
   -4409,  -633, -1019,  1656,  -672, -4409,  -133, -4409,  -735,  -595,
    -593,  -681, -3444, -3448, -3892, -3481, -3180,  1361,   162, -2840,
   -2925,   166,   484, -4409,   173,   185, -4409,   500,  -741, -1345,
   -4409,  -773, -4409, -4409, -4409, -2670, -4409, -4409, -4409, -4409,
      65, -4409, -4409, -4409, -4409,   554, -4409, -4409, -4409, -4409,
   -4409, -4409, -2452,  1830,  1831, -4409, -4409, -2904, -4409,  -813,
   -4409,   701, -2704,  1288, -4409, -4409, -4409,  2580, -4409, -4409,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -1473, -4409, -4409,
   -4409, -4409, -4409,   551,    85, -4409, -4409, -4409, -4409,   186,
   -4409,  1855,  1113, -4409, -4409, -4409,  -697,  -789,  -769, -4409,
   -2701, -4409, -4409, -4409, -4409,  -189, -4409, -4409, -4409, -4409,
   -4409, -4409,  -892, -4409,  1164, -2842, -4409, -4409,  1171, -4409,
   -4409, -4409, -4409, -4409,  -639,  -123,  2609, -4409,  -510,  -615,
   -4409, -4409, -4409,  -120, -4409, -4409, -4409, -4409, -4409, -4409,
    -997,   355,  -956,  -487, -4409, -4409, -4409, -4409, -2075, -4409,
   -4409, -4409, -3278, -4409,  4108,  1747,   602,   187, -4409,   -25,
      75,  3053, -1049, -2404,   478,  -308, -4409, -1668, -4409, -4409,
   -4409, -2311, -4409, -4409, -4409, -4409, -3212,   188, -4409,  3044,
   -4409, -3460, -4151, -3225, -3681, -4013, -3933, -3184, -4409, -4409,
   -1006, -4409, -4409, -4409, -1304,  2147, -1771, -4409, -1933,   537,
    1453,  -855, -2516, -3470,  -641, -2963, -4409, -4409, -3408,  -421,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -1010,  -534, -4409,
   -4409,  3564, -4409, -3997, -4409,  3528, -4409, -4409, -4409, -4409,
    2437,  2441, -4409,  2433, -4409, -4409, -1289,  1247, -4409, -4409,
   -4409, -4409, -4409,  -632,  -738, -4409, -4409, -4409,   189, -4409,
   -4409, -4409, -4409,  1987,  -829,  -651,  3431,   190, -4266, -4409,
   -4409,  -365, -4409,  2835, -4409, -4409, -4409, -4409, -4409, -4409,
   -4409, -4409, -1981, -4409, -4409, -4048, -4409, -4409, -4409, -4409,
   -4409,  2221,  2223,    64,   -18, -4409, -4409, -1175, -4409,  -508,
   -4409,  2509, -4409, -4409, -4409, -4409,  1523,   192,   586, -4409,
       3, -4409, -4409, -4409,   347, -4409, -4409, -3115,     5, -4409,
   -4409, -4409, -4409, -4033, -4409,     6,  -556,   860, -4409, -4409,
   -2538, -4409,   193,    14, -4409, -4409,     1,     2,   -39,   -42,
     -37,     4,   112,  2904, -4409,  2959, -4409,    -4,  1798, -4409,
   -4409,  -734,  -143, -4409,  1535,  -585,  2202,  2897,  2896, -4409,
    1530, -4409, -4409,  1532, -4409,   894,  -539,  -420, -4409, -4409,
   -4409, -4409,   378,  -580,  2215, -4409,  2898, -4409, -4409, -4409,
   -1665,  1531, -3107,   932, -3118, -3063,   423,   411, -1230,  -216,
      28,  -689,  2903, -4409, -4409,   944,  -388, -4409, -4409,  -385,
   -2547,   889, -4409, -3995, -2092,    57,  2618,  -952, -4409, -4409,
    -903, 12306, -4409, -4409, -4409, 13536, 13579, -4409, -4409, 14236,
   14875, -4409,  -801,  1141, 15532, 12284,  -924, -1624,   117, 12430,
   -2250, -1218, -2296, -4409, -3241, -2289, -4409, -4409, -4409,  -177,
     998,   171, -4409, -4409, -4409, -4409,    27, -4409,  -514, -4409,
    -512, -4409, -4409, -4409,  -497, -4408,  2413, -4409, -4409, -4409,
    -193, -4409, 15832,  1573, -4409,  -986, -2476, -2490, -3122, -1635,
   -4409, -4409, -4409, -4409, -4409, -4409, -4409, -2768, -2996,  -589,
    1641, -4409, -4409,  1733, -4409, -4409, -4409, -1203,  -759, -2393,
    1648, -1840, -4409,  -745, -4409,  -685,  2415,  -701, 10406, -1252,
    6737,  -468, -2049, -1143, -1412, -4409,  -170, -4409,    30,   -16,
      -9,  -111,    48,  -509,  3380,  6070,  -587, -1208,  8501, 10897,
   12009, -2832
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -2390
static const yytype_int16 yytable[] =
{
     597,   176,   177,   171,   181,   172,   174,   968,   845,   676,
     705,   753,   664,   549,  1618,  1227,  1663,   795,   664,  1628,
    1941,   537,   177,  2421,   181,  1301,   814,  1622,   587,  1223,
     937,  1295,  1463,  1086,  1087,  1088,   763,  1304,  2032,  1092,
     739,  2617,   966,  1591,  1433,  1524,  1926,  1063,  2974,  1475,
    1257,   663,   752,  1931,  1393,  3132,  1545,   663,  1614,  2683,
    2685,  2095,  1505,   579,  2221,  1683,  1719,  3545,  1656,  1965,
    2128,   736,  1241,  2308,  1597,  3284,  2994,  3616,  1029,  2103,
    1581,  1582,   628,  2176,   638,  1512,  2113,   922,  3390,  1517,
    1590,  3586,  2485,   851,  1521,  3373,  2843,   670,  3851,  2638,
    1926,  1931,  1944,  1528,   868,  2904,  1034,  3407,    67,  3409,
     706,  3746,  3816,  1547,  3850,  1428,  1569,  1049,  4059,  3523,
    3113,  3886,  3517,  3845,  3277,  1057,  3571,  4012,  1427,  3517,
    2190,  2191,   968,  3314,  1442,   976,  3275,  3276,  1046,   765,
    4051,  4068,  4062,  1468,   766,  4052,  2326,  2548,   757,  3792,
    2622,  2186,  3217,    76,  3775,  3599,  2102,   699,  2088,  4341,
    2942,   751,    77,  3320,   733,  2005,    78,  1234,  2946,   725,
    2948,  4209,  1363,    79,  3583,  2391,  4417,  1288,  4419,  1464,
    1578,  1579,  1291,   764,   593,    80,   104,   124,   129,   147,
     151,  1589,   169,   175,  1774,  4466,  4459,  3829, -2150, -2056,
    3714,  4563,  1570,  3790,  1544, -1678,  1767, -2056, -2056,  2114,
    1602, -2083,   547,  1570, -2185, -2206,   646, -2234,  4492,  4493,
     646,  2682,  4640,  1780,  2987,  1339, -2057, -1678,   593,  4485,
     873,  1570,  2202,  1570, -2057, -2057,  2197,  1068,   862,  1116,
    3130,  1581,  1582,  2926,  2105,   819,   588,  2105,  2556,  1597,
   -2389, -1645,   852,  1782,  3605, -1673,  1330,  3558, -2389, -2389,
    1590,  2610, -1678,   869,  1599,  3171,  3172,  3150,  1704,  1416,
    3191,  2556,   593,  4682,  1570, -1658,  2305,  2761,  1243,   811,
   -1685,  2761,  1500, -1916,  3319, -2153, -2028,   593,  1231,  1665,
   -1916,   593,   593,  4216,   646, -2027,  3369, -1688,  2105,  3174,
    2460,  2261,  1636,  2732,  4514,  2105,  2418,  3221,  3222,  2950,
    1646,  1072, -1673,  3947,  3268,  3374,  1654,  1417,   593,  4191,
    2687,  3270,   874,  1083,  3079,  4782,  3081,  1932,  2831,  1340,
    1472,  3551,  1578,  1579, -1688,   711,  1391, -2205,  4343,   646,
    1278,   646,  2591,   646,  -821,  3559,  1824,  1391,   593,  2592,
    4344,  2762,   646,  3121,   767,  2762,   652,  4527,  1589,  2034,
    1331,  2035,  2658,   875,  1491,   545,  4207,  3268,  3539,   652,
    4744,   845,   652,   652,  3270,   652,     3,     4,   653,  4845,
     917,  2763,  4605,  -131,  3273,  2274,  4465,  2035,  -131,   742,
    2747,   653,  1090,  2719,   653,   653,  1774,   653,  1418,  4102,
    3689,  4104,  1774,  1592,  1658,  4528,  2137,  1659,  2707,  2105,
   -1935,   646,  1475,  4529,   876,  2764,  3117, -1935,  2106,   845,
    4774,   542,  1593,  4601,  3560,  1780,  3316,  3122,   971,  3715,
     712,  1780,  4745,   768,  1768,  1279,  2416,  2306,  1020,  4636,
    2422,  4530,  2424,   652,  3174,  2427,  1419,  2720,  1420,  4212,
    4554,   931,  1825,  1508,   184,  1782,   940,  2659,  2175,  1571,
    1308,  1782,  1814,   968,  3174,   653,  1828,   950,  3948,  2105,
    1571,  1840,  1840,  1091,  2038,   968,  2105,  4897,  2184,  4362,
    2229,  2233,  3552,   927,  1084,  3457,  2708,  1422,  1571,  2115,
    1571,  1473,  4783,  1244,  2275,  1740,  3887,   185,  1651,   589,
    2116,  4757,  2117,  1258,  1620,  1259,  1332,  2688,  4345,  2765,
    2689,  4192,  -388,  2765,  4658,  4531,  2179,  2832,  3374,  1400,
     594,  1629,  2036,  2482,  2951,  4625,  4626,  1424,  3370,   914,
    2519,  1571,   968,  1017,  1809,  1091,  1091,  2419,  2537,   812,
    1333,   990,  1705,   800,   802,  2770,  1484,   806,  2838,   808,
    2487,   590, -2205,  2927,  1933,  1452,  1667,  3316,  2118,  1245,
    3561,  1453,  4868,  1826,  2203,  1931,  1426,  1723,  2557,   866,
    1334,  2554,  1112,  1474,  2076,  3900,  2248,  2249,   967,   597,
    4217,  1701,  2082,  2733,  3606,  3517,   591,  2172,   592,  2174,
    1620,  3237,  1711,  2307,  2341,   753,  2198,  1341,  1603,  3877,
    4753,  1598,  4307, -1916,  4342,  1576,  3904,  1720,  4732,   912,
     932,  1931,  1653,  2255,    50,   932,  3118,  2074, -2205,  1509,
    1064,  2181,  1296,  4134,  2224,  3562,   932,  1576,  4832,  1801,
    1620, -2205,  3660,  1335,   769,   177,   752,   181,  1065,  3540,
    1070,  3855,  1074,  2162, -2056,  2220,  2165,  2166,  1078,   968,
   -1678, -2150,   658,   659,  3792,  2395,  3061,   968,   968,  1454,
    4358,  1001,  2593,  2409, -2083,  1098,  3338, -2185, -2206,  2143,
   -2234, -2057, -1678,  4058,  4159,  1081,  4039,   663,  4163,   663,
     743,   663,  1001,  1056,  1822,  4027,  4532,   663,  1079,  1080,
    2436,  1117,  2417,  4108,  4363, -2389,  1580,  1705,  1059,  1224,
   -1673,  2428,  1233,   967,  1235,   845,  1094,  4810,  4153,  1592,
    1976,  2363,   765,  1479,  2230,  1977,  2154,   766,  4196,  4815,
    1584,  2157,  4795,  2091,  1486, -1685,   658,   659,  1593,  1253,
   -1935, -2028,  1770,  1254,  3189,  3618,  1812,  2625, -2153,  2481,
   -2027,  2484,  1594,   928,  1253,  1509,  1592,  2491,  1254,  3322,
    2745,  3323,  1260,  2505,  2506,  2507,   764,   176,   177,   171,
     181,   172,   174,  2523,  2525,  1593,  2039,  1094,  2535,  4621,
    2185,   658,   659,   658,  1392,   658,   659,  3458,  4860,  1596,
    2647,  4758,  4818,  2771,   658,  1392,  2344,  2345,  1559,  1810,
    3567,  3809,  4281,  1018,  1408,  4775,  4451,  1299,  1926,  4805,
    2966,   593,  2495,  4461,   593,  1455,  1485,  1263,  3837,  2437,
     544,  3583,  3119,  1951,  3619,  1409,  2413,  3889,  4375,  3998,
    -131,  -131,  4376,  4377,  2040,  4378,  1796,  1797,  1798,  1799,
    1800,  1801, -2025,  2337,  1798,  1799,  1800,  1801,  2821,  1456,
    1345,  2617,  2617,  2617,   593, -1645,  1230,  1284,  2316,  4616,
    1238,   760,  2839,  1563,  3491,  3590,  2665,   663,  3430,  1270,
    4553,  3495,  3496,  2697,    67,  3499,  4043,  4573,  2150,  1457,
     593,  4484,  3504,  2316,  3184,  3185,  3186,  3187,  3188,  3189,
    3667,   673,  2367,  4043,  4831,  2787,  2371,  3385,  2822,  3497,
    3498,  2088,  2377,  2378,  2850,  4635,  3186,  3187,  3188,  3189,
    2040,  2598,  2801,  2496,  1952,  1564,  2299,  2889,   920,    76,
    1605,  1323,   923,  2890,  4405,  2394,  1286,  3827,    77,  2828,
   -1645,  2319,    78,  2026,  1313,  3694,  3695,  3696,  3697,    79,
     948,  3702,  3703,  3704,  3705,  3706,  3707,  3708,  3709,  3710,
    3711,    80,   104,   124,   129,   147,   151,  1482,   169,   175,
    3620,  3851,  3386,   760,  4074,   958,   758,  2016,  2802,  3890,
     684,  2851,  3431,  3268,  3851,  3268,  2967,  1497,  2176,  4819,
    3270,  2497,  3270,  2705,  2823,   685,  1507,  1323,  1606,  3525,
    3850,   699,  1437,  2026,  2576,  2300,  2414,  3750,  3751,  1620,
    2438,  2083,  1605,  4383,  2425,  2426,  2028,  1565,  4617,  1540,
    2027,  1314,  3287,  2761,  4847,  4585,  1768,  3317,   873,  2439,
    2746,  2891,  3120,  1620,  2029,  3621,  3911,   759,  2415,  1541,
    3668,  3514,  1253,  3033,  3528,  4574,  1254,  1562,  3514,   593,
    2498,  2599,  4462,  2499,   967,  2041,  1591,  1607,  4406,  4820,
    1608,  3281,  2690,  3268,  2317,  2933,   967,  1566,  2127,  2968,
    3270,  1315,   677,  4409,  1447,   686,  2028,  2964,  4413,  4659,
    1606,  4415,  4044,  4821,  4865,  4008,   177,  3891,   181,  4326,
    3892,   685,  1063,  4690,  2029, -1645,    39,  2762,  2084,  4771,
    1707,  1669,  4676,  1671,   760,  1673,  3391,  1675,  3447,  1677,
    1678,  1679,   663,  2376,  1448,  4697,  1681,  -610,  2855,  2343,
     874,  4687,  4695,   967,  3612,  3616,  4688,  2339,  3432,    43,
    2368,  3851,   184,  2577,  4097,  2042,  3912,   959,  2578,  1607,
    4337,  1536,  1608,  2381,  2432,  2824,  2500,  4518,  1773,  1728,
    1567,  1774,  2774,  1609,  4848, -2390, -2390, -2390,  2390,  3839,
     683,   875,  3433,  3802,  1316,  4202,  2030,  2263,  1737,    47,
    2401,   686,  4664,   753,  2579,   185,  1708,  2892,  2389,  4305,
    1780,  1537,    48,  1816,  3532,  2127,  1781,  3104,  4333,  1542,
    2280,   960,  3434,  2301,  1638,  2856,  1954,   961,  1769,  1753,
     632,  4230,  3698,    49,  3699,  1832,  2302,  1771,  1398,  1399,
    1782,  2893,   876,  2015,  1765,  4586,   687,  2666,  2633,  4660,
      14,  1813,  3533,  4009,  4866,  2433,  2030,   710,   761,   845,
    1648,  3913,  2511,  1955,  1639,  1609,  3534,  3782,  4312,  2775,
     967,  2894,  1381,  1830,  1831,  1833,  2857,  1817,   967,   967,
    2501,  1649,    19,   688,   689,  2765,  4619,  1610,  1945,  1946,
    4776,  1950,  1240,   766,   766,  2281,   766,  1937,  2031,  1449,
   -1645,  1069,  1071,  1073,   734,   873,  1075,  1076,  1077, -1645,
    4580,  1580, -1645,  1308,  3916, -1645,  1082,  4665,  1499,   663,
    3392,  4622,  3065,  2657,   663,   663,  2654,  2655,  4005,  2580,
    2858,  4628,   764,   764,  4689,   764,  1320,  3783,  1321,  4781,
    1522,  1523,   687,  4195,  4830,  1783,  3393,  2519,  2519,  4833,
    1784,  2898,  2519,  2451,  3535,  3700,  2237,  4597,  2031,  3840,
    1957,  1556,  3809,  2044,  2915,  3701,  1538,  3784,  4182,  1610,
    1453,  4175,   690,  2045,  3455,  1299,  4313,  1339,  3207,   688,
     689,  3066,  3785,  3817,  3214,  4666,  1787,   745,  1611,  2519,
    2519,  3841,  3786,  1450,  2148,  2167,  2238,   874,  4006,  4405,
    4875,   756,  4638,  3361,  3051,  3068,  4643,  4644,  4094,  3902,
    3076,  3015,  3842,  2855,  3917,  1958,  3082,  3787,  2167,  1640,
    2899,  2786,  2859,  3077,  3851,  2643,  1313,   663,  1954,   755,
    1789,  1624,  1626,  2980,  1620,   663,  4410,  4557,   875,  3456,
    4729,  2871,  3818,  3362,    31,  4558,  4470,   770,  2336,  2874,
    2900,  2876,  2999,  3000,  3001,  3002,  3517,  2069,  2149,  4548,
    1539,  4901,  4007,  2953,  3007,  1955,  2180,   707,  1454,  3975,
    2870,    39,  1080,  4541,  3903,  3978,  3979,  1609,  3981,  2120,
     652,  1340,   968,  2869,   845,  2020,  4112,  3656,  4113,   876,
    2856,  4736,  4737,  1774,  3788,  2021,   663,  2366, -1459,   663,
     663,  1609,   653,  1314,    43,  2882,  2644,  2147,  3333,  3290,
   -1459,  1791,  2022,  1641,  1284, -1459,  2046,  2183,  1956,  1285,
    2564,  1413,  2565,  3226,  2168,  3227,  2169,  3384,  3834,  3858,
    2715,  3049,  2860,  2921,  3514,  3268,  2251,  4038,   807,  3268,
    2861,  2857,  3270,  2862,    47,  2566,  3270,  2168,  3228,  2169,
    2047,  2239,  1782,  1315,   827,  1414,   184,    48,  2208, -1459,
    2617,  2901,  1957,  3680,  1323,   561,  2289,   663, -1459,  1323,
    1284,   814,  1443,  4491,  4411,  2176,  2751,  2235,    49, -1459,
   -1459,  3173,  3858,  1286,  -984, -1459,  1381,  2225,  3851,   864,
    2981,  2902,    50,  3201,  2702,  2858,  1430,  4213,  3363,   185,
      39,  4559,  2241,   845,  1792,  3859,  1444, -2390, -2390, -2390,
    1445,  1796,  1797,  1798,  1799,  1800,  1801,  1958, -1459,  4114,
    2895,  2264,  1287,   563,  4661,  3224, -1459,  2430,  2279, -1459,
    1431,   872,  2292,    43,  2236,  1305,  1446,  4299,  2783,  1286,
    4078,  3459,  4079,  2567,  2208,  2240,  1316,  2023,  2568, -1459,
    2803,  3229,  4516,  2569,  2896,  2214,  3230,  3054,  3859,  3417,
    3860,  4214,  3861,  3250,  2342,  3659,  1620,  4300,  2330,  1306,
    3649,  4857,  3418,    47,  2350,    39,  2351,  1405,  1287,  3075,
    4488,  2338,  4678,  2356,  2897,  4694,    48,  2859, -1459,  2215,
    4469,  2362,  3364,  1001,  3084,  1317, -1459,  3086,  3087,  1307,
    3106,  4489,  3090,  3091,  3660,  2352,  2804,    49,    43,  3095,
     177,   858,   181,  3860,  2719,  3861,  4681,  1668,  2369,  2640,
    1670,    50,  1672,  4705,  1674,  4542,  1676,  2982,  4495,  1318,
    1680,  1432,  2403,    34,  2404,  2853,  2405,   859,  2406,  3027,
    2407,  4374,  1310,  2457,  2408,  4572,  2208,  1244,    47,  2386,
   -1459,  3344,  1001,  1999,   561,  3591,  4543,  4316,  3595,  1319,
    3782,  2450,   177,  2447,   181,  2448,  2449,    34,  3341,   571,
    2983,   572,  2504,  1059,  3321,  3134,  1311,  2105,   951,  2570,
    2690,  1774,  3231,  2441,  3616,  2122,  2112,  2000,  1320,  2571,
    1321,  3360,  3232,  1462,   968,  1525,    50,  2860,  1509,  4294,
    4317,  4712,  2261, -2047,  4295,  2861,  1312,  -153,  2862,   952,
    1780,  4629,   563,  1245,  4632,  2493,  2494,  2001,   661,   805,
   -1459,  -517,  2508,  2509,   661,  2863,  1112, -2047,  4713,  3045,
    3783,    34,  2277,  -153,  1587,  1588,  2562,  2363,  1322,  2479,
    1782,   953,  2456,  3783,  3427,  4447,  4315,  4449,  4296,   828,
    2547,  2309,  2192,  2193,  2194,  2195,   968,  1462,  1125,   554,
    3784,  3174,   561,  2626,  4568,  3175,  3176,  3177,  4220,  4221,
       3,     4,  4336,  3784,  4780,  3785,   951,  4324,  3428,  2863,
    1253,  2549,  3739,  1274,  1254,  3786,  1713,   954,  4165,  1714,
      39,  3094,  1253,  2216,  2231,  2232,  1254,  1236,  3786,  1935,
     916,  3655,  1936,  2244,  1840,  2217,  2129,   952,  3429,  3268,
    3787,  4380,  1408,  2258,  3268,   919,  3270,   845,  1820,  3268,
     563,  3270,  3268,    43,   921,  2109,  3270,  2110,   632,  3270,
    2218,  2739,  3004,  1409,  3352,  3282,  1408,  3005,   814,  3569,
     561,  2294,  2295,  2296,  2297,  1592,  3268,  4488,    14,  4277,
    1408,  4278,  4279,  3270,  4704,  4280,  3525,  1409,   571,  3268,
     572,  -978,  3526,    47,  1593,   924,  3270,  3949,  4489, -1495,
    3965,  1409,  4867,  3527, -1495,  4488,    48,  4739,  1594,  2541,
      19,  3856,  2544,  2111,   577,   954,  2640,  3788,  3950,  3200,
    3966,  3202,  3203,  1592,  2649,   938,  4489,    49,   563,  -411,
    3788,  3528,   946,  3529,  2173,  3375,  2129,  2519,  2519,  2519,
    2519,    50,  1593,  2519,  2519,  2519,  2519,  2519,  2519,  2519,
    2519,  2519,  2519,  3285,  3146,  1938,  1596,  3395,  1939,  2398,
    2668,   177,  2129,   663,  3572,  2782,  2380,  3347, -1495,  2383,
    3724,  2995,   218,  3581,  -516,  2130,  2709,   546,  2712,  2388,
    1263,  3179,  3726,   967,  4892,   630,  3147,  4291,  2396,  4293,
    2706,  3148,  3524,  4297,  2482,  4298,   571,  3005,   572,  2519,
    2519,  2397,  2131,   708,  2398,  3326,  2617, -1495,   955,  3530,
    1580,  2617,  2006,  4807,  1253,   956, -2028,  2617,  1254,  3235,
     968,  3378,  1525,   957,  2854,  2132,  3836,  2133,  1016,   663,
    2694,  1580,  1024,  2006,  2187,  2698,  3268,  1025,  -411,  2701,
    3180,  1030,  3399,  3270,  3401,  2410,   973,  4728,  2411,  1235,
     929,  2412,   930,  3986,  2411,  1041,  2444,  3888,  3893,  2445,
    2127,   933,  3670,   934,  1050,  2725,  3531,  3878, -1519, -1519,
    2639,  3532,    31,  2640,   571,  2130,   572,  2780,  2918,  2769,
    2781,  2332,  2845,  2333,  2955,  2846,   574,  2956,  2959,  3423,
    3052,  2960,  2743,  2398,  1054,  3987,  2482,   576,  3268,    39,
    1525,  2130,  2131,  3098,  2758,  3270,  2411,  2776,  3541,  3533,
    1085,  4579,  3905,  3675,  3630,  3631,   646,  2559,  3145, -1458,
    3988,  2398,  1093,  3534,   932,  2132,  3154,  2133,  2131,  2398,
     968, -1458,    43,   758,  3160,  3989, -1458,  2398,  4888,  3990,
    3161,  2788,  1580,  2398,  1308, -1496,  4834,    28,  3477,  1089,
   -1496,  2132,  2819,  2133,  3484,  3162,  3279,  3280,  2398,  3991,
    2127,  1096,  3992,  3193,  3691,  3351,  2398,  3206,  3211,  4061,
    2398,  3212,    47,  1099,   663,  3993,   633,  1101,  3330,  3331,
   -1458,  4496,   663,   932,   663,    48,  2127,  2865,  2828,  3410,
    3901,  2935,  3411,  3415,   759,  1727,  3416,    50,  3720,  2935,
   -1458,  3603,  1102,  1103,  3604,  2877,    49,  2935,  1109,  2935,
    3628,  3535,  3721,  2398, -1496,  3722,  2887,  3181,  3182,  3183,
     634,  3184,  3185,  3186,  3187,  3188,  3189,  1112,  3731,  2911,
      39,  3732,  3742,   829,  1111,  2398,  4855,   932,  1110, -1458,
     830,   831,   832,  3762,  1115,  1113,  3825, -1458,  2129,  3826,
    1119,  4537,  3830, -1496,  3994,  3831,  2129,  2998,  1118,  1121,
    3673,   760,  3995,    43,  3835,  3857,  4877,  2689,  2411,  4040,
    1114,  1242,  2411,  3135,  3268,  4049,  4354, -2297,  3985,  3139,
    3033,  3270,  3020,  4091,  3021,  3514,  1705,  3028,  4109,  4135,
    2519,  2398,  2445,  3626,  2958,   967,  3016,   177,  3996,  3268,
    1246,  3853,  3854,    47,  1239,  4147,  3270,  4804,  2398,  4198,
    4204,  2996,  2689,  4205,  4210,  4211,    48,  2411,  2411,  1247,
    3637,  3638,  3442,  3640,  4284,  3642,  3643,  4285,  4338,  1248,
    4385,  4339,  3450,  4386,  4907,  1252,  3557,    49,  3650,  4387,
    4395,  4467,  2398,  2445,  4468,  4538,  2213,  3676,  2411,  4565,
    4581,  4835,  4566,  2445,  2772,  4589,  1264,   967,  4590,   968,
     845,   968,  1271,  3060,  3062, -2297,  4594,  1272,  1297,  2640,
    3071, -1458,  4600,  1274,  4602,  3579,  3671,  3579,  1275,  1282,
    4085,  4086,  4087,  4614,  1298,   761,  4615,  2130,  2741,  2742,
    4655,  1302,  3874,  4656,  3542,  2130,  3544,  2753,  2363,  2755,
    1308,  4564,  1125,  2759,  4677,  3174,  3663,  1819,  1338,  3175,
    3176,  3177,  4696, -2297,  2131,  4615,  4706,  1367,  1343,  2445,
    3271,  4707,  2131,  1365,  3212, -2297,  3740,  1369,  2129,   968,
   -2297,  4708,  3295,   663,  2398, -2297,  1475,  2132,  4718,  2133,
   -2297,  2640,  1580, -2297,  2006,  2132, -2297,  2133,  3251,  4721,
    3252,  3550,  3579,  3553,  3067,  3069,  3070,  3111,   753,  4743,
    1370,  1400,  2445,  3268,  3609,  4749,  2129,  3253,  2445,  3254,
    3270,  1402,  2127,  3271, -2297,  4750,  1403,  1404,  2445,  3125,
    2127,  1405,  3124,  4765,  1407,  3294,  4766,  3111,  4796,  4797,
    1412,  2640,  2398,  3798, -2297,  4798,  1415,  4800,  2398,  1765,
    2398,  4851,   753,  3136,  3579,  2872,  4854,  4876,  1438,  4608,
    4615,  2463,  1773,  4890,  3142,  1774,  4891,  4916,  1439,  1451,
    4891,  3803,  3804,  3805,  1460,  3999,  2840,  4000,  4893,  4336,
    4894,    28,  1274, -2297, -1447, -2297,  4164,  1281,  4167,  1283,
    1461, -2297,  2129,  1765,  1780,  1465,  1773,  1470,  1471,  1774,
   -2390,  1476,  1478,  1775,  1776,  1777,  1480,  1483,  2464,  1487,
    2562,  2932,  1488,  1494,  3454,  1495,  1498,  2130,  1501,  2941,
    1778,  2943,  1503,  1506,  1782,  1931,  3244,  2945,  1780,  1513,
    3256,  3257,  3258,  1516,  1781,  1509,  1518,  1527,  1529,  2465,
   -2297,   967,  3262,  1530,  2131,  3179,  -173,  1532,  1534,  1546,
    1548,  3669,  1555,  1557,  2482,  2130,  2129,   753,  1782,  1561,
    2466,  4511,   203,  1568,    39,  1573,  1575,  2132,  1574,  2133,
    1576,  2467,  2450,   177,  2447,   181,  2448,  2449,  1583,  1586,
    1580,  1584,  2131,  1600,  1617,  3286,  1616,   663,  3223,   677,
    3460,  2468,  1619,  1620,  1627,  3262,  2469,    43,   752,  1630,
    1631,  3017,  2127,  3970,  3180,  2132,  1632,  2133,  1633,  1634,
    1635,  2129,   835,   836,   837, -2297,   838,   839,   840,   841,
     842,   843,  1637,  1642,  4265,  4266,  1643,  4268,  1644, -2390,
    1645,  2130,  1647,  1652, -2390,  1657,  1682,    47,  1710, -2297,
    2127, -2297, -2297,  1715,  2470,  1725,  1717,  1724,  1718, -1649,
      48,   967, -1656,  4071,  3488,  1732,  1733,  3078,  2131,  3080,
    1734, -1646,  1735,  1783,  1736,  2471,  4119,    50,  1784,  3327,
   -2390,    49,  1738,  1739,  1740, -2297, -1647, -1650, -2297, -2297,
   -2297,  2132,  1741,  2133,  1742,    50, -1228,  1743, -1228,  1785,
    1786,  3295,  1745,  1746, -1648,  2130,  1747,  1748,  3295,  1749,
    1750,  1807,  1751,  1752,  1787,  1754,  1805,  1755,  1756,  3879,
    1757,  1758,  3349,  4130,  1789,  1759,  2127,  1760,  1761,  1809,
    1823,  1835,  2131,  1843,  1810,  4354,   203,  3353,  1819,  1943,
    1285,  3413,  1972,  1287,  1974,  1788,  1983,  2002,  2003,  2004,
    2006,  2007,  2008,  2009,  3365,  2132,  2010,  2133,  1789,  2011,
    2130,  1790,  2012,  2472,  2018,  2037,  2043,  2049,  2071,  2077,
    2473,  2075,  2129,  2078,  2079,  3144,  2474,  2080,  2081,  2097,
    2096,  2108,  2098,  3448,  2120,  2121,  2123,  2131,  2124,  2126,
    2127,  3181,  3182,  3183,  2125,  3184,  3185,  3186,  3187,  3188,
    3189,  2127,  2135,  2136,  2138, -2390,  2139,  2144,  2475,  2140,
    2132,  2476,  2133,  2153,  2145,  2163,  2170,  2155,  2159,  1125,
    2160,  2182,  3174,  3419,  4088,  2171,  3175,  3176,  3177,  2477,
    2177,  3480,  2178,  2519,  1381,  3438,  2199,  2200,  2188,  1791,
    4077,  3435,  4388,  3437,  2189,  2127,  2201,  2205,  4080,  4081,
    4082,  4083,  2204,  2935,  2478,  2209,  2212,  2227,  2226,  1125,
    2935,  2935,  3174,  2234,  2935,  2242,  3175,  3176,  3177,  2228,
    3906,  2935,  2243,  1125,  2245,   814,  3174,  2246,  3516,  4288,
    3175,  3176,  3177,  4137,  2257,  3516,  2256,  2262,  2265,  2266,
     967,  2269,   967,   556,  2278,  1432,  1773,  4138, -2390,  1774,
    2293,  2270,  3478,  2273,  2298,  1796,  1797,  1798,  1799,  1800,
    1801,  2130,  3489,  2311,  2314,  2315,  2327,  2329,  2323,  2331,
    2335,  2346,  2340,  2348,   663,  2349,  2353,  3492,  1780,  2354,
    3577,   663,  1792,  2355, -2390,  1793,  1794,  1795,  2131,  1796,
    1797,  1798,  1799,  1800,  1801,  2370,  2357,  4321,  2358,  2359,
    2360,  2361,  3165,  3554,  2372,  2374,  2373,  2392,  1782,  3608,
     967,  2132,  2375,  2133,  2393,  2429,  1773,  3598,   177,  1774,
    2423,  2442,  1371,  1775,  1776,  1777,  2459,  2492,  1372,  2487,
    2536,  2542,  4023,  4024,  1774,  2555,  2561,  4049,  2546,  3625,
     177,  3178,  2573,  2575,  2595,  4028,  2127,  2596,  1780,  2610,
    2624,  2627,  2628,  2631,  1781,  2632,  2641,   759,  2651,  2642,
    2652,  2650,  3179,  2663,  2669,  2678,  2788,  3985,  1373,  2653,
    2679,  2681,  3234,  2724,  2691,  3629,  2692,  2693,  1782,  3271,
    2710,  3271,  2713,  1304,  2715,  2729,  2717,  2734,  2718,  2744,
    2735,  3356,  3756,  3357,  3358,  3359,  2740,  3627,  2737,  2748,
    2756,  2757,  3179,  2760,  2773,  2778,  1236,  4843,  4844,  1240,
    2792,  2835,  2805, -2390,  2830,  2836,  3179,  4218, -2390,  1374,
    2847,  3180,  2844,  2849,  2848,  2864,  1375,  2903,  4188,  1376,
    2906,  2208,  2924,  1094,  2925,  2917,  2928,  2929,  2930,  2938,
    2936,  2937,  2939,  2940,  2947,  4593,  3658,  2949,  2944,  4236,
    4237,  2954,  2961,  2519, -2390,  2972,  4593,  2986,  2990,  3271,
     663,  3180,  2997,  2988,  3003,  3006,  3011,  3013,  3014,  3025,
    3026,  3672,  3023,  3029,  3012,  3180,  3030,  3043,  3044,  3050,
    3046,  3047,  3055,  1783,  3048,  1377,  1609,  3053,  1784,  3072,
    3058,  3056,  3059,  3737,   753,  3064,  3057,  3074,  1789,  3073,
    3684,  3088,  4290,  3083,  3085,  3089,  3093,  3092,  3097,  1785,
    1786,  3103,   753,  3100,  3295,  3101,  3102,  3112,  2460,  2640,
    1653,  3693,  4274,  4275,  1787,  3114,  3105,  3115,  3116,  3123,
    3131,  4500,  4651,  4914,  4915,  1765,  1091,  3764,  3765,  3766,
    3767,  3126,  1378,  3133,  1379,  3137,  3716,  3138,  3140,  1773,
    3141,  3771,  1774,  3774,  1380,  1788,  3143,  3156,  3157,  3158,
    3159,  3163,  1381,  3164,  3208,  2398,  4506,  4508,  1789,  3166,
    3170,  4186,  1382,  3169,  3192, -1908,  3493,  3220,  3198, -2390,
    1708,  1780,  3205,  3219,  3225,  3233,  3301, -2390,  1773,  3242,
    3243,  1774,  3247,  3245,  3303,  1775,  1776,  1777,  3181,  3182,
    3183,  3246,  3184,  3185,  3186,  3187,  3188,  3189,  3249,  1384,
    1385,  1782,  1778,  3278,  3273,  3305,  3307,  3311,  3318,  3297,
    1780,  3324,  3334,  3332,  3335,  3339,  1781,  3340,  3343,  4367,
    3346,  3348,  4368,  4369,  4719,  3371,  1386,  3382,  3181,  3182,
    3183,  3355,  3184,  3185,  3186,  3187,  3188,  3189,  4373,  1791,
    1782,  3372,  3181,  3182,  3183,  3383,  3184,  3185,  3186,  3187,
    3188,  3189,  3387,  4227,  3398,  3397,  3388,  3400,  4308,  3406,
    3414,  3441, -2390,  3443,  3445, -2299,  3446,  3449,  3451,  1796,
    1797,  1798,  1799,  1800,  1801,  3452,  3453,  3463,   968,  3461,
    4583,  3516,   672,  3462,   674,  3464,  3465,  3468,   680,  1387,
    3471,  3466,  3473,   694,   702,   672,  3475,   709,  3479,  3875,
     702,   702,  3467,   738,  3483,   741, -2390,  3469,  3470,  4261,
    3932, -2390,  3481,  3933,  3472,  3934,  3931,  2197,  3644,  1767,
    3645,  4421,  3494,  3474,  3647,  4497,  3476,   663,  4436,  4446,
    3485,  3487,  1792,  3500,  3501,  1793,  1794,  1795,  3503,  1796,
    1797,  1798,  1799,  1800,  1801,  1783,  4642, -2390,  3555,  4639,
    1784,  3506,  3518, -2299,  1125,   663,  3521,  3174,  2935,  3564,
    3548, -2390, -2390, -2390,  2935,  2935,  4657,  2935,  3566,  2251,
    3568,  1785,  1786,  4647,  3549,  4649,  1346,  3570,  3678,  3578,
    3592,  3597,  3587,  3593,  3579,  3596,  1787,  3589,  3600,  3601,
    3613,  1789,  3624,  1602,  3951,  3639,  3632,  3954,  3641,  1346,
    3651, -2299,  3652,  3635,  3653,  3662,  3654,  3664,  3665,  1347,
    3633,  3666,  3674, -2299,  3677,  3679,  3657,  1788, -2299,  1727,
    1079,  1080,  3683, -2299,  3195,  3174, -1907,  3692, -2299,  3717,
    1789, -2299,  1347,  1790, -2299,  3194,  3718,  3733,  3719,  3725,
     760,  3744,  3748,  3757,  3773,  3745,  3795,   796,   801,   801,
     804,  3763,   801,  3797,   810,  3781,   796,  3800,   738,  3810,
    3812,   847, -2299,  3814,  4060,  3820,  1348,   738,  3815,  3823,
     738,  3828, -2390,  3838,   801,  3865,   738,  4056,   177,  3867,
    3844,  4711, -2299,  3868,  3873,  3880,  3881,  3882,  3885,  1348,
    4500,  3271,  4025,  4720,  4030,  3271,  3910,  4535,  4722,  1349,
    4724,  4874,   845,  3883,  3922,  3894,  3923,  3907,  3908,  3909,
    3926,  1791,  3920,  3921,  3924,  3925,  3928,  3929,  4578,  3938,
    3939, -2299,  1349, -2299,  3946,  3962,  3964,  3889,  3967, -2299,
    3974,  3976,  3615,  3977,  1350,  3980,  3973,  4013,  4099,  4002,
    4010,  4099,  4018,  4099,  4020,  4026,  4033,  4588,  2411,  4034,
    4036,  4037,  4454,  1125,  4042,  4053,  3174,  1350,  4054,  4066,
    3175,  3176,  3177,  4874,  4067, -2390,  1351,   663,  4069,  4070,
    4072,  4075,  1796,  1797,  1798,  1799,  1800,  1801, -2299,  4073,
     968,  4089,  4874,  4084,  4093,  4095,  4111,  4096,  3111,  1351,
    4076,  4100,  4101,  4620,  1352,  4476,  3869,  3870,  3871,  3872,
    4103,  4106,  4115,  4120,  1792,  4116,  3180,  1793,  1794,  1795,
    4471,  1796,  1797,  1798,  1799,  1800,  1801,  4121,  4122,  2629,
    4123,  4128,  4124, -1909,  4143,  2630,  4156,   677,  1353,  4155,
    4160,  4158,    34,  4161,  4168,  4169,  1354,  4173,  4174,  4652,
    4176,  4177,  4179,  1355,  4197,  4180,  4181,  4187,  4194,  4201,
    1356,  4199,  4207, -2299,  4206,    34,  4215,  2089,  1357,  1354,
    4231,  4232,  4238,  3262,  4239,  4240,  1355,  3262,  4260,  4251,
    1358,  4254,  4258,  1356,  4183,  4263,  4185, -2299,  1359, -2299,
   -2299,  2090,  1708,  4264,  4269,  4276,  4861,  4301,  4302,  4309,
    4314,  4318,  4319,  1358,  4320,  4322,  4325,  4328,  4330,  4200,
    4340,  1359,  4349,  4347,  4350,  4351,  4189,   177,  4352,  4360,
    4365,  4371,  4372, -2299,  4382,  4381, -2299, -2299, -2299,  4389,
    4384,  4391,  4414,  4311,  4392,  4393,  4400,  4434,  4440,  4443,
    4394,  4407,  1360,  1773,  4418,  4448,  1774,  4460,  4464,  4494,
    4438,  4473,  4444,  4498,  4505,  4463,  3179,  4478,  4512,  4009,
    4521,  4479,  4519,  4524,  4483,  1360,  4522,  4525,  4540,  4526,
    4546,  4003,  4233,  4547,  4545,  1780,  4550,  4552,  4569,  4555,
    4556, -2390,  4567,  4584,  4571,  4587,  4570,  4591,  4596,  4608,
    4631,  4646,  4662, -2390, -2390, -2390,  4599,  3184,  3185,  3186,
    3187,  3188,  3189,  4603,  4604,  1782,  4633,  4606,  4671,  4612,
    4667,   663,  4219,   882,  4672,  3180,  4623,  4674,   738,  4679,
     796,  4685,  4691,   801,  4692,   804,  4693,   801,  4700,  4701,
    4702,  4248,  4249,  4703,   847,  4709,  4252,  4253,   943,  4271,
    4272,  4235,  4710,  4717,  4723,   801,  4245,  4730,  2935,  4727,
    2935,  2935,  4726,  4731,  2935,  4746,  4733,  4640,  4255,   967,
    4250,  4742,  4759,  4292,  4755,  4756,  4761,  4764,   796,  3749,
    4769,  4767,  4770,   804,  4777,  3271,  4778,  4779,   796,  4785,
    3271,  4786,   847,  4794,  4738,  3271,  4813,  4757,  3271,  4416,
   -2313,  4817,  3758,  4758,  4825,  4852,  4846,  4806,  4829,   801,
    4808,  4864,  4824,   845,  4885,   663,  4883,  4884,  4889,  4895,
   -2390,  4332,  3271,  4886,  4273, -2390,  4899,  4896,  4908,  4903,
    4904,  4909,  2210,  4910,  4911,  3271,  4912,  1276,  2992,  1411,
    1368,  1842,  3394,  4334,   177,  3295,  3288,  1436,  1435,  2834,
    4353,  3899,  2916,  3505,  3982,  4653,   845,  4499,   738,  4754,
    4549, -2390,  4022,  4551,  4306,  4534,  4809,  3099,  4856,   968,
    3337,   738,  4452,  1108,  4859,  4762,  4760,  4823,  4475,  3342,
    4099,  4057,  4041,  1125,  4099,  4099,  3174,  4099, -2313,  4735,
    3175,  3176,  3177,  1221,  1221,  4017,   738,   702,  2970,  2971,
    3408,   702,  3181,  3182,  3183,  1789,  3184,  3185,  3186,  3187,
    3188,  3189,  3897,  2290,  4323,   738,  4029,  2962,  3574,   738,
    4863,  4913,  4900,  4523,  3522,  1221,  4359,  3519,  4477,   814,
    4827,  2272,  4748,  4814,  4480,   679, -2313,   738,  4090,  4618,
    2684,  4063,  3325,  3111,  1702,  4698,  1712,  2455, -2313,   738,
    2453,  1042,  4837, -2313,  2454,  3482,  4902,  2635, -2313,   969,
    2636,  2017,  3262, -2313,  3292,  1249, -2313,  3262,  2402, -2313,
    3262,  4045,  1708,  4190,  4803,  1940,  3832,  3293,  3811,  2662,
    3300,  1815,  3271,  3302,  4799,  1968, -2390,  1969,  4725,  4184,
    1973,  2661,   738,  3776,  3304,  4154,  4445, -2313,  4166,  4598,
    1978,  4439,  4716,  3772,  4715,  3634,  3833,  4582,   738,  2347,
    3727,  4437,  4801,   801,   801,  4802,  4793, -2313,  3296,  3240,
    2600,  3151,  3516,  1773,  3238,  2609,  1774,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   702,   702,
       0,     0,     0,     0,  3271,     0,     0,  3111,     0,  3111,
       0,     0,     0,     0,     0,  1780, -2313,     0, -2313,     0,
    2935, -2390,     0,   796, -2313,     0,     0,     0,   663,     0,
       0,   967,     0,     0,   796,  4503, -2390,  4504,   847, -2390,
       0,  4509,  4510,     0,     0,  1782,  1796,  1797,  1798,  1799,
    1800,  1801,     0,   801,     0,     0,     0,     0,     0,     0,
       0,  3035,     0,  4267,     0,     0,     0,     0,   738,     0,
       0,     0,     0, -2313,     0,   801,   801,  4270,     0,     0,
    1346,     0,     0,  4539,   177,     0,     0,     0,     0,     0,
       0,     0,   738,   738,   738,  3180,   801,     0,   796,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3752,
    4560,   177,     0,  1347,  4673,     0,     0,     0,     0,     0,
       0,     0,   677,     0,     0,     0,     0,     0,     0,     0,
       0,  1773,     0,     0,  1774,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   753,     0, -2313,     0,
   -2390,     0,     0,     0,     0, -2390,     0,     0,  4335,     0,
       0,     0,     0,  1780,   801,   753,   801,   801,     0, -2390,
    1348,     0, -2313,     0, -2313, -2313,  3262,     0,     0,     0,
    3271,     0,     0,     0,     0,     0,     0,  1765,     0,  1773,
     845, -2390,  1774,  1782,  1221,  3035,     0,     0,     0,  1708,
       0,     0,     0,  1349,     0,  3271,  1765,     0, -2313,     0,
       0, -2313, -2313, -2313,  1346,     0,     0,     0,     0,     0,
       0,  1780,     0,     0,  1685,  1685,     0, -2390,     0,   738,
       0,   672,     0,  3036,     0,  1789,     0,  3478,  1350,     0,
       0,     0,  4654,     0,     0,     0,     0,  1347,     0,     0,
       0,  1782,  1716,     0,     0,   738,     0,  3753,  1722,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1351,  1221,  3181,  3182,  3183,  4773,  3184,  3185,  3186,  3187,
    3188,  3189,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1708,     0,     0,     0,  1708,  1708,     0, -2390,     0,
    1221,     0,     0, -2390,  1348,     0,     0,     0,  4686,   177,
       0,     0,     0,     0,     0,  4141, -2390,     0,     0,     0,
       0,     0,  4455,  4457,  4457,     0,     0,     0,  1221,  1221,
    1221,     0,  1221,  4812,     0,     0,    34,  1349,     0, -2390,
    3037,     0,     0,     0,     0,     0,     0,  1355,     0,     0,
       0,     0,  1221,     0,  1356,     0, -2390,     0,     0,     0,
       0, -2390,  2090,     0,     0,     0,     0,  3036,     0,  3271,
       0,     0,  1350,     0,  1358,   814,   814,     0,     0,     0,
       0,     0,  1359,  1789,  4699,     0,     0,     0,     0,     0,
     738,     0,     0,  1221,     0,     0,     0, -2390,     0,     0,
     967,     0,  3038,     0,  1351,     0,     0,     0,     0, -2390,
       0,     0,     0,     0,     0,     0,  1796,  1797,  1798,  1799,
    1800,  1801,  1221,     0,     0,     0,  1221,  1221,     0,     0,
       0,     0,     0,     0,     0,     0,  1360,   738,   738,  1982,
    3039,  1789,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   702,
       0,     0,     0,     0, -2390,  4561,     0,     0,     0,     0,
      34,     0,     0,     0,  1354,  1773,     0,     0,  1774,     0,
       0,  1355,  1775,  1776,  1777,     0,     0,     0,  1356,  4906,
       0,     0,     0,     0,     0,     0,  2090,   702,     0,  1778,
       0,   814,   814,     0,     0,     0,     0,  1780,  1358,     0,
     738,  2104,     0,  1781,     0,     0,  1359,   738,     0,     0,
     801,     0, -2390,     0,     0,     0,     0,     0,     0,     0,
       0,  4828,   177,     0,     0,     0,  3038,  1782,     0,  3111,
       0,     0,   847,     0,   738,  4842,   177,  4839,   181,  4840,
    4841,     0,   738,     0,     0,   738,  4882, -2390,     0,     0,
       0,     0,     0,     0,  1796,  1797,  1798,  1799,  1800,  1801,
    1360,  4624,     0,  4873,  3039,  3615,     0,     0,     0,   738,
       0,     0,     0,     0,     0,     0,     0,   801,   801,   801,
     801,   738,     0,     0,     0,     0,  4842,  4881,  4839,   181,
    4840,  4841,   702,     0,     0,   738,  4648,     0,  4650,     0,
       0,     0,     0,     0,     0, -2390,  2222,     0,   738,  4872,
       0,     0,  1796,  1797,  1798,  1799,  1800,  1801,     0,   801,
     801,     0,     0,     0,     0,  4873,     0,     0,   801,     0,
       0,     0,  1783,     0,     0,     0,     0,  1784,   801,     0,
       0,     0,     0,     0,  4873,  4842,   177,  4839,   181,  4840,
    4841,     0,     0,     0,     0,     0,     0,   738,  1785,  1786,
       0,     0,     0,     0,     0,     0,   801,   801,   801,   801,
       0,  4872,     0,  1787,     0,     0,     0,     0,   738,     0,
       0,   187,     0,     0,     0,   738,     0,     0,  2222,     0,
    4872,     0,     0,     0,     0,     0,     0,     0,   796,     0,
       0,     0,     0,     0,  1788,   804,     0,     0,     0,     0,
    1221,     0,     0,     0,     0,     0,     0,  1789,     0,     0,
    1790,     0,     0,     0,     0,     0,  4457,   188,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   189,     0,     0,     0,     0,     0,   796,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   847,     0,   190,
       0,   801,     0,     0,   801,   191,     0,     0,     0,     0,
       0,     0,     0,     0,   801,     0,     0,     0,     0,     0,
     192,     0,   801,   801,  4768,     0,     0,   738,     0,     0,
       0,   193,     0,     0,     0,     0,     0,     0,  1791,   194,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   195,  1685,     0,     0,     0,   196,     0,     0,   801,
       0,   796,   197,     0,     0,   738,   738,     0,   801,     0,
       0,     0,     0,     0,     0,   738,     0,     0,     0,   198,
       0,     0,   738,     0,     0,     0,     0,   672,   672,     0,
       0,  2462,     0,     0,     0,  1221,     0,  1221,  4816,     0,
       0,     0,  1221,  1221,   199,     0,     0,     0,  1371,  1221,
    1221,  1221,     0,     0,  1372,  1221,   847,  1221,  1221,  1221,
    1221,  1221,  1221,     0,  1221,   200,  1221,  1221,     0,     0,
    1221,  1792,     0,     0,  1793,  1794,  1795,     0,  1796,  1797,
    1798,  1799,  1800,  1801,     0,  1221,  1221,  1221,  1221,     0,
       0,  3215,   801,  1221,  1373,     0,   201,  1221,  4862,     0,
    1221,     0,     0,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,     0,  1221,     0,     0,   202,     0,     0,   738,
    1221,     0,  1221,     0,     0,     0,   203,     0,     0,   738,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1374,     0,     0,     0,     0,
       0,     0,  1375,   204,     0,  1376,     0,  1371,   205,     0,
     206,     0,     0,  1372,     0,     0,   207,     0,     0,   208,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3035,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   209,   210,     0,
    1346,   211,     0,  1373,     0,   212,     0,     0,     0,     0,
       0,  1377,     0,     0,   213,     0,     0,     0,     0,   214,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   215,     0,  1347,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   216,   738,     0,   738,     0,  1221,
       0,     0,     0,     0,  1374,     0,     0,     0,     0,     0,
       0,  1375,     0,     0,  1376,     0,     0,     0,  1378,     0,
    1379,     0,     0,     0,     0,     0,     0,     0,     0,  -127,
    1380,     0,     0,     0,   738,     0,     0,     0,  1381,     0,
    1348,  2670,     0,  2677,     0,     0,  2051,     1,  1382,     0,
       0,     0,     0,     0,     0,     0,     0,     2,     0,     3,
       4,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1377,     0,   804,  1349,     5,     0,     0,     0,     0,  2052,
       0,   672,  1383,   672,     0,  1384,  1385,     0,     0,     0,
       0,     0,  2053,     0,     6,     0,     7,     8,     0,     0,
    1221,     0,     9,  3036,    10,     0,  2054,     0,  1350,     0,
       0,   796,  1386,   801,   801,    11,     0,    12,   796,     0,
     847,     0,   801,     0,   801,     0,     0,  1378,   801,  1379,
       0,   738,     0,     0,    13,     0,     0,    14,     0,  1380,
    1351,     0,     0,     0,     0,  2055,     0,  1381,     0,    15,
     702,    16,     0,     0,     0,    17,  2056,  1382,     0,     0,
    2104,    18,     0,     0,     0,     0,     0,  2790,     0,    19,
       0,    20,     0,  2800,     0,  1387,  2057,    21,     0,     0,
     738,  2058,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1440,    22,     0,  1384,  1385,     0,     0,     0,     0,
     738,     0,     0,     0,  2842,  2842,    34,     0,    23,     0,
    1354,     0,     0,   804,     0,     0,     0,  1355,     0,     0,
       0,  1441,     0,     0,  1356,     0,  1772,     0,     0,     0,
     801,  1773,  2090,     0,  1774,     0,     0,     0,  1775,  1776,
    1777,     0,     0,     0,  1358,     0,     0,    24,    25,     0,
    2059,     0,  1359,    26,     0,  1778,     0,  2905,  1779,  2908,
    2910,     0,     0,  1780,    27,     0,     0,     0,     0,  1781,
       0,     0,  3038,     0,     0,    28,     0,     0,     0,     0,
       0,  2060,     0,     0,  1387,     0,   801,     0,     0,     0,
       0,     0,     0,  1782,   801,     0,   801,     0,     0,     0,
       0,     0,   801,     0,     0,     0,  1360,     0,     0,     0,
    3039,   203,     0,     0,    29,     0,  1221,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    30,     0,     0,     0,
    2104,    31,    32,  2842,    33,   738,     0,     0,  2993,    34,
       0,   672,     0,     0,    35,  2061,     0,    36,     0,     0,
       0,  2062,    37,     0,  2063,     0,     0,    38,    39,     0,
       0,     0,     0,     0,     0,    40,     0,  2905,     0,    41,
       0,     0,     0,     0,     0,     0,   801,  3019,     0,    42,
       0,     0,     0,  2064,     0,     0,     0,     0,     0,     0,
    2065,    43,     0,     0,     0,     0,     0,  2066,  1783,     0,
    1221,     0,     0,  1784,  2067,     0,     0,     0,     0,     0,
      44,     0,     0,     0,     0,  3063,     0,     0,     0,     0,
      45,     0,     0,     0,  1785,  1786,    46,     0,     0,  2068,
     801,    47,   801,  2842,   801,  2842,     0,     0,     0,  1787,
       0,     0,     0,     0,    48,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1221,     0,
       0,     0,     0,     0,     0,    49,     0,     0,     0,     0,
    1788,  1685,     0,     0,     0,     0,     0,     0,     0,    50,
       0,     0,  -127,  1789,     0,     0,  1790,     0,     0,     0,
    1371,     0,     0,     0,     0,     0,  1372,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1773,     0,   738,  1774,     0,     0,     0,  1775,  1776,
    1777,  1416,     0,   796,     0,     0,     0,     0,     0,   796,
       0,     0,     0,     0,     0,  1778,  1373,     0,     0,     0,
     801,     0,     0,  1780,     0,     0,     0,  1221,     0,  1781,
       0,     0,  1221,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1791,     0,     0,     0,     0,  1417,
       0,     0,     0,  1782,     0,  1221,  1221,  1221,     0,     0,
    1221,     0,     0,     0,     0,     0,     0,  1374,  1221,  1221,
    1221,  1221,  1371,     0,  1375,     0,     0,  1376,  1372,     0,
       0,  1221,     0,     0,  1221,     0,  1221,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1221,  1221,     0,
       0,  1221,     0,  1416,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   847,     0,  1221,     0,  1221,  1373,  1221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1418,     0,     0,  1377,     0,     0,     0,  1792,     0,  1221,
    1793,  1794,  1795,   738,  1796,  1797,  1798,  1799,  1800,  1801,
    3272,  1417,  1221,  1221,  1221,     0,     0,     0,  1783,  1773,
       0,     0,  1774,  1784,     0,     0,  1775,  1776,  1777,  1374,
    1221,     0,     0,     0,     0,     0,  1375,     0,  1419,  1376,
    1420,     0,  1221,  1778,  1785,  1786,     0,  1221,     0,     0,
    1421,  1780,  1379,  1221,     0,     0,     0,  1781,     0,  1787,
       0,     0,  1380,  3272,     0,     0,  3310,     0,     0,  3313,
    1381,  2677,     0,     0,     0,     0,     0,     0,     0,  1422,
    1382,  1782,     0,     0,     0,     0,     0,     0,     0,     0,
    1788,     0,  1418,  1371,     0,  1377,     0,     0,     0,  1372,
       0,     0,     0,  1789,     0,     0,  1790,     0,     0,     0,
       0,     0,     0,  1221,  1423,  2842,     0,  1384,  1385,  1424,
    1685,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1373,
    1419,     0,  1420,     0,  1425,     0,   801,  1371,   801,   801,
     801,     0,  1421,  1372,  1379,     0,     0,     0,  1426,     0,
       0,     0,     0,     0,  1380,     0,     0,     0,     0,     0,
       0,     0,  1381,     0,     0,     0,     0,     0,     0,     0,
       0,  1422,  1382,     0,  1791,     0,  1783,     0,     0,     0,
    1374,  1784,     0,  1373,     0,     0,     0,  1375,     0,     0,
    1376,     0,     0,     0,     0,     0,     0,  1387,     0,     0,
       0,     0,  1785,  1786,     0,     0,  2867,     0,     0,  1384,
    1385,  1424,     0,     0,     0,     0,     0,  1787,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1374,     0,  2868,     0,     0,   738,
       0,  1375,     0,     0,  1376,     0,  1377,     0,  1788,     0,
    1426,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1789,     0,     0,  1790,     0,     0,  1792,     0,     0,
    1793,  1794,  1795,     0,  1796,  1797,  1798,  1799,  1800,  1801,
       0,     0,     0,     0,  2545,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1387,
    1377,     0,     0,  1378,  1371,  1379,     0,     0,     0,     0,
    1372,     0,     0,     0,     0,  1380,     0,     0,     0,     0,
       0,   801,     0,  1381,     0,     0,     0,     0,  2842,  2842,
       0,     0,     0,  1382,     0,     0,     0,     0,     0,     0,
       0,     0,  1791,     0,  1773,     0,     0,  1774,     0,     0,
    1373,  1775,  1776,  1777,     0,     0,     0,  1378,     0,  1379,
       0,     0,   738,   738,     0,     0,     0,  1466,  1778,  1380,
    1384,  1385,     0,     0,     0,     0,  1780,  1381,   738,     0,
       0,     0,  1781,     0,     0,     0,     0,  1382,     0,     0,
       0,     0,     0,  1685,   738,     0,     0,  1467,     0,     0,
       0,  1374,  1685,   738,   738,     0,  1782,     0,  1375,     0,
       0,  1376,     0,     0,     0,     0,     0,     0,     0,     0,
     738,  2072,     0,     0,  1384,  1385,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1792,     0,     0,  1793,  1794,
    1795,     0,  1796,  1797,  1798,  1799,  1800,  1801,     0,     0,
    1773,  2073,  3520,  1774,     0,     0,     0,  1775,  1776,  1777,
    1387,     0,     0,     0,     0,     0,     0,  1377,     0,     0,
       0,     0,     0,   801,  1778,   801,     0,     0,     0,   801,
       0,     0,  1780,     0,     0,     0,     0,     0,  1781,     0,
       0,     0,     0,     0,     0,   796,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   738,     0,     0,     0,     0,
       0,  1783,  1782,     0,  1387,     0,  1784,     0,     0,     0,
       0,   738,     0,     0,  1378,     0,  1379,     0,     0,     0,
       0,     0,     0,   801,     0,     0,  1380,  1785,  1786,     0,
    1221,     0,     0,     0,  1381,     0,     0,     0,     0,  1221,
       0,     0,  1787,     0,  1382,  1221,     0,  1221,     0,     0,
    1221,     0,     0,     0,     0,  1221,  1221,  1221,  1221,     0,
       0,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,     0,     0,  1788,  1221,  1221,     0,     0,  2141,     0,
       0,  1384,  1385,     0,  1221,     0,  1789,     0,  1221,  1790,
       0,     0,  1221,     0,     0,     0,     0,     0,     0,     0,
    1221,     0,     0,  1221,     0,  1221,     0,  1783,  2142,     0,
       0,     0,  1784,     0,  1221,     0,     0,  1221,  1221,     0,
       0,     0,  1221,  1221,     0,     0,     0,  3760,     0,  1221,
       0,     0,     0,  1785,  1786,     0,   738,   738,   738,   796,
       0,  3272,  3780,     0,     0,     0,  3780,  3794,  1787,     0,
       0,     0,     0,  1221,     0,     0,     0,     0,     0,  1221,
    1221,  1221,     0,     0,     0,     0,     0,  1791,     0,     0,
       0,  1387,     0,     0,  1014,     0,     0,     0,     0,  1788,
       0,     0,     0,     0,     0,  1221,     0,     0,     0,     0,
       0,     0,  1789,     0,     0,  1014,  2677,     0,  1221,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3852,
    1685,  1685,     0,  2222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   801,   801,   801,   801,     0,     0,     0,     0,     0,
     586,     0,     0,     0,     0,     0,   631,     0,     0,     0,
    1792,     0,     0,  1793,  1794,  1795,   682,  1796,  1797,  1798,
    1799,  1800,  1801,  1791,     0,     0,     0,  3685,     0,     0,
    3896,     0,     0,     0,     0,   750,   750,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1773,     0,     0,  1774,     0,     0,     0,  1775,
    1776,  1777,  1371,     0,     0,     0,     0,     0,  1372,     0,
       0,     0,     0,     0,     0,     0,  1778,     0,     0,     0,
    1773,     0,     0,  1774,  1780,     0,     0,  1775,  1776,  1777,
    1781,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1778,     0,     0,     0,  1373,     0,
       0,     0,  1780,  3968,  1782,     0,  1792,     0,  1781,  1793,
    1794,  1795,     0,  1796,  1797,  1798,  1799,  1800,  1801,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1782,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   738,     0,   801,     0,  1221,  1374,
       0,     0,     0,     0,   738,     0,  1375,     0,     0,  1376,
    4016,     0,     0,     0,     0,     0,     0,     0,     0,  2104,
       0,   809,     0,     0,     0,     0,     0,     0,     0,   849,
       0,     0,   853,   854,     0,   857,     0,     0,   863,   738,
     865,     0,     0,     0,     0,     0,     0,     0,     0,  2905,
    1014,     0,     0,     0,     0,     0,     0,  4050,     0,  1783,
       0,     0,     0,     0,  1784,  1377,     0,   738,     0,     0,
    1014,  2222,     0,     0,     0,  1221,  1221,     0,     0,  1014,
       0,     0,     0,     0,     0,  1785,  1786,  1783,     0,     0,
       0,     0,  1784,     0,     0,     0,     0,     0,     0,     0,
    1787,     0,     0,     0,     0,     0,     0,     0,     0,  2842,
       0,  2842,     0,  1785,  1786,     0,     0,     0,     0,     0,
       0,   738,  1378,     0,  1379,     0,     0,     0,  1787,     0,
       0,  1788,     0,     0,  1380,     0,     0,     0,     0,     0,
       0,     0,  1381,     0,  1789,     0,     0,  1790,     0,     0,
       0,  1221,  1382,     0,     0,  1014,     0,     0,     0,  1788,
       0,     0,  1221,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1789,     0,     0,  1790,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2785,     0,     0,  1384,
    1385,     0,  1221,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1221,  1221,     0,     0,     0,     0,     0,  1221,
    1221,     0,     0,     0,  1221,     0,  1386,     0,     0,  1221,
       0,     0,  1221,  1221,     0,  1791,     0,  1221,  4146,     0,
       0,     0,     0,  1221,   738,   738,   738,   738,     0,     0,
       0,  3780,  3794,     0,  3780,     0,     0,  4157,     0,     0,
       0,  3272,     0,  1791,     0,  3272,     0,     0,     0,  1014,
       0,  4172,     0,     0,     0,     0,     0,  1221,     0,     0,
       0,     0,  1221,     0,     0,     0,     0,     0,  1221,  1387,
       0,     0,     0,     0,     0,   847,     0,     0,     0,     0,
       0,     0,     0,  1221,     0,     0,  3310,     0,     0,     0,
       0,  2677,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   672,     0,     0,  1221,  1792,     0,
       0,  1793,  1794,  1795,     0,  1796,  1797,  1798,  1799,  1800,
    1801,     0,     0,     0,     0,  3736,     0,  2842,  2842,     0,
       0,     0,     0,     0,     0,     0,  1792,     0,     0,  1793,
    1794,  1795,     0,  1796,  1797,  1798,  1799,  1800,  1801,     0,
       0,     0,  4234,  3819,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   918,     0,
       0,     0,     0,  1371,     0,     0,   926,     0,     0,  1372,
       0,     0,     0,   939,     0,     0,   944,   945,  1221,     0,
       0,   947,     0,     0,     0,     0,  1773,     0,     0,  1774,
       0,     0,   964,  1775,  1776,  1777,     0,     0,   801,     0,
       0,     0,     0,     0,     0,     0,   972,     0,     0,  1373,
    1778,     0,   801,     0,     0,     0,     0,     0,  1780,     0,
       0,  1032,     0,  1036,  1781,     0,  1038,     0,  1040,     0,
       0,  1044,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1998,     0,     0,     0,     0,     0,  1782,     0,
       0,     0,  1221,     0,     0,     0,     0,     0,     0,     0,
    1374,     0,     0,   796,     0,     0,     0,  1375,  2104,     0,
    1376,     0,     0,     0,     0,     0,  1685,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   801,  3019,     0,     0,     0,     0,  1107,
       0,     0,     0,     0,     0,  1998,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   738,     0,     0,     0,  1377,     0,  1773,     0,
       0,  1774,     0,     0,     0,  1775,  1776,  1777,     0,     0,
    1014,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1778,  1783,   750,     0,     0,     0,  1784,     0,
    1780,  1221,     0,     0,     0,     0,  1781,     0,     0,     0,
    1221,     0,     0,     0,     0,     0,     0,     0,     0,  1785,
    1786,     0,     0,  1378,     0,  1379,     0,  1221,  1221,     0,
    1782,  1221,     0,     0,  1787,  1380,     0,     0,     0,     0,
       0,     0,     0,  1381,     0,   796,  3780,     0,     0,     0,
    3272,     0,     0,  1382,  1337,  3272,     0,     0,  3272,   796,
    1014,  2905,     0,  4420,     0,  1788,  1221,  1221,     0,     0,
       0,     0,     0,     0,     0,  1014,     0,     0,  1789,     0,
       0,  1790,  3852,  1998,     0,     0,     0,  2880,     0,     0,
    1384,  1385,     0,     0,  1014,  3852,   847,   801,   801,   801,
       0,     0,     0,     0,     0,  1773,     0,     0,  1774,     0,
       0,     0,  1775,  1776,  1777,     0,     0,  2881,     0,  1469,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1778,
       0,     0,     0,     0,  1481,  1783,     0,  1780,   796,   847,
    1784,  1014,     0,  1781,     0,     0,  1492,     0,  1493,     0,
       0,     0,     0,     0,  1014,     0,  1496,     0,     0,  1791,
       0,  1785,  1786,     0,     0,     0,  1014,  1782,  1511,     0,
       0,  1515,     0,     0,     0,     0,  1787,     0,  1014,     0,
    1387,     0,     0,     0,     0,  1685,  1685,     0,     0,   796,
       0,     0,   738,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4016,     0,     0,     0,  1560,  1788,   738,     0,
    2842,     0,     0,     0,     0,     0,  2104,     0,     0,     0,
    1789,     0,  1014,  1790,     0,  1014,     0,     0,     0,  4050,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     801,   738,  3852,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1792,     0,     0,  1793,  1794,  1795,     0,  1796,
    1797,  1798,  1799,  1800,  1801,     0,     0,     0,     0,  3846,
       0,  1221,  1783,     0,  1221,     0,  1221,  1784,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1785,  1786,
    1221,  1791,     0,     0,  3272,     0,     0,     0,  4420,     0,
       0,     0,     0,  1787,     0,  1221,     0,     0,     0,     0,
       0,     0,     0,     0,  4611,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1221,     0,     0,     0,     0,     0,
    1703,     0,     0,     0,  1788,     0,   801,     0,     0,     0,
     738,     0,     0,     0,  1014,     0,     0,  1789,     0,     0,
    1790,     0,     0,     0,  1371,     0,     0,     0,     0,     0,
    1372,     0,     0,  1221,     0,     0,     0,     0,     0,     0,
     801,   801,   801,   801,     0,     0,     0,     0,     0,     0,
       0,     0,  2621,     0,  1792,  1685,     0,  1793,  1794,  1795,
       0,  1796,  1797,  1798,  1799,  1800,  1801,     0,     0,     0,
    1373,  4107,     0,     0,   796,     0,  1773,     0,     0,  1774,
       0,     0,     0,  1775,  1776,  1777,     0,     0,     0,     0,
     738,     0,     0,     0,     0,  1221,     0,     0,  1791,     0,
    1778,     0,     0,     0,     0,     0,     0,     0,  1780,     0,
       0,     0,     0,     0,  1781,     0,     0,     0,     0,     0,
       0,  1374,     0,     0,     0,     0,     0,     0,  1375,     0,
       0,  1376,     0,     0,     0,     0,     0,  1221,  1782,     0,
     796,     0,     0,     0,     0,     0,     0,     0,     0,  1221,
       0,     0,  1773,     0,  1221,  1774,  1221,     0,  1221,  1775,
    1776,  1777,     0,     0,     0,  3852,     0,     0,     0,     0,
       0,   801,     0,   847,     0,     0,     0,     0,   750,  1942,
       0,     0,     0,  1221,  1780,     0,     0,  1377,     0,     0,
    1781,  1792,     0,     0,  1793,  1794,  1795,     0,  1796,  1797,
    1798,  1799,  1800,  1801,     0,     0,     0,     0,  4142,     0,
       0,     0,     0,  1773,  1782,     0,  1774,     0,     0,     0,
    1775,  1776,  1777,     0,     0,     0,     0,     0,  2680,   801,
       0,     0,  1998,  2686,     0,   796,     0,  1778,     0,     0,
       0,     0,     0,  1783,  1378,  1780,  1379,     0,  1784,     0,
    2070,  1781,     0,     0,     0,     0,  1380,     0,     0,     0,
       0,     0,  1221,  1221,  1381,     0,     0,  2905,     0,  1785,
    1786,     0,     0,  1221,  1382,  1782,  4611,     0,     0,     0,
    2677,     0,     0,     0,  1787,     0,     0,     0,     0,     0,
       0,     0,     0,   796,     0,  1014,     0,     0,     0,     0,
       0,     0,     0,   801,     0,     0,     0,  1014,  2919,     0,
    2151,  1384,  1385,     0,     0,  1788,     0,     0,     0,  1783,
       0,  2104,     0,     0,  1784,     0,     0,     0,  1789,  3852,
       0,  1790,     0,     0,     0,   796,   796,  1221,  2920,     0,
       0,     0,     0,     0,  1014, -2390, -2390,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1221,     0,  1773,     0,
    1787,  1774,     0,   801,     0,  1775,  1776,  1777,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1783,     0,  1778,     0,     0,  1784,  1773,     0,     0,  1774,
    1780, -2390,     0,  1775,  1776,  1777,  1781,     0,     0,     0,
       0,  1387,     0,     0,  1789,     0,  1785,  1786,     0,  1791,
    1778,     0,     0,     0,     0,     0,     0,     0,  1780,     0,
    1782,  1787,     0,     0,  1781,  2268,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1221,  1221,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1782,   796,
       0,     0,  1788,     0,     0,     0,     0,  1371,     0,     0,
       0,   796,   796,  1372,     0,  1789,     0,     0,  1790,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1791,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1014,     0,     0,
       0,     0,  1792,  1373,     0,  1793,  1794,  1795,     0,  1796,
    1797,  1798,  1799,  1800,  1801,     0,     0,     0,     0,  4379,
       0,     0,     0,  2365,     0,  1783,     0,     0,     0,     0,
    1784,     0,     0,     0,     0,     0,     0,  2379,     0,     0,
    2382,     0,  2384,     0,  2385,     0,  1791,     0,     0,     0,
    2387,  1785,  1786,  1783,  1374,     0,     0,     0,  1784,     0,
       0,  1375,     0,     0,  1376,     0,  1787,  1998,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1792,  1785,
    1786,  1793,  1794,  1795,     0,  1796,  1797,  1798,  1799,  1800,
    1801,     0,     0,     0,  1787,  1942,     0,  1788,     0,  1942,
       0,  1942,     0,     0,  1942,     0,     0,     0,     0,     0,
    1789,     0,     0,  1790,     0,     0,     0,     0,     0,     0,
    1377,     0,     0,     0,     0,  1788,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1789,  1792,
       0,  1790,  1793,  1794,  1795,     0,  1796,  1797,  1798,  1799,
    1800,  1801,     0,     0,     0,     0,  4390,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1378,     0,  1379,
       0,     0,     0,     0,     0,  1014,     0,     0,     0,  1380,
       0,  1791,     0,     0,     0,     0,     0,  1381,     0,     0,
       0,     0,     0,     0,     0,  1773,  1014,  1382,  1774,     0,
       0,     0,  1775,  1776,  1777,     0,     0,  1014,     0,  1791,
       0,     0,     0,     0,  1773,     0,     0,  1774,     0,  1778,
       0,  1775,  1776,  1777,     0,     0,     0,  1780,     0,     0,
       0,  3376,     0,  1781,  1384,  1385,     0,     0,  1778,     0,
       0,     0,     0,     0,     0,     0,  1780,     0,     0,     0,
       0,     0,  1781,     0,     0,     0,     0,  1782,     0,     0,
       0,  3377,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1792,     0,  1782,  1793,  1794,  1795,
       0,  1796,  1797,  1798,  1799,  1800,  1801,     0,     0,     0,
       0,  4399,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1792,     0,     0,  1793,  1794,  1795,     0,  1796,
    1797,  1798,  1799,  1800,  1801,     0,     0,     0,     0,  4402,
       0,     0,     0,     0,  1387,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2621,  2621,  2621,     0,     0,     0,   798,     0,
       0,     0,     0,     0,     0,     0,     0,   798,   821,     0,
       0,     0,  1783,     0,     0,   821,     0,  1784,     0,     0,
       0,     0,     0,     0,     0,     0,   821,     0,     0,     0,
       0,  1783,     0,     0,     0,     0,  1784,     0,  1785,  1786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2695,  2696,     0,  1787,     0,  2699,  2700,  1785,  1786,  1998,
    2703,     0,  2686,     0,  2686,     0,     0,     0,     0,  1998,
       0,     0,  1787,     0,  2714,     0,     0,     0,     0,     0,
       0,  2723,     0,     0,  1788,  2726,  2727,     0,     0,  2730,
    2731,     0,     0,     0,     0,     0,  2736,  1789,     0,     0,
    1790,     0,     0,  1788,     0,     0,     0,     0,  2752,     0,
    2754,     0,     0,     0,     0,     0,  1789,     0,     0,  1790,
    1014,     0,     0,     0,     0,     0,     0,  2777,     0,     0,
       0,     0,  2779,     0,     0,     0,     0,  1014,     0,     0,
    1371,     0,     0,     0,     0,  2784,  1372,     0,     0,     0,
       0,     0,     0,  2789,     0,  2791,     0,  2793,  2796,  2798,
       0,  1998,     0,     0,  2806,  2809,     0,     0,     0,     0,
       0,     0,  2820,     0,     0,     0,     0,  2829,  1791,     0,
       0,     0,  2833,     0,     0,     0,  1373,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1791,     0,     0,
       0,     0,     0,  1773,     0,     0,  1774,  2866,     0,     0,
    1775,  1776,  1777,     0,     0,     0,     0,     0,  2873,     0,
    2875,     0,     0,     0,  1014,  2878,  1014,  1778,     0,  2879,
       0,  2883,  2884,  2885,  2886,  1780,  2888,  1374,     0,     0,
       0,  1781,     0,     0,  1375,     0,     0,  1376,     0,  2912,
    2913,  2914,     0,     0,     0,     0,     0,     0,     0,  2922,
    2923,     0,     0,     0,     0,  1782,     0,     0,     0,     0,
       0,  1792,     0,     0,  1793,  1794,  1795,     0,  1796,  1797,
    1798,  1799,  1800,  1801,     0,  1014,     0,     0,  4450,     0,
    1792,     0,     0,  1793,  1794,  1795,     0,  1796,  1797,  1798,
    1799,  1800,  1801,  1377,     0,     0,     0,  4482,     0,     0,
    1014,     0,  1773,  2965,     0,  1774,     0,     0,     0,  1775,
    1776,  1777,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2686,     0,  1778,     0,     0,     0,
       0,  2686,     0,     0,  1780,     0,     0,     0,     0,     0,
    1781,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1378,   798,  1379,     0,     0,     0,     0,     0,     0,     0,
    1783,     0,  1380,   821,  1782,  1784,     0,     0,   821,     0,
    1381,     0,     0,     0,     0,     0,     0,     0,     0,   821,
    1382,     0,     0,     0,     0,     0,  1785,  1786,     0,  1014,
       0,     0,     0,     0,     0,   821,     0,     0,     0,   798,
       0,  1787,     0,     0,     0,  1015,     0,  2686,     0,   798,
     821,     0,     0,     0,  3421,     0,   821,  1384,  1385,     0,
    1014,     0,     0,     0,     0,     0,  1015,   821,     0,     0,
       0,     0,  1788,     0,     0,   821,     0,     0,     0,     0,
       0,     0,     0,     0,  3422,  1789,     0,     0,  1790,     0,
       0,     0,     0,     0,     0,     0,  1942,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1783,
       0,     0,     0,     0,  1784,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3129,     0,     0,     0,  1785,  1786,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1387,     0,     0,
    1787,     0,     0,     0,   798,   798,     0,     0,     0,     0,
     821,     0,     0,  1014,     0,     0,  1791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1788,     0,     0,  1014,     0,   798,     0,     0,     0,
       0,     0,     0,     0,  1789,     0,     0,  1790,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1014,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1014,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1792,
       0,     0,  1793,  1794,  1795,     0,  1796,  1797,  1798,  1799,
    1800,  1801,     0,     0,     0,  1791,  4517,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2621,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3291,     0,     0,
       0,     0,     0,     0,   798,     0,     0,     0,     0,     0,
       0,  1015,     0,     0,  1998,   798,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1015,     0,     0,     0,     0,     0,     0,     0,     0,
    1015,     0,     0,     0,     0,     0,     0,     0,  1792,  3328,
    3329,  1793,  1794,  1795,     0,  1796,  1797,  1798,  1799,  1800,
    1801,     0,     0,     0,     0,  4751,     0,  1942,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   798,
       0,     0,  1773,     0,     0,  1774,     0,     0,     0,  1775,
    1776,  1777,  3350,     0,     0,     0,     0,     0,     0,     0,
       0,  3354,     0,     0,     0,     0,  1778,  2686,     0,     0,
       0,     0,     0,     0,  1780,     0,  1015,  3366,  3368,     0,
    1781,     0,  3368,     0,     0,     0,     0,  3379,  3380,  3381,
       0,     0,  1773,     0,     0,  1774,     0,     0,     0,  1775,
    1776,  1777,     0,     0,  1782,     0,     0,     0,     0,     0,
       0,   821,     0,     0,     0,     0,  1778,     0,  3402,  3403,
    3404,  3405,     0,     0,  1780,     0,     0,     0,     0,     0,
    1781,   821,     0,     0,     0,   798,     0,     0,     0,     0,
       0,     0,     0,   821,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3420,  1782,  3424,  3425,  3426,     0,     0,
       0,     0,     0,     0,     0,  3439,     0,     0,     0,     0,
       0,   821,     0,     0,     0,     0,     0,     0,     0,     0,
    1015,     0,   821,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   821,     0,     0,
     821,     0,     0,     0,     0,  1014,     0,     0,     0,  1783,
       0,     0,   798,     0,  1784,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3486,  1785,  1786,     0,     0,     0,
       0,   798,  3490,     0,     0,     0,     0,     0,     0,     0,
    1787,     0,     0,     0,  1998,     0,     0,     0,     0,  1783,
       0,  3502,     0,     0,  1784,     0,     0,     0,     0,   798,
     798,   798,     0,   798,     0,     0,     0,     0,     0,     0,
       0,  1788,     0,     0,  3543,  1785,  1786,     0,     0,     0,
       0,     0,     0,   798,  1789,     0,     0,  1790,     0,     0,
    1787,     0,     0,     0,   550,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   551,   821,     0,     0,
       0,     0,     0,     0,     0,   821,   821,     0,  3580,     0,
       0,  1788,  3585,     0,   798,  1927,     0,   552,     0,     0,
       0,     0,     0,     0,  1789,     0,     0,  1790,     0,     0,
     553,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     554,  3623,     0,   798,  -775,     0,     0,   798,   798,     0,
       0,     0,     0,     0,     0,  1791,     0,     0,     0,     0,
       0,     0,   555,  1015,     0,  1014,     0,     0,   556,  1927,
       0,  3636,     0,     0,     0,  1014,     0,     0,     0,     0,
       0,     0,     0,   557,     0,  3646,     0,     0,     0,  3648,
       0,     0,     0,     0,   558,     0,     0,     0,     0,     0,
    1942,     0,   559,     0,     0,  1791,     0,     0,     0,     0,
       0,     0,     0,     0,   560,     0,     0,     0,     0,     0,
       0,   561,     0,     0,     0,   562,  1015,  2621,     0,     0,
       0,     0,  2621,     0,     0,     0,     0,     0,  2621,     0,
       0,     0,  -978,     0,     0,     0,     0,     0,  1792,     0,
       0,  1793,  1794,  1795,     0,  1796,  1797,  1798,  1799,  1800,
    1801,  1015,     0,     0,     0,  4772,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   563,
       0,     0,     0,     0,     0,     0,     0,     0,  -517,     0,
       0,     0,     0,     0,     0,  1014,     0,     0,  1792,     0,
       0,  1793,  1794,  1795,     0,  1796,  1797,  1798,  1799,  1800,
    1801,     0,     0,     0,     0,  4887,     0,     0,     0,   564,
       0,   821,   565,     0,  1014,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   566,
       0,  1015,     0,  1014,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1015,     0,  -411,     0,
       0,     0,     0,     0,  1015,     0,     0,     0,     0,     0,
    1927,     0,     0,     0,     0,  1015,   567,     0,     0,     0,
       0,     0,     0,   568,     0,     0,     0,     0,     0,  -411,
       0,   821,   569,     0,     0,   821,     0,  1014,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   821,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -411,  1015,     0,   570,   571,     0,   572,   573,   798,
       0,     0,     0,     0,     0,  1015,     0,   574,     0,     0,
       0,   798,   575,  3863,     0,  3864,     0,  1015,   576,     0,
       0,   577,  3866,     0,   578,     0,     0,     0,     0,  1015,
       0,     0,     0,     0,     0,     0,     0,  -411,     0,  3876,
       0,     0,     0,     0,     0,     0,     0,     0,   798,     0,
     821,   821,     0,     0,  3884,     0,     0,     0,     0,     0,
       0,     0,     0,   821,     0,  3895,     0,  4357,     0,  1014,
       0,     0,     0,  1015,     0,     0,  1015,     0,   821,   821,
       0,  3898,     0,     0,     0,     0,     0,     0,     0,     0,
     821,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3927,     0,
       0,     0,     0,     0,     0,  1014,     0,     0,     0,  3935,
    3936,  3937,   798,     0,  3940,  3941,  3942,  3943,  3944,  3945,
       0,     0,     0,     0,  3952,  3953,     0,  3955,  3956,  3957,
    3958,  3959,  3960,  3961,     0,     0,     0,     0,     0,     0,
       0,     0,  3969,     0,  3971,  3972,   798,     0,   798,     0,
       0,     0,     0,   798,   798,     0,     0,     0,     0,     0,
     798,   798,   798,     0,     0,     0,   798,     0,   798,   798,
     798,   798,   798,   798,     0,   798,     0,   798,   798,     0,
       0,   798,     0,     0,  4004,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1015,   798,   798,   798,   798,
    1927,     0,     0,     0,   798,     0,     0,     0,   798,     0,
       0,   798,     0,     0,   798,   798,   798,   798,   798,   798,
     798,   798,   798,     0,   798,     0,     0,     0,  2686,     0,
       0,   798,     0,   798,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1773,     0,
       0,  1774,     0,     0,     0,  1775,  1776,  1777,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3368,  1778,     0,     0,     0,     0,     0,     0,     0,
    1780,     0,     0,     0,     0,     0,  1781,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1942,
    1942,  1942,     0,     0,     0,     0,     0,     0,     0,     0,
    1782,  4092,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2686,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     798,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1014,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1015,
    1014,     0,     0,  1015,  1015,     0,     0,     0,     0,     0,
       0,     0,     0,   821,     0,  1783,     0,  1927,   821,     0,
    1784,     0,   821,     0,     0,     0,     0,     0,     0,     0,
     821,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1785,  1786,     0,     0,     0,     0,     0,   821,     0,
       0,   798,     0,     0,  1014,     0,  1787,     0,  1014,  1014,
       0,     0,   798,     0,     0,     0,  1015,     0,     0,   798,
       0,     0,     0,     0,     0,     0,     0,     0,  1015,     0,
       0,     0,     0,     0,     0,     0,     0,  1788,     0,     0,
     821,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1789,     0,     0,  1790,     0,     0,     0,   821,   821,     0,
       0,     0,     0,     0,   826,  1015,     0,     0,     0,     0,
    4222,     0,     0,   856,  4223,  4224,  4225,  4226,     0,     0,
    4228,     0,   871,     0,  1927,   821,     0,     0,  1927,     0,
       0,     0,     0,     0,     0,     0,  4357,  1014,     0,     0,
       0,  4241,  4242,  4243,  4244,     0,  4246,  4247,     0,     0,
       0,     0,     0,     0,     0,     0,   821,     0,  4256,  4257,
     821,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1791,     0,     0,     0,     0,  4262,     0,   821,     0,
       0,     0,     0,  1942,  1942,     0,  1942,     0,     0,   821,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   821,     0,     0,     0,     0,     0,     0,     0,
     821,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   798,  1015,     0,
       0,     0,     0,     0,  1792,     0,  1927,  1793,  1794,  1795,
    4327,  1796,  1797,  1798,  1799,  1800,  1801,     0,     0,     0,
       0,  4905,     0,     0,     0,     0,  1773,     0,     0,  1774,
       0,  4346,     0,  1775,  1776,  1777,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1778,     0,     0,     0,     0,     0,     0,     0,  1780,     0,
       0,  4370,     0,     0,  1781,     0,     0,     0,  1015,     0,
       0,     0,   821,     0,     0,     0,     0,     0,     0,     0,
       0,   798,     0,     0,     0,     0,     0,     0,  1782,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   821,  1942,     0,     0,     0,   798,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1942,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     821,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1015,     0,     0,   880,
       0,     0,   821,  1783,   915,     0,     0,     0,  1784,     0,
     821,     0,     0,     0,   798,     0,     0,  1015,     0,     0,
     798,     0,     0,     0,     0,     0,     0,  4472,  1015,  1785,
    1786,     0,     0,     0,     0,     0,     0,     0,   798,     0,
       0,     0,     0,   798,  1787,  4481,     0,     0,     0,     0,
    4486,  4487,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   798,   798,   798,     0,
       0,   798,     0,     0,     0,  1788,     0,     0,     0,   798,
     798,   798,   798,     0,     0,     0,     0,  1927,  1789,     0,
       0,  1790,   798,  1927,     0,   798,     0,   798,     0,     0,
       0,     0,     0,     0,     0,     0,  4536,     0,   798,   798,
       0,     0,   798,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   798,     0,   798,     0,
     798,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   822,     0,     0,  1106,     0,     0,
     798,   822,  3368,     0,     0,     0,     0,     0,     0,  4577,
       0,   798,   822,   798,   798,   798,     0,     0,     0,  1791,
       0,     0,  1228,     0,     0,     0,     0,  1773,   821,     0,
    1774,   798,     0,     0,  1775,  1776,  1777,     0,     0,     0,
       0,  1251,     0,   798,  1942,     0,     0,     0,   798,     0,
       0,  1778,     0,     0,   798,  1942,     0,     0,     0,  1780,
       0,     0,     0,  1277,   798,  1781,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4613,     0,     0,
    1015,     0,     0,  1015,     0,  1015,     0,     0,     0,  1782,
    1015,     0,   821,     0,     0,     0,     0,     0,     0,     0,
       0,  4630,     0,     0,     0,     0,     0,     0,   821,   821,
    4637,     0,  1792,     0,   798,  1793,  1794,  1795,     0,  1796,
    1797,  1798,  1799,  1800,  1801,     0,     0,  3813,     0,     0,
       0,  1942,     0,     0,  1397,   821,     0,     0,   821,     0,
       0,  1015,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1015,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3194,     0,     0,     0,     0,  3195,     0,     0,
       0,     0,  1015,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1783,     0,     0,     0,     0,  1784,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3368,  1927,  1927,  1927,     0,     0,     0,     0,     0,
    1785,  1786,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1942,  1520,  1787,   821,     0,     0,     0,
       0,     0,     0,     0,     0,  1015,     0,  1015,   821,     0,
       0,     0,   821,     0,     0,     0,     0,     0,  1550,  1553,
    1554,     0,   821,     0,     0,     0,  1788,     0,  4740,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1789,
       0,     0,  1790,  4752,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1015,     0,  4763,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   821,     0,     0,     0,     0,
       0,  1015,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1015,     0,     0,     0,   822,
    1791,  1927,  1015,     0,   822,     0,     0,   821,     0,   821,
       0,     0,     0,     0,     0,   822,     0,     0,     0,  4811,
       0,   821,     0,   821,     0,     0,     0,     0,     0,     0,
       0,   822,     0,     0,     0,  1228,     0,     0,     0,     0,
       0,     0,     0,     0,  4826,     0,   822,     0,     0,     0,
       0,     0,   822,     0,     0,     0,     0,     0,     0,     0,
    1015,  1228,     0,   822,     0,     0,     0,     0,     0,     0,
       0,   822,     0,     0,     0,     0,     0,   821,  1015,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1015,     0,  1792,     0,     0,  1793,  1794,  1795,     0,
    1796,  1797,  1798,  1799,  1800,  1801,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   821,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   798,     0,     0,   821,
       0,     0,     0,     0,     0,     0,   822,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   821,     0,     0,   821,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   798,     0,     0,  1015,     0,  1844,     0,     0,     0,
     798,     0,     0,     0,     0,     0,   798,     0,   798,     0,
       0,   798,     0,     0,     0,  1015,   798,   798,   798,   798,
       0,     0,   798,   798,   798,   798,   798,   798,   798,   798,
     798,   798,     0,     0,     0,   798,   798,     0,     0,     0,
    1015,     0,     0,     0,  1980,   798,     0,     0,     0,   798,
       0,  1927,     0,   798,     0,     0,     0,     0,     0,     0,
       0,   798,     0,     0,   798,     0,   798,     0,     0,     0,
       0,     0,     0,     0,  1015,   798,     0,     0,   798,   798,
       0,     0,     0,   798,   798,     0,     0,     0,     0,     0,
     798,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     798,     0,   798,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   798,     0,  2099,     0,     0,     0,
     798,   798,   798,  2119,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   798,     0,     0,     0,
    2152,     0,     0,     0,     0,     0,     0,     0,  2158,   798,
       0,  2161,     0,     0,     0,  1015,     0,   598,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   599,
     798,     0,  1773,     0,     0,  1774,     0,     0,     0,  1775,
    1776,  1777,     0,     0,     0,     0,     0,  2196,     0,     0,
     600,     0,     0,     0,     0,     0,  1778,     0,     0,     0,
    2643,  2211,   821,   601,  1780,     0,     0,     0,     0,     0,
    1781,     0,     0,     0,  2223,     0,     0,   602,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1782,   603,     0,     0,     0,     0,
       0,     0,  1927,     0,     0,     0,     0,  1927,  1015,  1927,
       0,     0,     0,     0,     0,     0,   604,   822,     0,     0,
       0,     0,     0,  2276,     0,     0,     0,   605,     0,     0,
       0,     0,     0,     0,     0,   606,     0,   822,     0,     0,
       0,  2644,     0,     0,  2310,     0,     0,   607,     0,   822,
       0,  2322,   608,     0,     0,     0,     0,   821,   609,     0,
     821,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   610,     0,   822,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   822,     0,
       0,     0,     0,     0,     0,     0,     0,  1927,     0,  1783,
       0,     0,     0,   822,  1784,     0,   822,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   798,
       0,   611,     0,     0,     0,  1785,  1786,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1787,     0,   821,   821,     0,     0,  1015,     0,     0,     0,
       0,     0,   612,  2400,     0,   821,     0,   821,     0,     0,
       0,     0,     0,   613,     0,     0,     0,     0,     0,     0,
       0,  1788,   614,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   203,     0,  1789,     0,     0,  1790,     0,     0,
       0,  1228,  1228,     0,     0,  1015,   798,   798,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2452,   615,
       0,     0,     0,     0,   616,     0,   617,     0,     0,     0,
       0,     0,   618,   822,     0,   619,     0,     0,     0,     0,
       0,   822,   822,     0,     0,     0,     0,     0,     0,     0,
       0,  1928,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   821,     0,     0,   620,     0,     0,   621,     0,     0,
       0,   622,     0,     0,     0,  1791,     0,     0,   623,     0,
     624,     0,   798,     0,     0,   625,     0,     0,     0,     0,
       0,     0,     0,   798,     0,     0,     0,   626,     0,     0,
       0,     0,     0,     0,     0,  1928,   823,     0,     0,     0,
     627,     0,     0,   823,     0,  2608,     0,     0,     0,     0,
       0,     0,     0,   798,   823,  2623,     0,     0,     0,     0,
    2645,     0,     0,   798,   798,     0,  1015,     0,     0,     0,
     798,   798,     0,     0,     0,   798,  1015,     0,     0,     0,
     798,     0,     0,   798,   798,     0,     0,     0,   798,     0,
       0,     0,     0,     0,   798,     0,     0,     0,  1792,     0,
       0,  1793,  1794,  1795,     0,  1796,  1797,  1798,  1799,  1800,
    1801,     0,   798,     0,  1773,     0,   798,  1774,     0,     0,
       0,  1775,  1776,  1777,     0,     0,     0,     0,   798,     0,
       0,     0,     0,   798,     0,     0,     0,     0,  1778,   798,
       0,     0,     0,     0,   883,     0,  1780,     0,     0,     0,
       0,     0,  1781,     0,   798,     0,  1773,     0,     0,  1774,
       0,     0,     0,  1775,  1776,  1777,     0,     0,     0,     0,
       0,  2634,     0,  2637,     0,     0,  1782,   884,   798,     0,
    1778,     0,     0,     0,     0,     0,     0,   822,  1780,     0,
     885,   886,     0,     0,  1781,     0,  1015,     0,     0,     0,
     887,     0,     0,     0,   888,     0,     0,     0,     0,     0,
    1228,     0,     0,   821,     0,     0,  1927,     0,  1782,     0,
       0,     0,   889,     0,     0,  1015,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1928,     0,     0,   821,
       0,     0,     0,   890,  1015,     0,     0,     0,     0,     0,
       0,   821,     0,     0,   891,     0,     0,   822,     0,   798,
       0,   822,   892,     0,     0,     0,     0,     0,     0,   821,
       0,     0,     0,   822,   893,     0,     0,     0,     0,   894,
       0,  1783,     0,     0,     0,     0,  1784,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1015,     0,
    4849,     0,   895,     0,     0,     0,     0,  1785,  1786,     0,
       0,     0,     0,     0,     0,     0,   821,     0,     0,     0,
       0,     0,  1787,  1783,     0,     0,     0,   896,  1784,     0,
       0,     0,     0,   798,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   798,     0,   822,   822,   897,  1785,
    1786,     0,     0,  1788,     0,     0,  2810,     0,     0,   822,
       0,     0,     0,     0,  1787,     0,  1789,     0,     0,  1790,
       0,     0,     0,     0,   822,   822,  2837,     0,     0,   898,
       0,     0,     0,     0,     0,     0,   822,     0,     0,     0,
    3728,     0,     0,     0,     0,  1788,     0,     0,  1015,   899,
    1015,   823,     0,     0,     0,     0,   823,     0,  1789,   203,
       0,  1790,     0,     0,     0,     0,     0,   823,     0,     0,
       0,     0,     0,     0,     0,     0,   821,     0,     0,     0,
    4850,     0,     0,   823,     0,     0,   900,     0,     0,     0,
       0,   901,   798,   902,     0,     0,  1015,  1791,   823,   903,
       0,   798,   904,     0,   823,     0,     0,     0,     0,     0,
       0,     0,     0,  3729,     0,   823,     0,     0,   798,   798,
       0,     0,   798,   823,     0,     0,     0,     0,     0,     0,
       0,   905,     0,     0,   906,     0,   798,     0,   907,  1791,
       0,   798,     0,     0,     0,   908,   798,   909,     0,   798,
     798,     0,   910,     0,     0,     0,  1928,   798,   798,     0,
       0,  2989,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   798,     0,     0,     0,   911,     0,     0,
     821,     0,   821,     0,     0,     0,   798,     0,     0,     0,
    1792,     0,     0,  1793,  1794,  1795,     0,  1796,  1797,  1798,
    1799,  1800,  1801,     0,     0,     0,     0,     0,   823,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1015,
     821,     0,     0,     0,     0,     0,     0,     0,     0,   798,
       0,     0,  1792,     0,     0,  1793,  1794,  1795,     0,  1796,
    1797,  1798,  1799,  1800,  1801,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1927,     0,   821,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     798,     0,     0,     0,     0,  1773,     0,     0,  1774,     0,
       0,     0,  1775,  1776,  1777,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1778,
       0,     0,  3153,     0,     0,     0,     0,  1780,     0,     0,
       0,     0,     0,  1781,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   798,     0,  1015,     0,     0,     0,  3128,
       0,     0,     0,     0,     0,     0,     0,  1782,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   798,  1015,     0,   798,     0,   798,  1013,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   822,
       0,     0,     0,  1928,   822,     0,     0,     0,   822,  1013,
    1004,   798,     0,     0,     0,   798,   822,     0,     0,     0,
       0,  1015,     0,     0,     0,     0,   798,     0,     0,  1773,
       0,  1004,  1774,     0,   822,     0,  1775,  1776,  1777,     0,
       0,     0,     0,     0,     0,   798,     0,     0,     0,     0,
       0,     0,     0,  1778,     0,     0,     0,     0,     0,     0,
       0,  1780,     0,     0,     0,     0,     0,  1781,     0,  1927,
       0,     0,  1783,     0,     0,  1015,   822,  1784,     0,  1015,
    1015,     0,     0,     0,   798,     0,     0,     0,     0,     0,
       0,  1782,     0,   822,   822,     0,     0,     0,  1785,  1786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3255,
       0,     0,     0,  1787,     0,     0,     0,     0,     0,     0,
    1928,   822,     0,     0,  1928,   798,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   823,
       0,     0,     0,     0,  1788,     0,   798,     0,     0,     0,
       0,     0,   822,     0,     0,     0,   822,  1789,     0,   823,
    1790,     0,     0,     0,     0,     0,     0,  1015,  1015,     0,
       0,   823,     0,     0,   822,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   822,     0,     0,   798,     0,
       0,   798,     0,     0,     0,     0,  1783,     0,   822,   823,
     798,  1784,     0,     0,     0,   798,   822,   798,     0,   798,
     823,     0,     0,     0,     0,     0,   798,     0,     0,     0,
       0,     0,  1785,  1786,     0,   823,     0,     0,   823,     0,
       0,     0,     0,     0,   798,     0,     0,  1787,  1791,     0,
       0,     0,     0,  1204,  1204,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   821,     0,     0,
       0,     0,  1928,     0,     0,     0,     0,     0,  1788,     0,
       0,     0,     0,     0,  1013,  1267,     0,     0,     0,     0,
       0,  1789,     0,     0,  1790,     0,   798,     0,     0,     0,
       0,     0,     0,     0,  1013,     0,  1004,     0,     0,  3167,
       0,     0,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   798,   798,     0,  1004,     0,     0,     0,
       0,     0,     0,     0,   798,  1004,     0,     0,   822,     0,
       0,  1792,   821,     0,  1793,  1794,  1795,     0,  1796,  1797,
    1798,  1799,  1800,  1801,   798,   823,     0,     0,     0,     0,
       0,     0,     0,   823,   823,  3440,     0,     0,     0,     0,
       0,     0,  1791,  1929,     0,  1773,     0,     0,  1774,     0,
       0,     0,  1775,  1776,  1777,     0,     0,     0,     0,  1013,
     798,     0,     0,     0,     0,     0,   798,   798,   798,  1778,
     822,     0,  3199,     0,     0,     0,     0,  1780,     0,     0,
       0,  1004,     0,  1781,     0,     0,     0,   798,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1929,     0,     0,
       0,     0,     0,     0,     0,     0,   822,  1782,     0,     0,
    1927,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   822,     0,
       0,     0,     0,     0,     0,  1792,   822,     0,  1793,  1794,
    1795,     0,  1796,  1797,  1798,  1799,  1800,  1801,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3546,  3547,
       0,     0,     0,  1013,     0,     0,   798,   798,     0,     0,
       0,     0,  1927,     0,  3556,     0,     0,     0,     0,     0,
     798,     0,     0,     0,     0,  1004,     0,     0,     0,     0,
    3573,  1927,   798,   798,     0,     0,     0,     0,     0,  3582,
    3584,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1783,  1928,     0,     0,  3602,  1784,     0,  1928,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1785,  1786,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   823,
       0,     0,     0,  1787,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1788,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1789,  1929,     0,
    1790,     0,     0,  1829,   822,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1228,     0,   823,
       0,     0,     0,   823,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   823,     0,     0,     0,     0,
       0,  1730,     0,  1773,     0,     0,  1774,     0,     0,     0,
    1775,  1776,  1777,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1013,  1778,   822,     0,
    1744,     0,     0,     0,     0,  1780,     0,     0,  1791,     0,
       0,  1781,     0,     0,   822,   822,     0,     0,  1004,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1762,  1763,
    1764,     0,  1766,     0,     0,  1782,     0,     0,   823,   823,
       0,   822,     0,     0,   822,     0,     0,     0,     0,     0,
       0,   823,  1808,     0,     0,     0,     0,     0,     0,  1013,
       0,     0,     0,     0,     0,     0,   823,   823,     0,     0,
       0,     0,  3768,  3769,  3770,     0,     0,     0,   823,     0,
       0,  1004,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1845,  1013,     0,     0,     0,     0,     0,
       0,  1792,     0,     0,  1793,  1794,  1795,     0,  1796,  1797,
    1798,  1799,  1800,  1801,     0,     0,  1004,     0,  1928,  1928,
    1928,     0,  1949,  3204,     0,     0,  1961,  1964,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1783,     0,   822,     0,     0,  1784,     0,     0,     0,     0,
       0,     0,     0,     0,   822,     0,     0,     0,   822,     0,
       0,     0,     0,     0,     0,     0,  1785,  1786,   822,     0,
       0,     0,     0,     0,  1013,     0,     0,     0,     0,     0,
       0,  1787,     0,     0,     0,     0,     0,     0,     0,  1013,
       0,     0,     0,     0,     0,     0,  1004,  1013,  1929,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1013,     0,
       0,  1004,  1788,     0,     0,     0,     0,     0,     0,  1004,
       0,     0,     0,     0,     0,  1789,     0,     0,  1790,     0,
    1004,   822,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1013,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1928,  1013,     0,
       0,     0,     0,   822,     0,   822,     0,  1004,     0,     0,
    1013,     0,     0,     0,     0,     0,     0,   822,     0,   822,
    1004,     0,  1013,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,     0,     0,     0,  1791,     0,     0,     0,
       0,     0,     0,     0,  1004,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1013,     0,     0,  1013,
    4001,     0,     0,   822,     0,     0,     0,     0,     0,     0,
    4011,     0,     0,     0,     0,     0,     0,     0,  1004,     0,
       0,  1004,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4032,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1792,
     822,     0,  1793,  1794,  1795,     0,  1796,  1797,  1798,  1799,
    1800,  1801,     0,  2322,     0,   822,     0,     0,     0,     0,
       0,   823,     0,     0,     0,  1929,   823,     0,     0,     0,
     823,     0,     0,     0,     0,     0,     0,   822,   823,     0,
     822,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   823,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2400,  1013,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,     0,     0,     0,     0,     0,     0,     0,   823,  1773,
       0,     0,  1774,     0,     0,     0,  1775,  1776,  1777,     0,
       0,     0,     0,     0,     0,   823,   823,  1928,     0,     0,
       0,     0,     0,  1778,     0,     0,  3210,     0,     0,     0,
       0,  1780,     0,     0,     0,     0,     0,  1781,     0,     0,
       0,     0,  1929,   823,     0,     0,  1929,     0,     0,     0,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1782,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1006,  2490,     0,   823,     0,     0,     0,   823,     0,
    4149,  4150,  4151,  4152,     0,  2510,     0,  2512,     0,     0,
    2524,  2527,  2532,  1007,     0,     0,   823,  2538,     0,     0,
    2543,     0,     0,     0,     0,     0,     0,   823,     0,     0,
       0,     0,     0,     0,  1007,  2550,  2551,  2552,  2553,     0,
     823,     0,     0,  2560,     0,     0,     0,  2572,   823,     0,
    2574,     0,     0,  2581,  2582,  2583,  2584,  2585,  2586,  2587,
    2588,  2589,     0,  2590,     0,     0,     0,     0,     0,     0,
    1204,     0,  2618,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1783,     0,     0,     0,
       0,  1784,     0,     0,     0,     0,     0,     0,   822,     0,
       0,     0,  1013,     0,  1929,     0,  1013,  1013,     0,     0,
       0,     0,  1785,  1786,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,     0,     0,  1787,  1004,  1004,
       0,     0,     0,     0,     0,     0,     0,     0,  1928,     0,
       0,     0,     0,  1928,     0,  1928,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1788,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1013,
     823,  1789,     0,     0,  1790,     0,     0,     0,     0,     0,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,     0,   822,     0,     0,   822,     0,     0,  1267,
       0,     0,     0,  1004,     0,     0,     0,  1773,     0,     0,
    1774,     0,     0,     0,  1775,  1776,  1777,     0,  1013,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1778,   823,  1928,     0,     0,     0,     0,     0,  1780,
    1004,     0,     0,     0,     0,  1781,     0,     0,     0,     0,
       0,     0,  1791,     0,     0,     0,  1006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   823,  1782,
       0,     0,     0,     0,     0,     0,  1006,     0,   822,   822,
       0,     0,     0,     0,     0,  1006,     0,     0,     0,     0,
     823,   822,     0,   822,     0,     0,     0,     0,   823,  1007,
    2728,     0,     0,     0,     0,     0,  1773,     0,  4361,  1774,
       0,     0,     0,  1775,  1776,  1777,     0,     0,     0,  1007,
       0,     0,     0,     0,     0,     0,     0,     0,  1007,     0,
    1778,     0,     0,  3735,     0,     0,     0,     0,  1780,     0,
       0,     0,     0,     0,  1781,  1792,     0,     0,  1793,  1794,
    1795,     0,  1796,  1797,  1798,  1799,  1800,  1801,     0,     0,
       0,  1006,     0,     0,     0,     0,     0,     0,  1782,     0,
       0,  1013,     0,     0,  1783,  1929,     0,     0,     0,  1784,
       0,  1929,     0,     0,     0,     0,     0,   822,     0,     0,
       0,     0,     0,  1004,     0,     0,     0,     0,     0,     0,
    1785,  1786,     0,     0,  1007,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1787,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,     0,     0,     0,     0,  1788,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1789,
       0,     0,  1790,  1004,     0,  1006,   823,     0,     0,     0,
       0,     0,     0,  1783,     0,     0,     0,     0,  1784,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1785,
    1786,     0,     0,     0,     0,     0,     0,     0,  1007,     0,
       0,     0,     0,     0,  1787,     0,  2957,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     823,     0,     0,     0,     0,     0,     0,     0,  4515,     0,
    1791,     0,     0,     0,     0,  1788,   823,   823,     0,     0,
       0,     0,     0,     0,  1228,     0,     0,     0,  1789,  1013,
       0,  1790,     0,     0,     0,     0,     0,     0,     0,  3681,
       0,     0,     0,   823,     0,     0,   823,     0,     0,     0,
    1013,  1004,     0,     0,     0,     0,     0,  4562,     0,     0,
       0,  1013,  1773,     0,     0,  1774,     0,     0,     0,  1775,
    1776,  1777,  1004,     0,     0,     0,     0,     0,     0,   822,
       0,     0,  1928,  1004,     0,     0,  1778,     0,     0,     0,
       0,     0,     0,     0,  1780,     0,     0,     0,     0,     0,
    1781,     0,     0,  1792,     0,   822,  1793,  1794,  1795,  1791,
    1796,  1797,  1798,  1799,  1800,  1801,     0,   822,     0,     0,
    1929,  1929,  1929,     0,  1782,     0,     0,     0,  3096,     0,
       0,     0,     0,     0,     0,   822,     0,     0,  1006,     0,
    1009,     0,     0,     0,   823,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   823,     0,     0,     0,
     823,  1009,     0,     0,     0,     0,  4627,     0,     0,     0,
     823,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1007,   822,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1006,  1792,     0,     0,  1793,  1794,  1795,     0,  1796,
    1797,  1798,  1799,  1800,  1801,     0,     0,  3149,     0,     0,
       0,     0,  3155,     0,     0,     0,     0,     0,     0,  1783,
       0,     0,     0,   823,  1784,     0,  1006,     0,     0,     0,
       0,     0,     0,     0,  1007,     0,  4683,  1766,     0,     0,
       0,     0,     0,     0,     0,  1785,  1786,     0,  2532,     0,
    2532,  2532,     0,  1013,     0,     0,  1013,     0,  1013,  1929,
    1787,  3213,     0,  1013,  3216,   823,  3218,   823,     0,  1007,
       0,     0,     0,     0,     0,  1004,     0,     0,  1004,   823,
    1004,   823,   822,     0,     0,  1004,     0,     0,     0,     0,
       0,  1788,     0,     0,     0,  3236,     0,  3239,     0,  3241,
       0,     0,     0,     0,  1789,     0,  1006,  1790,     0,     0,
       0,     0,     0,     0,  1013,     0,     0,     0,     0,     0,
       0,  1006,     0,     0,     0,     0,     0,     0,     0,  1006,
       0,  1013,  2618,  2618,  2618,   823,  1004,     0,     0,     0,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,  1007,
    3289,     0,     0,  1004,     0,  1013,     0,     0,     0,     0,
       0,     0,  1949,     0,  1007,     0,     0,  3299,     0,     0,
       0,     0,  1007,  1964,     0,     0,     0,  1004,     0,     0,
       0,     0,     0,  1007,     0,  1791,   822,  1006,   822,     0,
       0,     0,   823,     0,     0,     0,     0,     0,     0,     0,
    1006,     0,     0,     0,     0,     0,     0,   823,     0,     0,
       0,     0,  1006,     0,     0,     0,  1009,     0,  1013,     0,
    1013,     0,     0,     0,  1006,     0,   822,     0,     0,   823,
    1007,     0,   823,  3336,     0,     0,  1009,     0,     0,     0,
    1004,     0,  1004,  1007,     0,  1009,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1007,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1007,  1006,     0,
       0,  1006,  1928,     0,   822,     0,     0,     0,  1792,  1013,
       0,  1793,  1794,  1795,     0,  1796,  1797,  1798,  1799,  1800,
    1801,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,     0,     0,  1013,     0,     0,     0,     0,  1929,
       0,  1007,     0,     0,  1007,     0,     0,     0,     0,     0,
       0,  1009,     0,     0,     0,     0,  1004,     0,  1013,     0,
       0,     0,     0,     0,     0,  1013,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,     0,     0,     0,     0,     0,     0,  1004,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,     0,     0,     0,     0,     0,     0,
    1006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,     0,     0,     0,  1004,     0,     0,     0,     0,
       0,     0,     0,     0,  1013,  1009,     0,     0,     0,     0,
       0,     0,     0,  1004,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1007,     0,     0,  1004,     0,     0,     0,
       0,     0,     0,     0,     0,  1928,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     823,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1929,     0,     0,     0,     0,  1929,     0,  1929,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1013,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1013,  1004,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   823,     0,     0,   823,  1010,
    1004,     0,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1010,     0,     0,     0,     0,  1004,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1929,     0,  1013,     0,     0,
       0,     0,     0,     0,  1006,     0,     0,     0,  1006,  1006,
       0,     0,     0,     0,     0,     0,     0,     0,  1009,  1004,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   822,     0,     0,     0,     0,     0,     0,
     823,   823,     0,     0,     0,     0,     0,  1007,     0,     0,
       0,  1007,  1007,   823,     0,   823,     0,     0,     0,     0,
    3682,     0,     0,     0,     0,     0,     0,     0,     0,  3686,
       0,  1006,     0,     0,     0,  3687,     0,  3688,     0,     0,
       0,  1009,     0,  1006,     0,     0,     0,     0,  1013,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3712,  3713,     0,     0,   822,     0,
    1004,     0,     0,     0,  1007,     0,  1009,     0,     0,     0,
    1006,     0,  2538,     0,     0,     0,  1007,     0,     0,     0,
    3738,     0,     0,  3741,     0,  3743,     0,     0,     0,     0,
       0,     0,     0,     0,  3747,     0,     0,     0,     0,   823,
       0,     0,  3754,  3755,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1007,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,     0,  3799,     0,     0,     0,     0,     0,  3806,
    3807,  2618,     0,     0,     0,     0,  1009,     0,     0,     0,
       0,     0,     0,  1004,     0,     0,  1928,     0,     0,     0,
       0,  1009,     0,     0,     0,  3822,     0,     0,     0,  1009,
       0,     0,     0,     0,     0,     0,     0,     0,  1267,     0,
    1009,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1010,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1010,     0,     0,  1928,     0,
       0,     0,     0,  1006,  1010,     0,     0,  1009,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1928,     0,     0,
    1009,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1009,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1009,     0,  1007,     0,     0,  1013,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,     0,  1006,     0,     0,     0,     0,     0,     0,
    1010,     0,     0,     0,     0,     0,     0,     0,  1009,     0,
       0,  1009,     0,     0,     0,     0,     0,     0,  1013,     0,
       0,   823,     0,     0,  1929,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,     0,     0,     0,
    1004,     0,     0,     0,     0,     0,     0,   823,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   823,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   823,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1010,     0,     0,     0,     0,     0,
       0,  1006,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   823,     0,     0,     0,     0,     0,
       0,     0,  1006,     0,     0,     0,     0,     0,     0,     0,
    1009,     0,     0,  1006,     0,     0,     0,     0,     0,  1013,
       0,     0,     0,     0,  1007,     0,     0,     0,     0,  1013,
       0,     0,     0,     0,     0,  4064,  4065,     0,     0,     0,
       0,  1004,     0,     0,     0,  1007,     0,     0,     0,     0,
       0,  1004,     0,     0,     0,     0,  1007,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   823,     0,     0,     0,     0,     0,
       0,  4105,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4110,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1012,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1013,
       0,     0,     0,     0,     0,     0,     0,  1012,     0,     0,
       0,     0,  4125,  4127,     0,     0,     0,     0,     0,  4131,
    4132,  1004,     0,     0,  4133,     0,     0,  1010,  1013,  4136,
       0,     0,  4139,  4140,     0,     0,     0,  4144,     0,     0,
       0,     0,     0,  4148,     0,     0,     0,  1013,     0,     0,
    1004,     0,     0,     0,     0,     0,     0,     0,   823,     0,
     823,     0,     0,     0,     0,  1006,     0,     0,  1006,  1004,
    1006,     0,     0,     0,  1009,  1006,     0,  2618,  1009,  1009,
       0,     0,  2618,     0,     0,     0,     0,     0,  2618,     0,
    1010,     0,     0,     0,     0,     0,     0,     0,   823,     0,
       0,  1013,     0,  1204,     0,     0,     0,     0,  1007,     0,
       0,  1007,     0,  1007,     0,     0,     0,     0,  1007,     0,
       0,     0,     0,  1004,     0,  1010,  1006,  4203,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,     0,  1006,  1929,     0,   823,     0,     0,     0,
       0,     0,     0,  1009,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1006,     0,  1007,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,     0,     0,     0,
    1009,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,     0,  1010,     0,     0,  4259,     0,
    1007,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1010,     0,     0,     0,     0,  1004,     0,     0,  1010,     0,
    1006,     0,  1006,     0,     0,     0,     0,     0,     0,  1010,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1013,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,  1012,  1007,     0,  1007,     0,     0,     0,     0,
       0,     0,  4304,     0,     0,     0,  1010,     0,     0,     0,
       0,  1006,  1012,     0,     0,     0,     0,     0,     0,  1010,
       0,  1012,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1010,     0,     0,     0,     0,  1006,     0,     0,     0,
       0,     0,     0,  1010,     0,     0,     0,  1929,     0,     0,
       0,     0,     0,     0,  1007,     0,     0,     0,     0,     0,
    1006,     0,     0,  1009,     0,     0,     0,  1006,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1007,
       0,     0,     0,     0,     0,     0,     0,  1010,     0,     0,
    1010,     0,  1013,     0,     0,     0,     0,  1012,     0,     0,
       0,     0,     0,  1007,     0,     0,     0,     0,     0,     0,
    1007,     0,     0,     0,  1004,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1006,     0,     0,     0,     0,
       0,     0,     0,  1009,     0,     0,     0,  4396,  4397,     0,
       0,  4398,     0,  1006,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1007,     0,
       0,     0,     0,     0,     0,     0,  4432,  4433,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1007,
       0,  1012,     0,     0,     0,     0,     0,     0,  1013,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1010,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,     0,     0,     0,     0,   823,  1013,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,     0,     0,     0,     0,     0,     0,  1004,  1006,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1009,     0,  1013,     0,     0,     0,     0,     0,
    1006,     0,     0,  1009,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,     0,     0,     0,
       0,     0,  1007,     0,     0,  1006,     0,     0,     0,     0,
     823,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1007,     0,     0,     0,     0,  1013,     0,
       0,     0,  1013,  1013,     0,     0,     0,     0,     0,  1006,
       0,     0,     0,     0,     0,     0,     0,     0,  1007,     0,
    1004,     0,     0,     0,  1004,  1004,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1007,     0,  2538,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1012,     0,     0,     0,  1929,     0,
    4595,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,     0,     0,     0,  1766,     0,     0,     0,     0,
    1006,     0,     0,  1010,     0,     0,     0,  1010,  1010,     0,
       0,     0,     0,  1004,  1267,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1012,     0,     0,
    1929,     0,     0,  1007,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4645,     0,  1009,     0,     0,  1009,  1929,
    1009,     0,     0,     0,     0,  1009,     0,     0,     0,     0,
    1010,     0,  1012,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1006,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4684,  1009,     0,     0,  1010,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,     0,     0,  1007,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1012,     0,     0,     0,     0,  1009,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1012,     0,     0,
       0,     0,     0,     0,     0,  1012,  1803,     0,  4432,     0,
       0,     0,     0,     0,     0,     0,  1012,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4741,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1009,     0,  1009,     0,     0,     0,     0,     0,     0,     0,
       0,  1006,     0,  1012,     0,     0,     0,     0,     0,  1803,
       0,     0,     0,     0,     0,     0,  1012,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1012,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1012,     0,  1010,     0,  1007,     0,     0,     0,     0,     0,
    1006,  1009,  4790,  4790,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4432,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1009,     0,     0,     0,
       0,     0,     0,     0,  1012,     0,     0,  1012,     0,     0,
       0,     0,     0,  1007,     0,     0,     0,     0,     0,     0,
    1009,     0,     0,     0,     0,     0,     0,  1009,     0,     0,
       0,     0,  1010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4790,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4858,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1006,     0,  1009,     0,     0,     0,     0,     0,     0,
       0,  1006,     0,     0,     0,     0,  1009,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1012,     0,     0,     0,
       0,     0,     0,     0,  1007,  4790,  4898,     0,     0,     0,
    1010,     0,     0,     0,  1007,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1010,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1006,     0,     0,     0,     0,     0,     0,     0,     0,
    1009,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1006,     0,     0,     0,     0,  1009,     0,     0,     0,     0,
       0,     0,     0,     0,  1007,     0,     0,     0,     0,  1006,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
       0,     0,     0,  1007,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1803,     0,     0,
       0,     0,  1007,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1006,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1012,     0,     0,     0,  1012,  1012,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,     0,     0,     0,
       0,     0,     0,     0,  1010,     0,     0,  1010,     0,  1010,
    1009,     0,  1803,     0,  1010,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1803,     0,     0,     0,
    2520,     0,     0,     0,     0,     0,     0,  1012,     0,     0,
       0,     0,     0,     0,  1803,  1803,  1803,     0,  1803,  1012,
       0,     0,     0,     0,     0,  1006,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1010,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1010,     0,     0,     0,  1012,     0,     0,     0,
    1803,     0,     0,     0,     0,     0,     0,     0,  1007,     0,
       0,  1006,     0,  1009,     0,     0,  1010,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1803,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1007,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1010,
       0,  1010,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1006,     0,     0,     0,     0,     0,
    1010,  1803,     0,     0,     0,     0,     0,     0,     0,  1012,
       0,  1009,     0,  1803,     0,     0,  1803,     0,     0,     0,
       0,     0,     0,     0,     0,  1010,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1007,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1010,
       0,     0,     0,     0,     0,     0,  1010,     0,     0,     0,
    1009,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1012,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1006,     0,     0,     0,  1010,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1010,     0,     0,     0,     0,     0,  1006,     0,
       0,     0,     0,     0,     0,  1010,     0,     0,     0,     0,
       0,     0,     0,  1007,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1006,     0,     0,     0,
       0,  1007,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,     0,     0,     0,     0,     0,  1012,     0,     0,
       0,  1009,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1012,  1007,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1012,
    1006,     0,     0,     0,  1006,  1006,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1010,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1010,
       0,     0,     0,  1007,     0,     0,     0,  1007,  1007,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1010,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,     0,  1006,     0,     0,     0,     0,  1010,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1009,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1007,     0,     0,  1009,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1010,
       0,     0,     0,  1009,     0,     0,     0,     0,     0,     0,
       0,  1012,     0,     0,  1012,     0,  1012,     0,     0,     0,
       0,  1012,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1012,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1012,
       0,     0,  1010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,     0,     0,     0,     0,
       0,     0,     0,  1012,     0,     0,     0,     0,     0,     0,
       0,     0,  1803,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1803,     0,  1803,     0,     0,  2520,  2520,     0,
    3190,  1009,  2520,     0,     0,     0,  1803,     0,     0,  1803,
       0,     0,     0,     0,  1803,     0,     0,     0,     0,     0,
    1803,     0,     0,     0,     0,  1803,  1012,     0,  1012,     0,
       0,     0,  1803,  1803,  1803,  1803,     0,     0,     0,  2520,
    2520,     0,  1803,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1803,     0,  1803,     0,     0,     0,
       0,     0,     0,  1803,  1803,  1803,  1803,  1803,  1803,  1803,
    1803,  1803,  1803,     0,     0,     0,     0,     0,     0,     0,
    1010,     0,     0,     0,     0,     0,     0,  1012,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1803,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1012,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1009,     0,     0,     0,     0,  1010,
       0,     0,     0,     0,     0,     0,  1012,     0,     0,     0,
       0,     0,     0,  1012,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1012,     0,     0,     0,     0,     0,     0,     0,     0,
    1803,     0,     0,     0,     0,     0,     0,     0,     0,  1012,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1012,     0,     0,     0,     0,     0,     0,     0,
    1009,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1010,     0,     0,     0,     0,     0,     0,     0,  1009,     0,
    1010,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1009,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1012,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1012,     0,     0,     0,
    1009,     0,     0,     0,  1009,  1009,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1012,     0,     0,     0,     0,     0,     0,     0,     0,
    1010,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1012,     0,     0,     0,  1010,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1010,  1803,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1012,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1803,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1010,     0,     0,     0,     0,  1012,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1803,     0,     0,     0,     0,     0,  1803,     0,     0,
    1010,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3190,  3190,     0,     0,  2520,  2520,  2520,
    2520,     0,     0,  2520,  2520,  2520,  2520,  2520,  2520,  2520,
    2520,  2520,  2520,  3190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1803,     0,     0,  1803,     0,
    1803,     0,     0,  3190,  3190,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1803,  2520,
    2520,  1803,     0,  1803,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1012,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1010,     0,     0,     0,     0,     0,     0,
       0,  1803,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1803,     0,     0,     0,     0,  1012,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1803,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1010,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1010,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1012,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1012,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1010,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1010,
       0,     0,     0,  1010,  1010,     0,     0,     0,     0,     0,
    2520,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1012,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1012,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1010,     0,     0,  1012,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1012,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1803,     0,     0,     0,  1803,  1803,
    1803,     0,     0,     0,     0,     0,  3190,  3190,  3190,  3190,
       0,     0,     0,     0,  3190,  3190,  3190,  3190,  3190,  3190,
    3190,  3190,  3190,  3190,  1803,  1803,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1803,     0,     0,  1803,     0,  1803,     0,     0,     0,  1803,
       0,     0,  3190,  3190,     0,     0,  1803,  1803,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1012,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1803,     0,     0,     0,     0,     0,     0,  1803,  1803,
       0,     0,     0,     0,     0,     0,     0,  1012,     0,     0,
       0,     0,     0,     0,  1803,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1012,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1012,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1803,  1803,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1012,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1803,     0,     0,
       0,     0,  1803,  2520,     0,     0,     0,     0,     0,     0,
       0,     0,  1012,     0,     0,     0,     0,  1803,     0,  1803,
       0,     0,     0,  1803,  1803,  1803,     0,     0,  1803,     0,
       0,  1803,  1803,     0,     0,     0,  1803,     0,     0,     0,
    1803,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1012,     0,     0,     0,
    1012,  1012,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1803,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1803,     0,     0,     0,     0,     0,     0,     0,  1012,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1803,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3190,  2520,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1803,  1803,
    1803,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1803,  1803,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1803,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1803,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1803,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1803,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1803,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   771,  1122,   593,  1123,  1124,  1125,   646,  1126,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,  2612,   229,   230,   231,     0,     0,
    1803,     0,  1127,     0,     0,   232,   233,     0,   234,   235,
     772,   236,   237,   238,   239,  1128,   773,  1129,  1130,     0,
     243,   244,   245,   246,   247,  1131,  1132,   248,   249,  1133,
    1134,   252,     0,   253,   254,   255,   256,  1135,     0,  1136,
    1803,   258,   259,   260,   261,   775,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,   776,   271,   272,
     273,  1137,  1138,  1139,  1140,  1141,  1142,  1143,   274,   275,
     276,   277,   278,   279,  1144,  1145,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,  2613,
       0,   292,   293,   985,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,  1146,
     308,   309,   310,  1147,  1148,   312,     0,   313,   314,  1149,
     316,     0,   317,     0,   318,   778,     0,   779,   319,   320,
     321,     0,   322,  1150,     0,  1151,   325,     0,   326,   327,
     328,   329,   330,   780,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,   781,   342,   343,
     344,   345,   346,  1152,  1153,     0,  1154,     0,   350,   782,
     783,   351,   784,   352,   353,   354,   355,   356,     0,     0,
     357,  1155,   785,   359,   786,     0,   360,   361,   362,  1156,
    1157,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,  1158,   787,  1159,   380,
     381,   382,  1160,   383,   384,   788,   385,  1161,  1162,   387,
    1163,   389,   390,   391,     0,   392,     0,     0,  1164,   394,
     395,     0,     0,   396,   397,   789,   398,   790,  1165,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,  1166,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,  1167,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   791,   441,   442,   443,  1168,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,  1169,   458,   459,   460,   461,   462,   792,
     463,   464,  1170,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,  1171,     0,   479,   480,
       0,   481,   793,   482,   483,   484,   485,   486,     0,  1172,
    1173,     0,     0,   489,   490,  1174,   492,  1175,  1176,   494,
     495,   496,   497,   498,   499,   500,     0,  1177,   501,   502,
     503,   504,   505,  1178,     0,   506,   507,   508,   509,   510,
     511,  1179,  2614,   513,   794,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,   534,
     535,   536,  1188,     0,     0,     0,     0,     0,     0,  1189,
    1190,  2615,     0,     0,     0,     0,     0,     0,  1192,  2616,
     771,  1122,   593,  1123,  1124,  1125,   646,  1126,     0,     0,
       0,     0,     0,     0,     0,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   229,   230,   231,     0,     0,     0,
       0,  1127,     0,     0,   232,   233,     0,   234,   235,   772,
     236,   237,   238,   239,  1128,   773,  1129,  1130,     0,   243,
     244,   245,   246,   247,  1131,  1132,   248,   249,  1133,  1134,
     252,     0,   253,   254,   255,   256,  1135,     0,  1136,     0,
     258,   259,   260,   261,   775,   262,   263,   264,     0,   265,
     266,   267,   268,   269,   270,     0,   776,   271,   272,   273,
    1137,  1138,  1139,  1140,  1141,  1142,  1143,   274,   275,   276,
     277,   278,   279,  1144,  1145,   282,     0,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   985,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,   303,   304,   305,   306,  1146,   308,
     309,   310,  1147,  1148,   312,     0,   313,   314,  1149,   316,
       0,   317,     0,   318,   778,     0,   779,   319,   320,   321,
       0,   322,  1150,     0,  1151,   325,     0,   326,   327,   328,
     329,   330,   780,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,   781,   342,   343,   344,
     345,   346,  1152,  1153,     0,  1154,     0,   350,   782,   783,
     351,   784,   352,   353,   354,   355,   356,     0,     0,   357,
    1155,   785,   359,   786,     0,   360,   361,   362,  1156,  1157,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,  1158,   787,  1159,   380,   381,
     382,  1160,   383,   384,   788,   385,  1161,  1162,   387,  1163,
     389,   390,   391,     0,   392,     0,     0,  1164,   394,   395,
       0,     0,   396,   397,   789,   398,   790,  1165,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,  1166,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,  1167,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   791,   441,   442,   443,  1168,   445,   446,
     447,   448,   449,   450,   451,   452,    39,   453,   454,   455,
     456,   457,  1169,   458,   459,   460,   461,   462,   792,   463,
     464,  1170,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,  1171,     0,   479,   480,    43,
     481,   793,   482,   483,   484,   485,   486,     0,  1172,  1173,
       0,     0,   489,   490,  1174,   492,  1175,  1176,   494,   495,
     496,   497,   498,   499,   500,     0,  1177,   501,   502,   503,
     504,   505,  1178,     0,   506,   507,   508,   509,   510,  1058,
    1179,     0,   513,   794,   514,   515,   516,   517,     0,     0,
     518,     0,    48,   519,   520,   521,   522,   523,   524,   525,
    1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,   534,   535,
     536,  1188,     0,    49,     0,     0,     0,     0,  1189,  1190,
       0,     0,     0,     0,     0,     0,     0,  1192,  4607,   771,
    1122,   593,  1123,  1124,  1125,   646,  1126,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
    1127,     0,     0,   232,   233,     0,   234,   235,   772,   236,
     237,   238,   239,  1128,   773,  1129,  1130,     0,   243,   244,
     245,   246,   247,  1131,  1132,   248,   249,  1133,  1134,   252,
       0,   253,   254,   255,   256,  1135,     0,  1136,     0,   258,
     259,   260,   261,   775,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,   776,   271,   272,   273,  1137,
    1138,  1139,  1140,  1141,  1142,  1143,   274,   275,   276,   277,
     278,   279,  1144,  1145,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   985,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,  1146,   308,   309,
     310,  1147,  1148,   312,     0,   313,   314,  1149,   316,     0,
     317,     0,   318,   778,     0,   779,   319,   320,   321,     0,
     322,  1150,     0,  1151,   325,     0,   326,   327,   328,   329,
     330,   780,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,   781,   342,   343,   344,   345,
     346,  1152,  1153,     0,  1154,     0,   350,   782,   783,   351,
     784,   352,   353,   354,   355,   356,     0,     0,   357,  1155,
     785,   359,   786,     0,   360,   361,   362,  1156,  1157,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1158,   787,  1159,   380,   381,   382,
    1160,   383,   384,   788,   385,  1161,  1162,   387,  1163,   389,
     390,   391,     0,   392,     0,     0,  1164,   394,   395,     0,
       0,   396,   397,   789,   398,   790,  1165,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,  1166,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,  1167,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   791,   441,   442,   443,  1168,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,  1169,   458,   459,   460,   461,   462,   792,   463,   464,
    1170,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,  1171,     0,   479,   480,     0,   481,
     793,   482,   483,   484,   485,   486,     0,  1172,  1173,     0,
       0,   489,   490,  1174,   492,  1175,  1176,   494,   495,   496,
     497,   498,   499,   500,     0,  1177,   501,   502,   503,   504,
     505,  1178,     0,   506,   507,   508,   509,   510,   511,  1179,
       0,   513,   794,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,   534,   535,   536,
    1188,     0,     0,     0,     0,     0,     0,  1189,  1190,     0,
       0,     0,     0,     0,     0,     0,  1192,  2522,   771,  1122,
     593,  1123,  1124,  1125,   646,  1126,     0,     0,     0,     0,
       0,     0,     0,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,  1127,
       0,     0,   232,   233,     0,   234,   235,   772,   236,   237,
     238,   239,  1128,   773,  1129,  1130,     0,   243,   244,   245,
     246,   247,  1131,  1132,   248,   249,  1133,  1134,   252,     0,
     253,   254,   255,   256,  1135,     0,  1136,     0,   258,   259,
     260,   261,   775,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,   776,   271,   272,   273,  1137,  1138,
    1139,  1140,  1141,  1142,  1143,   274,   275,   276,   277,   278,
     279,  1144,  1145,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     985,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,  1146,   308,   309,   310,
    1147,  1148,   312,     0,   313,   314,  1149,   316,     0,   317,
       0,   318,   778,     0,   779,   319,   320,   321,     0,   322,
    1150,     0,  1151,   325,     0,   326,   327,   328,   329,   330,
     780,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,   781,   342,   343,   344,   345,   346,
    1152,  1153,     0,  1154,     0,   350,   782,   783,   351,   784,
     352,   353,   354,   355,   356,     0,     0,   357,  1155,   785,
     359,   786,     0,   360,   361,   362,  1156,  1157,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,  1158,   787,  1159,   380,   381,   382,  1160,
     383,   384,   788,   385,  1161,  1162,   387,  1163,   389,   390,
     391,     0,   392,     0,     0,  1164,   394,   395,     0,     0,
     396,   397,   789,   398,   790,  1165,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,  1166,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,  1167,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   791,   441,   442,   443,  1168,   445,   446,   447,   448,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
    1169,   458,   459,   460,   461,   462,   792,   463,   464,  1170,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,  1171,     0,   479,   480,     0,   481,   793,
     482,   483,   484,   485,   486,     0,  1172,  1173,     0,     0,
     489,   490,  1174,   492,  1175,  1176,   494,   495,   496,   497,
     498,   499,   500,     0,  1177,   501,   502,   503,   504,   505,
    1178,     0,   506,   507,   508,   509,   510,   511,  1179,     0,
     513,   794,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   525,  1180,  1181,
    1182,  1183,  1184,  1185,  1186,  1187,   534,   535,   536,  1188,
       0,     0,     0,     0,     0,     0,  1189,  1190,     0,     0,
       0,     0,     0,     0,     0,  1192,  3690,   771,  1122,   593,
    1123,  1124,  1125,   646,  1126,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,  1127,     0,
       0,   232,   233,     0,   234,   235,   772,   236,   237,   238,
     239,  1128,   773,  1129,  1130,     0,   243,   244,   245,   246,
     247,  1131,  1132,   248,   249,  1133,  1134,   252,     0,   253,
     254,   255,   256,  1135,     0,  1136,     0,   258,   259,   260,
     261,   775,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,   776,   271,   272,   273,  1137,  1138,  1139,
    1140,  1141,  1142,  1143,   274,   275,   276,   277,   278,   279,
    1144,  1145,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   985,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,  1146,   308,   309,   310,  1147,
    1148,   312,     0,   313,   314,  1149,   316,     0,   317,     0,
     318,   778,     0,   779,   319,   320,   321,     0,   322,  1150,
       0,  1151,   325,     0,   326,   327,   328,   329,   330,   780,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,   781,   342,   343,   344,   345,   346,  1152,
    1153,     0,  1154,     0,   350,   782,   783,   351,   784,   352,
     353,   354,   355,   356,     0,     0,   357,  1155,   785,   359,
     786,     0,   360,   361,   362,  1156,  1157,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,  1158,   787,  1159,   380,   381,   382,  1160,   383,
     384,   788,   385,  1161,  1162,   387,  1163,   389,   390,   391,
       0,   392,     0,     0,  1164,   394,   395,     0,     0,   396,
     397,   789,   398,   790,  1165,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,  1166,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
    1167,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     791,   441,   442,   443,  1168,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,  1169,
     458,   459,   460,   461,   462,   792,   463,   464,  1170,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,  1171,     0,   479,   480,     0,   481,   793,   482,
     483,   484,   485,   486,     0,  1172,  1173,     0,     0,   489,
     490,  1174,   492,  1175,  1176,   494,   495,   496,   497,   498,
     499,   500,     0,  1177,   501,   502,   503,   504,   505,  1178,
       0,   506,   507,   508,   509,   510,   511,  1179,     0,   513,
     794,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,   534,   535,   536,  1188,     0,
       0,   219,     0,     0,     0,  1189,  1190,     0,     0,     0,
       0,     0,     0,     0,  1192,  3761,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,  3777,     0,   232,   233,     0,   234,   235,
       0,   236,   237,   238,   239,   240,     0,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,     0,
       0,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0, -1577,   271,   272,
     273,     0,     0,     0,     0,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,     0,     0, -1577,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,   330,     0,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341, -1577,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,   351, -1577,   352,   353,   354,   355,   356,     0,     0,
     357,   358, -1577,   359,     0,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378, -1577,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440, -1577,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,     0,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,     0,   482,   483,   484,   485,   486,     0,   487,
     488,     0,     0,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,     0,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,     0,     0,     0,   977,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1274,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,     0,     0,     0,   232,
     233,     0,   234,   235,   772,   236,   237,   238,     0,   978,
     773,   979,   980,     0,   243,   244,   245,   246,   247,     0,
       0,   248,   249,   981,   982,   252,     0,   253,   254,   255,
     256,     0,     0,   774,     0,   258,   259,   260,   261,   775,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,   776,   271,   272,   273,     0,     0,     0,   777,     0,
       0,     0,   274,   275,   276,   277,   278,   279,   983,   984,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   985,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,     0,   308,   309,   310,     0,     0,   312,
       0,   313,   314,   986,   316,     0,   317,     0,   318,   778,
       0,   779,   319,   320,   321,     0,   322,     0,     0,     0,
     325,     0,   326,   327,   328,   329,   330,   780,   331,   332,
     333,   334,  1984,   335,   336,   337,   338,   339,   340,     0,
     341,   781,  1985,   343,   344,   345,   346,   988,   989,     0,
     990,     0,   350,   782,   783,   351,   784,   352,   353,   354,
     355,   356,     0,     0,   357,     0,   785,   359,   786,     0,
     360,   361,   362,     0,     0,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     991,   787,   992,   380,   381,     0,     0,   383,   384,   788,
     385,     0,     0,   387,   993,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,  1987,   789,
     398,   790,     0,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,     0,   410,     0,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   994,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   791,   441,
     442,   443,     0,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,     0,   458,   459,
    1988,   461,   462,   792,   463,   464,   996,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
       0,     0,   479,   480,     0,   481,   793,   482,   483,   484,
     485,   486,     0,   997,   998,     0,     0,   489,   490,     0,
     492,     0,     0,   494,   495,   496,   497,   498,   499,   500,
       0,     0,   501,   502,   503,   504,   505,     0,     0,   506,
     507,   508,   509,   510,     0,   999,  1989,   513,   794,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   977,     0,     0,     0,     0,     0,
       0,     0,     0,   534,   535,   536,     0,     0,     0,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   229,   230,
     231,     0,     0,  2093,     0,     0,     0,     0,   232,   233,
       0,   234,   235,   772,   236,   237,   238,     0,   978,   773,
     979,   980,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   981,   982,   252,     0,   253,   254,   255,   256,
       0,     0,   774,     0,   258,   259,   260,   261,   775,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
     776,   271,   272,   273,     0,     0,     0,   777,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   983,   984,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   985,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,     0,   308,   309,   310,     0,     0,   312,     0,
     313,   314,   986,   316,     0,   317,     0,   318,   778,     0,
     779,   319,   320,   321,     0,   322,     0,     0,     0,   325,
       0,   326,   327,   328,   329,   330,   780,   331,   332,   333,
     334,  1984,   335,   336,   337,   338,   339,   340,     0,   341,
     781,  1985,   343,   344,   345,   346,   988,   989,     0,   990,
       0,   350,   782,   783,   351,   784,   352,   353,   354,   355,
     356,     0,     0,   357,     0,   785,   359,   786,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   991,
     787,   992,   380,   381,     0,     0,   383,   384,   788,   385,
       0,     0,   387,   993,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,  1987,   789,   398,
     790,     0,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   410,     0,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   994,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   791,   441,   442,
     443,     0,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,  1988,
     461,   462,   792,   463,   464,   996,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,   479,   480,     0,   481,   793,   482,   483,   484,   485,
     486,     0,   997,   998,     0,     0,   489,   490,     0,   492,
       0,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,     0,   999,  1989,   513,   794,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   771,  1122,   593,  1123,  1124,  1125,   646,
    1126,     0,   534,   535,   536,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,  3031,     0,  1127,     0,     0,   232,   233,     0,
     234,   235,   772,   236,   237,   238,   239,  1128,   773,  1129,
    1130,     0,   243,   244,   245,   246,   247,  1131,  1132,   248,
     249,  1133,  1134,   252,     0,   253,   254,   255,   256,  1135,
       0,  1136,     0,   258,   259,   260,   261,   775,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,   776,
     271,   272,   273,  1137,  1138,  1139,  1140,  1141,  1142,  1143,
     274,   275,   276,   277,   278,   279,  1144,  1145,   282,  1266,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   985,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,  1146,   308,   309,   310,  1147,  1148,   312,     0,   313,
     314,  1149,   316,     0,   317,     0,   318,   778,     0,   779,
     319,   320,   321,     0,   322,  1150,     0,  1151,   325,     0,
     326,   327,   328,   329,   330,   780,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,   781,
     342,   343,   344,   345,   346,  1152,  1153,     0,  1154,     0,
     350,   782,   783,   351,   784,   352,   353,   354,   355,   356,
       0,     0,   357,  1155,   785,   359,   786,     0,   360,   361,
     362,  1156,  1157,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,  1158,   787,
    1159,   380,   381,   382,  1160,   383,   384,   788,   385,  1161,
    1162,   387,  1163,   389,   390,   391,     0,   392,     0,     0,
    1164,   394,   395,     0,     0,   396,   397,   789,   398,   790,
    1165,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,  1166,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,  1167,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   791,   441,   442,   443,
    1168,   445,   446,   447,   448,   449,   450,   451,   452,    39,
     453,   454,   455,   456,   457,  1169,   458,   459,   460,   461,
     462,   792,   463,   464,  1170,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,  1171,     0,
     479,   480,    43,   481,   793,   482,   483,   484,   485,   486,
       0,  1172,  1173,     0,     0,   489,   490,  1174,   492,  1175,
    1176,   494,   495,   496,   497,   498,   499,   500,     0,  1177,
     501,   502,   503,   504,   505,  1178,     0,   506,   507,   508,
     509,   510,  1058,  1179,     0,   513,   794,   514,   515,   516,
     517,     0,     0,   518,     0,    48,   519,   520,   521,   522,
     523,   524,   525,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,   534,   535,   536,  1188,     0,    49,     0,     0,     0,
       0,  1189,  1190,     0,     0,     0,     0,     0,     0,     0,
    1192,   771,  1122,   593,  1123,  1124,  1125,   646,  1126,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,  1127,     0,     0,   232,   233,     0,   234,   235,
     772,   236,   237,   238,   239,  1128,   773,  1129,  1130,     0,
     243,   244,   245,   246,   247,  1131,  1132,   248,   249,  1133,
    1134,   252,     0,   253,   254,   255,   256,  1135,     0,  1136,
       0,   258,   259,   260,   261,   775,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,   776,   271,   272,
     273,  1137,  1138,  1139,  1140,  1141,  1142,  1143,   274,   275,
     276,   277,   278,   279,  1144,  1145,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   985,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,  1146,
     308,   309,   310,  1147,  1148,   312,     0,   313,   314,  1149,
     316,     0,   317,     0,   318,   778,     0,   779,   319,   320,
     321,     0,   322,  1150,     0,  1151,   325,     0,   326,   327,
     328,   329,   330,   780,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,   781,   342,   343,
     344,   345,   346,  1152,  1153,     0,  1154,     0,   350,   782,
     783,   351,   784,   352,   353,   354,   355,   356,     0,     0,
     357,  1155,   785,   359,   786,     0,   360,   361,   362,  1156,
    1157,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,  1158,   787,  1159,   380,
     381,   382,  1160,   383,   384,   788,   385,  1161,  1162,   387,
    1163,   389,   390,   391,     0,   392,     0,     0,  1164,   394,
     395,     0,     0,   396,   397,   789,   398,   790,  1165,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,  1166,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,  1167,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   791,   441,   442,   443,  1168,   445,
     446,   447,   448,   449,   450,   451,   452,    39,   453,   454,
     455,   456,   457,  1169,   458,   459,   460,   461,   462,   792,
     463,   464,  1170,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,  1171,     0,   479,   480,
      43,   481,   793,   482,   483,   484,   485,   486,     0,  1172,
    1173,     0,     0,   489,   490,  1174,   492,  1175,  1176,   494,
     495,   496,   497,   498,   499,   500,     0,  1177,   501,   502,
     503,   504,   505,  1178,     0,   506,   507,   508,   509,   510,
    1058,  1179,     0,   513,   794,   514,   515,   516,   517,     0,
       0,   518,     0,    48,   519,   520,   521,   522,   523,   524,
     525,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,   534,
     535,   536,  1188,     0,    49,     0,     0,     0,     0,  1189,
    1190,     0,     0,     0,     0,     0,     0,     0,  1192,   771,
    1122,   593,  1123,  1124,  1125,   646,  1126,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
    1127,     0,     0,   232,   233,     0,   234,   235,   772,   236,
     237,   238,   239,  1128,   773,  1129,  1130,  2528,   243,   244,
     245,   246,   247,  1131,  1132,   248,   249,  1133,  1134,   252,
       0,   253,   254,   255,   256,  1135,     0,  1136,     0,   258,
     259,   260,   261,   775,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,   776,   271,   272,   273,  1137,
    1138,  1139,  1140,  1141,  1142,  1143,   274,   275,   276,   277,
     278,   279,  1144,  1145,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   985,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,  1146,   308,   309,
     310,  1147,  1148,   312,     0,   313,   314,  1149,   316,     0,
     317,     0,   318,   778,  2529,   779,   319,   320,   321,     0,
     322,  1150,     0,  1151,   325,     0,   326,   327,   328,   329,
     330,   780,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,   781,   342,   343,   344,   345,
     346,  1152,  1153,     0,  1154,     0,   350,   782,   783,   351,
     784,   352,   353,   354,   355,   356,     0,  2530,   357,  1155,
     785,   359,   786,     0,   360,   361,   362,  1156,  1157,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1158,   787,  1159,   380,   381,   382,
    1160,   383,   384,   788,   385,  1161,  1162,   387,  1163,   389,
     390,   391,     0,   392,     0,     0,  1164,   394,   395,     0,
       0,   396,   397,   789,   398,   790,  1165,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,  1166,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,  1167,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   791,   441,   442,   443,  1168,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,  1169,   458,   459,   460,   461,   462,   792,   463,   464,
    1170,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,  1171,     0,   479,   480,     0,   481,
     793,   482,   483,   484,   485,   486,     0,  1172,  1173,     0,
    2531,   489,   490,  1174,   492,  1175,  1176,   494,   495,   496,
     497,   498,   499,   500,     0,  1177,   501,   502,   503,   504,
     505,  1178,     0,   506,   507,   508,   509,   510,   511,  1179,
       0,   513,   794,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,   534,   535,   536,
    1188,     0,     0,     0,     0,     0,     0,  1189,  1190,     0,
       0,     0,     0,     0,     0,     0,  1192,   771,  1122,   593,
    1123,  1124,  1125,   646,  1126,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,  1127,     0,
       0,   232,   233,     0,   234,   235,   772,   236,   237,   238,
     239,  1128,   773,  1129,  1130,     0,   243,   244,   245,   246,
     247,  1131,  1132,   248,   249,  1133,  1134,   252,     0,   253,
     254,   255,   256,  1135,     0,  1136,     0,   258,   259,   260,
     261,   775,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,   776,   271,   272,   273,  1137,  1138,  1139,
    1140,  1141,  1142,  1143,   274,   275,   276,   277,   278,   279,
    1144,  1145,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   985,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,  1146,   308,   309,   310,  1147,
    1148,   312,     0,   313,   314,  1149,   316,     0,   317,     0,
     318,   778,     0,   779,   319,   320,   321,     0,   322,  1150,
       0,  1151,   325,     0,   326,   327,   328,   329,   330,   780,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,   781,   342,   343,   344,   345,   346,  1152,
    1153,     0,  1154,     0,   350,   782,   783,   351,   784,   352,
     353,   354,   355,   356,     0,     0,   357,  1155,   785,   359,
     786,     0,   360,   361,   362,  1156,  1157,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,  1158,   787,  1159,   380,   381,   382,  1160,   383,
     384,   788,   385,  1161,  1162,   387,  1163,   389,   390,   391,
       0,   392,     0,     0,  1164,   394,   395,     0,     0,   396,
     397,   789,   398,   790,  1165,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,  1166,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
    1167,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     791,   441,   442,   443,  1168,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,  1169,
     458,   459,   460,   461,   462,   792,   463,   464,  1170,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,  1171,     0,   479,   480,     0,   481,   793,   482,
     483,   484,   485,   486,     0,  1172,  1173,     0,     0,   489,
     490,  1174,   492,  1175,  1176,   494,   495,   496,   497,   498,
     499,   500,     0,  1177,   501,   502,   503,   504,   505,  1178,
       0,   506,   507,   508,   509,   510,   511,  1179,     0,   513,
     794,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,   534,   535,   536,  1188,     0,
       0,     0,     0,     0,     0,  1189,  1190,     0,     0,     0,
       0,     0,  1727,  2483,  1192,   771,  1122,   593,  1123,  1124,
    1125,   646,  1126,     0,     0,     0,     0,     0,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,  1127,     0,     0,   232,
     233,     0,   234,   235,   772,   236,   237,   238,   239,  1128,
     773,  1129,  1130,     0,   243,   244,   245,   246,   247,  1131,
    1132,   248,   249,  1133,  1134,   252,     0,   253,   254,   255,
     256,  1135,     0,  1136,     0,   258,   259,   260,   261,   775,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,   776,   271,   272,   273,  1137,  1138,  1139,  1140,  1141,
    1142,  1143,   274,   275,   276,   277,   278,   279,  1144,  1145,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   985,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,  1146,   308,   309,   310,  1147,  1148,   312,
       0,   313,   314,  1149,   316,     0,   317,     0,   318,   778,
       0,   779,   319,   320,   321,     0,   322,  1150,     0,  1151,
     325,     0,   326,   327,   328,   329,   330,   780,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,   781,   342,   343,   344,   345,   346,  1152,  1153,     0,
    1154,     0,   350,   782,   783,   351,   784,   352,   353,   354,
     355,   356,     0,     0,   357,  1155,   785,   359,   786,     0,
     360,   361,   362,  1156,  1157,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1158,   787,  1159,   380,   381,   382,  1160,   383,   384,   788,
     385,  1161,  1162,   387,  1163,   389,   390,   391,     0,   392,
       0,     0,  1164,   394,   395,     0,     0,   396,   397,   789,
     398,   790,  1165,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,  1166,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,  1167,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   791,   441,
     442,   443,  1168,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,  1169,   458,   459,
     460,   461,   462,   792,   463,   464,  1170,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
    1171,     0,   479,   480,     0,   481,   793,   482,   483,   484,
     485,   486,     0,  1172,  1173,     0,     0,   489,   490,  1174,
     492,  1175,  1176,   494,   495,   496,   497,   498,   499,   500,
       0,  1177,   501,   502,   503,   504,   505,  1178,     0,   506,
     507,   508,   509,   510,   511,  1179,     0,   513,   794,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,   534,   535,   536,  1188,     0,     0,     0,
       0,     0,     0,  1189,  1190,  1191,     0,     0,     0,     0,
       0,     0,  1192,   771,  1122,   593,  1123,  1124,  1125,   646,
    1126,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,  1127,     0,     0,   232,   233,     0,
     234,   235,   772,   236,   237,   238,   239,  1128,   773,  1129,
    1130,     0,   243,   244,   245,   246,   247,  1131,  1132,   248,
     249,  1133,  1134,   252,     0,   253,   254,   255,   256,  1135,
       0,  1136,     0,   258,   259,   260,   261,   775,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,   776,
     271,   272,   273,  1137,  1138,  1139,  1140,  1141,  1142,  1143,
     274,   275,   276,   277,   278,   279,  1144,  1145,   282,  1266,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   985,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,  1146,   308,   309,   310,  1147,  1148,   312,     0,   313,
     314,  1149,   316,     0,   317,     0,   318,   778,     0,   779,
     319,   320,   321,     0,   322,  1150,     0,  1151,   325,     0,
     326,   327,   328,   329,   330,   780,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,   781,
     342,   343,   344,   345,   346,  1152,  1153,     0,  1154,     0,
     350,   782,   783,   351,   784,   352,   353,   354,   355,   356,
       0,     0,   357,  1155,   785,   359,   786,     0,   360,   361,
     362,  1156,  1157,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,  1158,   787,
    1159,   380,   381,   382,  1160,   383,   384,   788,   385,  1161,
    1162,   387,  1163,   389,   390,   391,     0,   392,     0,     0,
    1164,   394,   395,     0,     0,   396,   397,   789,   398,   790,
    1165,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,  1166,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,  1167,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   791,   441,   442,   443,
    1168,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,  1169,   458,   459,   460,   461,
     462,   792,   463,   464,  1170,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,  1171,     0,
     479,   480,     0,   481,   793,   482,   483,   484,   485,   486,
       0,  1172,  1173,     0,     0,   489,   490,  1174,   492,  1175,
    1176,   494,   495,   496,   497,   498,   499,   500,     0,  1177,
     501,   502,   503,   504,   505,  1178,     0,   506,   507,   508,
     509,   510,   511,  1179,     0,   513,   794,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,   534,   535,   536,  1188,     0,     0,     0,     0,     0,
       0,  1189,  1190,     0,     0,     0,     0,     0,     0,     0,
    1192,   771,  1122,   593,  1123,  1124,  1125,   646,  1126,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,  1959,   229,   230,   231,     0,     0,
       0,     0,  1127,     0,     0,   232,   233,     0,   234,   235,
     772,   236,   237,   238,   239,  1128,   773,  1129,  1130,     0,
     243,   244,   245,   246,   247,  1131,  1132,   248,   249,  1133,
    1134,   252,     0,   253,   254,   255,   256,  1135,     0,  1136,
       0,   258,   259,   260,   261,   775,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,   776,   271,   272,
     273,  1137,  1138,  1139,  1140,  1141,  1142,  1143,   274,   275,
     276,   277,   278,   279,  1144,  1145,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   985,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,  1146,
     308,   309,   310,  1147,  1148,   312,     0,   313,   314,  1149,
     316,     0,   317,     0,   318,   778,     0,   779,   319,   320,
     321,     0,   322,  1150,     0,  1151,   325,     0,   326,   327,
     328,   329,   330,   780,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,   781,   342,   343,
     344,   345,   346,  1152,  1153,     0,  1154,     0,   350,   782,
     783,   351,   784,   352,   353,   354,   355,   356,     0,     0,
     357,  1155,   785,   359,   786,     0,   360,   361,   362,  1156,
    1157,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,  1158,   787,  1159,   380,
     381,   382,  1160,   383,   384,   788,   385,  1161,  1162,   387,
    1163,   389,   390,   391,     0,   392,     0,     0,  1164,   394,
     395,     0,     0,   396,   397,   789,   398,   790,  1165,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,  1166,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,  1167,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   791,   441,   442,   443,  1168,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,  1169,   458,   459,   460,   461,   462,   792,
     463,   464,  1170,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,  1171,     0,   479,   480,
       0,   481,   793,   482,   483,   484,   485,   486,     0,  1172,
    1173,     0,     0,   489,   490,  1174,   492,  1175,  1176,   494,
     495,   496,   497,   498,   499,   500,     0,  1177,   501,   502,
     503,   504,   505,  1178,     0,   506,   507,   508,   509,   510,
     511,  1179,     0,   513,   794,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,   534,
     535,   536,  1188,     0,     0,     0,     0,     0,     0,  1189,
    1190,     0,     0,     0,     0,     0,     0,     0,  1192,   771,
    1122,   593,  1123,  1124,  1125,   646,  1126,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
    1127,     0,     0,   232,   233,     0,   234,   235,   772,   236,
     237,   238,   239,  1128,   773,  1129,  1130,     0,   243,   244,
     245,   246,   247,  1131,  1132,   248,   249,  1133,  1134,   252,
       0,   253,   254,   255,   256,  1135,     0,  1136,     0,   258,
     259,   260,   261,   775,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,   776,   271,   272,   273,  1137,
    1138,  1139,  1140,  1141,  1142,  1143,   274,   275,   276,   277,
     278,   279,  1144,  1145,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   985,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,  1146,   308,   309,
     310,  1147,  1148,   312,     0,   313,   314,  1149,   316,     0,
     317,     0,   318,   778,  2529,   779,   319,   320,   321,     0,
     322,  1150,     0,  1151,   325,     0,   326,   327,   328,   329,
     330,   780,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,   781,   342,   343,   344,   345,
     346,  1152,  1153,     0,  1154,     0,   350,   782,   783,   351,
     784,   352,   353,   354,   355,   356,     0,     0,   357,  1155,
     785,   359,   786,     0,   360,   361,   362,  1156,  1157,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1158,   787,  1159,   380,   381,   382,
    1160,   383,   384,   788,   385,  1161,  1162,   387,  1163,   389,
     390,   391,     0,   392,     0,     0,  1164,   394,   395,     0,
       0,   396,   397,   789,   398,   790,  1165,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,  1166,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,  1167,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   791,   441,   442,   443,  1168,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,  1169,   458,   459,   460,   461,   462,   792,   463,   464,
    1170,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,  1171,     0,   479,   480,     0,   481,
     793,   482,   483,   484,   485,   486,     0,  1172,  1173,     0,
       0,   489,   490,  1174,   492,  1175,  1176,   494,   495,   496,
     497,   498,   499,   500,     0,  1177,   501,   502,   503,   504,
     505,  1178,     0,   506,   507,   508,   509,   510,   511,  1179,
       0,   513,   794,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,   534,   535,   536,
    1188,     0,     0,     0,     0,     0,     0,  1189,  1190,     0,
       0,     0,     0,     0,     0,     0,  1192,   771,  1122,   593,
    1123,  1124,  1125,   646,  1126,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,  1127,     0,
       0,   232,   233,     0,   234,   235,   772,   236,   237,   238,
     239,  1128,   773,  1129,  1130,     0,   243,   244,   245,   246,
     247,  1131,  1132,   248,   249,  1133,  1134,   252,     0,   253,
     254,   255,   256,  1135,     0,  1136,     0,   258,   259,   260,
     261,   775,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,   776,   271,   272,   273,  1137,  1138,  1139,
    1140,  1141,  1142,  1143,   274,   275,   276,   277,   278,   279,
    1144,  1145,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   985,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,  1146,   308,   309,   310,  1147,
    1148,   312,     0,   313,   314,  1149,   316,     0,   317,     0,
     318,   778,     0,   779,   319,   320,   321,     0,   322,  1150,
       0,  1151,   325,     0,   326,   327,   328,   329,   330,   780,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,   781,   342,   343,   344,   345,   346,  1152,
    1153,     0,  1154,     0,   350,   782,   783,   351,   784,   352,
     353,   354,   355,   356,     0,     0,   357,  1155,   785,   359,
     786,     0,   360,   361,   362,  1156,  1157,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,  1158,   787,  1159,   380,   381,   382,  1160,   383,
     384,   788,   385,  1161,  1162,   387,  1163,   389,   390,   391,
       0,   392,     0,     0,  1164,   394,   395,     0,     0,   396,
     397,   789,   398,   790,  1165,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,  1166,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
    1167,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     791,   441,   442,   443,  1168,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,  1169,
     458,   459,   460,   461,   462,   792,   463,   464,  1170,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,  1171,     0,   479,   480,     0,   481,   793,   482,
     483,   484,   485,   486,     0,  1172,  1173,     0,     0,   489,
     490,  1174,   492,  1175,  1176,   494,   495,   496,   497,   498,
     499,   500,     0,  1177,   501,   502,   503,   504,   505,  1178,
       0,   506,   507,   508,   509,   510,   511,  1179,  3808,   513,
     794,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,   534,   535,   536,  1188,     0,
       0,     0,     0,     0,     0,  1189,  1190,     0,     0,     0,
       0,     0,     0,     0,  1192,   771,  1122,   593,  1123,  1124,
    1125,   646,  1126,     0,     0,     0,     0,     0,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,  1127,     0,     0,   232,
     233,     0,   234,   235,   772,   236,   237,   238,   239,  1128,
     773,  1129,  1130,     0,   243,   244,   245,   246,   247,  1131,
    1132,   248,   249,  1133,  1134,   252,     0,   253,   254,   255,
     256,  1135,     0,  1136,     0,   258,   259,   260,   261,   775,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,   776,   271,   272,   273,  1137,  1138,  1139,  1140,  1141,
    1142,  1143,   274,   275,   276,   277,   278,   279,  1144,  1145,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   985,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,  1146,   308,   309,   310,  1147,  1148,   312,
       0,   313,   314,  1149,   316,     0,   317,     0,   318,   778,
       0,   779,   319,   320,   321,     0,   322,  1150,     0,  1151,
     325,     0,   326,   327,   328,   329,   330,   780,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,   781,   342,   343,   344,   345,   346,  1152,  1153,     0,
    1154,     0,   350,   782,   783,   351,   784,   352,   353,   354,
     355,   356,     0,     0,   357,  1155,   785,   359,   786,     0,
     360,   361,   362,  1156,  1157,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1158,   787,  1159,   380,   381,   382,  1160,   383,   384,   788,
     385,  1161,  1162,   387,  1163,   389,   390,   391,     0,   392,
       0,     0,  1164,   394,   395,     0,     0,   396,   397,   789,
     398,   790,  1165,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,  1166,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,  1167,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   791,   441,
     442,   443,  1168,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,  1169,   458,   459,
     460,   461,   462,   792,   463,   464,  1170,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
    1171,     0,   479,   480,     0,   481,   793,   482,   483,   484,
     485,   486,     0,  1172,  1173,     0,     0,   489,   490,  1174,
     492,  1175,  1176,   494,   495,   496,   497,   498,   499,   500,
       0,  1177,   501,   502,   503,   504,   505,  1178,     0,   506,
     507,   508,   509,   510,   511,  1179,     0,   513,   794,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,   534,   535,   536,  1188,     0,     0,     0,
       0,     0,     0,  1189,  1190,     0,     0,     0,     0,     0,
       0,     0,  1192,   771,  1122,   593,  1123,  1124,  1125,   646,
    1126,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,  1127,     0,     0,   232,   233,     0,
     234,   235,   772,   236,   237,   238,   239,  1128,   773,  1129,
    1130,     0,   243,   244,   245,   246,   247,  1131,  1132,   248,
     249,  1133,  1134,   252,     0,   253,   254,   255,   256,  1135,
       0,  1136,     0,   258,   259,   260,   261,   775,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,   776,
     271,   272,  3821,  1137,  1138,  1139,  1140,  1141,  1142,  1143,
     274,   275,   276,   277,   278,   279,  1144,  1145,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   985,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,  1146,   308,   309,   310,  1147,  1148,   312,     0,   313,
     314,  1149,   316,     0,   317,     0,   318,   778,     0,   779,
     319,   320,   321,     0,   322,  1150,     0,  1151,   325,     0,
     326,   327,   328,   329,   330,   780,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,   781,
     342,   343,   344,   345,   346,  1152,  1153,     0,  1154,     0,
     350,   782,   783,   351,   784,   352,   353,   354,   355,   356,
       0,     0,   357,  1155,   785,   359,   786,     0,   360,   361,
     362,  1156,  1157,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,  1158,   787,
    1159,   380,   381,   382,  1160,   383,   384,   788,   385,  1161,
    1162,   387,  1163,   389,   390,   391,     0,   392,     0,     0,
    1164,   394,   395,     0,     0,   396,   397,   789,   398,   790,
    1165,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,  1166,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,  1167,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   791,   441,   442,   443,
    1168,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,  1169,   458,   459,   460,   461,
     462,   792,   463,   464,  1170,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,  1171,     0,
     479,   480,     0,   481,   793,   482,   483,   484,   485,   486,
       0,  1172,  1173,     0,     0,   489,   490,  1174,   492,  1175,
    1176,   494,   495,   496,   497,   498,   499,   500,     0,  1177,
     501,   502,   503,   504,   505,  1178,     0,   506,   507,   508,
     509,   510,   511,  1179,     0,   513,   794,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,   534,   535,   536,  1188,     0,     0,     0,     0,     0,
       0,  1189,  1190,     0,     0,     0,     0,     0,     0,     0,
    1192,   771,  1122,   593,  1123,  1124,  1125,   646,  1126,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,  1127,     0,     0,   232,   233,     0,   234,   235,
     772,   236,   237,   238,   239,  1128,   773,  1129,  1130,     0,
     243,   244,   245,   246,   247,  1131,  1132,   248,   249,  1133,
    1134,   252,     0,   253,   254,   255,   256,  1135,     0,  1136,
       0,   258,   259,   260,   261,   775,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,   776,   271,   272,
     273,  1137,  1138,  1139,  1140,  1141,  1142,  1143,   274,   275,
     276,   277,   278,   279,  1144,  1145,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   985,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,  1146,
     308,   309,   310,  1147,  1148,   312,     0,   313,   314,  1149,
     316,     0,   317,     0,   318,   778,     0,   779,   319,   320,
     321,     0,   322,  1150,     0,  1151,   325,     0,   326,   327,
     328,   329,   330,   780,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,   781,   342,   343,
     344,   345,   346,  1152,  1153,     0,  1154,     0,   350,   782,
     783,   351,   784,   352,   353,   354,   355,   356,     0,     0,
     357,  1155,   785,   359,   786,     0,   360,   361,   362,  1156,
    1157,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,  1158,   787,  1159,   380,
     381,   382,  1160,   383,   384,   788,   385,  1161,  1162,   387,
    1163,   389,   390,   391,     0,   392,     0,     0,  1164,   394,
     395,     0,     0,   396,   397,   789,   398,   790,  1165,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,  1166,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,  1167,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   791,   441,   442,   443,  1168,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,  1169,   458,   459,   460,   461,   462,   792,
     463,   464,  1170,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,  1171,     0,   479,   480,
       0,   481,   793,   482,   483,   484,   485,   486,     0,  1172,
    1173,     0,     0,   489,   490,  1174,   492,  1175,  1176,   494,
     495,   496,   497,   498,   499,   500,     0,  1177,   501,   502,
     503,   504,   505,  1178,     0,   506,   507,   508,   509,   510,
     511,  1179,     0,   513,   794,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
    4117,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,   534,
     535,   536,  1188,     0,     0,     0,     0,     0,     0,  1189,
    1190,     0,     0,     0,     0,     0,     0,     0,  1192,   771,
    1122,   593,  1123,  1124,  1125,   646,  1126,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
    1127,     0,     0,   232,   233,     0,   234,   235,   772,   236,
     237,   238,   239,  1128,   773,  1129,  1130,     0,   243,   244,
     245,   246,   247,  1131,  1132,   248,   249,  1133,  1134,   252,
       0,   253,   254,   255,   256,  1135,     0,  1136,     0,   258,
     259,   260,   261,   775,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,   776,   271,   272,   273,  1137,
    1138,  1139,  1140,  1141,  1142,  1143,   274,   275,   276,   277,
     278,   279,  1144,  1145,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   985,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,  1146,   308,   309,
     310,  1147,  1148,   312,     0,   313,   314,  1149,   316,     0,
     317,     0,   318,   778,     0,   779,   319,   320,   321,     0,
     322,  1150,     0,  1151,   325,     0,   326,   327,   328,   329,
     330,   780,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,   781,   342,   343,   344,   345,
     346,  1152,  1153,     0,  1154,     0,   350,   782,   783,   351,
     784,   352,   353,   354,   355,   356,     0,     0,   357,  1155,
     785,   359,   786,     0,   360,   361,   362,  1156,  1157,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1158,   787,  1159,   380,  4126,   382,
    1160,   383,   384,   788,   385,  1161,  1162,   387,  1163,   389,
     390,   391,     0,   392,     0,     0,  1164,   394,   395,     0,
       0,   396,   397,   789,   398,   790,  1165,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,  1166,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,  1167,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   791,   441,   442,   443,  1168,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,  1169,   458,   459,   460,   461,   462,   792,   463,   464,
    1170,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,  1171,     0,   479,   480,     0,   481,
     793,   482,   483,   484,   485,   486,     0,  1172,  1173,     0,
       0,   489,   490,  1174,   492,  1175,  1176,   494,   495,   496,
     497,   498,   499,   500,     0,  1177,   501,   502,   503,   504,
     505,  1178,     0,   506,   507,   508,   509,   510,   511,  1179,
       0,   513,   794,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,   534,   535,   536,
    1188,     0,     0,     0,     0,     0,     0,  1189,  1190,     0,
       0,     0,     0,     0,     0,     0,  1192,   771,  1122,   593,
    1123,  1124,  1125,   646,  1126,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,  1127,     0,
       0,   232,   233,     0,   234,   235,   772,   236,   237,   238,
     239,  1128,   773,  1129,  1130,     0,   243,   244,   245,   246,
     247,  1131,  1132,   248,   249,  1133,  1134,   252,     0,   253,
     254,   255,   256,  1135,     0,  1136,     0,   258,   259,   260,
     261,   775,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,   776,   271,  4422,   273,  1137,  1138,  1139,
    1140,  1141,  1142,  1143,   274,   275,   276,   277,   278,   279,
    1144,  1145,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   985,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,  1146,   308,   309,   310,  1147,
    1148,   312,     0,   313,   314,  1149,   316,     0,   317,     0,
     318,   778,     0,   779,   319,   320,   321,     0,   322,  1150,
       0,  4423,   325,     0,   326,   327,   328,   329,   330,   780,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,   781,   342,   343,   344,   345,   346,  1152,
    1153,     0,  1154,     0,   350,   782,   783,   351,   784,   352,
     353,   354,   355,   356,     0,     0,   357,  1155,   785,   359,
     786,     0,   360,   361,   362,  1156,  1157,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,  1158,   787,  1159,   380,   381,   382,  1160,   383,
     384,   788,   385,  1161,  1162,   387,  1163,   389,   390,   391,
       0,   392,     0,     0,  1164,   394,   395,     0,     0,   396,
     397,   789,   398,   790,  1165,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,  1166,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
    1167,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     791,   441,   442,  4424,  1168,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,  1169,
     458,   459,   460,   461,   462,   792,   463,   464,  1170,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,  1171,     0,   479,   480,     0,   481,   793,   482,
     483,   484,   485,   486,     0,  1172,  1173,     0,     0,   489,
     490,  1174,   492,  1175,  1176,   494,   495,   496,   497,   498,
     499,   500,     0,  1177,   501,   502,   503,   504,   505,  1178,
       0,   506,   507,   508,   509,   510,   511,  1179,     0,   513,
     794,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,   534,   535,   536,  1188,     0,
       0,     0,     0,     0,     0,  1189,  1190,     0,     0,     0,
       0,     0,     0,     0,  4425,   771,  1122,   593,  1123,  1124,
    1125,   646,  1126,     0,     0,     0,     0,     0,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,  1127,     0,     0,   232,
     233,     0,   234,   235,   772,   236,   237,   238,  4787,  1128,
     773,  1129,  1130,     0,   243,   244,   245,   246,   247,  1131,
    1132,   248,   249,  1133,  1134,   252,     0,   253,   254,   255,
     256,  1135,     0,  1136,     0,   258,   259,   260,   261,   775,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,   776,   271,   272,  4788,  1137,  1138,  1139,  1140,  1141,
    1142,  1143,   274,   275,   276,   277,   278,   279,  1144,  1145,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   985,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,  1146,   308,   309,   310,  1147,  1148,   312,
       0,   313,   314,  1149,   316,     0,   317,     0,   318,   778,
       0,   779,   319,   320,   321,     0,   322,  1150,     0,  1151,
     325,     0,   326,   327,   328,   329,   330,   780,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,   781,   342,   343,   344,   345,   346,  1152,  1153,     0,
    1154,     0,   350,   782,   783,   351,   784,   352,   353,   354,
     355,   356,     0,     0,   357,  1155,   785,   359,   786,     0,
     360,   361,   362,  1156,  1157,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1158,   787,  1159,   380,   381,   382,  1160,   383,   384,   788,
     385,  1161,  1162,   387,  1163,   389,   390,   391,     0,   392,
       0,     0,  1164,   394,   395,     0,     0,   396,   397,   789,
     398,   790,  1165,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,  1166,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,  1167,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   791,   441,
     442,   443,  1168,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,  1169,   458,   459,
     460,   461,   462,   792,   463,   464,  1170,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
    1171,     0,   479,   480,     0,   481,   793,   482,   483,   484,
     485,   486,     0,  1172,  1173,     0,     0,   489,   490,  1174,
     492,  1175,  1176,   494,   495,   496,   497,  4789,   499,   500,
       0,  1177,   501,   502,   503,   504,   505,  1178,     0,   506,
     507,   508,   509,   510,   511,  1179,     0,   513,   794,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,   534,   535,   536,  1188,     0,     0,     0,
       0,     0,     0,  1189,  1190,     0,     0,     0,     0,     0,
       0,     0,  1192,   771,  1122,   593,  1123,  1124,  1125,   646,
    1126,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,  1127,     0,     0,   232,   233,     0,
     234,   235,   772,   236,   237,   238,   239,  1128,   773,  1129,
    1130,     0,   243,   244,   245,   246,   247,  1131,  1132,   248,
     249,  1133,  1134,   252,     0,   253,   254,   255,   256,  1135,
       0,  1136,     0,   258,   259,   260,   261,   775,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,   776,
     271,   272,  4788,  1137,  1138,  1139,  1140,  1141,  1142,  1143,
     274,   275,   276,   277,   278,   279,  1144,  1145,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   985,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,  1146,   308,   309,   310,  1147,  1148,   312,     0,   313,
     314,  1149,   316,     0,   317,     0,   318,   778,     0,   779,
     319,   320,   321,     0,   322,  1150,     0,  1151,   325,     0,
     326,   327,   328,   329,   330,   780,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,   781,
     342,   343,   344,   345,   346,  1152,  1153,     0,  1154,     0,
     350,   782,   783,   351,   784,   352,   353,   354,   355,   356,
       0,     0,   357,  1155,   785,   359,   786,     0,   360,   361,
     362,  1156,  1157,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,  1158,   787,
    1159,   380,   381,   382,  1160,   383,   384,   788,   385,  1161,
    1162,   387,  1163,   389,   390,   391,     0,   392,     0,     0,
    1164,   394,   395,     0,     0,   396,   397,   789,   398,   790,
    1165,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,  1166,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,  1167,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   791,   441,   442,   443,
    1168,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,  1169,   458,   459,   460,   461,
     462,   792,   463,   464,  1170,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,  1171,     0,
     479,   480,     0,   481,   793,   482,   483,   484,   485,   486,
       0,  1172,  1173,     0,     0,   489,   490,  1174,   492,  1175,
    1176,   494,   495,   496,   497,  4789,   499,   500,     0,  1177,
     501,   502,   503,   504,   505,  1178,     0,   506,   507,   508,
     509,   510,   511,  1179,     0,   513,   794,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,   534,   535,   536,  1188,     0,     0,     0,     0,     0,
       0,  1189,  1190,     0,     0,     0,     0,     0,     0,     0,
    1192,   771,  1122,   593,  1123,  1124,  1125,   646,  1126,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,  1127,     0,     0,   232,   233,     0,   234,   235,
     772,   236,   237,   238,   239,  1128,   773,  1129,  1130,     0,
     243,   244,   245,   246,   247,  1131,  1132,   248,   249,  1133,
    1134,   252,     0,   253,   254,   255,   256,  1135,     0,  1136,
       0,   258,   259,   260,   261,   775,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,   776,   271,   272,
     273,  1137,  1138,  1139,  1140,  1141,  1142,  1143,   274,   275,
     276,   277,   278,   279,  1144,  1145,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   985,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,  1146,
     308,   309,   310,  1147,  1148,   312,     0,   313,   314,  1149,
     316,     0,   317,     0,   318,   778,     0,   779,   319,   320,
     321,     0,   322,  1150,     0,  1151,   325,     0,   326,   327,
     328,   329,   330,   780,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,   781,   342,   343,
     344,   345,   346,  1152,  1153,     0,  1154,     0,   350,   782,
     783,   351,   784,   352,   353,   354,   355,   356,     0,     0,
     357,  1155,   785,   359,   786,     0,   360,   361,   362,  1156,
    1157,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,  1158,   787,  1159,   380,
     381,   382,     0,   383,   384,   788,   385,  1161,  1162,   387,
    1163,   389,   390,   391,     0,   392,     0,     0,  1164,   394,
     395,     0,     0,   396,   397,   789,   398,   790,  1165,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,  1166,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,  1167,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   791,   441,   442,   443,  2514,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,  1169,   458,   459,   460,   461,   462,   792,
     463,   464,  1170,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,  1171,     0,   479,   480,
       0,   481,   793,   482,   483,   484,   485,   486,     0,  1172,
    1173,     0,     0,   489,   490,  1174,   492,  1175,  1176,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,  1178,     0,   506,   507,   508,   509,   510,
     511,  1179,     0,   513,   794,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,   534,
     535,   536,     0,     0,     0,     0,     0,     0,     0,  2515,
    2516,     0,     0,     0,     0,     0,     0,     0,  2517,   771,
    1122,   593,  1123,  1124,  1125,   646,  1126,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
    1127,     0,     0,   232,   233,     0,   234,   235,   772,   236,
     237,   238, -2390,  1128,   773,  1129,  1130,     0,   243,   244,
     245,   246,   247,  1131,  1132,   248,   249,  1133,  1134,   252,
       0,   253,   254,   255,   256,  1135,     0,  1136,     0,   258,
     259,   260,   261,   775,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,   776,   271,   272,  4788,  1137,
    1138,  1139,  1140,  1141,  1142,  1143,   274,   275,   276,   277,
     278,   279,  1144,  1145,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   985,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,  1146,   308,   309,
     310,  1147,  1148,   312,     0,   313,   314,  1149,   316,     0,
     317,     0,   318,   778,     0,   779,   319,   320,   321,     0,
     322,  1150,     0,  1151,   325,     0,   326,   327,   328,   329,
     330, -2390,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,   781,   342,   343,   344,   345,
     346,  1152,  1153,     0,  1154,     0,   350,     0,     0,   351,
     784,   352,   353,   354,   355,   356,     0,     0,   357,  1155,
     785,   359, -2390,     0,   360,   361,   362,  1156,  1157,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1158,   787,  1159,   380,   381,   382,
    1160,   383,   384,     0,   385,  1161,  1162,   387,  1163,   389,
     390,   391,     0,   392,     0,     0,  1164,   394,   395,     0,
       0,   396,   397,   789,   398,   790,  1165,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,  1166,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,  1167,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   791,   441,   442,   443,  1168,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,  1169,   458,   459,   460,   461,   462, -2390,   463,   464,
    1170,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,  1171,     0,   479,   480,     0,   481,
     793,   482,   483,   484,   485,   486,     0,  1172,  1173,     0,
       0,   489,   490,  1174,   492,  1175,  1176,   494,   495,   496,
     497,  4789,   499,   500,     0,  1177,   501,   502,   503,   504,
     505,  1178,     0,   506,   507,   508,   509,   510,   511,  1179,
       0,   513,   794,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,   534,   535,   536,
   -2390,     0,     0,     0,     0,     0,     0,  1189,  1190,     0,
       0,     0,     0,     0,     0,     0,  1192,   771,  1122,   593,
    1123,  1124,  1125,   646,  1126,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,  1127,     0,
       0,   232,   233,     0,   234,   235,   772,   236,   237,   238,
     239,  1128,   773,  1129,  1130,     0,   243,   244,   245,   246,
     247,  1131,  1132,   248,   249,  1133,  1134,   252,     0,   253,
     254,   255,   256,  1135,     0,  1136,     0,   258,   259,   260,
     261,   775,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,   776,   271,   272,   273,  1137,  1138,  1139,
    1140,  1141,  1142,  1143,   274,   275,   276,   277,   278,   279,
    1144,  1145,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   985,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,  1146,   308,   309,   310,  1147,
    1148,   312,     0,   313,   314,  1149,   316,     0,   317,     0,
     318,   778,     0,   779,   319,   320,   321,     0,   322,  1150,
       0,  1151,   325,     0,   326,   327,   328,   329,   330,   780,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,   781,   342,   343,   344,   345,   346,  1152,
    1153,     0,  1154,     0,   350,     0,   783,   351,   784,   352,
     353,   354,   355,   356,     0,     0,   357,  1155,   785,   359,
     786,     0,   360,   361,   362,  1156,  1157,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,  1158,   787,  1159,   380,   381,   382,     0,   383,
     384,   788,   385,  1161,  1162,   387,  1163,   389,   390,   391,
       0,   392,     0,     0,  1164,   394,   395,     0,     0,   396,
     397,   789,   398,   790,  1165,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,  1166,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
    1167,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     791,   441,   442,   443,  2514,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,  1169,
     458,   459,   460,   461,   462,   792,   463,   464,  1170,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,  1171,     0,   479,   480,     0,   481,   793,   482,
     483,   484,   485,   486,     0,  1172,  1173,     0,     0,   489,
     490,  1174,   492,  1175,  1176,   494,   495,   496,   497,   498,
     499,   500,     0,     0,   501,   502,   503,   504,   505,  1178,
       0,   506,   507,   508,   509,   510,   511,  1179,     0,   513,
     794,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,   534,   535,   536,     0,     0,
       0,     0,     0,     0,     0,  2515,  2516,     0,     0,   771,
    1122,   593,  1123,  1124,  2517,   646,  1126,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
    1127,     0,     0,   232,   233,     0,   234,   235,   772,   236,
     237,   238,   239,  1128,   773,  1129,  1130,     0,   243,   244,
     245,   246,   247,  1131,  1132,   248,   249,  1133,  1134,   252,
       0,   253,   254,   255,   256,  1135,     0,  1136,     0,   258,
     259,   260,   261,   775,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,   776,   271,   272,   273,  1137,
    1138,  1139,  1140,  1141,  1142,  1143,   274,   275,   276,   277,
     278,   279,  1144,  1145,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   985,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,  1146,   308,   309,
     310,  1147,  1148,   312,     0,   313,   314,  1149,   316,     0,
     317,     0,   318,   778,     0,   779,   319,   320,   321,     0,
     322,  1150,     0,  1151,   325,     0,   326,   327,   328,   329,
     330,   780,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,   781,   342,   343,   344,   345,
     346,  1152,  1153,     0,  1154,     0,   350,   782,   783,   351,
     784,   352,   353,   354,   355,   356,     0,     0,   357,  1155,
     785,   359,   786,     0,   360,   361,   362,  1156,  1157,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1158,   787,  1159,   380,   381,   382,
       0,   383,   384,   788,   385,  1161,  1162,   387,  1163,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   789,   398,   790,  1165,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,  1166,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,  1167,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   791,   441,   442,   443,  2514,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,  1169,   458,   459,   460,   461,   462,   792,   463,   464,
    1170,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,  1171,     0,   479,   480,     0,   481,
     793,   482,   483,   484,   485,   486,     0,  1172,  1173,     0,
       0,   489,   490,  1174,   492,  1175,  1176,   494,   495,   496,
     497,   498,   499,   500,     0,     0,   501,   502,   503,   504,
     505,  1178,     0,   506,   507,   508,   509,   510,   511,  1179,
       0,   513,   794,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,   534,   535,   536,
       0,     0,   771,  1122,   593,  1123,  1124,     0,   646,  1126,
       0,     0,     0,     0,     0,     0,  2517,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,  1127,     0,     0,   232,   233,     0,   234,
     235,   772,   236,   237,   238,   239,  1128,   773,  1129,  1130,
       0,  3723,   244,   245,   246,   247,  1131,  1132,   248,   249,
    1133,  1134,   252,     0,   253,   254,   255,   256,  1135,     0,
    1136,     0,   258,   259,   260,   261,   775,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,   776,   271,
     272,   273,  1137,  1138,  1139,  1140,  1141,  1142,  1143,   274,
     275,   276,   277,   278,   279,  1144,  1145,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   985,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
    1146,   308,   309,   310,  1147,  1148,   312,     0,   313,   314,
    1149,   316,     0,   317,     0,   318,   778,     0,   779,   319,
     320,   321,     0,   322,  1150,     0,  1151,   325,     0,   326,
     327,   328,   329,   330,   780,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,   781,   342,
     343,   344,   345,   346,  1152,  1153,     0,  1154,     0,   350,
     782,   783,   351,   784,   352,   353,   354,   355,   356,     0,
       0,   357,  1155,   785,   359,   786,     0,   360,   361,   362,
    1156,  1157,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,  1158,   787,  1159,
     380,   381,   382,     0,   383,   384,   788,   385,  1161,  1162,
     387,  1163,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   789,   398,   790,  1165,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
    1166,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,  1167,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   791,   441,   442,   443,  2514,
     445,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,  1169,   458,   459,   460,   461,   462,
     792,   463,   464,  1170,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,  1171,     0,   479,
     480,     0,   481,   793,   482,   483,   484,   485,   486,     0,
    1172,  1173,     0,     0,   489,   490,  1174,   492,  1175,  1176,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,  1178,     0,   506,   507,   508,   509,
     510,   511,  1179,     0,   513,   794,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,
     534,   535,   536,     0,     0,   771,  1122,   593,  1123,  1124,
    1125,   646,  1126,     0,     0,     0,     0,     0,     0,  2517,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,  1127,     0,     0,   232,
     233,     0,   234,   235,   772,   236,   237,   238,     0,  1128,
     773,  1129,  1130,     0,   243,   244,   245,   246,   247,  1131,
    1132,   248,   249,  1133,  1134,   252,     0,   253,   254,   255,
     256,  1135,     0,  1136,     0,   258,   259,   260,   261,   775,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,   776,   271,   272,   273,  1137,  1138,  1139,  1140,  1141,
    1142,  1143,   274,   275,   276,   277,   278,   279,  1144,  1145,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   985,   295,   296,
       0,   297,   298,   299,     0,   300,     0,   302,     0,   303,
     304,   305,   306,  1146,   308,   309,   310,  1147,  1148,   312,
       0,   313,   314,  1149,   316,     0,   317,     0,   318,   778,
       0,   779,   319,   320,   321,     0,   322,  1150,     0,  1151,
     325,     0,   326,   327,   328,   329,   330,     0,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,   781,   342,   343,   344,   345,   346,  1152,  1153,     0,
    1154,     0,   350,     0,     0,   351,   784,   352,   353,   354,
     355,   356,     0,     0,   357,  1155,   785,   359,     0,     0,
     360,   361,   362,  1156,  1157,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1158,   787,  1159,   380,   381,   382,  1160,   383,   384,     0,
     385,  1161,  1162,   387,  1163,   389,   390,   391,     0,   392,
       0,     0,  1164,   394,   395,     0,     0,   396,   397,   789,
     398,   790,  1165,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,  1166,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,  1167,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   791,   441,
     442,   443,  1168,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,  1169,   458,   459,
     460,   461,   462,     0,   463,   464,  1170,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
    1171,     0,   479,   480,     0,   481,   793,   482,   483,   484,
     485,   486,     0,  1172,  1173,     0,     0,   489,   490,  1174,
     492,  1175,  1176,   494,   495,   496,   497,   498,   499,   500,
       0,  1177,   501,   502,   503,   504,   505,  1178,     0,   506,
     507,   508,   509,   510,   511,  1179,     0,   513,   794,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,   534,   535,   536,     0,     0,   771,     0,
       0,     0,     0,  1189,  1190,     0,     0,     0,     0,     0,
       0,     0,  1192,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,   772,   236,   237,
     238,   239,   240,   773,   241,   242,     0,   243,   244,   245,
     246,   247,     0,  1132,   248,   249,   250,   251,   252,     0,
     253,   254,   255,   256,  1135,     0,  1136,     0,   258,   259,
     260,   261,   775,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,   776,   271,   272,   273,  1137,  1138,
    1139,  1140,  1141,  1142,  1143,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
    1147,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,   778,     0,   779,   319,   320,   321,     0,   322,
    1150,     0,   324,   325,     0,   326,   327,   328,   329,   330,
     780,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,   781,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   782,   783,   351,   784,
     352,   353,   354,   355,   356,  3259,     0,   357,  1155,   785,
     359,   786,     0,   360,   361,   362,  1156,  1157,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   787,   379,   380,   381,   382,     0,
     383,   384,   788,   385,     0,  1162,   387,   388,   389,   390,
     391,     0,   392,     0,   735,   393,   394,   395,     0,     0,
     396,   397,   789,   398,   790,  1165,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,  1166,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   791,   441,   442,   443,   444,  3260,   446,   447,   448,
     449,   450,   451,   452,    39,   453,   454,   455,   456,   457,
    1169,   458,   459,   460,   461,   462,   792,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,  1171,     0,   479,   480,    43,   481,   793,
     482,   483,   484,   485,   486,     0,   487,   488,     0,     0,
     489,   490,  1174,   492,  1175,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
    1178,     0,   506,   507,   508,   509,   510,  1058,   512,     0,
     513,   794,   514,   515,   516,   517,     0,     0,   518,     0,
      48,   519,   520,   521,   522,   523,   524,   525,  1180,  1181,
    1182,  1183,  1184,  1185,  1186,  1187,   534,   535,   536,     0,
       0,    49,   771,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3261,     0,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,   772,   236,   237,   238,   239,   240,   773,   241,   242,
       0,   243,   244,   245,   246,   247,     0,  1132,   248,   249,
     250,   251,   252,     0,   253,   254,   255,   256,  1135,     0,
    1136,     0,   258,   259,   260,   261,   775,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,   776,   271,
     272,   273,  1137,  1138,  1139,  1140,  1141,  1142,  1143,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,  1147,     0,   312,     0,   313,   314,
     315,   316,     0,   317,     0,   318,   778,     0,   779,   319,
     320,   321,     0,   322,  1150,     0,   324,   325,     0,   326,
     327,   328,   329,   330,   780,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,   781,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     782,   783,   351,   784,   352,   353,   354,   355,   356,  3259,
       0,   357,  1155,   785,   359,   786,     0,   360,   361,   362,
    1156,  1157,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   787,   379,
     380,   381,   382,     0,   383,   384,   788,   385,     0,  1162,
     387,   388,   389,   390,   391,     0,   392,     0,   735,   393,
     394,   395,     0,     0,   396,   397,   789,   398,   790,  1165,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
    1166,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   791,   441,   442,   443,   444,
    3260,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,  1169,   458,   459,   460,   461,   462,
     792,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,  1171,     0,   479,
     480,     0,   481,   793,   482,   483,   484,   485,   486,     0,
     487,   488,     0,     0,   489,   490,  1174,   492,  1175,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,  1178,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,   794,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,
     534,   535,   536,     0,     0,   771,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3261,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,     0,     0,     0,   232,
     233,     0,   234,   235,   772,   236,   237,   238,   239,   240,
     773,   241,   242,     0,   243,   244,   245,   246,   247,     0,
    1132,   248,   249,   250,   251,   252,     0,   253,   254,   255,
     256,  1135,     0,  1136,     0,   258,   259,   260,   261,   775,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,   776,   271,   272,   273,  1137,  1138,  1139,  1140,  1141,
    1142,  1143,   274,   275,   276,   277,   278,   279,   280,   281,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,   307,   308,   309,   310,  1147,     0,   312,
       0,   313,   314,   315,   316,     0,   317,     0,   318,   778,
       0,   779,   319,   320,   321,     0,   322,  1150,     0,   324,
     325,     0,   326,   327,   328,   329,   330,   780,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,   781,   342,   343,   344,   345,   346,   347,   348,     0,
     349,     0,   350,   782,   783,   351,   784,   352,   353,   354,
     355,   356,     0,     0,   357,  1155,   785,   359,   786,     0,
     360,   361,   362,  1156,  1157,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   787,   379,   380,   381,   382,     0,   383,   384,   788,
     385,     0,  1162,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   789,
     398,   790,  1165,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,  1166,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   791,   441,
     442,   443,   444,  3260,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,  1169,   458,   459,
     460,   461,   462,   792,   463,   464,   465,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
    1171,     0,   479,   480,     0,   481,   793,   482,   483,   484,
     485,   486,     0,   487,   488,     0,     0,   489,   490,  1174,
     492,  1175,     0,   494,   495,   496,   497,   498,   499,   500,
       0,     0,   501,   502,   503,   504,   505,  1178,     0,   506,
     507,   508,   509,   510,   511,   512,     0,   513,   794,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,   534,   535,   536,     0,     0,   771,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    50,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,   772,   236,   237,
     238,   239,   240,   773,   241,   242,     0,   243,   244,   245,
     246,   247,     0,  1132,   248,   249,   250,   251,   252,     0,
     253,   254,   255,   256,  1135,     0,  1136,     0,   258,   259,
     260,   261,   775,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,   776,   271,   272,   273,  1137,  1138,
    1139,  1140,  1141,  1142,  1143,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
    1147,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,   778,     0,   779,   319,   320,   321,     0,   322,
    1150,     0,   324,   325,     0,   326,   327,   328,   329,   330,
     780,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,   781,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   782,   783,   351,   784,
     352,   353,   354,   355,   356,     0,     0,   357,  1155,   785,
     359,   786,     0,   360,   361,   362,  1156,  1157,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   787,   379,   380,   381,   382,     0,
     383,   384,   788,   385,     0,  1162,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   789,   398,   790,  1165,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,  1166,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   791,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
    1169,   458,   459,   460,   461,   462,   792,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,  1171,     0,   479,   480,     0,   481,   793,
     482,   483,   484,   485,   486,     0,   487,   488,     0,     0,
     489,   490,  1174,   492,  1175,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
    1178,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,   794,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   525,  1180,  1181,
    1182,  1183,  1184,  1185,  1186,  1187,   534,   535,   536,     0,
       0,   815,  1391,   593,     0,     0,     0,   646,     0,     0,
       0,     0,     0,     0,     0,  3847,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
     772,   236,   237,   238,   239,   240,   773,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,   774,
       0,   258,   259,   260,   261,   775,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,   776,   271,   272,
     273,     0,     0,     0,   777,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,  1660,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,   778,     0,   779,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,   330,   780,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,   781,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,   782,
     783,   351,   784,   352,   353,   354,   355,   356,     0,     0,
     357,   358,   785,   359,   786,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   787,   379,   380,
     381,   382,     0,   383,   384,   788,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,  1661,     0,   393,   394,
     395,     0,     0,   396,   397,   789,   398,   790,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   791,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   792,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,   793,   482,   483,   484,   485,   486,     0,   487,
     488,     0,     0,   489,   490,   491,   492,   493,  1662,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,   794,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,     0,     0,   815,     0,     0,     0,     0,   658,
    1392,  4286,     0,     0,     0,     0,     0,     0,  4287,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   229,   230,
     231,     3,     4,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,   772,   236,   237,   238,   239,   240,   773,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   254,   255,   256,
     257,     0,   774,     0,   258,   259,   260,   261,   775,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
     776,   271,   272,   273,     0,     0,     0,   777,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,     0,   317,     0,   318,   778,     0,
     779,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,   330,   780,   331,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,     0,   341,
     781,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,   782,   783,   351,   784,   352,   353,   354,   355,
     356,     0,     0,   357,   358,   785,   359,   786,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     787,   379,   380,   381,   382,     0,   383,   384,   788,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   789,   398,
     790,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   791,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
      39,   453,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,   792,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,    43,   481,   793,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,  1058,   512,     0,   513,   794,   514,   515,
     516,   517,     0,     0,   518,     0,    48,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,     0,     0,    49,   771,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,     0,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,   772,   236,   237,
     238,   239,   240,   773,   241,   242,     0,   243,   244,   245,
     246,   247,     0,     0,   248,   249,   250,   251,   252,     0,
     253,   254,   255,   256,   257,     0,   774,     0,   258,   259,
     260,   261,   775,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,   776,   271,   272,   273,     0,     0,
       0,   777,     0,     0,     0,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,   778,     0,   779,   319,   320,   321,     0,   322,
     323,     0,   324,   325,     0,   326,   327,   328,   329,   330,
     780,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,   781,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   782,   783,   351,   784,
     352,   353,   354,   355,   356,     0,     0,   357,   358,   785,
     359,   786,     0,   360,   361,   362,     0,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   787,   379,   380,   381,   382,     0,
     383,   384,   788,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   789,   398,   790,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   791,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
       0,   458,   459,   460,   461,   462,   792,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,     0,   481,   793,
     482,   483,   484,   485,   486,     0,   487,   488,     0,     0,
     489,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
       0,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,   794,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,     0,
       0,   219,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4474,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
       0,   236,   237,   238,   239,   240,     0,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,     0,
       0,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,     0,     0,     0,     0,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,     0,     0,     0,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,   330,     0,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,     0,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,   351,     0,   352,   353,   354,   355,   356,     0,     0,
     357,   358,     0,   359,     0,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,    39,   453,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,     0,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
      43,   481,     0,   482,   483,   484,   485,   486,     0,   487,
     488,     0,     0,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
    1058,   512,     0,   513,     0,   514,   515,   516,   517,     0,
       0,   518,     0,    48,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,     0,     0,    49,   219,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    50,     0,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,     0,     0,     0,   232,
     233,     0,   234,   235,     0,   236,   237,   238,   239,   240,
       0,   241,   242,     0,   243,   244,   245,   246,   247,     0,
       0,   248,   249,   250,   251,   252,     0,   253,   254,   255,
     256,   257,     0,     0,     0,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,     0,     0,     0,     0,     0,
       0,     0,   274,   275,   276,   277,   278,   279,   280,   281,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,     0,   317,     0,   318,     0,
       0,     0,   319,   320,   321,     0,   322,   323,     0,   324,
     325,     0,   326,   327,   328,   329,   330,     0,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,   348,     0,
     349,     0,   350,     0,     0,   351,     0,   352,   353,   354,
     355,   356,     0,     0,   357,   358,     0,   359,     0,     0,
     360,   361,   362,     0,     0,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,     0,   463,   464,   465,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,     0,   481,     0,   482,   483,   484,
     485,   486,     0,   487,   488,     0,     0,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
       0,     0,   501,   502,   503,   504,   505,     0,     0,   506,
     507,   508,   509,   510,   511,   512,     0,   513,     0,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,     0,     0,   219,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1250,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,     0,   236,   237,
     238,   239,   240,     0,   241,   242,     0,   243,   244,   245,
     246,   247,     0,     0,   248,   249,   250,   251,   252,     0,
     253,   254,   255,   256,   257,     0,     0,     0,   258,   259,
     260,   261,     0,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,     0,     0,
       0,     0,     0,     0,     0,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,     0,     0,     0,   319,   320,   321,     0,   322,
     323,     0,   324,   325,     0,   326,   327,   328,   329,   330,
       0,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,   351,     0,
     352,   353,   354,   355,   356,     0,     0,   357,   358,     0,
     359,     0,     0,   360,   361,   362,     0,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
       0,   458,   459,   460,   461,   462,     0,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,     0,   481,     0,
     482,   483,   484,   485,   486,     0,   487,   488,     0,     0,
     489,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
       0,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,     0,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,     0,
       0,   219,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2671,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
       0,   236,   237,   238,   239,   240,     0,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,     0,
       0,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,     0,     0,     0,     0,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,     0,     0,     0,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,   330,     0,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,     0,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,   351,     0,   352,   353,   354,   355,   356,     0,     0,
     357,   358,     0,   359,     0,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,     0,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,     0,   482,   483,   484,   485,   486,     0,   487,
     488,     0,     0,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,     0,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,     0,     0,   219,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3758,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,     0,   236,   237,   238,   239,   240,     0,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   254,   255,   256,
     257,     0,     0,     0,   258,   259,   260,   261,     0,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,     0,     0,     0,     0,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,     0,   317,     0,   318,     0,     0,
       0,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,   330,     0,   331,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,   351,     0,   352,   353,   354,   355,
     356,     0,     0,   357,   358,     0,   359,     0,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,   397,     0,   398,
       0,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,     0,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,     0,   481,     0,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,   511,   512,     0,   513,     0,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,     0,     0,     0,     0,     0,
     977,  1391,   593,     0,     0,   829,   646,     0,     0,     0,
       0,  4171,   830,   831,   832,   220,   221,   222,   223,   224,
     225,   226,   227,  1847,   229,   230,   231,  1848,  1849,  1850,
    1851,  1852,  1853,  1854,   232,   233,  1855,   234,   235,   772,
     236,   237,   238,     0,   978,   773,   979,   980,  1856,   243,
     244,   245,   246,   247,  1857,  1858,   248,   249,   981,   982,
     252,  1859,   253,   254,   255,   256,     0,  1860,   774,  1861,
     258,   259,   260,   261,   775,   262,   263,   264,  1862,   265,
     266,   267,   268,   269,   270,  1863,   776,   271,   272,   273,
    1864,  1865,  1866,   777,  1867,  1868,  1869,   274,   275,   276,
     277,   278,   279,   983,   984,   282,  1870,   283,  1871,   284,
     285,   286,   287,   288,  1872,   289,   290,   291,  1873,  1874,
     292,   293,   985,   295,   296,  1875,   297,   298,   299,  1876,
     300,   301,   302,  1877,   303,   304,   305,   306,     0,   308,
     309,   310,     0,  1878,   312,  1879,   313,   314,   986,   316,
    1880,   317,  1881,   318,   778,  1882,   779,   319,   320,   321,
    1883,   322,     0,  1884,     0,   325,  1885,   326,   327,   328,
     329,   330,   780,   331,   332,   333,   334,  1886,   335,   336,
     337,   338,   339,   340,  1887,   341,   781,     0,   343,   344,
     345,   346,   988,   989,  1888,   990,  1889,   350,   782,   783,
     351,   784,   352,   353,   354,   355,   356,  1890,  1891,   357,
       0,   785,   359,   786,  1892,   360,   361,   362,  1893,  1894,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   991,   787,   992,   380,   381,
       0,  1895,   383,   384,   788,   385,  1896,     0,   387,   993,
     389,   390,   391,  1897,   392,  1898,  1899,  3509,   394,   395,
    1900,  1901,   396,     0,   789,   398,   790,     0,   400,   401,
     402,   403,   404,   405,   406,  1902,   407,   408,     0,   410,
       0,   412,   413,   414,  1903,   415,   416,   417,   418,   419,
     420,   421,   422,   994,   424,   425,   426,   427,  1904,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
    1905,   439,   440,   791,   441,   442,   443,     0,   445,   446,
     447,   448,   449,   450,   451,   452,  1906,   453,   454,   455,
     456,   457,  1907,   458,   459,  1988,   461,   462,   792,   463,
     464,   996,   466,  1908,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,  1909,   479,   480,  1910,
     481,   793,   482,   483,   484,   485,   486,  1911,   997,   998,
    1912,  1913,   489,   490,     0,   492,     0,  1914,   494,   495,
     496,   497,   498,   499,   500,  1915,  1916,   501,   502,   503,
     504,   505,  1917,  1918,   506,   507,   508,   509,   510,     0,
     999,  1919,   513,   794,   514,   515,   516,   517,  1920,  1921,
     518,  1922,  1923,   519,   520,   521,   522,   523,   524,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   534,   535,
     536,     0,   219,     0,   835,   836,   837,   829,  3510,  3511,
     840,   841,   842,   843,   830,   831,   832,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,     0,   236,   237,   238,   239,   240,     0,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   248,   249,
     250,   251,   252,     0,   253,   833,   255,   256,   257,     0,
       0,     0,   258,   259,   260,   261,     0,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,     0,     0,     0,     0,     0,     0,     0,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   834,     0,   313,   314,
     315,   316,     0,   317,     0,   318,     0,     0,     0,   319,
     320,   321,     0,   322,   323,     0,   324,   325,     0,   326,
     327,   328,   329,   330,     0,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,   351,     0,   352,   353,   354,   355,   356,     0,
       0,   357,   358,     0,   359,     0,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,     0,   398,     0,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,     0,   458,   459,   460,   461,   462,
       0,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,     0,   481,     0,   482,   483,   484,   485,   486,     0,
     487,   488,     0,     0,   489,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,     0,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,     0,   219,     0,   835,   836,   837,   829,
     838,   839,   840,   841,   842,   843,   830,   831,   832,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,     0,   236,   237,   238,   239,   240,     0,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   935,   255,   256,
     257,     0,     0,     0,   258,   259,   260,   261,     0,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,     0,     0,     0,     0,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   936,     0,
     313,   314,   315,   316,     0,   317,     0,   318,     0,     0,
       0,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,   330,     0,   331,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,   351,     0,   352,   353,   354,   355,
     356,     0,     0,   357,   358,     0,   359,     0,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,   397,     0,   398,
       0,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,     0,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,     0,   481,     0,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,   511,   512,     0,   513,     0,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,     0,   219,     0,   835,   836,
     837,   829,   838,   839,   840,   841,   842,   843,   830,   831,
     832,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     229,   230,   231,     0,     0,     0,     0,     0,     0,     0,
     232,   233,     0,   234,   235,     0,   236,   237,   238,   239,
     240,     0,   241,   242,     0,   243,   244,   245,   246,   247,
       0,     0,   248,   249,   250,   251,   252,     0,   253,  1026,
     255,   256,   257,     0,     0,     0,   258,   259,   260,   261,
       0,   262,   263,   264,     0,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,     0,     0,     0,     0,
       0,     0,     0,   274,   275,   276,   277,   278,   279,   280,
     281,   282,     0,   283,     0,   284,   285,   286,   287,   288,
       0,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,     0,   297,   298,   299,     0,   300,   301,   302,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
    1027,     0,   313,   314,   315,   316,     0,   317,     0,   318,
       0,     0,     0,   319,   320,   321,     0,   322,   323,     0,
     324,   325,     0,   326,   327,   328,   329,  1028,     0,   331,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,   351,     0,   352,   353,
     354,   355,   356,     0,     0,   357,   358,     0,   359,     0,
       0,   360,   361,   362,     0,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,   397,
       0,   398,     0,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,     0,   458,
     459,   460,   461,   462,     0,   463,   464,   465,   466,     0,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,     0,   481,     0,   482,   483,
     484,   485,   486,     0,   487,   488,     0,     0,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,     0,     0,   501,   502,   503,   504,   505,     0,     0,
     506,   507,   508,   509,   510,   511,   512,     0,   513,     0,
     514,   515,   516,   517,     0,     0,   518,     0,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,     0,   219,     0,
     835,   836,   837,   829,   838,   839,   840,   841,   842,   843,
     830,   831,   832,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,     0,   236,   237,
     238,   239,   240,     0,   241,   242,     0,   243,   244,   245,
     246,   247,     0,     0,   248,   249,   250,   251,   252,     0,
     253,  1489,   255,   256,   257,     0,     0,     0,   258,   259,
     260,   261,     0,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,     0,     0,
       0,     0,     0,     0,     0,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,  1490,     0,   313,   314,   315,   316,     0,   317,
       0,   318,     0,     0,     0,   319,   320,   321,     0,   322,
     323,     0,   324,   325,     0,   326,   327,   328,   329,   330,
       0,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,   351,     0,
     352,   353,   354,   355,   356,     0,     0,   357,   358,     0,
     359,     0,     0,   360,   361,   362,     0,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
       0,   458,   459,   460,   461,   462,     0,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,     0,   481,     0,
     482,   483,   484,   485,   486,     0,   487,   488,     0,     0,
     489,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
       0,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,     0,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,     0,
     219,     0,   835,   836,   837,   829,   838,   839,   840,   841,
     842,   843,   830,   831,   832,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   229,   230,   231,     0,     0,     0,
       0,     0,     0,     0,   232,   233,     0,   234,   235,     0,
     236,   237,   238,   239,   240,     0,   241,   242,     0,   243,
     244,   245,   246,   247,     0,     0,   248,   249,   250,   251,
     252,     0,   253,   254,   255,   256,   257,     0,     0,     0,
     258,   259,   260,   261,     0,   262,   263,   264,     0,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
       0,     0,     0,     0,     0,     0,     0,   274,   275,   276,
     277,   278,   279,   280,   281,   282,     0,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
       0,   317,     0,   318,     0,     0,     0,   319,   320,   321,
       0,   322,   323,     0,   324,   325,     0,   326,   327,   328,
     329,   330,     0,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,   348,     0,   349,     0,   350,     0,     0,
     351,     0,   352,   353,   354,   355,   356,     0,     0,   357,
     358,     0,   359,     0,     0,   360,   361,   362,     0,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,     0,   398,     0,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,     0,   458,   459,   460,   461,   462,     0,   463,
     464,   465,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,     0,
     481,     0,   482,   483,   484,   485,   486,     0,   487,   488,
       0,     0,   489,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,     0,     0,   501,   502,   503,
     504,   505,     0,     0,   506,   507,   508,   509,   510,   511,
     512,     0,   513,     0,   514,   515,   516,   517,     0,     0,
     518,     0,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,     0,   219,     0,   835,   836,   837,   829,   838,   839,
     840,   841,   842,   843,   830,   831,   832,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,     0,   236,   237,   238,   239,   240,     0,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   248,   249,
     250,   251,   252,     0,   253,  2749,   255,   256,   257,     0,
       0,     0,   258,   259,   260,   261,     0,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,     0,     0,     0,     0,     0,     0,     0,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,  2750,     0,   313,   314,
     315,   316,     0,   317,     0,   318,     0,     0,     0,   319,
     320,   321,     0,   322,   323,     0,   324,   325,     0,   326,
     327,   328,   329,   330,     0,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,   351,     0,   352,   353,   354,   355,   356,     0,
       0,   357,   358,     0,   359,     0,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,     0,   398,     0,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,     0,   458,   459,   460,   461,   462,
       0,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,     0,   481,     0,   482,   483,   484,   485,   486,     0,
     487,   488,     0,     0,   489,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,     0,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,     0,   219,     0,   835,   836,   837,   829,
     838,   839,   840,   841,   842,   843,   830,   831,   832,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,     0,   236,   237,   238,   239,   240,     0,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   254,   255,   256,
     257,     0,     0,     0,   258,   259,   260,   261,     0,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,     0,     0,     0,     0,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,     0,   317,     0,   318,     0,     0,
       0,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,   330,     0,   331,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,   351,     0,   352,   353,   354,   355,
     356,     0,     0,   357,   358,     0,   359,     0,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,  4453,   394,   395,     0,     0,   396,   397,     0,   398,
       0,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,     0,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,     0,   481,     0,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,   511,   512,     0,   513,     0,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1846,     0,     0,   835,   836,
     837,     0,   838,   839,   840,   841,   842,   843,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,  1847,   229,
     230,   231,  1848,  1849,  1850,  1851,  1852,  1853,  1854,   232,
     233,  1855,   234,   235,   772,   236,   237,   238,   239,   240,
     773,   241,   242,  1856,   243,   244,   245,   246,   247,  1857,
    1858,   248,   249,   250,   251,   252,  1859,   253,   254,   255,
     256,   257,  1860,   774,  1861,   258,   259,   260,   261,   775,
     262,   263,   264,  1862,   265,   266,   267,   268,   269,   270,
    1863,   776,   271,   272,   273,  1864,  1865,  1866,   777,  1867,
    1868,  1869,   274,   275,   276,   277,   278,   279,   280,   281,
     282,  1870,   283,  1871,   284,   285,   286,   287,   288,  1872,
     289,   290,   291,  1873,  1874,   292,   293,   294,   295,   296,
    1875,   297,   298,   299,  1876,   300,   301,   302,  1877,   303,
     304,   305,   306,   307,   308,   309,   310,   311,  1878,   312,
    1879,   313,   314,   315,   316,  1880,   317,  1881,   318,   778,
    1882,   779,   319,   320,   321,  1883,   322,   323,  1884,   324,
     325,  1885,   326,   327,   328,   329,   330,   780,   331,   332,
     333,   334,  1886,   335,   336,   337,   338,   339,   340,  1887,
     341,   781,   342,   343,   344,   345,   346,   347,   348,  1888,
     349,  1889,   350,   782,   783,   351,   784,   352,   353,   354,
     355,   356,  1890,  1891,   357,   358,   785,   359,   786,  1892,
     360,   361,   362,  1893,  1894,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   787,   379,   380,   381,   382,  1895,   383,   384,   788,
     385,  1896,   386,   387,   388,   389,   390,   391,  1897,   392,
    1898,  1899,   393,   394,   395,  1900,  1901,   396,   397,   789,
     398,   790,   399,   400,   401,   402,   403,   404,   405,   406,
    1902,   407,   408,   409,   410,   411,   412,   413,   414,  1903,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,  1904,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,  1905,   439,   440,   791,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,  1906,   453,   454,   455,   456,   457,  1907,   458,   459,
     460,   461,   462,   792,   463,   464,   465,   466,  1908,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,  1909,   479,   480,  1910,   481,   793,   482,   483,   484,
     485,   486,  1911,   487,   488,  1912,  1913,   489,   490,   491,
     492,   493,  1914,   494,   495,   496,   497,   498,   499,   500,
    1915,  1916,   501,   502,   503,   504,   505,  1917,  1918,   506,
     507,   508,   509,   510,   511,   512,  1919,   513,   794,   514,
     515,   516,   517,  1920,  1921,   518,  1922,  1923,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   219,     0,     0,     0,
       0,     0,     0,     0,     0,  1924,     0,     0,     0,     0,
       0,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     229,   230,   231,     0,     0,     0,     0,     0,     0,     0,
     232,   233,     0,   234,   235,     0,   236,   237,   238,   239,
     240,     0,   241,   242,     0,   243,   244,   245,   246,   247,
       0,     0,   248,   249,   250,   251,   252,     0,   253,   254,
     255,   256,   257,     0,     0,     0,   258,   259,   260,   261,
       0,   262,   263,   264,     0,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,     0,     0,     0,     0,
       0,     0,     0,   274,   275,   276,   277,   278,   279,   280,
     281,   282,     0,   283,     0,   284,   285,   286,   287,   288,
       0,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,     0,   297,   298,   299,     0,   300,   301,   302,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,     0,   317,     0,   318,
       0,     0,     0,   319,   320,   321,     0,   322,   323,     0,
     324,   325,     0,   326,   327,   328,   329,   330,     0,   331,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,   351,     0,   352,   353,
     354,   355,   356,     0,     0,   357,   358,     0,   359,     0,
       0,   360,   361,   362,     0,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,   397,
       0,   398,     0,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,     0,   458,
     459,   460,   461,   462,     0,   463,   464,   465,   466,     0,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,     0,   481,     0,   482,   483,
     484,   485,   486,     0,   487,   488,     0,     0,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,     0,     0,   501,   502,   503,   504,   505,     0,     0,
     506,   507,   508,   509,   510,   511,   512,     0,   513,     0,
     514,   515,   516,   517,     0,     0,   518,     0,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   977,     0,     0,
       0,     0,     0,     0,     0,     0,   740,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,     0,     0,
       0,   232,   233,     0,   234,   235,   772,   236,   237,   238,
       0,   978,   773,   979,   980,     0,   243,   244,   245,   246,
     247,     0,     0,   248,   249,   981,   982,   252,     0,   253,
     254,   255,   256,     0,     0,   774,     0,   258,   259,   260,
     261,   775,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,   776,   271,   272,   273,     0,     0,     0,
     777,     0,     0,     0,   274,   275,   276,   277,   278,   279,
     983,   984,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   985,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,     0,   308,   309,   310,     0,
       0,   312,     0,   313,   314,   986,   316,     0,   317,     0,
     318,   778,     0,   779,   319,   320,   321,     0,   322,     0,
       0,     0,   325,     0,   326,   327,   328,   329,   330,   780,
     331,   332,   333,   334,  1984,   335,   336,   337,   338,   339,
     340,     0,   341,   781,  1985,   343,   344,   345,   346,   988,
     989,     0,   990,     0,   350,   782,   783,   351,   784,   352,
     353,   354,   355,   356,     0,     0,   357,     0,   785,   359,
     786,     0,   360,   361,   362,     0,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   991,   787,   992,   380,   381,     0,     0,   383,
     384,   788,   385,     0,     0,   387,   993,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,  1986,   396,
    1987,   789,   398,   790,     0,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,     0,   410,     0,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     994,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     791,   441,   442,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,     0,
     458,   459,  1988,   461,   462,   792,   463,   464,   996,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     0,     0,   479,   480,     0,   481,   793,   482,
     483,   484,   485,   486,     0,   997,   998,     0,     0,   489,
     490,     0,   492,     0,     0,   494,   495,   496,   497,   498,
     499,   500,     0,     0,   501,   502,   503,   504,   505,     0,
       0,   506,   507,   508,   509,   510,     0,   999,  1989,   513,
     794,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,     0,     0,     0,     0,
       0,     0,     0,  2252,     0,   534,   535,   536,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1990,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   232,   233,     0,
     234,   235,   772,   236,   237,   238,     0,   978,   773,   979,
     980,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   981,   982,   252,     0,   253,   254,   255,   256,     0,
       0,   774,     0,   258,   259,   260,   261,   775,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,   776,
     271,   272,   273,     0,     0,     0,   777,     0,     0,     0,
     274,   275,   276,   277,   278,   279,   983,   984,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   985,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,     0,   308,   309,   310,     0,     0,   312,     0,   313,
     314,   986,   316,     0,   317,     0,   318,   778,     0,   779,
     319,   320,   321,     0,   322,     0,     0,     0,   325,     0,
     326,   327,   328,   329,   330,   780,   331,   332,   333,   334,
    1984,   335,   336,   337,   338,   339,   340,     0,   341,   781,
    1985,   343,   344,   345,   346,   988,   989,     0,   990,     0,
     350,   782,   783,   351,   784,   352,   353,   354,   355,   356,
       0,     0,   357,     0,   785,   359,   786,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   991,   787,
     992,   380,   381,     0,     0,   383,   384,   788,   385,     0,
       0,   387,   993,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,  1986,   396,  1987,   789,   398,   790,
       0,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   410,     0,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   994,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   791,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,     0,   458,   459,  1988,   461,
     462,   792,   463,   464,   996,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     0,     0,
     479,   480,     0,   481,   793,   482,   483,   484,   485,   486,
       0,   997,   998,     0,     0,   489,   490,     0,   492,     0,
       0,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,     0,   999,  1989,   513,   794,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,     0,     0,     0,     0,     0,     0,     0,   219,
       0,   534,   535,   536,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1990,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
       0,     0,     0,   232,   233,     0,   234,   235,     0,   236,
     237,   238,   239,   240,     0,   241,   242,     0,   243,   244,
     245,   246,   247,     0,     0,   248,   249,   250,   251,   252,
       0,   253,   254,   255,   256,   257,     0,     0,     0,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,     0,
       0,     0,     0,     0,     0,     0,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,     0,
     317,     0,   318,     0,     0,     0,   319,   320,   321,     0,
     322,   323,     0,   324,   325,     0,   326,   327,   328,   329,
     330,     0,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,     0,   342,   343,   344,   345,
     346,   347,   348,     0,   349,     0,   350,     0,     0,   351,
       0,   352,   353,   354,   355,   356,     0,     0,   357,   358,
       0,   359,     0,     0,   360,   361,   362,     0,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,     0,   463,   464,
     465,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,     0,   481,
       0,   482,   483,   484,   485,   486,     0,   487,   488,     0,
       0,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,     0,     0,   501,   502,   503,   504,
     505,     0,     0,   506,   507,   508,   509,   510,   511,   512,
       0,   513,     0,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     815,  1391,   593,     0,     0,     0,   646,     0,     0,  4507,
       0,     0,     0,     0,     0,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   229,   230,   231,     0,     0,     0,
       0,     0,     0,     0,   232,   233,     0,   234,   235,   772,
     236,   237,   238,   239,   240,   773,   241,   242,     0,   243,
     244,   245,   246,   247,     0,     0,   248,   249,   250,   251,
     252,     0,   253,   254,   255,   256,   257,     0,   774,     0,
     258,   259,   260,   261,   775,   262,   263,   264,     0,   265,
     266,   267,   268,   269,   270,     0,   776,   271,   272,   273,
       0,     0,     0,   777,     0,     0,     0,   274,   275,   276,
     277,   278,   279,   280,   281,   282,  1836,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,  1660,   312,     0,   313,   314,   315,   316,
       0,   317,     0,   318,   778,     0,   779,   319,   320,   321,
       0,   322,   323,     0,   324,   325,     0,   326,   327,   328,
     329,   330,   780,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,   781,   342,   343,   344,
     345,   346,   347,   348,     0,   349,     0,   350,   782,   783,
     351,   784,   352,   353,   354,   355,   356,     0,     0,   357,
     358,   785,   359,   786,     0,   360,   361,   362,     0,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   787,   379,   380,   381,
     382,     0,   383,   384,   788,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,  1661,     0,   393,   394,   395,
       0,     0,   396,   397,   789,   398,   790,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   791,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,     0,   458,   459,   460,   461,   462,   792,   463,
     464,   465,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,     0,
     481,   793,   482,   483,   484,   485,   486,     0,   487,   488,
       0,     0,   489,   490,   491,   492,   493,  1662,   494,   495,
     496,   497,   498,   499,   500,     0,     0,   501,   502,   503,
     504,   505,     0,     0,   506,   507,   508,   509,   510,   511,
     512,     0,   513,   794,   514,   515,   516,   517,     0,     0,
     518,     0,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   815,  1391,   593,     0,     0,     0,   646,   658,  1392,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
     772,   236,   237,   238,   239,   240,   773,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,   774,
       0,   258,   259,   260,   261,   775,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,   776,   271,   272,
     273,     0,     0,     0,   777,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,  1841,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,  1660,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,   778,     0,   779,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,   330,   780,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,   781,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,   782,
     783,   351,   784,   352,   353,   354,   355,   356,     0,     0,
     357,   358,   785,   359,   786,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   787,   379,   380,
     381,   382,     0,   383,   384,   788,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,  1661,     0,   393,   394,
     395,     0,     0,   396,   397,   789,   398,   790,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   791,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   792,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,   793,   482,   483,   484,   485,   486,     0,   487,
     488,     0,     0,   489,   490,   491,   492,   493,  1662,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,   794,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   815,  1391,   593,     0,     0,     0,   646,   658,
    1392,     0,     0,     0,     0,     0,     0,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,   772,   236,   237,   238,   239,   240,   773,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   248,   249,
     250,   251,   252,     0,   253,   254,   255,   256,   257,     0,
     774,     0,   258,   259,   260,   261,   775,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,   776,   271,
     272,   273,     0,     0,     0,   777,     0,     0,     0,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,  1660,   312,     0,   313,   314,
     315,   316,     0,   317,     0,   318,   778,     0,   779,   319,
     320,   321,     0,   322,   323,     0,   324,   325,     0,   326,
     327,   328,   329,   330,   780,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,   781,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     782,   783,   351,   784,   352,   353,   354,   355,   356,     0,
       0,   357,   358,   785,   359,   786,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   787,   379,
     380,   381,   382,     0,   383,   384,   788,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,  1661,     0,   393,
     394,   395,     0,     0,   396,   397,   789,   398,   790,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   791,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,     0,   458,   459,   460,   461,   462,
     792,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,     0,   481,   793,   482,   483,   484,   485,   486,     0,
     487,   488,     0,     0,   489,   490,   491,   492,   493,  1662,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,   794,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   815,     0,   593,     0,     0,     0,   646,
     658,  1392,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   232,   233,     0,
     234,   235,   772,   236,   237,   238,   239,   240,   773,   241,
     242,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   250,   251,   252,     0,   253,   254,   255,   256,   257,
       0,   774,     0,   258,   259,   260,   261,   775,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,   776,
     271,   272,   273,     0,     0,     0,   777,     0,     0,     0,
     274,   275,   276,   277,   278,   279,   280,   281,   282,  2704,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,  1660,   312,     0,   313,
     314,   315,   316,     0,   317,     0,   318,   778,     0,   779,
     319,   320,   321,     0,   322,   323,     0,   324,   325,     0,
     326,   327,   328,   329,   330,   780,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,   781,
     342,   343,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   782,   783,   351,   784,   352,   353,   354,   355,   356,
       0,     0,   357,   358,   785,   359,   786,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   787,
     379,   380,   381,   382,     0,   383,   384,   788,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,  1661,     0,
     393,   394,   395,     0,     0,   396,   397,   789,   398,   790,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   791,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   792,   463,   464,   465,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,     0,   481,   793,   482,   483,   484,   485,   486,
       0,   487,   488,     0,     0,   489,   490,   491,   492,   493,
    1662,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,   511,   512,     0,   513,   794,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   219,     0,     0,     0,     0,     0,
     646,   658,   659,     0,     0,     0,     0,     0,     0,   220,
     647,   222,   223,   224,   225,   226,   227,   648,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,     0,   649,   237,   238,   239,   240,     0,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   254,   255,   256,
     257,     0,     0,     0,   258,   259,   260,   261,     0,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,     0,     0,     0,     0,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   650,   315,   316,     0,   317,     0,   651,     0,   652,
       0,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,   330,     0,   331,   332,   333,
     334,   653,   335,   336,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,   351,     0,   352,   353,   354,   355,
     654,     0,     0,   357,   358,     0,   359,     0,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   655,   381,   382,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,   397,     0,   398,
       0,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   656,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   657,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,     0,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,     0,   481,     0,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,   511,   512,     0,   513,     0,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,  1846,  4869,   593,     0,     0,
       0,   646,   658,   659,     0,     0,     0,     0,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,  1847,   229,
     230,   231,  1848,  1849,  1850,  1851,  1852,  1853,  1854,   232,
     233,  1855,   234,   235,   772,   236,   237,   238,   239,   240,
     773,   241,   242,  1856,   243,   244,   245,   246,   247,  1857,
    1858,   248,   249,   250,   251,   252,  1859,   253,   254,   255,
     256,   257,  1860,   774,  1861,   258,   259,   260,   261,   775,
     262,   263,   264,  1862,   265,   266,   267,   268,   269,   270,
    1863,   776,   271,   272,   273,  1864,  1865,  1866,   777,  1867,
    1868,  1869,   274,   275,   276,   277,   278,   279,   280,   281,
     282,  1870,   283,  1871,   284,   285,   286,   287,   288,  1872,
     289,   290,   291,  1873,  1874,   292,   293,   294,   295,   296,
    1875,   297,   298,   299,  1876,   300,   301,   302,  1877,   303,
     304,   305,   306,   307,   308,   309,   310,   311,  1878,   312,
    1879,   313,   314,   315,   316,  1880,   317,  1881,   318,   778,
    1882,   779,   319,   320,   321,  1883,   322,   323,  1884,   324,
     325,  1885,   326,   327,   328,   329,   330,   780,   331,   332,
     333,   334,  1886,   335,   336,   337,   338,   339,   340,  1887,
     341,   781,   342,   343,   344,   345,   346,   347,   348,  1888,
     349,  1889,   350,   782,   783,   351,   784,   352,   353,   354,
     355,   356,  1890,  1891,   357,   358,   785,   359,   786,  1892,
     360,   361,   362,  1893,  1894,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   787,   379,   380,   381,   382,  1895,   383,   384,   788,
     385,  1896,   386,   387,   388,   389,   390,   391,  1897,   392,
    1898,  1899,   393,   394,   395,  1900,  1901,   396,   397,   789,
     398,   790,   399,   400,   401,   402,   403,   404,   405,   406,
    1902,   407,   408,   409,   410,   411,   412,   413,   414,  1903,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,  1904,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,  1905,   439,   440,   791,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,  1906,   453,   454,   455,   456,   457,  1907,   458,   459,
     460,   461,   462,   792,   463,   464,   465,   466,  1908,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,  1909,   479,   480,  1910,   481,   793,   482,   483,   484,
     485,   486,  1911,   487,   488,  1912,  1913,   489,   490,   491,
     492,   493,  1914,   494,   495,   496,   497,   498,   499,   500,
    1915,  1916,   501,   502,   503,   504,   505,  1917,  1918,   506,
     507,   508,   509,   510,   511,   512,  1919,   513,   794,   514,
     515,   516,   517,  1920,  1921,   518,  1922,  1923,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,  1846,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   220,   221,   222,   223,   224,   225,   226,   227,  1847,
     229,   230,   231,  1848,  1849,  1850,  1851,  1852,  1853,  1854,
     232,   233,  1855,   234,   235,   772,   236,   237,   238,   239,
     240,   773,   241,   242,  1856,   243,   244,   245,   246,   247,
    1857,  1858,   248,   249,   250,   251,   252,  1859,   253,   254,
     255,   256,   257,  1860,   774,  1861,   258,   259,   260,   261,
     775,   262,   263,   264,  1862,   265,   266,   267,   268,   269,
     270,  1863,   776,   271,   272,   273,  1864,  1865,  1866,   777,
    1867,  1868,  1869,   274,   275,   276,   277,   278,   279,   280,
     281,   282,  1870,   283,  1871,   284,   285,   286,   287,   288,
    1872,   289,   290,   291,  1873,  1874,   292,   293,   294,   295,
     296,  1875,   297,   298,   299,  1876,   300,   301,   302,  1877,
     303,   304,   305,   306,   307,   308,   309,   310,   311,  1878,
     312,  1879,   313,   314,   315,   316,  1880,   317,  1881,   318,
     778,  1882,   779,   319,   320,   321,  1883,   322,   323,  1884,
     324,   325,  1885,   326,   327,   328,   329,   330,   780,   331,
     332,   333,   334,  1886,   335,   336,   337,   338,   339,   340,
    1887,   341,   781,   342,   343,   344,   345,   346,   347,   348,
    1888,   349,  1889,   350,   782,   783,   351,   784,   352,   353,
     354,   355,   356,  1890,  1891,   357,   358,   785,   359,   786,
    1892,   360,   361,   362,  1893,  1894,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   787,   379,   380,   381,   382,  1895,   383,   384,
     788,   385,  1896,   386,   387,   388,   389,   390,   391,  1897,
     392,  1898,  1899,   393,   394,   395,  1900,  1901,   396,   397,
     789,   398,   790,   399,   400,   401,   402,   403,   404,   405,
     406,  1902,   407,   408,   409,   410,   411,   412,   413,   414,
    1903,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,  1904,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,  1905,   439,   440,   791,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,  1906,   453,   454,   455,   456,   457,  1907,   458,
     459,   460,   461,   462,   792,   463,   464,   465,   466,  1908,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,  1909,   479,   480,  1910,   481,   793,   482,   483,
     484,   485,   486,  1911,   487,   488,  1912,  1913,   489,   490,
     491,   492,   493,  1914,   494,   495,   496,   497,   498,   499,
     500,  1915,  1916,   501,   502,   503,   504,   505,  1917,  1918,
     506,   507,   508,   509,   510,   511,   512,  1919,   513,   794,
     514,   515,   516,   517,  1920,  1921,   518,  1922,  1923,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,  1846,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,  2811,   225,   226,   227,
    1847,   229,   230,   231,  1848,  1849,  1850,  1851,  1852,  1853,
    1854,   232,   233,  1855,   234,   235,   772,   236,   237,   238,
     239,   240,   773,   241,   242,  1856,   243,   244,   245,   246,
     247,  1857,  1858,   248,   249,   250,   251,   252,  1859,   253,
     254,   255,   256,   257,  1860,   774,  1861,   258,   259,   260,
     261,   775,   262,   263,   264,  1862,   265,   266,   267,   268,
     269,   270,  1863,   776,   271,   272,   273,  1864,  1865,  1866,
     777,  1867,  1868,  1869,   274,   275,   276,   277,   278,   279,
     280,   281,   282,  1870,   283,  1871,   284,   285,   286,   287,
     288,  1872,   289,   290,   291,  1873,  1874,   292,   293,   294,
    2812,   296,  1875,   297,   298,   299,  1876,   300,   301,   302,
    1877,   303,   304,   305,   306,   307,   308,   309,   310,   311,
    1878,   312,  1879,   313,   314,   315,   316,  1880,   317,  1881,
     318,   778,  1882,   779,   319,   320,   321,  1883,   322,   323,
    1884,   324,   325,  1885,   326,   327,   328,   329,   330,   780,
     331,   332,   333,   334,  1886,   335,   336,   337,   338,   339,
     340,  1887,   341,   781,   342,   343,   344,   345,   346,   347,
     348,  1888,   349,  1889,   350,   782,   783,   351,   784,   352,
     353,   354,   355,   356,  1890,  1891,   357,   358,   785,   359,
     786,  1892,   360,   361,   362,  1893,  1894,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   787,   379,   380,   381,   382,  1895,   383,
     384,   788,   385,  1896,   386,   387,   388,   389,   390,   391,
    1897,   392,  1898,  1899,   393,   394,   395,  1900,  1901,   396,
     397,   789,   398,   790,   399,   400,   401,   402,   403,   404,
     405,   406,  1902,   407,   408,   409,   410,   411,   412,   413,
     414,  1903,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,  1904,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,  1905,   439,   440,
     791,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,  1906,   453,   454,   455,   456,   457,  1907,
    2813,   459,   460,   461,   462,   792,   463,   464,   465,   466,
    1908,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,  1909,   479,   480,  1910,   481,   793,   482,
     483,   484,   485,   486,  1911,   487,   488,  1912,  1913,   489,
     490,   491,   492,   493,  1914,   494,   495,   496,   497,   498,
     499,   500,  1915,  1916,   501,   502,   503,   504,   505,  1917,
    1918,   506,   507,   508,   509,   510,   511,   512,  1919,   513,
     794,   514,   515,   516,   517,  1920,  1921,   518,  1922,  1923,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   771,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,   772,   236,   237,
     238,   239,   240,   773,   241,   242,     0,   243,   244,   245,
     246,   247,     0,  1132,   248,   249,   250,   251,   252,     0,
     253,   254,   255,   256,  1135,     0,  1136,     0,   258,   259,
     260,   261,   775,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,   776,   271,   272,   273,  1137,  1138,
    1139,  1140,  1141,  1142,  1143,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
    1147,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,   778,     0,   779,   319,   320,   321,     0,   322,
    1150,     0,   324,   325,     0,   326,   327,   328,   329,   330,
     780,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,   781,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   782,   783,   351,   784,
     352,   353,   354,   355,   356,     0,     0,   357,  1155,   785,
     359,   786,     0,   360,   361,   362,  1156,  1157,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   787,   379,   380,   381,   382,     0,
     383,   384,   788,   385,     0,  1162,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   789,   398,   790,  1165,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,  1166,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   791,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
    1169,   458,   459,   460,   461,   462,   792,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,  1171,     0,   479,   480,     0,   481,   793,
     482,   483,   484,   485,   486,     0,   487,   488,     0,     0,
     489,   490,  1174,   492,  1175,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
    1178,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,   794,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   525,  1180,  1181,
    1182,  1183,  1184,  1185,  1186,  1187,   534,   535,   536,   815,
       0,   593,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
       0,     0,     0,   232,   233,     0,   234,   235,   772,   236,
     237,   238,   239,   240,   773,   241,   242,     0,   243,   244,
     245,   246,   247,     0,     0,   248,   249,   250,   251,   252,
       0,   253,   254,   255,   256,   257,     0,   774,     0,   258,
     259,   260,   261,   775,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,   776,   271,   272,   273,     0,
       0,     0,   777,     0,     0,     0,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,  1660,   312,     0,   313,   314,   315,   316,     0,
     317,     0,   318,   778,     0,   779,   319,   320,   321,     0,
     322,   323,     0,   324,   325,     0,   326,   327,   328,   329,
     330,   780,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,   781,   342,   343,   344,   345,
     346,   347,   348,     0,   349,     0,   350,   782,   783,   351,
     784,   352,   353,   354,   355,   356,     0,     0,   357,   358,
     785,   359,   786,     0,   360,   361,   362,     0,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   787,   379,   380,   381,   382,
       0,   383,   384,   788,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,  1661,     0,   393,   394,   395,     0,
       0,   396,   397,   789,   398,   790,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   791,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   792,   463,   464,
     465,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,     0,   481,
     793,   482,   483,   484,   485,   486,     0,   487,   488,     0,
       0,   489,   490,   491,   492,   493,  1662,   494,   495,   496,
     497,   498,   499,   500,     0,     0,   501,   502,   503,   504,
     505,     0,     0,   506,   507,   508,   509,   510,   511,   512,
       0,   513,   794,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     815,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   220,   221,   222,   223,   224,
     225,   226,   227,   850,   229,   230,   231,     0,     0,     0,
       0,     0,     0,     0,   232,   233,     0,   234,   235,   772,
     236,   237,   238,   239,   240,   773,   241,   242,     0,   243,
     244,   245,   246,   247,     0,     0,   248,   249,   250,   251,
     252,     0,   253,   254,   255,   256,   257,     0,   774,     0,
     258,   259,   260,   261,   775,   262,   263,   264,     0,   265,
     266,   267,   268,   269,   270,     0,   776,   271,   272,   273,
       0,     0,     0,   777,     0,     0,   816,   274,   275,   276,
     277,   278,   279,   280,   281,   282,     0,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
       0,   317,     0,   318,   778,     0,   779,   319,   320,   321,
       0,   322,   323,     0,   324,   325,     0,   326,   327,   328,
     329,   330,   780,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,   781,   342,   343,   344,
     345,   346,   347,   348,     0,   349,     0,   350,   782,   783,
     351,   784,   352,   353,   354,   355,   356,     0,     0,   357,
     358,   785,   359,   786,     0,   360,   361,   362,     0,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   787,   379,   380,   381,
     382,     0,   383,   384,   788,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   789,   398,   790,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   791,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   817,   458,   459,   460,   461,   462,   792,   463,
     464,   465,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,     0,
     481,   793,   482,   483,   484,   485,   486,     0,   487,   488,
       0,     0,   489,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,     0,     0,   501,   502,   503,
     504,   505,     0,     0,   506,   507,   508,   509,   510,   511,
     512,     0,   513,   794,   514,   515,   516,   517,     0,     0,
     518,     0,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   815,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
     772,   236,   237,   238,   239,   240,   773,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,   774,
       0,   258,   259,   260,   261,   775,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,   776,   271,   272,
     273,     0,     0,     0,   777,     0,     0,   816,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,   778,     0,   779,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,   330,   780,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,   781,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,   782,
     783,   351,   784,   352,   353,   354,   355,   356,     0,     0,
     357,   358,   785,   359,   786,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   787,   379,   380,
     381,   382,     0,   383,   384,   788,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   789,   398,   790,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   791,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   817,   458,   459,   460,   461,   462,   792,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,   793,   482,   483,   484,   485,   486,     0,   487,
     488,     0,     0,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,  2206,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,   794,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   815,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,   772,   236,   237,   238,   239,   240,   773,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   248,   249,
     250,   251,   252,     0,   253,   254,   255,   256,   257,     0,
     774,     0,   258,   259,   260,   261,   775,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,   776,   271,
     272,   273,     0,     0,     0,   777,     0,     0,   816,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,     0,   317,     0,   318,   778,     0,   779,   319,
     320,   321,     0,   322,   323,  3108,   324,   325,     0,   326,
     327,   328,   329,   330,   780,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,   781,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     782,   783,   351,   784,   352,   353,   354,   355,   356,     0,
       0,   357,   358,   785,   359,   786,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   787,   379,
     380,   381,   382,     0,   383,   384,   788,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   789,   398,   790,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   791,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,   817,   458,   459,   460,   461,   462,
     792,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,     0,   481,   793,   482,   483,   484,   485,   486,     0,
     487,   488,     0,     0,   489,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,   794,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   815,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   232,   233,     0,
     234,   235,   772,   236,   237,   238,   239,   240,   773,   241,
     242,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   250,   251,   252,     0,   253,   254,   255,   256,   257,
       0,   774,     0,   258,   259,   260,   261,   775,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,   776,
     271,   272,   273,     0,     0,     0,   777,     0,     0,   816,
     274,   275,   276,   277,   278,   279,   280,   281,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,     0,   317,     0,   318,   778,     0,   779,
     319,   320,   321,     0,   322,   323,     0,   324,   325,     0,
     326,   327,   328,   329,   330,   780,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,   781,
     342,   343,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   782,   783,   351,   784,   352,   353,   354,   355,   356,
       0,     0,   357,   358,   785,   359,   786,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   787,
     379,   380,   381,   382,     0,   383,   384,   788,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   789,   398,   790,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   791,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   817,   458,   459,   460,   461,
     462,   792,   463,   464,   465,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,     0,   481,   793,   482,   483,   484,   485,   486,
       0,   487,   488,     0,     0,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,   511,   512,     0,   513,   794,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   815,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,   772,   236,   237,   238,   239,   240,   773,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   254,   255,   256,
     257,     0,   774,     0,   258,   259,   260,   261,   775,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
     776,   271,   272,   273,     0,     0,     0,   777,     0,     0,
     816,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,     0,   317,     0,   318,   778,     0,
     779,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,   330,   780,   331,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,     0,   341,
     781,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,   782,   783,   351,   784,   352,   353,   354,   355,
     356,     0,     0,   357,   358,   785,   359,   786,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   867,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     787,   379,   380,   381,   382,     0,   383,   384,   788,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   789,   398,
     790,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   791,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,   817,   458,   459,   460,
     461,   462,   792,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,     0,   481,   793,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,   511,   512,     0,   513,   794,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   815,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,     0,     0,     0,   232,
     233,     0,   234,   235,   772,   236,   237,   238,   239,   240,
     773,   241,   242,     0,   243,   244,   245,   246,   247,     0,
       0,   248,   249,   250,   251,   252,     0,   253,   254,   255,
     256,   257,     0,   774,     0,   258,   259,   260,   261,   775,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,   776,   271,   272,   273,     0,     0,     0,   777,     0,
       0,   816,   274,   275,   276,   277,   278,   279,   280,   281,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,     0,   317,     0,   318,   778,
       0,   779,   319,   320,   321,     0,   322,   323,     0,   324,
     325,     0,   326,   327,   328,   329,   330,   780,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,   781,   342,   343,   344,   345,   346,   347,   348,     0,
     349,     0,   350,   782,   783,   351,   784,   352,   353,   354,
     355,   356,     0,     0,   357,   358,   785,   359,   786,     0,
     360,   361,   362,     0,     0,   363,   364,   365,   366,   949,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   787,   379,   380,   381,   382,     0,   383,   384,   788,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   789,
     398,   790,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   791,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,   817,   458,   459,
     460,   461,   462,   792,   463,   464,   465,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,     0,   481,   793,   482,   483,   484,
     485,   486,     0,   487,   488,     0,     0,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
       0,     0,   501,   502,   503,   504,   505,     0,     0,   506,
     507,   508,   509,   510,   511,   512,     0,   513,   794,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   815,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     229,   230,   231,     0,     0,     0,     0,     0,     0,     0,
     232,   233,     0,   234,   235,   772,   236,   237,   238,   239,
     240,   773,   241,   242,     0,   243,   244,   245,   246,   247,
       0,     0,   248,   249,   250,   251,   252,     0,   253,   254,
     255,   256,   257,     0,   774,     0,   258,   259,   260,   261,
     775,   262,   263,   264,     0,   265,   266,   267,   268,   269,
     270,     0,   776,   271,   272,   273,     0,     0,     0,   777,
       0,     0,   816,   274,   275,   276,   277,   278,   279,   280,
     281,   282,     0,   283,     0,   284,   285,   286,   287,   288,
       0,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,     0,   297,   298,   299,     0,   300,   301,   302,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,     0,   317,     0,   318,
     778,     0,   779,   319,   320,   321,     0,   322,   323,     0,
     324,   325,     0,   326,   327,   328,   329,  1021,   780,   331,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
       0,   341,   781,   342,   343,   344,   345,   346,   347,   348,
       0,   349,     0,   350,   782,   783,   351,   784,   352,   353,
     354,   355,   356,     0,     0,   357,   358,   785,   359,   786,
       0,   360,   361,   362,     0,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   787,   379,   380,   381,   382,     0,   383,   384,
     788,   385,     0,   386,   387,   388,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     789,   398,   790,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   791,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,   817,   458,
     459,   460,   461,   462,   792,   463,   464,   465,   466,     0,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,     0,   481,   793,   482,   483,
     484,   485,   486,     0,   487,   488,     0,     0,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,     0,     0,   501,   502,   503,   504,   505,     0,     0,
     506,   507,   508,   509,   510,   511,   512,     0,   513,   794,
     514,   515,   516,   517,     0,     0,   518,     0,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   815,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,     0,     0,
       0,   232,   233,     0,   234,   235,   772,   236,   237,   238,
     239,   240,   773,   241,   242,     0,   243,   244,   245,   246,
     247,     0,     0,   248,   249,   250,   251,   252,     0,   253,
     254,   255,   256,   257,     0,   774,     0,   258,   259,   260,
     261,   775,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,   776,   271,   272,   273,     0,     0,     0,
     777,     0,     0,   816,   274,   275,   276,   277,   278,   279,
     280,   281,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,     0,   317,     0,
     318,   778,     0,   779,   319,   320,   321,     0,   322,   323,
       0,   324,   325,     0,   326,   327,   328,   329,  1033,   780,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,   781,   342,   343,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   782,   783,   351,   784,   352,
     353,   354,   355,   356,     0,     0,   357,   358,   785,   359,
     786,     0,   360,   361,   362,     0,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   787,   379,   380,   381,   382,     0,   383,
     384,   788,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   789,   398,   790,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     791,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   817,
     458,   459,   460,   461,   462,   792,   463,   464,   465,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,     0,   481,   793,   482,
     483,   484,   485,   486,     0,   487,   488,     0,     0,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,     0,     0,   501,   502,   503,   504,   505,     0,
       0,   506,   507,   508,   509,   510,   511,   512,     0,   513,
     794,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   815,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,   772,   236,   237,
     238,   239,   240,   773,   241,   242,     0,   243,   244,   245,
     246,   247,     0,     0,   248,   249,   250,   251,   252,     0,
     253,   254,   255,   256,   257,     0,   774,     0,   258,   259,
     260,   261,   775,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,   776,   271,   272,   273,     0,     0,
       0,   777,     0,     0,   816,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,   778,     0,   779,   319,   320,   321,     0,   322,
     323,     0,   324,   325,     0,   326,   327,   328,   329,  1047,
     780,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,   781,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   782,   783,   351,   784,
     352,   353,   354,   355,   356,     0,     0,   357,   358,   785,
     359,   786,     0,   360,   361,   362,     0,     0,   363,   364,
     365,   366,  1048,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   787,   379,   380,   381,   382,     0,
     383,   384,   788,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   789,   398,   790,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   791,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
     817,   458,   459,   460,   461,   462,   792,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,     0,   481,   793,
     482,   483,   484,   485,   486,     0,   487,   488,     0,     0,
     489,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
       0,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,   794,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   815,
       0,   593,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
       0,     0,     0,   232,   233,     0,   234,   235,   772,   236,
     237,   238,   239,   240,   773,   241,   242,     0,   243,   244,
     245,   246,   247,     0,     0,   248,   249,   250,   251,   252,
       0,   253,   254,   255,   256,   257,     0,   774,     0,   258,
     259,   260,   261,   775,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,   776,   271,   272,   273,     0,
       0,     0,   777,     0,     0,     0,   274,   275,   276,   277,
     278,   279,   280,   281,   282,  1821,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,     0,
     317,     0,   318,   778,     0,   779,   319,   320,   321,     0,
     322,   323,     0,   324,   325,     0,   326,   327,   328,   329,
     330,   780,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,   781,   342,   343,   344,   345,
     346,   347,   348,     0,   349,     0,   350,   782,   783,   351,
     784,   352,   353,   354,   355,   356,     0,     0,   357,   358,
     785,   359,   786,     0,   360,   361,   362,     0,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   787,   379,   380,   381,   382,
       0,   383,   384,   788,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   789,   398,   790,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   791,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   792,   463,   464,
     465,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,     0,   481,
     793,   482,   483,   484,   485,   486,     0,   487,   488,     0,
       0,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,     0,     0,   501,   502,   503,   504,
     505,     0,     0,   506,   507,   508,   509,   510,   511,   512,
       0,   513,   794,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     815,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   229,   230,   231,     3,     4,     0,
       0,     0,     0,     0,   232,   233,     0,   234,   235,   772,
     236,   237,   238,   239,   240,   773,   241,   242,     0,   243,
     244,   245,   246,   247,     0,     0,   248,   249,   250,   251,
     252,     0,   253,   254,   255,   256,   257,     0,   774,     0,
     258,   259,   260,   261,   775,   262,   263,   264,     0,   265,
     266,   267,   268,   269,   270,     0,   776,   271,   272,   273,
       0,     0,     0,   777,     0,     0,     0,   274,   275,   276,
     277,   278,   279,   280,   281,   282,     0,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
       0,   317,     0,   318,   778,     0,   779,   319,   320,   321,
       0,   322,   323,     0,   324,   325,     0,   326,   327,   328,
     329,   330,   780,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,   781,   342,   343,   344,
     345,   346,   347,   348,     0,   349,     0,   350,   782,   783,
     351,   784,   352,   353,   354,   355,   356,     0,     0,   357,
     358,   785,   359,   786,     0,   360,   361,   362,     0,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   787,   379,   380,   381,
     382,     0,   383,   384,   788,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   789,   398,   790,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   791,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,     0,   458,   459,   460,   461,   462,   792,   463,
     464,   465,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,     0,
     481,   793,   482,   483,   484,   485,   486,     0,   487,   488,
       0,     0,   489,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,     0,     0,   501,   502,   503,
     504,   505,     0,     0,   506,   507,   508,   509,   510,   511,
     512,     0,   513,   794,   514,   515,   516,   517,     0,     0,
     518,     0,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   815,     0,   593,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
     772,   236,   237,   238,   239,   240,   773,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,   774,
       0,   258,   259,   260,   261,   775,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,   776,   271,   272,
     273,     0,     0,     0,   777,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,   778,     0,   779,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,   330,   780,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,   781,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,   782,
     783,   351,   784,   352,   353,   354,   355,   356,     0,     0,
     357,   358,   785,   359,   786,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   787,   379,   380,
     381,   382,     0,   383,   384,   788,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   789,   398,   790,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   791,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   792,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,   793,   482,   483,   484,   485,   486,     0,   487,
     488,     0,     0,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,   794,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   815,     0,   593,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,   772,   236,   237,   238,   239,   240,   773,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   248,   249,
     250,   251,   252,     0,   253,   254,   255,   256,   257,     0,
     774,     0,   258,   259,   260,   261,   775,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,   776,   271,
     272,   273,     0,     0,     0,   777,     0,     0,     0,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,     0,   317,     0,   318,   778,     0,   779,   319,
     320,   321,     0,   322,   323,     0,   324,   325,     0,   326,
     327,   328,   329,  1650,   780,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,   781,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     782,   783,   351,   784,   352,   353,   354,   355,   356,     0,
       0,   357,   358,   785,   359,   786,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   787,   379,
     380,   381,   382,     0,   383,   384,   788,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   789,   398,   790,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   791,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,     0,   458,   459,   460,   461,   462,
     792,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,     0,   481,   793,   482,   483,   484,   485,   486,     0,
     487,   488,     0,     0,   489,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,   794,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   771,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   232,   233,     0,
     234,   235,   772,   236,   237,   238,   239,   240,   773,   241,
     242,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   250,   251,   252,     0,   253,   254,   255,   256,   257,
       0,   774,     0,   258,   259,   260,   261,   775,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,   776,
     271,   272,   273,     0,     0,     0,   777,     0,     0,     0,
     274,   275,   276,   277,   278,   279,   280,   281,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,     0,   317,     0,   318,   778,     0,   779,
     319,   320,   321,     0,   322,   323,     0,   324,   325,     0,
     326,   327,   328,   329,   330,   780,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,   781,
     342,   343,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   782,   783,   351,   784,   352,   353,   354,   355,   356,
       0,     0,   357,   358,   785,   359,   786,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   787,
     379,   380,   381,   382,     0,   383,   384,   788,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   789,   398,   790,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   791,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   792,   463,   464,   465,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,     0,   481,   793,   482,   483,   484,   485,   486,
       0,   487,   488,     0,     0,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,   511,   512,     0,   513,   794,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   771,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,   772,   236,   237,   238,   239,   240,   773,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   254,   255,   256,
     257,     0,   774,     0,   258,   259,   260,   261,   775,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
     776,   271,   272,   273,     0,     0,     0,   777,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,     0,   317,     0,   318,   778,     0,
     779,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,   970,   780,   331,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,     0,   341,
     781,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,   782,   783,   351,   784,   352,   353,   354,   355,
     356,     0,     0,   357,   358,   785,   359,   786,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     787,   379,   380,   381,   382,     0,   383,   384,   788,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,   397,   789,   398,
     790,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   791,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,   792,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,     0,   481,   793,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,   511,   512,     0,   513,   794,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   771,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,     0,     0,     0,   232,
     233,     0,   234,   235,   772,   236,   237,   238,   239,   240,
     773,   241,   242,     0,   243,   244,   245,   246,   247,     0,
       0,   248,   249,   250,   251,   252,     0,   253,   254,   255,
     256,   257,     0,   774,     0,   258,   259,   260,   261,   775,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,   776,   271,   272,   273,     0,     0,     0,   777,     0,
       0,     0,   274,   275,   276,   277,   278,   279,   280,   281,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,     0,   317,     0,   318,   778,
       0,   779,   319,   320,   321,     0,   322,   323,     0,   324,
     325,     0,   326,   327,   328,   329,  1019,   780,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,   781,   342,   343,   344,   345,   346,   347,   348,     0,
     349,     0,   350,   782,   783,   351,   784,   352,   353,   354,
     355,   356,     0,     0,   357,   358,   785,   359,   786,     0,
     360,   361,   362,     0,     0,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   787,   379,   380,   381,   382,     0,   383,   384,   788,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   789,
     398,   790,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   791,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   792,   463,   464,   465,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,     0,   481,   793,   482,   483,   484,
     485,   486,     0,   487,   488,     0,     0,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
       0,     0,   501,   502,   503,   504,   505,     0,     0,   506,
     507,   508,   509,   510,   511,   512,     0,   513,   794,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     229,   230,   231,     0,     0,     0,     0,     0,     0,     0,
     232,   233,     0,   234,   235,     0,   236,   237,   238,   239,
     240,     0,   241,   242,     0,   243,   244,   245,   246,   247,
       0,     0,   248,   249,   250,   251,   252,  2026,   253,   254,
     255,   256,   257,     0,     0,  2100,   258,   259,   260,   261,
       0,   262,   263,   264,  2027,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,     0,     0,     0,     0,
       0,     0,     0,   274,   275,   276,   277,   278,   279,   280,
     281,   282,     0,   283,     0,   284,   285,   286,   287,   288,
       0,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,     0,   297,   298,   299,     0,   300,   301,   302,     0,
    2101,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,     0,   317,  2029,   318,
       0,     0,     0,   319,   320,   321,     0,   322,   323,     0,
     324,   325,     0,   326,   327,   328,   329,   330,     0,   331,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,   351,     0,   352,   353,
     354,   355,   356,     0,     0,   357,   358,     0,   359,     0,
       0,   360,   361,   362,     0,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,   397,
       0,   398,     0,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   409,   410,   411,   412,   413,   414,
    2030,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,     0,   458,
     459,   460,   461,   462,     0,   463,   464,   465,   466,     0,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,     0,   481,     0,   482,   483,
     484,   485,   486,     0,   487,   488,     0,     0,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,     0,  2031,   501,   502,   503,   504,   505,     0,     0,
     506,   507,   508,   509,   510,   511,   512,     0,   513,     0,
     514,   515,   516,   517,     0,     0,   518,     0,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,     0,     0,
       0,   232,   233,     0,   234,   235,     0,   236,   237,   238,
     239,   240,     0,   241,   242,     0,   243,   244,   245,   246,
     247,     0,     0,   248,   249,   250,   251,   252,  2026,   253,
     254,   255,   256,   257,     0,     0,     0,   258,   259,   260,
     261,     0,   262,   263,   264,  2027,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,     0,     0,     0,
       0,     0,     0,     0,   274,   275,   276,   277,   278,   279,
     280,   281,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,  2101,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,     0,   317,  2029,
     318,     0,     0,     0,   319,   320,   321,     0,   322,   323,
       0,   324,   325,     0,   326,   327,   328,   329,   330,     0,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,     0,   342,   343,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,   351,     0,   352,
     353,   354,   355,   356,     0,     0,   357,   358,     0,   359,
    2973,     0,   360,   361,   362,     0,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   409,   410,   411,   412,   413,
     414,  2030,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,     0,   463,   464,   465,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,     0,   481,     0,   482,
     483,   484,   485,   486,     0,   487,   488,     0,     0,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,     0,  2031,   501,   502,   503,   504,   505,     0,
       0,   506,   507,   508,   509,   510,   511,   512,     0,   513,
       0,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   219,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   220,   221,   222,   223,   224,   703,   226,
     227,   665,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,     0,   236,   237,
     238,   239,   240,     0,   241,   242,     0,   243,   244,   245,
     246,   247,     0,     0,   248,   249,   250,   251,   252,     0,
     253,   254,   255,   256,   257,     0,     0,     0,   258,   259,
     260,   261,     0,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,   666,     0,   271,   272,   273,     0,     0,
       0,     0,     0,     0,     0,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,     0,     0,     0,   319,   320,   321,   704,   322,
     323,     0,   324,   325,     0,   326,   327,   328,   329,   330,
       0,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,   351,     0,
     352,   353,   354,   355,   356,     0,     0,   357,   358,     0,
     359,     0,     0,   360,   361,   362,     0,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   667,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   668,   453,   454,   455,   456,   457,
       0,   458,   459,   460,   461,   462,     0,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,     0,   481,     0,
     482,   483,   484,   485,   486,     0,   487,   488,     0,     0,
     489,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
       0,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,     0,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,   665,   229,   230,   231,     0,     0,     0,     0,
       0,     0,     0,   232,   233,     0,   234,   235,     0,   236,
     237,   238,   239,   240,     0,   241,   242,     0,   243,   244,
     245,   246,   247,     0,     0,   248,   249,   250,   251,   252,
       0,   253,   254,   255,   256,   257,     0,     0,     0,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,   666,     0,   271,   272,   273,     0,
       0,     0,     0,     0,     0,     0,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,     0,
     317,     0,   318,     0,     0,     0,   319,   320,   321,  2711,
     322,   323,     0,   324,   325,     0,   326,   327,   328,   329,
     330,     0,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,     0,   342,   343,   344,   345,
     346,   347,   348,     0,   349,     0,   350,     0,     0,   351,
       0,   352,   353,   354,   355,   356,     0,     0,   357,   358,
       0,   359,     0,     0,   360,   361,   362,     0,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   667,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   668,   453,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,     0,   463,   464,
     465,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,     0,   481,
       0,   482,   483,   484,   485,   486,     0,   487,   488,     0,
       0,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,     0,     0,   501,   502,   503,   504,
     505,     0,     0,   506,   507,   508,   509,   510,   511,   512,
       0,   513,     0,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     219,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   229,   230,   231,     0,     0,     0,
       0,     0,     0,     0,   232,   233,     0,   234,   235,     0,
     236,   237,   238,   239,   240,     0,   241,   242,     0,   243,
     244,   245,   246,   247,     0,     0,   248,   249,   250,   251,
     252,  2026,   253,   254,   255,   256,   257,     0,     0,     0,
     258,   259,   260,   261,     0,   262,   263,   264,  2027,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
       0,     0,     0,     0,     0,     0,     0,   274,   275,   276,
     277,   278,   279,   280,   281,   282,     0,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,  2101,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
       0,   317,  2029,   318,     0,     0,     0,   319,   320,   321,
       0,   322,   323,     0,   324,   325,     0,   326,   327,   328,
     329,   330,     0,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,   348,     0,   349,     0,   350,     0,     0,
     351,     0,   352,   353,   354,   355,   356,     0,     0,   357,
     358,     0,   359,     0,     0,   360,   361,   362,     0,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,     0,   398,     0,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   409,   410,
     411,   412,   413,   414,  2030,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,     0,   458,   459,   460,   461,   462,     0,   463,
     464,   465,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,     0,
     481,     0,   482,   483,   484,   485,   486,     0,   487,   488,
       0,     0,   489,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,     0,  2031,   501,   502,   503,
     504,   505,     0,     0,   506,   507,   508,   509,   510,   511,
     512,     0,   513,     0,   514,   515,   516,   517,     0,     0,
     518,     0,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   219,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,   665,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
       0,   236,   237,   238,   239,   240,     0,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,     0,
       0,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,   666,     0,   271,   272,
     273,     0,     0,     0,     0,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,     0,     0,     0,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,   330,     0,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,     0,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,   351,     0,   352,   353,   354,   355,   356,     0,     0,
     357,   358,     0,   359,     0,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   667,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   668,   453,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,     0,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,     0,   482,   483,   484,   485,   486,     0,   487,
     488,     0,     0,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,     0,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   219,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,   221,   222,
     223,   224,   225,   226,   227,  1687,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,     0,   236,   237,   238,   239,   240,     0,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   248,   249,
     250,   251,   252,     0,   253,   254,   255,   256,   257,     0,
       0,     0,   258,   259,   260,   261,     0,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,     0,     0,     0,     0,     0,     0,     0,   274,
     275,   276,  1688,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,  1689,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,     0,   317,  1690,   318,     0,     0,     0,  1691,
     320,   321,     0,   322,   323,     0,   324,   325,     0,   326,
     327,   328,   329,   330,     0,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,   351,     0,   352,   353,  1692,  1693,   356,     0,
       0,   357,   358,     0,   359,     0,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,     0,   398,     0,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,   447,  1694,   449,   450,   451,   452,     0,  1695,
     454,   455,   456,   457,     0,   458,   459,   460,   461,   462,
       0,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,  1696,   481,     0,  1697,   483,   484,   485,   486,     0,
     487,   488,     0,     0,   489,   490,   491,   492,   493,     0,
     494,   495,  1698,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,     0,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   219,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   232,   233,     0,
     234,   235,     0,   236,   237,   238,   239,   240,     0,   241,
     242,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   250,   251,   252,     0,   253,   254,   255,   256,   257,
       0,     0,     0,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,   666,     0,
     271,   272,   273,     0,     0,     0,     0,     0,     0,     0,
     274,   275,   276,   277,   278,   279,   280,   281,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,     0,   317,     0,   318,     0,     0,     0,
     319,   320,   321,     0,   322,   323,     0,   324,   325,     0,
     326,   327,   328,   329,   330,     0,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,     0,
     342,   343,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,   351,     0,   352,   353,   354,   355,   356,
       0,     0,   357,   358,     0,   359,     0,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   667,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   668,
     453,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,     0,   463,   464,   465,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,     0,   481,     0,   482,   483,   484,   485,   486,
       0,   487,   488,     0,     0,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,   511,   512,     0,   513,     0,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   219,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   220,
     221,   222,   223,   224,   225,   226,   227,   860,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,     0,   236,   237,   238,   239,   240,     0,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   254,   255,   256,
     257,     0,     0,     0,   258,   259,   260,   261,     0,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,     0,     0,     0,     0,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,     0,   317,     0,   318,     0,     0,
       0,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,   861,     0,   331,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,   351,     0,   352,   353,   354,   355,
     356,     0,     0,   357,   358,     0,   359,     0,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
     735,   393,   394,   395,     0,     0,   396,   397,     0,   398,
       0,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,     0,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,     0,   481,     0,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,   511,   512,     0,   513,     0,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   219,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     3,     4,     0,     0,     0,     0,     0,   232,
     233,     0,   234,   235,     0,   236,   237,   238,   239,   240,
       0,   241,   242,     0,   243,   244,   245,   246,   247,     0,
       0,   248,   249,   250,   251,   252,     0,   253,   254,   255,
     256,   257,     0,     0,     0,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,     0,     0,     0,     0,     0,
       0,     0,   274,   275,   276,   277,   278,   279,   280,   281,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,     0,   317,     0,   318,     0,
       0,     0,   319,   320,   321,     0,   322,   323,     0,   324,
     325,     0,   326,   327,   328,   329,   330,     0,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,   348,     0,
     349,     0,   350,     0,     0,   351,     0,   352,   353,   354,
     355,   356,     0,     0,   357,   358,     0,   359,     0,     0,
     360,   361,   362,     0,     0,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,     0,   463,   464,   465,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,     0,   481,     0,   482,   483,   484,
     485,   486,     0,   487,   488,     0,     0,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
       0,     0,   501,   502,   503,   504,   505,     0,     0,   506,
     507,   508,   509,   510,   511,   512,     0,   513,     0,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   220,   221,   222,   223,   224,   225,   226,   227,  2794,
     229,   230,   231,     0,     0,     0,     0,     0,     0,     0,
     232,   233,     0,   234,   235,     0,   236,   237,   238,   239,
     240,     0,   241,   242,     0,   243,   244,   245,   246,   247,
       0,     0,   248,   249,   250,   251,   252,     0,   253,   254,
     255,   256,   257,     0,     0,     0,   258,   259,   260,   261,
       0,   262,   263,   264,     0,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,     0,     0,     0,     0,
       0,     0,     0,   274,   275,   276,   277,   278,   279,   280,
     281,   282,     0,   283,     0,   284,   285,   286,   287,   288,
       0,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,     0,   297,   298,   299,     0,   300,   301,   302,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,     0,   317,     0,   318,
       0,     0,     0,   319,   320,   321,     0,   322,   323,     0,
     324,   325,     0,   326,   327,   328,   329,   330,     0,   331,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,   351,     0,   352,   353,
     354,   355,   356,     0,     0,   357,   358,     0,   359,     0,
       0,   360,   361,   362,     0,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,   397,
       0,   398,     0,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,     0,   458,
     459,   460,   461,   462,     0,   463,   464,   465,   466,     0,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,     0,   481,     0,   482,   483,
     484,   485,   486,     0,   487,   488,     0,     0,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,     0,     0,   501,   502,   503,   504,   505,  2795,     0,
     506,   507,   508,   509,   510,   511,   512,     0,   513,     0,
     514,   515,   516,   517,     0,     0,   518,     0,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
    2807,   229,   230,   231,     0,     0,     0,     0,     0,     0,
       0,   232,   233,     0,   234,   235,     0,   236,   237,   238,
     239,   240,     0,   241,   242,     0,   243,   244,   245,   246,
     247,     0,     0,   248,   249,   250,   251,   252,     0,   253,
     254,   255,   256,   257,     0,     0,     0,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,     0,     0,     0,
       0,     0,     0,     0,   274,   275,   276,   277,   278,   279,
     280,   281,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,     0,   317,     0,
     318,     0,     0,     0,   319,   320,   321,     0,   322,   323,
       0,   324,   325,     0,   326,   327,   328,   329,   330,     0,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,     0,   342,   343,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,   351,     0,   352,
     353,   354,   355,   356,     0,     0,   357,   358,     0,   359,
       0,     0,   360,   361,   362,     0,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,     0,   463,   464,   465,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,     0,   481,     0,   482,
     483,   484,   485,   486,     0,   487,   488,     0,     0,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,     0,     0,   501,   502,   503,   504,   505,  2808,
       0,   506,   507,   508,   509,   510,   511,   512,     0,   513,
       0,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   219,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,     0,   236,   237,
     238,   239,   240,     0,   241,   242,     0,   243,   244,   245,
     246,   247,     0,     0,   248,   249,   250,   251,   252,     0,
     253,   254,   255,   256,   257,     0,     0,     0,   258,   259,
     260,   261,     0,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,     0,     0,
       0,     0,     0,     0,     0,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,     0,     0,     0,   319,   320,   321,     0,   322,
     323,     0,   324,   325,     0,   326,   327,   328,   329,   330,
       0,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,   351,     0,
     352,   353,   354,   355,   356,     0,     0,   357,   358,     0,
     359,     0,     0,   360,   361,   362,     0,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
       0,   458,   459,   460,   461,   462,     0,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,     0,   481,     0,
     482,   483,   484,   485,   486,     0,   487,   488,     0,     0,
     489,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
       0,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,     0,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,   584,   229,   230,   231,     0,     0,     0,     0,
       0,     0,     0,   232,   233,     0,   234,   235,     0,   236,
     237,   238,   239,   240,     0,   241,   242,     0,   243,   244,
     245,   246,   247,     0,     0,   248,   249,   250,   251,   252,
       0,   253,   254,   255,   256,   257,     0,     0,     0,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,     0,
       0,     0,     0,     0,     0,     0,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,     0,
     317,     0,   318,     0,     0,     0,   319,   320,   321,     0,
     322,   323,     0,   324,   325,     0,   326,   327,   328,   329,
     330,     0,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,     0,   342,   343,   344,   345,
     346,   347,   348,     0,   349,     0,   350,     0,     0,   351,
       0,   352,   353,   354,   355,   356,     0,     0,   357,   358,
       0,   359,     0,     0,   360,   361,   362,     0,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   409,   410,   411,
     412,   585,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,     0,   463,   464,
     465,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,     0,   481,
       0,   482,   483,   484,   485,   486,     0,   487,   488,     0,
       0,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,     0,     0,   501,   502,   503,   504,
     505,     0,     0,   506,   507,   508,   509,   510,   511,   512,
       0,   513,     0,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     219,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   220,   221,   222,   223,   224,
     225,   226,   227,   695,   229,   230,   231,     0,     0,     0,
       0,     0,     0,     0,   232,   233,     0,   234,   235,     0,
     236,   237,   238,   239,   240,     0,   241,   242,     0,   243,
     244,   245,   246,   247,     0,     0,   248,   249,   250,   251,
     252,     0,   253,   254,   255,   256,   257,     0,     0,     0,
     258,   259,   260,   261,     0,   262,   263,   264,     0,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
       0,     0,     0,     0,     0,     0,     0,   274,   275,   276,
     277,   278,   279,   280,   281,   282,     0,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
       0,   317,     0,   318,     0,     0,     0,   319,   320,   321,
       0,   322,   323,     0,   324,   325,     0,   326,   327,   328,
     329,   330,     0,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,   348,     0,   349,     0,   350,     0,     0,
     351,     0,   352,   353,   354,   355,   356,     0,     0,   357,
     358,     0,   359,     0,     0,   360,   361,   362,     0,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,     0,   398,     0,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   696,     0,   458,   459,   460,   461,   462,     0,   463,
     464,   465,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,     0,
     481,     0,   482,   483,   484,   485,   486,     0,   697,   488,
       0,     0,   698,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,     0,     0,   501,   502,   503,
     504,   505,     0,     0,   506,   507,   508,   509,   510,   511,
     512,     0,   513,     0,   514,   515,   516,   517,     0,     0,
     518,     0,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   219,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,   729,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
       0,   236,   237,   238,   239,   240,     0,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,     0,
       0,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,     0,     0,     0,     0,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,     0,     0,     0,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,   330,     0,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,     0,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,   351,     0,   352,   353,   354,   355,   356,     0,     0,
     357,   358,     0,   359,     0,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   730,     0,   458,   459,   460,   461,   462,     0,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,     0,   482,   483,   484,   485,   486,     0,   731,
     488,     0,     0,   732,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,     0,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   219,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,     0,   236,   237,   238,   239,   240,     0,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   248,   249,
     250,   251,   252,     0,   253,   254,   255,   256,   257,     0,
       0,     0,   258,   259,   260,   261,     0,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,     0,     0,     0,     0,     0,     0,     0,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,     0,   317,     0,   318,     0,     0,     0,   319,
     320,   321,     0,   322,   323,     0,   324,   325,     0,   326,
     327,   328,   329,   330,     0,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,   351,     0,   352,   353,   354,   355,   356,     0,
       0,   357,   358,     0,   359,     0,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   735,   393,
     394,   395,     0,     0,   396,   397,     0,   398,     0,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,     0,   458,   459,   460,   461,   462,
       0,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,     0,   481,     0,   482,   483,   484,   485,   486,     0,
     487,   488,     0,     0,   489,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,     0,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   219,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,   824,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   232,   233,     0,
     234,   235,     0,   236,   237,   238,   239,   240,     0,   241,
     242,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   250,   251,   252,     0,   253,   254,   255,   256,   257,
       0,     0,     0,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,     0,     0,     0,     0,     0,     0,     0,
     274,   275,   276,   277,   278,   279,   280,   281,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,     0,   317,     0,   318,     0,     0,     0,
     319,   320,   321,     0,   322,   323,     0,   324,   325,     0,
     326,   327,   328,   329,   825,     0,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,     0,
     342,   343,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,   351,     0,   352,   353,   354,   355,   356,
       0,     0,   357,   358,     0,   359,     0,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,     0,   463,   464,   465,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,     0,   481,     0,   482,   483,   484,   485,   486,
       0,   487,   488,     0,     0,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,   511,   512,     0,   513,     0,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   219,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   220,
     221,   222,   223,   224,   225,   226,   227,   963,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,     0,   236,   237,   238,   239,   240,     0,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   254,   255,   256,
     257,     0,     0,     0,   258,   259,   260,   261,     0,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,     0,     0,     0,     0,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,     0,   317,     0,   318,     0,     0,
       0,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,   330,     0,   331,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,   351,     0,   352,   353,   354,   355,
     356,     0,     0,   357,   358,     0,   359,     0,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,   397,     0,   398,
       0,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,     0,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,     0,   481,     0,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,   511,   512,     0,   513,     0,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   219,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,  1225,   229,
     230,   231,     0,     0,     0,     0,     0,     0,     0,   232,
     233,     0,   234,   235,     0,   236,   237,   238,   239,   240,
       0,   241,   242,     0,   243,   244,   245,   246,   247,     0,
       0,   248,   249,   250,   251,   252,     0,   253,   254,   255,
     256,   257,     0,     0,     0,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,     0,     0,     0,     0,     0,
       0,     0,   274,   275,   276,   277,   278,   279,   280,   281,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,     0,   317,     0,   318,     0,
       0,     0,   319,   320,   321,     0,   322,   323,     0,   324,
     325,     0,   326,   327,   328,   329,   330,     0,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,   348,     0,
     349,     0,   350,     0,     0,   351,     0,   352,   353,   354,
     355,   356,     0,     0,   357,   358,     0,   359,     0,     0,
     360,   361,   362,     0,     0,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,     0,   463,   464,   465,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,     0,   481,     0,   482,   483,   484,
     485,   486,     0,   487,   488,     0,     0,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
       0,     0,   501,   502,   503,   504,   505,     0,     0,   506,
     507,   508,   509,   510,   511,   512,     0,   513,     0,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     229,   230,   231,     0,     0,     0,     0,     0,     0,     0,
     232,   233,     0,   234,   235,  1236,   236,   237,   238,   239,
     240,     0,   241,   242,     0,   243,   244,   245,   246,   247,
       0,     0,   715,   249,   250,   251,  1237,     0,   253,   254,
     255,   256,   257,     0,     0,     0,   258,   259,   260,   261,
       0,   262,   263,   264,     0,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,     0,     0,     0,     0,
       0,     0,     0,   274,   275,   276,   277,   278,   279,   280,
     281,   282,     0,   283,     0,   284,   285,   286,   287,   288,
       0,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,     0,   297,   298,   299,     0,   300,   301,   302,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,     0,   317,     0,   318,
       0,     0,     0,   319,   320,   321,     0,   322,   323,     0,
     324,   325,     0,   326,   327,   328,   329,   330,     0,   331,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,   351,     0,   352,   353,
     354,   355,   356,     0,     0,   357,   358,     0,   359,     0,
       0,   360,   361,   362,     0,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     718,   378,     0,   379,   380,   381,   382,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,   397,
       0,   398,     0,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     719,   442,   443,   444,   445,   446,   447,   720,   449,   450,
     451,   452,     0,   453,   454,   455,   456,  1229,     0,   458,
     459,   460,   461,   462,     0,   463,   464,   465,   466,     0,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,     0,   481,     0,   482,   483,
     484,   485,   486,     0,   722,   488,     0,     0,   723,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,     0,     0,   501,   502,   503,   504,   505,     0,     0,
     506,   507,   508,   509,   510,   511,   512,     0,   513,     0,
     514,   515,   516,   517,     0,     0,   518,     0,     0,   519,
     520,   521,   522,   523,   724,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,     0,     0,
       0,   232,   233,     0,   234,   235,     0,   236,   237,   238,
     239,   240,     0,   241,   242,     0,   243,   244,   245,   246,
     247,     0,     0,   248,   249,   250,   251,   252,     0,   253,
     254,   255,   256,   257,     0,     0,     0,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,     0,     0,     0,
       0,     0,     0,     0,   274,   275,   276,   277,   278,   279,
     280,   281,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,     0,   317,     0,
     318,     0,     0,     0,   319,   320,   321,     0,   322,   323,
       0,   324,   325,     0,   326,   327,   328,   329,  1344,     0,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,     0,   342,   343,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,   351,     0,   352,
     353,   354,   355,   356,     0,     0,   357,   358,     0,   359,
       0,     0,   360,   361,   362,     0,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   735,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,     0,   463,   464,   465,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,     0,   481,     0,   482,
     483,   484,   485,   486,     0,   487,   488,     0,     0,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,     0,     0,   501,   502,   503,   504,   505,     0,
       0,   506,   507,   508,   509,   510,   511,   512,     0,   513,
       0,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   219,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   220,   221,   222,   223,   224,   225,   226,
     227,  1395,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,     0,   236,   237,
     238,   239,   240,     0,   241,   242,     0,   243,   244,   245,
     246,   247,     0,     0,   248,   249,   250,   251,   252,     0,
     253,   254,   255,   256,   257,     0,     0,     0,   258,   259,
     260,   261,     0,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,     0,     0,
       0,     0,     0,     0,     0,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,     0,     0,     0,   319,   320,   321,     0,   322,
     323,     0,   324,   325,     0,   326,   327,   328,   329,  1396,
       0,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,   351,     0,
     352,   353,   354,   355,   356,     0,     0,   357,   358,     0,
     359,     0,     0,   360,   361,   362,     0,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
       0,   458,   459,   460,   461,   462,     0,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,     0,   481,     0,
     482,   483,   484,   485,   486,     0,   487,   488,     0,     0,
     489,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
       0,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,     0,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,   695,   229,   230,   231,     0,     0,     0,     0,
       0,     0,     0,   232,   233,     0,   234,   235,     0,   236,
     237,   238,   239,   240,     0,   241,   242,     0,   243,   244,
     245,   246,   247,     0,     0,   248,   249,   250,   251,   252,
       0,   253,   254,   255,   256,   257,     0,     0,     0,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,     0,
       0,     0,     0,     0,     0,     0,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,     0,
     317,     0,   318,     0,     0,     0,   319,   320,   321,     0,
     322,   323,     0,   324,   325,     0,   326,   327,   328,   329,
     330,     0,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,     0,   342,   343,   344,   345,
     346,   347,   348,     0,   349,     0,   350,     0,     0,   351,
       0,   352,   353,   354,   355,   356,     0,     0,   357,   358,
       0,   359,     0,     0,   360,   361,   362,     0,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,     0,   463,   464,
     465,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,     0,   481,
       0,   482,   483,   484,   485,   486,     0,   487,   488,     0,
       0,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,     0,     0,   501,   502,   503,   504,
     505,     0,     0,   506,   507,   508,   509,   510,   511,   512,
       0,   513,     0,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     219,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   229,   230,   231,     0,     0,     0,
       0,     0,     0,     0,   232,   233,     0,   234,   235,     0,
     236,   237,   238,   239,   240,     0,   241,   242,     0,   243,
     244,   245,   246,   247,     0,     0,   248,   249,   250,   251,
     252,     0,   253,   254,   255,   256,   257,     0,     0,     0,
     258,   259,   260,   261,     0,   262,   263,   264,     0,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
       0,     0,     0,     0,     0,     0,     0,   274,   275,   276,
     277,   278,   279,   280,   281,   282,     0,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
       0,   317,     0,   318,     0,     0,     0,   319,   320,  2601,
       0,   322,   323,     0,   324,   325,     0,   326,   327,   328,
     329,   330,     0,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,   348,     0,   349,     0,   350,     0,     0,
     351,     0,   352,   353,   354,   355,   356,     0,     0,   357,
     358,     0,   359,     0,     0,   360,   361,  2602,     0,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,     0,   398,     0,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,     0,   458,   459,   460,   461,   462,     0,   463,
     464,   465,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,  2603,
     481,     0,   482,  2604,   484,  2605,   486,     0,   487,   488,
       0,     0,   489,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,     0,     0,   501,   502,  2606,
     504,   505,     0,     0,   506,   507,   508,   509,   510,   511,
     512,     0,   513,     0,   514,   515,   516,   517,     0,     0,
     518,     0,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   219,     0,   593,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
       0,   236,   237,   238,   239,   240,     0,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,     0,
       0,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,     0,     0,     0,     0,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,     0,     0,     0,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,   330,     0,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,     0,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,   351,     0,   352,   353,   354,   355,   356,     0,     0,
     357,   358,     0,   359,     0,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,     0,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,     0,   482,   483,   484,   485,   486,     0,   487,
     488,     0,     0,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,     0,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   219,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,  3777,     0,   232,   233,     0,   234,
     235,     0,   236,   237,   238,   239,   240,     0,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   248,   249,
     250,   251,   252,     0,   253,   254,   255,   256,   257,     0,
       0,     0,   258,   259,   260,   261,     0,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,     0,     0,     0,     0,     0,     0,     0,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,     0,   317,     0,   318,     0,     0,     0,   319,
     320,   321,     0,   322,   323,     0,   324,   325,     0,   326,
     327,   328,   329,   330,     0,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,   351,     0,   352,   353,   354,   355,   356,     0,
       0,   357,   358,     0,   359,     0,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,     0,   398,     0,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,     0,   458,   459,   460,   461,   462,
       0,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,     0,   481,     0,   482,   483,   484,   485,   486,     0,
     487,   488,     0,     0,   489,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,     0,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   219,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,     0,  3791,     0,   232,   233,     0,
     234,   235,     0,   236,   237,   238,   239,   240,     0,   241,
     242,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   250,   251,   252,     0,   253,   254,   255,   256,   257,
       0,     0,     0,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,     0,     0,     0,     0,     0,     0,     0,
     274,   275,   276,   277,   278,   279,   280,   281,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,     0,   317,     0,   318,     0,     0,     0,
     319,   320,   321,     0,   322,   323,     0,   324,   325,     0,
     326,   327,   328,   329,   330,     0,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,     0,
     342,   343,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,   351,     0,   352,   353,   354,   355,   356,
       0,     0,   357,   358,     0,   359,     0,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,     0,   463,   464,   465,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,     0,   481,     0,   482,   483,   484,   485,   486,
       0,   487,   488,     0,     0,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,   511,   512,     0,   513,     0,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   219,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,     0,   236,   237,   238,   239,   240,     0,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   254,   255,   256,
     257,     0,     0,     0,   258,   259,   260,   261,     0,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,     0,     0,     0,     0,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,     0,   317,     0,   318,     0,     0,
       0,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,   330,     0,   331,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,   351,     0,   352,   353,   354,   355,
     356,     0,     0,   357,   358,     0,   359,     0,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,   397,     0,   398,
       0,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,     0,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,     0,   481,     0,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,  4456,   506,   507,
     508,   509,   510,   511,   512,     0,   513,     0,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   219,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,     0,     0,     0,   232,
     233,     0,   234,   235,     0,   236,   237,   238,   239,   240,
       0,   241,   242,     0,   243,   244,   245,   246,   247,     0,
       0,   248,   249,   250,   251,   252,     0,   253,   254,   255,
     256,   257,     0,     0,     0,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,     0,     0,     0,     0,     0,
       0,     0,   274,   275,   276,   277,   278,   279,   280,   281,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,     0,   317,     0,   318,     0,
       0,     0,   319,   320,   321,     0,   322,   323,     0,   324,
     325,     0,   326,   327,   328,   329,   330,     0,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,   348,     0,
     349,     0,   350,     0,     0,   351,     0,   352,   353,   354,
     355,   356,     0,     0,   357,   358,     0,   359,     0,     0,
     360,   361,   362,     0,     0,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,     0,   463,   464,   465,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,     0,   481,     0,   482,   483,   484,
     485,   486,     0,   487,   488,     0,     0,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
       0,     0,   501,   502,   503,   504,   505,     0,     0,   506,
     507,   508,   509,   510,   511,   512,     0,   513,     0,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     229,   230,   231,     0,     0,     0,     0,     0,     0,     0,
     232,   233,     0,   234,   235,     0,   236,   237,   238,   239,
     240,     0,   241,   242,     0,   243,   244,   245,   246,   247,
       0,     0,   248,   249,   250,   251,   252,     0,   253,   254,
     255,   256,   257,     0,     0,     0,   258,   259,   260,   261,
       0,   262,   263,   264,     0,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,     0,     0,     0,     0,
       0,     0,     0,   274,   275,   276,   277,   278,   279,   280,
     281,   282,     0,   283,     0,   284,   285,   286,   287,   288,
       0,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,     0,   297,   298,   299,     0,   300,   301,   302,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,     0,   317,     0,   318,
       0,     0,     0,   319,   320,   321,     0,   322,   323,     0,
     324,   325,     0,   326,   327,   328,   329,   330,     0,   331,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,   351,     0,   352,   353,
     354,   355,   356,     0,     0,   357,   358,     0,   359,     0,
       0,   360,   361,   362,     0,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,   397,
       0,   398,     0,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,     0,   458,
     459,   460,   461,   462,     0,   463,   464,   465,   466,     0,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,     0,   481,     0,   482,   483,
     484,   485,   486,     0,   487,   488,     0,     0,   681,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,     0,     0,   501,   502,   503,   504,   505,     0,     0,
     506,   507,   508,   509,   510,   511,   512,     0,   513,     0,
     514,   515,   516,   517,     0,     0,   518,     0,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,     0,     0,
       0,   232,   233,     0,   234,   235,     0,   236,   237,   238,
     239,   240,     0,   241,   242,     0,   243,   244,   245,   246,
     247,     0,     0,   248,   249,   250,   251,   252,     0,   253,
     254,   255,   256,   257,     0,     0,     0,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,     0,     0,     0,
       0,     0,     0,     0,   274,   275,   276,   277,   278,   279,
     280,   281,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,     0,   317,     0,
     318,     0,     0,     0,   319,   320,   321,     0,   322,   323,
       0,   324,   325,     0,   326,   327,   328,   329,   330,     0,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,     0,   342,   343,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,   351,     0,   352,
     353,   354,   355,   356,     0,     0,   357,   358,     0,   359,
       0,     0,   360,   361,   362,     0,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,   693,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,     0,   463,   464,   465,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,     0,   481,     0,   482,
     483,   484,   485,   486,     0,   487,   488,     0,     0,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,     0,     0,   501,   502,   503,   504,   505,     0,
       0,   506,   507,   508,   509,   510,   511,   512,     0,   513,
       0,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   219,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,     0,   236,   237,
     238,   239,   240,     0,   241,   242,     0,   243,   244,   245,
     246,   247,     0,     0,   715,   249,   250,   251,   252,     0,
     253,   254,   255,   256,   257,     0,     0,     0,   258,   259,
     260,   261,     0,   262,   263,   264,     0,   716,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,     0,     0,
       0,     0,     0,     0,     0,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,     0,     0,     0,   319,   320,   321,     0,   322,
     323,     0,   324,   325,     0,   326,   327,   328,   329,   330,
       0,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,   351,     0,
     352,   353,   354,   355,   356,     0,     0,   357,   358,     0,
     359,     0,     0,   360,   361,   717,     0,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   718,   378,     0,   379,   380,   381,   382,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   719,   442,   443,   444,   445,   446,   447,   720,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   721,
       0,   458,   459,   460,   461,   462,     0,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,     0,   481,     0,
     482,   483,   484,   485,   486,     0,   722,   488,     0,     0,
     723,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
       0,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,     0,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   724,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
       0,     0,     0,   232,   233,     0,   234,   235,     0,   236,
     237,   238,   239,   240,     0,   241,   242,     0,   243,   244,
     245,   246,   247,     0,     0,   248,   249,   250,   251,   252,
       0,   253,   254,   255,   256,   257,     0,     0,     0,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,     0,
       0,     0,     0,     0,     0,     0,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,     0,
     317,     0,   318,     0,     0,     0,   319,   320,   321,     0,
     322,   323,     0,   324,   325,     0,   326,   327,   328,   329,
     330,     0,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,     0,   342,   343,   344,   345,
     346,   347,   348,     0,   349,     0,   350,     0,     0,   351,
       0,   352,   353,   354,   355,   356,     0,     0,   357,   358,
       0,   359,     0,     0,   360,   361,   362,     0,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   747,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,     0,   463,   464,
     465,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,     0,   481,
       0,   482,   483,   484,   485,   486,     0,   487,   488,     0,
       0,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,     0,     0,   501,   502,   503,   504,
     505,     0,     0,   506,   507,   508,   509,   510,   511,   512,
       0,   513,     0,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     219,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   229,   230,   231,     0,     0,     0,
       0,     0,     0,     0,   232,   233,     0,   234,   235,     0,
     236,   237,   238,   239,   240,     0,   241,   242,     0,   243,
     244,   245,   246,   247,     0,     0,   248,   249,   250,   251,
     252,     0,   253,   254,   255,   256,   257,     0,     0,     0,
     258,   259,   260,   261,     0,   262,   263,   264,     0,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
       0,     0,     0,     0,     0,     0,     0,   274,   275,   276,
     277,   278,   279,   280,   281,   282,     0,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
       0,   317,     0,   318,     0,     0,     0,   319,   320,   321,
       0,   322,   323,     0,   324,   325,     0,   326,   327,   328,
     329,   848,     0,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,   348,     0,   349,     0,   350,     0,     0,
     351,     0,   352,   353,   354,   355,   356,     0,     0,   357,
     358,     0,   359,     0,     0,   360,   361,   362,     0,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,     0,   398,     0,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,     0,   458,   459,   460,   461,   462,     0,   463,
     464,   465,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,     0,
     481,     0,   482,   483,   484,   485,   486,     0,   487,   488,
       0,     0,   489,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,     0,     0,   501,   502,   503,
     504,   505,     0,     0,   506,   507,   508,   509,   510,   511,
     512,     0,   513,     0,   514,   515,   516,   517,     0,     0,
     518,     0,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   219,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
       0,   236,   237,   238,   239,   240,     0,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,     0,
       0,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,     0,     0,     0,     0,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,     0,     0,     0,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,   855,     0,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,     0,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,   351,     0,   352,   353,   354,   355,   356,     0,     0,
     357,   358,     0,   359,     0,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,     0,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,     0,   482,   483,   484,   485,   486,     0,   487,
     488,     0,     0,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,     0,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   219,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,     0,   236,   237,   238,   239,   240,     0,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   248,   249,
     250,   251,   252,     0,   253,   254,   255,   256,   257,     0,
       0,     0,   258,   259,   260,   261,     0,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,     0,     0,     0,     0,     0,     0,     0,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,     0,   317,     0,   318,     0,     0,     0,   319,
     320,   321,     0,   322,   323,     0,   324,   325,     0,   326,
     327,   328,   329,   870,     0,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,   351,     0,   352,   353,   354,   355,   356,     0,
       0,   357,   358,     0,   359,     0,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,     0,   398,     0,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,     0,   458,   459,   460,   461,   462,
       0,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,     0,   481,     0,   482,   483,   484,   485,   486,     0,
     487,   488,     0,     0,   489,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,     0,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   219,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   232,   233,     0,
     234,   235,     0,   236,   237,   238,   239,   240,     0,   241,
     242,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   250,   251,   252,     0,   253,   254,   255,   256,   257,
       0,     0,     0,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,     0,     0,     0,     0,     0,     0,     0,
     274,   275,   276,   277,   278,   279,   280,   281,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,     0,   317,     0,   318,     0,     0,     0,
     319,   320,   321,     0,   322,   323,     0,   324,   325,     0,
     326,   327,   328,   329,   925,     0,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,     0,
     342,   343,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,   351,     0,   352,   353,   354,   355,   356,
       0,     0,   357,   358,     0,   359,     0,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,     0,   463,   464,   465,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,     0,   481,     0,   482,   483,   484,   485,   486,
       0,   487,   488,     0,     0,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,   511,   512,     0,   513,     0,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   219,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,     0,   236,   237,   238,   239,   240,     0,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   254,   255,   256,
     257,     0,     0,     0,   258,   259,   260,   261,     0,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,     0,     0,     0,     0,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,     0,   317,     0,   318,     0,     0,
       0,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,   941,     0,   331,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,   351,     0,   352,   353,   354,   355,
     356,     0,     0,   357,   358,     0,   359,     0,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,   397,     0,   398,
       0,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,     0,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,     0,   481,     0,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,   511,   512,     0,   513,     0,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   219,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,     0,     0,     0,   232,
     233,     0,   234,   235,     0,   236,   237,   238,   239,   240,
       0,   241,   242,     0,   243,   244,   245,   246,   247,     0,
       0,   248,   249,   250,   251,   252,     0,   253,   254,   255,
     256,   257,     0,     0,     0,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,     0,     0,     0,     0,     0,
       0,     0,   274,   275,   276,   277,   278,   279,   280,   281,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,     0,   317,     0,   318,     0,
       0,     0,   319,   320,   321,     0,   322,   323,     0,   324,
     325,     0,   326,   327,   328,   329,   975,     0,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,   348,     0,
     349,     0,   350,     0,     0,   351,     0,   352,   353,   354,
     355,   356,     0,     0,   357,   358,     0,   359,     0,     0,
     360,   361,   362,     0,     0,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,     0,   463,   464,   465,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,     0,   481,     0,   482,   483,   484,
     485,   486,     0,   487,   488,     0,     0,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
       0,     0,   501,   502,   503,   504,   505,     0,     0,   506,
     507,   508,   509,   510,   511,   512,     0,   513,     0,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     229,   230,   231,     0,     0,     0,     0,     0,     0,     0,
     232,   233,     0,   234,   235,     0,   236,   237,   238,   239,
     240,     0,   241,   242,     0,   243,   244,   245,   246,   247,
       0,     0,   248,   249,   250,   251,   252,     0,   253,   254,
     255,   256,   257,     0,     0,     0,   258,   259,   260,   261,
       0,   262,   263,   264,     0,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,     0,     0,     0,     0,
       0,     0,     0,   274,   275,   276,   277,   278,   279,   280,
     281,   282,     0,   283,     0,   284,   285,   286,   287,   288,
       0,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,     0,   297,   298,   299,     0,   300,   301,   302,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,     0,   317,     0,   318,
       0,     0,     0,   319,   320,   321,     0,   322,   323,     0,
     324,   325,     0,   326,   327,   328,   329,  1031,     0,   331,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,   351,     0,   352,   353,
     354,   355,   356,     0,     0,   357,   358,     0,   359,     0,
       0,   360,   361,   362,     0,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,   397,
       0,   398,     0,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,     0,   458,
     459,   460,   461,   462,     0,   463,   464,   465,   466,     0,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,     0,   481,     0,   482,   483,
     484,   485,   486,     0,   487,   488,     0,     0,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,     0,     0,   501,   502,   503,   504,   505,     0,     0,
     506,   507,   508,   509,   510,   511,   512,     0,   513,     0,
     514,   515,   516,   517,     0,     0,   518,     0,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,     0,     0,
       0,   232,   233,     0,   234,   235,     0,   236,   237,   238,
     239,   240,     0,   241,   242,     0,   243,   244,   245,   246,
     247,     0,     0,   248,   249,   250,   251,   252,     0,   253,
     254,   255,   256,   257,     0,     0,     0,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,     0,     0,     0,
       0,     0,     0,     0,   274,   275,   276,   277,   278,   279,
     280,   281,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,     0,   317,     0,
     318,     0,     0,     0,   319,   320,   321,     0,   322,   323,
       0,   324,   325,     0,   326,   327,   328,   329,  1035,     0,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,     0,   342,   343,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,   351,     0,   352,
     353,   354,   355,   356,     0,     0,   357,   358,     0,   359,
       0,     0,   360,   361,   362,     0,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,     0,   463,   464,   465,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,     0,   481,     0,   482,
     483,   484,   485,   486,     0,   487,   488,     0,     0,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,     0,     0,   501,   502,   503,   504,   505,     0,
       0,   506,   507,   508,   509,   510,   511,   512,     0,   513,
       0,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   219,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,     0,   236,   237,
     238,   239,   240,     0,   241,   242,     0,   243,   244,   245,
     246,   247,     0,     0,   248,   249,   250,   251,   252,     0,
     253,   254,   255,   256,   257,     0,     0,     0,   258,   259,
     260,   261,     0,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,     0,     0,
       0,     0,     0,     0,     0,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,     0,     0,     0,   319,   320,   321,     0,   322,
     323,     0,   324,   325,     0,   326,   327,   328,   329,  1037,
       0,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,   351,     0,
     352,   353,   354,   355,   356,     0,     0,   357,   358,     0,
     359,     0,     0,   360,   361,   362,     0,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
       0,   458,   459,   460,   461,   462,     0,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,     0,   481,     0,
     482,   483,   484,   485,   486,     0,   487,   488,     0,     0,
     489,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
       0,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,     0,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
       0,     0,     0,   232,   233,     0,   234,   235,     0,   236,
     237,   238,   239,   240,     0,   241,   242,     0,   243,   244,
     245,   246,   247,     0,     0,   248,   249,   250,   251,   252,
       0,   253,   254,   255,   256,   257,     0,     0,     0,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,     0,
       0,     0,     0,     0,     0,     0,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,     0,
     317,     0,   318,     0,     0,     0,   319,   320,   321,     0,
     322,   323,     0,   324,   325,     0,   326,   327,   328,   329,
    1039,     0,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,     0,   342,   343,   344,   345,
     346,   347,   348,     0,   349,     0,   350,     0,     0,   351,
       0,   352,   353,   354,   355,   356,     0,     0,   357,   358,
       0,   359,     0,     0,   360,   361,   362,     0,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,     0,   463,   464,
     465,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,     0,   481,
       0,   482,   483,   484,   485,   486,     0,   487,   488,     0,
       0,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,     0,     0,   501,   502,   503,   504,
     505,     0,     0,   506,   507,   508,   509,   510,   511,   512,
       0,   513,     0,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     219,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   229,   230,   231,     0,     0,     0,
       0,     0,     0,     0,   232,   233,     0,   234,   235,     0,
     236,   237,   238,   239,   240,     0,   241,   242,     0,   243,
     244,   245,   246,   247,     0,     0,   248,   249,   250,   251,
     252,     0,   253,   254,   255,   256,   257,     0,     0,     0,
     258,   259,   260,   261,     0,   262,   263,   264,     0,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
       0,     0,     0,     0,     0,     0,     0,   274,   275,   276,
     277,   278,   279,   280,   281,   282,     0,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
       0,   317,     0,   318,     0,     0,     0,   319,   320,   321,
       0,   322,   323,     0,   324,   325,     0,   326,   327,   328,
     329,  1043,     0,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,   348,     0,   349,     0,   350,     0,     0,
     351,     0,   352,   353,   354,   355,   356,     0,     0,   357,
     358,     0,   359,     0,     0,   360,   361,   362,     0,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,     0,   398,     0,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,     0,   458,   459,   460,   461,   462,     0,   463,
     464,   465,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,     0,
     481,     0,   482,   483,   484,   485,   486,     0,   487,   488,
       0,     0,   489,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,     0,     0,   501,   502,   503,
     504,   505,     0,     0,   506,   507,   508,   509,   510,   511,
     512,     0,   513,     0,   514,   515,   516,   517,     0,     0,
     518,     0,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   219,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
       0,   236,   237,   238,   239,   240,     0,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,     0,
       0,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,     0,     0,     0,     0,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,     0,     0,     0,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,  1051,     0,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,     0,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,   351,     0,   352,   353,   354,   355,   356,     0,     0,
     357,   358,     0,   359,     0,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,     0,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,     0,   482,   483,   484,   485,   486,     0,   487,
     488,     0,     0,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,     0,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   219,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,     0,   236,   237,   238,   239,   240,     0,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   715,   249,
     250,   251,   252,     0,   253,   254,   255,   256,   257,     0,
       0,     0,   258,   259,   260,   261,     0,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,     0,     0,     0,     0,     0,     0,     0,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,     0,   317,     0,   318,     0,     0,     0,   319,
     320,   321,     0,   322,   323,     0,   324,   325,     0,   326,
     327,   328,   329,   330,     0,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,   351,     0,   352,   353,   354,   355,   356,     0,
       0,   357,   358,     0,   359,     0,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   718,   378,     0,   379,
     380,   381,   382,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,     0,   398,     0,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   719,   442,   443,   444,
     445,   446,   447,   720,   449,   450,   451,   452,     0,   453,
     454,   455,   456,  1229,     0,   458,   459,   460,   461,   462,
       0,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,     0,   481,     0,   482,   483,   484,   485,   486,     0,
     722,   488,     0,     0,   723,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,     0,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     724,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   219,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   232,   233,     0,
     234,   235,     0,   236,   237,   238,   239,   240,     0,   241,
     242,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   250,   251,   252,     0,   253,   254,   255,   256,   257,
       0,     0,     0,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,     0,     0,     0,     0,     0,     0,     0,
     274,   275,   276,   277,   278,   279,   280,   281,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,     0,   317,     0,   318,     0,     0,     0,
     319,   320,   321,     0,   322,   323,     0,   324,   325,     0,
     326,   327,   328,   329,  1519,     0,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,     0,
     342,   343,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,   351,     0,   352,   353,   354,   355,   356,
       0,     0,   357,   358,     0,   359,     0,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,     0,   463,   464,   465,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,     0,   481,     0,   482,   483,   484,   485,   486,
       0,   487,   488,     0,     0,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,   511,   512,     0,   513,     0,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   219,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,     0,   236,   237,   238,   239,   240,     0,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   254,   255,   256,
     257,     0,     0,     0,   258,   259,   260,   261,     0,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,     0,     0,     0,     0,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,     0,   317,     0,   318,     0,     0,
       0,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,  1549,     0,   331,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,   351,     0,   352,   353,   354,   355,
     356,     0,     0,   357,   358,     0,   359,     0,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,   397,     0,   398,
       0,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,     0,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,     0,   481,     0,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,   511,   512,     0,   513,     0,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   219,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,     0,     0,     0,   232,
     233,     0,   234,   235,     0,   236,   237,   238,   239,   240,
       0,   241,   242,     0,   243,   244,   245,   246,   247,     0,
       0,   248,   249,   250,   251,   252,     0,   253,   254,   255,
     256,   257,     0,     0,     0,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,     0,     0,     0,     0,     0,
       0,     0,   274,   275,   276,   277,   278,   279,   280,   281,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,     0,   317,     0,   318,     0,
       0,     0,   319,   320,   321,     0,   322,   323,     0,   324,
     325,     0,   326,   327,   328,   329,  1551,     0,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,   348,     0,
     349,     0,   350,     0,     0,   351,     0,   352,   353,   354,
     355,   356,     0,     0,   357,   358,     0,   359,     0,     0,
     360,   361,   362,     0,     0,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,     0,   463,   464,   465,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,     0,   481,     0,   482,   483,   484,
     485,   486,     0,   487,   488,     0,     0,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
       0,     0,   501,   502,   503,   504,   505,     0,     0,   506,
     507,   508,   509,   510,   511,   512,     0,   513,     0,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     229,   230,   231,     0,     0,     0,     0,     0,     0,     0,
     232,   233,     0,   234,   235,     0,   236,   237,   238,   239,
     240,     0,   241,   242,     0,   243,   244,   245,   246,   247,
       0,     0,   248,   249,   250,   251,   252,     0,   253,   254,
     255,   256,   257,     0,     0,     0,   258,   259,   260,   261,
       0,   262,   263,   264,     0,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,     0,     0,     0,     0,
       0,     0,     0,   274,   275,   276,   277,   278,   279,   280,
     281,   282,     0,   283,     0,   284,   285,   286,   287,   288,
       0,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,     0,   297,   298,   299,     0,   300,   301,   302,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,     0,   317,     0,   318,
       0,     0,     0,   319,   320,   321,     0,   322,   323,     0,
     324,   325,     0,   326,   327,   328,   329,  1621,     0,   331,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,   351,     0,   352,   353,
     354,   355,   356,     0,     0,   357,   358,     0,   359,     0,
       0,   360,   361,   362,     0,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,   397,
       0,   398,     0,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,     0,   458,
     459,   460,   461,   462,     0,   463,   464,   465,   466,     0,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,     0,   481,     0,   482,   483,
     484,   485,   486,     0,   487,   488,     0,     0,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,     0,     0,   501,   502,   503,   504,   505,     0,     0,
     506,   507,   508,   509,   510,   511,   512,     0,   513,     0,
     514,   515,   516,   517,     0,     0,   518,     0,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,     0,     0,
       0,   232,   233,     0,   234,   235,     0,   236,   237,   238,
     239,   240,     0,   241,   242,     0,   243,   244,   245,   246,
     247,     0,     0,   248,   249,   250,   251,   252,     0,   253,
     254,   255,   256,   257,     0,     0,     0,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,     0,     0,     0,
       0,     0,     0,     0,   274,   275,   276,   277,   278,   279,
     280,   281,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,     0,   317,     0,
     318,     0,     0,     0,   319,   320,   321,     0,   322,   323,
       0,   324,   325,     0,   326,   327,   328,   329,  1623,     0,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,     0,   342,   343,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,   351,     0,   352,
     353,   354,   355,   356,     0,     0,   357,   358,     0,   359,
       0,     0,   360,   361,   362,     0,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,     0,   463,   464,   465,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,     0,   481,     0,   482,
     483,   484,   485,   486,     0,   487,   488,     0,     0,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,     0,     0,   501,   502,   503,   504,   505,     0,
       0,   506,   507,   508,   509,   510,   511,   512,     0,   513,
       0,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   219,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,     0,   236,   237,
     238,   239,   240,     0,   241,   242,     0,   243,   244,   245,
     246,   247,     0,     0,   248,   249,   250,   251,   252,     0,
     253,   254,   255,   256,   257,     0,     0,     0,   258,   259,
     260,   261,     0,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,     0,     0,
       0,     0,     0,     0,     0,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,     0,     0,     0,   319,   320,   321,     0,   322,
     323,     0,   324,   325,     0,   326,   327,   328,   329,  1625,
       0,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,   351,     0,
     352,   353,   354,   355,   356,     0,     0,   357,   358,     0,
     359,     0,     0,   360,   361,   362,     0,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
       0,   458,   459,   460,   461,   462,     0,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,     0,   481,     0,
     482,   483,   484,   485,   486,     0,   487,   488,     0,     0,
     489,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
       0,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,     0,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
       0,     0,     0,   232,   233,     0,   234,   235,     0,   236,
     237,   238,   239,   240,     0,   241,   242,     0,   243,   244,
     245,   246,   247,     0,     0,   248,   249,   250,   251,   252,
       0,   253,   254,   255,   256,   257,     0,     0,     0,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,     0,
       0,     0,     0,     0,     0,     0,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,     0,
     317,     0,   318,     0,     0,     0,   319,   320,   321,     0,
     322,   323,     0,   324,   325,     0,   326,   327,   328,   329,
     330,     0,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,     0,   342,   343,   344,   345,
     346,   347,   348,     0,   349,     0,   350,     0,     0,   351,
       0,   352,   353,   354,   355,   356,     0,     0,   357,   358,
       0,   359,     0,     0,   360,   361,   362,     0,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,  1721,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,     0,   463,   464,
     465,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,     0,   481,
       0,   482,   483,   484,   485,   486,     0,   487,   488,     0,
       0,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,     0,     0,   501,   502,   503,   504,
     505,     0,     0,   506,   507,   508,   509,   510,   511,   512,
       0,   513,     0,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     219,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   229,   230,   231,     0,     0,     0,
       0,     0,  1981,     0,   232,   233,     0,   234,   235,     0,
     236,   237,   238,   239,   240,     0,   241,   242,     0,   243,
     244,   245,   246,   247,     0,     0,   248,   249,   250,   251,
     252,     0,   253,   254,   255,   256,   257,     0,     0,     0,
     258,   259,   260,   261,     0,   262,   263,   264,     0,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
       0,     0,     0,     0,     0,     0,     0,   274,   275,   276,
     277,   278,   279,   280,   281,   282,     0,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
       0,   317,     0,   318,     0,     0,     0,   319,   320,   321,
       0,   322,   323,     0,   324,   325,     0,   326,   327,   328,
     329,   330,     0,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,   348,     0,   349,     0,   350,     0,     0,
     351,     0,   352,   353,   354,   355,   356,     0,     0,   357,
     358,     0,   359,     0,     0,   360,   361,   362,     0,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,     0,   398,     0,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,     0,     0,   459,   460,   461,   462,     0,   463,
     464,   465,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,     0,
     481,     0,   482,   483,   484,   485,   486,     0,   487,   488,
       0,     0,   489,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,     0,     0,   501,   502,   503,
     504,   505,     0,     0,   506,   507,   508,   509,   510,   511,
     512,     0,   513,     0,   514,   515,   516,   517,     0,     0,
     518,     0,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   219,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
       0,   236,   237,   238,   239,   240,     0,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   715,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,     0,
       0,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,     0,     0,     0,     0,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,     0,     0,     0,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,   330,     0,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,     0,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,   351,     0,   352,   353,   354,   355,   356,     0,     0,
     357,   358,     0,   359,     0,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   718,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   719,   442,   443,   444,   445,
     446,   447,   720,   449,   450,   451,   452,     0,   453,   454,
     455,   456,  1229,     0,   458,   459,   460,   461,   462,     0,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,     0,  2013,   483,   484,   485,   486,     0,   722,
     488,     0,     0,   723,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,     0,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   724,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   219,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,     0,   236,   237,   238,   239,   240,     0,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   715,   249,
     250,   251,   252,     0,   253,   254,   255,   256,   257,     0,
       0,     0,   258,   259,   260,   261,     0,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,     0,     0,     0,     0,     0,     0,     0,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,     0,   317,     0,   318,     0,     0,     0,   319,
     320,   321,     0,   322,   323,     0,   324,   325,     0,   326,
     327,   328,   329,   330,     0,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,   351,     0,   352,   353,   354,   355,   356,     0,
       0,   357,   358,     0,   359,     0,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   718,   378,     0,   379,
     380,   381,   382,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,     0,   398,     0,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   719,   442,   443,   444,
     445,   446,   447,  2085,   449,   450,   451,   452,     0,   453,
     454,   455,   456,  2086,     0,   458,   459,   460,   461,   462,
       0,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,     0,   481,     0,   482,   483,   484,   485,   486,     0,
     722,   488,     0,     0,  2087,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,     0,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     724,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   219,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   232,   233,     0,
     234,   235,     0,   236,   237,   238,   239,   240,     0,   241,
     242,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   250,   251,   252,     0,   253,   254,   255,   256,   257,
       0,     0,     0,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,     0,     0,     0,     0,     0,     0,     0,
     274,   275,   276,   277,   278,   279,   280,   281,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,     0,   317,     0,   318,     0,     0,     0,
     319,   320,   321,     0,   322,   323,     0,   324,   325,     0,
     326,   327,   328,   329,  2320,     0,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,     0,
     342,   343,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,   351,     0,   352,   353,   354,   355,   356,
       0,     0,   357,   358,     0,   359,     0,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,     0,   463,   464,   465,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,     0,   481,     0,   482,   483,   484,   485,   486,
       0,   487,   488,     0,     0,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,   511,   512,     0,   513,     0,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   219,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,     0,   236,   237,   238,   239,   240,     0,
     241,   242,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   250,   251,   252,     0,   253,   254,   255,   256,
     257,     0,     0,     0,   258,   259,   260,   261,     0,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,     0,     0,     0,     0,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   280,   281,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   294,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,     0,   317,     0,   318,     0,     0,
       0,   319,   320,   321,     0,   322,   323,     0,   324,   325,
       0,   326,   327,   328,   329,  2324,     0,   331,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,     0,   341,
       0,   342,   343,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,   351,     0,   352,   353,   354,   355,
     356,     0,     0,   357,   358,     0,   359,     0,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,   397,     0,   398,
       0,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,     0,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,     0,   463,   464,   465,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,     0,   481,     0,   482,   483,   484,   485,
     486,     0,   487,   488,     0,     0,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,   511,   512,     0,   513,     0,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   219,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   229,
     230,   231,     0,     0,     0,     0,     0,     0,     0,   232,
     233,     0,   234,   235,     0,   236,   237,   238,   239,   240,
       0,   241,   242,     0,   243,   244,   245,   246,   247,     0,
       0,   248,   249,   250,   251,   252,     0,   253,   254,   255,
     256,   257,     0,     0,     0,   258,   259,   260,   261,     0,
     262,   263,   264,     0,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,     0,     0,     0,     0,     0,
       0,     0,   274,   275,   276,   277,   278,   279,   280,   281,
     282,     0,   283,     0,   284,   285,   286,   287,   288,     0,
     289,   290,   291,     0,     0,   292,   293,   294,   295,   296,
       0,   297,   298,   299,     0,   300,   301,   302,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,     0,   317,     0,   318,     0,
       0,     0,   319,   320,   321,     0,   322,   323,     0,   324,
     325,     0,   326,   327,   328,   329,  2364,     0,   331,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,     0,
     341,     0,   342,   343,   344,   345,   346,   347,   348,     0,
     349,     0,   350,     0,     0,   351,     0,   352,   353,   354,
     355,   356,     0,     0,   357,   358,     0,   359,     0,     0,
     360,   361,   362,     0,     0,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,     0,   453,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,     0,   463,   464,   465,   466,     0,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,   479,   480,     0,   481,     0,   482,   483,   484,
     485,   486,     0,   487,   488,     0,     0,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
       0,     0,   501,   502,   503,   504,   505,     0,     0,   506,
     507,   508,   509,   510,   511,   512,     0,   513,     0,   514,
     515,   516,   517,     0,     0,   518,     0,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     229,   230,   231,     0,     0,     0,     0,     0,     0,     0,
     232,   233,     0,   234,   235,     0,   236,   237,   238,   239,
     240,     0,   241,   242,     0,   243,   244,   245,   246,   247,
       0,     0,   248,   249,   250,   251,   252,     0,   253,   254,
     255,   256,   257,     0,     0,     0,   258,   259,   260,   261,
       0,   262,   263,   264,     0,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,     0,     0,     0,     0,
       0,     0,     0,   274,   275,   276,   277,   278,   279,   280,
     281,   282,     0,   283,     0,   284,   285,   286,   287,   288,
       0,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,     0,   297,   298,   299,     0,   300,   301,   302,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,     0,   317,     0,   318,
       0,     0,     0,   319,   320,   321,     0,   322,   323,     0,
     324,   325,     0,   326,   327,   328,   329,  2399,     0,   331,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
       0,   341,     0,   342,   343,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,   351,     0,   352,   353,
     354,   355,   356,     0,     0,   357,   358,     0,   359,     0,
       0,   360,   361,   362,     0,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,   397,
       0,   398,     0,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,     0,   458,
     459,   460,   461,   462,     0,   463,   464,   465,   466,     0,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,     0,   481,     0,   482,   483,
     484,   485,   486,     0,   487,   488,     0,     0,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,     0,     0,   501,   502,   503,   504,   505,     0,     0,
     506,   507,   508,   509,   510,   511,   512,     0,   513,     0,
     514,   515,   516,   517,     0,     0,   518,     0,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,     0,     0,
       0,   232,   233,     0,   234,   235,     0,   236,   237,   238,
     239,   240,     0,   241,   242,     0,   243,   244,   245,   246,
     247,     0,     0,   248,   249,   250,   251,   252,     0,   253,
     254,   255,   256,   257,     0,     0,     0,   258,   259,   260,
     261,     0,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,     0,     0,     0,
       0,     0,     0,     0,   274,   275,   276,   277,   278,   279,
     280,   281,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   294,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,     0,   317,     0,
     318,     0,     0,     0,   319,   320,   321,     0,   322,   323,
       0,   324,   325,     0,   326,   327,   328,   329,  2722,     0,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,     0,   342,   343,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,   351,     0,   352,
     353,   354,   355,   356,     0,     0,   357,   358,     0,   359,
       0,     0,   360,   361,   362,     0,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,     0,   463,   464,   465,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,     0,   479,   480,     0,   481,     0,   482,
     483,   484,   485,   486,     0,   487,   488,     0,     0,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,     0,     0,   501,   502,   503,   504,   505,     0,
       0,   506,   507,   508,   509,   510,   511,   512,     0,   513,
       0,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   219,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,     0,   236,   237,
     238,   239,   240,     0,   241,   242,     0,   243,   244,   245,
     246,   247,     0,     0,   715,   249,   250,   251,   252,     0,
     253,   254,   255,   256,   257,     0,     0,     0,   258,   259,
     260,   261,     0,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,     0,     0,
       0,     0,     0,     0,     0,   274,   275,   276,   277,   278,
     279,   280,   281,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     294,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,     0,   317,
       0,   318,     0,     0,     0,   319,   320,   321,     0,   322,
     323,     0,   324,   325,     0,   326,   327,   328,   329,   330,
       0,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,     0,   342,   343,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,   351,     0,
     352,   353,   354,   355,   356,     0,     0,   357,   358,     0,
     359,     0,     0,   360,   361,   362,     0,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   718,   378,     0,   379,   380,   381,   382,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,     0,   719,   442,   443,   444,   445,   446,   447,   720,
     449,   450,   451,   452,     0,   453,   454,   455,   456,  2086,
       0,   458,   459,   460,   461,   462,     0,   463,   464,   465,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,     0,   481,     0,
     482,   483,   484,   485,   486,     0,   722,   488,     0,     0,
    2087,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
       0,     0,   506,   507,   508,   509,   510,   511,   512,     0,
     513,     0,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   724,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
       0,     0,     0,   232,   233,     0,   234,   235,     0,   236,
     237,   238,   239,   240,     0,   241,   242,     0,   243,   244,
     245,   246,   247,     0,     0,   248,   249,   250,   251,   252,
       0,   253,   254,   255,   256,   257,     0,     0,     0,   258,
     259,   260,   261,     0,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,     0,
       0,     0,     0,     0,     0,     0,   274,   275,   276,   277,
     278,   279,   280,   281,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   294,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,     0,
     317,     0,   318,     0,     0,     0,   319,   320,   321,     0,
     322,   323,     0,   324,   325,     0,   326,   327,   328,   329,
    2797,     0,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,     0,   342,   343,   344,   345,
     346,   347,   348,     0,   349,     0,   350,     0,     0,   351,
       0,   352,   353,   354,   355,   356,     0,     0,   357,   358,
       0,   359,     0,     0,   360,   361,   362,     0,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,     0,   463,   464,
     465,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,     0,   481,
       0,   482,   483,   484,   485,   486,     0,   487,   488,     0,
       0,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,     0,     0,   501,   502,   503,   504,
     505,     0,     0,   506,   507,   508,   509,   510,   511,   512,
       0,   513,     0,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     219,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   229,   230,   231,     0,     0,     0,
       0,     0,     0,     0,   232,   233,     0,   234,   235,     0,
     236,   237,   238,   239,   240,     0,   241,   242,     0,   243,
     244,   245,   246,   247,     0,     0,   248,   249,   250,   251,
     252,     0,   253,   254,   255,   256,   257,     0,     0,     0,
     258,   259,   260,   261,     0,   262,   263,   264,     0,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
       0,     0,     0,     0,     0,     0,     0,   274,   275,   276,
     277,   278,   279,   280,   281,   282,     0,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   294,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
       0,   317,     0,   318,     0,     0,     0,   319,   320,   321,
       0,   322,   323,     0,   324,   325,     0,   326,   327,   328,
     329,  2799,     0,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,     0,   342,   343,   344,
     345,   346,   347,   348,     0,   349,     0,   350,     0,     0,
     351,     0,   352,   353,   354,   355,   356,     0,     0,   357,
     358,     0,   359,     0,     0,   360,   361,   362,     0,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,     0,   398,     0,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,     0,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,     0,   458,   459,   460,   461,   462,     0,   463,
     464,   465,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,     0,
     481,     0,   482,   483,   484,   485,   486,     0,   487,   488,
       0,     0,   489,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,     0,     0,   501,   502,   503,
     504,   505,     0,     0,   506,   507,   508,   509,   510,   511,
     512,     0,   513,     0,   514,   515,   516,   517,     0,     0,
     518,     0,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   219,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
       0,   236,   237,   238,   239,   240,     0,   241,   242,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   250,
     251,   252,     0,   253,   254,   255,   256,   257,     0,     0,
       0,   258,   259,   260,   261,     0,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,     0,     0,     0,     0,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   280,   281,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   294,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,     0,   317,     0,   318,     0,     0,     0,   319,   320,
     321,     0,   322,   323,     0,   324,   325,     0,   326,   327,
     328,   329,  2909,     0,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,     0,   342,   343,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,   351,     0,   352,   353,   354,   355,   356,     0,     0,
     357,   358,     0,   359,     0,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,     0,
     463,   464,   465,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,   479,   480,
       0,   481,     0,   482,   483,   484,   485,   486,     0,   487,
     488,     0,     0,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
     511,   512,     0,   513,     0,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   219,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,     0,   236,   237,   238,   239,   240,     0,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   248,   249,
     250,   251,   252,     0,   253,   254,   255,   256,   257,     0,
       0,     0,   258,   259,   260,   261,     0,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,     0,     0,     0,     0,     0,     0,     0,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,  2931,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,     0,   317,     0,   318,     0,     0,     0,   319,
     320,   321,     0,   322,   323,     0,   324,   325,     0,   326,
     327,   328,   329,   330,     0,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,   351,     0,   352,   353,   354,   355,   356,     0,
       0,   357,   358,     0,   359,     0,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,     0,   398,     0,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,     0,   458,   459,   460,   461,   462,
       0,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,     0,   481,     0,   482,   483,   484,   485,   486,     0,
     487,   488,     0,     0,   489,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,     0,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   219,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   232,   233,     0,
     234,   235,     0,   236,   237,   238,   239,   240,     0,   241,
     242,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   250,   251,   252,     0,   253,   254,   255,   256,   257,
       0,     0,     0,   258,   259,   260,   261,     0,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,     0,     0,     0,     0,     0,     0,     0,
     274,   275,   276,   277,   278,   279,   280,   281,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   294,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,     0,   317,     0,   318,     0,     0,     0,
     319,   320,   321,     0,   322,   323,     0,   324,   325,     0,
     326,   327,   328,   329,  4031,     0,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,     0,
     342,   343,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,   351,     0,   352,   353,   354,   355,   356,
       0,     0,   357,   358,     0,   359,     0,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,     0,   463,   464,   465,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,     0,
     479,   480,     0,   481,     0,   482,   483,   484,   485,   486,
       0,   487,   488,     0,     0,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,   511,   512,     0,   513,     0,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   977,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,   232,   233,
       0,   234,   235,   772,   236,   237,   238,     0,   978,   773,
     979,   980,     0,   243,   244,   245,   246,   247,     0,     0,
     248,   249,   981,   982,   252,     0,   253,   254,   255,   256,
       0,     0,   774,     0,   258,   259,   260,   261,   775,   262,
     263,   264,     0,   265,   266,   267,   268,   269,   270,     0,
     776,   271,   272,   273,     0,     0,     0,   777,     0,     0,
       0,   274,   275,   276,   277,   278,   279,   983,   984,   282,
       0,   283,     0,   284,   285,   286,   287,   288,     0,   289,
     290,   291,     0,     0,   292,   293,   985,   295,   296,     0,
     297,   298,   299,     0,   300,   301,   302,     0,   303,   304,
     305,   306,     0,   308,   309,   310,     0,     0,   312,     0,
     313,   314,   986,   316,     0,   317,     0,   318,   778,     0,
     779,   319,   320,   321,     0,   322,     0,     0,     0,   325,
       0,   326,   327,   328,   329,   330,   780,   331,   332,   333,
     334,  1984,   335,   336,   337,   338,   339,   340,     0,   341,
     781,  1985,   343,   344,   345,   346,   988,   989,     0,   990,
       0,   350,   782,   783,   351,   784,   352,   353,   354,   355,
     356,     0,     0,   357,     0,   785,   359,   786,     0,   360,
     361,   362,     0,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   991,
     787,   992,   380,   381,     0,     0,   383,   384,   788,   385,
       0,     0,   387,   993,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,  1987,   789,   398,
     790,     0,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   410,     0,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   994,   424,   425,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   791,   441,   442,
     443,     0,   445,   446,   447,   448,   449,   450,   451,   452,
       0,   453,   454,   455,   456,   457,     0,   458,   459,  1988,
     461,   462,   792,   463,   464,   996,   466,     0,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     0,
       0,   479,   480,     0,   481,   793,   482,   483,   484,   485,
     486,     0,   997,   998,     0,     0,   489,   490,     0,   492,
       0,     0,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   501,   502,   503,   504,   505,     0,     0,   506,   507,
     508,   509,   510,     0,   999,  1989,   513,   794,   514,   515,
     516,   517,     0,     0,   518,     0,     0,   519,   520,   521,
     522,   523,   524,   977,     0,     0,     0,     0,     0,     0,
       0,     0,   534,   535,   536,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   232,   233,     0,
     234,   235,   772,   236,   237,   238,     0,   978,   773,   979,
     980,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   981,   982,   252,     0,   253,   254,   255,   256,     0,
       0,   774,     0,   258,   259,   260,   261,   775,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,   776,
     271,   272,   273,     0,     0,     0,   777,     0,     0,     0,
     274,   275,   276,   277,   278,   279,   983,   984,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   985,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,     0,   308,   309,   310,     0,     0,   312,     0,   313,
     314,   986,   316,     0,   317,     0,   318,   778,     0,   779,
     319,   320,   321,     0,   322,     0,     0,     0,   325,     0,
     326,   327,   328,   329,   330,   780,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,   781,
       0,   343,   344,   345,   346,   988,   989,     0,   990,     0,
     350,   782,   783,   351,   784,   352,   353,   354,   355,   356,
       0,     0,   357,     0,   785,   359,   786,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   991,   787,
     992,   380,   381,     0,     0,   383,   384,   788,   385,  2081,
       0,   387,   993,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,     0,   789,   398,   790,
       0,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   410,     0,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   994,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   791,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,     0,   458,   459,  1988,   461,
     462,   792,   463,   464,   996,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     0,     0,
     479,   480,  3610,   481,   793,   482,   483,   484,   485,   486,
       0,   997,   998,     0,     0,   489,   490,     0,   492,     0,
       0,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,     0,   999,     0,   513,   794,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   219,     0,     0,     0,     0,     0,     0,     0,
       0,   534,   535,   536,     0,     0,     0,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,     0,   236,   237,   238,   239,   240,     0,   241,   242,
       0,   243,   244,   245,   246,   247,     0,     0,   248,   249,
     250,   251,   252,     0,   253,   254,   255,   256,   257,     0,
       0,     0,   258,   259,   260,   261,     0,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,     0,     0,     0,     0,     0,     0,     0,   274,
     275,   276,   277,   278,   279,   280,   281,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   294,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,     0,   317,     0,   318,     0,     0,     0,   319,
     320,   321,     0,   322,   323,     0,   324,   325,     0,   326,
     327,   328,   329,   330,     0,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,     0,   342,
     343,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,   351,     0,   352,   353,   354,   355,   356,     0,
       0,   357,   358,     0,   359,     0,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,     0,   398,     0,   399,
     400,   401,   402,   403,     0,   405,   406,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,     0,   422,   423,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,     0,   441,   442,   443,   444,
       0,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,     0,   458,   459,   460,   461,   462,
       0,   463,   464,   465,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,     0,   481,     0,   482,   483,   484,   485,   486,     0,
     487,   488,     0,     0,   489,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,   511,   512,     0,   513,     0,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   977,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,   232,   233,     0,
     234,   235,   772,   236,   237,   238,     0,   978,   773,   979,
     980,     0,   243,   244,   245,   246,   247,     0,     0,   248,
     249,   981,   982,   252,     0,   253,   254,   255,   256,     0,
       0,   774,     0,   258,   259,   260,   261,   775,   262,   263,
     264,     0,   265,   266,   267,   268,   269,   270,     0,   776,
     271,   272,   273,     0,     0,     0,   777,     0,     0,     0,
     274,   275,   276,   277,   278,   279,   983,   984,   282,     0,
     283,     0,   284,   285,   286,   287,   288,     0,   289,   290,
     291,     0,     0,   292,   293,   985,   295,   296,     0,   297,
     298,   299,     0,   300,   301,   302,     0,   303,   304,   305,
     306,     0,   308,   309,   310,     0,     0,   312,     0,   313,
     314,   986,   316,     0,   317,     0,   318,   778,     0,   779,
     319,   320,   321,     0,   322,     0,     0,     0,   325,     0,
     326,   327,   328,   329,   330,   780,   331,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,     0,   341,   781,
       0,   343,   344,   345,   346,   988,   989,     0,   990,     0,
     350,   782,   783,   351,   784,   352,   353,   354,   355,   356,
       0,     0,   357,     0,   785,   359,   786,     0,   360,   361,
     362,     0,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   991,   787,
     992,   380,   381,  2146,     0,   383,   384,   788,   385,     0,
       0,   387,   993,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,     0,   789,   398,   790,
       0,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   410,     0,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   994,   424,   425,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   791,   441,   442,   443,
       0,   445,   446,   447,   448,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,     0,   458,   459,   995,   461,
     462,   792,   463,   464,   996,   466,     0,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     0,     0,
     479,   480,     0,   481,   793,   482,   483,   484,   485,   486,
       0,   997,   998,     0,     0,   489,   490,     0,   492,     0,
       0,   494,   495,   496,   497,   498,   499,   500,     0,     0,
     501,   502,   503,   504,   505,     0,     0,   506,   507,   508,
     509,   510,     0,   999,     0,   513,   794,   514,   515,   516,
     517,     0,     0,   518,     0,     0,   519,   520,   521,   522,
     523,   524,   977,     0,     0,     0,     0,     0,     0,     0,
       0,   534,   535,   536,     0,     0,     0,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   233,     0,   234,
     235,   772,   236,   237,   238,     0,   978,   773,   979,   980,
       0,   243,   244,   245,   246,   247,     0,     0,   248,   249,
     981,   982,   252,     0,   253,   254,   255,   256,     0,     0,
     774,     0,   258,   259,   260,   261,   775,   262,   263,   264,
       0,   265,   266,   267,   268,   269,   270,     0,   776,   271,
     272,   273,     0,     0,     0,   777,     0,     0,     0,   274,
     275,   276,   277,   278,   279,   983,   984,   282,     0,   283,
       0,   284,   285,   286,   287,   288,     0,   289,   290,   291,
       0,     0,   292,   293,   985,   295,   296,     0,   297,   298,
     299,     0,   300,   301,   302,     0,   303,   304,   305,   306,
       0,   308,   309,   310,     0,     0,   312,     0,   313,   314,
     986,   316,     0,   317,     0,   318,   778,     0,   779,   319,
     320,   321,     0,   322,     0,     0,     0,   325,     0,   326,
     327,   328,   329,   330,   780,   331,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,     0,   341,   781,     0,
     343,   344,   345,   346,   988,   989,     0,   990,     0,   350,
     782,   783,   351,   784,   352,   353,   354,   355,   356,     0,
       0,   357,     0,   785,   359,   786,     0,   360,   361,   362,
       0,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   991,   787,   992,
     380,   381,  3436,     0,   383,   384,   788,   385,     0,     0,
     387,   993,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,     0,   789,   398,   790,     0,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   410,     0,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   994,   424,   425,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   791,   441,   442,   443,     0,
     445,   446,   447,   448,   449,   450,   451,   452,     0,   453,
     454,   455,   456,   457,     0,   458,   459,   995,   461,   462,
     792,   463,   464,   996,   466,     0,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     0,     0,   479,
     480,     0,   481,   793,   482,   483,   484,   485,   486,     0,
     997,   998,     0,     0,   489,   490,     0,   492,     0,     0,
     494,   495,   496,   497,   498,   499,   500,     0,     0,   501,
     502,   503,   504,   505,     0,     0,   506,   507,   508,   509,
     510,     0,   999,     0,   513,   794,   514,   515,   516,   517,
       0,     0,   518,     0,     0,   519,   520,   521,   522,   523,
     524,   977,     0,     0,     0,     0,     0,     0,     0,     0,
     534,   535,   536,     0,     0,     0,   220,   221,   222,   223,
     224,   225,   226,   227,     0,   229,   230,   231,     0,     0,
       0,     0,     0,     0,     0,   232,   233,     0,   234,   235,
     772,   236,   237,   238,     0,   978,   773,   979,   980,     0,
     243,   244,   245,   246,   247,     0,     0,   248,   249,   981,
     982,   252,     0,   253,   254,   255,   256,     0,     0,   774,
       0,   258,   259,   260,   261,   775,   262,   263,   264,     0,
     265,   266,   267,   268,   269,   270,     0,   776,   271,   272,
     273,     0,     0,     0,   777,     0,     0,     0,   274,   275,
     276,   277,   278,   279,   983,   984,   282,     0,   283,     0,
     284,   285,   286,   287,   288,     0,   289,   290,   291,     0,
       0,   292,   293,   985,   295,   296,     0,   297,   298,   299,
       0,   300,   301,   302,     0,   303,   304,   305,   306,     0,
     308,   309,   310,     0,     0,   312,     0,   313,   314,   986,
     316,     0,   317,     0,   318,   778,     0,   779,   319,   320,
     321,     0,   322,     0,     0,     0,   325,     0,   326,   327,
     328,   329,   987,   780,   331,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,     0,   341,   781,     0,   343,
     344,   345,   346,   988,   989,     0,   990,     0,   350,   782,
     783,   351,   784,   352,   353,   354,   355,   356,     0,     0,
     357,     0,   785,   359,   786,     0,   360,   361,   362,     0,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   991,   787,   992,   380,
     381,     0,     0,   383,   384,   788,   385,     0,     0,   387,
     993,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,     0,   789,   398,   790,     0,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,     0,
     410,     0,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   994,   424,   425,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   791,   441,   442,   443,     0,   445,
     446,   447,   448,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,     0,   458,   459,   995,   461,   462,   792,
     463,   464,   996,   466,     0,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     0,     0,   479,   480,
       0,   481,   793,   482,   483,   484,   485,   486,     0,   997,
     998,     0,     0,   489,   490,     0,   492,     0,     0,   494,
     495,   496,   497,   498,   499,   500,     0,     0,   501,   502,
     503,   504,   505,     0,     0,   506,   507,   508,   509,   510,
       0,   999,     0,   513,   794,   514,   515,   516,   517,     0,
       0,   518,     0,     0,   519,   520,   521,   522,   523,   524,
     977,     0,     0,     0,     0,     0,     0,     0,     0,   534,
     535,   536,     0,     0,     0,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   229,   230,   231,     0,     0,     0,
       0,     0,     0,     0,   232,   233,     0,   234,   235,   772,
     236,   237,   238,     0,   978,   773,   979,   980,     0,   243,
     244,   245,   246,   247,     0,     0,   248,   249,   981,   982,
     252,     0,   253,   254,   255,   256,     0,     0,   774,     0,
     258,   259,   260,   261,   775,   262,   263,   264,     0,   265,
     266,   267,   268,   269,   270,     0,   776,   271,   272,   273,
       0,     0,     0,   777,     0,     0,     0,   274,   275,   276,
     277,   278,   279,   983,   984,   282,     0,   283,     0,   284,
     285,   286,   287,   288,     0,   289,   290,   291,     0,     0,
     292,   293,   985,   295,   296,     0,   297,   298,   299,     0,
     300,   301,   302,     0,   303,   304,   305,   306,     0,   308,
     309,   310,     0,     0,   312,     0,   313,   314,   986,   316,
       0,   317,     0,   318,   778,     0,   779,   319,   320,   321,
       0,   322,     0,     0,     0,   325,     0,   326,   327,   328,
     329,  1045,   780,   331,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,     0,   341,   781,     0,   343,   344,
     345,   346,   988,   989,     0,   990,     0,   350,   782,   783,
     351,   784,   352,   353,   354,   355,   356,     0,     0,   357,
       0,   785,   359,   786,     0,   360,   361,   362,     0,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   991,   787,   992,   380,   381,
       0,     0,   383,   384,   788,   385,     0,     0,   387,   993,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,     0,   789,   398,   790,     0,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   410,
       0,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   994,   424,   425,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   791,   441,   442,   443,     0,   445,   446,
     447,   448,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,     0,   458,   459,   995,   461,   462,   792,   463,
     464,   996,   466,     0,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,     0,     0,   479,   480,     0,
     481,   793,   482,   483,   484,   485,   486,     0,   997,   998,
       0,     0,   489,   490,     0,   492,     0,     0,   494,   495,
     496,   497,   498,   499,   500,     0,     0,   501,   502,   503,
     504,   505,     0,     0,   506,   507,   508,   509,   510,     0,
     999,     0,   513,   794,   514,   515,   516,   517,     0,     0,
     518,     0,     0,   519,   520,   521,   522,   523,   524,   977,
       0,     0,     0,     0,     0,     0,     0,     0,   534,   535,
     536,     0,     0,     0,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   229,   230,   231,     0,     0,     0,     0,
       0,     0,     0,   232,   233,     0,   234,   235,   772,   236,
     237,   238,     0,   978,   773,   979,   980,     0,   243,   244,
     245,   246,   247,     0,     0,   248,   249,   981,   982,   252,
       0,   253,   254,   255,   256,     0,     0,   774,     0,   258,
     259,   260,   261,   775,   262,   263,   264,     0,   265,   266,
     267,   268,   269,   270,     0,   776,   271,   272,   273,     0,
       0,     0,   777,     0,     0,     0,   274,   275,   276,   277,
     278,   279,   983,   984,   282,     0,   283,     0,   284,   285,
     286,   287,   288,     0,   289,   290,   291,     0,     0,   292,
     293,   985,   295,   296,     0,   297,   298,   299,     0,   300,
     301,   302,     0,   303,   304,   305,   306,     0,   308,   309,
     310,     0,     0,   312,     0,   313,   314,   986,   316,     0,
     317,     0,   318,   778,     0,   779,   319,   320,   321,     0,
     322,     0,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   780,   331,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,     0,   341,   781,     0,   343,   344,   345,
     346,   988,   989,     0,   990,     0,   350,   782,   783,   351,
     784,   352,   353,   354,   355,   356,     0,     0,   357,     0,
     785,   359,   786,     0,   360,   361,   362,     0,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   991,   787,   992,   380,   381,     0,
       0,   383,   384,   788,   385,     0,     0,   387,   993,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,     0,   789,   398,   790,     0,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,     0,   410,     0,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   994,   424,   425,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   791,   441,   442,   443,     0,   445,   446,   447,
     448,   449,   450,   451,   452,     0,   453,   454,   455,   456,
     457,     0,   458,   459,   995,   461,   462,   792,   463,   464,
     996,   466,     0,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,     0,     0,   479,   480,     0,   481,
     793,   482,   483,   484,   485,   486,     0,   997,   998,     0,
       0,   489,   490,     0,   492,     0,     0,   494,   495,   496,
     497,   498,   499,   500,     0,     0,   501,   502,   503,   504,
     505,     0,     0,   506,   507,   508,   509,   510,     0,   999,
       0,   513,   794,   514,   515,   516,   517,     0,     0,   518,
       0,     0,   519,   520,   521,   522,   523,   524,   977,     0,
       0,     0,     0,     0,     0,     0,     0,   534,   535,   536,
       0,     0,     0,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   229,   230,   231,     0,     0,     0,     0,     0,
       0,     0,   232,   233,     0,   234,   235,   772,   236,   237,
     238,     0,   978,   773,   979,   980,     0,   243,   244,   245,
     246,   247,     0,     0,   248,   249,   981,   982,   252,     0,
     253,   254,   255,   256,     0,     0,   774,     0,   258,   259,
     260,   261,   775,   262,   263,   264,     0,   265,   266,   267,
     268,   269,   270,     0,   776,   271,   272,   273,     0,     0,
       0,   777,     0,     0,     0,   274,   275,   276,   277,   278,
     279,   983,   984,   282,     0,   283,     0,   284,   285,   286,
     287,   288,     0,   289,   290,   291,     0,     0,   292,   293,
     985,   295,   296,     0,   297,   298,   299,     0,   300,   301,
     302,     0,   303,   304,   305,   306,     0,   308,   309,   310,
       0,     0,   312,     0,   313,   314,   986,   316,     0,   317,
       0,   318,   778,     0,   779,   319,   320,   321,     0,   322,
       0,     0,     0,   325,     0,   326,   327,   328,   329,   330,
     780,   331,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,     0,   341,   781,     0,   343,   344,   345,   346,
     988,   989,     0,   990,     0,   350,   782,   783,   351,   784,
     352,   353,   354,   355,   356,     0,     0,   357,     0,   785,
     359,   786,     0,   360,   361,   362,     0,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   991,   787,   992,   380,   381,     0,     0,
     383,   384,   788,   385,     0,     0,   387,   993,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,     0,   789,   398,   790,     0,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   410,     0,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   994,   424,   425,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   791,   441,   442,   443,     0,   445,   446,   447,   448,
     449,   450,   451,   452,     0,   453,   454,   455,   456,   457,
       0,   458,   459,  1988,   461,   462,   792,   463,   464,   996,
     466,     0,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     0,     0,   479,   480,     0,   481,   793,
     482,   483,   484,   485,   486,     0,   997,   998,     0,     0,
     489,   490,     0,   492,     0,     0,   494,   495,   496,   497,
     498,   499,   500,     0,     0,   501,   502,   503,   504,   505,
       0,     0,   506,   507,   508,   509,   510,     0,   999,     0,
     513,   794,   514,   515,   516,   517,     0,     0,   518,     0,
       0,   519,   520,   521,   522,   523,   524,   977,     0,     0,
       0,     0,     0,     0,     0,     0,   534,   535,   536,     0,
       0,     0,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   229,   230,   231,     0,     0,     0,     0,     0,     0,
       0,   232,   233,     0,   234,   235,   772,   236,   237,   238,
       0,   978,   773,   979,   980,     0,   243,   244,   245,   246,
     247,     0,     0,   248,   249,   981,   982,   252,     0,   253,
     254,   255,   256,     0,     0,   774,     0,   258,   259,   260,
     261,   775,   262,   263,   264,     0,   265,   266,   267,   268,
     269,   270,     0,   776,   271,   272,   273,     0,     0,     0,
     777,     0,     0,     0,   274,   275,   276,   277,   278,   279,
     983,   984,   282,     0,   283,     0,   284,   285,   286,   287,
     288,     0,   289,   290,   291,     0,     0,   292,   293,   985,
     295,   296,     0,   297,   298,   299,     0,   300,   301,   302,
       0,   303,   304,   305,   306,     0,   308,   309,   310,     0,
       0,   312,     0,   313,   314,   986,   316,     0,   317,     0,
     318,   778,     0,   779,   319,   320,   321,     0,   322,     0,
       0,     0,   325,     0,   326,   327,   328,   329,   330,   780,
     331,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,     0,   341,   781,     0,   343,   344,   345,   346,   988,
     989,     0,   990,     0,   350,   782,   783,   351,   784,   352,
     353,   354,   355,   356,     0,     0,   357,     0,   785,   359,
     786,     0,   360,   361,   362,     0,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   991,   787,   992,   380,   381,     0,     0,   383,
     384,   788,   385,     0,     0,   387,   993,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
       0,   789,   398,   790,     0,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,     0,   410,     0,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     994,   424,   425,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     791,   441,   442,   443,     0,   445,   446,   447,   448,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,     0,
     458,   459,     0,   461,   462,   792,   463,   464,   996,   466,
       0,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     0,     0,   479,   480,     0,   481,   793,   482,
     483,   484,   485,   486,     0,   997,   998,     0,     0,   489,
     490,     0,   492,     0,     0,   494,   495,   496,   497,   498,
     499,   500,     0,     0,   501,   502,   503,   504,   505,     0,
       0,   506,   507,   508,   509,   510,     0,   999,     0,   513,
     794,   514,   515,   516,   517,     0,     0,   518,     0,     0,
     519,   520,   521,   522,   523,   524,   977,     0,     0,     0,
       0,     0,     0,     0,     0,   534,   535,   536,     0,     0,
       0,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     229,   230,   231,     0,     0,     0,     0,     0,     0,     0,
     232,   233,     0,   234,   235,   772,   236,   237,   238,     0,
       0,   773,     0,     0,     0,   243,   244,   245,   246,   247,
       0,     0,   248,   249,     0,     0,   252,     0,   253,   254,
     255,   256,     0,     0,   774,     0,   258,   259,   260,   261,
     775,   262,   263,   264,     0,   265,   266,   267,   268,   269,
     270,     0,   776,   271,   272,   273,     0,     0,     0,   777,
       0,     0,     0,   274,   275,   276,   277,   278,   279,     0,
       0,   282,     0,   283,     0,   284,   285,   286,   287,   288,
       0,   289,   290,   291,     0,     0,   292,   293,   294,   295,
     296,     0,   297,   298,   299,     0,   300,   301,   302,     0,
     303,   304,   305,   306,     0,   308,   309,   310,     0,     0,
     312,     0,   313,   314,     0,   316,     0,   317,     0,   318,
     778,     0,   779,   319,   320,   321,     0,   322,     0,     0,
       0,   325,     0,   326,   327,   328,   329,   330,   780,   331,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
       0,   341,   781,     0,   343,   344,   345,   346,     0,     0,
       0,     0,     0,   350,   782,   783,   351,   784,   352,   353,
     354,   355,   356,     0,     0,   357,     0,   785,   359,   786,
       0,   360,   361,   362,     0,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   787,     0,   380,   381,     0,     0,   383,   384,
     788,   385,     0,     0,   387,     0,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,     0,
     789,   398,   790,     0,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   410,     0,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,     0,
     424,   425,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   791,
     441,   442,   443,     0,   445,   446,   447,   448,   449,   450,
     451,   452,     0,   453,   454,   455,   456,   457,     0,   458,
     459,     0,   461,   462,   792,   463,   464,     0,   466,     0,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     0,     0,   479,   480,     0,   481,   793,   482,   483,
     484,   485,   486,     0,     0,     0,     0,     0,   489,   490,
       0,   492,     0,     0,   494,   495,   496,   497,   498,   499,
     500,     0,     0,   501,   502,   503,   504,   505,     0,     0,
     506,   507,   508,   509,   510,     0,     0,     0,   513,   794,
     514,   515,   516,   517,     0,     0,   518,     0,     0,   519,
     520,   521,   522,   523,   524,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   534,   535,   536
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-4409)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2390)))

static const yytype_int16 yycheck[] =
{
      16,     0,     0,     0,     0,     0,     0,   594,   201,    25,
      35,    50,    21,    11,  1020,   716,  1062,   187,    27,  1029,
    1272,     7,    20,  1691,    20,   770,   196,  1024,    14,   714,
     564,   765,   869,   666,   667,   668,   179,   796,  1330,   672,
      44,  1812,   594,   995,   857,   937,  1254,   634,  2270,   878,
     739,    21,    50,  1256,   827,  2459,   948,    27,  1014,  1992,
    1993,  1365,   917,    12,  1476,  1084,  1115,  2971,  1054,  1287,
    1385,    43,   723,  1546,   998,  2622,  2279,  3040,   612,  1371,
     983,   984,    17,  1428,    20,   922,  1375,   555,  2789,   926,
     993,  3016,  1727,   204,   931,  2765,  2145,    22,  3339,  1939,
    1308,  1304,  1277,   940,   215,  2197,   615,  2811,     0,  2813,
      35,  3233,  3296,   950,  3339,   856,   971,   626,  3599,  2961,
    2431,  3389,  2954,  3335,  2614,   633,  2998,  3535,   856,  2961,
    1445,  1446,   719,  2671,   862,   603,  2612,  2613,   625,   181,
    3588,  3611,  3602,   871,   181,  3589,  1558,  1771,   166,  3267,
    1815,  1440,  2545,     0,  3261,  3027,  1371,    34,  1357,  4051,
    2235,    49,     0,  2679,    41,  1308,     0,   719,  2243,    40,
    2245,  3852,   813,     0,  3014,  1648,  4171,   762,  4173,   869,
     981,   982,   762,   181,     5,     0,     0,     0,     0,     0,
       0,   992,     0,     0,    11,  4228,  4209,  3312,     0,     5,
    3196,  4352,    55,  3266,    35,     5,  1192,    13,    14,    29,
      62,     0,    48,    55,     0,     0,     9,     0,  4266,  4267,
       9,  1992,   153,    40,  2273,    22,     5,     5,     5,  4262,
     111,    55,    41,    55,    13,    14,    41,    26,   210,   158,
     158,  1144,  1145,    76,    72,   197,    26,    72,    39,  1173,
       5,     5,   204,    70,   109,     5,    22,    26,    13,    14,
    1163,   158,    62,   215,  1000,  2515,  2516,   128,   180,    53,
    2520,    39,     5,  4539,    55,     5,   133,   168,   158,   102,
       5,   168,   915,    26,  2677,     0,     5,     5,   109,  1062,
      33,     5,     5,   111,     9,     5,   168,     5,    72,    11,
     164,  1509,  1038,    29,  4301,    72,   102,  2557,  2558,   158,
    1046,    26,    62,   153,  2610,  2767,  1052,   101,     5,   258,
     264,  2610,   203,   289,  2373,    27,  2375,    84,    68,   126,
     259,   166,  1133,  1134,     5,    26,     4,   158,   114,     9,
      26,     9,    26,     9,   336,   114,     3,     4,     5,    33,
     126,   242,     9,   320,   114,   242,   158,    26,  1159,    81,
     126,   109,   248,   244,   898,   286,    70,  2663,   140,   158,
     264,   564,   158,   158,  2663,   158,    30,    31,   180,  4787,
     550,   272,   337,     4,   412,   299,   336,   109,     9,   159,
    2058,   180,   373,   396,   180,   180,    11,   180,   182,  3677,
    3168,  3679,    11,   417,   451,    74,     4,   454,   317,    72,
      26,     9,  1241,    82,   295,   306,   139,    33,    81,   612,
    4686,   406,   436,  4418,   193,    40,   454,   394,   598,  3197,
     121,    40,   326,   193,  1193,   121,  1688,   294,   608,  4472,
    1692,   110,  1694,   158,    11,  1697,   230,   450,   232,  3857,
    4342,   562,   109,   158,   375,    70,   567,   343,   242,   312,
     452,    70,  1221,  1050,    11,   180,  1239,   578,   308,    72,
     312,  1244,  1245,   454,    81,  1062,    72,  4885,    81,   158,
    1486,  1491,   317,   102,   450,    81,   395,   271,   312,   309,
     312,   420,   194,   373,   408,   450,   244,   418,  1050,   279,
     320,   114,   322,   157,   454,   159,   272,   451,   284,   400,
     454,   450,   116,   400,  4511,   184,   249,   257,  2970,   450,
     207,  1030,   244,  1726,   373,  4458,  4459,   311,   400,   545,
    1748,   312,  1119,   102,   199,   454,   454,   333,  1756,   362,
     306,   198,   454,   188,   189,   373,   102,   192,   373,   194,
     411,   331,   373,   386,   311,    22,  1064,   454,   378,   439,
     329,    28,  4828,   220,   373,  1768,   350,  1119,   359,   214,
     336,  1779,   452,   454,  1347,  3417,   353,   354,   594,   595,
     398,  1090,  1355,   309,   439,  3417,   366,  1424,   368,  1426,
     454,   359,  1101,   450,  1580,   634,   401,   394,   450,   373,
    4648,   454,  4010,   346,  4052,   405,   373,  1116,  4621,   544,
     562,  1814,   454,  1505,   450,   567,   339,  1345,   439,   450,
     638,  1434,   765,  3745,  1479,   394,   578,   405,  4779,   446,
     454,   452,   454,   399,   394,   633,   634,   633,   647,   411,
     649,  3342,   651,  1416,   450,  1474,  1419,  1420,   657,  1236,
     450,   453,   441,   442,  3772,  1652,   449,  1244,  1245,   126,
    4068,   604,   346,  1682,   453,   681,  2715,   453,   453,  1397,
     453,   450,   450,  3598,  3781,   661,  3580,   647,  3785,   649,
     450,   651,   625,   632,  1236,  3557,   355,   657,   658,   659,
      20,   707,  1689,  3689,   373,   450,   450,   454,   634,   715,
     450,  1698,   718,   719,   720,   898,   678,  4740,  3771,   417,
    1295,  1614,   754,   883,  1487,  1295,  1406,   754,  3833,  4752,
     450,  1411,  4717,  1364,   894,   450,   441,   442,   436,   448,
     346,   450,   450,   452,   446,   114,   450,   450,   453,  1725,
     450,  1727,   450,   362,   448,   450,   417,  1733,   452,  2682,
     102,  2684,   406,  1739,  1740,  1741,   754,   756,   756,   756,
     756,   756,   756,  1749,  1750,   436,   373,   739,  1754,  4450,
     373,   441,   442,   441,   442,   441,   442,   373,  4811,   450,
     450,   394,    55,  2072,   441,   442,  1587,  1588,   958,   454,
    2993,  3281,   396,   362,   415,  4687,  4204,   769,  2006,  4732,
     158,     5,     3,  4211,     5,   272,   362,   743,  3324,   139,
     258,  3651,   139,   150,   193,   436,   161,   102,  4096,  3520,
     441,   442,  4100,  4101,   109,  4103,   441,   442,   443,   444,
     445,   446,   258,  1569,   443,   444,   445,   446,   109,   306,
     812,  2612,  2613,  2614,     5,    34,   717,   148,   254,   245,
     721,   264,  2141,    48,  2929,   257,   109,   827,    22,   747,
    4341,  2936,  2937,  2006,   756,  2940,   254,   242,  1402,   336,
       5,   336,  2947,   254,   441,   442,   443,   444,   445,   446,
     102,   155,  1618,   254,  4776,  2100,  1622,   271,   159,  2938,
    2939,  2090,  1628,  1629,   306,   336,   443,   444,   445,   446,
     109,   320,   322,   104,   241,   100,   114,    22,   553,   756,
     104,   803,   557,    28,  4155,  1651,   217,  3310,   756,  2127,
     109,  1554,   756,    64,     3,  3175,  3176,  3177,  3178,   756,
     575,  3181,  3182,  3183,  3184,  3185,  3186,  3187,  3188,  3189,
    3190,   756,   756,   756,   756,   756,   756,   890,   756,   756,
     329,  4192,   336,   264,  3624,   160,   136,  1322,   378,   244,
     229,   373,   126,  3259,  4205,  3261,   324,   910,  2313,   242,
    3259,   172,  3261,  2019,   245,   103,   919,   869,   172,    64,
    4205,   858,   859,    64,    46,   193,   331,  3237,  3238,   454,
     320,   113,   104,  4115,  1695,  1696,   137,   192,   394,    24,
      81,    80,  2626,   168,   152,   242,  1765,  2672,   111,   339,
     362,   126,   339,   454,   155,   394,   160,   197,   363,    44,
     242,  2954,   448,  2327,   109,   400,   452,   962,  2961,     5,
     231,   450,  4212,   234,  1050,   244,  1988,   231,  4156,   312,
     234,   454,  1998,  3339,   450,   249,  1062,   242,   450,   407,
    3339,   130,   362,  4160,    78,   183,   137,  2265,  4165,    38,
     172,  4168,   450,   336,   109,   111,  1064,   352,  1064,   450,
     355,   103,  1659,  4554,   155,   264,   329,   242,   200,   450,
    1096,  1067,  4526,  1069,   264,  1071,   126,  1073,   249,  1075,
    1076,  1077,  1062,  1627,   118,  4565,  1082,   262,     3,  1586,
     203,  4549,  4562,  1119,  3037,  4068,  4550,  1575,   272,   362,
    1619,  4352,   375,   175,   249,   324,   260,   322,   180,   231,
    4045,    78,   234,  1632,   136,   396,   327,  4307,     8,  1127,
     325,    11,   113,   327,   282,    15,    16,    17,  1647,   161,
     271,   244,   306,   454,   223,  3846,   287,  1512,  1146,   402,
    1658,   183,   159,  1192,   216,   418,  1099,   272,  1645,   244,
      40,   118,   415,   112,   249,   450,    46,  2419,  4040,   194,
      88,   376,   336,   381,    78,    80,   205,   382,  1194,  1177,
      88,  3885,   121,   436,   123,    83,   394,  1203,   833,   834,
      70,   306,   295,   272,  1192,   432,   324,   450,  1934,   178,
     108,  1217,   287,   249,   249,   217,   287,   206,   388,  1402,
     153,   355,  1746,   242,   118,   327,   301,    89,    32,   200,
    1236,   336,   262,  1239,  1240,   123,   131,   176,  1244,  1245,
     431,   174,   140,   361,   362,   400,  4448,   431,  1280,  1281,
    4688,  1283,   345,  1280,  1281,   163,  1283,  1265,   389,   273,
     439,   649,   650,   651,   375,   111,   654,   655,   656,   448,
    4382,   450,   451,   452,   160,   454,   664,   274,   913,  1239,
     310,  4451,   172,  1974,  1244,  1245,   320,   321,  3528,   341,
     185,  4461,  1280,  1281,  4552,  1283,   365,   159,   367,  4697,
     935,   936,   324,  3831,  4775,   175,   336,  2515,  2516,  4780,
     180,  2193,  2520,   373,   389,   244,    78,  4414,   389,   331,
     339,   956,  3802,   119,    22,   254,   273,   189,  3808,   431,
      28,  3797,   450,   129,   271,  1297,   140,    22,  2536,   361,
     362,   231,   204,   150,  2542,   342,   216,   450,   450,  2557,
    2558,   363,   214,   367,   272,   101,   118,   203,   112,  4590,
    4831,   453,  4474,    78,  2340,   231,  4478,  4479,  3669,   271,
    2366,   140,   384,     3,   260,   394,  2376,   239,   101,   273,
     306,  2099,   277,  2370,  4615,    36,     3,  1347,   205,     0,
     260,  1026,  1027,    23,   454,  1355,   258,    56,   244,   336,
    4615,  2164,   209,   118,   302,    64,  4238,   454,  1568,  2172,
     336,  2174,  2294,  2295,  2296,  2297,  4238,  1342,   336,  4334,
     367,  4892,   176,  2250,  2306,   242,  1432,   286,   126,  3494,
    2161,   329,  1392,  4327,   336,  3500,  3501,   327,  3503,   185,
     158,   126,  2019,  2161,  1627,   153,   121,  3105,   123,   295,
      80,  4625,  4626,    11,   316,   163,  1416,  1617,   136,  1419,
    1420,   327,   180,    80,   362,  2183,   117,  1400,  2710,  2634,
     148,   341,   180,   367,   148,   153,   272,  1439,   295,   153,
     121,   272,   123,   121,   230,   123,   232,  2781,  3318,   111,
     396,  2336,   387,  2211,  3417,  3781,  1502,  3579,   378,  3785,
     395,   131,  3781,   398,   402,   146,  3785,   230,   146,   232,
     306,   273,    70,   130,   253,   306,   375,   415,  1460,   197,
    3281,   306,   339,  3148,  1406,   162,  1532,  1487,   136,  1411,
     148,  1691,   272,   308,   396,  2870,  2060,   201,   436,   217,
     148,  2517,   111,   217,   450,   153,   262,  1480,  4779,   326,
     180,   336,   450,  2529,  2012,   185,   272,   112,   273,   418,
     329,   220,  1495,  1746,   434,   187,   306,   437,   438,   439,
     310,   441,   442,   443,   444,   445,   446,   394,   256,   254,
     272,  1514,   256,   220,   153,  2561,   264,   415,  1530,   197,
     306,   207,  1534,   362,   258,   272,   336,   160,  2097,   217,
    3639,  2880,  3641,   244,  1546,   367,   223,   315,   249,   217,
     322,   249,  4303,   254,   306,   272,   254,  2343,   187,   439,
     242,   176,   244,  2599,  1584,   415,   454,   190,  1561,   306,
    3093,  4805,   452,   402,  1594,   329,  1596,   180,   256,  2365,
     415,  1574,  4536,  1603,   336,  4560,   415,   277,   256,   306,
    4235,  1611,   367,  1586,  2380,   272,   264,  2383,  2384,   336,
    2423,   436,  2388,  2389,   454,  1598,   378,   436,   362,  2395,
    1658,   310,  1658,   242,   396,   244,  4538,  1065,  1620,   454,
    1068,   450,  1070,  4577,  1072,   320,  1074,   317,  4273,   306,
    1078,   407,  1668,   310,  1670,  2153,  1672,   336,  1674,  2322,
    1676,  4095,   272,  1718,  1680,  4365,  1648,   373,   402,  1642,
     388,  2720,  1645,   272,   162,  3020,   351,   138,  3023,   336,
      89,  1710,  1710,  1710,  1710,  1710,  1710,   310,   450,   366,
     360,   368,  1738,  1659,  2680,  2461,   306,    72,   299,   380,
    2686,    11,   380,  1705,  4697,  1380,    81,   306,   365,   390,
     367,  2751,   390,   336,  2331,   392,   450,   387,   450,   244,
     181,   294,  2960,   306,   249,   395,   336,   310,   398,   330,
      40,  4462,   220,   439,  4468,  1735,  1736,   336,    21,   289,
     388,   229,  1742,  1743,    27,  2156,   452,   306,   321,  2331,
     159,   310,  1528,   336,    61,    62,  1784,  2690,   415,  1724,
      70,   362,  1717,   159,   272,  4199,  4018,  4201,   293,   408,
    1770,  1547,  1447,  1448,  1449,  1450,  2393,   336,     8,    81,
     189,    11,   162,  1829,  4361,    15,    16,    17,  3867,  3868,
      30,    31,  4044,   189,  4696,   204,   299,  4030,   306,  2210,
     448,  1774,    32,   451,   452,   214,   451,   408,   204,   454,
     329,  2393,   448,   295,  1489,  1490,   452,    42,   214,   451,
     373,  3103,   454,  1498,  2627,   307,   226,   330,   336,  4155,
     239,  4111,   415,  1508,  4160,   450,  4155,  2060,    63,  4165,
     220,  4160,  4168,   362,   378,   320,  4165,   322,    88,  4168,
     332,  2051,   258,   436,  2739,  2619,   415,   263,  2058,   362,
     162,  1536,  1537,  1538,  1539,   417,  4192,   415,   108,  3974,
     415,  3976,  3977,  4192,  4574,  3980,    64,   436,   366,  4205,
     368,   183,    70,   402,   436,   378,  4205,   153,   436,   148,
      24,   436,  4826,    81,   153,   415,   415,  4628,   450,  1758,
     140,  3343,  1761,   378,   392,   408,   454,   316,   174,  2528,
      44,  2530,  2531,   417,  1953,   308,   436,   436,   220,   299,
     316,   109,   326,   111,   324,  2768,   226,  3175,  3176,  3177,
    3178,   450,   436,  3181,  3182,  3183,  3184,  3185,  3186,  3187,
    3188,  3189,  3190,  2624,   449,   451,   450,  2790,   454,   454,
    1979,  1979,   226,  1953,  3003,  2096,  1631,  2723,   217,  1634,
    3208,   263,     5,  3012,   229,   365,  2021,    10,  2023,  1644,
    1936,   201,  3210,  2019,  4876,    18,   449,  3988,  1653,  3990,
    2019,   454,   258,  3994,  3217,  3996,   366,   263,   368,  3237,
    3238,   451,   392,    36,   454,   445,  3797,   256,   229,   187,
     450,  3802,   452,  4734,   448,    85,   450,  3808,   452,  2573,
    2627,  2769,   392,   183,  2155,   415,   445,   417,   378,  2019,
    2002,   450,    77,   452,   324,  2007,  4352,   408,   408,  2011,
     260,    52,  2798,  4352,  2800,   451,   174,  4614,   454,  2085,
     366,   451,   368,    48,   454,   326,   451,  3392,  3393,   454,
     450,   366,  3131,   368,   207,  2037,   244,  3376,   320,   321,
     451,   249,   302,   454,   366,   365,   368,   451,  2209,  2071,
     454,   415,   451,   417,   451,   454,   378,   454,   451,  2837,
     451,   454,  2055,   454,   450,    90,  3319,   389,  4414,   329,
     392,   365,   392,   451,  2067,  4414,   454,  2079,  2965,   287,
     450,  4381,  3421,  3139,  3058,  3059,     9,  1782,   451,   136,
     115,   454,   324,   301,  2096,   415,   451,   417,   392,   454,
    2737,   148,   362,   136,   451,   130,   153,   454,  4859,   134,
     451,  2104,   450,   454,   452,   148,   245,   246,  2904,   258,
     153,   415,  2124,   417,  2910,   451,    13,    14,   454,   154,
     450,   454,   157,   451,  3170,  2737,   454,   451,   451,  3601,
     454,   454,   402,   450,  2164,   170,   406,    52,  2707,  2708,
     197,  4276,  2172,  2155,  2174,   415,   450,  2159,  3416,   451,
    3418,  2227,   454,   451,   197,   448,   454,   450,  3204,  2235,
     217,   451,   408,   406,   454,  2177,   436,  2243,    42,  2245,
     451,   389,   451,   454,   217,   454,  2188,   437,   438,   439,
     450,   441,   442,   443,   444,   445,   446,   452,   451,  2201,
     329,   454,   451,     8,   203,   454,  4803,  2209,   433,   256,
      15,    16,    17,  3249,   258,   261,   451,   264,   226,   454,
     153,  4320,   451,   256,   249,   454,   226,  2293,   373,   258,
    3135,   264,   257,   362,   451,   451,  4833,   454,   454,   451,
     261,   261,   454,  2463,  4590,  3587,  4067,     0,  3506,  2469,
    3604,  4590,   415,   451,   417,  4238,   454,  2323,   451,   451,
    3528,   454,   454,  3049,  2257,  2331,  2315,  2315,   293,  4615,
      42,  3340,  3341,   402,   433,   451,  4615,  4731,   454,   451,
     451,  2280,   454,   454,   451,   451,   415,   454,   454,   433,
    3076,  3077,  2851,  3079,   451,  3081,  3082,   454,   451,   203,
     451,   454,  2861,   454,  4901,   443,  2989,   436,  3094,   451,
     451,   451,   454,   454,   454,   451,   324,  3140,   454,   451,
     451,   450,   454,   454,   324,   451,   157,  2393,   454,  2966,
    2573,  2968,   454,  2353,  2354,    88,   451,   450,   158,   454,
    2360,   388,   451,   451,   451,   454,  3132,   454,   451,    52,
    3652,  3653,  3654,   451,   199,   388,   454,   365,  2053,  2054,
     451,   450,  3368,   454,  2966,   365,  2968,  2062,  3321,  2064,
     452,  4354,     8,  2068,   451,    11,  3115,   454,   336,    15,
      16,    17,   451,   136,   392,   454,   451,   306,   419,   454,
    2610,   451,   392,   450,   454,   148,    32,   180,   226,  3036,
     153,   451,  2645,  2423,   454,   158,  3285,   415,   451,   417,
     163,   454,   450,   166,   452,   415,   169,   417,   366,   451,
     368,  2980,   454,  2982,  2357,  2358,  2359,  2429,  2517,   451,
     141,   450,   454,  4779,  3036,   451,   226,   366,   454,   368,
    4779,   452,   450,  2663,   197,   451,   141,   258,   454,  2451,
     450,   180,  2445,   451,   306,   260,   454,  2459,   451,   451,
     258,   454,   454,  3272,   217,   451,   141,   451,   454,  2517,
     454,   451,  2561,  2466,   454,  2170,   451,   451,   180,   454,
     454,    25,     8,   451,  2477,    11,   454,   451,   141,   258,
     454,  3275,  3276,  3277,   153,   415,   324,   417,   451,  4771,
     453,   246,   451,   256,   453,   258,  3786,   759,  3788,   761,
     306,   264,   226,  2561,    40,   141,     8,   215,   111,    11,
      46,   396,   258,    15,    16,    17,   450,   378,    72,   253,
    2578,  2226,   408,   326,   324,   153,   207,   365,   292,  2234,
      32,  2236,   450,    64,    70,  3798,  2594,  2242,    40,    35,
    2604,  2605,  2606,   244,    46,   450,   419,   258,   244,   103,
     313,  2627,  2610,    42,   392,   201,    42,   383,   272,   153,
     408,  3130,   408,    77,  3827,   365,   226,  2666,    70,   153,
     124,  4299,   290,   141,   329,   141,   141,   415,   450,   417,
     405,   135,  2641,  2641,  2641,  2641,  2641,  2641,   283,   141,
     450,   450,   392,    34,   141,  2625,   419,  2627,   134,   362,
     324,   155,   141,   454,   141,  2663,   160,   362,  2666,   141,
     258,  2316,   450,  3486,   260,   415,   141,   417,   141,   258,
     141,   226,   437,   438,   439,   388,   441,   442,   443,   444,
     445,   446,   141,   153,  3946,  3947,   141,  3949,   258,   175,
     141,   365,   141,   141,   180,   362,   450,   402,    35,   412,
     450,   414,   415,   215,   208,   450,   153,   258,   153,     5,
     415,  2737,     5,  3615,   324,   450,   450,  2372,   392,  2374,
     153,     5,   450,   175,   450,   229,  3722,   450,   180,  2691,
     216,   436,   450,   450,   450,   448,     5,     5,   451,   452,
     453,   415,   450,   417,   450,   450,   451,   450,   453,   201,
     202,  2954,   450,   450,     5,   365,   450,   450,  2961,   450,
     450,   269,   450,   450,   216,   450,   416,   450,   450,   324,
     450,   450,  2734,  3735,   260,   450,   450,   450,   450,   199,
      35,    92,   392,   215,   454,  4566,   290,  2740,   454,    35,
     153,  2817,   153,   256,   254,   247,   336,   373,   373,   324,
     452,   373,   373,   324,  2757,   415,   217,   417,   260,   373,
     365,   263,   373,   317,   439,   373,    81,   324,   141,   328,
     324,   258,   226,   212,   373,  2480,   330,   373,   249,   395,
     373,   258,   365,  2859,   185,   254,   450,   392,   373,   173,
     450,   437,   438,   439,   373,   441,   442,   443,   444,   445,
     446,   450,    81,   454,   272,   341,   180,   396,   362,   141,
     415,   365,   417,   103,   396,    52,    52,   373,   373,     8,
     373,   365,    11,  2835,  3657,   373,    15,    16,    17,   383,
     373,  2907,   373,  4111,   262,  2847,    41,    41,   373,   341,
    3636,  2844,  4120,  2846,   373,   450,   373,   454,  3644,  3645,
    3646,  3647,   324,  2929,   408,   373,   373,   201,   258,     8,
    2936,  2937,    11,   258,  2940,   258,    15,    16,    17,   419,
     324,  2947,   201,     8,   201,  3105,    11,   415,  2954,  3985,
      15,    16,    17,    32,    35,  2961,   450,    24,   258,   141,
    2966,   244,  2968,   109,   141,   407,     8,    32,   434,    11,
     223,   450,  2905,   396,   254,   441,   442,   443,   444,   445,
     446,   365,  2924,   244,   244,    35,   450,    35,   153,   207,
     325,    34,   450,   371,  2954,   371,   448,  2930,    40,   448,
    3006,  2961,   434,   336,    46,   437,   438,   439,   392,   441,
     442,   443,   444,   445,   446,   141,   373,  4026,   373,   373,
     450,   373,   454,  2983,   141,   141,   396,   141,    70,  3035,
    3036,   415,   396,   417,   141,   373,     8,  3026,  3026,    11,
     253,   248,    22,    15,    16,    17,   158,   450,    28,   411,
     236,   236,  3551,  3552,    11,   371,   450,  4339,   454,  3048,
    3048,   180,   450,   373,   166,  3564,   450,   149,    40,   158,
     375,   454,   451,   173,    46,   173,   450,   197,   205,   454,
     259,   339,   201,   396,    35,   266,  3019,  4285,    68,   454,
      52,   451,   134,   249,   373,  3055,   373,   324,    70,  3259,
     324,  3261,   450,  3852,   396,   249,   205,   373,   205,   378,
     373,  2746,  3245,  2748,  2749,  2750,   450,  3050,   373,   408,
     326,   153,   201,   207,   249,   258,    42,  4785,  4786,   345,
     215,   373,   215,   175,   257,   365,   201,  3863,   180,   119,
     373,   260,   454,   258,   324,   306,   126,   306,  3823,   129,
     174,  3093,   373,  3115,   373,   333,   295,   201,    35,   396,
     201,   201,   396,   201,   201,  4407,  3108,   257,   207,  3895,
    3896,   439,   439,  4381,   216,   141,  4418,   153,   153,  3339,
    3140,   260,   155,   408,   254,   450,   333,   141,   141,   244,
      35,  3133,   415,   244,   450,   260,   258,   258,   207,    35,
     171,   171,   448,   175,   153,   185,   327,   451,   180,   234,
     451,   433,   451,  3219,  3243,   451,   433,   141,   260,   451,
    3153,   207,  3985,   258,   258,   258,   153,   333,   244,   201,
     202,   419,  3261,   180,  3417,   180,   180,    23,   164,   454,
     454,  3174,  3968,  3969,   216,   373,   454,   450,   158,   233,
     258,  4287,  4494,  4911,  4912,  3243,   454,  3251,  3252,  3253,
    3254,   415,   242,    52,   244,   378,  3199,   362,   253,     8,
     408,  3259,    11,  3261,   254,   247,   207,   451,   451,   451,
     158,   451,   262,   451,   276,   454,  4295,  4296,   260,   451,
     450,  3815,   272,   451,   451,   269,  2931,   433,   451,   341,
    3233,    40,   451,   451,   158,   450,   394,    46,     8,   373,
     450,    11,   268,   450,   225,    15,    16,    17,   437,   438,
     439,   450,   441,   442,   443,   444,   445,   446,   450,   309,
     310,    70,    32,   451,   412,   412,   402,   258,   439,   435,
      40,    52,   261,   258,   258,   450,    46,   450,   183,  4075,
     141,   373,  4078,  4079,  4596,   373,   336,   191,   437,   438,
     439,   419,   441,   442,   443,   444,   445,   446,  4094,   341,
      70,   373,   437,   438,   439,   249,   441,   442,   443,   444,
     445,   446,   373,  3882,   141,   328,   262,   141,  4011,   328,
     183,   373,   434,   396,   217,     0,   277,   277,   393,   441,
     442,   443,   444,   445,   446,   373,   373,   227,  3985,   373,
    4386,  3417,    22,   373,    24,   227,   227,   324,    28,   399,
     324,   373,   324,    33,    34,    35,   324,    37,   244,  3371,
      40,    41,   373,    43,   141,    45,   175,   373,   373,  3938,
    3446,   180,   336,  3449,   373,  3451,  3445,    41,  3083,  4425,
    3085,  4175,   201,   373,  3089,  4282,   373,  3417,  4182,  4194,
     373,   373,   434,   201,   201,   437,   438,   439,   201,   441,
     442,   443,   444,   445,   446,   175,  4476,   216,   383,  4475,
     180,   450,     3,    88,     8,  3445,   451,    11,  3494,   373,
     451,    15,    16,    17,  3500,  3501,  4505,  3503,    42,  3505,
     308,   201,   202,  4490,   454,  4492,    54,   102,  3143,   451,
     257,   141,   450,   258,   454,    35,   216,   451,   373,   141,
     153,   260,   168,    62,  3466,   396,   449,  3469,   396,    54,
     141,   136,   324,   451,   324,   261,   324,   333,   139,    87,
     449,   139,   201,   148,   201,   201,   454,   247,   153,   448,
    3510,  3511,   132,   158,   158,    11,   269,   454,   163,   451,
     260,   166,    87,   263,   169,   153,   451,   407,   451,   451,
     264,   158,   451,   412,   158,   450,   436,   187,   188,   189,
     190,   454,   192,   450,   194,   454,   196,   166,   198,   451,
     451,   201,   197,   451,  3600,   259,   144,   207,   450,   313,
     210,    79,   341,   383,   214,    35,   216,  3596,  3596,   396,
     153,  4587,   217,   396,   207,   373,   191,    52,   450,   144,
    4656,  3781,  3555,  4599,  3566,  3785,   324,  4318,  4604,   177,
    4606,  4829,  3815,   365,   324,   383,   451,   373,   373,   373,
     306,   341,   373,   373,   451,   451,   450,   415,  4374,    52,
     365,   256,   177,   258,   153,    70,   141,   102,   383,   264,
     201,   201,   415,   201,   212,   201,   451,   291,  3674,   450,
     205,  3677,   450,  3679,   186,   450,   419,  4401,   454,   153,
     451,   454,  4206,     8,    35,    75,    11,   212,   365,   454,
      15,    16,    17,  4891,   450,   434,   244,  3657,   383,   454,
     373,   451,   441,   442,   443,   444,   445,   446,   313,   450,
    4287,   163,  4910,   333,   102,   158,   158,   201,  3660,   244,
     449,   201,   201,  4449,   272,  4249,  3361,  3362,  3363,  3364,
     201,   451,   450,   300,   434,   451,   260,   437,   438,   439,
    4239,   441,   442,   443,   444,   445,   446,    52,   413,   449,
     413,   454,   451,   269,   451,   455,   451,   362,   306,   450,
     204,   450,   310,   267,   204,   364,   314,   450,   265,  4495,
      52,   169,   451,   321,   383,   451,   451,   254,   439,   158,
     328,   373,    70,   388,   415,   310,   185,   312,   336,   314,
     249,   249,   439,  3781,    52,   365,   321,  3785,    64,   454,
     348,   454,   373,   328,  3810,   373,  3812,   412,   356,   414,
     415,   336,  3745,   373,   141,   201,  4812,   160,   158,   396,
     180,   450,   333,   348,   396,    35,   244,   127,   411,  3844,
     415,   356,    35,   415,   158,   258,  3825,  3825,   450,   153,
     188,   261,   199,   448,   450,   158,   451,   452,   453,   300,
     450,   401,   204,  4013,   349,   451,   275,   414,    81,   122,
     451,   450,   410,     8,   450,   258,    11,   301,   373,   153,
     451,   373,   450,   116,   249,   451,   201,   450,    35,   249,
     183,   450,   228,   291,   450,   410,   450,   450,   141,   451,
     140,  3526,  3891,    35,   450,    40,   451,   262,   347,   321,
     321,    46,   383,    52,   451,    52,   347,    35,   450,   454,
     365,   365,   242,   437,   438,   439,   450,   441,   442,   443,
     444,   445,   446,   451,   450,    70,   396,   450,   365,   451,
     258,  3891,  3865,   543,   451,   260,   450,     5,   548,   147,
     550,   291,    64,   553,   261,   555,    64,   557,   122,   415,
     415,  3911,  3912,   400,   564,   300,  3916,  3917,   568,  3965,
    3966,  3894,   401,   450,   450,   575,  3908,   336,  3974,    35,
    3976,  3977,   454,   158,  3980,   298,   412,   153,  3920,  3985,
    3913,   365,   258,  3989,   127,   185,   258,   450,   598,   134,
      35,   333,    35,   603,   261,  4155,   261,   450,   608,   160,
    4160,   160,   612,   451,  4627,  4165,    52,   114,  4168,  4169,
       0,   320,   450,   394,     5,   307,   320,   450,   450,   629,
     451,    21,   451,  4206,    32,  3985,   454,   454,   140,   373,
     175,  4037,  4192,   450,  3967,   180,   291,   158,   415,   347,
     347,   415,  1463,   450,   160,  4205,   160,   756,  2278,   852,
     819,  1245,  2790,  4042,  4042,  4238,  2627,   859,   858,  2136,
    4066,  3416,  2205,  2952,  3505,  4497,  4249,  4285,   678,  4656,
    4335,   216,  3549,  4339,  4004,  4317,  4738,  2411,  4804,  4656,
    2714,   691,  4205,   693,  4809,  4670,  4669,  4758,  4248,  2718,
    4096,  3597,  3582,     8,  4100,  4101,    11,  4103,    88,  4623,
      15,    16,    17,   713,   714,  3541,   716,   717,  2268,  2268,
    2812,   721,   437,   438,   439,   260,   441,   442,   443,   444,
     445,   446,  3411,  1533,  4029,   735,  3565,  2262,  3005,   739,
    4817,  4910,  4891,  4312,  2960,   745,  4069,  2956,  4251,  4299,
    4769,  1522,  4642,  4748,  4254,    27,   136,   757,  3660,  4447,
    1993,  3604,  2689,  4095,  1091,  4566,  1102,  1714,   148,   769,
    1713,   623,  4784,   153,  1713,  2908,  4894,  1936,   158,   595,
    1937,  1326,  4160,   163,  2641,   734,   166,  4165,  1659,   169,
    4168,  3585,  4115,  3826,  4730,  1271,  3316,  2642,  3284,  1977,
    2648,  1222,  4352,  2653,  4723,  1289,   341,  1290,  4608,  3811,
    1292,  1976,   812,  3261,  2663,  3772,  4194,   197,  3787,  4415,
    1297,  4187,  4590,  3259,  4589,  3064,  3317,  4384,   828,  1591,
    3212,  4184,  4726,   833,   834,  4727,  4713,   217,  2645,  2578,
    1807,  2488,  4238,     8,  2576,  1810,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   858,   859,
      -1,    -1,    -1,    -1,  4414,    -1,    -1,  4199,    -1,  4201,
      -1,    -1,    -1,    -1,    -1,    40,   256,    -1,   258,    -1,
    4276,    46,    -1,   883,   264,    -1,    -1,    -1,  4238,    -1,
      -1,  4287,    -1,    -1,   894,  4291,   201,  4293,   898,   434,
      -1,  4297,  4298,    -1,    -1,    70,   441,   442,   443,   444,
     445,   446,    -1,   913,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,  3948,    -1,    -1,    -1,    -1,   928,    -1,
      -1,    -1,    -1,   313,    -1,   935,   936,  3962,    -1,    -1,
      54,    -1,    -1,  4322,  4322,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   952,   953,   954,   260,   956,    -1,   958,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,
    4349,  4349,    -1,    87,  4524,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4425,    -1,   388,    -1,
     175,    -1,    -1,    -1,    -1,   180,    -1,    -1,  4043,    -1,
      -1,    -1,    -1,    40,  1024,  4444,  1026,  1027,    -1,    46,
     144,    -1,   412,    -1,   414,   415,  4414,    -1,    -1,    -1,
    4590,    -1,    -1,    -1,    -1,    -1,    -1,  4425,    -1,     8,
    4623,   216,    11,    70,  1054,    35,    -1,    -1,    -1,  4382,
      -1,    -1,    -1,   177,    -1,  4615,  4444,    -1,   448,    -1,
      -1,   451,   452,   453,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,  1084,  1085,    -1,    46,    -1,  1089,
      -1,  1091,    -1,   207,    -1,   260,    -1,  4420,   212,    -1,
      -1,    -1,  4498,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      -1,    70,  1112,    -1,    -1,  1115,    -1,   134,  1118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     244,  1131,   437,   438,   439,  4685,   441,   442,   443,   444,
     445,   446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4474,    -1,    -1,    -1,  4478,  4479,    -1,   175,    -1,
    1160,    -1,    -1,   180,   144,    -1,    -1,    -1,  4547,  4547,
      -1,    -1,    -1,    -1,    -1,   134,   341,    -1,    -1,    -1,
      -1,    -1,  4207,  4208,  4209,    -1,    -1,    -1,  1188,  1189,
    1190,    -1,  1192,  4743,    -1,    -1,   310,   177,    -1,   216,
     314,    -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,
      -1,    -1,  1212,    -1,   328,    -1,   175,    -1,    -1,    -1,
      -1,   180,   336,    -1,    -1,    -1,    -1,   207,    -1,  4779,
      -1,    -1,   212,    -1,   348,  4785,  4786,    -1,    -1,    -1,
      -1,    -1,   356,   260,  4567,    -1,    -1,    -1,    -1,    -1,
    1250,    -1,    -1,  1253,    -1,    -1,    -1,   216,    -1,    -1,
    4656,    -1,   376,    -1,   244,    -1,    -1,    -1,    -1,   434,
      -1,    -1,    -1,    -1,    -1,    -1,   441,   442,   443,   444,
     445,   446,  1282,    -1,    -1,    -1,  1286,  1287,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   410,  1297,  1298,  1299,
     414,   260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1319,
      -1,    -1,    -1,    -1,   341,  4350,    -1,    -1,    -1,    -1,
     310,    -1,    -1,    -1,   314,     8,    -1,    -1,    11,    -1,
      -1,   321,    15,    16,    17,    -1,    -1,    -1,   328,  4899,
      -1,    -1,    -1,    -1,    -1,    -1,   336,  1357,    -1,    32,
      -1,  4911,  4912,    -1,    -1,    -1,    -1,    40,   348,    -1,
    1370,  1371,    -1,    46,    -1,    -1,   356,  1377,    -1,    -1,
    1380,    -1,   341,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4770,  4770,    -1,    -1,    -1,   376,    70,    -1,  4731,
      -1,    -1,  1402,    -1,  1404,  4784,  4784,  4784,  4784,  4784,
    4784,    -1,  1412,    -1,    -1,  1415,  4835,   434,    -1,    -1,
      -1,    -1,    -1,    -1,   441,   442,   443,   444,   445,   446,
     410,  4456,    -1,  4829,   414,   415,    -1,    -1,    -1,  1439,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1447,  1448,  1449,
    1450,  1451,    -1,    -1,    -1,    -1,  4835,  4835,  4835,  4835,
    4835,  4835,  1462,    -1,    -1,  1465,  4491,    -1,  4493,    -1,
      -1,    -1,    -1,    -1,    -1,   434,  1476,    -1,  1478,  4829,
      -1,    -1,   441,   442,   443,   444,   445,   446,    -1,  1489,
    1490,    -1,    -1,    -1,    -1,  4891,    -1,    -1,  1498,    -1,
      -1,    -1,   175,    -1,    -1,    -1,    -1,   180,  1508,    -1,
      -1,    -1,    -1,    -1,  4910,  4894,  4894,  4894,  4894,  4894,
    4894,    -1,    -1,    -1,    -1,    -1,    -1,  1527,   201,   202,
      -1,    -1,    -1,    -1,    -1,    -1,  1536,  1537,  1538,  1539,
      -1,  4891,    -1,   216,    -1,    -1,    -1,    -1,  1548,    -1,
      -1,    25,    -1,    -1,    -1,  1555,    -1,    -1,  1558,    -1,
    4910,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1568,    -1,
      -1,    -1,    -1,    -1,   247,  1575,    -1,    -1,    -1,    -1,
    1580,    -1,    -1,    -1,    -1,    -1,    -1,   260,    -1,    -1,
     263,    -1,    -1,    -1,    -1,    -1,  4621,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    -1,  1617,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1627,    -1,   103,
      -1,  1631,    -1,    -1,  1634,   109,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1644,    -1,    -1,    -1,    -1,    -1,
     124,    -1,  1652,  1653,  4679,    -1,    -1,  1657,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,   341,   143,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   155,  1682,    -1,    -1,    -1,   160,    -1,    -1,  1689,
      -1,  1691,   166,    -1,    -1,  1695,  1696,    -1,  1698,    -1,
      -1,    -1,    -1,    -1,    -1,  1705,    -1,    -1,    -1,   183,
      -1,    -1,  1712,    -1,    -1,    -1,    -1,  1717,  1718,    -1,
      -1,  1721,    -1,    -1,    -1,  1725,    -1,  1727,  4753,    -1,
      -1,    -1,  1732,  1733,   208,    -1,    -1,    -1,    22,  1739,
    1740,  1741,    -1,    -1,    28,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,    -1,  1754,   229,  1756,  1757,    -1,    -1,
    1760,   434,    -1,    -1,   437,   438,   439,    -1,   441,   442,
     443,   444,   445,   446,    -1,  1775,  1776,  1777,  1778,    -1,
      -1,   454,  1782,  1783,    68,    -1,   260,  1787,  4813,    -1,
    1790,    -1,    -1,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,    -1,  1803,    -1,    -1,   280,    -1,    -1,  1809,
    1810,    -1,  1812,    -1,    -1,    -1,   290,    -1,    -1,  1819,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,
      -1,    -1,   126,   317,    -1,   129,    -1,    22,   322,    -1,
     324,    -1,    -1,    28,    -1,    -1,   330,    -1,    -1,   333,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   361,   362,    -1,
      54,   365,    -1,    68,    -1,   369,    -1,    -1,    -1,    -1,
      -1,   185,    -1,    -1,   378,    -1,    -1,    -1,    -1,   383,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   395,    -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   408,  1935,    -1,  1937,    -1,  1939,
      -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,
      -1,   126,    -1,    -1,   129,    -1,    -1,    -1,   242,    -1,
     244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     0,
     254,    -1,    -1,    -1,  1974,    -1,    -1,    -1,   262,    -1,
     144,  1981,    -1,  1983,    -1,    -1,    25,    18,   272,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     185,    -1,  2012,   177,    45,    -1,    -1,    -1,    -1,    58,
      -1,  2021,   306,  2023,    -1,   309,   310,    -1,    -1,    -1,
      -1,    -1,    71,    -1,    65,    -1,    67,    68,    -1,    -1,
    2040,    -1,    73,   207,    75,    -1,    85,    -1,   212,    -1,
      -1,  2051,   336,  2053,  2054,    86,    -1,    88,  2058,    -1,
    2060,    -1,  2062,    -1,  2064,    -1,    -1,   242,  2068,   244,
      -1,  2071,    -1,    -1,   105,    -1,    -1,   108,    -1,   254,
     244,    -1,    -1,    -1,    -1,   124,    -1,   262,    -1,   120,
    2090,   122,    -1,    -1,    -1,   126,   135,   272,    -1,    -1,
    2100,   132,    -1,    -1,    -1,    -1,    -1,  2107,    -1,   140,
      -1,   142,    -1,  2113,    -1,   399,   155,   148,    -1,    -1,
    2120,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   306,   163,    -1,   309,   310,    -1,    -1,    -1,    -1,
    2140,    -1,    -1,    -1,  2144,  2145,   310,    -1,   179,    -1,
     314,    -1,    -1,  2153,    -1,    -1,    -1,   321,    -1,    -1,
      -1,   336,    -1,    -1,   328,    -1,     3,    -1,    -1,    -1,
    2170,     8,   336,    -1,    11,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    -1,   348,    -1,    -1,   218,   219,    -1,
     229,    -1,   356,   224,    -1,    32,    -1,  2197,    35,  2199,
    2200,    -1,    -1,    40,   235,    -1,    -1,    -1,    -1,    46,
      -1,    -1,   376,    -1,    -1,   246,    -1,    -1,    -1,    -1,
      -1,   260,    -1,    -1,   399,    -1,  2226,    -1,    -1,    -1,
      -1,    -1,    -1,    70,  2234,    -1,  2236,    -1,    -1,    -1,
      -1,    -1,  2242,    -1,    -1,    -1,   410,    -1,    -1,    -1,
     414,   290,    -1,    -1,   285,    -1,  2256,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,    -1,
    2270,   302,   303,  2273,   305,  2275,    -1,    -1,  2278,   310,
      -1,  2281,    -1,    -1,   315,   324,    -1,   318,    -1,    -1,
      -1,   330,   323,    -1,   333,    -1,    -1,   328,   329,    -1,
      -1,    -1,    -1,    -1,    -1,   336,    -1,  2307,    -1,   340,
      -1,    -1,    -1,    -1,    -1,    -1,  2316,  2317,    -1,   350,
      -1,    -1,    -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,
     369,   362,    -1,    -1,    -1,    -1,    -1,   376,   175,    -1,
    2340,    -1,    -1,   180,   383,    -1,    -1,    -1,    -1,    -1,
     381,    -1,    -1,    -1,    -1,  2355,    -1,    -1,    -1,    -1,
     391,    -1,    -1,    -1,   201,   202,   397,    -1,    -1,   408,
    2370,   402,  2372,  2373,  2374,  2375,    -1,    -1,    -1,   216,
      -1,    -1,    -1,    -1,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2398,    -1,
      -1,    -1,    -1,    -1,    -1,   436,    -1,    -1,    -1,    -1,
     247,  2411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,
      -1,    -1,   453,   260,    -1,    -1,   263,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,  2453,    11,    -1,    -1,    -1,    15,    16,
      17,    53,    -1,  2463,    -1,    -1,    -1,    -1,    -1,  2469,
      -1,    -1,    -1,    -1,    -1,    32,    68,    -1,    -1,    -1,
    2480,    -1,    -1,    40,    -1,    -1,    -1,  2487,    -1,    46,
      -1,    -1,  2492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   341,    -1,    -1,    -1,    -1,   101,
      -1,    -1,    -1,    70,    -1,  2515,  2516,  2517,    -1,    -1,
    2520,    -1,    -1,    -1,    -1,    -1,    -1,   119,  2528,  2529,
    2530,  2531,    22,    -1,   126,    -1,    -1,   129,    28,    -1,
      -1,  2541,    -1,    -1,  2544,    -1,  2546,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2557,  2558,    -1,
      -1,  2561,    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2573,    -1,  2575,    -1,  2577,    68,  2579,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     182,    -1,    -1,   185,    -1,    -1,    -1,   434,    -1,  2599,
     437,   438,   439,  2603,   441,   442,   443,   444,   445,   446,
    2610,   101,  2612,  2613,  2614,    -1,    -1,    -1,   175,     8,
      -1,    -1,    11,   180,    -1,    -1,    15,    16,    17,   119,
    2630,    -1,    -1,    -1,    -1,    -1,   126,    -1,   230,   129,
     232,    -1,  2642,    32,   201,   202,    -1,  2647,    -1,    -1,
     242,    40,   244,  2653,    -1,    -1,    -1,    46,    -1,   216,
      -1,    -1,   254,  2663,    -1,    -1,  2666,    -1,    -1,  2669,
     262,  2671,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   271,
     272,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     247,    -1,   182,    22,    -1,   185,    -1,    -1,    -1,    28,
      -1,    -1,    -1,   260,    -1,    -1,   263,    -1,    -1,    -1,
      -1,    -1,    -1,  2713,   306,  2715,    -1,   309,   310,   311,
    2720,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
     230,    -1,   232,    -1,   336,    -1,  2746,    22,  2748,  2749,
    2750,    -1,   242,    28,   244,    -1,    -1,    -1,   350,    -1,
      -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   262,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   271,   272,    -1,   341,    -1,   175,    -1,    -1,    -1,
     119,   180,    -1,    68,    -1,    -1,    -1,   126,    -1,    -1,
     129,    -1,    -1,    -1,    -1,    -1,    -1,   399,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,   306,    -1,    -1,   309,
     310,   311,    -1,    -1,    -1,    -1,    -1,   216,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,   336,    -1,    -1,  2849,
      -1,   126,    -1,    -1,   129,    -1,   185,    -1,   247,    -1,
     350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   260,    -1,    -1,   263,    -1,    -1,   434,    -1,    -1,
     437,   438,   439,    -1,   441,   442,   443,   444,   445,   446,
      -1,    -1,    -1,    -1,   451,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,
     185,    -1,    -1,   242,    22,   244,    -1,    -1,    -1,    -1,
      28,    -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,
      -1,  2931,    -1,   262,    -1,    -1,    -1,    -1,  2938,  2939,
      -1,    -1,    -1,   272,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   341,    -1,     8,    -1,    -1,    11,    -1,    -1,
      68,    15,    16,    17,    -1,    -1,    -1,   242,    -1,   244,
      -1,    -1,  2972,  2973,    -1,    -1,    -1,   306,    32,   254,
     309,   310,    -1,    -1,    -1,    -1,    40,   262,  2988,    -1,
      -1,    -1,    46,    -1,    -1,    -1,    -1,   272,    -1,    -1,
      -1,    -1,    -1,  3003,  3004,    -1,    -1,   336,    -1,    -1,
      -1,   119,  3012,  3013,  3014,    -1,    70,    -1,   126,    -1,
      -1,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3030,   306,    -1,    -1,   309,   310,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   434,    -1,    -1,   437,   438,
     439,    -1,   441,   442,   443,   444,   445,   446,    -1,    -1,
       8,   336,   451,    11,    -1,    -1,    -1,    15,    16,    17,
     399,    -1,    -1,    -1,    -1,    -1,    -1,   185,    -1,    -1,
      -1,    -1,    -1,  3083,    32,  3085,    -1,    -1,    -1,  3089,
      -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    -1,  3105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3115,    -1,    -1,    -1,    -1,
      -1,   175,    70,    -1,   399,    -1,   180,    -1,    -1,    -1,
      -1,  3131,    -1,    -1,   242,    -1,   244,    -1,    -1,    -1,
      -1,    -1,    -1,  3143,    -1,    -1,   254,   201,   202,    -1,
    3150,    -1,    -1,    -1,   262,    -1,    -1,    -1,    -1,  3159,
      -1,    -1,   216,    -1,   272,  3165,    -1,  3167,    -1,    -1,
    3170,    -1,    -1,    -1,    -1,  3175,  3176,  3177,  3178,    -1,
      -1,  3181,  3182,  3183,  3184,  3185,  3186,  3187,  3188,  3189,
    3190,    -1,    -1,   247,  3194,  3195,    -1,    -1,   306,    -1,
      -1,   309,   310,    -1,  3204,    -1,   260,    -1,  3208,   263,
      -1,    -1,  3212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3220,    -1,    -1,  3223,    -1,  3225,    -1,   175,   336,    -1,
      -1,    -1,   180,    -1,  3234,    -1,    -1,  3237,  3238,    -1,
      -1,    -1,  3242,  3243,    -1,    -1,    -1,  3247,    -1,  3249,
      -1,    -1,    -1,   201,   202,    -1,  3256,  3257,  3258,  3259,
      -1,  3261,  3262,    -1,    -1,    -1,  3266,  3267,   216,    -1,
      -1,    -1,    -1,  3273,    -1,    -1,    -1,    -1,    -1,  3279,
    3280,  3281,    -1,    -1,    -1,    -1,    -1,   341,    -1,    -1,
      -1,   399,    -1,    -1,   604,    -1,    -1,    -1,    -1,   247,
      -1,    -1,    -1,    -1,    -1,  3305,    -1,    -1,    -1,    -1,
      -1,    -1,   260,    -1,    -1,   625,  3316,    -1,  3318,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3339,
    3340,  3341,    -1,  3343,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3361,  3362,  3363,  3364,    -1,    -1,    -1,    -1,    -1,
      13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
     434,    -1,    -1,   437,   438,   439,    29,   441,   442,   443,
     444,   445,   446,   341,    -1,    -1,    -1,   451,    -1,    -1,
    3400,    -1,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,
      16,    17,    22,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,
       8,    -1,    -1,    11,    40,    -1,    -1,    15,    16,    17,
      46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    68,    -1,
      -1,    -1,    40,  3483,    70,    -1,   434,    -1,    46,   437,
     438,   439,    -1,   441,   442,   443,   444,   445,   446,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3524,    -1,  3526,    -1,  3528,   119,
      -1,    -1,    -1,    -1,  3534,    -1,   126,    -1,    -1,   129,
    3540,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3549,
      -1,   194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,
      -1,    -1,   205,   206,    -1,   208,    -1,    -1,   211,  3569,
     213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3579,
     890,    -1,    -1,    -1,    -1,    -1,    -1,  3587,    -1,   175,
      -1,    -1,    -1,    -1,   180,   185,    -1,  3597,    -1,    -1,
     910,  3601,    -1,    -1,    -1,  3605,  3606,    -1,    -1,   919,
      -1,    -1,    -1,    -1,    -1,   201,   202,   175,    -1,    -1,
      -1,    -1,   180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3639,
      -1,  3641,    -1,   201,   202,    -1,    -1,    -1,    -1,    -1,
      -1,  3651,   242,    -1,   244,    -1,    -1,    -1,   216,    -1,
      -1,   247,    -1,    -1,   254,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   262,    -1,   260,    -1,    -1,   263,    -1,    -1,
      -1,  3681,   272,    -1,    -1,   995,    -1,    -1,    -1,   247,
      -1,    -1,  3692,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   260,    -1,    -1,   263,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   306,    -1,    -1,   309,
     310,    -1,  3722,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3732,  3733,    -1,    -1,    -1,    -1,    -1,  3739,
    3740,    -1,    -1,    -1,  3744,    -1,   336,    -1,    -1,  3749,
      -1,    -1,  3752,  3753,    -1,   341,    -1,  3757,  3758,    -1,
      -1,    -1,    -1,  3763,  3764,  3765,  3766,  3767,    -1,    -1,
      -1,  3771,  3772,    -1,  3774,    -1,    -1,  3777,    -1,    -1,
      -1,  3781,    -1,   341,    -1,  3785,    -1,    -1,    -1,  1099,
      -1,  3791,    -1,    -1,    -1,    -1,    -1,  3797,    -1,    -1,
      -1,    -1,  3802,    -1,    -1,    -1,    -1,    -1,  3808,   399,
      -1,    -1,    -1,    -1,    -1,  3815,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3823,    -1,    -1,  3826,    -1,    -1,    -1,
      -1,  3831,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3844,    -1,    -1,  3847,   434,    -1,
      -1,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,    -1,    -1,    -1,    -1,   451,    -1,  3867,  3868,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   434,    -1,    -1,   437,
     438,   439,    -1,   441,   442,   443,   444,   445,   446,    -1,
      -1,    -1,  3892,   451,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   551,    -1,
      -1,    -1,    -1,    22,    -1,    -1,   559,    -1,    -1,    28,
      -1,    -1,    -1,   566,    -1,    -1,   569,   570,  3928,    -1,
      -1,   574,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
      -1,    -1,   585,    15,    16,    17,    -1,    -1,  3948,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   599,    -1,    -1,    68,
      32,    -1,  3962,    -1,    -1,    -1,    -1,    -1,    40,    -1,
      -1,   614,    -1,   616,    46,    -1,   619,    -1,   621,    -1,
      -1,   624,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1302,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    -1,  4002,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,  4013,    -1,    -1,    -1,   126,  4018,    -1,
     129,    -1,    -1,    -1,    -1,    -1,  4026,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4043,  4044,    -1,    -1,    -1,    -1,   692,
      -1,    -1,    -1,    -1,    -1,  1365,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4072,    -1,    -1,    -1,   185,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,
    1400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    32,   175,   747,    -1,    -1,    -1,   180,    -1,
      40,  4111,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,
    4120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,   242,    -1,   244,    -1,  4137,  4138,    -1,
      70,  4141,    -1,    -1,   216,   254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   262,    -1,  4155,  4156,    -1,    -1,    -1,
    4160,    -1,    -1,   272,   807,  4165,    -1,    -1,  4168,  4169,
    1480,  4171,    -1,  4173,    -1,   247,  4176,  4177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1495,    -1,    -1,   260,    -1,
      -1,   263,  4192,  1503,    -1,    -1,    -1,   306,    -1,    -1,
     309,   310,    -1,    -1,  1514,  4205,  4206,  4207,  4208,  4209,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,   336,    -1,   872,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    -1,    -1,   887,   175,    -1,    40,  4248,  4249,
     180,  1561,    -1,    46,    -1,    -1,   899,    -1,   901,    -1,
      -1,    -1,    -1,    -1,  1574,    -1,   909,    -1,    -1,   341,
      -1,   201,   202,    -1,    -1,    -1,  1586,    70,   921,    -1,
      -1,   924,    -1,    -1,    -1,    -1,   216,    -1,  1598,    -1,
     399,    -1,    -1,    -1,    -1,  4295,  4296,    -1,    -1,  4299,
      -1,    -1,  4302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4312,    -1,    -1,    -1,   959,   247,  4318,    -1,
    4320,    -1,    -1,    -1,    -1,    -1,  4326,    -1,    -1,    -1,
     260,    -1,  1642,   263,    -1,  1645,    -1,    -1,    -1,  4339,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4350,  4351,  4352,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   434,    -1,    -1,   437,   438,   439,    -1,   441,
     442,   443,   444,   445,   446,    -1,    -1,    -1,    -1,   451,
      -1,  4381,   175,    -1,  4384,    -1,  4386,   180,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
    4410,   341,    -1,    -1,  4414,    -1,    -1,    -1,  4418,    -1,
      -1,    -1,    -1,   216,    -1,  4425,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4434,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4444,    -1,    -1,    -1,    -1,    -1,
    1093,    -1,    -1,    -1,   247,    -1,  4456,    -1,    -1,    -1,
    4460,    -1,    -1,    -1,  1774,    -1,    -1,   260,    -1,    -1,
     263,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    -1,  4483,    -1,    -1,    -1,    -1,    -1,    -1,
    4490,  4491,  4492,  4493,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1812,    -1,   434,  4505,    -1,   437,   438,   439,
      -1,   441,   442,   443,   444,   445,   446,    -1,    -1,    -1,
      68,   451,    -1,    -1,  4524,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,
    4540,    -1,    -1,    -1,    -1,  4545,    -1,    -1,   341,    -1,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,
      -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,   119,    -1,    -1,    -1,    -1,    -1,    -1,   126,    -1,
      -1,   129,    -1,    -1,    -1,    -1,    -1,  4587,    70,    -1,
    4590,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4599,
      -1,    -1,     8,    -1,  4604,    11,  4606,    -1,  4608,    15,
      16,    17,    -1,    -1,    -1,  4615,    -1,    -1,    -1,    -1,
      -1,  4621,    -1,  4623,    -1,    -1,    -1,    -1,  1271,  1272,
      -1,    -1,    -1,  4633,    40,    -1,    -1,   185,    -1,    -1,
      46,   434,    -1,    -1,   437,   438,   439,    -1,   441,   442,
     443,   444,   445,   446,    -1,    -1,    -1,    -1,   451,    -1,
      -1,    -1,    -1,     8,    70,    -1,    11,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,  1988,  4679,
      -1,    -1,  1992,  1993,    -1,  4685,    -1,    32,    -1,    -1,
      -1,    -1,    -1,   175,   242,    40,   244,    -1,   180,    -1,
    1343,    46,    -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,
      -1,    -1,  4712,  4713,   262,    -1,    -1,  4717,    -1,   201,
     202,    -1,    -1,  4723,   272,    70,  4726,    -1,    -1,    -1,
    4730,    -1,    -1,    -1,   216,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4743,    -1,  2055,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4753,    -1,    -1,    -1,  2067,   306,    -1,
    1403,   309,   310,    -1,    -1,   247,    -1,    -1,    -1,   175,
      -1,  4771,    -1,    -1,   180,    -1,    -1,    -1,   260,  4779,
      -1,   263,    -1,    -1,    -1,  4785,  4786,  4787,   336,    -1,
      -1,    -1,    -1,    -1,  2104,   201,   202,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4806,    -1,     8,    -1,
     216,    11,    -1,  4813,    -1,    15,    16,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     175,    -1,    32,    -1,    -1,   180,     8,    -1,    -1,    11,
      40,   247,    -1,    15,    16,    17,    46,    -1,    -1,    -1,
      -1,   399,    -1,    -1,   260,    -1,   201,   202,    -1,   341,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,
      70,   216,    -1,    -1,    46,  1518,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4885,  4886,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,  4899,
      -1,    -1,   247,    -1,    -1,    -1,    -1,    22,    -1,    -1,
      -1,  4911,  4912,    28,    -1,   260,    -1,    -1,   263,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   341,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2257,    -1,    -1,
      -1,    -1,   434,    68,    -1,   437,   438,   439,    -1,   441,
     442,   443,   444,   445,   446,    -1,    -1,    -1,    -1,   451,
      -1,    -1,    -1,  1616,    -1,   175,    -1,    -1,    -1,    -1,
     180,    -1,    -1,    -1,    -1,    -1,    -1,  1630,    -1,    -1,
    1633,    -1,  1635,    -1,  1637,    -1,   341,    -1,    -1,    -1,
    1643,   201,   202,   175,   119,    -1,    -1,    -1,   180,    -1,
      -1,   126,    -1,    -1,   129,    -1,   216,  2327,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   434,   201,
     202,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,    -1,    -1,    -1,   216,  1688,    -1,   247,    -1,  1692,
      -1,  1694,    -1,    -1,  1697,    -1,    -1,    -1,    -1,    -1,
     260,    -1,    -1,   263,    -1,    -1,    -1,    -1,    -1,    -1,
     185,    -1,    -1,    -1,    -1,   247,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   260,   434,
      -1,   263,   437,   438,   439,    -1,   441,   442,   443,   444,
     445,   446,    -1,    -1,    -1,    -1,   451,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,   244,
      -1,    -1,    -1,    -1,    -1,  2445,    -1,    -1,    -1,   254,
      -1,   341,    -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,  2466,   272,    11,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,  2477,    -1,   341,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    32,
      -1,    15,    16,    17,    -1,    -1,    -1,    40,    -1,    -1,
      -1,   306,    -1,    46,   309,   310,    -1,    -1,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      -1,    -1,    46,    -1,    -1,    -1,    -1,    70,    -1,    -1,
      -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   434,    -1,    70,   437,   438,   439,
      -1,   441,   442,   443,   444,   445,   446,    -1,    -1,    -1,
      -1,   451,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   434,    -1,    -1,   437,   438,   439,    -1,   441,
     442,   443,   444,   445,   446,    -1,    -1,    -1,    -1,   451,
      -1,    -1,    -1,    -1,   399,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2612,  2613,  2614,    -1,    -1,    -1,   187,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,   197,    -1,
      -1,    -1,   175,    -1,    -1,   204,    -1,   180,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   215,    -1,    -1,    -1,
      -1,   175,    -1,    -1,    -1,    -1,   180,    -1,   201,   202,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2003,  2004,    -1,   216,    -1,  2008,  2009,   201,   202,  2679,
    2013,    -1,  2682,    -1,  2684,    -1,    -1,    -1,    -1,  2689,
      -1,    -1,   216,    -1,  2027,    -1,    -1,    -1,    -1,    -1,
      -1,  2034,    -1,    -1,   247,  2038,  2039,    -1,    -1,  2042,
    2043,    -1,    -1,    -1,    -1,    -1,  2049,   260,    -1,    -1,
     263,    -1,    -1,   247,    -1,    -1,    -1,    -1,  2061,    -1,
    2063,    -1,    -1,    -1,    -1,    -1,   260,    -1,    -1,   263,
    2740,    -1,    -1,    -1,    -1,    -1,    -1,  2080,    -1,    -1,
      -1,    -1,  2085,    -1,    -1,    -1,    -1,  2757,    -1,    -1,
      22,    -1,    -1,    -1,    -1,  2098,    28,    -1,    -1,    -1,
      -1,    -1,    -1,  2106,    -1,  2108,    -1,  2110,  2111,  2112,
      -1,  2781,    -1,    -1,  2117,  2118,    -1,    -1,    -1,    -1,
      -1,    -1,  2125,    -1,    -1,    -1,    -1,  2130,   341,    -1,
      -1,    -1,  2135,    -1,    -1,    -1,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   341,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,  2160,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,  2171,    -1,
    2173,    -1,    -1,    -1,  2844,  2178,  2846,    32,    -1,  2182,
      -1,  2184,  2185,  2186,  2187,    40,  2189,   119,    -1,    -1,
      -1,    46,    -1,    -1,   126,    -1,    -1,   129,    -1,  2202,
    2203,  2204,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2212,
    2213,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,
      -1,   434,    -1,    -1,   437,   438,   439,    -1,   441,   442,
     443,   444,   445,   446,    -1,  2905,    -1,    -1,   451,    -1,
     434,    -1,    -1,   437,   438,   439,    -1,   441,   442,   443,
     444,   445,   446,   185,    -1,    -1,    -1,   451,    -1,    -1,
    2930,    -1,     8,  2266,    -1,    11,    -1,    -1,    -1,    15,
      16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2954,    -1,    32,    -1,    -1,    -1,
      -1,  2961,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     242,   550,   244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     175,    -1,   254,   562,    70,   180,    -1,    -1,   567,    -1,
     262,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   578,
     272,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,  3019,
      -1,    -1,    -1,    -1,    -1,   594,    -1,    -1,    -1,   598,
      -1,   216,    -1,    -1,    -1,   604,    -1,  3037,    -1,   608,
     609,    -1,    -1,    -1,   306,    -1,   615,   309,   310,    -1,
    3050,    -1,    -1,    -1,    -1,    -1,   625,   626,    -1,    -1,
      -1,    -1,   247,    -1,    -1,   634,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   336,   260,    -1,    -1,   263,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2419,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
      -1,    -1,    -1,    -1,   180,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2454,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,    -1,    -1,
     216,    -1,    -1,    -1,   713,   714,    -1,    -1,    -1,    -1,
     719,    -1,    -1,  3153,    -1,    -1,   341,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   247,    -1,    -1,  3174,    -1,   745,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   260,    -1,    -1,   263,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3199,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3233,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   434,
      -1,    -1,   437,   438,   439,    -1,   441,   442,   443,   444,
     445,   446,    -1,    -1,    -1,   341,   451,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2640,    -1,    -1,
      -1,    -1,    -1,    -1,   883,    -1,    -1,    -1,    -1,    -1,
      -1,   890,    -1,    -1,  3324,   894,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   910,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     919,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   434,  2692,
    2693,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,    -1,    -1,    -1,    -1,   451,    -1,  2710,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   958,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,
      16,    17,  2735,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2744,    -1,    -1,    -1,    -1,    32,  3417,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    -1,   995,  2760,  2761,    -1,
      46,    -1,  2765,    -1,    -1,    -1,    -1,  2770,  2771,  2772,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,
      16,    17,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,  1030,    -1,    -1,    -1,    -1,    32,    -1,  2801,  2802,
    2803,  2804,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      46,  1050,    -1,    -1,    -1,  1054,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1062,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2836,    70,  2838,  2839,  2840,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2848,    -1,    -1,    -1,    -1,
      -1,  1090,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1099,    -1,  1101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1116,    -1,    -1,
    1119,    -1,    -1,    -1,    -1,  3555,    -1,    -1,    -1,   175,
      -1,    -1,  1131,    -1,   180,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2917,   201,   202,    -1,    -1,    -1,
      -1,  1160,  2925,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     216,    -1,    -1,    -1,  3604,    -1,    -1,    -1,    -1,   175,
      -1,  2944,    -1,    -1,   180,    -1,    -1,    -1,    -1,  1188,
    1189,  1190,    -1,  1192,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   247,    -1,    -1,  2967,   201,   202,    -1,    -1,    -1,
      -1,    -1,    -1,  1212,   260,    -1,    -1,   263,    -1,    -1,
     216,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,  1236,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1244,  1245,    -1,  3011,    -1,
      -1,   247,  3015,    -1,  1253,  1254,    -1,    58,    -1,    -1,
      -1,    -1,    -1,    -1,   260,    -1,    -1,   263,    -1,    -1,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      81,  3044,    -1,  1282,    85,    -1,    -1,  1286,  1287,    -1,
      -1,    -1,    -1,    -1,    -1,   341,    -1,    -1,    -1,    -1,
      -1,    -1,   103,  1302,    -1,  3735,    -1,    -1,   109,  1308,
      -1,  3074,    -1,    -1,    -1,  3745,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   124,    -1,  3088,    -1,    -1,    -1,  3092,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
    3103,    -1,   143,    -1,    -1,   341,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   155,    -1,    -1,    -1,    -1,    -1,
      -1,   162,    -1,    -1,    -1,   166,  1365,  3797,    -1,    -1,
      -1,    -1,  3802,    -1,    -1,    -1,    -1,    -1,  3808,    -1,
      -1,    -1,   183,    -1,    -1,    -1,    -1,    -1,   434,    -1,
      -1,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,  1400,    -1,    -1,    -1,   451,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,    -1,
      -1,    -1,    -1,    -1,    -1,  3865,    -1,    -1,   434,    -1,
      -1,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,    -1,    -1,    -1,    -1,   451,    -1,    -1,    -1,   260,
      -1,  1460,   263,    -1,  3894,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,
      -1,  1480,    -1,  3913,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1495,    -1,   299,    -1,
      -1,    -1,    -1,    -1,  1503,    -1,    -1,    -1,    -1,    -1,
    1509,    -1,    -1,    -1,    -1,  1514,   317,    -1,    -1,    -1,
      -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,   330,
      -1,  1530,   333,    -1,    -1,  1534,    -1,  3967,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1546,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   362,  1561,    -1,   365,   366,    -1,   368,   369,  1568,
      -1,    -1,    -1,    -1,    -1,  1574,    -1,   378,    -1,    -1,
      -1,  1580,   383,  3346,    -1,  3348,    -1,  1586,   389,    -1,
      -1,   392,  3355,    -1,   395,    -1,    -1,    -1,    -1,  1598,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   408,    -1,  3372,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1617,    -1,
    1619,  1620,    -1,    -1,  3387,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1632,    -1,  3398,    -1,  4067,    -1,  4069,
      -1,    -1,    -1,  1642,    -1,    -1,  1645,    -1,  1647,  1648,
      -1,  3414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1659,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3441,    -1,
      -1,    -1,    -1,    -1,    -1,  4115,    -1,    -1,    -1,  3452,
    3453,  3454,  1691,    -1,  3457,  3458,  3459,  3460,  3461,  3462,
      -1,    -1,    -1,    -1,  3467,  3468,    -1,  3470,  3471,  3472,
    3473,  3474,  3475,  3476,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3485,    -1,  3487,  3488,  1725,    -1,  1727,    -1,
      -1,    -1,    -1,  1732,  1733,    -1,    -1,    -1,    -1,    -1,
    1739,  1740,  1741,    -1,    -1,    -1,  1745,    -1,  1747,  1748,
    1749,  1750,  1751,  1752,    -1,  1754,    -1,  1756,  1757,    -1,
      -1,  1760,    -1,    -1,  3527,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1774,  1775,  1776,  1777,  1778,
    1779,    -1,    -1,    -1,  1783,    -1,    -1,    -1,  1787,    -1,
      -1,  1790,    -1,    -1,  1793,  1794,  1795,  1796,  1797,  1798,
    1799,  1800,  1801,    -1,  1803,    -1,    -1,    -1,  4238,    -1,
      -1,  1810,    -1,  1812,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3624,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3652,
    3653,  3654,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,  3664,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4354,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1939,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1988,
    4420,    -1,    -1,  1992,  1993,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2002,    -1,   175,    -1,  2006,  2007,    -1,
     180,    -1,  2011,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2019,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,    -1,    -1,    -1,  2037,    -1,
      -1,  2040,    -1,    -1,  4474,    -1,   216,    -1,  4478,  4479,
      -1,    -1,  2051,    -1,    -1,    -1,  2055,    -1,    -1,  2058,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2067,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,
    2079,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     260,    -1,    -1,   263,    -1,    -1,    -1,  2096,  2097,    -1,
      -1,    -1,    -1,    -1,   198,  2104,    -1,    -1,    -1,    -1,
    3873,    -1,    -1,   207,  3877,  3878,  3879,  3880,    -1,    -1,
    3883,    -1,   216,    -1,  2123,  2124,    -1,    -1,  2127,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4566,  4567,    -1,    -1,
      -1,  3904,  3905,  3906,  3907,    -1,  3909,  3910,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2155,    -1,  3921,  3922,
    2159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   341,    -1,    -1,    -1,    -1,  3939,    -1,  2177,    -1,
      -1,    -1,    -1,  3946,  3947,    -1,  3949,    -1,    -1,  2188,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2256,  2257,    -1,
      -1,    -1,    -1,    -1,   434,    -1,  2265,   437,   438,   439,
    4033,   441,   442,   443,   444,   445,   446,    -1,    -1,    -1,
      -1,   451,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
      -1,  4054,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,
      -1,  4084,    -1,    -1,    46,    -1,    -1,    -1,  2327,    -1,
      -1,    -1,  2331,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2340,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2393,  4158,    -1,    -1,    -1,  2398,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2429,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2445,    -1,    -1,   543,
      -1,    -1,  2451,   175,   548,    -1,    -1,    -1,   180,    -1,
    2459,    -1,    -1,    -1,  2463,    -1,    -1,  2466,    -1,    -1,
    2469,    -1,    -1,    -1,    -1,    -1,    -1,  4240,  2477,   201,
     202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2487,    -1,
      -1,    -1,    -1,  2492,   216,  4258,    -1,    -1,    -1,    -1,
    4263,  4264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2515,  2516,  2517,    -1,
      -1,  2520,    -1,    -1,    -1,   247,    -1,    -1,    -1,  2528,
    2529,  2530,  2531,    -1,    -1,    -1,    -1,  2536,   260,    -1,
      -1,   263,  2541,  2542,    -1,  2544,    -1,  2546,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4319,    -1,  2557,  2558,
      -1,    -1,  2561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2575,    -1,  2577,    -1,
    2579,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   197,    -1,    -1,   691,    -1,    -1,
    2599,   204,  4365,    -1,    -1,    -1,    -1,    -1,    -1,  4372,
      -1,  2610,   215,  2612,  2613,  2614,    -1,    -1,    -1,   341,
      -1,    -1,   716,    -1,    -1,    -1,    -1,     8,  2627,    -1,
      11,  2630,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,
      -1,   735,    -1,  2642,  4407,    -1,    -1,    -1,  2647,    -1,
      -1,    32,    -1,    -1,  2653,  4418,    -1,    -1,    -1,    40,
      -1,    -1,    -1,   757,  2663,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4440,    -1,    -1,
    2679,    -1,    -1,  2682,    -1,  2684,    -1,    -1,    -1,    70,
    2689,    -1,  2691,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4464,    -1,    -1,    -1,    -1,    -1,    -1,  2707,  2708,
    4473,    -1,   434,    -1,  2713,   437,   438,   439,    -1,   441,
     442,   443,   444,   445,   446,    -1,    -1,   449,    -1,    -1,
      -1,  4494,    -1,    -1,   828,  2734,    -1,    -1,  2737,    -1,
      -1,  2740,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2757,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   153,    -1,    -1,    -1,    -1,   158,    -1,    -1,
      -1,    -1,  2781,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   175,    -1,    -1,    -1,    -1,   180,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4574,  2811,  2812,  2813,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4596,   928,   216,  2835,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2844,    -1,  2846,  2847,    -1,
      -1,    -1,  2851,    -1,    -1,    -1,    -1,    -1,   952,   953,
     954,    -1,  2861,    -1,    -1,    -1,   247,    -1,  4631,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   260,
      -1,    -1,   263,  4646,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2905,    -1,  4671,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2924,    -1,    -1,    -1,    -1,
      -1,  2930,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2954,    -1,    -1,    -1,   562,
     341,  2960,  2961,    -1,   567,    -1,    -1,  2966,    -1,  2968,
      -1,    -1,    -1,    -1,    -1,   578,    -1,    -1,    -1,  4742,
      -1,  2980,    -1,  2982,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   594,    -1,    -1,    -1,  1089,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4767,    -1,   609,    -1,    -1,    -1,
      -1,    -1,   615,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3019,  1115,    -1,   626,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   634,    -1,    -1,    -1,    -1,    -1,  3036,  3037,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3050,    -1,   434,    -1,    -1,   437,   438,   439,    -1,
     441,   442,   443,   444,   445,   446,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3093,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3105,    -1,    -1,  3108,
      -1,    -1,    -1,    -1,    -1,    -1,   719,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3130,    -1,    -1,  3133,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3150,    -1,    -1,  3153,    -1,  1250,    -1,    -1,    -1,
    3159,    -1,    -1,    -1,    -1,    -1,  3165,    -1,  3167,    -1,
      -1,  3170,    -1,    -1,    -1,  3174,  3175,  3176,  3177,  3178,
      -1,    -1,  3181,  3182,  3183,  3184,  3185,  3186,  3187,  3188,
    3189,  3190,    -1,    -1,    -1,  3194,  3195,    -1,    -1,    -1,
    3199,    -1,    -1,    -1,  1298,  3204,    -1,    -1,    -1,  3208,
      -1,  3210,    -1,  3212,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3220,    -1,    -1,  3223,    -1,  3225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3233,  3234,    -1,    -1,  3237,  3238,
      -1,    -1,    -1,  3242,  3243,    -1,    -1,    -1,    -1,    -1,
    3249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3259,    -1,  3261,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3273,    -1,  1370,    -1,    -1,    -1,
    3279,  3280,  3281,  1377,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3305,    -1,    -1,    -1,
    1404,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1412,  3318,
      -1,  1415,    -1,    -1,    -1,  3324,    -1,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
    3339,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,
      16,    17,    -1,    -1,    -1,    -1,    -1,  1451,    -1,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,
      36,  1465,  3371,    71,    40,    -1,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,  1478,    -1,    -1,    85,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,   103,    -1,    -1,    -1,    -1,
      -1,    -1,  3411,    -1,    -1,    -1,    -1,  3416,  3417,  3418,
      -1,    -1,    -1,    -1,    -1,    -1,   124,  1030,    -1,    -1,
      -1,    -1,    -1,  1527,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   143,    -1,  1050,    -1,    -1,
      -1,   117,    -1,    -1,  1548,    -1,    -1,   155,    -1,  1062,
      -1,  1555,   160,    -1,    -1,    -1,    -1,  3466,   166,    -1,
    3469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   183,    -1,  1090,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1101,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3506,    -1,   175,
      -1,    -1,    -1,  1116,   180,    -1,  1119,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3528,
      -1,   229,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     216,    -1,  3551,  3552,    -1,    -1,  3555,    -1,    -1,    -1,
      -1,    -1,   260,  1657,    -1,  3564,    -1,  3566,    -1,    -1,
      -1,    -1,    -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   247,   280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   290,    -1,   260,    -1,    -1,   263,    -1,    -1,
      -1,  1695,  1696,    -1,    -1,  3604,  3605,  3606,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1712,   317,
      -1,    -1,    -1,    -1,   322,    -1,   324,    -1,    -1,    -1,
      -1,    -1,   330,  1236,    -1,   333,    -1,    -1,    -1,    -1,
      -1,  1244,  1245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3660,    -1,    -1,   362,    -1,    -1,   365,    -1,    -1,
      -1,   369,    -1,    -1,    -1,   341,    -1,    -1,   376,    -1,
     378,    -1,  3681,    -1,    -1,   383,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3692,    -1,    -1,    -1,   395,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1308,   197,    -1,    -1,    -1,
     408,    -1,    -1,   204,    -1,  1809,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3722,   215,  1819,    -1,    -1,    -1,    -1,
     396,    -1,    -1,  3732,  3733,    -1,  3735,    -1,    -1,    -1,
    3739,  3740,    -1,    -1,    -1,  3744,  3745,    -1,    -1,    -1,
    3749,    -1,    -1,  3752,  3753,    -1,    -1,    -1,  3757,    -1,
      -1,    -1,    -1,    -1,  3763,    -1,    -1,    -1,   434,    -1,
      -1,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,    -1,  3781,    -1,     8,    -1,  3785,    11,    -1,    -1,
      -1,    15,    16,    17,    -1,    -1,    -1,    -1,  3797,    -1,
      -1,    -1,    -1,  3802,    -1,    -1,    -1,    -1,    32,  3808,
      -1,    -1,    -1,    -1,    25,    -1,    40,    -1,    -1,    -1,
      -1,    -1,    46,    -1,  3823,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,
      -1,  1935,    -1,  1937,    -1,    -1,    70,    58,  3847,    -1,
      32,    -1,    -1,    -1,    -1,    -1,    -1,  1460,    40,    -1,
      71,    72,    -1,    -1,    46,    -1,  3865,    -1,    -1,    -1,
      81,    -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,
    1974,    -1,    -1,  3882,    -1,    -1,  3885,    -1,    70,    -1,
      -1,    -1,   103,    -1,    -1,  3894,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1509,    -1,    -1,  3908,
      -1,    -1,    -1,   124,  3913,    -1,    -1,    -1,    -1,    -1,
      -1,  3920,    -1,    -1,   135,    -1,    -1,  1530,    -1,  3928,
      -1,  1534,   143,    -1,    -1,    -1,    -1,    -1,    -1,  3938,
      -1,    -1,    -1,  1546,   155,    -1,    -1,    -1,    -1,   160,
      -1,   175,    -1,    -1,    -1,    -1,   180,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3967,    -1,
     152,    -1,   183,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3985,    -1,    -1,    -1,
      -1,    -1,   216,   175,    -1,    -1,    -1,   208,   180,    -1,
      -1,    -1,    -1,  4002,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4013,    -1,  1619,  1620,   229,   201,
     202,    -1,    -1,   247,    -1,    -1,  2120,    -1,    -1,  1632,
      -1,    -1,    -1,    -1,   216,    -1,   260,    -1,    -1,   263,
      -1,    -1,    -1,    -1,  1647,  1648,  2140,    -1,    -1,   260,
      -1,    -1,    -1,    -1,    -1,    -1,  1659,    -1,    -1,    -1,
     284,    -1,    -1,    -1,    -1,   247,    -1,    -1,  4067,   280,
    4069,   562,    -1,    -1,    -1,    -1,   567,    -1,   260,   290,
      -1,   263,    -1,    -1,    -1,    -1,    -1,   578,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4095,    -1,    -1,    -1,
     282,    -1,    -1,   594,    -1,    -1,   317,    -1,    -1,    -1,
      -1,   322,  4111,   324,    -1,    -1,  4115,   341,   609,   330,
      -1,  4120,   333,    -1,   615,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   357,    -1,   626,    -1,    -1,  4137,  4138,
      -1,    -1,  4141,   634,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   362,    -1,    -1,   365,    -1,  4155,    -1,   369,   341,
      -1,  4160,    -1,    -1,    -1,   376,  4165,   378,    -1,  4168,
    4169,    -1,   383,    -1,    -1,    -1,  1779,  4176,  4177,    -1,
      -1,  2275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4192,    -1,    -1,    -1,   408,    -1,    -1,
    4199,    -1,  4201,    -1,    -1,    -1,  4205,    -1,    -1,    -1,
     434,    -1,    -1,   437,   438,   439,    -1,   441,   442,   443,
     444,   445,   446,    -1,    -1,    -1,    -1,    -1,   719,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4238,
    4239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4248,
      -1,    -1,   434,    -1,    -1,   437,   438,   439,    -1,   441,
     442,   443,   444,   445,   446,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4285,    -1,  4287,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4299,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4352,    -1,  4354,    -1,    -1,    -1,  2453,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4381,  4382,    -1,  4384,    -1,  4386,   604,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2002,
      -1,    -1,    -1,  2006,  2007,    -1,    -1,    -1,  2011,   625,
     604,  4410,    -1,    -1,    -1,  4414,  2019,    -1,    -1,    -1,
      -1,  4420,    -1,    -1,    -1,    -1,  4425,    -1,    -1,     8,
      -1,   625,    11,    -1,  2037,    -1,    15,    16,    17,    -1,
      -1,    -1,    -1,    -1,    -1,  4444,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    46,    -1,  4468,
      -1,    -1,   175,    -1,    -1,  4474,  2079,   180,    -1,  4478,
    4479,    -1,    -1,    -1,  4483,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,  2096,  2097,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2603,
      -1,    -1,    -1,   216,    -1,    -1,    -1,    -1,    -1,    -1,
    2123,  2124,    -1,    -1,  2127,  4524,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1030,
      -1,    -1,    -1,    -1,   247,    -1,  4545,    -1,    -1,    -1,
      -1,    -1,  2155,    -1,    -1,    -1,  2159,   260,    -1,  1050,
     263,    -1,    -1,    -1,    -1,    -1,    -1,  4566,  4567,    -1,
      -1,  1062,    -1,    -1,  2177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2188,    -1,    -1,  4587,    -1,
      -1,  4590,    -1,    -1,    -1,    -1,   175,    -1,  2201,  1090,
    4599,   180,    -1,    -1,    -1,  4604,  2209,  4606,    -1,  4608,
    1101,    -1,    -1,    -1,    -1,    -1,  4615,    -1,    -1,    -1,
      -1,    -1,   201,   202,    -1,  1116,    -1,    -1,  1119,    -1,
      -1,    -1,    -1,    -1,  4633,    -1,    -1,   216,   341,    -1,
      -1,    -1,    -1,   713,   714,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4656,    -1,    -1,
      -1,    -1,  2265,    -1,    -1,    -1,    -1,    -1,   247,    -1,
      -1,    -1,    -1,    -1,   890,   745,    -1,    -1,    -1,    -1,
      -1,   260,    -1,    -1,   263,    -1,  4685,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   910,    -1,   890,    -1,    -1,   278,
      -1,    -1,    -1,   919,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4712,  4713,    -1,   910,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4723,   919,    -1,    -1,  2331,    -1,
      -1,   434,  4731,    -1,   437,   438,   439,    -1,   441,   442,
     443,   444,   445,   446,  4743,  1236,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1244,  1245,  2849,    -1,    -1,    -1,    -1,
      -1,    -1,   341,  1254,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,   995,
    4779,    -1,    -1,    -1,    -1,    -1,  4785,  4786,  4787,    32,
    2393,    -1,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,   995,    -1,    46,    -1,    -1,    -1,  4806,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1308,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2429,    70,    -1,    -1,
    4829,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2451,    -1,
      -1,    -1,    -1,    -1,    -1,   434,  2459,    -1,   437,   438,
     439,    -1,   441,   442,   443,   444,   445,   446,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2972,  2973,
      -1,    -1,    -1,  1099,    -1,    -1,  4885,  4886,    -1,    -1,
      -1,    -1,  4891,    -1,  2988,    -1,    -1,    -1,    -1,    -1,
    4899,    -1,    -1,    -1,    -1,  1099,    -1,    -1,    -1,    -1,
    3004,  4910,  4911,  4912,    -1,    -1,    -1,    -1,    -1,  3013,
    3014,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   175,  2536,    -1,    -1,  3030,   180,    -1,  2542,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1460,
      -1,    -1,    -1,   216,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   247,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   260,  1509,    -1,
     263,    -1,    -1,  1239,  2627,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3131,    -1,  1530,
      -1,    -1,    -1,  1534,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1546,    -1,    -1,    -1,    -1,
      -1,  1131,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1302,    32,  2691,    -1,
    1160,    -1,    -1,    -1,    -1,    40,    -1,    -1,   341,    -1,
      -1,    46,    -1,    -1,  2707,  2708,    -1,    -1,  1302,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1188,  1189,
    1190,    -1,  1192,    -1,    -1,    70,    -1,    -1,  1619,  1620,
      -1,  2734,    -1,    -1,  2737,    -1,    -1,    -1,    -1,    -1,
      -1,  1632,  1212,    -1,    -1,    -1,    -1,    -1,    -1,  1365,
      -1,    -1,    -1,    -1,    -1,    -1,  1647,  1648,    -1,    -1,
      -1,    -1,  3256,  3257,  3258,    -1,    -1,    -1,  1659,    -1,
      -1,  1365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1253,  1400,    -1,    -1,    -1,    -1,    -1,
      -1,   434,    -1,    -1,   437,   438,   439,    -1,   441,   442,
     443,   444,   445,   446,    -1,    -1,  1400,    -1,  2811,  2812,
    2813,    -1,  1282,   158,    -1,    -1,  1286,  1287,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     175,    -1,  2835,    -1,    -1,   180,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2847,    -1,    -1,    -1,  2851,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,  2861,    -1,
      -1,    -1,    -1,    -1,  1480,    -1,    -1,    -1,    -1,    -1,
      -1,   216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1495,
      -1,    -1,    -1,    -1,    -1,    -1,  1480,  1503,  1779,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1514,    -1,
      -1,  1495,   247,    -1,    -1,    -1,    -1,    -1,    -1,  1503,
      -1,    -1,    -1,    -1,    -1,   260,    -1,    -1,   263,    -1,
    1514,  2924,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1561,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2960,  1574,    -1,
      -1,    -1,    -1,  2966,    -1,  2968,    -1,  1561,    -1,    -1,
    1586,    -1,    -1,    -1,    -1,    -1,    -1,  2980,    -1,  2982,
    1574,    -1,  1598,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1586,    -1,    -1,    -1,   341,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1598,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1642,    -1,    -1,  1645,
    3524,    -1,    -1,  3036,    -1,    -1,    -1,    -1,    -1,    -1,
    3534,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1642,    -1,
      -1,  1645,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3569,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   434,
    3093,    -1,   437,   438,   439,    -1,   441,   442,   443,   444,
     445,   446,    -1,  3597,    -1,  3108,    -1,    -1,    -1,    -1,
      -1,  2002,    -1,    -1,    -1,  2006,  2007,    -1,    -1,    -1,
    2011,    -1,    -1,    -1,    -1,    -1,    -1,  3130,  2019,    -1,
    3133,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2037,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3651,  1774,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1774,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2079,     8,
      -1,    -1,    11,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    -1,    -1,    -1,    -1,  2096,  2097,  3210,    -1,    -1,
      -1,    -1,    -1,    32,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,
      -1,    -1,  2123,  2124,    -1,    -1,  2127,    -1,    -1,    -1,
     604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   625,  1732,    -1,  2155,    -1,    -1,    -1,  2159,    -1,
    3764,  3765,  3766,  3767,    -1,  1745,    -1,  1747,    -1,    -1,
    1750,  1751,  1752,   604,    -1,    -1,  2177,  1757,    -1,    -1,
    1760,    -1,    -1,    -1,    -1,    -1,    -1,  2188,    -1,    -1,
      -1,    -1,    -1,    -1,   625,  1775,  1776,  1777,  1778,    -1,
    2201,    -1,    -1,  1783,    -1,    -1,    -1,  1787,  2209,    -1,
    1790,    -1,    -1,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,    -1,  1803,    -1,    -1,    -1,    -1,    -1,    -1,
    1810,    -1,  1812,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   175,    -1,    -1,    -1,
      -1,   180,    -1,    -1,    -1,    -1,    -1,    -1,  3371,    -1,
      -1,    -1,  1988,    -1,  2265,    -1,  1992,  1993,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1988,    -1,    -1,   216,  1992,  1993,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3411,    -1,
      -1,    -1,    -1,  3416,    -1,  3418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2055,
    2331,   260,    -1,    -1,   263,    -1,    -1,    -1,    -1,    -1,
      -1,  2067,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2055,    -1,  3466,    -1,    -1,  3469,    -1,    -1,  1939,
      -1,    -1,    -1,  2067,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    15,    16,    17,    -1,  2104,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    32,  2393,  3506,    -1,    -1,    -1,    -1,    -1,    40,
    2104,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    -1,   341,    -1,    -1,    -1,   890,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2429,    70,
      -1,    -1,    -1,    -1,    -1,    -1,   910,    -1,  3551,  3552,
      -1,    -1,    -1,    -1,    -1,   919,    -1,    -1,    -1,    -1,
    2451,  3564,    -1,  3566,    -1,    -1,    -1,    -1,  2459,   890,
    2040,    -1,    -1,    -1,    -1,    -1,     8,    -1,  4072,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,   910,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   919,    -1,
      32,    -1,    -1,    35,    -1,    -1,    -1,    -1,    40,    -1,
      -1,    -1,    -1,    -1,    46,   434,    -1,    -1,   437,   438,
     439,    -1,   441,   442,   443,   444,   445,   446,    -1,    -1,
      -1,   995,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,  2257,    -1,    -1,   175,  2536,    -1,    -1,    -1,   180,
      -1,  2542,    -1,    -1,    -1,    -1,    -1,  3660,    -1,    -1,
      -1,    -1,    -1,  2257,    -1,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,   995,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   216,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2327,    -1,    -1,    -1,    -1,   247,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   260,
      -1,    -1,   263,  2327,    -1,  1099,  2627,    -1,    -1,    -1,
      -1,    -1,    -1,   175,    -1,    -1,    -1,    -1,   180,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1099,    -1,
      -1,    -1,    -1,    -1,   216,    -1,  2256,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2691,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4302,    -1,
     341,    -1,    -1,    -1,    -1,   247,  2707,  2708,    -1,    -1,
      -1,    -1,    -1,    -1,  4318,    -1,    -1,    -1,   260,  2445,
      -1,   263,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   370,
      -1,    -1,    -1,  2734,    -1,    -1,  2737,    -1,    -1,    -1,
    2466,  2445,    -1,    -1,    -1,    -1,    -1,  4351,    -1,    -1,
      -1,  2477,     8,    -1,    -1,    11,    -1,    -1,    -1,    15,
      16,    17,  2466,    -1,    -1,    -1,    -1,    -1,    -1,  3882,
      -1,    -1,  3885,  2477,    -1,    -1,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      46,    -1,    -1,   434,    -1,  3908,   437,   438,   439,   341,
     441,   442,   443,   444,   445,   446,    -1,  3920,    -1,    -1,
    2811,  2812,  2813,    -1,    70,    -1,    -1,    -1,  2398,    -1,
      -1,    -1,    -1,    -1,    -1,  3938,    -1,    -1,  1302,    -1,
     604,    -1,    -1,    -1,  2835,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2847,    -1,    -1,    -1,
    2851,   625,    -1,    -1,    -1,    -1,  4460,    -1,    -1,    -1,
    2861,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1302,  3985,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1365,   434,    -1,    -1,   437,   438,   439,    -1,   441,
     442,   443,   444,   445,   446,    -1,    -1,  2487,    -1,    -1,
      -1,    -1,  2492,    -1,    -1,    -1,    -1,    -1,    -1,   175,
      -1,    -1,    -1,  2924,   180,    -1,  1400,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1365,    -1,  4540,  2517,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,  2528,    -1,
    2530,  2531,    -1,  2679,    -1,    -1,  2682,    -1,  2684,  2960,
     216,  2541,    -1,  2689,  2544,  2966,  2546,  2968,    -1,  1400,
      -1,    -1,    -1,    -1,    -1,  2679,    -1,    -1,  2682,  2980,
    2684,  2982,  4095,    -1,    -1,  2689,    -1,    -1,    -1,    -1,
      -1,   247,    -1,    -1,    -1,  2575,    -1,  2577,    -1,  2579,
      -1,    -1,    -1,    -1,   260,    -1,  1480,   263,    -1,    -1,
      -1,    -1,    -1,    -1,  2740,    -1,    -1,    -1,    -1,    -1,
      -1,  1495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1503,
      -1,  2757,  2612,  2613,  2614,  3036,  2740,    -1,    -1,    -1,
    1514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1480,
    2630,    -1,    -1,  2757,    -1,  2781,    -1,    -1,    -1,    -1,
      -1,    -1,  2642,    -1,  1495,    -1,    -1,  2647,    -1,    -1,
      -1,    -1,  1503,  2653,    -1,    -1,    -1,  2781,    -1,    -1,
      -1,    -1,    -1,  1514,    -1,   341,  4199,  1561,  4201,    -1,
      -1,    -1,  3093,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1574,    -1,    -1,    -1,    -1,    -1,    -1,  3108,    -1,    -1,
      -1,    -1,  1586,    -1,    -1,    -1,   890,    -1,  2844,    -1,
    2846,    -1,    -1,    -1,  1598,    -1,  4239,    -1,    -1,  3130,
    1561,    -1,  3133,  2713,    -1,    -1,   910,    -1,    -1,    -1,
    2844,    -1,  2846,  1574,    -1,   919,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1586,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1598,  1642,    -1,
      -1,  1645,  4285,    -1,  4287,    -1,    -1,    -1,   434,  2905,
      -1,   437,   438,   439,    -1,   441,   442,   443,   444,   445,
     446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2905,    -1,    -1,  2930,    -1,    -1,    -1,    -1,  3210,
      -1,  1642,    -1,    -1,  1645,    -1,    -1,    -1,    -1,    -1,
      -1,   995,    -1,    -1,    -1,    -1,  2930,    -1,  2954,    -1,
      -1,    -1,    -1,    -1,    -1,  2961,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2954,    -1,    -1,    -1,    -1,    -1,    -1,  2961,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3019,    -1,    -1,    -1,    -1,    -1,    -1,
    1774,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3037,    -1,    -1,    -1,  3019,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3050,  1099,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3037,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1774,    -1,    -1,  3050,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3411,    -1,    -1,    -1,    -1,  3416,    -1,  3418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3153,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3174,  3153,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3466,    -1,    -1,  3469,   604,
    3174,    -1,    -1,  3199,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     625,    -1,    -1,    -1,    -1,  3199,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3506,    -1,  3233,    -1,    -1,
      -1,    -1,    -1,    -1,  1988,    -1,    -1,    -1,  1992,  1993,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1302,  3233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4656,    -1,    -1,    -1,    -1,    -1,    -1,
    3551,  3552,    -1,    -1,    -1,    -1,    -1,  1988,    -1,    -1,
      -1,  1992,  1993,  3564,    -1,  3566,    -1,    -1,    -1,    -1,
    3150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3159,
      -1,  2055,    -1,    -1,    -1,  3165,    -1,  3167,    -1,    -1,
      -1,  1365,    -1,  2067,    -1,    -1,    -1,    -1,  3324,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3194,  3195,    -1,    -1,  4731,    -1,
    3324,    -1,    -1,    -1,  2055,    -1,  1400,    -1,    -1,    -1,
    2104,    -1,  3212,    -1,    -1,    -1,  2067,    -1,    -1,    -1,
    3220,    -1,    -1,  3223,    -1,  3225,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3234,    -1,    -1,    -1,    -1,  3660,
      -1,    -1,  3242,  3243,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2104,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3417,    -1,  3273,    -1,    -1,    -1,    -1,    -1,  3279,
    3280,  3281,    -1,    -1,    -1,    -1,  1480,    -1,    -1,    -1,
      -1,    -1,    -1,  3417,    -1,    -1,  4829,    -1,    -1,    -1,
      -1,  1495,    -1,    -1,    -1,  3305,    -1,    -1,    -1,  1503,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3318,    -1,
    1514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   890,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   910,    -1,    -1,  4891,    -1,
      -1,    -1,    -1,  2257,   919,    -1,    -1,  1561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4910,    -1,    -1,
    1574,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1586,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1598,    -1,  2257,    -1,    -1,  3555,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3555,    -1,  2327,    -1,    -1,    -1,    -1,    -1,    -1,
     995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1642,    -1,
      -1,  1645,    -1,    -1,    -1,    -1,    -1,    -1,  3604,    -1,
      -1,  3882,    -1,    -1,  3885,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2327,    -1,    -1,    -1,
    3604,    -1,    -1,    -1,    -1,    -1,    -1,  3908,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3920,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3938,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1099,    -1,    -1,    -1,    -1,    -1,
      -1,  2445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3985,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1774,    -1,    -1,  2477,    -1,    -1,    -1,    -1,    -1,  3735,
      -1,    -1,    -1,    -1,  2445,    -1,    -1,    -1,    -1,  3745,
      -1,    -1,    -1,    -1,    -1,  3605,  3606,    -1,    -1,    -1,
      -1,  3735,    -1,    -1,    -1,  2466,    -1,    -1,    -1,    -1,
      -1,  3745,    -1,    -1,    -1,    -1,  2477,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4095,    -1,    -1,    -1,    -1,    -1,
      -1,  3681,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3692,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   604,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3865,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   625,    -1,    -1,
      -1,    -1,  3732,  3733,    -1,    -1,    -1,    -1,    -1,  3739,
    3740,  3865,    -1,    -1,  3744,    -1,    -1,  1302,  3894,  3749,
      -1,    -1,  3752,  3753,    -1,    -1,    -1,  3757,    -1,    -1,
      -1,    -1,    -1,  3763,    -1,    -1,    -1,  3913,    -1,    -1,
    3894,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4199,    -1,
    4201,    -1,    -1,    -1,    -1,  2679,    -1,    -1,  2682,  3913,
    2684,    -1,    -1,    -1,  1988,  2689,    -1,  3797,  1992,  1993,
      -1,    -1,  3802,    -1,    -1,    -1,    -1,    -1,  3808,    -1,
    1365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4239,    -1,
      -1,  3967,    -1,  3823,    -1,    -1,    -1,    -1,  2679,    -1,
      -1,  2682,    -1,  2684,    -1,    -1,    -1,    -1,  2689,    -1,
      -1,    -1,    -1,  3967,    -1,  1400,  2740,  3847,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2055,    -1,  2757,  4285,    -1,  4287,    -1,    -1,    -1,
      -1,    -1,    -1,  2067,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2781,    -1,  2740,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2757,    -1,    -1,    -1,
    2104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4069,    -1,  1480,    -1,    -1,  3928,    -1,
    2781,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1495,    -1,    -1,    -1,    -1,  4069,    -1,    -1,  1503,    -1,
    2844,    -1,  2846,    -1,    -1,    -1,    -1,    -1,    -1,  1514,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4115,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4115,   890,  2844,    -1,  2846,    -1,    -1,    -1,    -1,
      -1,    -1,  4002,    -1,    -1,    -1,  1561,    -1,    -1,    -1,
      -1,  2905,   910,    -1,    -1,    -1,    -1,    -1,    -1,  1574,
      -1,   919,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1586,    -1,    -1,    -1,    -1,  2930,    -1,    -1,    -1,
      -1,    -1,    -1,  1598,    -1,    -1,    -1,  4468,    -1,    -1,
      -1,    -1,    -1,    -1,  2905,    -1,    -1,    -1,    -1,    -1,
    2954,    -1,    -1,  2257,    -1,    -1,    -1,  2961,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2930,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1642,    -1,    -1,
    1645,    -1,  4238,    -1,    -1,    -1,    -1,   995,    -1,    -1,
      -1,    -1,    -1,  2954,    -1,    -1,    -1,    -1,    -1,    -1,
    2961,    -1,    -1,    -1,  4238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3019,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2327,    -1,    -1,    -1,  4137,  4138,    -1,
      -1,  4141,    -1,  3037,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3050,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3019,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4176,  4177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3037,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3050,
      -1,  1099,    -1,    -1,    -1,    -1,    -1,    -1,  4354,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1774,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4354,    -1,    -1,    -1,    -1,  4656,  4382,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2445,    -1,    -1,    -1,    -1,    -1,    -1,  4382,  3153,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2466,    -1,  4420,    -1,    -1,    -1,    -1,    -1,
    3174,    -1,    -1,  2477,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4420,    -1,    -1,    -1,
      -1,    -1,  3153,    -1,    -1,  3199,    -1,    -1,    -1,    -1,
    4731,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3174,    -1,    -1,    -1,    -1,  4474,    -1,
      -1,    -1,  4478,  4479,    -1,    -1,    -1,    -1,    -1,  3233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3199,    -1,
    4474,    -1,    -1,    -1,  4478,  4479,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3233,    -1,  4384,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1302,    -1,    -1,    -1,  4829,    -1,
    4410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4567,    -1,    -1,    -1,  4425,    -1,    -1,    -1,    -1,
    3324,    -1,    -1,  1988,    -1,    -1,    -1,  1992,  1993,    -1,
      -1,    -1,    -1,  4567,  4444,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1365,    -1,    -1,
    4891,    -1,    -1,  3324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4483,    -1,  2679,    -1,    -1,  2682,  4910,
    2684,    -1,    -1,    -1,    -1,  2689,    -1,    -1,    -1,    -1,
    2055,    -1,  1400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2067,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3417,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4545,  2740,    -1,    -1,  2104,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2757,    -1,    -1,  3417,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1480,    -1,    -1,    -1,    -1,  2781,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1495,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1503,  1204,    -1,  4608,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1514,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4633,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2844,    -1,  2846,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3555,    -1,  1561,    -1,    -1,    -1,    -1,    -1,  1267,
      -1,    -1,    -1,    -1,    -1,    -1,  1574,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1586,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1598,    -1,  2257,    -1,  3555,    -1,    -1,    -1,    -1,    -1,
    3604,  2905,  4712,  4713,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4723,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2930,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1642,    -1,    -1,  1645,    -1,    -1,
      -1,    -1,    -1,  3604,    -1,    -1,    -1,    -1,    -1,    -1,
    2954,    -1,    -1,    -1,    -1,    -1,    -1,  2961,    -1,    -1,
      -1,    -1,  2327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4787,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4806,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3019,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3735,    -1,  3037,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3745,    -1,    -1,    -1,    -1,  3050,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1774,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3735,  4885,  4886,    -1,    -1,    -1,
    2445,    -1,    -1,    -1,  3745,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3153,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3865,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3894,    -1,    -1,    -1,    -1,  3199,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3865,    -1,    -1,    -1,    -1,  3913,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3233,
      -1,    -1,    -1,  3894,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1655,    -1,    -1,
      -1,    -1,  3913,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3967,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1988,    -1,    -1,    -1,  1992,  1993,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3967,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2679,    -1,    -1,  2682,    -1,  2684,
    3324,    -1,  1730,    -1,  2689,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1744,    -1,    -1,    -1,
    1748,    -1,    -1,    -1,    -1,    -1,    -1,  2055,    -1,    -1,
      -1,    -1,    -1,    -1,  1762,  1763,  1764,    -1,  1766,  2067,
      -1,    -1,    -1,    -1,    -1,  4069,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2740,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2757,    -1,    -1,    -1,  2104,    -1,    -1,    -1,
    1808,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4069,    -1,
      -1,  4115,    -1,  3417,    -1,    -1,  2781,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1845,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4115,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2844,
      -1,  2846,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4238,    -1,    -1,    -1,    -1,    -1,
    2905,  1949,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2257,
      -1,  3555,    -1,  1961,    -1,    -1,  1964,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2930,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2954,
      -1,    -1,    -1,    -1,    -1,    -1,  2961,    -1,    -1,    -1,
    3604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2327,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4354,    -1,    -1,    -1,  3019,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3037,    -1,    -1,    -1,    -1,    -1,  4382,    -1,
      -1,    -1,    -1,    -1,    -1,  3050,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4354,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4420,    -1,    -1,    -1,
      -1,  4382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3735,    -1,    -1,    -1,    -1,    -1,  2445,    -1,    -1,
      -1,  3745,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2466,  4420,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2477,
    4474,    -1,    -1,    -1,  4478,  4479,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3153,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3174,
      -1,    -1,    -1,  4474,    -1,    -1,    -1,  4478,  4479,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3199,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3865,    -1,  4567,    -1,    -1,    -1,    -1,  3233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3894,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4567,    -1,    -1,  3913,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3324,
      -1,    -1,    -1,  3967,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2679,    -1,    -1,  2682,    -1,  2684,    -1,    -1,    -1,
      -1,  2689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2740,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2757,
      -1,    -1,  3417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4069,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2781,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2510,    -1,  2512,    -1,    -1,  2515,  2516,    -1,
    2518,  4115,  2520,    -1,    -1,    -1,  2524,    -1,    -1,  2527,
      -1,    -1,    -1,    -1,  2532,    -1,    -1,    -1,    -1,    -1,
    2538,    -1,    -1,    -1,    -1,  2543,  2844,    -1,  2846,    -1,
      -1,    -1,  2550,  2551,  2552,  2553,    -1,    -1,    -1,  2557,
    2558,    -1,  2560,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2572,    -1,  2574,    -1,    -1,    -1,
      -1,    -1,    -1,  2581,  2582,  2583,  2584,  2585,  2586,  2587,
    2588,  2589,  2590,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3555,    -1,    -1,    -1,    -1,    -1,    -1,  2905,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2618,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2930,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4238,    -1,    -1,    -1,    -1,  3604,
      -1,    -1,    -1,    -1,    -1,    -1,  2954,    -1,    -1,    -1,
      -1,    -1,    -1,  2961,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3019,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2728,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3037,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3050,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3735,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4382,    -1,
    3745,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4420,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3153,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3174,    -1,    -1,    -1,
    4474,    -1,    -1,    -1,  4478,  4479,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3199,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3865,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3233,    -1,    -1,    -1,  3894,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3913,  2957,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4567,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3324,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3096,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4069,    -1,    -1,    -1,    -1,  3417,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3149,    -1,    -1,    -1,    -1,    -1,  3155,    -1,    -1,
    4115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3171,  3172,    -1,    -1,  3175,  3176,  3177,
    3178,    -1,    -1,  3181,  3182,  3183,  3184,  3185,  3186,  3187,
    3188,  3189,  3190,  3191,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3213,    -1,    -1,  3216,    -1,
    3218,    -1,    -1,  3221,  3222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3236,  3237,
    3238,  3239,    -1,  3241,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3555,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3299,    -1,    -1,    -1,    -1,  3604,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3336,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4354,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4382,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3735,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3745,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4420,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4474,
      -1,    -1,    -1,  4478,  4479,    -1,    -1,    -1,    -1,    -1,
    3528,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3865,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3894,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4567,    -1,    -1,  3913,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3967,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3682,    -1,    -1,    -1,  3686,  3687,
    3688,    -1,    -1,    -1,    -1,    -1,  3694,  3695,  3696,  3697,
      -1,    -1,    -1,    -1,  3702,  3703,  3704,  3705,  3706,  3707,
    3708,  3709,  3710,  3711,  3712,  3713,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3738,    -1,    -1,  3741,    -1,  3743,    -1,    -1,    -1,  3747,
      -1,    -1,  3750,  3751,    -1,    -1,  3754,  3755,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4069,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3799,    -1,    -1,    -1,    -1,    -1,    -1,  3806,  3807,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4115,    -1,    -1,
      -1,    -1,    -1,    -1,  3822,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4005,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4354,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4064,  4065,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4382,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4105,    -1,    -1,
      -1,    -1,  4110,  4111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4420,    -1,    -1,    -1,    -1,  4125,    -1,  4127,
      -1,    -1,    -1,  4131,  4132,  4133,    -1,    -1,  4136,    -1,
      -1,  4139,  4140,    -1,    -1,    -1,  4144,    -1,    -1,    -1,
    4148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4474,    -1,    -1,    -1,
    4478,  4479,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4203,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4567,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4304,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4380,  4381,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4396,  4397,
    4398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4432,  4433,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4579,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4595,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4645,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4684,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4741,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4790,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
    4858,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
    4898,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,    -1,   159,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,    -1,    -1,    -1,    -1,    -1,    -1,   441,
     442,   443,    -1,    -1,    -1,    -1,    -1,    -1,   450,   451,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,    -1,   149,   150,   151,   152,
      -1,   154,    -1,   156,   157,    -1,   159,   160,   161,   162,
      -1,   164,   165,    -1,   167,   168,    -1,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,    -1,   212,
     213,   214,   215,   216,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,    -1,   257,    -1,    -1,   260,   261,   262,
      -1,    -1,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,   409,   410,    -1,    -1,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,    -1,   436,    -1,    -1,    -1,    -1,   441,   442,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,   451,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,    -1,   159,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,    -1,    -1,    -1,    -1,    -1,    -1,   441,   442,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   450,   451,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,    -1,   159,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,   214,
     215,   216,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
      -1,    -1,    -1,    -1,    -1,    -1,   441,   442,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   450,   451,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,    -1,   159,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,    -1,
      -1,     3,    -1,    -1,    -1,   441,   442,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   450,   451,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,    -1,    -1,   159,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,    -1,
      -1,   203,   204,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,    -1,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,    -1,   245,   246,    -1,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,    -1,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,    -1,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   451,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    -1,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,    -1,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
      -1,   159,   160,   161,   162,    -1,   164,    -1,    -1,    -1,
     168,    -1,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,    -1,   212,    -1,   214,   215,   216,    -1,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,    -1,    -1,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,    -1,   282,    -1,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
      -1,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,    -1,
     378,    -1,    -1,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   431,   432,   433,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,   451,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      -1,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,   157,    -1,
     159,   160,   161,   162,    -1,   164,    -1,    -1,    -1,   168,
      -1,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,    -1,   212,    -1,   214,   215,   216,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,    -1,    -1,   245,   246,   247,   248,
      -1,    -1,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,    -1,   282,    -1,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
      -1,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,    -1,   378,
      -1,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,   431,   432,   433,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,   451,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,    -1,   159,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,   409,
     410,    -1,    -1,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,    -1,   436,    -1,    -1,    -1,
      -1,   441,   442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     450,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,    -1,   159,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,   409,   410,    -1,
      -1,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,    -1,   436,    -1,    -1,    -1,    -1,   441,
     442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,    -1,    -1,    -1,    -1,    -1,    -1,   441,   442,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   450,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,    -1,   159,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,    -1,
      -1,    -1,    -1,    -1,    -1,   441,   442,    -1,    -1,    -1,
      -1,    -1,   448,   449,   450,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
      -1,   159,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,    -1,    -1,    -1,
      -1,    -1,    -1,   441,   442,   443,    -1,    -1,    -1,    -1,
      -1,    -1,   450,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,    -1,   159,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,    -1,    -1,    -1,    -1,    -1,
      -1,   441,   442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     450,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,    -1,   159,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,    -1,    -1,    -1,    -1,    -1,    -1,   441,
     442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,    -1,    -1,    -1,    -1,    -1,    -1,   441,   442,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   450,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,    -1,   159,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,    -1,
      -1,    -1,    -1,    -1,    -1,   441,   442,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   450,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
      -1,   159,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,    -1,    -1,    -1,
      -1,    -1,    -1,   441,   442,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   450,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,    -1,   159,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,    -1,    -1,    -1,    -1,    -1,
      -1,   441,   442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     450,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,    -1,   159,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,    -1,    -1,    -1,    -1,    -1,    -1,   441,
     442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,    -1,   159,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,    -1,    -1,    -1,    -1,    -1,    -1,   441,   442,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   450,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,    -1,   159,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,    -1,
      -1,    -1,    -1,    -1,    -1,   441,   442,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   450,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
      -1,   159,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,    -1,    -1,    -1,
      -1,    -1,    -1,   441,   442,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   450,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,    -1,   159,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,    -1,    -1,    -1,    -1,    -1,
      -1,   441,   442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     450,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,    -1,   159,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,    -1,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   441,
     442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,    -1,   159,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,
     204,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,    -1,    -1,    -1,    -1,    -1,    -1,   441,   442,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   450,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,    -1,   159,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,    -1,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   441,   442,    -1,    -1,     3,
       4,     5,     6,     7,   450,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,    -1,   159,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,     3,     4,     5,     6,     7,    -1,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,   450,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,   157,    -1,   159,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,   214,   215,   216,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,   450,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,    -1,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
      -1,   159,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,    -1,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,    -1,    -1,   203,   204,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,     3,    -1,
      -1,    -1,    -1,   441,   442,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   450,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,    -1,   159,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,    -1,   212,   213,   214,
     215,   216,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,   246,   247,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,   259,   260,   261,   262,    -1,    -1,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,   409,   410,    -1,    -1,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,   436,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   450,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,   157,    -1,   159,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
      -1,   212,   213,   214,   215,   216,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,   246,   247,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,   259,   260,
     261,   262,    -1,    -1,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
      -1,   159,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,    -1,   245,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   450,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,    -1,   159,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,   214,
     215,   216,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,   246,   247,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,     3,     4,     5,    -1,    -1,    -1,     9,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   450,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,    -1,   159,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,    -1,   245,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,   258,    -1,   260,   261,
     262,    -1,    -1,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,     3,    -1,    -1,    -1,    -1,   441,
     442,   443,    -1,    -1,    -1,    -1,    -1,    -1,   450,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,   157,    -1,
     159,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,   214,   215,   216,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,   246,   247,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
     409,   410,    -1,    -1,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   450,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    -1,    -1,
      -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,    -1,   159,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,   214,
     215,   216,    -1,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,   246,   247,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   450,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,    -1,   245,   246,    -1,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,    -1,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,    -1,   407,   408,   409,   410,    -1,
      -1,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,    -1,
      -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,    -1,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,   243,    -1,   245,   246,    -1,
     248,    -1,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,    -1,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,    -1,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   450,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
      -1,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,    -1,
     215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,    -1,   240,   241,   242,   243,    -1,
     245,   246,    -1,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,    -1,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,    -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   450,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,    -1,   245,   246,    -1,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,    -1,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,    -1,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,
      -1,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,    -1,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      -1,   240,   241,   242,   243,    -1,   245,   246,    -1,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,    -1,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,    -1,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    -1,    -1,    -1,
      -1,   450,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,    -1,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
      -1,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,    -1,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,   432,
     433,    -1,     3,    -1,   437,   438,   439,     8,   441,   442,
     443,   444,   445,   446,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,    -1,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,    -1,   245,   246,    -1,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,    -1,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,    -1,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,    -1,     3,    -1,   437,   438,   439,     8,
     441,   442,   443,   444,   445,   446,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,
      -1,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,    -1,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      -1,   240,   241,   242,   243,    -1,   245,   246,    -1,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,    -1,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,    -1,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,     3,    -1,   437,   438,
     439,     8,   441,   442,   443,   444,   445,   446,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
      -1,   118,   119,   120,    -1,    -1,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,    -1,   154,    -1,   156,
      -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,
     167,   168,    -1,   170,   171,   172,   173,   174,    -1,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
      -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,
      -1,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,    -1,   240,   241,   242,   243,    -1,   245,   246,
      -1,   248,    -1,   250,   251,   252,   253,   254,   255,    -1,
     257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,    -1,   365,   366,
     367,   368,   369,    -1,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,
     397,   398,   399,   400,   401,   402,   403,    -1,   405,    -1,
     407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,    -1,     3,    -1,
     437,   438,   439,     8,   441,   442,   443,   444,   445,   446,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
      -1,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,    -1,
     215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,    -1,   240,   241,   242,   243,    -1,
     245,   246,    -1,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,    -1,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,    -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
       3,    -1,   437,   438,   439,     8,   441,   442,   443,   444,
     445,   446,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
      -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,
      -1,   164,   165,    -1,   167,   168,    -1,   170,   171,   172,
     173,   174,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,
     203,    -1,   205,   206,   207,   208,   209,    -1,    -1,   212,
     213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,    -1,   240,   241,   242,
     243,    -1,   245,   246,    -1,   248,    -1,   250,   251,   252,
     253,   254,   255,    -1,   257,    -1,    -1,   260,   261,   262,
      -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,    -1,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,    -1,    -1,   390,   391,   392,
     393,   394,    -1,    -1,   397,   398,   399,   400,   401,   402,
     403,    -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,    -1,     3,    -1,   437,   438,   439,     8,   441,   442,
     443,   444,   445,   446,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,    -1,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,    -1,   245,   246,    -1,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,    -1,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,    -1,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,    -1,     3,    -1,   437,   438,   439,     8,
     441,   442,   443,   444,   445,   446,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,
      -1,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,    -1,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      -1,   240,   241,   242,   243,    -1,   245,   246,    -1,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,    -1,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,    -1,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     3,    -1,    -1,   437,   438,
     439,    -1,   441,   442,   443,   444,   445,   446,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   443,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
      -1,   118,   119,   120,    -1,    -1,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,    -1,   154,    -1,   156,
      -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,
     167,   168,    -1,   170,   171,   172,   173,   174,    -1,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
      -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,
      -1,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,    -1,   240,   241,   242,   243,    -1,   245,   246,
      -1,   248,    -1,   250,   251,   252,   253,   254,   255,    -1,
     257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,    -1,   365,   366,
     367,   368,   369,    -1,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,
     397,   398,   399,   400,   401,   402,   403,    -1,   405,    -1,
     407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   443,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    -1,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
      -1,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,    -1,   159,   160,   161,   162,    -1,   164,    -1,
      -1,    -1,   168,    -1,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,    -1,   212,    -1,   214,   215,
     216,    -1,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,    -1,    -1,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,    -1,   282,    -1,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,    -1,   378,    -1,    -1,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,   390,   391,   392,   393,   394,    -1,
      -1,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,   431,   432,   433,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   443,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    -1,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,    -1,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,    -1,   159,
     160,   161,   162,    -1,   164,    -1,    -1,    -1,   168,    -1,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,    -1,   212,    -1,   214,   215,   216,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,    -1,   282,    -1,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,    -1,   378,    -1,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,   431,   432,   433,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   443,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,    -1,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
      -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,   243,
      -1,   245,   246,    -1,   248,    -1,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
      -1,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,   391,   392,   393,
     394,    -1,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       3,     4,     5,    -1,    -1,    -1,     9,    -1,    -1,   443,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,    -1,   149,   150,   151,   152,
      -1,   154,    -1,   156,   157,    -1,   159,   160,   161,   162,
      -1,   164,   165,    -1,   167,   168,    -1,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,    -1,   212,
     213,   214,   215,   216,    -1,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,    -1,   245,   246,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,    -1,   257,   258,    -1,   260,   261,   262,
      -1,    -1,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,    -1,    -1,   390,   391,   392,
     393,   394,    -1,    -1,   397,   398,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,   409,   410,    -1,    -1,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     3,     4,     5,    -1,    -1,    -1,     9,   441,   442,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,    -1,   159,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,    -1,   245,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,   258,    -1,   260,   261,
     262,    -1,    -1,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     3,     4,     5,    -1,    -1,    -1,     9,   441,
     442,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,   157,    -1,   159,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,   214,   215,   216,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,   246,   247,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,   258,    -1,   260,
     261,   262,    -1,    -1,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     3,    -1,     5,    -1,    -1,    -1,     9,
     441,   442,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,    -1,   159,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,    -1,   245,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,    -1,   257,   258,    -1,
     260,   261,   262,    -1,    -1,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,
       9,   441,   442,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,    -1,   158,
      -1,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      -1,   240,   241,   242,   243,    -1,   245,   246,    -1,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,    -1,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,    -1,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     3,     4,     5,    -1,    -1,
      -1,     9,   441,   442,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,    -1,   159,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,   214,
     215,   216,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,   246,   247,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     3,
      -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,    -1,   159,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,    -1,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
      -1,   245,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,   255,    -1,   257,   258,    -1,   260,   261,   262,    -1,
      -1,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,   391,   392,   393,
     394,    -1,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
      -1,   154,    -1,   156,   157,    -1,   159,   160,   161,   162,
      -1,   164,   165,    -1,   167,   168,    -1,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,    -1,   212,
     213,   214,   215,   216,    -1,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,    -1,   245,   246,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,    -1,   257,    -1,    -1,   260,   261,   262,
      -1,    -1,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,    -1,    -1,   390,   391,   392,
     393,   394,    -1,    -1,   397,   398,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,   409,   410,    -1,    -1,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,    -1,   159,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,    -1,   245,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    -1,    -1,    -1,    96,    -1,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,   157,    -1,   159,   160,
     161,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,   214,   215,   216,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,   246,   247,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,    -1,   159,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,    -1,   245,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,   157,    -1,
     159,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,   214,   215,   216,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,   246,   247,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
      -1,   159,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,    -1,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,    -1,   245,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,
      -1,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
      -1,   118,   119,   120,    -1,    -1,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,    -1,   154,    -1,   156,
     157,    -1,   159,   160,   161,   162,    -1,   164,   165,    -1,
     167,   168,    -1,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
      -1,   198,    -1,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,    -1,   212,   213,   214,   215,   216,
      -1,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,    -1,   245,   246,
     247,   248,    -1,   250,   251,   252,   253,   254,   255,    -1,
     257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,    -1,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,
     397,   398,   399,   400,   401,   402,   403,    -1,   405,   406,
     407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,    -1,   159,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,    -1,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,    -1,   245,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,   390,   391,   392,   393,   394,    -1,
      -1,   397,   398,   399,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    -1,    -1,
      -1,    96,    -1,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,    -1,   159,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,   214,
     215,   216,    -1,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,   246,   247,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     3,
      -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,    -1,   159,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,    -1,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
      -1,   245,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,   391,   392,   393,
     394,    -1,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,   406,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
      -1,   154,    -1,   156,   157,    -1,   159,   160,   161,   162,
      -1,   164,   165,    -1,   167,   168,    -1,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,    -1,   212,
     213,   214,   215,   216,    -1,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,    -1,   245,   246,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,    -1,   257,    -1,    -1,   260,   261,   262,
      -1,    -1,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,    -1,    -1,   390,   391,   392,
     393,   394,    -1,    -1,   397,   398,   399,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,   409,   410,    -1,    -1,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,    -1,   159,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,    -1,   245,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,   157,    -1,   159,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,   214,   215,   216,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,   246,   247,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,    -1,   159,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,    -1,   245,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,   157,    -1,
     159,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,   214,   215,   216,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,   246,   247,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,   406,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    71,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,   157,
      -1,   159,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,    -1,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,    -1,   245,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,   406,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    -1,    -1,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
      -1,   118,   119,   120,    -1,    -1,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,
     167,   168,    -1,   170,   171,   172,   173,   174,    -1,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
      -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,
      -1,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,    -1,   240,   241,   242,   243,    -1,   245,   246,
      -1,   248,    -1,   250,   251,   252,   253,   254,   255,    -1,
     257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,    -1,   365,   366,
     367,   368,   369,    -1,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,    -1,    -1,
     397,   398,   399,   400,   401,   402,   403,    -1,   405,    -1,
     407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,    -1,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,    -1,   215,
     216,    -1,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,    -1,   245,
     246,    -1,   248,    -1,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,    -1,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,    -1,
      -1,   397,   398,   399,   400,   401,   402,   403,    -1,   405,
      -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    88,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,    -1,    -1,    -1,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
      -1,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,    -1,
     215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,    -1,   240,   241,   242,   243,    -1,
     245,   246,    -1,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,    -1,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,    -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,    -1,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
      -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,   243,
      -1,   245,   246,    -1,   248,    -1,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
      -1,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,   391,   392,   393,
     394,    -1,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,    -1,    -1,   160,   161,   162,
      -1,   164,   165,    -1,   167,   168,    -1,   170,   171,   172,
     173,   174,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,
     203,    -1,   205,   206,   207,   208,   209,    -1,    -1,   212,
     213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,    -1,   240,   241,   242,
     243,    -1,   245,   246,    -1,   248,    -1,   250,   251,   252,
     253,   254,   255,    -1,   257,    -1,    -1,   260,   261,   262,
      -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,    -1,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,    -1,    -1,   397,   398,   399,   400,   401,   402,
     403,    -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,    -1,   245,   246,    -1,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,    -1,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,    -1,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,    -1,    -1,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,    -1,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,    -1,   245,   246,    -1,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,    -1,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,    -1,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,    -1,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,   243,    -1,   245,   246,    -1,   248,    -1,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,    -1,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,    -1,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,
      -1,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,    -1,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      -1,   240,   241,   242,   243,    -1,   245,   246,    -1,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
     259,   260,   261,   262,    -1,    -1,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,    -1,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,    -1,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,    -1,
      -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,    -1,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,   243,    -1,   245,   246,    -1,
     248,    -1,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,    -1,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,    -1,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
      -1,   118,   119,   120,    -1,    -1,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,    -1,   154,    -1,   156,
      -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,
     167,   168,    -1,   170,   171,   172,   173,   174,    -1,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
      -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,
      -1,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,    -1,   240,   241,   242,   243,    -1,   245,   246,
      -1,   248,    -1,   250,   251,   252,   253,   254,   255,    -1,
     257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,    -1,   365,   366,
     367,   368,   369,    -1,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,    -1,   405,    -1,
     407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,    -1,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,    -1,   215,
      -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,    -1,   245,
     246,    -1,   248,    -1,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,    -1,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,    -1,   405,
      -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
      -1,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,    -1,
     215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,    -1,   240,   241,   242,   243,    -1,
     245,   246,    -1,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,    -1,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,    -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,    -1,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
      -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,   243,
      -1,   245,   246,    -1,   248,    -1,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
      -1,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,   391,   392,   393,
     394,    -1,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
      -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,
      -1,   164,   165,    -1,   167,   168,    -1,   170,   171,   172,
     173,   174,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,
     203,    -1,   205,   206,   207,   208,   209,    -1,    -1,   212,
     213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,    -1,   240,   241,   242,
     243,    -1,   245,   246,    -1,   248,    -1,   250,   251,   252,
     253,   254,   255,    -1,   257,    -1,    -1,   260,   261,   262,
      -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,    -1,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,    -1,    -1,   390,   391,   392,
     393,   394,    -1,    -1,   397,   398,   399,   400,   401,   402,
     403,    -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,    -1,   245,   246,    -1,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,    -1,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,    -1,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,    -1,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,    -1,   245,   246,    -1,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,   259,   260,
     261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,    -1,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,    -1,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,    -1,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,   243,    -1,   245,   246,    -1,   248,    -1,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,    -1,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,    -1,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,
      -1,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,    -1,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      -1,   240,   241,   242,   243,    -1,   245,   246,    -1,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,    -1,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,    -1,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,    -1,
      -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,    -1,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,   243,    -1,   245,   246,    -1,
     248,    -1,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,    -1,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,    -1,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
      -1,   118,   119,   120,    -1,    -1,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,    -1,   154,    -1,   156,
      -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,
     167,   168,    -1,   170,   171,   172,   173,   174,    -1,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
      -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,
      -1,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,    -1,   240,   241,   242,   243,    -1,   245,   246,
      -1,   248,    -1,   250,   251,   252,   253,   254,   255,    -1,
     257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,    -1,   365,   366,
     367,   368,   369,    -1,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,
     397,   398,   399,   400,   401,   402,   403,    -1,   405,    -1,
     407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,    -1,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,    -1,   215,
      -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,    -1,   245,
     246,    -1,   248,    -1,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,   259,   260,   261,   262,    -1,    -1,   265,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,    -1,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,   390,   391,   392,   393,   394,    -1,
      -1,   397,   398,   399,   400,   401,   402,   403,    -1,   405,
      -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
      -1,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,    -1,
     215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,    -1,   240,   241,   242,   243,    -1,
     245,   246,    -1,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,    -1,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,    -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,    -1,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
      -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,   243,
      -1,   245,   246,    -1,   248,    -1,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
      -1,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,   391,   392,   393,
     394,    -1,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
      -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,
      -1,   164,   165,    -1,   167,   168,    -1,   170,   171,   172,
     173,   174,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,
     203,    -1,   205,   206,   207,   208,   209,    -1,    -1,   212,
     213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,    -1,   240,   241,   242,
     243,    -1,   245,   246,    -1,   248,    -1,   250,   251,   252,
     253,   254,   255,    -1,   257,    -1,    -1,   260,   261,   262,
      -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,    -1,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,    -1,    -1,   390,   391,   392,
     393,   394,    -1,    -1,   397,   398,   399,   400,   401,   402,
     403,    -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,    -1,   245,   246,    -1,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,    -1,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,    -1,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    35,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,    -1,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,    -1,   245,   246,    -1,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,    -1,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,    -1,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,    -1,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,   243,    -1,   245,   246,    -1,   248,    -1,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,    -1,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,    -1,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,
      -1,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,    -1,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      -1,   240,   241,   242,   243,    -1,   245,   246,    -1,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,    -1,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,    -1,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,    -1,
      -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,    -1,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,   243,    -1,   245,   246,    -1,
     248,    -1,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,    -1,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,    -1,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
      -1,   118,   119,   120,    -1,    -1,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,    -1,   154,    -1,   156,
      -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,
     167,   168,    -1,   170,   171,   172,   173,   174,    -1,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
      -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,
      -1,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,    -1,   240,   241,   242,   243,    -1,   245,   246,
      -1,   248,    -1,   250,   251,   252,   253,   254,   255,    -1,
     257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,    -1,   365,   366,
     367,   368,   369,    -1,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,
     397,   398,   399,   400,   401,   402,   403,    -1,   405,    -1,
     407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,    -1,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,    -1,   215,
      -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,    -1,   245,
     246,    -1,   248,    -1,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,    -1,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,   390,   391,   392,   393,   394,    -1,
      -1,   397,   398,   399,   400,   401,   402,   403,    -1,   405,
      -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
      -1,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,    -1,
     215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,    -1,   240,   241,   242,   243,    -1,
     245,   246,    -1,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,    -1,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,    -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,    -1,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
      -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,   243,
      -1,   245,   246,    -1,   248,    -1,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
      -1,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,   391,   392,   393,
     394,    -1,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
      -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,
      -1,   164,   165,    -1,   167,   168,    -1,   170,   171,   172,
     173,   174,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,
     203,    -1,   205,   206,   207,   208,   209,    -1,    -1,   212,
     213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,    -1,   240,   241,   242,
     243,    -1,   245,   246,    -1,   248,    -1,   250,   251,   252,
     253,   254,   255,    -1,   257,    -1,    -1,   260,   261,   262,
      -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,    -1,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,    -1,    -1,   390,   391,   392,
     393,   394,    -1,    -1,   397,   398,   399,   400,   401,   402,
     403,    -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,    -1,   245,   246,    -1,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,    -1,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,    -1,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,    -1,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,    -1,   245,   246,    -1,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,    -1,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,    -1,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,    -1,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,   243,    -1,   245,   246,    -1,   248,    -1,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,    -1,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,    -1,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,
      -1,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,    -1,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      -1,   240,   241,   242,   243,    -1,   245,   246,    -1,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,    -1,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,    -1,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,    -1,
      -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,    -1,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,   243,    -1,   245,   246,    -1,
     248,    -1,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,    -1,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,    -1,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
      -1,   118,   119,   120,    -1,    -1,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,    -1,   154,    -1,   156,
      -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,
     167,   168,    -1,   170,   171,   172,   173,   174,    -1,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
      -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,
      -1,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,    -1,   240,   241,   242,   243,    -1,   245,   246,
      -1,   248,    -1,   250,   251,   252,   253,   254,   255,    -1,
     257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,    -1,   365,   366,
     367,   368,   369,    -1,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,
     397,   398,   399,   400,   401,   402,   403,    -1,   405,    -1,
     407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,    -1,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,    -1,   215,
      -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,    -1,   245,
     246,    -1,   248,    -1,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,    -1,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,   390,   391,   392,   393,   394,    -1,
      -1,   397,   398,   399,   400,   401,   402,   403,    -1,   405,
      -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
      -1,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,    -1,
     215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,    -1,   240,   241,   242,   243,    -1,
     245,   246,    -1,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,    -1,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,    -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,    -1,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
      -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,   243,
      -1,   245,   246,    -1,   248,    -1,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
      -1,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,   391,   392,   393,
     394,    -1,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
      -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,
      -1,   164,   165,    -1,   167,   168,    -1,   170,   171,   172,
     173,   174,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,
     203,    -1,   205,   206,   207,   208,   209,    -1,    -1,   212,
     213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,    -1,   240,   241,   242,
     243,    -1,   245,   246,    -1,   248,    -1,   250,   251,   252,
     253,   254,   255,    -1,   257,    -1,    -1,   260,   261,   262,
      -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,    -1,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,    -1,    -1,   390,   391,   392,
     393,   394,    -1,    -1,   397,   398,   399,   400,   401,   402,
     403,    -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,    -1,   245,   246,    -1,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,    -1,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,    -1,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,    -1,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,    -1,   245,   246,    -1,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,    -1,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,    -1,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,    -1,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,   243,    -1,   245,   246,    -1,   248,    -1,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,    -1,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,    -1,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,
      -1,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,    -1,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      -1,   240,   241,   242,   243,    -1,   245,   246,    -1,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,    -1,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,    -1,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,    -1,
      -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,    -1,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,   243,    -1,   245,   246,    -1,
     248,    -1,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,    -1,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,    -1,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
      -1,   118,   119,   120,    -1,    -1,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,    -1,   154,    -1,   156,
      -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,
     167,   168,    -1,   170,   171,   172,   173,   174,    -1,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
      -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,
      -1,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,    -1,   240,   241,   242,   243,    -1,   245,   246,
      -1,   248,    -1,   250,   251,   252,   253,   254,   255,    -1,
     257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,    -1,   365,   366,
     367,   368,   369,    -1,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,
     397,   398,   399,   400,   401,   402,   403,    -1,   405,    -1,
     407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,    -1,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,    -1,   215,
      -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,    -1,   245,
     246,    -1,   248,    -1,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,    -1,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,   390,   391,   392,   393,   394,    -1,
      -1,   397,   398,   399,   400,   401,   402,   403,    -1,   405,
      -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
      -1,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,    -1,
     215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,    -1,   240,   241,   242,   243,    -1,
     245,   246,    -1,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,    -1,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,    -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,    -1,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
      -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,   243,
      -1,   245,   246,    -1,   248,    -1,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
      -1,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,   391,   392,   393,
     394,    -1,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
      -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,
      -1,   164,   165,    -1,   167,   168,    -1,   170,   171,   172,
     173,   174,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,
     203,    -1,   205,   206,   207,   208,   209,    -1,    -1,   212,
     213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,    -1,   240,   241,   242,
     243,    -1,   245,   246,    -1,   248,    -1,   250,   251,   252,
     253,   254,   255,    -1,   257,    -1,    -1,   260,   261,   262,
      -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,    -1,    -1,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,    -1,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,    -1,    -1,   390,   391,   392,
     393,   394,    -1,    -1,   397,   398,   399,   400,   401,   402,
     403,    -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,    -1,   245,   246,    -1,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,    -1,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,    -1,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,    -1,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,    -1,   245,   246,    -1,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,    -1,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,    -1,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,    -1,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,   243,    -1,   245,   246,    -1,   248,    -1,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,    -1,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,    -1,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,
      -1,   160,   161,   162,    -1,   164,   165,    -1,   167,   168,
      -1,   170,   171,   172,   173,   174,    -1,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,   208,
     209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      -1,   240,   241,   242,   243,    -1,   245,   246,    -1,   248,
      -1,   250,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,    -1,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,    -1,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,   402,   403,    -1,   405,    -1,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    -1,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,    -1,
     118,   119,   120,    -1,    -1,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,   142,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,    -1,   154,    -1,   156,    -1,
      -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,   167,
     168,    -1,   170,   171,   172,   173,   174,    -1,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,   207,
     208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,    -1,
     218,   219,   220,    -1,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,   243,    -1,   245,   246,    -1,
     248,    -1,   250,   251,   252,   253,   254,   255,    -1,   257,
      -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,    -1,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,    -1,   365,   366,   367,
     368,   369,    -1,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
      -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,   397,
     398,   399,   400,   401,   402,   403,    -1,   405,    -1,   407,
     408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
      -1,   118,   119,   120,    -1,    -1,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,    -1,   154,    -1,   156,
      -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,    -1,
     167,   168,    -1,   170,   171,   172,   173,   174,    -1,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
      -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,   206,
     207,   208,   209,    -1,    -1,   212,   213,    -1,   215,    -1,
      -1,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,    -1,   240,   241,   242,   243,    -1,   245,   246,
      -1,   248,    -1,   250,   251,   252,   253,   254,   255,    -1,
     257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,    -1,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,    -1,   365,   366,
     367,   368,   369,    -1,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,
     397,   398,   399,   400,   401,   402,   403,    -1,   405,    -1,
     407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,   165,
      -1,   167,   168,    -1,   170,   171,   172,   173,   174,    -1,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,   205,
     206,   207,   208,   209,    -1,    -1,   212,   213,    -1,   215,
      -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,    -1,   245,
     246,    -1,   248,    -1,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,    -1,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,    -1,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,   390,   391,   392,   393,   394,    -1,
      -1,   397,   398,   399,   400,   401,   402,   403,    -1,   405,
      -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,   164,
     165,    -1,   167,   168,    -1,   170,   171,   172,   173,   174,
      -1,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,    -1,
     205,   206,   207,   208,   209,    -1,    -1,   212,   213,    -1,
     215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,    -1,   240,   241,   242,   243,    -1,
     245,   246,    -1,   248,    -1,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,    -1,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,    -1,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
     405,    -1,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,    -1,
     164,   165,    -1,   167,   168,    -1,   170,   171,   172,   173,
     174,    -1,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,   203,
      -1,   205,   206,   207,   208,   209,    -1,    -1,   212,   213,
      -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,    -1,   240,   241,   242,   243,
      -1,   245,   246,    -1,   248,    -1,   250,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,    -1,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
      -1,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,   391,   392,   393,
     394,    -1,    -1,   397,   398,   399,   400,   401,   402,   403,
      -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
      -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,   162,
      -1,   164,   165,    -1,   167,   168,    -1,   170,   171,   172,
     173,   174,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,    -1,    -1,
     203,    -1,   205,   206,   207,   208,   209,    -1,    -1,   212,
     213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,    -1,   240,   241,   242,
     243,    -1,   245,   246,    -1,   248,    -1,   250,   251,   252,
     253,   254,   255,    -1,   257,    -1,    -1,   260,   261,   262,
      -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,    -1,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,    -1,    -1,   390,   391,   392,
     393,   394,    -1,    -1,   397,   398,   399,   400,   401,   402,
     403,    -1,   405,    -1,   407,   408,   409,   410,    -1,    -1,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,   161,
     162,    -1,   164,   165,    -1,   167,   168,    -1,   170,   171,
     172,   173,   174,    -1,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,    -1,
      -1,   203,    -1,   205,   206,   207,   208,   209,    -1,    -1,
     212,   213,    -1,   215,    -1,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,    -1,   240,   241,
     242,   243,    -1,   245,   246,    -1,   248,    -1,   250,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,    -1,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,    -1,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
     402,   403,    -1,   405,    -1,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,    -1,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,    -1,   245,   246,    -1,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,    -1,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,    -1,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,
     160,   161,   162,    -1,   164,   165,    -1,   167,   168,    -1,
     170,   171,   172,   173,   174,    -1,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,    -1,    -1,   203,    -1,   205,   206,   207,   208,   209,
      -1,    -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,   243,    -1,   245,   246,    -1,   248,    -1,
     250,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,    -1,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,   402,   403,    -1,   405,    -1,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      -1,    -1,    71,    -1,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      89,    90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,   110,    -1,   112,   113,   114,   115,   116,    -1,   118,
     119,   120,    -1,    -1,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,    -1,   147,    -1,
     149,   150,   151,   152,    -1,   154,    -1,   156,   157,    -1,
     159,   160,   161,   162,    -1,   164,    -1,    -1,    -1,   168,
      -1,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,    -1,   212,    -1,   214,   215,   216,    -1,   218,
     219,   220,    -1,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,    -1,    -1,   245,   246,   247,   248,
      -1,    -1,   251,   252,   253,   254,   255,    -1,   257,    -1,
      -1,   260,   261,   262,    -1,    -1,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,    -1,   282,    -1,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,    -1,
      -1,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,    -1,   371,   372,    -1,    -1,   375,   376,    -1,   378,
      -1,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,   410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   431,   432,   433,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    -1,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,    -1,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,    -1,   159,
     160,   161,   162,    -1,   164,    -1,    -1,    -1,   168,    -1,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,    -1,   212,    -1,   214,   215,   216,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,    -1,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,    -1,   282,    -1,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,    -1,   378,    -1,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   431,   432,   433,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,    -1,    -1,    -1,   160,
     161,   162,    -1,   164,   165,    -1,   167,   168,    -1,   170,
     171,   172,   173,   174,    -1,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
      -1,    -1,   203,    -1,   205,   206,   207,   208,   209,    -1,
      -1,   212,   213,    -1,   215,    -1,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,    -1,   240,
     241,   242,   243,    -1,   245,   246,    -1,   248,    -1,   250,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,    -1,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
      -1,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,    -1,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,   402,   403,    -1,   405,    -1,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    -1,
      -1,    71,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    89,
      90,    91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
     110,    -1,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,    -1,    -1,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,    -1,   147,    -1,   149,
     150,   151,   152,    -1,   154,    -1,   156,   157,    -1,   159,
     160,   161,   162,    -1,   164,    -1,    -1,    -1,   168,    -1,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,    -1,   212,    -1,   214,   215,   216,    -1,   218,   219,
     220,    -1,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,    -1,   245,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,    -1,   257,    -1,    -1,
     260,   261,   262,    -1,    -1,   265,    -1,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,    -1,   282,    -1,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
      -1,   371,   372,    -1,    -1,   375,   376,    -1,   378,    -1,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,    -1,   397,   398,   399,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
     410,    -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   431,   432,   433,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    -1,    -1,
      71,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    -1,    89,    90,
      91,    92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,    -1,   118,   119,   120,
      -1,    -1,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,    -1,   147,    -1,   149,   150,
     151,   152,    -1,   154,    -1,   156,   157,    -1,   159,   160,
     161,   162,    -1,   164,    -1,    -1,    -1,   168,    -1,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
      -1,   212,    -1,   214,   215,   216,    -1,   218,   219,   220,
      -1,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,   246,   247,   248,    -1,    -1,
     251,   252,   253,   254,   255,    -1,   257,    -1,    -1,   260,
     261,   262,    -1,    -1,   265,    -1,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
      -1,   282,    -1,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,    -1,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,    -1,
     371,   372,    -1,    -1,   375,   376,    -1,   378,    -1,    -1,
     381,   382,   383,   384,   385,   386,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,    -1,   397,   398,   399,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,   410,
      -1,    -1,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     431,   432,   433,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    -1,    -1,    71,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    89,    90,    91,
      92,    -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,    -1,   118,   119,   120,    -1,
      -1,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,    -1,   147,    -1,   149,   150,   151,
     152,    -1,   154,    -1,   156,   157,    -1,   159,   160,   161,
     162,    -1,   164,    -1,    -1,    -1,   168,    -1,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,    -1,
     212,    -1,   214,   215,   216,    -1,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,    -1,    -1,   245,   246,   247,   248,    -1,    -1,   251,
     252,   253,   254,   255,    -1,   257,    -1,    -1,   260,   261,
     262,    -1,    -1,   265,    -1,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,    -1,
     282,    -1,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,    -1,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,    -1,   371,
     372,    -1,    -1,   375,   376,    -1,   378,    -1,    -1,   381,
     382,   383,   384,   385,   386,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,    -1,   397,   398,   399,   400,   401,
      -1,   403,    -1,   405,   406,   407,   408,   409,   410,    -1,
      -1,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,
     432,   433,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    -1,    -1,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    89,    90,    91,    92,
      -1,    -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,    -1,   118,   119,   120,    -1,    -1,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,    -1,   147,    -1,   149,   150,   151,   152,
      -1,   154,    -1,   156,   157,    -1,   159,   160,   161,   162,
      -1,   164,    -1,    -1,    -1,   168,    -1,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,    -1,   212,
      -1,   214,   215,   216,    -1,   218,   219,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
      -1,    -1,   245,   246,   247,   248,    -1,    -1,   251,   252,
     253,   254,   255,    -1,   257,    -1,    -1,   260,   261,   262,
      -1,    -1,   265,    -1,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,    -1,   282,
      -1,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,    -1,    -1,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,    -1,   371,   372,
      -1,    -1,   375,   376,    -1,   378,    -1,    -1,   381,   382,
     383,   384,   385,   386,   387,    -1,    -1,   390,   391,   392,
     393,   394,    -1,    -1,   397,   398,   399,   400,   401,    -1,
     403,    -1,   405,   406,   407,   408,   409,   410,    -1,    -1,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,   432,
     433,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    -1,    -1,    71,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    89,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,    -1,   110,    -1,   112,   113,
     114,   115,   116,    -1,   118,   119,   120,    -1,    -1,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,    -1,   147,    -1,   149,   150,   151,   152,    -1,
     154,    -1,   156,   157,    -1,   159,   160,   161,   162,    -1,
     164,    -1,    -1,    -1,   168,    -1,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,    -1,   212,    -1,
     214,   215,   216,    -1,   218,   219,   220,    -1,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,    -1,    -1,   251,   252,   253,
     254,   255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,
      -1,   265,    -1,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,    -1,   282,    -1,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,    -1,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,    -1,   371,   372,    -1,
      -1,   375,   376,    -1,   378,    -1,    -1,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,   391,   392,   393,
     394,    -1,    -1,   397,   398,   399,   400,   401,    -1,   403,
      -1,   405,   406,   407,   408,   409,   410,    -1,    -1,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,   432,   433,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    -1,    -1,    71,    -1,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    89,    90,    91,    92,    -1,    -1,
      -1,    96,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,   110,    -1,   112,   113,   114,
     115,   116,    -1,   118,   119,   120,    -1,    -1,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,    -1,   147,    -1,   149,   150,   151,   152,    -1,   154,
      -1,   156,   157,    -1,   159,   160,   161,   162,    -1,   164,
      -1,    -1,    -1,   168,    -1,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,    -1,   212,    -1,   214,
     215,   216,    -1,   218,   219,   220,    -1,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,    -1,    -1,
     245,   246,   247,   248,    -1,    -1,   251,   252,   253,   254,
     255,    -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,
     265,    -1,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,    -1,   282,    -1,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,    -1,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,    -1,   371,   372,    -1,    -1,
     375,   376,    -1,   378,    -1,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,   397,   398,   399,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,   410,    -1,    -1,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   431,   432,   433,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    -1,    -1,    71,    -1,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,    -1,    -1,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
      -1,   147,    -1,   149,   150,   151,   152,    -1,   154,    -1,
     156,   157,    -1,   159,   160,   161,   162,    -1,   164,    -1,
      -1,    -1,   168,    -1,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,    -1,   212,    -1,   214,   215,
     216,    -1,   218,   219,   220,    -1,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,    -1,    -1,   251,   252,   253,   254,   255,
      -1,   257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,
      -1,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,    -1,   282,    -1,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,    -1,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,    -1,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,    -1,   371,   372,    -1,    -1,   375,
     376,    -1,   378,    -1,    -1,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,   390,   391,   392,   393,   394,    -1,
      -1,   397,   398,   399,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   431,   432,   433,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    -1,
      -1,    48,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    -1,    -1,    63,    -1,    65,    66,
      67,    68,    -1,    -1,    71,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    -1,    -1,    -1,    96,
      -1,    -1,    -1,   100,   101,   102,   103,   104,   105,    -1,
      -1,   108,    -1,   110,    -1,   112,   113,   114,   115,   116,
      -1,   118,   119,   120,    -1,    -1,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,    -1,
     147,    -1,   149,   150,    -1,   152,    -1,   154,    -1,   156,
     157,    -1,   159,   160,   161,   162,    -1,   164,    -1,    -1,
      -1,   168,    -1,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,   189,    -1,   191,   192,   193,   194,    -1,    -1,
      -1,    -1,    -1,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,    -1,   212,    -1,   214,   215,   216,
      -1,   218,   219,   220,    -1,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,    -1,   241,   242,    -1,    -1,   245,   246,
     247,   248,    -1,    -1,   251,    -1,   253,   254,   255,    -1,
     257,    -1,    -1,   260,   261,   262,    -1,    -1,   265,    -1,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,    -1,   282,    -1,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,    -1,   336,
     337,    -1,   339,   340,   341,   342,   343,    -1,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,    -1,    -1,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,    -1,    -1,    -1,    -1,    -1,   375,   376,
      -1,   378,    -1,    -1,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,   390,   391,   392,   393,   394,    -1,    -1,
     397,   398,   399,   400,   401,    -1,    -1,    -1,   405,   406,
     407,   408,   409,   410,    -1,    -1,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   431,   432,   433
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    18,    28,    30,    31,    45,    65,    67,    68,    73,
      75,    86,    88,   105,   108,   120,   122,   126,   132,   140,
     142,   148,   163,   179,   218,   219,   224,   235,   246,   285,
     297,   302,   303,   305,   310,   315,   318,   323,   328,   329,
     336,   340,   350,   362,   381,   391,   397,   402,   415,   436,
     450,   457,   458,   459,   460,   466,   467,   469,   470,   471,
     472,   473,   474,   475,   477,   478,   482,   494,   499,   500,
     503,   504,   505,   517,   520,   521,   537,   574,   577,   580,
     581,   582,   589,   595,   597,   599,   600,   603,   606,   607,
     611,   612,   621,   625,   626,   627,   628,   629,   632,   634,
     635,   636,   637,   638,   645,   658,   659,   663,   665,   666,
     667,   677,   679,   686,   687,   690,   691,   692,   693,   694,
     700,   702,   705,   709,   713,   714,   724,   725,   728,   733,
     744,   767,   770,   771,   772,   775,   778,   780,   782,   784,
     785,   790,   791,   794,   795,   796,   803,   804,   806,   807,
     808,   813,   815,   816,   822,   823,   824,   825,   826,   827,
     829,   830,   832,   833,   835,   838,   839,   844,   850,   853,
     855,   856,   864,   866,   871,   878,   882,   883,   884,   885,
     886,   887,   890,   925,   375,   418,   809,    25,    71,    85,
     103,   109,   124,   135,   143,   155,   160,   166,   183,   208,
     229,   260,   280,   290,   317,   322,   324,   330,   333,   361,
     362,   365,   369,   378,   383,   395,   408,   596,   809,     3,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    37,    38,    40,    41,    43,    44,    45,    46,
      47,    49,    50,    52,    53,    54,    55,    56,    59,    60,
      61,    62,    63,    65,    66,    67,    68,    69,    73,    74,
      75,    76,    78,    79,    80,    82,    83,    84,    85,    86,
      87,    90,    91,    92,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   110,   112,   113,   114,   115,   116,   118,
     119,   120,   123,   124,   125,   126,   127,   129,   130,   131,
     133,   134,   135,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   147,   149,   150,   151,   152,   154,   156,   160,
     161,   162,   164,   165,   167,   168,   170,   171,   172,   173,
     174,   176,   177,   178,   179,   181,   182,   183,   184,   185,
     186,   188,   190,   191,   192,   193,   194,   195,   196,   198,
     200,   203,   205,   206,   207,   208,   209,   212,   213,   215,
     218,   219,   220,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   240,
     241,   242,   243,   245,   246,   248,   250,   251,   252,   253,
     254,   255,   257,   260,   261,   262,   265,   266,   268,   270,
     271,   272,   273,   274,   275,   276,   277,   279,   280,   281,
     282,   283,   284,   285,   286,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   314,
     315,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   330,   331,   332,   333,   334,   336,   337,
     338,   339,   340,   342,   343,   344,   345,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   360,
     361,   363,   365,   366,   367,   368,   369,   371,   372,   375,
     376,   377,   378,   379,   381,   382,   383,   384,   385,   386,
     387,   390,   391,   392,   393,   394,   397,   398,   399,   400,
     401,   402,   403,   405,   407,   408,   409,   410,   413,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   879,  1046,  1060,
    1064,  1065,   406,   840,   258,   286,   809,    48,   528,   883,
      25,    37,    58,    71,    81,   103,   109,   124,   135,   143,
     155,   162,   166,   220,   260,   263,   280,   317,   324,   333,
     365,   366,   368,   369,   378,   383,   389,   392,   395,   538,
     579,   682,   734,   745,    26,   285,  1046,   879,    26,   279,
     331,   366,   368,     5,   207,   776,   777,  1055,    25,    37,
      58,    71,    85,   103,   124,   135,   143,   155,   160,   166,
     183,   229,   260,   271,   280,   317,   322,   324,   330,   333,
     362,   365,   369,   376,   378,   383,   395,   408,   596,   695,
     809,  1046,    88,   406,   450,   574,   577,   580,   839,   845,
     853,   856,   864,   871,   878,   882,     9,    19,    26,    43,
     150,   156,   158,   180,   209,   241,   288,   304,   441,   442,
     710,   711,   879,  1054,  1056,    26,    88,   301,   329,   715,
     716,   717,  1060,   155,  1060,  1051,  1055,   362,   893,   710,
    1060,   375,  1046,   271,   229,   103,   183,   324,   361,   362,
     450,   786,   787,   323,  1060,    26,   334,   371,   375,   486,
     495,   496,  1060,    23,   163,   715,   716,   286,   809,  1060,
     206,    26,   121,   895,   896,    59,    82,   220,   237,   317,
     324,   334,   371,   375,   421,   483,   484,   485,   486,    26,
     334,   371,   375,   486,   375,   259,   936,  1044,  1060,   893,
     443,  1060,   159,   450,   841,   450,  1039,   299,   888,   889,
    1046,   888,   883,   884,   887,     0,   453,   840,   136,   197,
     264,   388,   897,   898,   883,   885,   886,   114,   193,   394,
     454,     3,    42,    48,    71,    77,    89,    96,   157,   159,
     175,   189,   201,   202,   204,   214,   216,   239,   247,   267,
     269,   316,   341,   364,   406,  1052,  1060,  1061,  1064,  1066,
     697,  1060,   697,  1047,  1060,   289,   697,   378,   697,  1046,
    1060,   102,   362,   723,  1052,     3,    99,   335,  1057,  1058,
    1062,  1064,  1065,  1066,    26,   174,  1044,   253,   408,     8,
      15,    16,    17,    66,   147,   437,   438,   439,   441,   442,
     443,   444,   445,   446,   774,  1006,  1007,  1060,   174,  1046,
      26,  1057,  1058,  1046,  1046,   174,  1044,  1046,   310,   336,
      26,   174,   936,  1046,   326,  1046,   697,   227,  1057,  1058,
     174,  1044,   207,   111,   203,   244,   295,   810,   811,   812,
    1044,  1050,  1060,    25,    58,    71,    72,    81,    85,   103,
     124,   135,   143,   155,   160,   183,   208,   229,   260,   280,
     317,   322,   324,   330,   333,   362,   365,   369,   376,   378,
     383,   408,   596,   703,  1055,  1044,   373,  1052,  1046,   450,
     697,   378,  1047,   697,   378,   174,  1046,   102,   362,   366,
     368,  1057,  1058,   366,   368,    66,   147,   774,   308,  1046,
    1057,   174,   479,  1060,  1046,  1046,   326,  1046,   697,   227,
    1057,   299,   330,   362,   408,   229,    85,   183,   160,   322,
     376,   382,   590,    26,  1046,   880,   493,  1055,  1062,   777,
     174,  1052,  1046,   174,   781,   174,  1047,     3,    47,    49,
      50,    61,    62,   106,   107,   125,   151,   174,   195,   196,
     198,   238,   240,   252,   296,   338,   344,   371,   372,   403,
     699,   951,   953,   955,   957,   959,   961,   962,   963,   965,
     966,   967,   970,   971,  1061,  1064,   378,   102,   362,   174,
    1052,   174,  1058,  1059,    77,   408,    66,   147,   174,   774,
      52,   174,  1046,   174,  1059,   174,  1046,   174,  1046,   174,
    1046,   326,   781,   174,  1046,   174,   699,   174,   227,  1059,
     207,   174,   696,   697,   450,   854,   538,   845,   402,   839,
     846,   847,   848,  1062,   840,  1056,   711,   712,    26,   712,
    1056,   712,    26,   712,  1056,   712,   712,   712,  1056,  1054,
    1054,   879,   712,   289,   450,   450,   557,   557,   557,   258,
     373,   454,   557,   324,   936,   937,   454,   805,  1055,   450,
     851,    52,   408,   406,   788,   789,  1044,  1046,  1060,    42,
     433,   203,   452,   261,   261,   258,   158,  1055,   373,   153,
     706,   258,     4,     6,     7,     8,    10,    34,    47,    49,
      50,    57,    58,    61,    62,    69,    71,    93,    94,    95,
      96,    97,    98,    99,   106,   107,   141,   145,   146,   151,
     165,   167,   195,   196,   198,   213,   221,   222,   238,   240,
     244,   249,   250,   252,   260,   270,   281,   296,   320,   335,
     344,   358,   371,   372,   377,   379,   380,   389,   395,   403,
     423,   424,   425,   426,   427,   428,   429,   430,   434,   441,
     442,   443,   450,   883,   954,   957,   960,   961,   962,   964,
     965,   966,   970,   971,   975,   977,   978,   979,   981,  1002,
    1003,  1004,  1008,  1027,  1032,  1041,  1042,  1052,  1053,  1054,
    1055,  1060,  1040,  1041,  1055,    26,   501,  1043,  1044,   334,
     483,   109,   492,  1055,   493,  1055,    42,    63,   483,   433,
     345,   811,   261,   158,   373,   439,    42,   433,   203,   812,
     450,  1044,   443,   448,   452,  1033,  1034,   937,   157,   159,
     406,   836,   837,   839,   157,   842,   109,   975,  1037,  1038,
     888,   454,   450,   843,   451,   451,   459,  1044,    26,   121,
     894,   894,    52,   894,   148,   153,   217,   256,   901,   903,
     904,   919,   921,   922,   923,   897,   898,   158,   199,   936,
     938,  1039,   450,   757,  1034,   272,   306,   336,   452,   698,
     272,   306,   336,     3,    80,   130,   223,   272,   306,   336,
     365,   367,   415,   494,   497,   817,   818,   819,   820,   729,
      22,   126,   272,   306,   336,   399,   508,  1046,   336,    22,
     126,   394,   476,   419,   174,   936,    54,    87,   144,   177,
     212,   244,   272,   306,   314,   321,   328,   336,   348,   356,
     410,   494,   498,   760,   768,   450,   746,   306,   476,   180,
     141,    22,    28,    68,   119,   126,   129,   185,   242,   244,
     254,   262,   272,   306,   309,   310,   336,   399,   506,   507,
     615,     4,   442,   587,  1056,    26,   174,  1044,   697,   697,
     450,   773,   452,   141,   258,   180,   468,   306,   415,   436,
     461,   468,   258,   272,   306,   141,    53,   101,   182,   230,
     232,   242,   271,   306,   311,   336,   350,   506,   584,   585,
     272,   306,   407,   615,   623,   496,   484,   486,   180,   141,
     306,   336,   506,   272,   306,   310,   336,    78,   118,   273,
     367,   258,    22,    28,   126,   272,   306,   336,   518,   519,
     153,   306,   336,   461,   497,   141,   306,   336,   506,  1046,
     215,   111,   259,   420,   454,   810,   396,   834,   258,  1052,
     450,  1046,   951,   378,   102,   362,  1052,   253,   408,    66,
     147,   774,  1046,  1046,   326,   153,  1046,   951,   207,   697,
     557,   292,   523,   450,   672,   757,    64,   951,   158,   450,
     668,  1046,   461,    35,   828,  1046,   244,   461,   419,   174,
    1044,   461,   697,   697,   668,   392,   538,   258,   461,   244,
      42,   480,   383,   622,   272,   598,    78,   118,   273,   367,
      24,    44,   194,   646,    35,   668,   153,   461,   408,   174,
    1044,   174,   575,  1044,  1044,   408,   697,    77,   735,  1052,
    1046,   153,   596,    48,   100,   192,   242,   325,   141,   757,
      55,   312,   509,   141,   450,   141,   405,   968,   968,   968,
     450,   956,   956,   283,   450,   958,   141,    61,    62,   968,
     956,   953,   417,   436,   450,   972,   450,   972,   454,   509,
      34,   952,    62,   450,   969,   104,   172,   231,   234,   327,
     431,   450,   973,   974,   698,   956,   419,   141,   746,   141,
     454,   174,   696,   174,   697,   174,   697,   141,   773,  1059,
     141,   258,   141,   141,   258,   141,   509,   141,    78,   118,
     273,   367,   153,   141,   258,   141,   509,   141,   153,   174,
     174,   493,   141,   454,   509,   975,  1011,   362,   451,   454,
     146,   258,   380,   490,   493,   587,   849,   845,   712,   879,
     712,   879,   712,   879,   712,   879,   712,   879,   879,   879,
     712,   879,   450,   558,   559,  1060,   558,    26,   103,   124,
     155,   160,   207,   208,   324,   330,   362,   365,   383,   718,
    1043,  1059,   717,  1046,   180,   454,   867,  1055,   951,  1014,
      35,  1059,   735,   451,   454,   215,  1060,   153,   153,   718,
    1059,   323,  1060,   493,   258,   450,  1035,   448,   883,  1015,
     975,  1031,   450,   450,   153,   450,   450,   883,   450,   450,
     450,   450,   450,   450,   975,   450,   450,   450,   450,   450,
     450,   450,   450,   883,   450,   450,   450,   450,   450,   450,
     450,   450,   975,   975,   975,   883,   975,  1011,  1034,  1055,
     450,  1055,     3,     8,    11,    15,    16,    17,    32,    35,
      40,    46,    70,   175,   180,   201,   202,   216,   247,   260,
     263,   341,   434,   437,   438,   439,   441,   442,   443,   444,
     445,   446,  1006,  1008,  1010,   416,   990,   269,   975,   199,
     454,   891,   450,  1055,  1034,   891,   112,   176,   502,   454,
      63,   109,   493,    35,     3,   109,   220,   491,   587,   971,
    1055,  1055,    83,   123,   987,    92,   109,   487,   488,   490,
     587,   109,   487,   215,  1044,   975,     3,    26,    30,    31,
      32,    33,    34,    35,    36,    39,    51,    57,    58,    64,
      70,    72,    81,    88,    93,    94,    95,    97,    98,    99,
     109,   111,   117,   121,   122,   128,   132,   136,   146,   148,
     153,   155,   158,   163,   166,   169,   180,   187,   197,   199,
     210,   211,   217,   221,   222,   244,   249,   256,   258,   259,
     263,   264,   278,   287,   301,   313,   329,   335,   346,   359,
     362,   370,   373,   374,   380,   388,   389,   395,   396,   404,
     411,   412,   414,   415,   443,  1049,  1063,  1064,  1065,  1066,
    1067,  1033,    84,   311,   701,   451,   454,   840,   451,   454,
     889,  1045,  1046,    35,   843,   885,   885,   899,   900,   975,
     885,   150,   241,   910,   205,   242,   295,   339,   394,    26,
     905,   975,   906,   908,   975,   977,   919,   920,   904,   903,
     901,   902,   153,   922,   254,   924,   901,   919,   938,   857,
    1044,    35,  1060,   336,   180,   190,   264,   266,   338,   404,
     443,   750,   751,   752,   754,   756,   758,   951,  1061,   272,
     306,   336,   373,   373,   324,  1049,   452,   373,   373,   324,
     217,   373,   373,   365,   483,   272,   817,   819,   439,   821,
     153,   163,   180,   315,   730,   731,    64,    81,   137,   155,
     287,   389,   554,   555,    81,   109,   244,   373,    81,   373,
     109,   244,   324,    81,   119,   129,   272,   306,   664,   324,
     604,    25,    58,    71,    85,   124,   135,   155,   160,   229,
     260,   324,   330,   333,   362,   369,   376,   383,   408,   596,
    1046,   141,   306,   336,   506,   258,   587,   328,   212,   373,
     373,   249,   587,   113,   200,   324,   334,   375,   485,   312,
     336,   760,   769,   451,   747,   750,   373,   395,   365,  1044,
      72,   137,   545,   554,  1060,    72,    81,   792,   258,   320,
     322,   378,    81,   792,    29,   309,   320,   322,   378,  1044,
     185,   254,   697,   450,   373,   373,   173,   450,   513,   226,
     365,   392,   415,   417,   513,    81,   454,     4,   272,   180,
     141,   306,   336,   506,   396,   396,   243,   951,   272,   336,
     774,  1046,  1044,   103,   497,   373,   463,   497,  1044,   373,
     373,  1044,   587,    52,   586,   587,   587,   101,   230,   232,
      52,   373,   461,   324,   461,   242,   585,   373,   373,   249,
    1055,   615,   365,   936,    81,   373,   792,   324,   373,   373,
     513,   513,   697,   697,   697,   697,  1044,    41,   401,    41,
      41,   373,    41,   373,   324,   454,   395,   633,  1058,   373,
     463,  1044,   373,   324,   272,   306,   295,   307,   332,   489,
     810,  1050,  1060,  1044,   757,   951,   258,   201,   419,   746,
     587,   697,   697,   773,   258,   201,   258,    78,   118,   273,
     367,   951,   258,   201,   697,   201,   415,   529,   353,   354,
     524,  1055,     3,   673,   674,   668,   450,    35,   697,   669,
     670,  1063,    24,   817,   951,   258,   141,   601,  1046,   244,
     450,   462,   682,   396,   299,   408,  1044,   462,   141,  1058,
      88,   163,   481,   537,   581,   645,   713,   733,   813,  1055,
     623,   624,  1058,   223,   697,   697,   697,   697,   254,   114,
     193,   381,   394,   647,   648,   133,   294,   450,   633,   462,
    1044,   244,   583,   584,   244,    35,   254,   450,   557,   557,
     174,   578,  1044,   153,   174,   736,  1050,   450,   748,    35,
     951,   207,   415,   417,   881,   325,  1052,   509,   951,  1047,
     450,  1011,  1054,   699,   968,   968,    34,   952,   371,   371,
    1054,  1054,   951,   448,   448,   336,  1054,   373,   373,   373,
     450,   373,  1054,   956,   174,  1046,  1052,   509,  1059,  1058,
     141,   509,   141,   396,   141,   396,   774,   509,   509,  1046,
     697,  1059,  1046,   697,  1046,  1046,   951,  1046,   697,   699,
    1059,   633,   141,   141,   509,   696,   697,   451,   454,   174,
    1044,   845,   847,   879,   879,   879,   879,   879,   879,   558,
     451,   454,   451,   161,   331,   363,  1045,   696,   102,   333,
     722,   723,  1045,   253,  1045,  1043,  1043,  1045,   696,   373,
     415,   726,   136,   217,   630,   631,    20,   139,   320,   339,
     868,   936,   248,   869,   451,   454,   852,   856,   864,   871,
     882,   373,  1044,   786,   787,   789,   716,   715,   716,   158,
     164,   727,  1060,    25,    72,   103,   124,   135,   155,   160,
     208,   229,   317,   324,   330,   362,   365,   383,   408,   596,
     707,  1011,  1033,   449,  1011,  1015,  1016,   411,  1028,  1029,
     975,  1011,   450,  1054,  1054,     3,   104,   172,   231,   234,
     327,   431,  1017,  1018,  1055,  1011,  1011,  1011,  1054,  1054,
     975,   774,   975,  1019,   320,   441,   442,   450,   976,   977,
    1008,  1021,   451,  1011,   975,  1011,  1022,   975,    51,   158,
     211,   374,   975,  1011,  1025,  1011,   236,   977,   975,   985,
     986,   987,   236,   975,   987,   451,   454,  1054,   973,   951,
     975,   975,   975,   975,  1063,   371,    39,   359,  1036,   697,
     975,   450,   883,  1026,   121,   123,   146,   244,   249,   254,
     380,   390,   975,   450,   975,   373,    46,   175,   180,   216,
     341,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,    26,    33,   346,  1005,   166,   149,   991,   320,   450,
    1002,   162,   220,   362,   366,   368,   392,   892,  1044,  1042,
     158,   926,    26,   121,   404,   443,   451,   752,   975,  1012,
    1013,  1061,   926,  1044,   375,   450,  1055,   454,   451,   449,
     455,   173,   173,   509,  1044,   837,   838,  1044,  1037,   451,
     454,   450,   454,    36,   117,   396,   742,   450,   907,  1056,
     339,   205,   259,   454,   320,   321,   909,  1043,   248,   343,
     870,   920,   902,   396,   865,   109,   450,   858,   882,    35,
    1060,   450,   872,   873,   874,   875,   876,  1060,   266,    52,
    1061,   451,   752,   754,   751,   754,  1061,   264,   451,   454,
     698,   373,   373,   324,  1058,  1046,  1046,  1049,  1058,  1046,
    1046,  1058,  1047,  1046,   109,   490,  1056,   317,   395,   715,
     324,   163,   715,   450,  1046,   396,   737,   205,   205,   396,
     450,   573,   174,  1046,   249,  1058,  1046,  1046,   975,   249,
    1046,  1046,    29,   309,   373,   373,  1046,   373,   605,  1052,
     450,   697,   697,   951,   378,   102,   362,   723,   408,    66,
     147,   774,  1046,   697,  1046,   697,   326,   153,   951,   697,
     207,   168,   242,   272,   306,   400,   608,   609,   610,   936,
     373,   792,   324,   249,   113,   200,  1058,  1046,   258,  1046,
     451,   454,  1057,  1059,  1046,   306,   506,   545,   951,  1046,
    1060,  1046,   215,  1046,    26,   395,  1046,   174,  1046,   174,
    1060,   322,   378,   322,   378,   215,  1046,    26,   395,  1046,
    1044,    22,   126,   336,   616,   617,   618,   619,  1063,  1058,
    1046,   109,   159,   245,   396,   512,   515,   516,  1063,  1046,
     257,    68,   257,  1046,   507,   373,   365,  1044,   373,   792,
     324,  1048,  1060,  1048,   454,   451,   454,   373,   324,   258,
     306,   373,   642,  1047,  1057,     3,    80,   131,   185,   277,
     387,   395,   398,   464,   306,  1058,  1046,   306,   336,   506,
     584,   587,   697,  1046,   587,  1046,   587,  1058,  1046,  1046,
     306,   336,   506,  1046,  1046,  1046,  1046,  1058,  1046,    22,
      28,   126,   272,   306,   336,   272,   306,   336,   668,   306,
     336,   306,   336,   306,   950,  1060,   174,   678,  1060,   174,
    1060,  1058,  1046,  1046,  1046,    22,   519,   333,  1057,   306,
     336,   506,  1046,  1046,   373,   373,    76,   386,   295,   201,
      35,   124,   697,   249,   704,  1055,   201,   201,   396,   396,
     201,   697,   704,   697,   207,   697,   704,   201,   704,   257,
     158,   373,   522,   461,   439,   451,   454,   975,   951,   451,
     454,   439,   647,   547,  1063,  1046,   158,   324,   407,   602,
     609,   610,   141,   216,   539,   541,   543,   545,   551,   554,
      23,   180,   317,   360,   464,   465,   153,  1048,   408,  1044,
     153,   643,   479,  1060,   480,   263,   538,   155,  1055,   668,
     668,   668,   668,   254,   258,   263,   450,   668,   948,   949,
     950,   333,   450,   141,   141,   140,   882,   697,   539,  1060,
     415,   417,   569,   415,   514,   244,    35,   557,  1055,   244,
     258,   451,   749,   750,   755,    35,   207,   314,   376,   414,
     759,   760,   761,   258,   207,   493,   171,   171,   153,   757,
      35,  1011,   451,   451,   509,   448,   433,   433,   451,   451,
    1054,   449,  1054,  1060,   451,   172,   231,   974,   231,   974,
     974,  1054,   234,   451,   141,   509,   746,   696,   697,  1048,
     697,  1048,   773,   258,   509,   258,   509,   509,   207,   258,
     509,   509,   333,   153,   493,   509,   975,   244,   451,   559,
     180,   180,   180,   419,  1045,   454,   587,   588,   166,   719,
     720,  1058,    23,   727,   373,   450,   158,   139,   339,   139,
     339,   320,   394,   233,   951,  1058,   415,   576,  1044,  1046,
     158,   258,   719,    52,   509,  1052,   951,   378,   362,  1052,
     253,   408,   951,   207,   697,   451,   449,   449,   454,   975,
     128,  1029,  1030,    35,   451,   975,   451,   451,   451,   158,
     451,   451,   451,   451,   451,   454,   451,   278,  1020,   451,
     450,   976,   976,  1011,    11,    15,    16,    17,   180,   201,
     260,   437,   438,   439,   441,   442,   443,   444,   445,   446,
    1008,   976,   451,   451,   153,   158,  1023,  1024,   451,    35,
    1025,  1011,  1025,  1025,   158,   451,   451,  1063,   276,   989,
      35,   451,   454,   975,  1063,   454,   975,  1035,   975,   451,
     433,   976,   976,   134,  1011,   158,   121,   123,   146,   249,
     254,   380,   390,   450,   134,   774,   975,   359,  1036,   975,
    1026,   975,   373,   450,   883,   450,   450,   268,   995,   450,
    1011,   366,   368,   366,   368,  1044,   893,   893,   893,   210,
     321,   450,   883,   927,   928,   929,   936,   941,   978,   980,
     981,  1052,  1060,   412,   946,  1012,  1012,  1013,   451,    13,
      14,   454,   897,   898,   946,   811,  1054,   973,   488,   975,
     843,  1046,   852,   900,   260,  1006,  1009,   435,   743,   975,
     909,   394,   906,   225,   927,   412,   947,   402,   859,   860,
    1060,   258,   861,  1060,   876,   877,   454,   926,   439,  1035,
     758,   698,   754,   754,    52,   756,   445,  1058,  1046,  1046,
    1059,  1059,   258,  1045,   261,   258,   975,   555,  1048,   450,
     450,   450,   573,   183,   558,   656,   141,   509,   373,  1058,
    1046,   493,   757,   951,  1046,   419,   697,   697,   697,   697,
     773,    78,   118,   273,   367,   951,  1046,   591,  1046,   168,
     400,   373,   373,   591,   608,   615,   306,   336,   506,  1046,
    1046,  1046,   191,   249,   750,   271,   336,   373,   262,   613,
     656,   126,   310,   336,   508,   615,   793,   328,   141,   509,
     141,   509,  1046,  1046,  1046,  1046,   328,   618,   619,   618,
     451,   454,   620,  1055,   183,   451,   454,   439,   452,  1058,
    1046,   306,   336,   506,  1046,  1046,  1046,   272,   306,   336,
      22,   126,   272,   306,   336,   951,   243,   951,  1058,  1046,
    1044,   373,  1059,   396,   639,   217,   277,   249,  1055,   277,
    1059,   393,   373,   373,   324,   271,   336,    81,   373,   792,
     324,   373,   373,   227,   227,   227,   373,   373,   324,   373,
     373,   324,   373,   324,   373,   324,   373,   509,   951,   244,
    1055,   336,   793,   141,   509,   373,  1046,   373,   324,  1058,
    1046,   704,   951,   697,   201,   704,   704,  1048,  1048,   704,
     201,   201,  1046,   201,   704,   523,   450,   525,   526,   260,
     441,   442,   587,   671,   754,  1009,  1055,  1067,     3,   674,
     451,   451,   670,   671,   258,    64,    70,    81,   109,   111,
     187,   244,   249,   287,   301,   389,   548,   549,   550,   140,
     411,   461,   493,  1046,   493,   613,  1044,  1044,   451,   454,
    1059,   166,   317,  1059,  1054,   383,  1044,   557,    26,   114,
     193,   329,   394,   644,   373,   641,    42,   480,   308,   362,
     102,   514,   558,  1044,   648,   675,   676,  1055,   451,   454,
    1046,   558,  1044,   575,  1044,  1046,   576,   450,   540,   451,
     257,   513,   257,   258,   570,   513,    35,   141,   882,   514,
     373,   141,  1044,   451,   454,   109,   439,   762,  1055,   493,
     362,   753,   754,   153,   763,   415,   761,   764,   114,   193,
     329,   394,   801,  1046,   168,   882,   509,   951,   451,  1054,
     972,   972,   449,   449,   969,   451,  1046,   509,   509,   396,
     509,   396,   509,   509,   697,   697,  1046,   697,  1046,   633,
     509,   141,   324,   324,   324,  1045,   723,   454,  1058,   415,
     454,   721,   261,   937,   333,   139,   139,   102,   242,  1059,
     718,   509,  1058,   757,   201,   746,   587,   201,   697,   201,
    1015,   370,   975,   132,   951,   451,   975,   975,   975,  1023,
     451,  1011,   454,   951,   976,   976,   976,   976,   121,   123,
     244,   254,   976,   976,   976,   976,   976,   976,   976,   976,
     976,   976,   975,   975,  1024,  1023,   951,   451,   451,   451,
    1011,   451,   454,    52,   977,   451,  1063,   986,   284,   357,
     988,   451,   454,   407,   982,    35,   451,  1055,   975,    32,
      32,   975,   451,   975,   158,   450,  1014,   975,   451,   134,
     976,   976,   134,   134,   975,   975,   898,   412,   450,   996,
    1060,   451,  1011,   454,   893,   893,   893,   893,  1044,  1044,
    1044,   883,   941,   158,   883,   928,   929,    35,   930,   931,
    1060,   454,    89,   159,   189,   204,   214,   239,   316,   933,
     931,    35,   930,   932,  1060,   436,   945,   450,  1034,   975,
     166,   911,   454,   897,   897,   897,   975,   975,   404,  1013,
     451,   911,   451,   449,   451,   450,   743,   150,   209,   451,
     259,    92,   975,   313,   863,   451,   454,  1035,    79,   863,
     451,   454,   873,   947,  1037,   451,   445,   758,   383,   161,
     331,   363,   384,   732,   153,   732,   451,   450,   561,   562,
     739,   980,  1060,   558,   558,   656,  1050,   451,   111,   187,
     242,   244,   657,  1046,  1046,    35,  1046,   396,   396,   697,
     697,   697,   697,   207,   698,  1058,  1046,   373,   792,   324,
     373,   191,    52,   365,  1046,   450,   547,   244,   513,   102,
     244,   352,   355,   513,   383,  1046,  1060,   617,  1046,   516,
     671,  1063,   271,   336,   373,   792,   324,   373,   373,   373,
     324,   160,   260,   355,   680,   681,   160,   260,   688,   689,
     373,   373,   324,   451,   451,   451,   306,  1046,   450,   415,
     640,  1056,  1055,  1055,  1055,  1046,  1046,  1046,    52,   365,
    1046,  1046,  1046,  1046,  1046,  1046,   153,   153,   308,   153,
     174,  1058,  1046,  1046,  1058,  1046,  1046,  1046,  1046,  1046,
    1046,  1046,    70,   510,   141,    24,    44,   383,  1060,  1046,
     615,  1046,  1046,   451,   201,   704,   201,   201,   704,   704,
     201,   704,   524,   532,   533,  1063,    48,    90,   115,   130,
     134,   154,   157,   170,   249,   257,   293,   527,   656,   415,
     417,  1044,   450,   697,  1046,   976,   112,   176,   111,   249,
     205,  1044,   764,   291,   660,   661,  1060,   601,   450,   552,
     186,   568,   543,  1059,  1059,   951,   450,   514,  1059,   639,
    1058,   174,  1044,   419,   153,   649,   451,   454,   950,   613,
     451,   583,    35,   254,   450,   854,   542,   544,   546,   554,
    1060,   569,   568,    75,   365,   571,   882,   578,   576,   571,
    1055,  1050,   737,   755,   975,   975,   454,   450,   759,   383,
     454,   668,   373,   450,   591,   451,   449,   509,  1048,  1048,
     509,   509,   509,   509,   333,  1045,  1045,  1045,   587,   163,
     720,   451,  1046,   102,   727,   158,   201,   249,   708,  1055,
     201,   201,   708,   201,   708,   975,   451,   451,  1024,   451,
     975,   158,   121,   123,   254,   450,   451,   422,   984,  1011,
     300,    52,   413,   413,   451,   975,   242,   975,   454,   983,
     953,   975,   975,   975,  1014,   451,   975,    32,    32,   975,
     975,   134,   451,   451,   975,   997,  1060,   451,   975,  1044,
    1044,  1044,  1044,   931,   932,   450,   451,  1060,   450,   928,
     204,   267,   934,   928,   934,   204,   933,   934,   204,   364,
     939,   450,  1060,   450,   265,  1012,    52,   169,   918,   451,
     451,   451,  1013,  1055,   918,  1055,   774,   254,  1041,   882,
     860,   258,   450,   862,   439,   876,   863,   383,   451,   373,
     715,   158,   656,   975,   451,   454,   415,    70,   740,   740,
     451,   451,   764,   112,   176,   185,   111,   398,   509,   951,
    1048,  1048,  1046,  1046,  1046,  1046,  1046,  1059,  1046,   614,
     618,   249,   249,  1056,  1060,   951,   509,   509,   439,    52,
     365,  1046,  1046,  1046,  1046,  1058,  1046,  1046,  1054,  1054,
     951,   454,  1054,  1054,   454,  1058,  1046,  1046,   373,   975,
      64,  1059,  1046,   373,   373,  1045,  1045,   697,  1045,   141,
     697,  1055,  1055,   951,   509,   509,   201,   704,   704,   704,
     704,   396,   530,   531,   451,   454,   443,   450,   490,   534,
     587,   828,  1055,   828,   244,   249,   293,   828,   828,   160,
     190,   160,   158,   655,   975,   244,   549,   764,   557,   396,
     572,  1052,    32,   140,   180,   539,   138,   181,   450,   333,
     396,   558,    35,   640,   480,   244,   450,  1046,   127,   650,
     411,   652,  1055,   514,   882,   697,   539,   576,   451,   454,
     415,   570,   569,   114,   126,   284,  1046,   415,   814,    35,
     158,   258,   450,  1055,   752,   765,   766,  1061,   764,   951,
     153,  1044,   158,   373,   783,   188,   592,   509,   509,   509,
    1046,   261,   199,   509,   719,   708,   708,   708,   708,   451,
     976,   158,   450,  1014,   450,   451,   454,   451,   977,   300,
     451,   401,   349,   451,   451,   451,   975,   975,   975,   451,
     275,   998,   451,   942,   943,   980,   930,   450,  1045,   928,
     258,   396,   935,   928,   204,   928,  1052,   949,   450,   949,
    1060,   897,    91,   167,   319,   450,   912,   913,   914,   915,
     916,   917,   975,   975,   414,   992,   897,   992,   451,   879,
      81,   738,   739,   122,   450,   883,  1039,   719,   258,   719,
     451,   764,   562,   260,   774,   697,   396,   697,   741,   741,
     301,   764,   572,   451,   373,   336,   869,   451,   454,   510,
     671,  1059,  1046,   373,   450,  1052,   774,   681,   450,   450,
     689,  1046,   451,   450,   336,   869,  1046,  1046,   415,   436,
     831,   308,   831,   831,   153,   510,   704,   461,   116,   533,
     490,   535,   536,  1055,  1055,   249,   558,   443,   558,  1055,
    1055,   723,    35,   779,   779,  1044,   656,   451,   572,   228,
     560,   183,   450,   661,   291,   450,   451,    26,    74,    82,
     110,   184,   355,   553,   553,  1043,  1046,  1048,   451,   882,
     141,   613,   320,   351,   651,   450,   140,    35,   576,   540,
     451,   544,   262,   571,   570,   321,   321,    56,    64,   220,
     882,   697,  1044,   738,   754,   451,   454,   383,   946,   347,
     347,   451,   591,   242,   400,   593,   594,  1046,   509,   976,
    1014,   451,   985,  1011,    52,   242,   432,    52,   897,   451,
     454,    35,   944,  1045,   451,   975,   450,   928,   935,   450,
     451,   949,   451,   451,   450,   337,   450,   451,   454,   993,
     994,  1060,   451,  1046,   451,   454,   245,   394,   721,   732,
     509,   740,   572,   450,   697,   742,   742,  1044,   572,   656,
    1046,   365,   618,   396,   511,   336,   869,  1046,  1014,   746,
     153,   684,   773,  1014,  1014,   975,   365,   696,   697,   696,
     697,  1045,   509,   525,  1055,   451,   454,   558,   779,    38,
     178,   153,   242,   556,   159,   274,   342,   258,   564,   565,
     566,   365,   451,  1052,     5,   662,   568,   451,   613,   147,
     683,   514,   814,  1044,   975,   291,   882,   569,   568,   547,
     571,    64,   261,    64,   576,   737,   451,   759,   765,   951,
     122,   415,   415,   400,   591,   613,   451,   451,   451,   300,
     401,  1011,   294,   321,   999,   945,   942,   450,   451,  1045,
    1011,   451,  1011,   450,  1011,   913,   454,    35,   946,   739,
     336,   158,   741,   412,   563,   774,   743,   743,   557,   656,
    1046,   975,   365,   451,   264,   326,   298,   685,   684,   451,
     451,   451,  1046,   831,   536,   127,   185,   114,   394,   258,
     566,   258,   565,  1046,   450,   451,   454,   333,   697,    35,
      35,   450,   451,  1052,   814,   570,   569,   261,   261,   450,
     514,   764,    27,   194,   802,   160,   160,    46,    92,   385,
     975,  1000,  1001,  1000,   451,   949,   451,   451,   451,   912,
     451,   994,   996,   872,   719,   742,   450,   656,   451,   560,
     869,  1046,  1052,    52,   685,   869,   697,   320,    55,   242,
     312,   336,   567,   567,   451,     5,  1046,   680,   882,   450,
     571,   570,   738,   571,   245,   450,   797,   799,   804,   856,
     864,   871,   882,   723,   723,  1001,   320,   152,   282,   152,
     282,   451,   307,   940,   451,   946,   509,   743,   975,   564,
     869,   746,   697,   652,    21,   109,   249,   613,   814,     4,
     653,   654,  1054,  1055,  1063,   571,   451,   946,   798,   799,
     800,   883,   884,   454,   454,    32,   450,   451,   656,   140,
     451,   454,   514,   451,   453,   373,   158,  1001,   975,   291,
     654,   571,   800,   347,   347,   451,  1052,   946,   415,   415,
     450,   160,   160,   653,   723,   723,   451
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
#else
static unsigned
yy_location_print_ (yyo, yylocp)
    FILE *yyo;
    YYLTYPE const * const yylocp;
#endif
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += fprintf (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += fprintf (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += fprintf (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += fprintf (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += fprintf (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    core_yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YYUSE (yytype);
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (core_yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    core_yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;


#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
static YYSTYPE yyval_default;
# define YY_INITIAL_VALUE(Value) = Value
#endif
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc = yyloc_default;


    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1787 of yacc.c  */
#line 768 "gram.y"
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[(1) - (1)].list);
			}
    break;

  case 3:
/* Line 1787 of yacc.c  */
#line 775 "gram.y"
    {
					if ((yyvsp[(3) - (3)].node) != NULL)
						(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
					else
						(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 4:
/* Line 1787 of yacc.c  */
#line 782 "gram.y"
    {
					if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					else
						(yyval.list) = NIL;
				}
    break;

  case 127:
/* Line 1787 of yacc.c  */
#line 914 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 128:
/* Line 1787 of yacc.c  */
#line 925 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 129:
/* Line 1787 of yacc.c  */
#line 935 "gram.y"
    {}
    break;

  case 130:
/* Line 1787 of yacc.c  */
#line 936 "gram.y"
    {}
    break;

  case 131:
/* Line 1787 of yacc.c  */
#line 937 "gram.y"
    {}
    break;

  case 132:
/* Line 1787 of yacc.c  */
#line 946 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 133:
/* Line 1787 of yacc.c  */
#line 947 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 134:
/* Line 1787 of yacc.c  */
#line 951 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 135:
/* Line 1787 of yacc.c  */
#line 952 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 136:
/* Line 1787 of yacc.c  */
#line 957 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 137:
/* Line 1787 of yacc.c  */
#line 962 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
    break;

  case 138:
/* Line 1787 of yacc.c  */
#line 966 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 139:
/* Line 1787 of yacc.c  */
#line 971 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 140:
/* Line 1787 of yacc.c  */
#line 976 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
    break;

  case 141:
/* Line 1787 of yacc.c  */
#line 980 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 142:
/* Line 1787 of yacc.c  */
#line 984 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 143:
/* Line 1787 of yacc.c  */
#line 989 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 144:
/* Line 1787 of yacc.c  */
#line 993 "gram.y"
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[(1) - (1)].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "createuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					}
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreateuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					}
					else if (strcmp((yyvsp[(1) - (1)].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[(1) - (1)].str)),
									 parser_errposition((yylsp[(1) - (1)]))));
				}
    break;

  case 145:
/* Line 1787 of yacc.c  */
#line 1050 "gram.y"
    { (yyval.defelt) = (yyvsp[(1) - (1)].defelt); }
    break;

  case 146:
/* Line 1787 of yacc.c  */
#line 1053 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				}
    break;

  case 147:
/* Line 1787 of yacc.c  */
#line 1057 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 148:
/* Line 1787 of yacc.c  */
#line 1061 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 149:
/* Line 1787 of yacc.c  */
#line 1065 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 150:
/* Line 1787 of yacc.c  */
#line 1069 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 151:
/* Line 1787 of yacc.c  */
#line 1083 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 152:
/* Line 1787 of yacc.c  */
#line 1101 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].node);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 153:
/* Line 1787 of yacc.c  */
#line 1111 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 154:
/* Line 1787 of yacc.c  */
#line 1112 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 155:
/* Line 1787 of yacc.c  */
#line 1117 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].node);
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 156:
/* Line 1787 of yacc.c  */
#line 1125 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 157:
/* Line 1787 of yacc.c  */
#line 1143 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].node);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 158:
/* Line 1787 of yacc.c  */
#line 1155 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].node);
					n->database = NULL;
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 159:
/* Line 1787 of yacc.c  */
#line 1176 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 160:
/* Line 1787 of yacc.c  */
#line 1183 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 161:
/* Line 1787 of yacc.c  */
#line 1202 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 162:
/* Line 1787 of yacc.c  */
#line 1209 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 163:
/* Line 1787 of yacc.c  */
#line 1226 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 164:
/* Line 1787 of yacc.c  */
#line 1244 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].node);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 165:
/* Line 1787 of yacc.c  */
#line 1254 "gram.y"
    { (yyval.ival) = +1; }
    break;

  case 166:
/* Line 1787 of yacc.c  */
#line 1255 "gram.y"
    { (yyval.ival) = -1; }
    break;

  case 167:
/* Line 1787 of yacc.c  */
#line 1268 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 168:
/* Line 1787 of yacc.c  */
#line 1275 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 169:
/* Line 1787 of yacc.c  */
#line 1292 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[(3) - (6)].str);
					n->authrole = (yyvsp[(5) - (6)].node);
					n->schemaElts = (yyvsp[(6) - (6)].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 170:
/* Line 1787 of yacc.c  */
#line 1302 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (4)].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[(4) - (4)].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 171:
/* Line 1787 of yacc.c  */
#line 1312 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[(6) - (9)].str);
					n->authrole = (yyvsp[(8) - (9)].node);
					if ((yyvsp[(9) - (9)].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[(9) - (9)]))));
					n->schemaElts = (yyvsp[(9) - (9)].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 172:
/* Line 1787 of yacc.c  */
#line 1327 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not here */
					n->schemaname = (yyvsp[(6) - (7)].str);
					n->authrole = NULL;
					if ((yyvsp[(7) - (7)].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[(7) - (7)]))));
					n->schemaElts = (yyvsp[(7) - (7)].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 173:
/* Line 1787 of yacc.c  */
#line 1344 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 174:
/* Line 1787 of yacc.c  */
#line 1345 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 175:
/* Line 1787 of yacc.c  */
#line 1350 "gram.y"
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[(2) - (2)]);
					(yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node));
				}
    break;

  case 176:
/* Line 1787 of yacc.c  */
#line 1356 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 183:
/* Line 1787 of yacc.c  */
#line 1384 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 184:
/* Line 1787 of yacc.c  */
#line 1390 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 185:
/* Line 1787 of yacc.c  */
#line 1396 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 186:
/* Line 1787 of yacc.c  */
#line 1405 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 187:
/* Line 1787 of yacc.c  */
#line 1413 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 189:
/* Line 1787 of yacc.c  */
#line 1425 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 190:
/* Line 1787 of yacc.c  */
#line 1433 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 191:
/* Line 1787 of yacc.c  */
#line 1441 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 192:
/* Line 1787 of yacc.c  */
#line 1448 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 193:
/* Line 1787 of yacc.c  */
#line 1456 "gram.y"
    {(yyval.vsetstmt) = (yyvsp[(1) - (1)].vsetstmt);}
    break;

  case 194:
/* Line 1787 of yacc.c  */
#line 1458 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 195:
/* Line 1787 of yacc.c  */
#line 1466 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 196:
/* Line 1787 of yacc.c  */
#line 1477 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
    break;

  case 197:
/* Line 1787 of yacc.c  */
#line 1485 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 198:
/* Line 1787 of yacc.c  */
#line 1493 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 199:
/* Line 1787 of yacc.c  */
#line 1504 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 200:
/* Line 1787 of yacc.c  */
#line 1512 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 201:
/* Line 1787 of yacc.c  */
#line 1520 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
    break;

  case 202:
/* Line 1787 of yacc.c  */
#line 1527 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 203:
/* Line 1787 of yacc.c  */
#line 1536 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 204:
/* Line 1787 of yacc.c  */
#line 1545 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 205:
/* Line 1787 of yacc.c  */
#line 1547 "gram.y"
    { (yyval.str) = psprintf("%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str)); }
    break;

  case 206:
/* Line 1787 of yacc.c  */
#line 1550 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 207:
/* Line 1787 of yacc.c  */
#line 1551 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 208:
/* Line 1787 of yacc.c  */
#line 1555 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); }
    break;

  case 209:
/* Line 1787 of yacc.c  */
#line 1557 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); }
    break;

  case 210:
/* Line 1787 of yacc.c  */
#line 1560 "gram.y"
    { (yyval.str) = "read uncommitted"; }
    break;

  case 211:
/* Line 1787 of yacc.c  */
#line 1561 "gram.y"
    { (yyval.str) = "read committed"; }
    break;

  case 212:
/* Line 1787 of yacc.c  */
#line 1562 "gram.y"
    { (yyval.str) = "repeatable read"; }
    break;

  case 213:
/* Line 1787 of yacc.c  */
#line 1563 "gram.y"
    { (yyval.str) = "serializable"; }
    break;

  case 214:
/* Line 1787 of yacc.c  */
#line 1567 "gram.y"
    { (yyval.str) = "true"; }
    break;

  case 215:
/* Line 1787 of yacc.c  */
#line 1568 "gram.y"
    { (yyval.str) = "false"; }
    break;

  case 216:
/* Line 1787 of yacc.c  */
#line 1569 "gram.y"
    { (yyval.str) = "on"; }
    break;

  case 217:
/* Line 1787 of yacc.c  */
#line 1575 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 218:
/* Line 1787 of yacc.c  */
#line 1588 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 219:
/* Line 1787 of yacc.c  */
#line 1592 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 220:
/* Line 1787 of yacc.c  */
#line 1596 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					if ((yyvsp[(3) - (3)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(3) - (3)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(3) - (3)]))));
					}
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				}
    break;

  case 221:
/* Line 1787 of yacc.c  */
#line 1611 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (5)].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (5)].str), (yylsp[(5) - (5)]), t);
				}
    break;

  case 222:
/* Line 1787 of yacc.c  */
#line 1617 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); }
    break;

  case 223:
/* Line 1787 of yacc.c  */
#line 1618 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 224:
/* Line 1787 of yacc.c  */
#line 1619 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 225:
/* Line 1787 of yacc.c  */
#line 1623 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 226:
/* Line 1787 of yacc.c  */
#line 1624 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 227:
/* Line 1787 of yacc.c  */
#line 1625 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 228:
/* Line 1787 of yacc.c  */
#line 1629 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 229:
/* Line 1787 of yacc.c  */
#line 1630 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 230:
/* Line 1787 of yacc.c  */
#line 1634 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 231:
/* Line 1787 of yacc.c  */
#line 1638 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(1) - (1)].vsetstmt); }
    break;

  case 232:
/* Line 1787 of yacc.c  */
#line 1640 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
    break;

  case 233:
/* Line 1787 of yacc.c  */
#line 1647 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
    break;

  case 234:
/* Line 1787 of yacc.c  */
#line 1654 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
    break;

  case 235:
/* Line 1787 of yacc.c  */
#line 1664 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(1) - (1)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 236:
/* Line 1787 of yacc.c  */
#line 1671 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
    break;

  case 237:
/* Line 1787 of yacc.c  */
#line 1680 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 238:
/* Line 1787 of yacc.c  */
#line 1681 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 239:
/* Line 1787 of yacc.c  */
#line 1686 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 240:
/* Line 1787 of yacc.c  */
#line 1687 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 241:
/* Line 1787 of yacc.c  */
#line 1693 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 242:
/* Line 1787 of yacc.c  */
#line 1699 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
    break;

  case 243:
/* Line 1787 of yacc.c  */
#line 1705 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
    break;

  case 244:
/* Line 1787 of yacc.c  */
#line 1711 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
    break;

  case 245:
/* Line 1787 of yacc.c  */
#line 1717 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
    break;

  case 246:
/* Line 1787 of yacc.c  */
#line 1727 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 247:
/* Line 1787 of yacc.c  */
#line 1736 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 248:
/* Line 1787 of yacc.c  */
#line 1737 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 249:
/* Line 1787 of yacc.c  */
#line 1741 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 250:
/* Line 1787 of yacc.c  */
#line 1742 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 251:
/* Line 1787 of yacc.c  */
#line 1751 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 252:
/* Line 1787 of yacc.c  */
#line 1766 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 253:
/* Line 1787 of yacc.c  */
#line 1772 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 254:
/* Line 1787 of yacc.c  */
#line 1778 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 255:
/* Line 1787 of yacc.c  */
#line 1784 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
    break;

  case 256:
/* Line 1787 of yacc.c  */
#line 1790 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
    break;

  case 257:
/* Line 1787 of yacc.c  */
#line 1809 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 258:
/* Line 1787 of yacc.c  */
#line 1818 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 259:
/* Line 1787 of yacc.c  */
#line 1827 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (10)].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[(9) - (10)].str);
					n->nowait = (yyvsp[(10) - (10)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 260:
/* Line 1787 of yacc.c  */
#line 1838 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (13)].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[(9) - (13)].list);
					n->new_tablespacename = (yyvsp[(12) - (13)].str);
					n->nowait = (yyvsp[(13) - (13)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 261:
/* Line 1787 of yacc.c  */
#line 1849 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 262:
/* Line 1787 of yacc.c  */
#line 1858 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 263:
/* Line 1787 of yacc.c  */
#line 1867 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (10)].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[(9) - (10)].str);
					n->nowait = (yyvsp[(10) - (10)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 264:
/* Line 1787 of yacc.c  */
#line 1878 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (13)].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[(9) - (13)].list);
					n->new_tablespacename = (yyvsp[(12) - (13)].str);
					n->nowait = (yyvsp[(13) - (13)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 265:
/* Line 1787 of yacc.c  */
#line 1889 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 266:
/* Line 1787 of yacc.c  */
#line 1898 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 267:
/* Line 1787 of yacc.c  */
#line 1907 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 268:
/* Line 1787 of yacc.c  */
#line 1916 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 269:
/* Line 1787 of yacc.c  */
#line 1925 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(4) - (5)].range);
					n->cmds = (yyvsp[(5) - (5)].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 270:
/* Line 1787 of yacc.c  */
#line 1934 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(6) - (7)].range);
					n->cmds = (yyvsp[(7) - (7)].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 271:
/* Line 1787 of yacc.c  */
#line 1943 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(7) - (11)].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[(10) - (11)].str);
					n->nowait = (yyvsp[(11) - (11)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 272:
/* Line 1787 of yacc.c  */
#line 1954 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(7) - (14)].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[(10) - (14)].list);
					n->new_tablespacename = (yyvsp[(13) - (14)].str);
					n->nowait = (yyvsp[(14) - (14)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 273:
/* Line 1787 of yacc.c  */
#line 1967 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 274:
/* Line 1787 of yacc.c  */
#line 1968 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 275:
/* Line 1787 of yacc.c  */
#line 1974 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 276:
/* Line 1787 of yacc.c  */
#line 1982 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 277:
/* Line 1787 of yacc.c  */
#line 1990 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 278:
/* Line 1787 of yacc.c  */
#line 1999 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 279:
/* Line 1787 of yacc.c  */
#line 2007 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 280:
/* Line 1787 of yacc.c  */
#line 2015 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeInteger((yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				}
    break;

  case 281:
/* Line 1787 of yacc.c  */
#line 2024 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 282:
/* Line 1787 of yacc.c  */
#line 2033 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 283:
/* Line 1787 of yacc.c  */
#line 2042 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				}
    break;

  case 284:
/* Line 1787 of yacc.c  */
#line 2051 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 285:
/* Line 1787 of yacc.c  */
#line 2061 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 286:
/* Line 1787 of yacc.c  */
#line 2074 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (8)].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[(6) - (8)].typnam);
					def->collClause = (CollateClause *) (yyvsp[(7) - (8)].node);
					def->raw_default = (yyvsp[(8) - (8)].node);
					def->location = (yylsp[(3) - (8)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 287:
/* Line 1787 of yacc.c  */
#line 2089 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (Node *) (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 288:
/* Line 1787 of yacc.c  */
#line 2098 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 289:
/* Line 1787 of yacc.c  */
#line 2106 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[(3) - (4)].str);
					processCASbits((yyvsp[(4) - (4)].ival), (yylsp[(4) - (4)]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 290:
/* Line 1787 of yacc.c  */
#line 2121 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 291:
/* Line 1787 of yacc.c  */
#line 2129 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 292:
/* Line 1787 of yacc.c  */
#line 2139 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 293:
/* Line 1787 of yacc.c  */
#line 2149 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 294:
/* Line 1787 of yacc.c  */
#line 2156 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 295:
/* Line 1787 of yacc.c  */
#line 2163 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 296:
/* Line 1787 of yacc.c  */
#line 2171 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 297:
/* Line 1787 of yacc.c  */
#line 2179 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *)n;
				}
    break;

  case 298:
/* Line 1787 of yacc.c  */
#line 2186 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *)n;
				}
    break;

  case 299:
/* Line 1787 of yacc.c  */
#line 2193 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 300:
/* Line 1787 of yacc.c  */
#line 2201 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 301:
/* Line 1787 of yacc.c  */
#line 2209 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 302:
/* Line 1787 of yacc.c  */
#line 2217 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 303:
/* Line 1787 of yacc.c  */
#line 2224 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 304:
/* Line 1787 of yacc.c  */
#line 2231 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 305:
/* Line 1787 of yacc.c  */
#line 2239 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 306:
/* Line 1787 of yacc.c  */
#line 2246 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 307:
/* Line 1787 of yacc.c  */
#line 2253 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 308:
/* Line 1787 of yacc.c  */
#line 2261 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 309:
/* Line 1787 of yacc.c  */
#line 2269 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 310:
/* Line 1787 of yacc.c  */
#line 2277 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 311:
/* Line 1787 of yacc.c  */
#line 2285 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 312:
/* Line 1787 of yacc.c  */
#line 2293 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 313:
/* Line 1787 of yacc.c  */
#line 2301 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[(2) - (2)].list));
					def->location = (yylsp[(2) - (2)]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
    break;

  case 314:
/* Line 1787 of yacc.c  */
#line 2311 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
    break;

  case 315:
/* Line 1787 of yacc.c  */
#line 2318 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 316:
/* Line 1787 of yacc.c  */
#line 2326 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 317:
/* Line 1787 of yacc.c  */
#line 2334 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 318:
/* Line 1787 of yacc.c  */
#line 2342 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 319:
/* Line 1787 of yacc.c  */
#line 2350 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 320:
/* Line 1787 of yacc.c  */
#line 2358 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *)n;
				}
    break;

  case 321:
/* Line 1787 of yacc.c  */
#line 2365 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *)n;
				}
    break;

  case 322:
/* Line 1787 of yacc.c  */
#line 2371 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[(1) - (1)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 323:
/* Line 1787 of yacc.c  */
#line 2380 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); }
    break;

  case 324:
/* Line 1787 of yacc.c  */
#line 2381 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 325:
/* Line 1787 of yacc.c  */
#line 2385 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; }
    break;

  case 326:
/* Line 1787 of yacc.c  */
#line 2386 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; }
    break;

  case 327:
/* Line 1787 of yacc.c  */
#line 2387 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
    break;

  case 328:
/* Line 1787 of yacc.c  */
#line 2392 "gram.y"
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[(2) - (2)].list);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 329:
/* Line 1787 of yacc.c  */
#line 2399 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 330:
/* Line 1787 of yacc.c  */
#line 2403 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 331:
/* Line 1787 of yacc.c  */
#line 2404 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 332:
/* Line 1787 of yacc.c  */
#line 2409 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 333:
/* Line 1787 of yacc.c  */
#line 2416 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 334:
/* Line 1787 of yacc.c  */
#line 2423 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 335:
/* Line 1787 of yacc.c  */
#line 2430 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 336:
/* Line 1787 of yacc.c  */
#line 2439 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 337:
/* Line 1787 of yacc.c  */
#line 2442 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 338:
/* Line 1787 of yacc.c  */
#line 2443 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 339:
/* Line 1787 of yacc.c  */
#line 2447 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 340:
/* Line 1787 of yacc.c  */
#line 2448 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 341:
/* Line 1787 of yacc.c  */
#line 2454 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				}
    break;

  case 342:
/* Line 1787 of yacc.c  */
#line 2458 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 343:
/* Line 1787 of yacc.c  */
#line 2462 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (5)].str), (yyvsp[(3) - (5)].str), (Node *) (yyvsp[(5) - (5)].node),
											 DEFELEM_UNSPEC);
				}
    break;

  case 344:
/* Line 1787 of yacc.c  */
#line 2467 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str), NULL, DEFELEM_UNSPEC);
				}
    break;

  case 345:
/* Line 1787 of yacc.c  */
#line 2482 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[(3) - (4)].list), (yylsp[(3) - (4)]), yyscanner);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 346:
/* Line 1787 of yacc.c  */
#line 2494 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 347:
/* Line 1787 of yacc.c  */
#line 2495 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 348:
/* Line 1787 of yacc.c  */
#line 2501 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (4)].node);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 349:
/* Line 1787 of yacc.c  */
#line 2510 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 350:
/* Line 1787 of yacc.c  */
#line 2520 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 351:
/* Line 1787 of yacc.c  */
#line 2530 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (8)].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[(6) - (8)].typnam);
					def->collClause = (CollateClause *) (yyvsp[(7) - (8)].node);
					def->raw_default = NULL;
					def->location = (yylsp[(3) - (8)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 352:
/* Line 1787 of yacc.c  */
#line 2556 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 353:
/* Line 1787 of yacc.c  */
#line 2562 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 354:
/* Line 1787 of yacc.c  */
#line 2593 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (11)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (11)].list);
					n->is_from = (yyvsp[(6) - (11)].boolean);
					n->is_program = (yyvsp[(7) - (11)].boolean);
					n->filename = (yyvsp[(8) - (11)].str);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[(8) - (11)]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (11)].defelt));
					if ((yyvsp[(5) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (11)].defelt));
					if ((yyvsp[(9) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(9) - (11)].defelt));
					if ((yyvsp[(11) - (11)].list))
						n->options = list_concat(n->options, (yyvsp[(11) - (11)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 355:
/* Line 1787 of yacc.c  */
#line 2621 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(2) - (7)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[(4) - (7)].boolean);
					n->filename = (yyvsp[(5) - (7)].str);
					n->options = (yyvsp[(7) - (7)].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[(5) - (7)]))));

					(yyval.node) = (Node *)n;
				}
    break;

  case 356:
/* Line 1787 of yacc.c  */
#line 2642 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 357:
/* Line 1787 of yacc.c  */
#line 2643 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 358:
/* Line 1787 of yacc.c  */
#line 2647 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 359:
/* Line 1787 of yacc.c  */
#line 2648 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 360:
/* Line 1787 of yacc.c  */
#line 2657 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 361:
/* Line 1787 of yacc.c  */
#line 2658 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 362:
/* Line 1787 of yacc.c  */
#line 2659 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 363:
/* Line 1787 of yacc.c  */
#line 2662 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 364:
/* Line 1787 of yacc.c  */
#line 2663 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 365:
/* Line 1787 of yacc.c  */
#line 2668 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 366:
/* Line 1787 of yacc.c  */
#line 2669 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 367:
/* Line 1787 of yacc.c  */
#line 2674 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
    break;

  case 368:
/* Line 1787 of yacc.c  */
#line 2678 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 369:
/* Line 1787 of yacc.c  */
#line 2682 "gram.y"
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE));
				}
    break;

  case 370:
/* Line 1787 of yacc.c  */
#line 2686 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 371:
/* Line 1787 of yacc.c  */
#line 2690 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 372:
/* Line 1787 of yacc.c  */
#line 2694 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
    break;

  case 373:
/* Line 1787 of yacc.c  */
#line 2698 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
    break;

  case 374:
/* Line 1787 of yacc.c  */
#line 2702 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 375:
/* Line 1787 of yacc.c  */
#line 2706 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 376:
/* Line 1787 of yacc.c  */
#line 2710 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 377:
/* Line 1787 of yacc.c  */
#line 2714 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
    break;

  case 378:
/* Line 1787 of yacc.c  */
#line 2718 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[(4) - (4)].list));
				}
    break;

  case 379:
/* Line 1787 of yacc.c  */
#line 2722 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 380:
/* Line 1787 of yacc.c  */
#line 2726 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 381:
/* Line 1787 of yacc.c  */
#line 2735 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
    break;

  case 382:
/* Line 1787 of yacc.c  */
#line 2738 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 383:
/* Line 1787 of yacc.c  */
#line 2743 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 384:
/* Line 1787 of yacc.c  */
#line 2746 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 385:
/* Line 1787 of yacc.c  */
#line 2751 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 386:
/* Line 1787 of yacc.c  */
#line 2754 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 387:
/* Line 1787 of yacc.c  */
#line 2758 "gram.y"
    {}
    break;

  case 388:
/* Line 1787 of yacc.c  */
#line 2759 "gram.y"
    {}
    break;

  case 389:
/* Line 1787 of yacc.c  */
#line 2765 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 390:
/* Line 1787 of yacc.c  */
#line 2769 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 391:
/* Line 1787 of yacc.c  */
#line 2776 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 392:
/* Line 1787 of yacc.c  */
#line 2782 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 393:
/* Line 1787 of yacc.c  */
#line 2783 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); }
    break;

  case 394:
/* Line 1787 of yacc.c  */
#line 2784 "gram.y"
    { (yyval.node) = (Node *) makeNode(A_Star); }
    break;

  case 395:
/* Line 1787 of yacc.c  */
#line 2785 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (3)].list); }
    break;

  case 396:
/* Line 1787 of yacc.c  */
#line 2786 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 397:
/* Line 1787 of yacc.c  */
#line 2791 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 398:
/* Line 1787 of yacc.c  */
#line 2795 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 399:
/* Line 1787 of yacc.c  */
#line 2802 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 400:
/* Line 1787 of yacc.c  */
#line 2815 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (11)].range)->relpersistence = (yyvsp[(2) - (11)].ival);
					n->relation = (yyvsp[(4) - (11)].range);
					n->tableElts = (yyvsp[(6) - (11)].list);
					n->inhRelations = (yyvsp[(8) - (11)].list);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (11)].list);
					n->oncommit = (yyvsp[(10) - (11)].oncommit);
					n->tablespacename = (yyvsp[(11) - (11)].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 401:
/* Line 1787 of yacc.c  */
#line 2832 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(7) - (14)].range)->relpersistence = (yyvsp[(2) - (14)].ival);
					n->relation = (yyvsp[(7) - (14)].range);
					n->tableElts = (yyvsp[(9) - (14)].list);
					n->inhRelations = (yyvsp[(11) - (14)].list);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[(12) - (14)].list);
					n->oncommit = (yyvsp[(13) - (14)].oncommit);
					n->tablespacename = (yyvsp[(14) - (14)].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 402:
/* Line 1787 of yacc.c  */
#line 2848 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (10)].range)->relpersistence = (yyvsp[(2) - (10)].ival);
					n->relation = (yyvsp[(4) - (10)].range);
					n->tableElts = (yyvsp[(7) - (10)].list);
					n->inhRelations = NIL;
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(6) - (10)].list));
					n->ofTypename->location = (yylsp[(6) - (10)]);
					n->constraints = NIL;
					n->options = (yyvsp[(8) - (10)].list);
					n->oncommit = (yyvsp[(9) - (10)].oncommit);
					n->tablespacename = (yyvsp[(10) - (10)].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 403:
/* Line 1787 of yacc.c  */
#line 2865 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(7) - (13)].range)->relpersistence = (yyvsp[(2) - (13)].ival);
					n->relation = (yyvsp[(7) - (13)].range);
					n->tableElts = (yyvsp[(10) - (13)].list);
					n->inhRelations = NIL;
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(9) - (13)].list));
					n->ofTypename->location = (yylsp[(9) - (13)]);
					n->constraints = NIL;
					n->options = (yyvsp[(11) - (13)].list);
					n->oncommit = (yyvsp[(12) - (13)].oncommit);
					n->tablespacename = (yyvsp[(13) - (13)].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 404:
/* Line 1787 of yacc.c  */
#line 2893 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 405:
/* Line 1787 of yacc.c  */
#line 2894 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 406:
/* Line 1787 of yacc.c  */
#line 2895 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 407:
/* Line 1787 of yacc.c  */
#line 2896 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 408:
/* Line 1787 of yacc.c  */
#line 2898 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
    break;

  case 409:
/* Line 1787 of yacc.c  */
#line 2905 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
    break;

  case 410:
/* Line 1787 of yacc.c  */
#line 2911 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
    break;

  case 411:
/* Line 1787 of yacc.c  */
#line 2912 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
    break;

  case 412:
/* Line 1787 of yacc.c  */
#line 2916 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 413:
/* Line 1787 of yacc.c  */
#line 2917 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 414:
/* Line 1787 of yacc.c  */
#line 2921 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 415:
/* Line 1787 of yacc.c  */
#line 2922 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 416:
/* Line 1787 of yacc.c  */
#line 2927 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 417:
/* Line 1787 of yacc.c  */
#line 2931 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 418:
/* Line 1787 of yacc.c  */
#line 2938 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 419:
/* Line 1787 of yacc.c  */
#line 2942 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 420:
/* Line 1787 of yacc.c  */
#line 2948 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 421:
/* Line 1787 of yacc.c  */
#line 2949 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 422:
/* Line 1787 of yacc.c  */
#line 2950 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 423:
/* Line 1787 of yacc.c  */
#line 2954 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 424:
/* Line 1787 of yacc.c  */
#line 2955 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 425:
/* Line 1787 of yacc.c  */
#line 2959 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typeName = (yyvsp[(2) - (4)].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[(3) - (4)].list);
					SplitColQualList((yyvsp[(4) - (4)].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 426:
/* Line 1787 of yacc.c  */
#line 2980 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[(4) - (4)].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 427:
/* Line 1787 of yacc.c  */
#line 3000 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 428:
/* Line 1787 of yacc.c  */
#line 3001 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 429:
/* Line 1787 of yacc.c  */
#line 3006 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 430:
/* Line 1787 of yacc.c  */
#line 3013 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 431:
/* Line 1787 of yacc.c  */
#line 3014 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 432:
/* Line 1787 of yacc.c  */
#line 3016 "gram.y"
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[(2) - (2)].list);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 433:
/* Line 1787 of yacc.c  */
#line 3047 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 434:
/* Line 1787 of yacc.c  */
#line 3054 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 435:
/* Line 1787 of yacc.c  */
#line 3061 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 436:
/* Line 1787 of yacc.c  */
#line 3072 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 437:
/* Line 1787 of yacc.c  */
#line 3083 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->is_no_inherit = (yyvsp[(5) - (5)].boolean);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 438:
/* Line 1787 of yacc.c  */
#line 3093 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[(1) - (2)]);
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 439:
/* Line 1787 of yacc.c  */
#line 3102 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (5)]);
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 440:
/* Line 1787 of yacc.c  */
#line 3135 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 441:
/* Line 1787 of yacc.c  */
#line 3142 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 442:
/* Line 1787 of yacc.c  */
#line 3149 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 443:
/* Line 1787 of yacc.c  */
#line 3156 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 444:
/* Line 1787 of yacc.c  */
#line 3167 "gram.y"
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 445:
/* Line 1787 of yacc.c  */
#line 3176 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 446:
/* Line 1787 of yacc.c  */
#line 3177 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) & ~(yyvsp[(3) - (3)].ival); }
    break;

  case 447:
/* Line 1787 of yacc.c  */
#line 3178 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 448:
/* Line 1787 of yacc.c  */
#line 3182 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
    break;

  case 449:
/* Line 1787 of yacc.c  */
#line 3183 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
    break;

  case 450:
/* Line 1787 of yacc.c  */
#line 3184 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
    break;

  case 451:
/* Line 1787 of yacc.c  */
#line 3185 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
    break;

  case 452:
/* Line 1787 of yacc.c  */
#line 3186 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
    break;

  case 453:
/* Line 1787 of yacc.c  */
#line 3187 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
    break;

  case 454:
/* Line 1787 of yacc.c  */
#line 3197 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 455:
/* Line 1787 of yacc.c  */
#line 3204 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 456:
/* Line 1787 of yacc.c  */
#line 3209 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[(5) - (5)].ival), (yylsp[(5) - (5)]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
    break;

  case 457:
/* Line 1787 of yacc.c  */
#line 3223 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (7)]);
					n->keys = (yyvsp[(3) - (7)].list);
					n->options = (yyvsp[(5) - (7)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(6) - (7)].str);
					processCASbits((yyvsp[(7) - (7)].ival), (yylsp[(7) - (7)]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 458:
/* Line 1787 of yacc.c  */
#line 3237 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[(2) - (3)].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[(3) - (3)].ival), (yylsp[(3) - (3)]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 459:
/* Line 1787 of yacc.c  */
#line 3252 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (8)]);
					n->keys = (yyvsp[(4) - (8)].list);
					n->options = (yyvsp[(6) - (8)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(7) - (8)].str);
					processCASbits((yyvsp[(8) - (8)].ival), (yylsp[(8) - (8)]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 460:
/* Line 1787 of yacc.c  */
#line 3266 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[(3) - (4)].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[(4) - (4)].ival), (yylsp[(4) - (4)]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 461:
/* Line 1787 of yacc.c  */
#line 3282 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[(1) - (9)]);
					n->access_method	= (yyvsp[(2) - (9)].str);
					n->exclusions		= (yyvsp[(4) - (9)].list);
					n->options			= (yyvsp[(6) - (9)].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[(7) - (9)].str);
					n->where_clause		= (yyvsp[(8) - (9)].node);
					processCASbits((yyvsp[(9) - (9)].ival), (yylsp[(9) - (9)]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 462:
/* Line 1787 of yacc.c  */
#line 3299 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (11)]);
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					processCASbits((yyvsp[(11) - (11)].ival), (yylsp[(11) - (11)]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
    break;

  case 463:
/* Line 1787 of yacc.c  */
#line 3318 "gram.y"
    {  (yyval.boolean) = TRUE; }
    break;

  case 464:
/* Line 1787 of yacc.c  */
#line 3319 "gram.y"
    {  (yyval.boolean) = FALSE; }
    break;

  case 465:
/* Line 1787 of yacc.c  */
#line 3323 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 466:
/* Line 1787 of yacc.c  */
#line 3324 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 467:
/* Line 1787 of yacc.c  */
#line 3328 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 468:
/* Line 1787 of yacc.c  */
#line 3329 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 469:
/* Line 1787 of yacc.c  */
#line 3333 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				}
    break;

  case 470:
/* Line 1787 of yacc.c  */
#line 3339 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
    break;

  case 471:
/* Line 1787 of yacc.c  */
#line 3343 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[(1) - (2)]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
    break;

  case 472:
/* Line 1787 of yacc.c  */
#line 3351 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
    break;

  case 473:
/* Line 1787 of yacc.c  */
#line 3355 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
    break;

  case 474:
/* Line 1787 of yacc.c  */
#line 3361 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 475:
/* Line 1787 of yacc.c  */
#line 3363 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 476:
/* Line 1787 of yacc.c  */
#line 3367 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (3)].ielem), (yyvsp[(3) - (3)].list));
			}
    break;

  case 477:
/* Line 1787 of yacc.c  */
#line 3372 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (6)].ielem), (yyvsp[(5) - (6)].list));
			}
    break;

  case 478:
/* Line 1787 of yacc.c  */
#line 3378 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 479:
/* Line 1787 of yacc.c  */
#line 3379 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 480:
/* Line 1787 of yacc.c  */
#line 3390 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 481:
/* Line 1787 of yacc.c  */
#line 3392 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); }
    break;

  case 482:
/* Line 1787 of yacc.c  */
#line 3394 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); }
    break;

  case 483:
/* Line 1787 of yacc.c  */
#line 3396 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); }
    break;

  case 484:
/* Line 1787 of yacc.c  */
#line 3398 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 485:
/* Line 1787 of yacc.c  */
#line 3401 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 486:
/* Line 1787 of yacc.c  */
#line 3404 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 487:
/* Line 1787 of yacc.c  */
#line 3408 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
    break;

  case 488:
/* Line 1787 of yacc.c  */
#line 3409 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
    break;

  case 489:
/* Line 1787 of yacc.c  */
#line 3410 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
    break;

  case 490:
/* Line 1787 of yacc.c  */
#line 3411 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
    break;

  case 491:
/* Line 1787 of yacc.c  */
#line 3412 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
    break;

  case 492:
/* Line 1787 of yacc.c  */
#line 3415 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 493:
/* Line 1787 of yacc.c  */
#line 3416 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 494:
/* Line 1787 of yacc.c  */
#line 3421 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 495:
/* Line 1787 of yacc.c  */
#line 3422 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); }
    break;

  case 496:
/* Line 1787 of yacc.c  */
#line 3423 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); }
    break;

  case 497:
/* Line 1787 of yacc.c  */
#line 3424 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 498:
/* Line 1787 of yacc.c  */
#line 3427 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; }
    break;

  case 499:
/* Line 1787 of yacc.c  */
#line 3428 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
    break;

  case 500:
/* Line 1787 of yacc.c  */
#line 3429 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
    break;

  case 501:
/* Line 1787 of yacc.c  */
#line 3430 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
    break;

  case 502:
/* Line 1787 of yacc.c  */
#line 3433 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 503:
/* Line 1787 of yacc.c  */
#line 3434 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 504:
/* Line 1787 of yacc.c  */
#line 3437 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); }
    break;

  case 505:
/* Line 1787 of yacc.c  */
#line 3438 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 506:
/* Line 1787 of yacc.c  */
#line 3441 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 507:
/* Line 1787 of yacc.c  */
#line 3457 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(6) - (7)].node);
					ctas->into = (yyvsp[(4) - (7)].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(4) - (7)].into)->rel->relpersistence = (yyvsp[(2) - (7)].ival);
					(yyvsp[(4) - (7)].into)->skipData = !((yyvsp[(7) - (7)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 508:
/* Line 1787 of yacc.c  */
#line 3470 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(9) - (10)].node);
					ctas->into = (yyvsp[(7) - (10)].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[(7) - (10)].into)->rel->relpersistence = (yyvsp[(2) - (10)].ival);
					(yyvsp[(7) - (10)].into)->skipData = !((yyvsp[(10) - (10)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 509:
/* Line 1787 of yacc.c  */
#line 3486 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
    break;

  case 510:
/* Line 1787 of yacc.c  */
#line 3499 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 511:
/* Line 1787 of yacc.c  */
#line 3500 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 512:
/* Line 1787 of yacc.c  */
#line 3501 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 513:
/* Line 1787 of yacc.c  */
#line 3514 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(7) - (8)].node);
					ctas->into = (yyvsp[(5) - (8)].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(5) - (8)].into)->rel->relpersistence = (yyvsp[(2) - (8)].ival);
					(yyvsp[(5) - (8)].into)->skipData = !((yyvsp[(8) - (8)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 514:
/* Line 1787 of yacc.c  */
#line 3527 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(10) - (11)].node);
					ctas->into = (yyvsp[(8) - (11)].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[(8) - (11)].into)->rel->relpersistence = (yyvsp[(2) - (11)].ival);
					(yyvsp[(8) - (11)].into)->skipData = !((yyvsp[(11) - (11)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 515:
/* Line 1787 of yacc.c  */
#line 3543 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (4)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (4)].list);
					(yyval.into)->options = (yyvsp[(3) - (4)].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[(4) - (4)].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
    break;

  case 516:
/* Line 1787 of yacc.c  */
#line 3555 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
    break;

  case 517:
/* Line 1787 of yacc.c  */
#line 3556 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
    break;

  case 518:
/* Line 1787 of yacc.c  */
#line 3569 "gram.y"
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[(4) - (6)].boolean);
					n->relation = (yyvsp[(5) - (6)].range);
					n->skipData = !((yyvsp[(6) - (6)].boolean));
					(yyval.node) = (Node *) n;
				}
    break;

  case 519:
/* Line 1787 of yacc.c  */
#line 3589 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (5)].range)->relpersistence = (yyvsp[(2) - (5)].ival);
					n->sequence = (yyvsp[(4) - (5)].range);
					n->options = (yyvsp[(5) - (5)].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 520:
/* Line 1787 of yacc.c  */
#line 3599 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(7) - (8)].range)->relpersistence = (yyvsp[(2) - (8)].ival);
					n->sequence = (yyvsp[(7) - (8)].range);
					n->options = (yyvsp[(8) - (8)].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 521:
/* Line 1787 of yacc.c  */
#line 3612 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 522:
/* Line 1787 of yacc.c  */
#line 3620 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(5) - (6)].range);
					n->options = (yyvsp[(6) - (6)].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 523:
/* Line 1787 of yacc.c  */
#line 3630 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 524:
/* Line 1787 of yacc.c  */
#line 3631 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 525:
/* Line 1787 of yacc.c  */
#line 3634 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 526:
/* Line 1787 of yacc.c  */
#line 3635 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 527:
/* Line 1787 of yacc.c  */
#line 3639 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 528:
/* Line 1787 of yacc.c  */
#line 3643 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
    break;

  case 529:
/* Line 1787 of yacc.c  */
#line 3647 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
    break;

  case 530:
/* Line 1787 of yacc.c  */
#line 3651 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 531:
/* Line 1787 of yacc.c  */
#line 3655 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 532:
/* Line 1787 of yacc.c  */
#line 3659 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 533:
/* Line 1787 of yacc.c  */
#line 3663 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
    break;

  case 534:
/* Line 1787 of yacc.c  */
#line 3667 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
    break;

  case 535:
/* Line 1787 of yacc.c  */
#line 3671 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 536:
/* Line 1787 of yacc.c  */
#line 3675 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 537:
/* Line 1787 of yacc.c  */
#line 3679 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
    break;

  case 538:
/* Line 1787 of yacc.c  */
#line 3683 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 539:
/* Line 1787 of yacc.c  */
#line 3688 "gram.y"
    {}
    break;

  case 540:
/* Line 1787 of yacc.c  */
#line 3689 "gram.y"
    {}
    break;

  case 541:
/* Line 1787 of yacc.c  */
#line 3693 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); }
    break;

  case 542:
/* Line 1787 of yacc.c  */
#line 3695 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				}
    break;

  case 543:
/* Line 1787 of yacc.c  */
#line 3699 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); }
    break;

  case 544:
/* Line 1787 of yacc.c  */
#line 3702 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 545:
/* Line 1787 of yacc.c  */
#line 3703 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 546:
/* Line 1787 of yacc.c  */
#line 3716 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (6)].boolean);
				n->plname = (yyvsp[(6) - (6)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
    break;

  case 547:
/* Line 1787 of yacc.c  */
#line 3729 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (10)].boolean);
				n->plname = (yyvsp[(6) - (10)].str);
				n->plhandler = (yyvsp[(8) - (10)].list);
				n->plinline = (yyvsp[(9) - (10)].list);
				n->plvalidator = (yyvsp[(10) - (10)].list);
				n->pltrusted = (yyvsp[(3) - (10)].boolean);
				(yyval.node) = (Node *)n;
			}
    break;

  case 548:
/* Line 1787 of yacc.c  */
#line 3742 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 549:
/* Line 1787 of yacc.c  */
#line 3743 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 550:
/* Line 1787 of yacc.c  */
#line 3751 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 551:
/* Line 1787 of yacc.c  */
#line 3752 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 552:
/* Line 1787 of yacc.c  */
#line 3756 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 553:
/* Line 1787 of yacc.c  */
#line 3757 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 554:
/* Line 1787 of yacc.c  */
#line 3761 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 555:
/* Line 1787 of yacc.c  */
#line 3762 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 556:
/* Line 1787 of yacc.c  */
#line 3766 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 557:
/* Line 1787 of yacc.c  */
#line 3767 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 558:
/* Line 1787 of yacc.c  */
#line 3772 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[(4) - (5)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 559:
/* Line 1787 of yacc.c  */
#line 3783 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 560:
/* Line 1787 of yacc.c  */
#line 3795 "gram.y"
    {}
    break;

  case 561:
/* Line 1787 of yacc.c  */
#line 3796 "gram.y"
    {}
    break;

  case 562:
/* Line 1787 of yacc.c  */
#line 3807 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (7)].str);
					n->owner = (yyvsp[(4) - (7)].node);
					n->location = (yyvsp[(6) - (7)].str);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 563:
/* Line 1787 of yacc.c  */
#line 3817 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 564:
/* Line 1787 of yacc.c  */
#line 3818 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 565:
/* Line 1787 of yacc.c  */
#line 3832 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 566:
/* Line 1787 of yacc.c  */
#line 3839 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 567:
/* Line 1787 of yacc.c  */
#line 3856 "gram.y"
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[(3) - (5)].str);
					n->if_not_exists = false;
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 568:
/* Line 1787 of yacc.c  */
#line 3864 "gram.y"
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[(6) - (8)].str);
					n->if_not_exists = true;
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 569:
/* Line 1787 of yacc.c  */
#line 3875 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 570:
/* Line 1787 of yacc.c  */
#line 3877 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 571:
/* Line 1787 of yacc.c  */
#line 3882 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 572:
/* Line 1787 of yacc.c  */
#line 3886 "gram.y"
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 573:
/* Line 1787 of yacc.c  */
#line 3890 "gram.y"
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 574:
/* Line 1787 of yacc.c  */
#line 3902 "gram.y"
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 575:
/* Line 1787 of yacc.c  */
#line 3912 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 576:
/* Line 1787 of yacc.c  */
#line 3914 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 577:
/* Line 1787 of yacc.c  */
#line 3919 "gram.y"
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 578:
/* Line 1787 of yacc.c  */
#line 3932 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(6) - (7)].list);
					n->objargs = extractAggrArgTypes((yyvsp[(7) - (7)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 579:
/* Line 1787 of yacc.c  */
#line 3942 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (10)].str);
					n->action = (yyvsp[(4) - (10)].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(7) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(9) - (10)].typnam));
					(yyval.node) = (Node *) n;
				}
    break;

  case 580:
/* Line 1787 of yacc.c  */
#line 3952 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 581:
/* Line 1787 of yacc.c  */
#line 3961 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 582:
/* Line 1787 of yacc.c  */
#line 3970 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = list_make1((yyvsp[(6) - (6)].typnam));
					(yyval.node) = (Node *)n;
				}
    break;

  case 583:
/* Line 1787 of yacc.c  */
#line 3979 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(6) - (6)].funwithargs)->funcname;
					n->objargs = (yyvsp[(6) - (6)].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
    break;

  case 584:
/* Line 1787 of yacc.c  */
#line 3989 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[(7) - (7)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 585:
/* Line 1787 of yacc.c  */
#line 3998 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(6) - (7)].list);
					n->objargs = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 586:
/* Line 1787 of yacc.c  */
#line 4008 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = lcons(makeString((yyvsp[(9) - (9)].str)), (yyvsp[(7) - (9)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 587:
/* Line 1787 of yacc.c  */
#line 4017 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = lcons(makeString((yyvsp[(9) - (9)].str)), (yyvsp[(7) - (9)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 588:
/* Line 1787 of yacc.c  */
#line 4026 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[(6) - (6)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 589:
/* Line 1787 of yacc.c  */
#line 4035 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->objname = list_make1(makeString((yyvsp[(7) - (7)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 590:
/* Line 1787 of yacc.c  */
#line 4044 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 591:
/* Line 1787 of yacc.c  */
#line 4053 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 592:
/* Line 1787 of yacc.c  */
#line 4062 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 593:
/* Line 1787 of yacc.c  */
#line 4071 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 594:
/* Line 1787 of yacc.c  */
#line 4080 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 595:
/* Line 1787 of yacc.c  */
#line 4089 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 596:
/* Line 1787 of yacc.c  */
#line 4098 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 597:
/* Line 1787 of yacc.c  */
#line 4107 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_MATVIEW;
					n->objname = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 598:
/* Line 1787 of yacc.c  */
#line 4116 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 599:
/* Line 1787 of yacc.c  */
#line 4125 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[(8) - (8)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 600:
/* Line 1787 of yacc.c  */
#line 4134 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[(6) - (6)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 601:
/* Line 1787 of yacc.c  */
#line 4143 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->objname = list_make1((yyvsp[(7) - (9)].typnam));
					n->objargs = list_make1(makeString((yyvsp[(9) - (9)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 602:
/* Line 1787 of yacc.c  */
#line 4153 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[(6) - (6)].typnam));
					(yyval.node) = (Node *)n;
				}
    break;

  case 603:
/* Line 1787 of yacc.c  */
#line 4171 "gram.y"
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->func_options = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 604:
/* Line 1787 of yacc.c  */
#line 4181 "gram.y"
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[(2) - (2)].list)); }
    break;

  case 605:
/* Line 1787 of yacc.c  */
#line 4182 "gram.y"
    { (yyval.defelt) = makeDefElem("handler", NULL); }
    break;

  case 606:
/* Line 1787 of yacc.c  */
#line 4183 "gram.y"
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[(2) - (2)].list)); }
    break;

  case 607:
/* Line 1787 of yacc.c  */
#line 4184 "gram.y"
    { (yyval.defelt) = makeDefElem("validator", NULL); }
    break;

  case 608:
/* Line 1787 of yacc.c  */
#line 4188 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 609:
/* Line 1787 of yacc.c  */
#line 4189 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 610:
/* Line 1787 of yacc.c  */
#line 4193 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 611:
/* Line 1787 of yacc.c  */
#line 4194 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 612:
/* Line 1787 of yacc.c  */
#line 4205 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[(5) - (6)].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 613:
/* Line 1787 of yacc.c  */
#line 4216 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[(7) - (8)].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 614:
/* Line 1787 of yacc.c  */
#line 4236 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->func_options = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 615:
/* Line 1787 of yacc.c  */
#line 4244 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->func_options = (yyvsp[(6) - (6)].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 616:
/* Line 1787 of yacc.c  */
#line 4255 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 617:
/* Line 1787 of yacc.c  */
#line 4256 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 618:
/* Line 1787 of yacc.c  */
#line 4261 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 619:
/* Line 1787 of yacc.c  */
#line 4265 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 620:
/* Line 1787 of yacc.c  */
#line 4272 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 621:
/* Line 1787 of yacc.c  */
#line 4277 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 622:
/* Line 1787 of yacc.c  */
#line 4281 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 623:
/* Line 1787 of yacc.c  */
#line 4288 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 624:
/* Line 1787 of yacc.c  */
#line 4292 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
    break;

  case 625:
/* Line 1787 of yacc.c  */
#line 4297 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
    break;

  case 626:
/* Line 1787 of yacc.c  */
#line 4302 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[(2) - (2)].str), NULL, DEFELEM_DROP);
				}
    break;

  case 627:
/* Line 1787 of yacc.c  */
#line 4309 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 628:
/* Line 1787 of yacc.c  */
#line 4315 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 629:
/* Line 1787 of yacc.c  */
#line 4320 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 630:
/* Line 1787 of yacc.c  */
#line 4332 "gram.y"
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[(3) - (10)].str);
					n->servertype = (yyvsp[(4) - (10)].str);
					n->version = (yyvsp[(5) - (10)].str);
					n->fdwname = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 631:
/* Line 1787 of yacc.c  */
#line 4344 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 632:
/* Line 1787 of yacc.c  */
#line 4345 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 633:
/* Line 1787 of yacc.c  */
#line 4350 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 634:
/* Line 1787 of yacc.c  */
#line 4351 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 635:
/* Line 1787 of yacc.c  */
#line 4355 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 636:
/* Line 1787 of yacc.c  */
#line 4356 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 637:
/* Line 1787 of yacc.c  */
#line 4367 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[(3) - (4)].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 638:
/* Line 1787 of yacc.c  */
#line 4378 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[(5) - (6)].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 639:
/* Line 1787 of yacc.c  */
#line 4398 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (5)].str);
					n->version = (yyvsp[(4) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 640:
/* Line 1787 of yacc.c  */
#line 4407 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->version = (yyvsp[(4) - (4)].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 641:
/* Line 1787 of yacc.c  */
#line 4415 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 642:
/* Line 1787 of yacc.c  */
#line 4434 "gram.y"
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[(4) - (11)].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[(4) - (11)].range);
					n->base.tableElts = (yyvsp[(6) - (11)].list);
					n->base.inhRelations = (yyvsp[(8) - (11)].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[(10) - (11)].str);
					n->options = (yyvsp[(11) - (11)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 643:
/* Line 1787 of yacc.c  */
#line 4454 "gram.y"
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[(7) - (14)].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[(7) - (14)].range);
					n->base.tableElts = (yyvsp[(9) - (14)].list);
					n->base.inhRelations = (yyvsp[(11) - (14)].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[(13) - (14)].str);
					n->options = (yyvsp[(14) - (14)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 644:
/* Line 1787 of yacc.c  */
#line 4482 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(4) - (5)].range);
					n->cmds = (yyvsp[(5) - (5)].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 645:
/* Line 1787 of yacc.c  */
#line 4491 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(6) - (7)].range);
					n->cmds = (yyvsp[(7) - (7)].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 646:
/* Line 1787 of yacc.c  */
#line 4513 "gram.y"
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);
				n->server_name = (yyvsp[(8) - (11)].str);
				n->remote_schema = (yyvsp[(4) - (11)].str);
				n->local_schema = (yyvsp[(10) - (11)].str);
				n->list_type = (yyvsp[(5) - (11)].importqual)->type;
				n->table_list = (yyvsp[(5) - (11)].importqual)->table_names;
				n->options = (yyvsp[(11) - (11)].list);
				(yyval.node) = (Node *) n;
			}
    break;

  case 647:
/* Line 1787 of yacc.c  */
#line 4526 "gram.y"
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
    break;

  case 648:
/* Line 1787 of yacc.c  */
#line 4527 "gram.y"
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
    break;

  case 649:
/* Line 1787 of yacc.c  */
#line 4532 "gram.y"
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = (yyvsp[(1) - (4)].ival);
				n->table_names = (yyvsp[(3) - (4)].list);
				(yyval.importqual) = n;
			}
    break;

  case 650:
/* Line 1787 of yacc.c  */
#line 4539 "gram.y"
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
    break;

  case 651:
/* Line 1787 of yacc.c  */
#line 4555 "gram.y"
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[(5) - (8)].node);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 652:
/* Line 1787 of yacc.c  */
#line 4565 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 653:
/* Line 1787 of yacc.c  */
#line 4566 "gram.y"
    { (yyval.node) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[(1) - (1)])); }
    break;

  case 654:
/* Line 1787 of yacc.c  */
#line 4577 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[(5) - (7)].node);
					n->servername = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 655:
/* Line 1787 of yacc.c  */
#line 4585 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[(7) - (9)].node);
					n->servername = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 656:
/* Line 1787 of yacc.c  */
#line 4602 "gram.y"
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->user = (yyvsp[(5) - (8)].node);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 657:
/* Line 1787 of yacc.c  */
#line 4626 "gram.y"
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);
					n->policy_name = (yyvsp[(3) - (9)].str);
					n->table = (yyvsp[(5) - (9)].range);
					n->cmd_name = (yyvsp[(6) - (9)].str);
					n->roles = (yyvsp[(7) - (9)].list);
					n->qual = (yyvsp[(8) - (9)].node);
					n->with_check = (yyvsp[(9) - (9)].node);
					(yyval.node) = (Node *) n;
				}
    break;

  case 658:
/* Line 1787 of yacc.c  */
#line 4641 "gram.y"
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);
					n->policy_name = (yyvsp[(3) - (8)].str);
					n->table = (yyvsp[(5) - (8)].range);
					n->roles = (yyvsp[(6) - (8)].list);
					n->qual = (yyvsp[(7) - (8)].node);
					n->with_check = (yyvsp[(8) - (8)].node);
					(yyval.node) = (Node *) n;
				}
    break;

  case 659:
/* Line 1787 of yacc.c  */
#line 4654 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_POLICY;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 660:
/* Line 1787 of yacc.c  */
#line 4665 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_POLICY;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 661:
/* Line 1787 of yacc.c  */
#line 4678 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 662:
/* Line 1787 of yacc.c  */
#line 4679 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 663:
/* Line 1787 of yacc.c  */
#line 4683 "gram.y"
    { (yyval.node) = (yyvsp[(4) - (5)].node); }
    break;

  case 664:
/* Line 1787 of yacc.c  */
#line 4684 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 665:
/* Line 1787 of yacc.c  */
#line 4688 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 666:
/* Line 1787 of yacc.c  */
#line 4689 "gram.y"
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
    break;

  case 667:
/* Line 1787 of yacc.c  */
#line 4693 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 668:
/* Line 1787 of yacc.c  */
#line 4694 "gram.y"
    { (yyval.list) = NULL; }
    break;

  case 669:
/* Line 1787 of yacc.c  */
#line 4698 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 670:
/* Line 1787 of yacc.c  */
#line 4699 "gram.y"
    { (yyval.str) = "all"; }
    break;

  case 671:
/* Line 1787 of yacc.c  */
#line 4703 "gram.y"
    { (yyval.str) = "all"; }
    break;

  case 672:
/* Line 1787 of yacc.c  */
#line 4704 "gram.y"
    { (yyval.str) = "select"; }
    break;

  case 673:
/* Line 1787 of yacc.c  */
#line 4705 "gram.y"
    { (yyval.str) = "insert"; }
    break;

  case 674:
/* Line 1787 of yacc.c  */
#line 4706 "gram.y"
    { (yyval.str) = "update"; }
    break;

  case 675:
/* Line 1787 of yacc.c  */
#line 4707 "gram.y"
    { (yyval.str) = "delete"; }
    break;

  case 676:
/* Line 1787 of yacc.c  */
#line 4722 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (15)].str);
					n->relation = (yyvsp[(7) - (15)].range);
					n->funcname = (yyvsp[(12) - (15)].list);
					n->args = (yyvsp[(14) - (15)].list);
					n->row = (yyvsp[(8) - (15)].boolean);
					n->timing = (yyvsp[(4) - (15)].ival);
					n->events = intVal(linitial((yyvsp[(5) - (15)].list)));
					n->columns = (List *) lsecond((yyvsp[(5) - (15)].list));
					n->whenClause = (yyvsp[(9) - (15)].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 677:
/* Line 1787 of yacc.c  */
#line 4743 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (20)].str);
					n->relation = (yyvsp[(8) - (20)].range);
					n->funcname = (yyvsp[(17) - (20)].list);
					n->args = (yyvsp[(19) - (20)].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[(6) - (20)].list)));
					n->columns = (List *) lsecond((yyvsp[(6) - (20)].list));
					n->whenClause = (yyvsp[(14) - (20)].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[(10) - (20)].ival), (yylsp[(10) - (20)]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[(9) - (20)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 678:
/* Line 1787 of yacc.c  */
#line 4764 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
    break;

  case 679:
/* Line 1787 of yacc.c  */
#line 4765 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
    break;

  case 680:
/* Line 1787 of yacc.c  */
#line 4766 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
    break;

  case 681:
/* Line 1787 of yacc.c  */
#line 4771 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 682:
/* Line 1787 of yacc.c  */
#line 4773 "gram.y"
    {
					int		events1 = intVal(linitial((yyvsp[(1) - (3)].list)));
					int		events2 = intVal(linitial((yyvsp[(3) - (3)].list)));
					List   *columns1 = (List *) lsecond((yyvsp[(1) - (3)].list));
					List   *columns2 = (List *) lsecond((yyvsp[(3) - (3)].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
    break;

  case 683:
/* Line 1787 of yacc.c  */
#line 4795 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
    break;

  case 684:
/* Line 1787 of yacc.c  */
#line 4797 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
    break;

  case 685:
/* Line 1787 of yacc.c  */
#line 4799 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
    break;

  case 686:
/* Line 1787 of yacc.c  */
#line 4801 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[(3) - (3)].list)); }
    break;

  case 687:
/* Line 1787 of yacc.c  */
#line 4803 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
    break;

  case 688:
/* Line 1787 of yacc.c  */
#line 4808 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				}
    break;

  case 689:
/* Line 1787 of yacc.c  */
#line 4812 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
    break;

  case 690:
/* Line 1787 of yacc.c  */
#line 4822 "gram.y"
    {}
    break;

  case 691:
/* Line 1787 of yacc.c  */
#line 4823 "gram.y"
    {}
    break;

  case 692:
/* Line 1787 of yacc.c  */
#line 4827 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 693:
/* Line 1787 of yacc.c  */
#line 4828 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 694:
/* Line 1787 of yacc.c  */
#line 4832 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 695:
/* Line 1787 of yacc.c  */
#line 4833 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 696:
/* Line 1787 of yacc.c  */
#line 4837 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 697:
/* Line 1787 of yacc.c  */
#line 4838 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 698:
/* Line 1787 of yacc.c  */
#line 4839 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 699:
/* Line 1787 of yacc.c  */
#line 4844 "gram.y"
    {
					(yyval.value) = makeString(psprintf("%d", (yyvsp[(1) - (1)].ival)));
				}
    break;

  case 700:
/* Line 1787 of yacc.c  */
#line 4847 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 701:
/* Line 1787 of yacc.c  */
#line 4848 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 702:
/* Line 1787 of yacc.c  */
#line 4849 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 703:
/* Line 1787 of yacc.c  */
#line 4853 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); }
    break;

  case 704:
/* Line 1787 of yacc.c  */
#line 4854 "gram.y"
    { (yyval.range) = NULL; }
    break;

  case 705:
/* Line 1787 of yacc.c  */
#line 4859 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 706:
/* Line 1787 of yacc.c  */
#line 4861 "gram.y"
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(2) - (2)]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.ival) = newspec;
				}
    break;

  case 707:
/* Line 1787 of yacc.c  */
#line 4887 "gram.y"
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
    break;

  case 708:
/* Line 1787 of yacc.c  */
#line 4888 "gram.y"
    { (yyval.ival) = CAS_DEFERRABLE; }
    break;

  case 709:
/* Line 1787 of yacc.c  */
#line 4889 "gram.y"
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
    break;

  case 710:
/* Line 1787 of yacc.c  */
#line 4890 "gram.y"
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
    break;

  case 711:
/* Line 1787 of yacc.c  */
#line 4891 "gram.y"
    { (yyval.ival) = CAS_NOT_VALID; }
    break;

  case 712:
/* Line 1787 of yacc.c  */
#line 4892 "gram.y"
    { (yyval.ival) = CAS_NO_INHERIT; }
    break;

  case 713:
/* Line 1787 of yacc.c  */
#line 4898 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 714:
/* Line 1787 of yacc.c  */
#line 4909 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 715:
/* Line 1787 of yacc.c  */
#line 4933 "gram.y"
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[(4) - (11)].str);
					n->eventname = (yyvsp[(6) - (11)].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[(9) - (11)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 716:
/* Line 1787 of yacc.c  */
#line 4944 "gram.y"
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[(4) - (13)].str);
					n->eventname = (yyvsp[(6) - (13)].str);
					n->whenclause = (yyvsp[(8) - (13)].list);
					n->funcname = (yyvsp[(11) - (13)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 717:
/* Line 1787 of yacc.c  */
#line 4956 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 718:
/* Line 1787 of yacc.c  */
#line 4958 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 719:
/* Line 1787 of yacc.c  */
#line 4963 "gram.y"
    { (yyval.defelt) = makeDefElem((yyvsp[(1) - (5)].str), (Node *) (yyvsp[(4) - (5)].list)); }
    break;

  case 720:
/* Line 1787 of yacc.c  */
#line 4968 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 721:
/* Line 1787 of yacc.c  */
#line 4970 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 722:
/* Line 1787 of yacc.c  */
#line 4975 "gram.y"
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[(4) - (5)].str);
					n->tgenabled = (yyvsp[(5) - (5)].chr);
					(yyval.node) = (Node *) n;
				}
    break;

  case 723:
/* Line 1787 of yacc.c  */
#line 4984 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
    break;

  case 724:
/* Line 1787 of yacc.c  */
#line 4985 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
    break;

  case 725:
/* Line 1787 of yacc.c  */
#line 4986 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
    break;

  case 726:
/* Line 1787 of yacc.c  */
#line 4987 "gram.y"
    { (yyval.chr) = TRIGGER_DISABLED; }
    break;

  case 727:
/* Line 1787 of yacc.c  */
#line 5001 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[(8) - (8)].ival), (yylsp[(8) - (8)]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
    break;

  case 728:
/* Line 1787 of yacc.c  */
#line 5020 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
    break;

  case 729:
/* Line 1787 of yacc.c  */
#line 5043 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 730:
/* Line 1787 of yacc.c  */
#line 5053 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 731:
/* Line 1787 of yacc.c  */
#line 5064 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 732:
/* Line 1787 of yacc.c  */
#line 5074 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 733:
/* Line 1787 of yacc.c  */
#line 5084 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 734:
/* Line 1787 of yacc.c  */
#line 5095 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[(3) - (7)].list), (yylsp[(3) - (7)]), yyscanner);
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 735:
/* Line 1787 of yacc.c  */
#line 5104 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 736:
/* Line 1787 of yacc.c  */
#line 5111 "gram.y"
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[(3) - (6)].list);
					n->params	= (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 737:
/* Line 1787 of yacc.c  */
#line 5118 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 738:
/* Line 1787 of yacc.c  */
#line 5127 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 739:
/* Line 1787 of yacc.c  */
#line 5136 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 740:
/* Line 1787 of yacc.c  */
#line 5145 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 741:
/* Line 1787 of yacc.c  */
#line 5154 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 742:
/* Line 1787 of yacc.c  */
#line 5163 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[(5) - (5)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 743:
/* Line 1787 of yacc.c  */
#line 5173 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 744:
/* Line 1787 of yacc.c  */
#line 5176 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 745:
/* Line 1787 of yacc.c  */
#line 5177 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 746:
/* Line 1787 of yacc.c  */
#line 5181 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				}
    break;

  case 747:
/* Line 1787 of yacc.c  */
#line 5185 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 748:
/* Line 1787 of yacc.c  */
#line 5191 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); }
    break;

  case 749:
/* Line 1787 of yacc.c  */
#line 5192 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); }
    break;

  case 750:
/* Line 1787 of yacc.c  */
#line 5193 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); }
    break;

  case 751:
/* Line 1787 of yacc.c  */
#line 5194 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); }
    break;

  case 752:
/* Line 1787 of yacc.c  */
#line 5195 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 753:
/* Line 1787 of yacc.c  */
#line 5198 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 754:
/* Line 1787 of yacc.c  */
#line 5201 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 755:
/* Line 1787 of yacc.c  */
#line 5202 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 756:
/* Line 1787 of yacc.c  */
#line 5211 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				}
    break;

  case 757:
/* Line 1787 of yacc.c  */
#line 5217 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 758:
/* Line 1787 of yacc.c  */
#line 5218 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 759:
/* Line 1787 of yacc.c  */
#line 5222 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 760:
/* Line 1787 of yacc.c  */
#line 5224 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 761:
/* Line 1787 of yacc.c  */
#line 5235 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (7)].list);
				n->newVal = (yyvsp[(7) - (7)].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[(6) - (7)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 762:
/* Line 1787 of yacc.c  */
#line 5245 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (9)].list);
				n->newVal = (yyvsp[(7) - (9)].str);
				n->newValNeighbor = (yyvsp[(9) - (9)].str);
				n->newValIsAfter = false;
				n->skipIfExists = (yyvsp[(6) - (9)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 763:
/* Line 1787 of yacc.c  */
#line 5255 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (9)].list);
				n->newVal = (yyvsp[(7) - (9)].str);
				n->newValNeighbor = (yyvsp[(9) - (9)].str);
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[(6) - (9)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 764:
/* Line 1787 of yacc.c  */
#line 5266 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 765:
/* Line 1787 of yacc.c  */
#line 5267 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 766:
/* Line 1787 of yacc.c  */
#line 5285 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 767:
/* Line 1787 of yacc.c  */
#line 5298 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 768:
/* Line 1787 of yacc.c  */
#line 5299 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 769:
/* Line 1787 of yacc.c  */
#line 5304 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (5)].ival);
					n->order_family = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 770:
/* Line 1787 of yacc.c  */
#line 5315 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (6)].list);
					n->args = (yyvsp[(4) - (6)].list);
					n->number = (yyvsp[(2) - (6)].ival);
					n->order_family = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 771:
/* Line 1787 of yacc.c  */
#line 5325 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 772:
/* Line 1787 of yacc.c  */
#line 5334 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 773:
/* Line 1787 of yacc.c  */
#line 5344 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				}
    break;

  case 774:
/* Line 1787 of yacc.c  */
#line 5352 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 775:
/* Line 1787 of yacc.c  */
#line 5353 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 776:
/* Line 1787 of yacc.c  */
#line 5356 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 777:
/* Line 1787 of yacc.c  */
#line 5357 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 778:
/* Line 1787 of yacc.c  */
#line 5360 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 779:
/* Line 1787 of yacc.c  */
#line 5361 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (4)].list); }
    break;

  case 780:
/* Line 1787 of yacc.c  */
#line 5362 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 781:
/* Line 1787 of yacc.c  */
#line 5366 "gram.y"
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.boolean) = TRUE;
				}
    break;

  case 782:
/* Line 1787 of yacc.c  */
#line 5379 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 783:
/* Line 1787 of yacc.c  */
#line 5385 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 784:
/* Line 1787 of yacc.c  */
#line 5395 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 785:
/* Line 1787 of yacc.c  */
#line 5404 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 786:
/* Line 1787 of yacc.c  */
#line 5415 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 787:
/* Line 1787 of yacc.c  */
#line 5416 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 788:
/* Line 1787 of yacc.c  */
#line 5421 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 789:
/* Line 1787 of yacc.c  */
#line 5429 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 790:
/* Line 1787 of yacc.c  */
#line 5441 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[(6) - (7)].str)), (yyvsp[(4) - (7)].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 791:
/* Line 1787 of yacc.c  */
#line 5451 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[(8) - (9)].str)), (yyvsp[(6) - (9)].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 792:
/* Line 1787 of yacc.c  */
#line 5464 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[(6) - (7)].str)), (yyvsp[(4) - (7)].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 793:
/* Line 1787 of yacc.c  */
#line 5474 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[(8) - (9)].str)), (yyvsp[(6) - (9)].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 794:
/* Line 1787 of yacc.c  */
#line 5496 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 795:
/* Line 1787 of yacc.c  */
#line 5506 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 796:
/* Line 1787 of yacc.c  */
#line 5524 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 797:
/* Line 1787 of yacc.c  */
#line 5535 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 798:
/* Line 1787 of yacc.c  */
#line 5546 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 799:
/* Line 1787 of yacc.c  */
#line 5556 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 800:
/* Line 1787 of yacc.c  */
#line 5566 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 801:
/* Line 1787 of yacc.c  */
#line 5576 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 802:
/* Line 1787 of yacc.c  */
#line 5586 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(4) - (5)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 803:
/* Line 1787 of yacc.c  */
#line 5597 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(6) - (7)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 804:
/* Line 1787 of yacc.c  */
#line 5610 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 805:
/* Line 1787 of yacc.c  */
#line 5611 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 806:
/* Line 1787 of yacc.c  */
#line 5612 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 807:
/* Line 1787 of yacc.c  */
#line 5613 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 808:
/* Line 1787 of yacc.c  */
#line 5614 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 809:
/* Line 1787 of yacc.c  */
#line 5615 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 810:
/* Line 1787 of yacc.c  */
#line 5616 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 811:
/* Line 1787 of yacc.c  */
#line 5617 "gram.y"
    { (yyval.objtype) = OBJECT_COLLATION; }
    break;

  case 812:
/* Line 1787 of yacc.c  */
#line 5618 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 813:
/* Line 1787 of yacc.c  */
#line 5619 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 814:
/* Line 1787 of yacc.c  */
#line 5620 "gram.y"
    { (yyval.objtype) = OBJECT_EXTENSION; }
    break;

  case 815:
/* Line 1787 of yacc.c  */
#line 5621 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; }
    break;

  case 816:
/* Line 1787 of yacc.c  */
#line 5622 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
    break;

  case 817:
/* Line 1787 of yacc.c  */
#line 5623 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
    break;

  case 818:
/* Line 1787 of yacc.c  */
#line 5624 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
    break;

  case 819:
/* Line 1787 of yacc.c  */
#line 5628 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 820:
/* Line 1787 of yacc.c  */
#line 5629 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 821:
/* Line 1787 of yacc.c  */
#line 5632 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 822:
/* Line 1787 of yacc.c  */
#line 5633 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 823:
/* Line 1787 of yacc.c  */
#line 5637 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); }
    break;

  case 824:
/* Line 1787 of yacc.c  */
#line 5639 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 825:
/* Line 1787 of yacc.c  */
#line 5643 "gram.y"
    { (yyval.list) = list_make1(list_make1((yyvsp[(1) - (1)].typnam))); }
    break;

  case 826:
/* Line 1787 of yacc.c  */
#line 5644 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), list_make1((yyvsp[(3) - (3)].typnam))); }
    break;

  case 827:
/* Line 1787 of yacc.c  */
#line 5655 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (5)].list);
					n->restart_seqs = (yyvsp[(4) - (5)].boolean);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 828:
/* Line 1787 of yacc.c  */
#line 5665 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 829:
/* Line 1787 of yacc.c  */
#line 5666 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 830:
/* Line 1787 of yacc.c  */
#line 5667 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 831:
/* Line 1787 of yacc.c  */
#line 5701 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 832:
/* Line 1787 of yacc.c  */
#line 5710 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[(4) - (6)].typnam));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 833:
/* Line 1787 of yacc.c  */
#line 5719 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMAIN;
					n->objname = list_make1((yyvsp[(4) - (6)].typnam));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 834:
/* Line 1787 of yacc.c  */
#line 5728 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractAggrArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 835:
/* Line 1787 of yacc.c  */
#line 5737 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 836:
/* Line 1787 of yacc.c  */
#line 5746 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 837:
/* Line 1787 of yacc.c  */
#line 5755 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TABCONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 838:
/* Line 1787 of yacc.c  */
#line 5764 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->objname = list_make1(makeTypeNameFromNameList((yyvsp[(7) - (9)].list)));
					n->objargs = list_make1(makeString((yyvsp[(4) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 839:
/* Line 1787 of yacc.c  */
#line 5778 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_POLICY;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 840:
/* Line 1787 of yacc.c  */
#line 5787 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 841:
/* Line 1787 of yacc.c  */
#line 5796 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 842:
/* Line 1787 of yacc.c  */
#line 5806 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRANSFORM;
					n->objname = list_make1((yyvsp[(5) - (9)].typnam));
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 843:
/* Line 1787 of yacc.c  */
#line 5815 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 844:
/* Line 1787 of yacc.c  */
#line 5824 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = lcons(makeString((yyvsp[(7) - (9)].str)), (yyvsp[(5) - (9)].list));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 845:
/* Line 1787 of yacc.c  */
#line 5832 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = lcons(makeString((yyvsp[(7) - (9)].str)), (yyvsp[(5) - (9)].list));
					n->objargs = NIL;
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 846:
/* Line 1787 of yacc.c  */
#line 5841 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 847:
/* Line 1787 of yacc.c  */
#line 5850 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 848:
/* Line 1787 of yacc.c  */
#line 5859 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 849:
/* Line 1787 of yacc.c  */
#line 5870 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 850:
/* Line 1787 of yacc.c  */
#line 5871 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 851:
/* Line 1787 of yacc.c  */
#line 5872 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 852:
/* Line 1787 of yacc.c  */
#line 5873 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 853:
/* Line 1787 of yacc.c  */
#line 5874 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 854:
/* Line 1787 of yacc.c  */
#line 5875 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 855:
/* Line 1787 of yacc.c  */
#line 5876 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 856:
/* Line 1787 of yacc.c  */
#line 5877 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 857:
/* Line 1787 of yacc.c  */
#line 5878 "gram.y"
    { (yyval.objtype) = OBJECT_COLLATION; }
    break;

  case 858:
/* Line 1787 of yacc.c  */
#line 5879 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 859:
/* Line 1787 of yacc.c  */
#line 5880 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 860:
/* Line 1787 of yacc.c  */
#line 5881 "gram.y"
    { (yyval.objtype) = OBJECT_EXTENSION; }
    break;

  case 861:
/* Line 1787 of yacc.c  */
#line 5882 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 862:
/* Line 1787 of yacc.c  */
#line 5883 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 863:
/* Line 1787 of yacc.c  */
#line 5884 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
    break;

  case 864:
/* Line 1787 of yacc.c  */
#line 5885 "gram.y"
    { (yyval.objtype) = OBJECT_FDW; }
    break;

  case 865:
/* Line 1787 of yacc.c  */
#line 5886 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 866:
/* Line 1787 of yacc.c  */
#line 5887 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
    break;

  case 867:
/* Line 1787 of yacc.c  */
#line 5888 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
    break;

  case 868:
/* Line 1787 of yacc.c  */
#line 5889 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; }
    break;

  case 869:
/* Line 1787 of yacc.c  */
#line 5890 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
    break;

  case 870:
/* Line 1787 of yacc.c  */
#line 5894 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 871:
/* Line 1787 of yacc.c  */
#line 5895 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 872:
/* Line 1787 of yacc.c  */
#line 5911 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (8)].str);
					n->objtype = (yyvsp[(5) - (8)].objtype);
					n->objname = (yyvsp[(6) - (8)].list);
					n->objargs = NIL;
					n->label = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 873:
/* Line 1787 of yacc.c  */
#line 5922 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (8)].str);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[(6) - (8)].typnam));
					n->objargs = NIL;
					n->label = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 874:
/* Line 1787 of yacc.c  */
#line 5933 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (8)].str);
					n->objtype = OBJECT_TYPE;
					n->objname = list_make1((yyvsp[(6) - (8)].typnam));
					n->objargs = NIL;
					n->label = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 875:
/* Line 1787 of yacc.c  */
#line 5944 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(6) - (9)].list);
					n->objargs = extractAggrArgTypes((yyvsp[(7) - (9)].list));
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 876:
/* Line 1787 of yacc.c  */
#line 5955 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(6) - (9)].list);
					n->objargs = extractArgTypes((yyvsp[(7) - (9)].list));
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 877:
/* Line 1787 of yacc.c  */
#line 5966 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(7) - (9)].value));
					n->objargs = NIL;
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 878:
/* Line 1787 of yacc.c  */
#line 5977 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = NIL;
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 879:
/* Line 1787 of yacc.c  */
#line 5988 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 880:
/* Line 1787 of yacc.c  */
#line 5989 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 881:
/* Line 1787 of yacc.c  */
#line 5993 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 882:
/* Line 1787 of yacc.c  */
#line 5994 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 883:
/* Line 1787 of yacc.c  */
#line 5995 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 884:
/* Line 1787 of yacc.c  */
#line 5996 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 885:
/* Line 1787 of yacc.c  */
#line 5997 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 886:
/* Line 1787 of yacc.c  */
#line 5998 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 887:
/* Line 1787 of yacc.c  */
#line 5999 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 888:
/* Line 1787 of yacc.c  */
#line 6000 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 889:
/* Line 1787 of yacc.c  */
#line 6001 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 890:
/* Line 1787 of yacc.c  */
#line 6002 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 891:
/* Line 1787 of yacc.c  */
#line 6003 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 892:
/* Line 1787 of yacc.c  */
#line 6006 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 893:
/* Line 1787 of yacc.c  */
#line 6007 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 894:
/* Line 1787 of yacc.c  */
#line 6018 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 895:
/* Line 1787 of yacc.c  */
#line 6024 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 896:
/* Line 1787 of yacc.c  */
#line 6032 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(1) - (1)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 897:
/* Line 1787 of yacc.c  */
#line 6040 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 898:
/* Line 1787 of yacc.c  */
#line 6048 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 899:
/* Line 1787 of yacc.c  */
#line 6056 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 900:
/* Line 1787 of yacc.c  */
#line 6064 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 901:
/* Line 1787 of yacc.c  */
#line 6072 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 902:
/* Line 1787 of yacc.c  */
#line 6080 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 903:
/* Line 1787 of yacc.c  */
#line 6088 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 904:
/* Line 1787 of yacc.c  */
#line 6096 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (3)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 905:
/* Line 1787 of yacc.c  */
#line 6104 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 906:
/* Line 1787 of yacc.c  */
#line 6112 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 907:
/* Line 1787 of yacc.c  */
#line 6120 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 908:
/* Line 1787 of yacc.c  */
#line 6128 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 909:
/* Line 1787 of yacc.c  */
#line 6136 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 910:
/* Line 1787 of yacc.c  */
#line 6144 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 911:
/* Line 1787 of yacc.c  */
#line 6152 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 912:
/* Line 1787 of yacc.c  */
#line 6161 "gram.y"
    {}
    break;

  case 913:
/* Line 1787 of yacc.c  */
#line 6162 "gram.y"
    {}
    break;

  case 914:
/* Line 1787 of yacc.c  */
#line 6165 "gram.y"
    {}
    break;

  case 915:
/* Line 1787 of yacc.c  */
#line 6166 "gram.y"
    {}
    break;

  case 916:
/* Line 1787 of yacc.c  */
#line 6178 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 917:
/* Line 1787 of yacc.c  */
#line 6194 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 918:
/* Line 1787 of yacc.c  */
#line 6208 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ((yyvsp[(7) - (10)].privtarget))->targtype;
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 919:
/* Line 1787 of yacc.c  */
#line 6233 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 920:
/* Line 1787 of yacc.c  */
#line 6235 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 921:
/* Line 1787 of yacc.c  */
#line 6237 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 922:
/* Line 1787 of yacc.c  */
#line 6239 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(3) - (4)].list);
					(yyval.list) = list_make1(n);
				}
    break;

  case 923:
/* Line 1787 of yacc.c  */
#line 6246 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(4) - (5)].list);
					(yyval.list) = list_make1(n);
				}
    break;

  case 924:
/* Line 1787 of yacc.c  */
#line 6254 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].accesspriv)); }
    break;

  case 925:
/* Line 1787 of yacc.c  */
#line 6255 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].accesspriv)); }
    break;

  case 926:
/* Line 1787 of yacc.c  */
#line 6259 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 927:
/* Line 1787 of yacc.c  */
#line 6266 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 928:
/* Line 1787 of yacc.c  */
#line 6273 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 929:
/* Line 1787 of yacc.c  */
#line 6280 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[(1) - (2)].str);
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 930:
/* Line 1787 of yacc.c  */
#line 6294 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 931:
/* Line 1787 of yacc.c  */
#line 6302 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 932:
/* Line 1787 of yacc.c  */
#line 6310 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 933:
/* Line 1787 of yacc.c  */
#line 6318 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[(4) - (4)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 934:
/* Line 1787 of yacc.c  */
#line 6326 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 935:
/* Line 1787 of yacc.c  */
#line 6334 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 936:
/* Line 1787 of yacc.c  */
#line 6342 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 937:
/* Line 1787 of yacc.c  */
#line 6350 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 938:
/* Line 1787 of yacc.c  */
#line 6358 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 939:
/* Line 1787 of yacc.c  */
#line 6366 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 940:
/* Line 1787 of yacc.c  */
#line 6374 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 941:
/* Line 1787 of yacc.c  */
#line 6382 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 942:
/* Line 1787 of yacc.c  */
#line 6390 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 943:
/* Line 1787 of yacc.c  */
#line 6398 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 944:
/* Line 1787 of yacc.c  */
#line 6406 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 945:
/* Line 1787 of yacc.c  */
#line 6414 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 946:
/* Line 1787 of yacc.c  */
#line 6425 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 947:
/* Line 1787 of yacc.c  */
#line 6426 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 948:
/* Line 1787 of yacc.c  */
#line 6430 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 949:
/* Line 1787 of yacc.c  */
#line 6431 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 950:
/* Line 1787 of yacc.c  */
#line 6436 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 951:
/* Line 1787 of yacc.c  */
#line 6437 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 952:
/* Line 1787 of yacc.c  */
#line 6441 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); }
    break;

  case 953:
/* Line 1787 of yacc.c  */
#line 6443 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); }
    break;

  case 954:
/* Line 1787 of yacc.c  */
#line 6448 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				}
    break;

  case 955:
/* Line 1787 of yacc.c  */
#line 6464 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node*)n;
				}
    break;

  case 956:
/* Line 1787 of yacc.c  */
#line 6477 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 957:
/* Line 1787 of yacc.c  */
#line 6487 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 958:
/* Line 1787 of yacc.c  */
#line 6498 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 959:
/* Line 1787 of yacc.c  */
#line 6499 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 960:
/* Line 1787 of yacc.c  */
#line 6502 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); }
    break;

  case 961:
/* Line 1787 of yacc.c  */
#line 6503 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 962:
/* Line 1787 of yacc.c  */
#line 6514 "gram.y"
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[(4) - (5)].list);
					n->action = (GrantStmt *) (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node*)n;
				}
    break;

  case 963:
/* Line 1787 of yacc.c  */
#line 6523 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 964:
/* Line 1787 of yacc.c  */
#line 6524 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 965:
/* Line 1787 of yacc.c  */
#line 6529 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 966:
/* Line 1787 of yacc.c  */
#line 6533 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 967:
/* Line 1787 of yacc.c  */
#line 6537 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 968:
/* Line 1787 of yacc.c  */
#line 6549 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 969:
/* Line 1787 of yacc.c  */
#line 6562 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 970:
/* Line 1787 of yacc.c  */
#line 6576 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(7) - (10)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 971:
/* Line 1787 of yacc.c  */
#line 6591 "gram.y"
    { (yyval.ival) = ACL_OBJECT_RELATION; }
    break;

  case 972:
/* Line 1787 of yacc.c  */
#line 6592 "gram.y"
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
    break;

  case 973:
/* Line 1787 of yacc.c  */
#line 6593 "gram.y"
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
    break;

  case 974:
/* Line 1787 of yacc.c  */
#line 6594 "gram.y"
    { (yyval.ival) = ACL_OBJECT_TYPE; }
    break;

  case 975:
/* Line 1787 of yacc.c  */
#line 6609 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = (yyvsp[(4) - (14)].boolean);
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 976:
/* Line 1787 of yacc.c  */
#line 6635 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (17)].boolean);
					n->concurrent = (yyvsp[(4) - (17)].boolean);
					n->idxname = (yyvsp[(8) - (17)].str);
					n->relation = (yyvsp[(10) - (17)].range);
					n->accessMethod = (yyvsp[(11) - (17)].str);
					n->indexParams = (yyvsp[(13) - (17)].list);
					n->options = (yyvsp[(15) - (17)].list);
					n->tableSpace = (yyvsp[(16) - (17)].str);
					n->whereClause = (yyvsp[(17) - (17)].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 977:
/* Line 1787 of yacc.c  */
#line 6661 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 978:
/* Line 1787 of yacc.c  */
#line 6662 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 979:
/* Line 1787 of yacc.c  */
#line 6666 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 980:
/* Line 1787 of yacc.c  */
#line 6667 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 981:
/* Line 1787 of yacc.c  */
#line 6671 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 982:
/* Line 1787 of yacc.c  */
#line 6672 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 983:
/* Line 1787 of yacc.c  */
#line 6676 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 984:
/* Line 1787 of yacc.c  */
#line 6677 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
    break;

  case 985:
/* Line 1787 of yacc.c  */
#line 6680 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); }
    break;

  case 986:
/* Line 1787 of yacc.c  */
#line 6681 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); }
    break;

  case 987:
/* Line 1787 of yacc.c  */
#line 6690 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (5)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(2) - (5)].list);
					(yyval.ielem)->opclass = (yyvsp[(3) - (5)].list);
					(yyval.ielem)->ordering = (yyvsp[(4) - (5)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(5) - (5)].ival);
				}
    break;

  case 988:
/* Line 1787 of yacc.c  */
#line 6701 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (5)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(2) - (5)].list);
					(yyval.ielem)->opclass = (yyvsp[(3) - (5)].list);
					(yyval.ielem)->ordering = (yyvsp[(4) - (5)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(5) - (5)].ival);
				}
    break;

  case 989:
/* Line 1787 of yacc.c  */
#line 6712 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (7)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(4) - (7)].list);
					(yyval.ielem)->opclass = (yyvsp[(5) - (7)].list);
					(yyval.ielem)->ordering = (yyvsp[(6) - (7)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(7) - (7)].ival);
				}
    break;

  case 990:
/* Line 1787 of yacc.c  */
#line 6724 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 991:
/* Line 1787 of yacc.c  */
#line 6725 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 992:
/* Line 1787 of yacc.c  */
#line 6728 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 993:
/* Line 1787 of yacc.c  */
#line 6729 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 994:
/* Line 1787 of yacc.c  */
#line 6730 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 995:
/* Line 1787 of yacc.c  */
#line 6733 "gram.y"
    { (yyval.ival) = SORTBY_ASC; }
    break;

  case 996:
/* Line 1787 of yacc.c  */
#line 6734 "gram.y"
    { (yyval.ival) = SORTBY_DESC; }
    break;

  case 997:
/* Line 1787 of yacc.c  */
#line 6735 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; }
    break;

  case 998:
/* Line 1787 of yacc.c  */
#line 6738 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
    break;

  case 999:
/* Line 1787 of yacc.c  */
#line 6739 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; }
    break;

  case 1000:
/* Line 1787 of yacc.c  */
#line 6740 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
    break;

  case 1001:
/* Line 1787 of yacc.c  */
#line 6758 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1002:
/* Line 1787 of yacc.c  */
#line 6770 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (12)].boolean);
					n->funcname = (yyvsp[(4) - (12)].list);
					n->parameters = mergeTableFuncParameters((yyvsp[(5) - (12)].list), (yyvsp[(9) - (12)].list));
					n->returnType = TableFuncTypeName((yyvsp[(9) - (12)].list));
					n->returnType->location = (yylsp[(7) - (12)]);
					n->options = (yyvsp[(11) - (12)].list);
					n->withClause = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1003:
/* Line 1787 of yacc.c  */
#line 6783 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1004:
/* Line 1787 of yacc.c  */
#line 6796 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1005:
/* Line 1787 of yacc.c  */
#line 6797 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1006:
/* Line 1787 of yacc.c  */
#line 6800 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1007:
/* Line 1787 of yacc.c  */
#line 6801 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1008:
/* Line 1787 of yacc.c  */
#line 6805 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 1009:
/* Line 1787 of yacc.c  */
#line 6806 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 1010:
/* Line 1787 of yacc.c  */
#line 6814 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1011:
/* Line 1787 of yacc.c  */
#line 6815 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1012:
/* Line 1787 of yacc.c  */
#line 6819 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 1013:
/* Line 1787 of yacc.c  */
#line 6821 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 1014:
/* Line 1787 of yacc.c  */
#line 6836 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1015:
/* Line 1787 of yacc.c  */
#line 6845 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1016:
/* Line 1787 of yacc.c  */
#line 6854 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1017:
/* Line 1787 of yacc.c  */
#line 6863 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1018:
/* Line 1787 of yacc.c  */
#line 6872 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1019:
/* Line 1787 of yacc.c  */
#line 6883 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
    break;

  case 1020:
/* Line 1787 of yacc.c  */
#line 6884 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
    break;

  case 1021:
/* Line 1787 of yacc.c  */
#line 6885 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 1022:
/* Line 1787 of yacc.c  */
#line 6886 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 1023:
/* Line 1787 of yacc.c  */
#line 6887 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
    break;

  case 1025:
/* Line 1787 of yacc.c  */
#line 6898 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1026:
/* Line 1787 of yacc.c  */
#line 6912 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1027:
/* Line 1787 of yacc.c  */
#line 6914 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				}
    break;

  case 1028:
/* Line 1787 of yacc.c  */
#line 6920 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				}
    break;

  case 1029:
/* Line 1787 of yacc.c  */
#line 6930 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
				}
    break;

  case 1030:
/* Line 1787 of yacc.c  */
#line 6934 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
				}
    break;

  case 1031:
/* Line 1787 of yacc.c  */
#line 6939 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
				}
    break;

  case 1032:
/* Line 1787 of yacc.c  */
#line 6947 "gram.y"
    {
					if (!((yyvsp[(1) - (1)].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[(1) - (1)].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
				}
    break;

  case 1033:
/* Line 1787 of yacc.c  */
#line 6988 "gram.y"
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
    break;

  case 1034:
/* Line 1787 of yacc.c  */
#line 6992 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(2) - (3)].list), makeInteger(-1));
				}
    break;

  case 1035:
/* Line 1787 of yacc.c  */
#line 6996 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(4) - (5)].list), makeInteger(0));
				}
    break;

  case 1036:
/* Line 1787 of yacc.c  */
#line 7000 "gram.y"
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[(2) - (6)].list), (yyvsp[(5) - (6)].list), yyscanner);
				}
    break;

  case 1037:
/* Line 1787 of yacc.c  */
#line 7007 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 1038:
/* Line 1787 of yacc.c  */
#line 7008 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 1039:
/* Line 1787 of yacc.c  */
#line 7013 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1040:
/* Line 1787 of yacc.c  */
#line 7014 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1041:
/* Line 1787 of yacc.c  */
#line 7022 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
    break;

  case 1042:
/* Line 1787 of yacc.c  */
#line 7026 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 1043:
/* Line 1787 of yacc.c  */
#line 7030 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 1044:
/* Line 1787 of yacc.c  */
#line 7034 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
    break;

  case 1045:
/* Line 1787 of yacc.c  */
#line 7038 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
    break;

  case 1046:
/* Line 1787 of yacc.c  */
#line 7042 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
    break;

  case 1047:
/* Line 1787 of yacc.c  */
#line 7046 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 1048:
/* Line 1787 of yacc.c  */
#line 7050 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 1049:
/* Line 1787 of yacc.c  */
#line 7054 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 1050:
/* Line 1787 of yacc.c  */
#line 7058 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 1051:
/* Line 1787 of yacc.c  */
#line 7062 "gram.y"
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
    break;

  case 1052:
/* Line 1787 of yacc.c  */
#line 7066 "gram.y"
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
    break;

  case 1053:
/* Line 1787 of yacc.c  */
#line 7070 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 1054:
/* Line 1787 of yacc.c  */
#line 7074 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 1055:
/* Line 1787 of yacc.c  */
#line 7078 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				}
    break;

  case 1056:
/* Line 1787 of yacc.c  */
#line 7086 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 1057:
/* Line 1787 of yacc.c  */
#line 7090 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 1058:
/* Line 1787 of yacc.c  */
#line 7094 "gram.y"
    {
					(yyval.defelt) = makeDefElem("transform", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 1059:
/* Line 1787 of yacc.c  */
#line 7098 "gram.y"
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
    break;

  case 1060:
/* Line 1787 of yacc.c  */
#line 7102 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 1061:
/* Line 1787 of yacc.c  */
#line 7107 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1062:
/* Line 1787 of yacc.c  */
#line 7109 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1063:
/* Line 1787 of yacc.c  */
#line 7115 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(3) - (3)].typnam)); }
    break;

  case 1064:
/* Line 1787 of yacc.c  */
#line 7116 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (5)].list), (yyvsp[(5) - (5)].typnam)); }
    break;

  case 1065:
/* Line 1787 of yacc.c  */
#line 7120 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1066:
/* Line 1787 of yacc.c  */
#line 7121 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1067:
/* Line 1787 of yacc.c  */
#line 7125 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1068:
/* Line 1787 of yacc.c  */
#line 7137 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param));
				}
    break;

  case 1069:
/* Line 1787 of yacc.c  */
#line 7141 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param));
				}
    break;

  case 1070:
/* Line 1787 of yacc.c  */
#line 7156 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1071:
/* Line 1787 of yacc.c  */
#line 7166 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1072:
/* Line 1787 of yacc.c  */
#line 7167 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1075:
/* Line 1787 of yacc.c  */
#line 7189 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[(4) - (5)].list)));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1076:
/* Line 1787 of yacc.c  */
#line 7200 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[(6) - (7)].list)));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1077:
/* Line 1787 of yacc.c  */
#line 7214 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[(4) - (5)].list)));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1078:
/* Line 1787 of yacc.c  */
#line 7225 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[(6) - (7)].list)));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1079:
/* Line 1787 of yacc.c  */
#line 7239 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1080:
/* Line 1787 of yacc.c  */
#line 7250 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1081:
/* Line 1787 of yacc.c  */
#line 7264 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[(3) - (3)]))));
				}
    break;

  case 1082:
/* Line 1787 of yacc.c  */
#line 7272 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), (yyvsp[(4) - (5)].typnam)); }
    break;

  case 1083:
/* Line 1787 of yacc.c  */
#line 7274 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(4) - (5)].typnam)); }
    break;

  case 1084:
/* Line 1787 of yacc.c  */
#line 7276 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), NULL); }
    break;

  case 1085:
/* Line 1787 of yacc.c  */
#line 7281 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1086:
/* Line 1787 of yacc.c  */
#line 7283 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); }
    break;

  case 1087:
/* Line 1787 of yacc.c  */
#line 7296 "gram.y"
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1088:
/* Line 1787 of yacc.c  */
#line 7304 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1089:
/* Line 1787 of yacc.c  */
#line 7305 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1090:
/* Line 1787 of yacc.c  */
#line 7310 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[(1) - (1)].str)));
				}
    break;

  case 1091:
/* Line 1787 of yacc.c  */
#line 7314 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 1092:
/* Line 1787 of yacc.c  */
#line 7327 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1093:
/* Line 1787 of yacc.c  */
#line 7338 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1094:
/* Line 1787 of yacc.c  */
#line 7349 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1095:
/* Line 1787 of yacc.c  */
#line 7360 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; }
    break;

  case 1096:
/* Line 1787 of yacc.c  */
#line 7361 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; }
    break;

  case 1097:
/* Line 1787 of yacc.c  */
#line 7362 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; }
    break;

  case 1098:
/* Line 1787 of yacc.c  */
#line 7367 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[(5) - (9)].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[(7) - (9)].typnam)));
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1099:
/* Line 1787 of yacc.c  */
#line 7379 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1100:
/* Line 1787 of yacc.c  */
#line 7380 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1101:
/* Line 1787 of yacc.c  */
#line 7391 "gram.y"
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);
					n->replace = (yyvsp[(2) - (10)].boolean);
					n->type_name = (yyvsp[(5) - (10)].typnam);
					n->lang = (yyvsp[(7) - (10)].str);
					n->fromsql = linitial((yyvsp[(9) - (10)].list));
					n->tosql = lsecond((yyvsp[(9) - (10)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1102:
/* Line 1787 of yacc.c  */
#line 7403 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(5) - (11)].funwithargs), (yyvsp[(11) - (11)].funwithargs));
				}
    break;

  case 1103:
/* Line 1787 of yacc.c  */
#line 7407 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(11) - (11)].funwithargs), (yyvsp[(5) - (11)].funwithargs));
				}
    break;

  case 1104:
/* Line 1787 of yacc.c  */
#line 7411 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(5) - (5)].funwithargs), NULL);
				}
    break;

  case 1105:
/* Line 1787 of yacc.c  */
#line 7415 "gram.y"
    {
					(yyval.list) = list_make2(NULL, (yyvsp[(5) - (5)].funwithargs));
				}
    break;

  case 1106:
/* Line 1787 of yacc.c  */
#line 7422 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make1((yyvsp[(5) - (8)].typnam)));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(7) - (8)].str))));
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (8)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1107:
/* Line 1787 of yacc.c  */
#line 7443 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (3)].ival);
					n->relation = (yyvsp[(3) - (3)].range);
					n->name = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1108:
/* Line 1787 of yacc.c  */
#line 7452 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (3)].ival);
					n->name = (yyvsp[(3) - (3)].str);
					n->relation = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1109:
/* Line 1787 of yacc.c  */
#line 7461 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(5) - (6)].ival);
					n->relation = (yyvsp[(6) - (6)].range);
					n->name = NULL;
					n->options = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1110:
/* Line 1787 of yacc.c  */
#line 7470 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(5) - (6)].ival);
					n->name = (yyvsp[(6) - (6)].str);
					n->relation = NULL;
					n->options = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1111:
/* Line 1787 of yacc.c  */
#line 7480 "gram.y"
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
    break;

  case 1112:
/* Line 1787 of yacc.c  */
#line 7481 "gram.y"
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
    break;

  case 1113:
/* Line 1787 of yacc.c  */
#line 7484 "gram.y"
    { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
    break;

  case 1114:
/* Line 1787 of yacc.c  */
#line 7485 "gram.y"
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
    break;

  case 1115:
/* Line 1787 of yacc.c  */
#line 7486 "gram.y"
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
    break;

  case 1116:
/* Line 1787 of yacc.c  */
#line 7489 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1117:
/* Line 1787 of yacc.c  */
#line 7490 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 1118:
/* Line 1787 of yacc.c  */
#line 7493 "gram.y"
    { (yyval.ival) = REINDEXOPT_VERBOSE; }
    break;

  case 1119:
/* Line 1787 of yacc.c  */
#line 7504 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1120:
/* Line 1787 of yacc.c  */
#line 7513 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1121:
/* Line 1787 of yacc.c  */
#line 7530 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractAggrArgTypes((yyvsp[(4) - (7)].list));
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1122:
/* Line 1787 of yacc.c  */
#line 7540 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1123:
/* Line 1787 of yacc.c  */
#line 7549 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1124:
/* Line 1787 of yacc.c  */
#line 7558 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1125:
/* Line 1787 of yacc.c  */
#line 7567 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1126:
/* Line 1787 of yacc.c  */
#line 7576 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (yyvsp[(3) - (8)].list);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1127:
/* Line 1787 of yacc.c  */
#line 7585 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1128:
/* Line 1787 of yacc.c  */
#line 7594 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1129:
/* Line 1787 of yacc.c  */
#line 7604 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1130:
/* Line 1787 of yacc.c  */
#line 7613 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1131:
/* Line 1787 of yacc.c  */
#line 7622 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = lcons(makeString((yyvsp[(6) - (9)].str)), (yyvsp[(4) - (9)].list));
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1132:
/* Line 1787 of yacc.c  */
#line 7631 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = lcons(makeString((yyvsp[(6) - (9)].str)), (yyvsp[(4) - (9)].list));
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1133:
/* Line 1787 of yacc.c  */
#line 7640 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1134:
/* Line 1787 of yacc.c  */
#line 7650 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[(7) - (10)].range);
					n->subname = (yyvsp[(5) - (10)].str);
					n->newname = (yyvsp[(10) - (10)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1135:
/* Line 1787 of yacc.c  */
#line 7660 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1136:
/* Line 1787 of yacc.c  */
#line 7669 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1137:
/* Line 1787 of yacc.c  */
#line 7678 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1138:
/* Line 1787 of yacc.c  */
#line 7688 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1139:
/* Line 1787 of yacc.c  */
#line 7698 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1140:
/* Line 1787 of yacc.c  */
#line 7708 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1141:
/* Line 1787 of yacc.c  */
#line 7718 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1142:
/* Line 1787 of yacc.c  */
#line 7728 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1143:
/* Line 1787 of yacc.c  */
#line 7738 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (7)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1144:
/* Line 1787 of yacc.c  */
#line 7748 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (9)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1145:
/* Line 1787 of yacc.c  */
#line 7758 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1146:
/* Line 1787 of yacc.c  */
#line 7768 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1147:
/* Line 1787 of yacc.c  */
#line 7778 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (7)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1148:
/* Line 1787 of yacc.c  */
#line 7788 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (9)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1149:
/* Line 1787 of yacc.c  */
#line 7798 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1150:
/* Line 1787 of yacc.c  */
#line 7809 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (10)].range);
					n->subname = (yyvsp[(8) - (10)].str);
					n->newname = (yyvsp[(10) - (10)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1151:
/* Line 1787 of yacc.c  */
#line 7820 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (9)].range);
					n->subname = (yyvsp[(7) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1152:
/* Line 1787 of yacc.c  */
#line 7831 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (11)].range);
					n->subname = (yyvsp[(9) - (11)].str);
					n->newname = (yyvsp[(11) - (11)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1153:
/* Line 1787 of yacc.c  */
#line 7842 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1154:
/* Line 1787 of yacc.c  */
#line 7852 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[(5) - (10)].range);
					n->subname = (yyvsp[(8) - (10)].str);
					n->newname = (yyvsp[(10) - (10)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1155:
/* Line 1787 of yacc.c  */
#line 7862 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (9)].range);
					n->subname = (yyvsp[(7) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1156:
/* Line 1787 of yacc.c  */
#line 7873 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (11)].range);
					n->subname = (yyvsp[(9) - (11)].str);
					n->newname = (yyvsp[(11) - (11)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1157:
/* Line 1787 of yacc.c  */
#line 7884 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1158:
/* Line 1787 of yacc.c  */
#line 7894 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1159:
/* Line 1787 of yacc.c  */
#line 7904 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1160:
/* Line 1787 of yacc.c  */
#line 7912 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1161:
/* Line 1787 of yacc.c  */
#line 7921 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1162:
/* Line 1787 of yacc.c  */
#line 7930 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1163:
/* Line 1787 of yacc.c  */
#line 7939 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1164:
/* Line 1787 of yacc.c  */
#line 7948 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1165:
/* Line 1787 of yacc.c  */
#line 7957 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1166:
/* Line 1787 of yacc.c  */
#line 7966 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1167:
/* Line 1787 of yacc.c  */
#line 7975 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1168:
/* Line 1787 of yacc.c  */
#line 7984 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[(3) - (9)].list), (yylsp[(3) - (9)]), yyscanner);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1169:
/* Line 1787 of yacc.c  */
#line 7997 "gram.y"
    { (yyval.ival) = COLUMN; }
    break;

  case 1170:
/* Line 1787 of yacc.c  */
#line 7998 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1171:
/* Line 1787 of yacc.c  */
#line 8001 "gram.y"
    { (yyval.ival) = 1; }
    break;

  case 1172:
/* Line 1787 of yacc.c  */
#line 8002 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1173:
/* Line 1787 of yacc.c  */
#line 8013 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractAggrArgTypes((yyvsp[(4) - (7)].list));
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1174:
/* Line 1787 of yacc.c  */
#line 8023 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1175:
/* Line 1787 of yacc.c  */
#line 8032 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1176:
/* Line 1787 of yacc.c  */
#line 8041 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1177:
/* Line 1787 of yacc.c  */
#line 8050 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1178:
/* Line 1787 of yacc.c  */
#line 8059 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1179:
/* Line 1787 of yacc.c  */
#line 8069 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1180:
/* Line 1787 of yacc.c  */
#line 8079 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = lcons(makeString((yyvsp[(6) - (9)].str)), (yyvsp[(4) - (9)].list));
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1181:
/* Line 1787 of yacc.c  */
#line 8088 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = lcons(makeString((yyvsp[(6) - (9)].str)), (yyvsp[(4) - (9)].list));
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1182:
/* Line 1787 of yacc.c  */
#line 8097 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1183:
/* Line 1787 of yacc.c  */
#line 8106 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1184:
/* Line 1787 of yacc.c  */
#line 8115 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1185:
/* Line 1787 of yacc.c  */
#line 8124 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1186:
/* Line 1787 of yacc.c  */
#line 8133 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1187:
/* Line 1787 of yacc.c  */
#line 8142 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1188:
/* Line 1787 of yacc.c  */
#line 8151 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1189:
/* Line 1787 of yacc.c  */
#line 8160 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1190:
/* Line 1787 of yacc.c  */
#line 8169 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1191:
/* Line 1787 of yacc.c  */
#line 8178 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1192:
/* Line 1787 of yacc.c  */
#line 8187 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (7)].range);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1193:
/* Line 1787 of yacc.c  */
#line 8196 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (9)].range);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1194:
/* Line 1787 of yacc.c  */
#line 8205 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (7)].range);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1195:
/* Line 1787 of yacc.c  */
#line 8214 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (9)].range);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1196:
/* Line 1787 of yacc.c  */
#line 8223 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1197:
/* Line 1787 of yacc.c  */
#line 8240 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractAggrArgTypes((yyvsp[(4) - (7)].list));
					n->newowner = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1198:
/* Line 1787 of yacc.c  */
#line 8249 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1199:
/* Line 1787 of yacc.c  */
#line 8257 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1200:
/* Line 1787 of yacc.c  */
#line 8265 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1201:
/* Line 1787 of yacc.c  */
#line 8273 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1202:
/* Line 1787 of yacc.c  */
#line 8281 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1203:
/* Line 1787 of yacc.c  */
#line 8290 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1204:
/* Line 1787 of yacc.c  */
#line 8298 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[(4) - (7)].value));
					n->newowner = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1205:
/* Line 1787 of yacc.c  */
#line 8306 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1206:
/* Line 1787 of yacc.c  */
#line 8315 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = lcons(makeString((yyvsp[(6) - (9)].str)), (yyvsp[(4) - (9)].list));
					n->newowner = (yyvsp[(9) - (9)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1207:
/* Line 1787 of yacc.c  */
#line 8323 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = lcons(makeString((yyvsp[(6) - (9)].str)), (yyvsp[(4) - (9)].list));
					n->newowner = (yyvsp[(9) - (9)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1208:
/* Line 1787 of yacc.c  */
#line 8331 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1209:
/* Line 1787 of yacc.c  */
#line 8339 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1210:
/* Line 1787 of yacc.c  */
#line 8347 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1211:
/* Line 1787 of yacc.c  */
#line 8355 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1212:
/* Line 1787 of yacc.c  */
#line 8363 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1213:
/* Line 1787 of yacc.c  */
#line 8371 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newowner = (yyvsp[(8) - (8)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1214:
/* Line 1787 of yacc.c  */
#line 8379 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1215:
/* Line 1787 of yacc.c  */
#line 8387 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1216:
/* Line 1787 of yacc.c  */
#line 8406 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (13)].boolean);
					n->relation = (yyvsp[(9) - (13)].range);
					n->rulename = (yyvsp[(4) - (13)].str);
					n->whereClause = (yyvsp[(10) - (13)].node);
					n->event = (yyvsp[(7) - (13)].ival);
					n->instead = (yyvsp[(12) - (13)].boolean);
					n->actions = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1217:
/* Line 1787 of yacc.c  */
#line 8420 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1218:
/* Line 1787 of yacc.c  */
#line 8421 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1219:
/* Line 1787 of yacc.c  */
#line 8422 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1220:
/* Line 1787 of yacc.c  */
#line 8428 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 1221:
/* Line 1787 of yacc.c  */
#line 8434 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				}
    break;

  case 1227:
/* Line 1787 of yacc.c  */
#line 8450 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1228:
/* Line 1787 of yacc.c  */
#line 8451 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1229:
/* Line 1787 of yacc.c  */
#line 8454 "gram.y"
    { (yyval.ival) = CMD_SELECT; }
    break;

  case 1230:
/* Line 1787 of yacc.c  */
#line 8455 "gram.y"
    { (yyval.ival) = CMD_UPDATE; }
    break;

  case 1231:
/* Line 1787 of yacc.c  */
#line 8456 "gram.y"
    { (yyval.ival) = CMD_DELETE; }
    break;

  case 1232:
/* Line 1787 of yacc.c  */
#line 8457 "gram.y"
    { (yyval.ival) = CMD_INSERT; }
    break;

  case 1233:
/* Line 1787 of yacc.c  */
#line 8461 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1234:
/* Line 1787 of yacc.c  */
#line 8462 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1235:
/* Line 1787 of yacc.c  */
#line 8463 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1236:
/* Line 1787 of yacc.c  */
#line 8469 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1237:
/* Line 1787 of yacc.c  */
#line 8480 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1238:
/* Line 1787 of yacc.c  */
#line 8502 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[(2) - (3)].str);
					n->payload = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1239:
/* Line 1787 of yacc.c  */
#line 8511 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 1240:
/* Line 1787 of yacc.c  */
#line 8512 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1241:
/* Line 1787 of yacc.c  */
#line 8516 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1242:
/* Line 1787 of yacc.c  */
#line 8525 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1243:
/* Line 1787 of yacc.c  */
#line 8531 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1244:
/* Line 1787 of yacc.c  */
#line 8550 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1245:
/* Line 1787 of yacc.c  */
#line 8557 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1246:
/* Line 1787 of yacc.c  */
#line 8564 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1247:
/* Line 1787 of yacc.c  */
#line 8571 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1248:
/* Line 1787 of yacc.c  */
#line 8578 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1249:
/* Line 1787 of yacc.c  */
#line 8585 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1250:
/* Line 1787 of yacc.c  */
#line 8592 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1251:
/* Line 1787 of yacc.c  */
#line 8600 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1252:
/* Line 1787 of yacc.c  */
#line 8608 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1253:
/* Line 1787 of yacc.c  */
#line 8616 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1254:
/* Line 1787 of yacc.c  */
#line 8624 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1255:
/* Line 1787 of yacc.c  */
#line 8632 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1256:
/* Line 1787 of yacc.c  */
#line 8639 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1257:
/* Line 1787 of yacc.c  */
#line 8646 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1258:
/* Line 1787 of yacc.c  */
#line 8654 "gram.y"
    {}
    break;

  case 1259:
/* Line 1787 of yacc.c  */
#line 8655 "gram.y"
    {}
    break;

  case 1260:
/* Line 1787 of yacc.c  */
#line 8656 "gram.y"
    {}
    break;

  case 1261:
/* Line 1787 of yacc.c  */
#line 8661 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)]))); }
    break;

  case 1262:
/* Line 1787 of yacc.c  */
#line 8664 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[(1) - (2)]))); }
    break;

  case 1263:
/* Line 1787 of yacc.c  */
#line 8667 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); }
    break;

  case 1264:
/* Line 1787 of yacc.c  */
#line 8670 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[(1) - (1)]))); }
    break;

  case 1265:
/* Line 1787 of yacc.c  */
#line 8673 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); }
    break;

  case 1266:
/* Line 1787 of yacc.c  */
#line 8680 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1267:
/* Line 1787 of yacc.c  */
#line 8682 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 1268:
/* Line 1787 of yacc.c  */
#line 8684 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1270:
/* Line 1787 of yacc.c  */
#line 8690 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1271:
/* Line 1787 of yacc.c  */
#line 8704 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (9)].range);
					n->view->relpersistence = (yyvsp[(2) - (9)].ival);
					n->aliases = (yyvsp[(5) - (9)].list);
					n->query = (yyvsp[(8) - (9)].node);
					n->replace = false;
					n->options = (yyvsp[(6) - (9)].list);
					n->withCheckOption = (yyvsp[(9) - (9)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1272:
/* Line 1787 of yacc.c  */
#line 8717 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (11)].range);
					n->view->relpersistence = (yyvsp[(4) - (11)].ival);
					n->aliases = (yyvsp[(7) - (11)].list);
					n->query = (yyvsp[(10) - (11)].node);
					n->replace = true;
					n->options = (yyvsp[(8) - (11)].list);
					n->withCheckOption = (yyvsp[(11) - (11)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1273:
/* Line 1787 of yacc.c  */
#line 8730 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(5) - (12)].range);
					n->view->relpersistence = (yyvsp[(2) - (12)].ival);
					n->aliases = (yyvsp[(7) - (12)].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[(11) - (12)].node));
					n->replace = false;
					n->options = (yyvsp[(9) - (12)].list);
					n->withCheckOption = (yyvsp[(12) - (12)].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[(12) - (12)]))));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1274:
/* Line 1787 of yacc.c  */
#line 8748 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(7) - (14)].range);
					n->view->relpersistence = (yyvsp[(4) - (14)].ival);
					n->aliases = (yyvsp[(9) - (14)].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[(13) - (14)].node));
					n->replace = true;
					n->options = (yyvsp[(11) - (14)].list);
					n->withCheckOption = (yyvsp[(14) - (14)].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[(14) - (14)]))));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1275:
/* Line 1787 of yacc.c  */
#line 8767 "gram.y"
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
    break;

  case 1276:
/* Line 1787 of yacc.c  */
#line 8768 "gram.y"
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
    break;

  case 1277:
/* Line 1787 of yacc.c  */
#line 8769 "gram.y"
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
    break;

  case 1278:
/* Line 1787 of yacc.c  */
#line 8770 "gram.y"
    { (yyval.ival) = NO_CHECK_OPTION; }
    break;

  case 1279:
/* Line 1787 of yacc.c  */
#line 8781 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1280:
/* Line 1787 of yacc.c  */
#line 8797 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1281:
/* Line 1787 of yacc.c  */
#line 8806 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1282:
/* Line 1787 of yacc.c  */
#line 8807 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1283:
/* Line 1787 of yacc.c  */
#line 8811 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1284:
/* Line 1787 of yacc.c  */
#line 8812 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1285:
/* Line 1787 of yacc.c  */
#line 8817 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 1286:
/* Line 1787 of yacc.c  */
#line 8821 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1287:
/* Line 1787 of yacc.c  */
#line 8825 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), NULL);
				}
    break;

  case 1288:
/* Line 1787 of yacc.c  */
#line 8842 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1289:
/* Line 1787 of yacc.c  */
#line 8843 "gram.y"
    { (yyval.str) = pstrdup("connection_limit"); }
    break;

  case 1290:
/* Line 1787 of yacc.c  */
#line 8844 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1291:
/* Line 1787 of yacc.c  */
#line 8845 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1292:
/* Line 1787 of yacc.c  */
#line 8846 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1293:
/* Line 1787 of yacc.c  */
#line 8847 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1294:
/* Line 1787 of yacc.c  */
#line 8848 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1295:
/* Line 1787 of yacc.c  */
#line 8855 "gram.y"
    {}
    break;

  case 1296:
/* Line 1787 of yacc.c  */
#line 8856 "gram.y"
    {}
    break;

  case 1297:
/* Line 1787 of yacc.c  */
#line 8868 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1298:
/* Line 1787 of yacc.c  */
#line 8875 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1299:
/* Line 1787 of yacc.c  */
#line 8882 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (6)].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[(6) - (6)].str))));
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1300:
/* Line 1787 of yacc.c  */
#line 8893 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1301:
/* Line 1787 of yacc.c  */
#line 8910 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1302:
/* Line 1787 of yacc.c  */
#line 8917 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1303:
/* Line 1787 of yacc.c  */
#line 8935 "gram.y"
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1304:
/* Line 1787 of yacc.c  */
#line 8941 "gram.y"
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1305:
/* Line 1787 of yacc.c  */
#line 8957 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typeName = (yyvsp[(5) - (6)].typnam);
					SplitColQualList((yyvsp[(6) - (6)].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1306:
/* Line 1787 of yacc.c  */
#line 8970 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1307:
/* Line 1787 of yacc.c  */
#line 8979 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1308:
/* Line 1787 of yacc.c  */
#line 8987 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1309:
/* Line 1787 of yacc.c  */
#line 8995 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1310:
/* Line 1787 of yacc.c  */
#line 9004 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1311:
/* Line 1787 of yacc.c  */
#line 9015 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (9)].list);
					n->name = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1312:
/* Line 1787 of yacc.c  */
#line 9026 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[(3) - (6)].list);
					n->name = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1313:
/* Line 1787 of yacc.c  */
#line 9035 "gram.y"
    {}
    break;

  case 1314:
/* Line 1787 of yacc.c  */
#line 9036 "gram.y"
    {}
    break;

  case 1315:
/* Line 1787 of yacc.c  */
#line 9048 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1316:
/* Line 1787 of yacc.c  */
#line 9058 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1317:
/* Line 1787 of yacc.c  */
#line 9069 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1318:
/* Line 1787 of yacc.c  */
#line 9080 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1319:
/* Line 1787 of yacc.c  */
#line 9091 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1320:
/* Line 1787 of yacc.c  */
#line 9102 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1321:
/* Line 1787 of yacc.c  */
#line 9111 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1322:
/* Line 1787 of yacc.c  */
#line 9122 "gram.y"
    {}
    break;

  case 1323:
/* Line 1787 of yacc.c  */
#line 9123 "gram.y"
    {}
    break;

  case 1324:
/* Line 1787 of yacc.c  */
#line 9139 "gram.y"
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[(4) - (10)].list);
				n->for_encoding_name = (yyvsp[(6) - (10)].str);
				n->to_encoding_name = (yyvsp[(8) - (10)].str);
				n->func_name = (yyvsp[(10) - (10)].list);
				n->def = (yyvsp[(2) - (10)].boolean);
				(yyval.node) = (Node *)n;
			}
    break;

  case 1325:
/* Line 1787 of yacc.c  */
#line 9161 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->indexname = (yyvsp[(4) - (4)].str);
					n->verbose = (yyvsp[(2) - (4)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1326:
/* Line 1787 of yacc.c  */
#line 9169 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[(2) - (2)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1327:
/* Line 1787 of yacc.c  */
#line 9178 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[(5) - (5)].range);
					n->indexname = (yyvsp[(3) - (5)].str);
					n->verbose = (yyvsp[(2) - (5)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1328:
/* Line 1787 of yacc.c  */
#line 9188 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 1329:
/* Line 1787 of yacc.c  */
#line 9189 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1330:
/* Line 1787 of yacc.c  */
#line 9202 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(3) - (4)].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[(4) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1331:
/* Line 1787 of yacc.c  */
#line 9216 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(3) - (5)].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1332:
/* Line 1787 of yacc.c  */
#line 9230 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(3) - (5)].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1333:
/* Line 1787 of yacc.c  */
#line 9242 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (4)].ival);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1334:
/* Line 1787 of yacc.c  */
#line 9250 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (6)].ival);
					n->relation = (yyvsp[(5) - (6)].range);
					n->va_cols = (yyvsp[(6) - (6)].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1335:
/* Line 1787 of yacc.c  */
#line 9262 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1336:
/* Line 1787 of yacc.c  */
#line 9263 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 1337:
/* Line 1787 of yacc.c  */
#line 9267 "gram.y"
    { (yyval.ival) = VACOPT_ANALYZE; }
    break;

  case 1338:
/* Line 1787 of yacc.c  */
#line 9268 "gram.y"
    { (yyval.ival) = VACOPT_VERBOSE; }
    break;

  case 1339:
/* Line 1787 of yacc.c  */
#line 9269 "gram.y"
    { (yyval.ival) = VACOPT_FREEZE; }
    break;

  case 1340:
/* Line 1787 of yacc.c  */
#line 9270 "gram.y"
    { (yyval.ival) = VACOPT_FULL; }
    break;

  case 1341:
/* Line 1787 of yacc.c  */
#line 9275 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (2)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1342:
/* Line 1787 of yacc.c  */
#line 9285 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1343:
/* Line 1787 of yacc.c  */
#line 9297 "gram.y"
    {}
    break;

  case 1344:
/* Line 1787 of yacc.c  */
#line 9298 "gram.y"
    {}
    break;

  case 1345:
/* Line 1787 of yacc.c  */
#line 9302 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1346:
/* Line 1787 of yacc.c  */
#line 9303 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1347:
/* Line 1787 of yacc.c  */
#line 9306 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1348:
/* Line 1787 of yacc.c  */
#line 9307 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1349:
/* Line 1787 of yacc.c  */
#line 9310 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1350:
/* Line 1787 of yacc.c  */
#line 9311 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1351:
/* Line 1787 of yacc.c  */
#line 9315 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1352:
/* Line 1787 of yacc.c  */
#line 9316 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1353:
/* Line 1787 of yacc.c  */
#line 9330 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(2) - (2)].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1354:
/* Line 1787 of yacc.c  */
#line 9337 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(4) - (4)].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[(3) - (4)].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1355:
/* Line 1787 of yacc.c  */
#line 9347 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(3) - (3)].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1356:
/* Line 1787 of yacc.c  */
#line 9354 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(5) - (5)].node);
					n->options = (yyvsp[(3) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1366:
/* Line 1787 of yacc.c  */
#line 9376 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 1367:
/* Line 1787 of yacc.c  */
#line 9380 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 1368:
/* Line 1787 of yacc.c  */
#line 9387 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1369:
/* Line 1787 of yacc.c  */
#line 9393 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1370:
/* Line 1787 of yacc.c  */
#line 9394 "gram.y"
    { (yyval.str) = "analyze"; }
    break;

  case 1371:
/* Line 1787 of yacc.c  */
#line 9398 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 1372:
/* Line 1787 of yacc.c  */
#line 9399 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); }
    break;

  case 1373:
/* Line 1787 of yacc.c  */
#line 9400 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1374:
/* Line 1787 of yacc.c  */
#line 9411 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1375:
/* Line 1787 of yacc.c  */
#line 9420 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1376:
/* Line 1787 of yacc.c  */
#line 9421 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1381:
/* Line 1787 of yacc.c  */
#line 9439 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1382:
/* Line 1787 of yacc.c  */
#line 9447 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (9)].str);
					n->params = (yyvsp[(8) - (9)].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[(4) - (9)].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(4) - (9)].into)->rel->relpersistence = (yyvsp[(2) - (9)].ival);
					(yyvsp[(4) - (9)].into)->skipData = !((yyvsp[(9) - (9)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 1383:
/* Line 1787 of yacc.c  */
#line 9463 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1384:
/* Line 1787 of yacc.c  */
#line 9464 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1385:
/* Line 1787 of yacc.c  */
#line 9475 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 1386:
/* Line 1787 of yacc.c  */
#line 9481 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 1387:
/* Line 1787 of yacc.c  */
#line 9487 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 1388:
/* Line 1787 of yacc.c  */
#line 9493 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 1389:
/* Line 1787 of yacc.c  */
#line 9510 "gram.y"
    {
					(yyvsp[(5) - (7)].istmt)->relation = (yyvsp[(4) - (7)].range);
					(yyvsp[(5) - (7)].istmt)->onConflictClause = (yyvsp[(6) - (7)].onconflict);
					(yyvsp[(5) - (7)].istmt)->returningList = (yyvsp[(7) - (7)].list);
					(yyvsp[(5) - (7)].istmt)->withClause = (yyvsp[(1) - (7)].with);
					(yyval.node) = (Node *) (yyvsp[(5) - (7)].istmt);
				}
    break;

  case 1390:
/* Line 1787 of yacc.c  */
#line 9527 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				}
    break;

  case 1391:
/* Line 1787 of yacc.c  */
#line 9531 "gram.y"
    {
					(yyvsp[(1) - (3)].range)->alias = makeAlias((yyvsp[(3) - (3)].str), NIL);
					(yyval.range) = (yyvsp[(1) - (3)].range);
				}
    break;

  case 1392:
/* Line 1787 of yacc.c  */
#line 9539 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				}
    break;

  case 1393:
/* Line 1787 of yacc.c  */
#line 9545 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				}
    break;

  case 1394:
/* Line 1787 of yacc.c  */
#line 9551 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
    break;

  case 1395:
/* Line 1787 of yacc.c  */
#line 9560 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1396:
/* Line 1787 of yacc.c  */
#line 9562 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1397:
/* Line 1787 of yacc.c  */
#line 9567 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1398:
/* Line 1787 of yacc.c  */
#line 9578 "gram.y"
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[(3) - (8)].infer);
					(yyval.onconflict)->targetList = (yyvsp[(7) - (8)].list);
					(yyval.onconflict)->whereClause = (yyvsp[(8) - (8)].node);
					(yyval.onconflict)->location = (yylsp[(1) - (8)]);
				}
    break;

  case 1399:
/* Line 1787 of yacc.c  */
#line 9588 "gram.y"
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[(3) - (5)].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1400:
/* Line 1787 of yacc.c  */
#line 9597 "gram.y"
    {
					(yyval.onconflict) = NULL;
				}
    break;

  case 1401:
/* Line 1787 of yacc.c  */
#line 9604 "gram.y"
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[(2) - (4)].list);
					(yyval.infer)->whereClause = (yyvsp[(4) - (4)].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[(1) - (4)]);
				}
    break;

  case 1402:
/* Line 1787 of yacc.c  */
#line 9613 "gram.y"
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[(3) - (3)].str);
					(yyval.infer)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1403:
/* Line 1787 of yacc.c  */
#line 9621 "gram.y"
    {
					(yyval.infer) = NULL;
				}
    break;

  case 1404:
/* Line 1787 of yacc.c  */
#line 9627 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1405:
/* Line 1787 of yacc.c  */
#line 9628 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1406:
/* Line 1787 of yacc.c  */
#line 9641 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(4) - (7)].range);
					n->usingClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					n->withClause = (yyvsp[(1) - (7)].with);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1407:
/* Line 1787 of yacc.c  */
#line 9653 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1408:
/* Line 1787 of yacc.c  */
#line 9654 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1409:
/* Line 1787 of yacc.c  */
#line 9666 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1410:
/* Line 1787 of yacc.c  */
#line 9676 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); }
    break;

  case 1411:
/* Line 1787 of yacc.c  */
#line 9677 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 1412:
/* Line 1787 of yacc.c  */
#line 9680 "gram.y"
    { (yyval.ival) = AccessShareLock; }
    break;

  case 1413:
/* Line 1787 of yacc.c  */
#line 9681 "gram.y"
    { (yyval.ival) = RowShareLock; }
    break;

  case 1414:
/* Line 1787 of yacc.c  */
#line 9682 "gram.y"
    { (yyval.ival) = RowExclusiveLock; }
    break;

  case 1415:
/* Line 1787 of yacc.c  */
#line 9683 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; }
    break;

  case 1416:
/* Line 1787 of yacc.c  */
#line 9684 "gram.y"
    { (yyval.ival) = ShareLock; }
    break;

  case 1417:
/* Line 1787 of yacc.c  */
#line 9685 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; }
    break;

  case 1418:
/* Line 1787 of yacc.c  */
#line 9686 "gram.y"
    { (yyval.ival) = ExclusiveLock; }
    break;

  case 1419:
/* Line 1787 of yacc.c  */
#line 9687 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 1420:
/* Line 1787 of yacc.c  */
#line 9690 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1421:
/* Line 1787 of yacc.c  */
#line 9691 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1422:
/* Line 1787 of yacc.c  */
#line 9695 "gram.y"
    { (yyval.ival) = LockWaitError; }
    break;

  case 1423:
/* Line 1787 of yacc.c  */
#line 9696 "gram.y"
    { (yyval.ival) = LockWaitSkip; }
    break;

  case 1424:
/* Line 1787 of yacc.c  */
#line 9697 "gram.y"
    { (yyval.ival) = LockWaitBlock; }
    break;

  case 1425:
/* Line 1787 of yacc.c  */
#line 9713 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(3) - (8)].range);
					n->targetList = (yyvsp[(5) - (8)].list);
					n->fromClause = (yyvsp[(6) - (8)].list);
					n->whereClause = (yyvsp[(7) - (8)].node);
					n->returningList = (yyvsp[(8) - (8)].list);
					n->withClause = (yyvsp[(1) - (8)].with);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1426:
/* Line 1787 of yacc.c  */
#line 9726 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1427:
/* Line 1787 of yacc.c  */
#line 9727 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); }
    break;

  case 1428:
/* Line 1787 of yacc.c  */
#line 9731 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1429:
/* Line 1787 of yacc.c  */
#line 9732 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1430:
/* Line 1787 of yacc.c  */
#line 9737 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				}
    break;

  case 1431:
/* Line 1787 of yacc.c  */
#line 9753 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  This is semantically
					 * equivalent to, and much cheaper to process than, the
					 * general case.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[(5) - (5)]))));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				}
    break;

  case 1432:
/* Line 1787 of yacc.c  */
#line 9779 "gram.y"
    {
					SubLink *sl = makeNode(SubLink);
					int ncolumns = list_length((yyvsp[(2) - (5)].list));
					int i = 1;
					ListCell *col_cell;

					/* First, convert bare SelectStmt into a SubLink */
					sl->subLinkType = MULTIEXPR_SUBLINK;
					sl->subLinkId = 0;		/* will be assigned later */
					sl->testexpr = NULL;
					sl->operName = NIL;
					sl->subselect = (yyvsp[(5) - (5)].node);
					sl->location = (yylsp[(5) - (5)]);

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[(2) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) sl;
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				}
    break;

  case 1433:
/* Line 1787 of yacc.c  */
#line 9812 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1434:
/* Line 1787 of yacc.c  */
#line 9822 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1435:
/* Line 1787 of yacc.c  */
#line 9823 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); }
    break;

  case 1436:
/* Line 1787 of yacc.c  */
#line 9834 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1437:
/* Line 1787 of yacc.c  */
#line 9844 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1438:
/* Line 1787 of yacc.c  */
#line 9847 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1439:
/* Line 1787 of yacc.c  */
#line 9848 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; }
    break;

  case 1440:
/* Line 1787 of yacc.c  */
#line 9849 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; }
    break;

  case 1441:
/* Line 1787 of yacc.c  */
#line 9850 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; }
    break;

  case 1442:
/* Line 1787 of yacc.c  */
#line 9851 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; }
    break;

  case 1443:
/* Line 1787 of yacc.c  */
#line 9854 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1444:
/* Line 1787 of yacc.c  */
#line 9855 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; }
    break;

  case 1445:
/* Line 1787 of yacc.c  */
#line 9856 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1448:
/* Line 1787 of yacc.c  */
#line 9909 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1449:
/* Line 1787 of yacc.c  */
#line 9910 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1450:
/* Line 1787 of yacc.c  */
#line 9925 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1451:
/* Line 1787 of yacc.c  */
#line 9927 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				}
    break;

  case 1452:
/* Line 1787 of yacc.c  */
#line 9934 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 1453:
/* Line 1787 of yacc.c  */
#line 9942 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 1454:
/* Line 1787 of yacc.c  */
#line 9950 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (2)].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[(1) - (2)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (2)].node);
				}
    break;

  case 1455:
/* Line 1787 of yacc.c  */
#line 9958 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].list), NIL,
										NULL, NULL,
										(yyvsp[(1) - (3)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (3)].node);
				}
    break;

  case 1456:
/* Line 1787 of yacc.c  */
#line 9966 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(4) - (5)].list),
										list_nth((yyvsp[(5) - (5)].list), 0), list_nth((yyvsp[(5) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				}
    break;

  case 1457:
/* Line 1787 of yacc.c  */
#line 9974 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(5) - (5)].list),
										list_nth((yyvsp[(4) - (5)].list), 0), list_nth((yyvsp[(4) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				}
    break;

  case 1458:
/* Line 1787 of yacc.c  */
#line 9984 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1459:
/* Line 1787 of yacc.c  */
#line 9985 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1460:
/* Line 1787 of yacc.c  */
#line 10015 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1461:
/* Line 1787 of yacc.c  */
#line 10029 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (9)].list);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1462:
/* Line 1787 of yacc.c  */
#line 10041 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1463:
/* Line 1787 of yacc.c  */
#line 10043 "gram.y"
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[(2) - (2)].range));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1464:
/* Line 1787 of yacc.c  */
#line 10062 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1465:
/* Line 1787 of yacc.c  */
#line 10066 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1466:
/* Line 1787 of yacc.c  */
#line 10070 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1467:
/* Line 1787 of yacc.c  */
#line 10087 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			}
    break;

  case 1468:
/* Line 1787 of yacc.c  */
#line 10094 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			}
    break;

  case 1469:
/* Line 1787 of yacc.c  */
#line 10101 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(3) - (3)].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[(1) - (3)]);
			}
    break;

  case 1470:
/* Line 1787 of yacc.c  */
#line 10110 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1471:
/* Line 1787 of yacc.c  */
#line 10111 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1472:
/* Line 1787 of yacc.c  */
#line 10115 "gram.y"
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[(1) - (6)].str);
				n->aliascolnames = (yyvsp[(2) - (6)].list);
				n->ctequery = (yyvsp[(5) - (6)].node);
				n->location = (yylsp[(1) - (6)]);
				(yyval.node) = (Node *) n;
			}
    break;

  case 1473:
/* Line 1787 of yacc.c  */
#line 10126 "gram.y"
    { (yyval.with) = (yyvsp[(1) - (1)].with); }
    break;

  case 1474:
/* Line 1787 of yacc.c  */
#line 10127 "gram.y"
    { (yyval.with) = NULL; }
    break;

  case 1475:
/* Line 1787 of yacc.c  */
#line 10132 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
    break;

  case 1476:
/* Line 1787 of yacc.c  */
#line 10143 "gram.y"
    { (yyval.into) = NULL; }
    break;

  case 1477:
/* Line 1787 of yacc.c  */
#line 10152 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1478:
/* Line 1787 of yacc.c  */
#line 10157 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1479:
/* Line 1787 of yacc.c  */
#line 10162 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1480:
/* Line 1787 of yacc.c  */
#line 10167 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1481:
/* Line 1787 of yacc.c  */
#line 10172 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (4)]))));
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1482:
/* Line 1787 of yacc.c  */
#line 10180 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (4)]))));
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1483:
/* Line 1787 of yacc.c  */
#line 10188 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
    break;

  case 1484:
/* Line 1787 of yacc.c  */
#line 10193 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
    break;

  case 1485:
/* Line 1787 of yacc.c  */
#line 10198 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
    break;

  case 1486:
/* Line 1787 of yacc.c  */
#line 10204 "gram.y"
    {}
    break;

  case 1487:
/* Line 1787 of yacc.c  */
#line 10205 "gram.y"
    {}
    break;

  case 1488:
/* Line 1787 of yacc.c  */
#line 10209 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1489:
/* Line 1787 of yacc.c  */
#line 10210 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1490:
/* Line 1787 of yacc.c  */
#line 10211 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1491:
/* Line 1787 of yacc.c  */
#line 10218 "gram.y"
    { (yyval.list) = list_make1(NIL); }
    break;

  case 1492:
/* Line 1787 of yacc.c  */
#line 10219 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); }
    break;

  case 1493:
/* Line 1787 of yacc.c  */
#line 10223 "gram.y"
    { (yyval.list) = NIL;}
    break;

  case 1494:
/* Line 1787 of yacc.c  */
#line 10224 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1495:
/* Line 1787 of yacc.c  */
#line 10228 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);}
    break;

  case 1496:
/* Line 1787 of yacc.c  */
#line 10229 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1497:
/* Line 1787 of yacc.c  */
#line 10233 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1498:
/* Line 1787 of yacc.c  */
#line 10237 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); }
    break;

  case 1499:
/* Line 1787 of yacc.c  */
#line 10238 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); }
    break;

  case 1500:
/* Line 1787 of yacc.c  */
#line 10242 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
					(yyval.sortby)->location = (yylsp[(3) - (4)]);
				}
    break;

  case 1501:
/* Line 1787 of yacc.c  */
#line 10251 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
    break;

  case 1502:
/* Line 1787 of yacc.c  */
#line 10263 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), (yyvsp[(1) - (2)].node)); }
    break;

  case 1503:
/* Line 1787 of yacc.c  */
#line 10264 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node)); }
    break;

  case 1504:
/* Line 1787 of yacc.c  */
#line 10265 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(1) - (1)].node)); }
    break;

  case 1505:
/* Line 1787 of yacc.c  */
#line 10266 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (1)].node), NULL); }
    break;

  case 1506:
/* Line 1787 of yacc.c  */
#line 10270 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1507:
/* Line 1787 of yacc.c  */
#line 10271 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); }
    break;

  case 1508:
/* Line 1787 of yacc.c  */
#line 10276 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1509:
/* Line 1787 of yacc.c  */
#line 10278 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[(1) - (4)]))));
				}
    break;

  case 1510:
/* Line 1787 of yacc.c  */
#line 10288 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (5)].node); }
    break;

  case 1511:
/* Line 1787 of yacc.c  */
#line 10293 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1512:
/* Line 1787 of yacc.c  */
#line 10296 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1513:
/* Line 1787 of yacc.c  */
#line 10300 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1514:
/* Line 1787 of yacc.c  */
#line 10302 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				}
    break;

  case 1515:
/* Line 1787 of yacc.c  */
#line 10309 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1516:
/* Line 1787 of yacc.c  */
#line 10319 "gram.y"
    { (yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)])); }
    break;

  case 1517:
/* Line 1787 of yacc.c  */
#line 10320 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1518:
/* Line 1787 of yacc.c  */
#line 10321 "gram.y"
    { (yyval.node) = makeIntConst(1, -1); }
    break;

  case 1519:
/* Line 1787 of yacc.c  */
#line 10329 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1520:
/* Line 1787 of yacc.c  */
#line 10333 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1521:
/* Line 1787 of yacc.c  */
#line 10334 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1522:
/* Line 1787 of yacc.c  */
#line 10337 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1523:
/* Line 1787 of yacc.c  */
#line 10338 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1524:
/* Line 1787 of yacc.c  */
#line 10363 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1525:
/* Line 1787 of yacc.c  */
#line 10364 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1526:
/* Line 1787 of yacc.c  */
#line 10368 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1527:
/* Line 1787 of yacc.c  */
#line 10369 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].node)); }
    break;

  case 1528:
/* Line 1787 of yacc.c  */
#line 10373 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1529:
/* Line 1787 of yacc.c  */
#line 10374 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1530:
/* Line 1787 of yacc.c  */
#line 10375 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1531:
/* Line 1787 of yacc.c  */
#line 10376 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1532:
/* Line 1787 of yacc.c  */
#line 10377 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1533:
/* Line 1787 of yacc.c  */
#line 10382 "gram.y"
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[(1) - (2)]));
				}
    break;

  case 1534:
/* Line 1787 of yacc.c  */
#line 10395 "gram.y"
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1535:
/* Line 1787 of yacc.c  */
#line 10402 "gram.y"
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1536:
/* Line 1787 of yacc.c  */
#line 10409 "gram.y"
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1537:
/* Line 1787 of yacc.c  */
#line 10415 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1538:
/* Line 1787 of yacc.c  */
#line 10416 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1539:
/* Line 1787 of yacc.c  */
#line 10420 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1540:
/* Line 1787 of yacc.c  */
#line 10421 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1541:
/* Line 1787 of yacc.c  */
#line 10425 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1542:
/* Line 1787 of yacc.c  */
#line 10426 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1543:
/* Line 1787 of yacc.c  */
#line 10430 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1544:
/* Line 1787 of yacc.c  */
#line 10431 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1545:
/* Line 1787 of yacc.c  */
#line 10436 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(2) - (3)].list);
					n->strength = (yyvsp[(1) - (3)].ival);
					n->waitPolicy = (yyvsp[(3) - (3)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1546:
/* Line 1787 of yacc.c  */
#line 10446 "gram.y"
    { (yyval.ival) = LCS_FORUPDATE; }
    break;

  case 1547:
/* Line 1787 of yacc.c  */
#line 10447 "gram.y"
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
    break;

  case 1548:
/* Line 1787 of yacc.c  */
#line 10448 "gram.y"
    { (yyval.ival) = LCS_FORSHARE; }
    break;

  case 1549:
/* Line 1787 of yacc.c  */
#line 10449 "gram.y"
    { (yyval.ival) = LCS_FORKEYSHARE; }
    break;

  case 1550:
/* Line 1787 of yacc.c  */
#line 10453 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1551:
/* Line 1787 of yacc.c  */
#line 10454 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1552:
/* Line 1787 of yacc.c  */
#line 10460 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1553:
/* Line 1787 of yacc.c  */
#line 10466 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1554:
/* Line 1787 of yacc.c  */
#line 10483 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1555:
/* Line 1787 of yacc.c  */
#line 10484 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1556:
/* Line 1787 of yacc.c  */
#line 10488 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1557:
/* Line 1787 of yacc.c  */
#line 10489 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1558:
/* Line 1787 of yacc.c  */
#line 10496 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				}
    break;

  case 1559:
/* Line 1787 of yacc.c  */
#line 10501 "gram.y"
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[(3) - (3)].node);
					(yyvsp[(1) - (3)].range)->alias = (yyvsp[(2) - (3)].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[(1) - (3)].range);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1560:
/* Line 1787 of yacc.c  */
#line 10509 "gram.y"
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[(1) - (2)].node);
					n->alias = linitial((yyvsp[(2) - (2)].list));
					n->coldeflist = lsecond((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1561:
/* Line 1787 of yacc.c  */
#line 10516 "gram.y"
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[(2) - (3)].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[(3) - (3)].list));
					n->coldeflist = lsecond((yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1562:
/* Line 1787 of yacc.c  */
#line 10524 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[(2) - (2)].alias) == NULL)
					{
						if (IsA((yyvsp[(1) - (2)].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[(1) - (2)].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[(1) - (2)]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[(1) - (2)]))));
					}
					(yyval.node) = (Node *) n;
				}
    break;

  case 1563:
/* Line 1787 of yacc.c  */
#line 10559 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[(2) - (3)].node);
					n->alias = (yyvsp[(3) - (3)].alias);
					/* same coment as above */
					if ((yyvsp[(3) - (3)].alias) == NULL)
					{
						if (IsA((yyvsp[(2) - (3)].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[(2) - (3)].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[(2) - (3)]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[(2) - (3)]))));
					}
					(yyval.node) = (Node *) n;
				}
    break;

  case 1564:
/* Line 1787 of yacc.c  */
#line 10584 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				}
    break;

  case 1565:
/* Line 1787 of yacc.c  */
#line 10588 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				}
    break;

  case 1566:
/* Line 1787 of yacc.c  */
#line 10614 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				}
    break;

  case 1567:
/* Line 1787 of yacc.c  */
#line 10618 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
    break;

  case 1568:
/* Line 1787 of yacc.c  */
#line 10630 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->usingClause = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1569:
/* Line 1787 of yacc.c  */
#line 10643 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->usingClause = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1570:
/* Line 1787 of yacc.c  */
#line 10657 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1571:
/* Line 1787 of yacc.c  */
#line 10668 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1572:
/* Line 1787 of yacc.c  */
#line 10683 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				}
    break;

  case 1573:
/* Line 1787 of yacc.c  */
#line 10689 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				}
    break;

  case 1574:
/* Line 1787 of yacc.c  */
#line 10694 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				}
    break;

  case 1575:
/* Line 1787 of yacc.c  */
#line 10700 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				}
    break;

  case 1576:
/* Line 1787 of yacc.c  */
#line 10706 "gram.y"
    { (yyval.alias) = (yyvsp[(1) - (1)].alias); }
    break;

  case 1577:
/* Line 1787 of yacc.c  */
#line 10707 "gram.y"
    { (yyval.alias) = NULL; }
    break;

  case 1578:
/* Line 1787 of yacc.c  */
#line 10716 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (1)].alias), NIL);
				}
    break;

  case 1579:
/* Line 1787 of yacc.c  */
#line 10720 "gram.y"
    {
					(yyval.list) = list_make2(NULL, (yyvsp[(3) - (4)].list));
				}
    break;

  case 1580:
/* Line 1787 of yacc.c  */
#line 10724 "gram.y"
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.list) = list_make2(a, (yyvsp[(4) - (5)].list));
				}
    break;

  case 1581:
/* Line 1787 of yacc.c  */
#line 10730 "gram.y"
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.list) = list_make2(a, (yyvsp[(3) - (4)].list));
				}
    break;

  case 1582:
/* Line 1787 of yacc.c  */
#line 10736 "gram.y"
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
    break;

  case 1583:
/* Line 1787 of yacc.c  */
#line 10741 "gram.y"
    { (yyval.jtype) = JOIN_FULL; }
    break;

  case 1584:
/* Line 1787 of yacc.c  */
#line 10742 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; }
    break;

  case 1585:
/* Line 1787 of yacc.c  */
#line 10743 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; }
    break;

  case 1586:
/* Line 1787 of yacc.c  */
#line 10744 "gram.y"
    { (yyval.jtype) = JOIN_INNER; }
    break;

  case 1587:
/* Line 1787 of yacc.c  */
#line 10748 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1588:
/* Line 1787 of yacc.c  */
#line 10749 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1589:
/* Line 1787 of yacc.c  */
#line 10761 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); }
    break;

  case 1590:
/* Line 1787 of yacc.c  */
#line 10762 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1591:
/* Line 1787 of yacc.c  */
#line 10768 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1592:
/* Line 1787 of yacc.c  */
#line 10775 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1593:
/* Line 1787 of yacc.c  */
#line 10782 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1594:
/* Line 1787 of yacc.c  */
#line 10789 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1595:
/* Line 1787 of yacc.c  */
#line 10799 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 1596:
/* Line 1787 of yacc.c  */
#line 10800 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 1597:
/* Line 1787 of yacc.c  */
#line 10814 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				}
    break;

  case 1598:
/* Line 1787 of yacc.c  */
#line 10818 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				}
    break;

  case 1599:
/* Line 1787 of yacc.c  */
#line 10825 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				}
    break;

  case 1600:
/* Line 1787 of yacc.c  */
#line 10838 "gram.y"
    {
					RangeTableSample *n = makeNode(RangeTableSample);
					/* n->relation will be filled in later */
					n->method = (yyvsp[(2) - (6)].list);
					n->args = (yyvsp[(4) - (6)].list);
					n->repeatable = (yyvsp[(6) - (6)].node);
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1601:
/* Line 1787 of yacc.c  */
#line 10850 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].node); }
    break;

  case 1602:
/* Line 1787 of yacc.c  */
#line 10851 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1603:
/* Line 1787 of yacc.c  */
#line 10867 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[(2) - (2)].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[(1) - (2)].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
    break;

  case 1604:
/* Line 1787 of yacc.c  */
#line 10877 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[(6) - (6)].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[(4) - (6)].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
    break;

  case 1605:
/* Line 1787 of yacc.c  */
#line 10889 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list)); }
    break;

  case 1606:
/* Line 1787 of yacc.c  */
#line 10893 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 1607:
/* Line 1787 of yacc.c  */
#line 10894 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 1608:
/* Line 1787 of yacc.c  */
#line 10897 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1609:
/* Line 1787 of yacc.c  */
#line 10898 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1610:
/* Line 1787 of yacc.c  */
#line 10901 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 1611:
/* Line 1787 of yacc.c  */
#line 10902 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 1612:
/* Line 1787 of yacc.c  */
#line 10907 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1613:
/* Line 1787 of yacc.c  */
#line 10908 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1614:
/* Line 1787 of yacc.c  */
#line 10913 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1615:
/* Line 1787 of yacc.c  */
#line 10915 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1616:
/* Line 1787 of yacc.c  */
#line 10922 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1617:
/* Line 1787 of yacc.c  */
#line 10927 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1618:
/* Line 1787 of yacc.c  */
#line 10928 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1619:
/* Line 1787 of yacc.c  */
#line 10933 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1620:
/* Line 1787 of yacc.c  */
#line 10937 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1621:
/* Line 1787 of yacc.c  */
#line 10943 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typeName = (yyvsp[(2) - (3)].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[(3) - (3)].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1622:
/* Line 1787 of yacc.c  */
#line 10973 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1623:
/* Line 1787 of yacc.c  */
#line 10978 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1624:
/* Line 1787 of yacc.c  */
#line 10985 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				}
    break;

  case 1625:
/* Line 1787 of yacc.c  */
#line 10990 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1626:
/* Line 1787 of yacc.c  */
#line 10996 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
    break;

  case 1627:
/* Line 1787 of yacc.c  */
#line 11001 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1628:
/* Line 1787 of yacc.c  */
#line 11010 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); }
    break;

  case 1629:
/* Line 1787 of yacc.c  */
#line 11012 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); }
    break;

  case 1630:
/* Line 1787 of yacc.c  */
#line 11014 "gram.y"
    {  (yyval.list) = NIL; }
    break;

  case 1631:
/* Line 1787 of yacc.c  */
#line 11018 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1632:
/* Line 1787 of yacc.c  */
#line 11019 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1633:
/* Line 1787 of yacc.c  */
#line 11020 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1634:
/* Line 1787 of yacc.c  */
#line 11021 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1635:
/* Line 1787 of yacc.c  */
#line 11022 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1636:
/* Line 1787 of yacc.c  */
#line 11024 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1637:
/* Line 1787 of yacc.c  */
#line 11029 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (4)].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				}
    break;

  case 1638:
/* Line 1787 of yacc.c  */
#line 11048 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1639:
/* Line 1787 of yacc.c  */
#line 11049 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1640:
/* Line 1787 of yacc.c  */
#line 11050 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1641:
/* Line 1787 of yacc.c  */
#line 11051 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1642:
/* Line 1787 of yacc.c  */
#line 11063 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1643:
/* Line 1787 of yacc.c  */
#line 11069 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1644:
/* Line 1787 of yacc.c  */
#line 11076 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1645:
/* Line 1787 of yacc.c  */
#line 11077 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1646:
/* Line 1787 of yacc.c  */
#line 11084 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1647:
/* Line 1787 of yacc.c  */
#line 11089 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1648:
/* Line 1787 of yacc.c  */
#line 11094 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1649:
/* Line 1787 of yacc.c  */
#line 11099 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1650:
/* Line 1787 of yacc.c  */
#line 11104 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1651:
/* Line 1787 of yacc.c  */
#line 11109 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1652:
/* Line 1787 of yacc.c  */
#line 11114 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1653:
/* Line 1787 of yacc.c  */
#line 11119 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1654:
/* Line 1787 of yacc.c  */
#line 11125 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1655:
/* Line 1787 of yacc.c  */
#line 11131 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1656:
/* Line 1787 of yacc.c  */
#line 11137 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1657:
/* Line 1787 of yacc.c  */
#line 11144 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[(2) - (3)]))));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[(2) - (3)]))));
				}
    break;

  case 1658:
/* Line 1787 of yacc.c  */
#line 11165 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
    break;

  case 1659:
/* Line 1787 of yacc.c  */
#line 11175 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1660:
/* Line 1787 of yacc.c  */
#line 11179 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1661:
/* Line 1787 of yacc.c  */
#line 11187 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1662:
/* Line 1787 of yacc.c  */
#line 11191 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1663:
/* Line 1787 of yacc.c  */
#line 11199 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1664:
/* Line 1787 of yacc.c  */
#line 11211 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1665:
/* Line 1787 of yacc.c  */
#line 11232 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1666:
/* Line 1787 of yacc.c  */
#line 11236 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1667:
/* Line 1787 of yacc.c  */
#line 11242 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1668:
/* Line 1787 of yacc.c  */
#line 11246 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1669:
/* Line 1787 of yacc.c  */
#line 11259 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
						(yyvsp[(1) - (5)].str) = psprintf("%s_%s", (yyvsp[(1) - (5)].str), (yyvsp[(5) - (5)].str));

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1670:
/* Line 1787 of yacc.c  */
#line 11270 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
						(yyvsp[(1) - (2)].str) = psprintf("%s_%s", (yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str));

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1671:
/* Line 1787 of yacc.c  */
#line 11285 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1672:
/* Line 1787 of yacc.c  */
#line 11287 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1673:
/* Line 1787 of yacc.c  */
#line 11289 "gram.y"
    { (yyval.str) = "varchar"; }
    break;

  case 1674:
/* Line 1787 of yacc.c  */
#line 11291 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1675:
/* Line 1787 of yacc.c  */
#line 11293 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1676:
/* Line 1787 of yacc.c  */
#line 11295 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1677:
/* Line 1787 of yacc.c  */
#line 11299 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1678:
/* Line 1787 of yacc.c  */
#line 11300 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1679:
/* Line 1787 of yacc.c  */
#line 11304 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 1680:
/* Line 1787 of yacc.c  */
#line 11305 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1681:
/* Line 1787 of yacc.c  */
#line 11313 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1682:
/* Line 1787 of yacc.c  */
#line 11322 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1683:
/* Line 1787 of yacc.c  */
#line 11330 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1684:
/* Line 1787 of yacc.c  */
#line 11339 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1685:
/* Line 1787 of yacc.c  */
#line 11350 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1686:
/* Line 1787 of yacc.c  */
#line 11357 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1687:
/* Line 1787 of yacc.c  */
#line 11358 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1688:
/* Line 1787 of yacc.c  */
#line 11359 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1689:
/* Line 1787 of yacc.c  */
#line 11364 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[(1) - (1)]))); }
    break;

  case 1690:
/* Line 1787 of yacc.c  */
#line 11366 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[(1) - (1)]))); }
    break;

  case 1691:
/* Line 1787 of yacc.c  */
#line 11368 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[(1) - (1)]))); }
    break;

  case 1692:
/* Line 1787 of yacc.c  */
#line 11370 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[(1) - (1)]))); }
    break;

  case 1693:
/* Line 1787 of yacc.c  */
#line 11372 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[(1) - (1)]))); }
    break;

  case 1694:
/* Line 1787 of yacc.c  */
#line 11374 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1695:
/* Line 1787 of yacc.c  */
#line 11376 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[(1) - (3)])));
				}
    break;

  case 1696:
/* Line 1787 of yacc.c  */
#line 11381 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[(1) - (3)])));
				}
    break;

  case 1697:
/* Line 1787 of yacc.c  */
#line 11386 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				}
    break;

  case 1698:
/* Line 1787 of yacc.c  */
#line 11392 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1699:
/* Line 1787 of yacc.c  */
#line 11400 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				}
    break;

  case 1700:
/* Line 1787 of yacc.c  */
#line 11405 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1701:
/* Line 1787 of yacc.c  */
#line 11412 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1702:
/* Line 1787 of yacc.c  */
#line 11418 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1703:
/* Line 1787 of yacc.c  */
#line 11423 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (1)])));
				}
    break;

  case 1704:
/* Line 1787 of yacc.c  */
#line 11427 "gram.y"
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (4)])),
									makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				}
    break;

  case 1705:
/* Line 1787 of yacc.c  */
#line 11462 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1706:
/* Line 1787 of yacc.c  */
#line 11464 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); }
    break;

  case 1707:
/* Line 1787 of yacc.c  */
#line 11466 "gram.y"
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[(1) - (3)].node);
					n->collname = (yyvsp[(3) - (3)].list);
					n->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1708:
/* Line 1787 of yacc.c  */
#line 11474 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node)),
											   (yylsp[(2) - (5)]));
				}
    break;

  case 1709:
/* Line 1787 of yacc.c  */
#line 11489 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1710:
/* Line 1787 of yacc.c  */
#line 11491 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1711:
/* Line 1787 of yacc.c  */
#line 11493 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1712:
/* Line 1787 of yacc.c  */
#line 11495 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1713:
/* Line 1787 of yacc.c  */
#line 11497 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1714:
/* Line 1787 of yacc.c  */
#line 11499 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1715:
/* Line 1787 of yacc.c  */
#line 11501 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1716:
/* Line 1787 of yacc.c  */
#line 11503 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1717:
/* Line 1787 of yacc.c  */
#line 11505 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1718:
/* Line 1787 of yacc.c  */
#line 11507 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1719:
/* Line 1787 of yacc.c  */
#line 11509 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1720:
/* Line 1787 of yacc.c  */
#line 11511 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1721:
/* Line 1787 of yacc.c  */
#line 11513 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1722:
/* Line 1787 of yacc.c  */
#line 11515 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1723:
/* Line 1787 of yacc.c  */
#line 11518 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1724:
/* Line 1787 of yacc.c  */
#line 11520 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1725:
/* Line 1787 of yacc.c  */
#line 11522 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1726:
/* Line 1787 of yacc.c  */
#line 11525 "gram.y"
    { (yyval.node) = makeAndExpr((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1727:
/* Line 1787 of yacc.c  */
#line 11527 "gram.y"
    { (yyval.node) = makeOrExpr((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1728:
/* Line 1787 of yacc.c  */
#line 11529 "gram.y"
    { (yyval.node) = makeNotExpr((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1729:
/* Line 1787 of yacc.c  */
#line 11531 "gram.y"
    { (yyval.node) = makeNotExpr((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1730:
/* Line 1787 of yacc.c  */
#line 11534 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
				}
    break;

  case 1731:
/* Line 1787 of yacc.c  */
#line 11539 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node)),
											   (yylsp[(2) - (5)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1732:
/* Line 1787 of yacc.c  */
#line 11547 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
				}
    break;

  case 1733:
/* Line 1787 of yacc.c  */
#line 11552 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
											   (yylsp[(2) - (6)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1734:
/* Line 1787 of yacc.c  */
#line 11560 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
				}
    break;

  case 1735:
/* Line 1787 of yacc.c  */
#line 11565 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node)),
											   (yylsp[(2) - (5)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1736:
/* Line 1787 of yacc.c  */
#line 11573 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
				}
    break;

  case 1737:
/* Line 1787 of yacc.c  */
#line 11578 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
											   (yylsp[(2) - (6)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1738:
/* Line 1787 of yacc.c  */
#line 11587 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[(4) - (4)].node), makeNullAConst(-1)),
											   (yylsp[(2) - (4)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				}
    break;

  case 1739:
/* Line 1787 of yacc.c  */
#line 11595 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
											   (yylsp[(2) - (6)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1740:
/* Line 1787 of yacc.c  */
#line 11603 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[(5) - (5)].node), makeNullAConst(-1)),
											   (yylsp[(2) - (5)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1741:
/* Line 1787 of yacc.c  */
#line 11611 "gram.y"
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node)),
											   (yylsp[(2) - (7)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				}
    break;

  case 1742:
/* Line 1787 of yacc.c  */
#line 11629 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1743:
/* Line 1787 of yacc.c  */
#line 11637 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1744:
/* Line 1787 of yacc.c  */
#line 11645 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1745:
/* Line 1787 of yacc.c  */
#line 11653 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1746:
/* Line 1787 of yacc.c  */
#line 11661 "gram.y"
    {
					if (list_length((yyvsp[(1) - (3)].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[(1) - (3)]))));
					if (list_length((yyvsp[(3) - (3)].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[(3) - (3)]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)),
											   (yylsp[(2) - (3)]));
				}
    break;

  case 1747:
/* Line 1787 of yacc.c  */
#line 11677 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *)b;
				}
    break;

  case 1748:
/* Line 1787 of yacc.c  */
#line 11685 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)b;
				}
    break;

  case 1749:
/* Line 1787 of yacc.c  */
#line 11693 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *)b;
				}
    break;

  case 1750:
/* Line 1787 of yacc.c  */
#line 11701 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)b;
				}
    break;

  case 1751:
/* Line 1787 of yacc.c  */
#line 11709 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *)b;
				}
    break;

  case 1752:
/* Line 1787 of yacc.c  */
#line 11717 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)b;
				}
    break;

  case 1753:
/* Line 1787 of yacc.c  */
#line 11725 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1754:
/* Line 1787 of yacc.c  */
#line 11729 "gram.y"
    {
					(yyval.node) = makeNotExpr((Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															   "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
									 (yylsp[(2) - (6)]));
				}
    break;

  case 1755:
/* Line 1787 of yacc.c  */
#line 11735 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1756:
/* Line 1787 of yacc.c  */
#line 11739 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1757:
/* Line 1787 of yacc.c  */
#line 11743 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[(1) - (6)].node),
												   (Node *) list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
												   (yylsp[(2) - (6)]));
				}
    break;

  case 1758:
/* Line 1787 of yacc.c  */
#line 11751 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[(1) - (7)].node),
												   (Node *) list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node)),
												   (yylsp[(2) - (7)]));
				}
    break;

  case 1759:
/* Line 1787 of yacc.c  */
#line 11759 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[(1) - (6)].node),
												   (Node *) list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
												   (yylsp[(2) - (6)]));
				}
    break;

  case 1760:
/* Line 1787 of yacc.c  */
#line 11767 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[(1) - (7)].node),
												   (Node *) list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node)),
												   (yylsp[(2) - (7)]));
				}
    break;

  case 1761:
/* Line 1787 of yacc.c  */
#line 11775 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[(2) - (3)]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				}
    break;

  case 1762:
/* Line 1787 of yacc.c  */
#line 11795 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[(2) - (4)]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				}
    break;

  case 1763:
/* Line 1787 of yacc.c  */
#line 11817 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1764:
/* Line 1787 of yacc.c  */
#line 11828 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				}
    break;

  case 1765:
/* Line 1787 of yacc.c  */
#line 11835 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[(1) - (2)]))));
				}
    break;

  case 1766:
/* Line 1787 of yacc.c  */
#line 11851 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				}
    break;

  case 1767:
/* Line 1787 of yacc.c  */
#line 11856 "gram.y"
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
									 (yylsp[(2) - (4)]));
				}
    break;

  case 1768:
/* Line 1787 of yacc.c  */
#line 11873 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1769:
/* Line 1787 of yacc.c  */
#line 11875 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); }
    break;

  case 1770:
/* Line 1787 of yacc.c  */
#line 11877 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1771:
/* Line 1787 of yacc.c  */
#line 11879 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1772:
/* Line 1787 of yacc.c  */
#line 11881 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1773:
/* Line 1787 of yacc.c  */
#line 11883 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1774:
/* Line 1787 of yacc.c  */
#line 11885 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1775:
/* Line 1787 of yacc.c  */
#line 11887 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1776:
/* Line 1787 of yacc.c  */
#line 11889 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1777:
/* Line 1787 of yacc.c  */
#line 11891 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1778:
/* Line 1787 of yacc.c  */
#line 11893 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1779:
/* Line 1787 of yacc.c  */
#line 11895 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1780:
/* Line 1787 of yacc.c  */
#line 11897 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1781:
/* Line 1787 of yacc.c  */
#line 11899 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1782:
/* Line 1787 of yacc.c  */
#line 11901 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1783:
/* Line 1787 of yacc.c  */
#line 11903 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1784:
/* Line 1787 of yacc.c  */
#line 11905 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1785:
/* Line 1787 of yacc.c  */
#line 11907 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1786:
/* Line 1787 of yacc.c  */
#line 11909 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1787:
/* Line 1787 of yacc.c  */
#line 11911 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1788:
/* Line 1787 of yacc.c  */
#line 11915 "gram.y"
    {
					(yyval.node) = makeNotExpr((Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															   "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
									 (yylsp[(2) - (6)]));
				}
    break;

  case 1789:
/* Line 1787 of yacc.c  */
#line 11921 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1790:
/* Line 1787 of yacc.c  */
#line 11925 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1791:
/* Line 1787 of yacc.c  */
#line 11929 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				}
    break;

  case 1792:
/* Line 1787 of yacc.c  */
#line 11934 "gram.y"
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
									 (yylsp[(2) - (4)]));
				}
    break;

  case 1793:
/* Line 1787 of yacc.c  */
#line 11949 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1794:
/* Line 1787 of yacc.c  */
#line 11950 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1795:
/* Line 1787 of yacc.c  */
#line 11952 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					p->location = (yylsp[(1) - (2)]);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
    break;

  case 1796:
/* Line 1787 of yacc.c  */
#line 11967 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = check_indirection((yyvsp[(4) - (4)].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else if (operator_precedence_warning)
					{
						/*
						 * If precedence warnings are enabled, insert
						 * AEXPR_PAREN nodes wrapping all explicitly
						 * parenthesized subexpressions; this prevents bogus
						 * warnings from being issued when the ordering has
						 * been forced by parentheses.
						 *
						 * In principle we should not be relying on a GUC to
						 * decide whether to insert AEXPR_PAREN nodes.
						 * However, since they have no effect except to
						 * suppress warnings, it's probably safe enough; and
						 * we'd just as soon not waste cycles on dummy parse
						 * nodes if we don't have to.
						 */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_PAREN, NIL, (yyvsp[(2) - (4)].node), NULL, (yylsp[(1) - (4)]));
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1797:
/* Line 1787 of yacc.c  */
#line 11997 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1798:
/* Line 1787 of yacc.c  */
#line 11999 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1799:
/* Line 1787 of yacc.c  */
#line 12001 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1800:
/* Line 1787 of yacc.c  */
#line 12012 "gram.y"
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
    break;

  case 1801:
/* Line 1787 of yacc.c  */
#line 12036 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1802:
/* Line 1787 of yacc.c  */
#line 12047 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1803:
/* Line 1787 of yacc.c  */
#line 12058 "gram.y"
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[(2) - (2)].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1804:
/* Line 1787 of yacc.c  */
#line 12066 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				}
    break;

  case 1805:
/* Line 1787 of yacc.c  */
#line 12076 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				}
    break;

  case 1806:
/* Line 1787 of yacc.c  */
#line 12086 "gram.y"
    {
				  GroupingFunc *g = makeNode(GroupingFunc);
				  g->args = (yyvsp[(3) - (4)].list);
				  g->location = (yylsp[(1) - (4)]);
				  (yyval.node) = (Node *)g;
			  }
    break;

  case 1807:
/* Line 1787 of yacc.c  */
#line 12095 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[(1) - (3)].list), NIL, (yylsp[(1) - (3)]));
				}
    break;

  case 1808:
/* Line 1787 of yacc.c  */
#line 12099 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (5)].list), (yyvsp[(3) - (5)].list), (yylsp[(1) - (5)]));
					n->agg_order = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1809:
/* Line 1787 of yacc.c  */
#line 12105 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (6)].list), list_make1((yyvsp[(4) - (6)].node)), (yylsp[(1) - (6)]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1810:
/* Line 1787 of yacc.c  */
#line 12112 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (8)].list), lappend((yyvsp[(3) - (8)].list), (yyvsp[(6) - (8)].node)), (yylsp[(1) - (8)]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1811:
/* Line 1787 of yacc.c  */
#line 12119 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (6)].list), (yyvsp[(4) - (6)].list), (yylsp[(1) - (6)]));
					n->agg_order = (yyvsp[(5) - (6)].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
    break;

  case 1812:
/* Line 1787 of yacc.c  */
#line 12129 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (6)].list), (yyvsp[(4) - (6)].list), (yylsp[(1) - (6)]));
					n->agg_order = (yyvsp[(5) - (6)].list);
					n->agg_distinct = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1813:
/* Line 1787 of yacc.c  */
#line 12136 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[(1) - (4)].list), NIL, (yylsp[(1) - (4)]));
					n->agg_star = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1814:
/* Line 1787 of yacc.c  */
#line 12164 "gram.y"
    {
					FuncCall *n = (FuncCall *) (yyvsp[(1) - (4)].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[(2) - (4)].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[(2) - (4)]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[(2) - (4)]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[(2) - (4)]))));
						n->agg_order = (yyvsp[(2) - (4)].list);
						n->agg_within_group = TRUE;
					}
					n->agg_filter = (yyvsp[(3) - (4)].node);
					n->over = (yyvsp[(4) - (4)].windef);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1815:
/* Line 1787 of yacc.c  */
#line 12199 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1816:
/* Line 1787 of yacc.c  */
#line 12209 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1817:
/* Line 1787 of yacc.c  */
#line 12210 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1818:
/* Line 1787 of yacc.c  */
#line 12218 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[(4) - (5)].node)),
											   (yylsp[(1) - (5)]));
				}
    break;

  case 1819:
/* Line 1787 of yacc.c  */
#line 12224 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[(1) - (1)]));
				}
    break;

  case 1820:
/* Line 1787 of yacc.c  */
#line 12250 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[(1) - (1)]));
				}
    break;

  case 1821:
/* Line 1787 of yacc.c  */
#line 12260 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1822:
/* Line 1787 of yacc.c  */
#line 12273 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("now"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1823:
/* Line 1787 of yacc.c  */
#line 12281 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1824:
/* Line 1787 of yacc.c  */
#line 12294 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[(1) - (1)]));
				}
    break;

  case 1825:
/* Line 1787 of yacc.c  */
#line 12304 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1826:
/* Line 1787 of yacc.c  */
#line 12317 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[(1) - (1)]));
				}
    break;

  case 1827:
/* Line 1787 of yacc.c  */
#line 12327 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1828:
/* Line 1787 of yacc.c  */
#line 12340 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1829:
/* Line 1787 of yacc.c  */
#line 12344 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1830:
/* Line 1787 of yacc.c  */
#line 12348 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("session_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1831:
/* Line 1787 of yacc.c  */
#line 12352 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1832:
/* Line 1787 of yacc.c  */
#line 12356 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_database"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1833:
/* Line 1787 of yacc.c  */
#line 12360 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_schema"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1834:
/* Line 1787 of yacc.c  */
#line 12364 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam), (yylsp[(1) - (6)])); }
    break;

  case 1835:
/* Line 1787 of yacc.c  */
#line 12366 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1836:
/* Line 1787 of yacc.c  */
#line 12370 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1837:
/* Line 1787 of yacc.c  */
#line 12379 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1838:
/* Line 1787 of yacc.c  */
#line 12384 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1839:
/* Line 1787 of yacc.c  */
#line 12391 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str),
												list_make1((yyvsp[(3) - (6)].node)),
												(yylsp[(1) - (6)]));
				}
    break;

  case 1840:
/* Line 1787 of yacc.c  */
#line 12406 "gram.y"
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1841:
/* Line 1787 of yacc.c  */
#line 12413 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1842:
/* Line 1787 of yacc.c  */
#line 12417 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1843:
/* Line 1787 of yacc.c  */
#line 12421 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1844:
/* Line 1787 of yacc.c  */
#line 12425 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				}
    break;

  case 1845:
/* Line 1787 of yacc.c  */
#line 12429 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					c->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1846:
/* Line 1787 of yacc.c  */
#line 12436 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				}
    break;

  case 1847:
/* Line 1787 of yacc.c  */
#line 12444 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				}
    break;

  case 1848:
/* Line 1787 of yacc.c  */
#line 12452 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1849:
/* Line 1787 of yacc.c  */
#line 12456 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL, (yylsp[(1) - (5)]));
				}
    break;

  case 1850:
/* Line 1787 of yacc.c  */
#line 12460 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL, (yylsp[(1) - (7)]));
				}
    break;

  case 1851:
/* Line 1787 of yacc.c  */
#line 12464 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list), (yylsp[(1) - (7)]));
				}
    break;

  case 1852:
/* Line 1787 of yacc.c  */
#line 12468 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list), (yylsp[(1) - (9)]));
				}
    break;

  case 1853:
/* Line 1787 of yacc.c  */
#line 12472 "gram.y"
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[(3) - (5)].node), (yyvsp[(4) - (5)].node)), (yylsp[(1) - (5)]));
				}
    break;

  case 1854:
/* Line 1787 of yacc.c  */
#line 12478 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL, (yylsp[(1) - (4)]));
				}
    break;

  case 1855:
/* Line 1787 of yacc.c  */
#line 12482 "gram.y"
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[(4) - (6)].node), makeBoolAConst((yyvsp[(5) - (6)].boolean), -1)),
									(yylsp[(1) - (6)]));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				}
    break;

  case 1856:
/* Line 1787 of yacc.c  */
#line 12491 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL, (yylsp[(1) - (5)]));
				}
    break;

  case 1857:
/* Line 1787 of yacc.c  */
#line 12495 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				}
    break;

  case 1858:
/* Line 1787 of yacc.c  */
#line 12499 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				}
    break;

  case 1859:
/* Line 1787 of yacc.c  */
#line 12504 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typeName = (yyvsp[(6) - (7)].typnam);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1860:
/* Line 1787 of yacc.c  */
#line 12518 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1861:
/* Line 1787 of yacc.c  */
#line 12520 "gram.y"
    { (yyval.node) = makeNullAConst(-1); }
    break;

  case 1862:
/* Line 1787 of yacc.c  */
#line 12524 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
    break;

  case 1863:
/* Line 1787 of yacc.c  */
#line 12526 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
    break;

  case 1864:
/* Line 1787 of yacc.c  */
#line 12528 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
    break;

  case 1865:
/* Line 1787 of yacc.c  */
#line 12530 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
    break;

  case 1866:
/* Line 1787 of yacc.c  */
#line 12533 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1867:
/* Line 1787 of yacc.c  */
#line 12536 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1868:
/* Line 1787 of yacc.c  */
#line 12537 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1869:
/* Line 1787 of yacc.c  */
#line 12541 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1870:
/* Line 1787 of yacc.c  */
#line 12549 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1871:
/* Line 1787 of yacc.c  */
#line 12558 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
    break;

  case 1872:
/* Line 1787 of yacc.c  */
#line 12559 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; }
    break;

  case 1873:
/* Line 1787 of yacc.c  */
#line 12562 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1874:
/* Line 1787 of yacc.c  */
#line 12563 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1875:
/* Line 1787 of yacc.c  */
#line 12564 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1876:
/* Line 1787 of yacc.c  */
#line 12570 "gram.y"
    {
					(yyval.node) = (yyvsp[(2) - (2)].node);
				}
    break;

  case 1877:
/* Line 1787 of yacc.c  */
#line 12574 "gram.y"
    {
					(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1878:
/* Line 1787 of yacc.c  */
#line 12578 "gram.y"
    {
					(yyval.node) = (yyvsp[(4) - (4)].node);
				}
    break;

  case 1879:
/* Line 1787 of yacc.c  */
#line 12582 "gram.y"
    {
					(yyval.node) = (yyvsp[(4) - (6)].node);
				}
    break;

  case 1880:
/* Line 1787 of yacc.c  */
#line 12592 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); }
    break;

  case 1881:
/* Line 1787 of yacc.c  */
#line 12593 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1882:
/* Line 1787 of yacc.c  */
#line 12597 "gram.y"
    { (yyval.node) = (yyvsp[(4) - (5)].node); }
    break;

  case 1883:
/* Line 1787 of yacc.c  */
#line 12598 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1884:
/* Line 1787 of yacc.c  */
#line 12606 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1885:
/* Line 1787 of yacc.c  */
#line 12607 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1886:
/* Line 1787 of yacc.c  */
#line 12611 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].windef)); }
    break;

  case 1887:
/* Line 1787 of yacc.c  */
#line 12613 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].windef)); }
    break;

  case 1888:
/* Line 1787 of yacc.c  */
#line 12618 "gram.y"
    {
					WindowDef *n = (yyvsp[(3) - (3)].windef);
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.windef) = n;
				}
    break;

  case 1889:
/* Line 1787 of yacc.c  */
#line 12626 "gram.y"
    { (yyval.windef) = (yyvsp[(2) - (2)].windef); }
    break;

  case 1890:
/* Line 1787 of yacc.c  */
#line 12628 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[(2) - (2)].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.windef) = n;
				}
    break;

  case 1891:
/* Line 1787 of yacc.c  */
#line 12641 "gram.y"
    { (yyval.windef) = NULL; }
    break;

  case 1892:
/* Line 1787 of yacc.c  */
#line 12646 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[(2) - (6)].str);
					n->partitionClause = (yyvsp[(3) - (6)].list);
					n->orderClause = (yyvsp[(4) - (6)].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[(5) - (6)].windef)->frameOptions;
					n->startOffset = (yyvsp[(5) - (6)].windef)->startOffset;
					n->endOffset = (yyvsp[(5) - (6)].windef)->endOffset;
					n->location = (yylsp[(1) - (6)]);
					(yyval.windef) = n;
				}
    break;

  case 1893:
/* Line 1787 of yacc.c  */
#line 12671 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1894:
/* Line 1787 of yacc.c  */
#line 12672 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1895:
/* Line 1787 of yacc.c  */
#line 12675 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1896:
/* Line 1787 of yacc.c  */
#line 12676 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1897:
/* Line 1787 of yacc.c  */
#line 12688 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.windef) = n;
				}
    break;

  case 1898:
/* Line 1787 of yacc.c  */
#line 12706 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
    break;

  case 1899:
/* Line 1787 of yacc.c  */
#line 12712 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1900:
/* Line 1787 of yacc.c  */
#line 12722 "gram.y"
    {
					WindowDef *n = (yyvsp[(1) - (1)].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(1) - (1)]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[(1) - (1)]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
    break;

  case 1901:
/* Line 1787 of yacc.c  */
#line 12739 "gram.y"
    {
					WindowDef *n1 = (yyvsp[(2) - (4)].windef);
					WindowDef *n2 = (yyvsp[(4) - (4)].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(2) - (4)]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
    break;

  case 1902:
/* Line 1787 of yacc.c  */
#line 12784 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1903:
/* Line 1787 of yacc.c  */
#line 12792 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1904:
/* Line 1787 of yacc.c  */
#line 12800 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1905:
/* Line 1787 of yacc.c  */
#line 12808 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1906:
/* Line 1787 of yacc.c  */
#line 12816 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1907:
/* Line 1787 of yacc.c  */
#line 12836 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1908:
/* Line 1787 of yacc.c  */
#line 12837 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1909:
/* Line 1787 of yacc.c  */
#line 12838 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); }
    break;

  case 1910:
/* Line 1787 of yacc.c  */
#line 12841 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1911:
/* Line 1787 of yacc.c  */
#line 12842 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1912:
/* Line 1787 of yacc.c  */
#line 12845 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); }
    break;

  case 1913:
/* Line 1787 of yacc.c  */
#line 12848 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1914:
/* Line 1787 of yacc.c  */
#line 12849 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1915:
/* Line 1787 of yacc.c  */
#line 12850 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; }
    break;

  case 1916:
/* Line 1787 of yacc.c  */
#line 12853 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1917:
/* Line 1787 of yacc.c  */
#line 12854 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1918:
/* Line 1787 of yacc.c  */
#line 12857 "gram.y"
    { (yyval.str) = "+"; }
    break;

  case 1919:
/* Line 1787 of yacc.c  */
#line 12858 "gram.y"
    { (yyval.str) = "-"; }
    break;

  case 1920:
/* Line 1787 of yacc.c  */
#line 12859 "gram.y"
    { (yyval.str) = "*"; }
    break;

  case 1921:
/* Line 1787 of yacc.c  */
#line 12860 "gram.y"
    { (yyval.str) = "/"; }
    break;

  case 1922:
/* Line 1787 of yacc.c  */
#line 12861 "gram.y"
    { (yyval.str) = "%"; }
    break;

  case 1923:
/* Line 1787 of yacc.c  */
#line 12862 "gram.y"
    { (yyval.str) = "^"; }
    break;

  case 1924:
/* Line 1787 of yacc.c  */
#line 12863 "gram.y"
    { (yyval.str) = "<"; }
    break;

  case 1925:
/* Line 1787 of yacc.c  */
#line 12864 "gram.y"
    { (yyval.str) = ">"; }
    break;

  case 1926:
/* Line 1787 of yacc.c  */
#line 12865 "gram.y"
    { (yyval.str) = "="; }
    break;

  case 1927:
/* Line 1787 of yacc.c  */
#line 12866 "gram.y"
    { (yyval.str) = "<="; }
    break;

  case 1928:
/* Line 1787 of yacc.c  */
#line 12867 "gram.y"
    { (yyval.str) = ">="; }
    break;

  case 1929:
/* Line 1787 of yacc.c  */
#line 12868 "gram.y"
    { (yyval.str) = "<>"; }
    break;

  case 1930:
/* Line 1787 of yacc.c  */
#line 12872 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1931:
/* Line 1787 of yacc.c  */
#line 12874 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1932:
/* Line 1787 of yacc.c  */
#line 12879 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1933:
/* Line 1787 of yacc.c  */
#line 12881 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1934:
/* Line 1787 of yacc.c  */
#line 12886 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1935:
/* Line 1787 of yacc.c  */
#line 12888 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1936:
/* Line 1787 of yacc.c  */
#line 12890 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); }
    break;

  case 1937:
/* Line 1787 of yacc.c  */
#line 12892 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); }
    break;

  case 1938:
/* Line 1787 of yacc.c  */
#line 12894 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); }
    break;

  case 1939:
/* Line 1787 of yacc.c  */
#line 12896 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); }
    break;

  case 1940:
/* Line 1787 of yacc.c  */
#line 12908 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1941:
/* Line 1787 of yacc.c  */
#line 12912 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1942:
/* Line 1787 of yacc.c  */
#line 12919 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1943:
/* Line 1787 of yacc.c  */
#line 12923 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1944:
/* Line 1787 of yacc.c  */
#line 12929 "gram.y"
    {
					(yyval.node) = (yyvsp[(1) - (1)].node);
				}
    break;

  case 1945:
/* Line 1787 of yacc.c  */
#line 12933 "gram.y"
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[(1) - (3)].str);
					na->arg = (Expr *) (yyvsp[(3) - (3)].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) na;
				}
    break;

  case 1946:
/* Line 1787 of yacc.c  */
#line 12942 "gram.y"
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[(1) - (3)].str);
					na->arg = (Expr *) (yyvsp[(3) - (3)].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) na;
				}
    break;

  case 1947:
/* Line 1787 of yacc.c  */
#line 12952 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); }
    break;

  case 1948:
/* Line 1787 of yacc.c  */
#line 12953 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); }
    break;

  case 1949:
/* Line 1787 of yacc.c  */
#line 12957 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 1950:
/* Line 1787 of yacc.c  */
#line 12961 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 1951:
/* Line 1787 of yacc.c  */
#line 12965 "gram.y"
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[(1) - (2)]));
				}
    break;

  case 1952:
/* Line 1787 of yacc.c  */
#line 12970 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1953:
/* Line 1787 of yacc.c  */
#line 12971 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1954:
/* Line 1787 of yacc.c  */
#line 12977 "gram.y"
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[(1) - (3)].str), (yylsp[(1) - (3)])), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1955:
/* Line 1787 of yacc.c  */
#line 12980 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1956:
/* Line 1787 of yacc.c  */
#line 12987 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1957:
/* Line 1787 of yacc.c  */
#line 12988 "gram.y"
    { (yyval.str) = "year"; }
    break;

  case 1958:
/* Line 1787 of yacc.c  */
#line 12989 "gram.y"
    { (yyval.str) = "month"; }
    break;

  case 1959:
/* Line 1787 of yacc.c  */
#line 12990 "gram.y"
    { (yyval.str) = "day"; }
    break;

  case 1960:
/* Line 1787 of yacc.c  */
#line 12991 "gram.y"
    { (yyval.str) = "hour"; }
    break;

  case 1961:
/* Line 1787 of yacc.c  */
#line 12992 "gram.y"
    { (yyval.str) = "minute"; }
    break;

  case 1962:
/* Line 1787 of yacc.c  */
#line 12993 "gram.y"
    { (yyval.str) = "second"; }
    break;

  case 1963:
/* Line 1787 of yacc.c  */
#line 12994 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1964:
/* Line 1787 of yacc.c  */
#line 13005 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1965:
/* Line 1787 of yacc.c  */
#line 13009 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1966:
/* Line 1787 of yacc.c  */
#line 13016 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1967:
/* Line 1787 of yacc.c  */
#line 13022 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); }
    break;

  case 1968:
/* Line 1787 of yacc.c  */
#line 13023 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1969:
/* Line 1787 of yacc.c  */
#line 13040 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1970:
/* Line 1787 of yacc.c  */
#line 13044 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				}
    break;

  case 1971:
/* Line 1787 of yacc.c  */
#line 13049 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1972:
/* Line 1787 of yacc.c  */
#line 13053 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[(2) - (2)].node),
												 SystemTypeName("int4"), -1));
				}
    break;

  case 1973:
/* Line 1787 of yacc.c  */
#line 13068 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				}
    break;

  case 1974:
/* Line 1787 of yacc.c  */
#line 13072 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1975:
/* Line 1787 of yacc.c  */
#line 13076 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1976:
/* Line 1787 of yacc.c  */
#line 13079 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1977:
/* Line 1787 of yacc.c  */
#line 13082 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); }
    break;

  case 1978:
/* Line 1787 of yacc.c  */
#line 13083 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1979:
/* Line 1787 of yacc.c  */
#line 13084 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1980:
/* Line 1787 of yacc.c  */
#line 13088 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
    break;

  case 1981:
/* Line 1787 of yacc.c  */
#line 13094 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); }
    break;

  case 1982:
/* Line 1787 of yacc.c  */
#line 13105 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					c->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1983:
/* Line 1787 of yacc.c  */
#line 13118 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1984:
/* Line 1787 of yacc.c  */
#line 13119 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1985:
/* Line 1787 of yacc.c  */
#line 13124 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					w->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)w;
				}
    break;

  case 1986:
/* Line 1787 of yacc.c  */
#line 13134 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1987:
/* Line 1787 of yacc.c  */
#line 13135 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1988:
/* Line 1787 of yacc.c  */
#line 13138 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1989:
/* Line 1787 of yacc.c  */
#line 13139 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1990:
/* Line 1787 of yacc.c  */
#line 13143 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]), yyscanner);
				}
    break;

  case 1991:
/* Line 1787 of yacc.c  */
#line 13147 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]), yyscanner);
				}
    break;

  case 1992:
/* Line 1787 of yacc.c  */
#line 13154 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				}
    break;

  case 1993:
/* Line 1787 of yacc.c  */
#line 13158 "gram.y"
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
    break;

  case 1994:
/* Line 1787 of yacc.c  */
#line 13162 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 1995:
/* Line 1787 of yacc.c  */
#line 13169 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 1996:
/* Line 1787 of yacc.c  */
#line 13178 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1997:
/* Line 1787 of yacc.c  */
#line 13179 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1998:
/* Line 1787 of yacc.c  */
#line 13183 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1999:
/* Line 1787 of yacc.c  */
#line 13184 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 2002:
/* Line 1787 of yacc.c  */
#line 13199 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); }
    break;

  case 2003:
/* Line 1787 of yacc.c  */
#line 13201 "gram.y"
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 2004:
/* Line 1787 of yacc.c  */
#line 13209 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 2005:
/* Line 1787 of yacc.c  */
#line 13210 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 2006:
/* Line 1787 of yacc.c  */
#line 13218 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 2007:
/* Line 1787 of yacc.c  */
#line 13228 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 2008:
/* Line 1787 of yacc.c  */
#line 13229 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 2009:
/* Line 1787 of yacc.c  */
#line 13233 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 2010:
/* Line 1787 of yacc.c  */
#line 13234 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 2011:
/* Line 1787 of yacc.c  */
#line 13238 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 2012:
/* Line 1787 of yacc.c  */
#line 13254 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(2) - (2)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (2)].node);
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 2013:
/* Line 1787 of yacc.c  */
#line 13262 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 2014:
/* Line 1787 of yacc.c  */
#line 13270 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 2015:
/* Line 1787 of yacc.c  */
#line 13291 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 2016:
/* Line 1787 of yacc.c  */
#line 13292 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 2017:
/* Line 1787 of yacc.c  */
#line 13304 "gram.y"
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 2018:
/* Line 1787 of yacc.c  */
#line 13308 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[(1) - (2)]));
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)))),
									 parser_errposition((yylsp[(1) - (2)]))));
							break;
					}
				}
    break;

  case 2019:
/* Line 1787 of yacc.c  */
#line 13335 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 2020:
/* Line 1787 of yacc.c  */
#line 13337 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 2021:
/* Line 1787 of yacc.c  */
#line 13341 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2022:
/* Line 1787 of yacc.c  */
#line 13344 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2023:
/* Line 1787 of yacc.c  */
#line 13347 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2024:
/* Line 1787 of yacc.c  */
#line 13349 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2025:
/* Line 1787 of yacc.c  */
#line 13351 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2026:
/* Line 1787 of yacc.c  */
#line 13353 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2027:
/* Line 1787 of yacc.c  */
#line 13364 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 2028:
/* Line 1787 of yacc.c  */
#line 13366 "gram.y"
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)),
											 yyscanner);
					}
    break;

  case 2029:
/* Line 1787 of yacc.c  */
#line 13377 "gram.y"
    {
					(yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)]));
				}
    break;

  case 2030:
/* Line 1787 of yacc.c  */
#line 13381 "gram.y"
    {
					(yyval.node) = makeFloatConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 2031:
/* Line 1787 of yacc.c  */
#line 13385 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 2032:
/* Line 1787 of yacc.c  */
#line 13389 "gram.y"
    {
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 2033:
/* Line 1787 of yacc.c  */
#line 13393 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 2034:
/* Line 1787 of yacc.c  */
#line 13402 "gram.y"
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					t->location = (yylsp[(1) - (2)]);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), t);
				}
    break;

  case 2035:
/* Line 1787 of yacc.c  */
#line 13409 "gram.y"
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (6)].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[(3) - (6)].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[(4) - (6)].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[(4) - (6)]))));

					t->typmods = (yyvsp[(3) - (6)].list);
					t->location = (yylsp[(1) - (6)]);
					(yyval.node) = makeStringConstCast((yyvsp[(6) - (6)].str), (yylsp[(6) - (6)]), t);
				}
    break;

  case 2036:
/* Line 1787 of yacc.c  */
#line 13441 "gram.y"
    {
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), (yyvsp[(1) - (2)].typnam));
				}
    break;

  case 2037:
/* Line 1787 of yacc.c  */
#line 13445 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				}
    break;

  case 2038:
/* Line 1787 of yacc.c  */
#line 13451 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (5)].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (5)].str), (yylsp[(5) - (5)]), t);
				}
    break;

  case 2039:
/* Line 1787 of yacc.c  */
#line 13458 "gram.y"
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[(1) - (1)]));
				}
    break;

  case 2040:
/* Line 1787 of yacc.c  */
#line 13462 "gram.y"
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[(1) - (1)]));
				}
    break;

  case 2041:
/* Line 1787 of yacc.c  */
#line 13466 "gram.y"
    {
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				}
    break;

  case 2042:
/* Line 1787 of yacc.c  */
#line 13471 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 2043:
/* Line 1787 of yacc.c  */
#line 13472 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2044:
/* Line 1787 of yacc.c  */
#line 13474 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 2045:
/* Line 1787 of yacc.c  */
#line 13475 "gram.y"
    { (yyval.ival) = + (yyvsp[(2) - (2)].ival); }
    break;

  case 2046:
/* Line 1787 of yacc.c  */
#line 13476 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); }
    break;

  case 2047:
/* Line 1787 of yacc.c  */
#line 13481 "gram.y"
    {
					RoleSpec *spc = (RoleSpec *) (yyvsp[(1) - (1)].node);
					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[(1) - (1)]))));
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[(1) - (1)]))));
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[(1) - (1)]))));
					}
				}
    break;

  case 2048:
/* Line 1787 of yacc.c  */
#line 13511 "gram.y"
    {
						/*
						 * "public" and "none" are not keywords, but they must
						 * be treated specially here.
						 */
						RoleSpec *n;
						if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[(1) - (1)]));
							n->roletype = ROLESPEC_PUBLIC;
						}
						else if (strcmp((yyvsp[(1) - (1)].str), "none") == 0)
						{
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"none"),
									 parser_errposition((yylsp[(1) - (1)]))));
						}
						else
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_CSTRING, (yylsp[(1) - (1)]));
							n->rolename = pstrdup((yyvsp[(1) - (1)].str));
						}
						(yyval.node) = (Node *) n;
					}
    break;

  case 2049:
/* Line 1787 of yacc.c  */
#line 13538 "gram.y"
    {
						(yyval.node) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[(1) - (1)]));
					}
    break;

  case 2050:
/* Line 1787 of yacc.c  */
#line 13542 "gram.y"
    {
						(yyval.node) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[(1) - (1)]));
					}
    break;

  case 2051:
/* Line 1787 of yacc.c  */
#line 13548 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 2052:
/* Line 1787 of yacc.c  */
#line 13550 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 2053:
/* Line 1787 of yacc.c  */
#line 13566 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2054:
/* Line 1787 of yacc.c  */
#line 13567 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2055:
/* Line 1787 of yacc.c  */
#line 13568 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2056:
/* Line 1787 of yacc.c  */
#line 13573 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2057:
/* Line 1787 of yacc.c  */
#line 13574 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2058:
/* Line 1787 of yacc.c  */
#line 13575 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2059:
/* Line 1787 of yacc.c  */
#line 13580 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2060:
/* Line 1787 of yacc.c  */
#line 13581 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2061:
/* Line 1787 of yacc.c  */
#line 13582 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2062:
/* Line 1787 of yacc.c  */
#line 13583 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2063:
/* Line 1787 of yacc.c  */
#line 13589 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 2064:
/* Line 1787 of yacc.c  */
#line 13590 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2065:
/* Line 1787 of yacc.c  */
#line 13591 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2066:
/* Line 1787 of yacc.c  */
#line 13592 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 2067:
/* Line 1787 of yacc.c  */
#line 13593 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;


/* Line 1787 of yacc.c  */
#line 42229 "gram.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2050 of yacc.c  */
#line 14066 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static Node *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return (Node *) spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	int			ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = list_length(directargs);

	return list_make2(list_concat(directargs, orderedargs),
					  makeInteger(ndirectargs));
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

/*
 * Create a DefElem setting "oids" to the specified value.
 */
static DefElem *
defWithOids(bool value)
{
	DefElem    *f = makeNode(DefElem);
	
	f->defname = "oids";
	f->arg = (Node *) makeInteger(value);
	return f;
}

/*
 * Must undefine this stuff before including scan.c, since it has different
 * definitions for these macros.
 */
#undef yyerror
#undef yylval
#undef yylloc

#include "scan.c"
